Package: plotgardener
Title: Coordinate-Based Genomic Visualization Package for R
Version: 1.17.0
Date: 2024-06-28
Author: Nicole Kramer [aut, cre], Eric S. Davis [aut], Craig Wenger [aut],
    Sarah Parker [ctb], Erika Deoudes [art], Michael Love [ctb],
    Douglas H. Phanstiel [aut, cre, cph]
Maintainer: Nicole Kramer <nekramer27@gmail.com>,
 Douglas Phanstiel <douglas_phanstiel@med.unc.edu>
Description: 
    Coordinate-based genomic visualization package for R. It grants users
    the ability to programmatically produce complex, multi-paneled figures. Tailored for
    genomics, plotgardener allows users to visualize large complex genomic datasets and
    provides exquisite control over how plots are placed and arranged on a page. 
Depends: R (>= 4.2.0)
License: MIT + file LICENSE
URL: https://phanstiellab.github.io/plotgardener,
        https://github.com/PhanstielLab/plotgardener
Encoding: UTF-8
RoxygenNote: 7.3.2
Imports: curl, data.table, dplyr, GenomeInfoDb, GenomicRanges, glue,
        grDevices, grid, ggplotify, IRanges, methods, plyranges, purrr,
        Rcpp, RColorBrewer, rhdf5, rlang, stats, strawr, tools, utils,
        withr
biocViews: Visualization, GenomeAnnotation, FunctionalGenomics,
        GenomeAssembly, HiC
LinkingTo: Rcpp
Suggests: AnnotationDbi, AnnotationHub, BSgenome,
        BSgenome.Hsapiens.UCSC.hg19, ComplexHeatmap, GenomicFeatures,
        ggplot2, InteractionSet, knitr, org.Hs.eg.db, rtracklayer,
        plotgardenerData, pdftools, png, rmarkdown, scales, showtext,
        testthat (>= 3.0.0), TxDb.Hsapiens.UCSC.hg19.knownGene,
        TxDb.Hsapiens.UCSC.hg38.knownGene
VignetteBuilder: knitr
Config/testthat/edition: 3
BugReports: https://github.com/PhanstielLab/plotgardener/issues
git_url: https://git.bioconductor.org/packages/plotgardener
git_branch: devel
git_last_commit: eaa9c96
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-04
NeedsCompilation: yes
Packaged: 2025-11-05 00:14:31 UTC; biocbuild

# <img src="man/figures/pg-wordmark.png" width="400px" style="background-color:white;border=transparent" /> <img src="man/figures/pg-hex-text.png" align="right" width="140px" style="padding-left:20px; background-color:white" />

<!-- badges: start -->
![GitHub R package version](https://img.shields.io/github/r-package/v/PhanstielLab/plotgardener?style=plastic)
[![R build status](https://github.com/PhanstielLab/plotgardener/actions/workflows/check-bioc.yml/badge.svg)](https://github.com/PhanstielLab/plotgardener/actions)
<!-- badges: end -->

## Overview

`plotgardener` is a genomic data visualization package for R. Using `grid`
graphics, `plotgardener` empowers users to programmatically and flexibly
generate multi-panel figures. `plotgardener` accomplishes these goals by
utilizing 1) a coordinate-based plotting system, and 2) edge-to-edge
containerized data visualization. The coordinate-based plotting system
grants users precise control over the size, position, and arrangement of
plots. Its edge-to-edge plotting functions preserve the mapping between
user-specified containers and the represented data. This allows users to
stack plots with confidence that vertically aligned data will correspond
to the same regions. For more information about plotgardener’s philosophy
and design, check out the `Our Philosophy` page.

Specialized for genomic data, `plotgardener` also contains functions to read
and plot multi-omic data quickly and easily. These functions are
integrated with Bioconductor packages to flexibly accommodate a large variety 
of genomic assemblies. `plotgardener` can address an
endless number of use cases, including: dynamic exploration of genomic
data, arrangement into multi-omic layouts, and survey plotting for
quickly viewing data across the genome. Check out our `vignettes` for
detailed examples and suggested use cases!

## Citation

To cite `plotgardener` in publications use:

Nicole E Kramer, Eric S Davis, Craig D Wenger, Erika M Deoudes, Sarah M
Parker, Michael I Love, Douglas H Phanstiel, Plotgardener: cultivating 
precise multi-panel figures in R, *Bioinformatics*, 2022.

## Installation

plotgardener can be installed from Bioconductor version 3.19 

(R version 4.4) as follows:

``` r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install(version = "3.19")

BiocManager::install("plotgardener")

```

Example datasets and files are included with the package plotgardenerData:

``` r
BiocManager::install("plotgardenerData")
```

## Usage

<img src="man/figures/homePage-1.png" width="672" style="display: block; margin: auto;" />

``` r
## Load libraries and datasets
library("plotgardener")
library("org.Hs.eg.db")
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
library("plotgardenerData")
library("AnnotationHub")
data("GM12878_HiC_10kb")
data("IMR90_HiC_10kb")
data("GM12878_ChIP_CTCF_signal")
data("IMR90_ChIP_CTCF_signal")
data("GM12878_ChIP_H3K27ac_signal")
data("IMR90_ChIP_H3K27ac_signal")

## Create a plotgardener page
pageCreate(width = 7, height = 4.25, default.units = "inches")

##########################
######## Panel A #########
##########################
## Text section label
plotText(label = "A", fontsize = 12,
            x = 0.25, y = 0.25, just = "left", default.units = "inches")
## Set genomic and dimension parameters in a `params` object
params_a <- pgParams(chrom = "chr21", chromstart = 28000000, chromend = 30300000, 
                      assembly = "hg19",
                      x = 0.25, width = 2.75, just = c("left", "top"), default.units = "inches")
## Double-sided Hi-C Plot
hicPlot_top <- plotHicSquare(data = GM12878_HiC_10kb, params = params_a,
                                zrange = c(0, 200), resolution = 10000,
                                half = "top",
                                y = 0.5, height = 2.75)
hicPlot_bottom <- plotHicSquare(data = IMR90_HiC_10kb, params = params_a,
                                   zrange = c(0, 70), resolution = 10000,
                                   half = "bottom",
                                   y = 0.5, height = 2.75)
## Annotate Hi-C heatmap legends
annoHeatmapLegend(plot = hicPlot_bottom, fontsize = 7, 
                     x = 3.05, y = 0.5,
                     width = 0.07, height = 0.5, just = c("left", "top"),
                     default.units = "inches")
annoHeatmapLegend(plot = hicPlot_top, fontsize = 7, 
                     x = .125, y = 0.5,
                     width = 0.07, height = 0.5, just = c("left", "top"),
                     default.units = "inches")
## Plot gene track
genes_a <- plotGenes(params = params_a, stroke = 1, fontsize = 6,
                        y = 3.35, height = 0.4)
## Annotate genome label
annoGenomeLabel(plot = genes_a, params = params_a, 
                   scale = "Mb", fontsize = 7,
                   y = 3.85)
##########################
######## Panel B #########
##########################
## Text section label
plotText(label = "B", fontsize = 12,
            x = 3.5, y = 0.25, just = "left", default.units = "inches")
## Plot ideogram
plotIdeogram(chrom = "chr21", assembly = "hg19",
                x = 3.5, y = 0.5,
                width = 3.25, height = 0.15, just = c("left", "top"), default.units = "inches")
## Add text to ideogram
plotText(label = "Chromosome 21", fontsize = 8, fontcolor = "darkgrey",
            x = 6.75, y = 0.4, just = "right", default.units = "inches")
##########################
######## Panel C #########
##########################
## Text section label
plotText(label = "C", fontsize = 12,
            x = 3.5, y = 1, just = c("left", "top"), default.units = "inches")
## Set genomic and dimension parameters in a `params` object
params_c <- pgParams(chrom = "chr21", chromstart = 28150000, chromend = 29150000, 
                      assembly = "hg19",
                      x = 3.5, width = 1.5, default.units = "inches")
## Set signal track data ranges
ctcf_range <- pgParams(range = c(0, 77),
                        assembly = "hg19")
hk_range <- pgParams(range = c(0, 32.6),
                      assembly = "hg19")
## Plot Hi-C triangle
hic_gm <- plotHicTriangle(data = GM12878_HiC_10kb, params = params_c,
                             zrange = c(0, 200), resolution = 10000,
                             y = 1.75, height = 0.75, just = c("left", "bottom"))
## Annotate Hi-C heatmap legend
annoHeatmapLegend(plot = hic_gm, fontsize = 7, 
                     x = 5, y = 1, width = 0.07, height = 0.5, 
                     just = c("right", "top"), default.units = "inches")
## Plot CTCF signal
ctcf_gm <- plotSignal(data = GM12878_ChIP_CTCF_signal, params = c(params_c, ctcf_range),
                         fill = "#253494", linecolor = "#253494",
                         y = 1.95, height = 0.6)
## CTCF label
plotText(label = "CTCF", fontcolor = "#253494", fontsize = 8,
            x = 3.5, y = 1.95, just = c("left","top"), default.units = "inches")
## Plot H3K27ac signal
hk_gm <- plotSignal(data = GM12878_ChIP_H3K27ac_signal, params = c(params_c, hk_range),
                       fill = "#37a7db", linecolor = "#37a7db",
                       y = 3.25, height = 0.6, just = c("left", "bottom"))
## H3K27ac label
plotText(label = "H3K27ac", fontcolor = "#37a7db", fontsize = 8,
            x = 3.5, y = 2.65, just = c("left","top"), default.units = "inches")
## Plot genes
genes_gm <- plotGenes(params = params_c, stroke = 1, fontsize = 6,
                         strandLabels = FALSE,
                         y = 3.35, height = 0.4)
## Annotate genome label
annoGenomeLabel(plot = genes_gm, params = params_c, 
                   scale = "Kb", fontsize = 7,
                   y = 3.85)
##########################
######## Panel D #########
##########################
## Text section label
plotText(label = "D", fontsize = 12,
            x = 5.25, y = 1, just = c("left", "top"), default.units = "inches")
## Set genomic and dimension parameters in a `params` object
params_d <- pgParams(chrom = "chr21", chromstart = 28150000, chromend = 29150000, 
                      assembly = "hg19",
                      x = 6.75, width = 1.5, default.units = "inches")
## Plot Hi-C triangle
hic_imr <- plotHicTriangle(data = IMR90_HiC_10kb, params = params_d,
                              zrange = c(0, 70), resolution = 10000,
                              y = 1.75, height = 0.75, just = c("right", "bottom"))
## Annotate Hi-C heatmap legend
annoHeatmapLegend(plot = hic_imr, fontsize = 7, digits = 0,
                     x = 6.75, y = 1, width = 0.07, height = 0.5, just = c("right", "top"))
## Plot CTCF signal
ctcf_imr <- plotSignal(data = IMR90_ChIP_CTCF_signal, params = c(params_d, ctcf_range),
                          fill = "#253494", linecolor = "#253494",
                          y = 1.95, height = 0.6, just = c("right", "top"))
## Plot H3K27ac signal
hk_imr <- plotSignal(data = IMR90_ChIP_H3K27ac_signal, params = c(params_d, hk_range),
                        fill = "#37a7db", linecolor = "#37a7db",
                        y = 3.25, height = 0.6, just = c("right", "bottom"))
## Plot gene track
genes_imr <- plotGenes(params = params_d, stroke = 1, fontsize = 6,
                          strandLabels = FALSE,
                          y = 3.35, height = 0.4, just = c("right", "top"))
## Annotate genome label
annoGenomeLabel(plot = genes_imr, params = params_d, 
                   scale = "Kb", fontsize = 7, digits = 0,
                   y = 3.85, just = c("right", "top"))
## Hide page guides
pageGuideHide()
```

## A word of caution

`plotgardener` is incredibly flexible and functional. However, due to this
flexibility and like all programming packages, it may not always prevent
users from making unintentional mistakes. If plot sizes are entered
incorrectly or data is mishandled, it is possible to connect multi-omic
data incorrectly. Make sure you utilize package features that reduce
human error and increase re-usability of code to get the most mileage out
of plotgardener.

#' Plot a Hi-C interaction matrix in a triangular format
#' 
#' @usage plotHicTriangle(
#'     data,
#'     resolution = "auto",
#'     zrange = NULL,
#'     norm = "KR",
#'     matrix = "observed",
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     assembly = "hg38",
#'     palette = colorRampPalette(brewer.pal(n = 9, "YlGnBu")),
#'     colorTrans = "linear",
#'     flip = FALSE,
#'     bg = NA,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL,
#'     quiet = FALSE
#' )
#'
#' @param data Path to .hic or .(m)cool file as a string or a 3-column
#' dataframe of interaction counts in sparse upper triangular format.
#' @param resolution A numeric specifying the width in basepairs of
#' each pixel. For files, "auto" will attempt to choose a
#' resolution based on the size of the region. For
#' dataframes, "auto" will attempt to detect the resolution
#' the dataframe contains.
#' @param zrange A numeric vector of length 2 specifying the
#' range of interaction scores to plot, where extreme values
#' will be set to the max or min.
#' @param norm Character value specifying hic data normalization method,
#' if giving .hic or .(m)cool file. This value must be found in the .hic or
#' .(m)cool file. Default value is \code{norm = "KR"}.
#' @param matrix Character value indicating the type of matrix to output for
#' .hic files.
#' Default value is \code{matrix = "observed"}. Options are:
#' \itemize{
#' \item{\code{"observed"}: }{Observed counts.}
#' \item{\code{"oe"}: }{Observed/expected counts.}
#' \item{\code{"log2oe"}: }{Log2 transformed observed/expected counts.}
#' }
#' @param chrom Chromosome of region to be plotted, as a string.
#' @param chromstart Integer start position on chromosome to be plotted.
#' @param chromend Integer end position on chromosome to be plotted.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param palette A function describing the color palette to use for
#' representing scale of interaction scores. Default value is
#' \code{palette =  colorRampPalette(brewer.pal(n = 9, "YlGnBu"))}.
#' @param colorTrans A string specifying how to scale Hi-C colors.
#' Options are "linear", "log", "log2", or "log10".
#' Default value is \code{colorTrans = "linear"}.
#' @param flip A logical indicating whether to flip the orientation of
#' the Hi-C matrix over the x-axis. Default value is \code{flip = FALSE}.
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param x A numeric or unit object specifying triangle Hi-C plot x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying triangle Hi-C plot y-location.
#' The character value will
#' place the triangle Hi-C plot y relative to the bottom of the most
#' recently plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying the bottom
#' width of the Hi-C plot triangle.
#' @param height A numeric or unit object specifying the height of
#' the Hi-C plot triangle.
#' @param just Justification of triangle Hi-C plot relative to
#' its (x, y) location. If there are two values, the first value specifies
#' horizontal justification and the second value specifies vertical
#' justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use if
#' \code{x}, \code{y}, \code{width}, or \code{height} are only given as
#' numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output should
#' be produced. Default value is \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param quiet A logical indicating whether or not to print messages.
#'
#' @return Returns a \code{hicTriangle} object containing relevant
#' genomic region, Hi-C data, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load Hi-C data
#' library(plotgardenerData)
#' data("IMR90_HiC_10kb")
#'
#' ## Create a page
#' pageCreate(width = 4, height = 2.5, default.units = "inches")
#'
#' ## Plot and place triangle Hi-C plot
#' hicPlot <- plotHicTriangle(
#'     data = IMR90_HiC_10kb, resolution = 10000,
#'     zrange = c(0, 70),
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19",
#'     x = 2, y = 0.5, width = 3, height = 1.5,
#'     just = "top", default.units = "inches"
#' )
#'
#' ## Annotate x-axis genome label
#' annoGenomeLabel(
#'     plot = hicPlot, scale = "Mb", x = 0.5, y = 2.03,
#'     just = c("left", "top")
#' )
#'
#' ## Annotate heatmap legend
#' annoHeatmapLegend(
#'     plot = hicPlot, x = 3.5, y = 0.5,
#'     width = 0.13, height = 1.2,
#'     just = c("right", "top")
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @details
#' In this orientation, the x-axis represents the genomic coordinates and
#' the y-axis corresponds to distance in Hi-C bins.
#' 
#' A triangle Hi-C plot can be placed on a plotgardener coordinate page
#' by providing plot placement parameters:
#' \preformatted{
#' plotHicTriangle(data, chrom,
#'                 chromstart = NULL, chromend = NULL,
#'                 x, y, width, height, just = c("left", "top"),
#'                 default.units = "inches")
#' }
#' This function can also be used to quickly plot an unannotated triangle
#' Hi-C plot by ignoring plot placement parameters:
#' \preformatted{
#' plotHicTriangle(data, chrom,
#'                 chromstart = NULL, chromend = NULL)
#' }
#'
#' If \code{height} is \eqn{<} \eqn{0.5 * width}, the top of the triangle
#' will be cropped to the given \code{height}.
#'
#' @seealso \link[plotgardener]{readHic}, \link[plotgardener]{readCool}
#'
#' @export
plotHicTriangle <- function(data, resolution = "auto", zrange = NULL,
                            norm = "KR", matrix = "observed", chrom,
                            chromstart = NULL, chromend = NULL,
                            assembly = "hg38",
                            palette = colorRampPalette(brewer.pal(
                                n = 9, "YlGnBu"
                            )),
                            colorTrans = "linear", flip = FALSE, 
                            bg = NA,
                            x = NULL, y = NULL,
                            width = NULL, height = NULL,
                            just = c("left", "top"),
                            default.units = "inches", draw = TRUE,
                            params = NULL, quiet = FALSE) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors for plotTriangleHic
    errorcheck_plotTriangleHic <- function(hic, hicPlot, norm) {

        ###### hic/cool/mcool/norm #####
        hicErrors(hic = hic,
                    norm = norm)

        
        regionErrors(chromstart = hicPlot$chromstart,
                    chromend = hicPlot$chromend)

        ##### zrange #####
        rangeErrors(range = hicPlot$zrange)
        
        ##### height #####
        if (!is.null(hicPlot$height)) {

            ## convert height to inches
            height <- convertHeight(hicPlot$height,
                unitTo = "inches", valueOnly = TRUE
            )
            if (height < 0.05) {
                stop("Height is too small for a valid triangle Hi-C plot.",
                    call. = FALSE
                )
            }
        }
    }

    ## Define a function that subsets data
    subset_data <- function(hic, hicPlot) {
        if (nrow(hic) > 0) {
            hic <- hic[which(hic[, "x"] >= floor(hicPlot$chromstart /
                hicPlot$resolution) *
                hicPlot$resolution &
                hic[, "x"] < hicPlot$chromend &
                hic[, "y"] >= floor(hicPlot$chromstart /
                    hicPlot$resolution) *
                    hicPlot$resolution &
                hic[, "y"] < hicPlot$chromend), ]
        }


        return(hic)
    }

    ## Define a function that manually "clips" pixels along edges
    manual_clip <- function(hic, hicPlot, flip) {
        
        if (flip == FALSE){
            clipLeft <- hic[which(hic[, "x"] < hicPlot$chromstart), ]
            clipTop <- hic[which((hic[, "y"] + hicPlot$resolution) >
                hicPlot$chromend), ]

            topLeft <- suppressMessages(dplyr::inner_join(clipLeft, clipTop))

            clipLeft <- suppressMessages(dplyr::anti_join(clipLeft, topLeft))
            clipTop <- suppressMessages(dplyr::anti_join(clipTop, topLeft))

            ############# Squares
            squares <- hic[which(hic[, "y"] > hic[, "x"]), ]
            clipLeftsquares <- suppressMessages(dplyr::inner_join(
                squares,
                clipLeft
            ))
            clipTopsquares <- suppressMessages(dplyr::inner_join(
                squares,
                clipTop
            ))
            clippedSquares <- rbind(
                clipLeftsquares, clipTopsquares,
                topLeft
            )

            squares <- suppressMessages(dplyr::anti_join(squares, 
                                                        clippedSquares))


            clipLeftsquares$width <- hicPlot$resolution - (hicPlot$chromstart -
                clipLeftsquares$x)
            clipLeftsquares$x <- rep(hicPlot$chromstart, nrow(clipLeftsquares))

            clipTopsquares$height <- hicPlot$chromend - clipTopsquares$y

            topLeft$width <- hicPlot$resolution - (hicPlot$chromstart -
                topLeft$x)
            topLeft$x <- rep(hicPlot$chromstart, nrow(topLeft))

            topLeft$height <- hicPlot$chromend - topLeft$y


            ############# Triangles
            triangles <- hic[which(hic[, "y"] == hic[, "x"]), ]
            topRight <- suppressMessages(dplyr::inner_join(triangles, clipTop))
            bottomLeft <- suppressMessages(dplyr::inner_join(triangles, 
                                                                    clipLeft))
            clippedTriangles <- rbind(topRight, bottomLeft)

            triangles <- suppressMessages(dplyr::anti_join(
                triangles,
                clippedTriangles
            ))

            topRight$height <- hicPlot$chromend - topRight$y
            topRight$width <- topRight$height

            bottomLeft$width <- hicPlot$resolution - (hicPlot$chromstart -
                bottomLeft$x)
            bottomLeft$height <- bottomLeft$width
            bottomLeft$x <- rep(hicPlot$chromstart, nrow(bottomLeft))
            bottomLeft$y <- rep(hicPlot$chromstart, nrow(bottomLeft))
            
            clippedHic <- rbind(
                    squares, triangles, clipLeftsquares,
                    clipTopsquares, topLeft, topRight, bottomLeft
                )
            
        } else {
            
            clipBottom <- hic[which(hic[, "y"] < hicPlot$chromstart), ]
            clipRight <- hic[which((hic[, "x"] + hicPlot$resolution) >
                                hicPlot$chromend), ]
            
            bottomRight <- suppressMessages(dplyr::inner_join(clipBottom, 
                                                                clipRight))
            
            clipBottom <- suppressMessages(dplyr::anti_join(clipBottom, 
                                                            bottomRight))
            clipRight <- suppressMessages(dplyr::anti_join(clipRight, 
                                                            bottomRight))
            
            ############# Squares
            squares <- hic[which(hic[, "x"] > hic[, "y"]), ]
            clipBottomsquares <- suppressMessages(dplyr::inner_join(
                squares,
                clipBottom
            ))
            clipRightsquares <- suppressMessages(dplyr::inner_join(
                squares,
                clipRight
            ))
            clippedSquares <- rbind(
                clipBottomsquares, clipRightsquares,
                bottomRight
            )
            
            squares <- suppressMessages(dplyr::anti_join(squares, 
                                                        clippedSquares))
            
            clipRightsquares$width <- hicPlot$chromend - clipRightsquares$x
            clipBottomsquares$height <- hicPlot$resolution - 
                (hicPlot$chromstart - clipBottomsquares$y)
            clipBottomsquares$y <- rep(hicPlot$chromstart, 
                                        nrow(clipBottomsquares))
            
            
            bottomRight$height <- hicPlot$resolution - (hicPlot$chromstart -
                                        bottomRight$y)
            bottomRight$y <- rep(hicPlot$chromstart, nrow(bottomRight))
            bottomRight$width <- hicPlot$chromend - bottomRight$x
            
            
            ############# Triangles
            triangles <- hic[which(hic[, "y"] == hic[, "x"]), ]
            topRight <- suppressMessages(dplyr::inner_join(triangles, 
                                                            clipRight))
            bottomLeft <- suppressMessages(dplyr::inner_join(triangles, 
                                                            clipBottom))
            
            
            clippedTriangles <- rbind(topRight, bottomLeft)
            
            triangles <- suppressMessages(dplyr::anti_join(
                triangles,
                clippedTriangles
            ))
            
            topRight$width <- hicPlot$chromend - topRight$x
            topRight$height <- topRight$width
            
            bottomLeft$height <- hicPlot$resolution - (hicPlot$chromstart -
                                        bottomLeft$y)
            bottomLeft$width <- bottomLeft$height
            bottomLeft$x <- rep(hicPlot$chromstart, nrow(bottomLeft))
            bottomLeft$y <- rep(hicPlot$chromstart, nrow(bottomLeft))
            
            
            clippedHic <- rbind(
                squares, triangles, clipRightsquares,
                clipBottomsquares, bottomRight, topRight, bottomLeft
            )
            
        }

        return(clippedHic)
    }

    ## Define a function that makes grobs for the triangle hic diagonal
    hic_diagonal <- function(hic, flip) {
        col <- hic["color"]
        x <- utils::type.convert(hic["x"], as.is = TRUE)
        y <- utils::type.convert(hic["y"], as.is = TRUE)
        width <- utils::type.convert(hic["width"], as.is = TRUE)
        height <- utils::type.convert(hic["height"], as.is = TRUE)
        
        xleft <- x
        xright <- x + width
        ybottom <- y
        ytop <- y + height
        
        if (flip == FALSE){

            hic_triangle <- polygonGrob(
                x = c(xleft, xleft, xright),
                y = c(ybottom, ytop, ytop),
                gp = gpar(col = NA, fill = col),
                default.units = "native"
            )
            
        } else {
            
            hic_triangle <- polygonGrob(
                x = c(xleft, xright, xright),
                y = c(ybottom, ybottom, ytop),
                gp = gpar(col = NA, fill = col),
                default.units = "native"
            )
        }

        assign("hic_grobs2",
            addGrob(
                gTree = get("hic_grobs2", envir = pgEnv),
                child = hic_triangle
            ),
            envir = pgEnv
        )
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    thicInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "thicInternal"
    )
    ## Justification
    thicInternal$just <- justConversion(just = thicInternal$just)
    
    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    hicPlot <- structure(list(
        chrom = thicInternal$chrom,
        chromstart = thicInternal$chromstart,
        chromend = thicInternal$chromend,
        altchrom = thicInternal$chrom,
        altchromstart = thicInternal$chromstart,
        altchromend = thicInternal$chromend,
        assembly = thicInternal$assembly,
        resolution = thicInternal$resolution,
        x = thicInternal$x, y = thicInternal$y,
        width = thicInternal$width,
        height = thicInternal$height,
        just = thicInternal$just,
        color_palette = NULL,
        colorTrans = thicInternal$colorTrans,
        zrange = thicInternal$zrange,
        flip = thicInternal$flip,
        outsideVP = NULL, grobs = NULL
    ),
    class = "hicTriangle"
    )
    attr(x = hicPlot, which = "plotted") <- thicInternal$draw

    # =========================================================================
    # CHECK PLACEMENT/ARGUMENT ERRORS
    # =========================================================================

    if (is.null(thicInternal$data)) stop("argument \"data\" is missing, ",
                                            "with no default.", call. = FALSE)
    if (is.null(thicInternal$chrom)) stop("argument \"chrom\" is missing, ",
                                            "with no default.", call. = FALSE)
    check_placement(object = hicPlot)

    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    hicPlot$assembly <- parseAssembly(assembly = hicPlot$assembly)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    hicPlot <- defaultUnits(
        object = hicPlot,
        default.units = thicInternal$default.units
    )

    # ========================================================================
    # CATCH ERRORS
    # ========================================================================

    errorcheck_plotTriangleHic(
        hic = thicInternal$data,
        hicPlot = hicPlot,
        norm = thicInternal$norm
    )

    # =========================================================================
    # GENOMIC SCALE
    # =========================================================================
    
    scaleChecks <- genomicScale(object = hicPlot,
                                objectInternal = thicInternal,
                                plotType = "triangle Hi-C plot")
    hicPlot <- scaleChecks[[1]]
    thicInternal <- scaleChecks[[2]]
    
    # =========================================================================
    # ADJUST RESOLUTION
    # =========================================================================

    if (thicInternal$resolution == "auto") {
        hicPlot <- adjust_resolution(
            hic = thicInternal$data,
            hicPlot = hicPlot
        )
    } else {
        hicPlot <- hic_limit(
            hic = thicInternal$data,
            hicPlot = hicPlot
        )
    }

    # =========================================================================
    # READ IN DATA
    # =========================================================================

    hic <- read_data(
        hic = thicInternal$data, hicPlot = hicPlot,
        norm = thicInternal$norm, assembly = hicPlot$assembly,
        type = thicInternal$matrix,
        quiet = thicInternal$quiet
    )

    # =========================================================================
    # SUBSET DATA
    # =========================================================================

    hic <- subset_data(hic = hic, hicPlot = hicPlot)
    
    # =========================================================================
    # GET LOWER TRIANGULAR FOR FLIP
    # =========================================================================
    
    if (thicInternal$flip == TRUE){
        hic <- hic[, c("y", "x", "counts")]
        colnames(hic) <- c("x", "y", "counts")
    }

    # =========================================================================
    # SET ZRANGE AND SCALE DATA
    # =========================================================================

    hicPlot <- set_zrange(hic = hic, hicPlot = hicPlot)
    hic$counts[hic$counts <= hicPlot$zrange[1]] <- hicPlot$zrange[1]
    hic$counts[hic$counts >= hicPlot$zrange[2]] <- hicPlot$zrange[2]

    # =========================================================================
    # CONVERT NUMBERS TO COLORS
    # =========================================================================

    ## if we don't have an appropriate zrange (even after setting it
    ## based on a null zrange), can't scale to colors
    if (!is.null(hicPlot$zrange) & length(unique(hicPlot$zrange)) == 2) {
        if (grepl("log", thicInternal$colorTrans) == TRUE) {
            logBase <- utils::type.convert(gsub("log", "", 
                                                thicInternal$colorTrans), 
                                as.is = TRUE)
            if (is.na(logBase)) {
                logBase <- exp(1)
            }

            ## Won't scale to log if negative values
            if (any(hic$counts < 0)) {
                stop("Negative values in Hi-C data. Cannot scale colors ",
                "on a log scale. Please ",
                "set `colorTrans = 'linear'`.", call. = FALSE)
            }


            hic$counts <- log(hic$counts, base = logBase)
            hic$color <- mapColors(vector = hic$counts,
                palette = thicInternal$palette,
                range = log(hicPlot$zrange, logBase)
            )
        } else {
            hic$color <- mapColors(hic$counts,
                palette = thicInternal$palette,
                range = hicPlot$zrange
            )
        }

        hicPlot$color_palette <- thicInternal$palette
    }

    # =========================================================================
    # VIEWPORTS
    # =========================================================================
    
    ## Inner viewport y-coordinate
    if (thicInternal$flip == TRUE){
        y <- unit(1, "npc")
        
    } else {
        y <- unit(0, "npc")
    }

    if (is.null(hicPlot$x) | is.null(hicPlot$y)) {
        vp_name <- "hicTriangle1"
        inside_vp <- viewport(
            height = unit(1, "npc"), width = unit(0.5, "npc"),
            x = unit(0, "npc"), 
            y = y,
            xscale = thicInternal$xscale,
            yscale = thicInternal$xscale,
            just = c("left", "bottom"),
            name = "hicTriangle1_inside",
            angle = -45
        )
        
        # Number of bins along yscale
        num_pixelsWidth <- 
            (thicInternal$chromend - thicInternal$chromstart)/hicPlot$resolution
        per_pixel <- 1.5/num_pixelsWidth
        num_pixelsHeight <- 0.75/per_pixel

        outside_vp <- viewport(
            height = unit(0.75, "snpc"),
            width = unit(1.5, "snpc"),
            x = unit(0.25, "npc"),
            y = unit(0.125, "npc"),
            xscale = thicInternal$xscale,
            yscale = c(0, num_pixelsHeight),
            clip = "on",
            just = c("left", "bottom"),
            name = "hicTriangle1_outside"
        )

        if (thicInternal$draw == TRUE) {
            grid.newpage()
        }
    } else {
        
        ## Get viewport name
        currentViewports <- current_viewports()
        vp_name <- paste0(
            "hicTriangle",
            length(grep(
                pattern = "hicTriangle",
                x = currentViewports
            )) + 1
        )

        ## Get sides of viewport based on input width
        vp_side <- (convertWidth(hicPlot$width,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )) / sqrt(2)

        ## Convert coordinates into same units as page for outside vp
        page_coords <- convert_page(object = hicPlot)

        ## Get bottom left point of triangle (hence bottom left of actual
        ## viewport) based on just
        bottom_coords <- vp_bottomLeft(viewport(
            x = page_coords$x,
            y = page_coords$y,
            width = page_coords$width,
            height = page_coords$height,
            just = hicPlot$just
        ))

        inside_vp <- viewport(
            height = unit(
                vp_side,
                get("page_units", envir = pgEnv)
            ),
            width = unit(
                vp_side,
                get("page_units", envir = pgEnv)
            ),
            x = unit(0, "npc"),
            y = y,
            xscale = thicInternal$xscale,
            yscale = thicInternal$xscale,
            just = c("left", "bottom"),
            name = paste0(vp_name, "_inside"),
            angle = -45
        )
        
        # Number of bins along yscale
        num_pixelsWidth <- 
            (thicInternal$chromend - thicInternal$chromstart)/hicPlot$resolution
        per_pixel <- as.numeric(page_coords$width)/num_pixelsWidth
        num_pixelsHeight <- as.numeric(page_coords$height)/per_pixel

        outside_vp <- viewport(
            height = page_coords$height,
            width = page_coords$width,
            x = unit(
                bottom_coords[[1]],
                get("page_units", envir = pgEnv)
            ),
            y = unit(
                bottom_coords[[2]],
                get("page_units", envir = pgEnv)
            ),
            xscale = thicInternal$xscale,
            yscale = c(0, num_pixelsHeight),
            clip = "on",
            just = c("left", "bottom"),
            name = paste0(vp_name, "_outside")
        )

        addViewport(paste0(vp_name, "_outside"))
    }

    
    # =========================================================================
    # INITIALIZE GTREE FOR GROBS WITH BACKGROUND
    # =========================================================================
    hicPlot$outsideVP <- outside_vp
    backgroundGrob <- rectGrob(gp = gpar(
        fill = thicInternal$bg,
        col = NA
    ), name = "background")
    assign("hic_grobs2", gTree(vp = inside_vp, children = gList(backgroundGrob)),
        envir = pgEnv
    )
    
    # =========================================================================
    # MAKE GROBS
    # =========================================================================

    if (!is.null(hicPlot$chromstart) & !is.null(hicPlot$chromend)) {
        if (nrow(hic) > 0) {
            
            hic$width <- hicPlot$resolution
            hic$height <- hicPlot$resolution

            ## Manually "clip" the grobs that fall out of the desired chmstart
            ## to chromend region
            hic <- manual_clip(hic = hic, hicPlot = hicPlot, 
                                flip = thicInternal$flip)
            hic <- hic[order(utils::type.convert(rownames(hic),
                                            as.is = TRUE)), ]

            ## Separate into squares for upper region and triangle
            ## shapes for the diagonal
            
            if (thicInternal$flip == TRUE){
                squares <- hic[which(hic[, "x"] > hic[, "y"]), ] 
            } else {
                squares <- hic[which(hic[, "y"] > hic[, "x"]), ]  
            }
            
            triangles <- hic[which(hic[, "y"] == hic[, "x"]), ]

            if (nrow(squares) > 0) {

                ## Make square grobs and add to grob gTree
                hic_squares <- rectGrob(
                    x = squares$x,
                    y = squares$y,
                    just = c("left", "bottom"),
                    width = squares$width,
                    height = squares$height,
                    gp = gpar(col = NA, fill = squares$color),
                    default.units = "native"
                )
                assign("hic_grobs2",
                    addGrob(
                        gTree = get("hic_grobs2", envir = pgEnv),
                        child = hic_squares
                    ),
                    envir = pgEnv
                )
            }

            if (nrow(triangles) > 0) {
                ## Make triangle grobs and add to grob gTree
                invisible(apply(triangles, 1, hic_diagonal, 
                                flip = thicInternal$flip))
            }

            if (nrow(squares) == 0 & nrow(triangles) == 0) {
                if (thicInternal$txdbChecks == TRUE) {
                    if (!is.na(hicPlot$resolution)){
                        warning("No data found in region.", call. = FALSE)
                    }
                }
            }
        } else {
            if (!is.na(hicPlot$resolution)){
                warning("No data found in region.", call. = FALSE)
            }
        }
    }


    # =========================================================================
    # IF DRAW == TRUE, DRAW GROBS
    # =========================================================================

    if (thicInternal$draw == TRUE) {
        pushViewport(outside_vp)
        
        grid.draw(get("hic_grobs2", envir = pgEnv))
        upViewport()
    }

    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    hicPlot$grobs <- get("hic_grobs2", envir = pgEnv)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("hicTriangle[", vp_name, "]")
    invisible(hicPlot)
}

library(withr)
library(pdftools)
library(plotgardenerData)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(AnnotationHub)
library(org.Hs.eg.db)


test_that("plotGenes_pdf", {
    temp_pdf <- file.path(tempdir(), "testGenes.pdf")
    on.exit(unlink(temp_pdf))

    graphics.off()
    pdf(temp_pdf, width = 7, height = 3.5)
    suppressMessages(plotGenes(chrom = "chr8",
             chromstart = 1,
              chromend = 3000000,
              assembly = "hg19"))
    dev.off()
    
    expect_equal(pdf_info(temp_pdf)$pages, 1)
    
})

test_that("plotHicRectangle_pdf", {

    data("IMR90_HiC_10kb")
    temp_pdf <- tempfile("testHicRectangle", fileext = ".pdf")
    on.exit(unlink(temp_pdf))
    graphics.off()
    pdf(temp_pdf, width = 6, height = 3.5)
    suppressMessages(plotHicRectangle(data = IMR90_HiC_10kb, resolution = 10000,
                     zrange = c(0, 70),
                     chrom = "chr21",
                     chromstart = 28950000,
                     chromend = 29800000,
                     assembly = "hg19"))
    dev.off()

    expect_equal(pdf_info(temp_pdf)$pages, 1)

})

test_that("plotHicSquare_pdf", {

    data("IMR90_HiC_10kb")
    temp_pdf <- tempfile("testHicSquare", fileext = ".pdf")
    on.exit(unlink(temp_pdf))
    graphics.off()
    pdf(temp_pdf, width = 3, height = 3)
    suppressMessages(plotHicSquare(data = IMR90_HiC_10kb, resolution = 10000,
                  zrange = c(0, 70),
                  chrom = "chr21",
                  chromstart = 28000000,
                  chromend = 30300000,
                  assembly = "hg19"))
    dev.off()

    expect_equal(pdf_info(temp_pdf)$pages, 1)

})

test_that("plotHicTriangle_pdf", {

    data("IMR90_HiC_10kb")
    temp_pdf <- tempfile("testHicTriangle", fileext = ".pdf")
    on.exit(unlink(temp_pdf))
    graphics.off()
    pdf(temp_pdf, width = 4, height = 2.5)
    suppressMessages(plotHicTriangle(data = IMR90_HiC_10kb, resolution = 10000,
                    zrange = c(0, 70),
                    chrom = "chr21",
                    chromstart = 28000000,
                    chromend = 30300000,
                    assembly = "hg19"))
    dev.off()

    expect_equal(pdf_info(temp_pdf)$pages, 1)

})


test_that("plotIdeogram_pdf", {

    temp_pdf <- tempfile("testIdeogram", fileext = ".pdf")
    on.exit(unlink(temp_pdf))
    graphics.off()
    pdf(temp_pdf, width = 4.5, height = 1)
    suppressMessages(plotIdeogram(chrom = "chr2", assembly = "hg19"))
    dev.off()

    expect_equal(pdf_info(temp_pdf)$pages, 1)

})

test_that("plotLegend_pdf", {

    temp_pdf <- tempfile("testLegend", fileext = ".pdf")
    on.exit(unlink(temp_pdf))
    graphics.off()
    pdf(temp_pdf, width = 2, height = 2)
    suppressMessages(plotLegend(legend = c("- strand", "+ strand"),
               fill = c("steel blue", "light salmon"),
               border = FALSE))
    dev.off()

    expect_equal(pdf_info(temp_pdf)$pages, 1)
})

test_that("plotManhattan_pdf", {

    data("hg19_insulin_GWAS")

    temp_pdf <- tempfile("testManhattan", fileext = ".pdf")
    on.exit(unlink(temp_pdf))
    graphics.off()
    pdf(temp_pdf, width = 7.5, height = 4.5)
    suppressMessages(plotManhattan(data = hg19_insulin_GWAS, assembly = "hg19",
                  fill = c("grey", "#37a7db"),
                  sigLine = TRUE, col = "grey", range = c(0, 14)))
    dev.off()

    expect_equal(pdf_info(temp_pdf)$pages, 1)

})

test_that("plotPairs_pdf", {

    data("IMR90_DNAloops_pairs")

    temp_pdf <- tempfile("testPairs", fileext = ".pdf")
    on.exit(unlink(temp_pdf))
    graphics.off()
    pdf(temp_pdf, width = 7.5, height = 2)
    suppressWarnings(plotPairs(data = IMR90_DNAloops_pairs,
              chrom = "chr21",
              chromstart = 27900000, chromend = 30700000,
              assembly = "hg19"))
    dev.off()

    expect_equal(pdf_info(temp_pdf)$pages, 1)

})

test_that("plotPairsArches_pdf", {

    data("IMR90_DNAloops_pairs")

    temp_pdf <- tempfile("testPairsArches", fileext = ".pdf")
    on.exit(unlink(temp_pdf))
    graphics.off()
    pdf(temp_pdf, width = 7.5, height = 2)
    suppressWarnings(plotPairsArches(data = IMR90_DNAloops_pairs,
                    chrom = "chr21",
                    chromstart = 27900000, chromend = 30700000,
                    assembly = "hg19"))
    dev.off()

    expect_equal(pdf_info(temp_pdf)$pages, 1)

})

test_that("plotRanges_pdf", {

    data("IMR90_ChIP_CTCF_reads")

    temp_pdf <- tempfile("testRanges", fileext = ".pdf")
    on.exit(unlink(temp_pdf))
    graphics.off()
    pdf(temp_pdf, width = 7.5, height = 5)
    suppressWarnings(plotRanges(data = IMR90_ChIP_CTCF_reads,
               chrom = "chr21",
               chromstart = 29073000, chromend = 29074000,
               assembly = "hg19"))
    dev.off()

    expect_equal(pdf_info(temp_pdf)$pages, 1)

})

test_that("plotSignal_pdf", {

    data("IMR90_ChIP_H3K27ac_signal")

    temp_pdf <- tempfile("testSignal", fileext = ".pdf")
    on.exit(unlink(temp_pdf))
    graphics.off()
    pdf(temp_pdf, width = 7.5, height = 2)
    suppressMessages(plotSignal(data = IMR90_ChIP_H3K27ac_signal,
               chrom = "chr21",
               chromstart = 28000000, chromend = 30300000,
               assembly = "hg19",
               range = c(0, 45)))
    dev.off()

    expect_equal(pdf_info(temp_pdf)$pages, 1)

})

test_that("plotTranscripts_pdf", {

    temp_pdf <- tempfile("testTranscripts", fileext = ".pdf")
    graphics.off()
    pdf(temp_pdf, width = 7.5, height = 5)
    on.exit(unlink(temp_pdf))
    suppressWarnings(plotTranscripts(chrom = "chr8",
                    chromstart = 1000000,
                    chromend = 2000000,
                    assembly = "hg19"))
    dev.off()

    expect_equal(pdf_info(temp_pdf)$pages, 1)

})

#' Generate row positions for a number of plot elements with a specified height
#' and space between them
#' 
#' @param y A numeric or unit object specifying the starting row y-position.
#' @param height A numeric or unit object specifying the height of rows.
#' @param space A numeric or unit object specifying the space between rows.
#' @param n An integer specifying the number of elements to generate row 
#' positions for.
#' @param default.units A string indicating the default units to use
#' if \code{y}, \code{h}, or \code{s} are only given as numerics.
#' Default value is \code{default.units = "inches"}.
#' 
#' @examples 
#' # Starting at 0.5 units, return a vector of positions for 3 objects that
#' # are 2 units in height with 0.1 units of space between them
#' 
#' pageLayoutRow(y = 0.5, height = 2, space = 0.1, n = 3, 
#'             default.units = "inches")
#' 
#' @returns Returns a unit vector of page positions.
#' @export
pageLayoutRow <- function(y, height, space, n, default.units = "inches"){
    ## Parse default units
    y <- misc_defaultUnits(value = y,
                           name = "y",
                           default.units = default.units)
    height <- misc_defaultUnits(value = height,
                           name = "height",
                           default.units = default.units)
    space <- misc_defaultUnits(value = space,
                           name = "space",
                           default.units = default.units)
    
    ## Calculate positions
    y + ((height+space) * seq(0,(n-1)))
    
}

#' Generate column positions for a number of plot elements with a specified 
#' width and space between them
#' 
#' @param x A numeric or unit object specifying the starting column x-position.
#' @param width A numeric or unit object specifying the width of columns.
#' @param space A numeric or unit object specifying the space between columns.
#' @param n  An integer specifying the number of elements to generate column 
#' positions for.
#' @param default.units A string indicating the default units to use
#' if \code{x}, \code{w}, or \code{s} are only given as numerics.
#' Default value is \code{default.units = "inches"}
#' 
#' @examples 
#' # Starting at 0.5 units, return a vector of positions for 3 objects that
#' # are 2 units in width with 0.1 units of space between them
#' 
#' pageLayoutCol(x = 0.5, width = 2, space = 0.1, n = 3, 
#'             default.units = "inches")
#' 
#' @returns Returns a unit vector of page positions.
#' @export
pageLayoutCol <- \(x, width, space, n, default.units = "inches") 

    ## Calculate positions
    pageLayoutRow(y = x, height = width, space = space, n = n, 
                  default.units = default.units)

#' Draw a vertical guideline at a specified x-coordinate on a 
#' plotgardener page
#' 
#' @usage pageGuideVertical(
#'     x,
#'     default.units = "inches",
#'     linecolor = "grey55",
#'     params = NULL,
#'     ...
#' )
#'
#' @param x A numeric or unit object specifying x-coordinate of guide.
#' @param default.units A string indicating the default units to use
#' if \code{x} is only given as a numeric.
#' Default value is \code{default.units = "inches"}.
#' @param linecolor Character value indicating color of guideline.
#' Default value is \code{linecolor = "grey55"}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @examples
#' ## Create a page
#' pageCreate(width = 6, height = 5, default.units = "inches")
#'
#' ## Add blue vertical guideline at x = 1.7 inches
#' pageGuideVertical(x = 1.7, linecolor = "blue")
#' @return None.
#'
#' @export
pageGuideVertical <- function(x, default.units = "inches",
                                linecolor = "grey55", params = NULL, ...) {

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    vguide <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "vguide"
    )

    ## Set gp
    vguide$gp <- gpar(col = vguide$linecolor)
    vguide$gp <- setGP(
        gpList = vguide$gp,
        params = vguide, ...
    )

    # =========================================================================
    # ERRORS
    # =========================================================================

    if (is.null(vguide$x)) {
        stop("argument \"x\" is missing, with no default.",
            call. = FALSE
        )
    }
    
    # =========================================================================
    # DEFAULT UNITS
    # =========================================================================

    x <- misc_defaultUnits(value = vguide$x, 
                        name = "x", 
                        default.units = vguide$default.units)
    
    # =========================================================================
    # MAKE GROB AND ASSIGN TO GTREE
    # =========================================================================

    guide <- grid.segments(
        x0 = x, x1 = x,
        y0 = unit(0, units = "npc"),
        y1 = unit(1, units = "npc"),
        gp = vguide$gp
    )
    assign("guide_grobs",
        addGrob(
            gTree = get("guide_grobs", envir = pgEnv),
            child = guide
        ),
        envir = pgEnv
    )
}

.onLoad <- function(libname, pkgname) {

    ## Define params object  -----------------------------

    ## Initialize documented params function names
    x <- c("assembly", "gene", "geneBuffer")

    ## Set argument inputs for function definition
    allArgs1 <- paste(paste0(x, "=NULL"), collapse = ",")
    allArgs2 <- paste0(paste(x, "=", x), collapse = ",")

    ## Change specific argument defaults
    allArgs1 <- gsub("assembly=NULL", 'assembly="hg38"', allArgs1)
    allArgs1 <- paste0(allArgs1, ",...")

    ## Pass all arguments into function definition
    pgParams <- parse(text = c(sprintf("

    pgParams <- function(%s) {

    ## Construct object
    object <- structure(.Data = list(%s), class = 'pgParams')
    object[names(list(...))] <- list(...)

    ## Feature: setting region parameters by gene name & assembly -------------

    if (!is.null(gene)){

        ## Parse assembly
        assembly <- parseAssembly(assembly = assembly)

        if (is(assembly$TxDb, 'TxDb')){
            txdbChecks <- TRUE
        } else {
            if (!requireNamespace(assembly$TxDb, quietly = TRUE)){
                txdbChecks <- FALSE
                warning('`', assembly$TxDb, '` not available. Please install',
                ' to define genomic region based on a gene.', call. = FALSE)
            } else {
                txdbChecks <- TRUE
            }
            
        }
        
        ## Custom orgDb
        if (is(assembly$OrgDb, 'OrgDb')){
            orgdbChecks <- TRUE
        } else {
            if (!requireNamespace(assembly$OrgDb, quietly = TRUE)){
                orgdbChecks <- FALSE
                warning('`', assembly$OrgDb, '` not available. Please install',
                ' to define genomic region based ona  gene.', call. = FALSE)
            } else {
                orgdbChecks <- TRUE
            }
        }
        
        if (txdbChecks == TRUE & orgdbChecks == TRUE){

            if (is(assembly$TxDb, 'TxDb')){
                tx_db <- assembly$TxDb
            } else {
                tx_db <- eval(parse(text = paste0(as.name(assembly$TxDb),
                                            '::',
                                            as.name(assembly$TxDb))))
            }
            
            if (is(assembly$OrgDb, 'OrgDb')){
                org_db <- assembly$OrgDb
            } else {
                org_db <- eval(parse(text = paste0(as.name(assembly$OrgDb),
                                        '::',
                                        as.name(assembly$OrgDb))))
            }

        ## Filter TxDb for standard chromosomes
        tx_db <- keepStandardChromosomes(tx_db, pruning.mode = 'coarse')
        
        chromSizes <- GenomeInfoDb::seqlengths(tx_db)
        idCol <- assembly$gene.id.column
        displayCol <- assembly$display.column

        ## convert input gene name to geneID
        geneID <- tryCatch(expr = {
            suppressMessages(AnnotationDbi::select(org_db, keys = gene,
            columns = c(idCol), keytype = displayCol))

        }, error = function(e) stop('Gene', shQuote(gene),
        'does not exist in assembly.', call. = FALSE))

        geneData <- suppressMessages(AnnotationDbi::select(tx_db,
        keys = geneID[[idCol]], columns = AnnotationDbi::columns(tx_db),
        keytype = 'GENEID'))
    
        ## Temporarily convert geneData to GRanges
        geneData_GRanges <- makeGRangesFromDataFrame(geneData, 
        keep.extra.columns = TRUE, seqnames.field = 'TXCHROM', 
        start.field = 'TXSTART', end.field = 'TXEND')
    
        ## Filter non-standard chromosomes from geneData GRanges
        geneData_GRanges <- keepStandardChromosomes(geneData_GRanges, 
                                                    pruning.mode = 'coarse')
        
        ## Convert back to original format
        geneData <- as.data.frame(geneData_GRanges)
        geneData <- subset(geneData, select = -c(width, strand))
        colnames(geneData)[colnames(geneData) == 'seqnames'] <- 'TXCHROM'
        colnames(geneData)[colnames(geneData) == 'start'] <- 'TXSTART'
        colnames(geneData)[colnames(geneData) == 'end'] <- 'TXEND'

        ## Check that user has not supplied both gene and chrom/start/end
        chrom <- object$chrom
        chromstart <- object$chromstart
        chromend <- object$chromend
        if(any(!is.null(c(chrom, chromstart, chromend)))) {
            stop('Cannot use \\'gene\\' in combination with \\'chrom\\',
            \\'chromstart\\', or \\'chromend\\'', call. = FALSE)
        }

        ## Get info about gene region
        minGeneStart <- min(geneData$TXSTART)
        maxGeneEnd <- max(geneData$TXEND)

        ## Set default gene buffer (window = 2X gene length)
        ## Define buffer
        if (is.null(geneBuffer)) geneBuffer <- (maxGeneEnd - minGeneStart) / 2

        if (length(geneBuffer) == 1) geneBuffer <- rep(geneBuffer, 2)

        ## Assign values to params object (with buffer)
        object$chrom      <- unique(geneData$TXCHROM)
        object$chromstart <- minGeneStart - geneBuffer[1]
        object$chromend   <- maxGeneEnd  + geneBuffer[2]
        object$geneBuffer <- geneBuffer

        ## Extract chromSizes length
        chrLength <- chromSizes[[object$chrom]]

        ## Check that starts and ends are within chromSizes
        if (object$chromstart < 1) {
            object$chromstart <- 1
            message('geneBuffer range is less than start. Start has been
            adjusted', call. = FALSE)
        }

        if (object$chromend > chrLength) {
            object$chromend   <- chrLength
            message('geneBuffer range is greater than end. End has been
            adjusted', call. = FALSE)
        }

        }

    }

    ## Filter out null values for pretty printing
    object <- structure(Filter(Negate(is.null), object), class = 'pgParams')

    return(object)

    }
                                        ", allArgs1, allArgs2)))

    ## Assign function in environment
    assign("pgParams", eval(pgParams), rlang::ns_env(pkgname))
}

library(TxDb.Hsapiens.UCSC.hg38.knownGene)
library(plotgardener)

test_that("plotTranscripts transcritFilter works", {
  
  txdb <- TxDb.Hsapiens.UCSC.hg38.knownGene

  tbg <- transcriptsBy(txdb, by="gene")
  gene <- tbg[["7168"]]
  range <- range(gene)

  par <- pgParams(
    chrom = as.character(seqnames(range)),
    chromstart = start(range)-1e4, chromend = end(range)+1e4,
    assembly = "hg38", just = c("left", "bottom")
  )
  
  pageCreate(width = 5, height = 2, showGuides = TRUE)
  
  # highlight can be a subset of filter
  hilite <- data.frame(transcript=c("ENST00000559831.6","ENST00000288398.10"), color=c("blue","red"))
  filter <- c("ENST00000559831.6","ENST00000288398.10","ENST00000651344.1","ENST00000560975.5")
 
  # should only show 4 out of 44 total txps
  plotTranscripts(
    params = par, x = 0.5, y = 1.5, width = 4, height = 1.1,
    transcriptHighlight=hilite, transcriptFilter=filter
  )
 
})

test_that("pgParams object created", {
    object <- pgParams(chrom = "chr1")
    expect_equal(class(object), "pgParams")
})

test_that("pgParams object concatenates", {
    object1 <- pgParams(chrom = "chr1")
    object2 <- pgParams(chromstart = 1000000)
    object3 <- pgParams(chrom = "chr1", chromstart = 1000000)

    expect_equal(class(c(object1, object2)), "pgParams")
    expect_equal(c(object1, object2), object3)
    expect_warning(c(object1, "gene"))
})

test_that("pgParams parameter parsing", {
    
    testFun <- function(data, chrom, chromstart = NULL, chromend = NULL,
                        assembly = "hg19", 
                        params = NULL, ...){
        newObject <- plotgardener:::parseParams(params = params,
                                            defaultArgs = formals(eval(match.call()[[1]])),
                                            declaredArgs = lapply(match.call()[-1], eval.parent,
                                                                  n = 2),
                                            class = "test_object")
        return(newObject)
    }
    
    ## All default parameters
    expect_mapequal(
        testFun(),
        list(data = NULL,
             chrom = NULL,
             chromstart = NULL,
             chromend = NULL,
             assembly = "hg19"
        )
    )
    
    ## Parameter replaces default
    expect_mapequal(
        testFun(chromstart = 1000000),
        list(data = NULL,
             chrom = NULL,
             chromstart = 1000000,
             chromend = NULL,
             assembly = "hg19"
        )
    )
    
    ## pgParams replaces default
    params <- pgParams(assembly = "hg38")
    expect_mapequal(
        testFun(params = params),
        list(data = NULL,
             chrom = NULL,
             chromstart = NULL,
             chromend = NULL,
             assembly = "hg38"
        )
    )
    
    ## Input overrides pgParams
    expect_mapequal(
        testFun(params = params, assembly = "mm9"),
        list(data = NULL,
             chrom = NULL,
             chromstart = NULL,
             chromend = NULL,
             assembly = "mm9"
        )
    )

    ## Multiple replacements
    expect_mapequal(
        testFun(params = params, assembly = "mm9", chromstart = 1000000),
        list(data = NULL,
             chrom = NULL,
             chromstart = 1000000,
             chromend = NULL,
             assembly = "mm9"
        )
    )
    
})

test_that("signalRanges", {
    library(plotgardenerData)
    data("IMR90_ChIP_H3K27ac_signal")
    data("GM12878_ChIP_H3K27ac_signal")
    GM12878_ChIP_H3K27ac_signal[,"score"] <- 
        GM12878_ChIP_H3K27ac_signal[,"score"] * -1
    
    region <- pgParams(
            chrom = "chr21",
            chromstart = 28000000, chromend = 30300000,
            assembly = "hg19")
    
    sig1 <- suppressMessages(plotSignal(
        data = IMR90_ChIP_H3K27ac_signal, params = region, range = c(0, 45)))

    expect_equal(sig1$range, c(0, 45))

    sig2 <- suppressMessages(plotSignal(
        data = list(IMR90_ChIP_H3K27ac_signal, 
                    GM12878_ChIP_H3K27ac_signal), params = region, 
        range = c(-45, 45)
    ))
    expect_equal(sig2$range, c(-45, 45))

})

test_that("plotSignalMessages", {
    
    library(plotgardenerData)
    data("IMR90_ChIP_H3K27ac_signal")
    data("GM12878_ChIP_H3K27ac_signal")
    GM12878_ChIP_H3K27ac_signal[,"score"] <- 
                                    GM12878_ChIP_H3K27ac_signal[,"score"] * -1
    
    region <- pgParams(
        chrom = "chr21",
        chromstart = 28000000, chromend = 30300000,
        assembly = "hg19")
    
    # Positive data should have no warnings/errors
    expect_message(plotSignal(data = IMR90_ChIP_H3K27ac_signal,
                              params = region))
    expect_invisible(plotSignal(data = IMR90_ChIP_H3K27ac_signal,
                              params = region))
    
    # Negative data with negData = TRUE should have no warnings or errors
    expect_message(plotSignal(data = GM12878_ChIP_H3K27ac_signal,
                              params = region, negData = TRUE))
    
    # Negative data with negData = FALSE should throw warning
    expect_warning(plotSignal(data = GM12878_ChIP_H3K27ac_signal,
                              params = region))
    
    # Positive and negative data in proper order should have no warnings/errors
    expect_message(plotSignal(data = list(IMR90_ChIP_H3K27ac_signal,
                                          GM12878_ChIP_H3K27ac_signal),
                              params = region))
    
    # Positive and negative data in proper order should error
    expect_error(plotSignal(data = list(GM12878_ChIP_H3K27ac_signal,
                                        IMR90_ChIP_H3K27ac_signal),
                              params = region))
    
})

#' Remove plotgardener plots and annotations
#'
#' @param plot Plot object to be removed, defined by the output
#' of a plotgardener plotting function.
#'
#' @examples
#' ## Load Hi-C data
#' library(plotgardenerData)
#' data("IMR90_HiC_10kb")
#'
#' ## Create page
#' pageCreate(width = 5.5, height = 4, default.units = "inches")
#'
#' ## Plot and place a square Hi-C plot
#' hicPlot <- plotHicSquare(
#'     data = IMR90_HiC_10kb, resolution = 10000,
#'     zrange = c(0, 70),
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     x = 0.5, y = 0.5, width = 2.5, height = 2.5,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Remove square Hi-C plot from page
#' pagePlotRemove(plot = hicPlot)
#' @return None.
#'
#' @export
pagePlotRemove <- function(plot) {
    
    if (is(plot, "yaxis") | is(plot, "xaxis")){
        grid.remove(gPath(plot$grobs$childrenOrder))
    } else {
        grid.remove(gPath(plot$grobs$name))
        
        pg_vpTree <- get("pg_vpTree", envir = pgEnv)
        pg_vpTree[grep(plot$grobs$name, pg_vpTree)] <- NULL
        assign("pg_vpTree", pg_vpTree, envir = pgEnv)
        
        ## Need to remove outer viewport of bb_hicTriangle/bb_hicRectangle plot
        ## and domain Clips
        if (is(plot, "hicTriangle") |
            is(plot, "hicRectangle")) {
            vp_name <- plot$grobs$vp$name
            vp_name <- gsub("inside", "outside", vp_name)
            suppressMessages(seekViewport(vp_name))
            suppressMessages(popViewport())
        } else if (is(plot, "domain")) {
            if (plot$hicClass != "hicSquare") {
                vp_name <- plot$grobs$vp$name
                vp_name <- gsub("inside", "outside", vp_name)
                suppressMessages(seekViewport(vp_name))
                suppressMessages(popViewport())
            }
        } else if (is(plot, "signal")){
            if (grepl("_v", plot$grobs$vp$name)){
                vp_name <- plot$grobs$vp$name
                vp_name <- gsub("_v", "_vClip", vp_name)
                suppressMessages(seekViewport(vp_name))
                suppressMessages(popViewport())
            }
        } 
    }

}

#' Plot text within a plotgardener layout
#' 
#' @usage plotText(
#'     label,
#'     fontcolor = "black",
#'     fontsize = 12,
#'     rot = 0,
#'     check.overlap = FALSE,
#'     x,
#'     y,
#'     just = "center",
#'     default.units = "inches",
#'     params = NULL,
#'     ...
#' )
#'
#' @param label Character or expression of text to be plotted.
#' @param fontcolor A character value specifying text fontcolor.
#' Default value is \code{fontcolor = "black"}.
#' @param fontsize A numeric specifying text fontsize in points.
#' Default value is \code{fontsize = 12}.
#' @param rot A numeric specifying the angle to rotate the text.
#' Default value is \code{rot = 0}.
#' @param check.overlap A logical value to indicate whether to check
#' for and omit overlapping text.
#' Default value is \code{check.overlap = FALSE}.
#' @param x A numeric vector or unit object specifying text x-location.
#' @param y A numeric vector, unit object, or a character vector of
#' values containing a "b" combined with a numeric value
#' specifying text y-locations.
#' The character vector will place text y-locations relative to the
#' bottom of the most recently plotted plot according to the
#' units of the plotgardener page.
#' @param just Justification of text relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = "center"}.
#' @param default.units A string indicating the default units to use if
#' \code{x} or \code{y} are only given as numerics or numeric vectors.
#' Default value is \code{default.units = "inches"}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{text} object containing relevant
#' placement and \link[grid]{grob} information.
#'
#' @examples
#' ## Create a page
#' pageCreate(width = 4, height = 2, default.units = "inches")
#'
#' ## Plot text, adjusting fontsize and fontface
#' plotText(
#'     label = "plotgardener", fontsize = 14, fontface = "bold",
#'     x = 1, y = 1, just = "center", default.units = "inches"
#' )
#'
#' ## Plot text, adjusting color, rotation, and fontfamily
#' plotText(
#'     label = "coordinate-based", fontcolor = "#225EA8", rot = 90,
#'     fontfamily = "HersheyScript", x = 2, y = 1, just = "center",
#'     default.units = "inches"
#' )
#'
#' ## Plot a text label in multiple places at once
#' plotText(
#'     label = "R", x = c(0.5, 1, 1.5), y = 1.5, just = "center",
#'     default.units = "inches"
#' )
#'
#' ## Plot a vector of text labels
#' plotText(
#'     label = c("pg", "plot", "gardener"), x = 3, y = c(0.5, 1, 1.75),
#'     just = "center", default.units = "inches"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @seealso \link[grid]{grid.text}
#'
#' @export
plotText <- function(label, fontcolor = "black", fontsize = 12, rot = 0,
                        check.overlap = FALSE, x, y, just = "center",
                        default.units = "inches", params = NULL, ...) {


    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    textInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "textInternal"
    )

    ## Set gp
    textInternal$gp <- gpar(
        col = textInternal$fontcolor,
        fontsize = textInternal$fontsize
    )
    
    textInternal$gp <- setGP(
        gpList = textInternal$gp,
        params = textInternal, ...
    )
    
    ## Justification
    textInternal$just <- justConversion(just = textInternal$just)
    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    text <- structure(list(
        label = textInternal$label,
        x = textInternal$x, y = textInternal$y,
        just = textInternal$just, grobs = NULL
    ),
    class = "text"
    )

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_page(error = "Cannot plot text without a `plotgardener` page.")
    if (is.null(text$label)) stop("argument \"label\" is missing, ",
                                    "with no default.", call. = FALSE)
    if (is.null(text$x)) {
        stop("argument \"x\" is missing, with no default.",
            call. = FALSE
        )
    }
    if (is.null(text$y)) {
        stop("argument \"y\" is missing, with no default.",
            call. = FALSE
        )
    }

    # =========================================================================
    # DEFINE PARAMETERS
    # =========================================================================

    ## Get page_height and its units from pgEnv
    page_height <- get("page_height", envir = pgEnv)
    page_units <- get("page_units", envir = pgEnv)
    
    text$x <- misc_defaultUnits(
        value = text$x,
        name = "x",
        default.units = textInternal$default.units
    )
    text$y <- misc_defaultUnits(
        value = text$y,
        name = "y",
        default.units = textInternal$default.units
    )

    ## Convert coordinates to page_units
    new_x <- convertX(text$x, unitTo = page_units, valueOnly = TRUE)
    new_y <- page_height - convertY(text$y,
        unitTo = page_units,
        valueOnly = TRUE
    )

    # =========================================================================
    # MAKE GROB
    # =========================================================================

    name <- paste0(
        "text",
        length(grep(
            pattern = "text",
            x = grid.ls(
                print = FALSE,
                recursive = FALSE
            )
        )) + 1
    )
    
    text <- grid.text(
        label = text$label, x = unit(new_x, page_units),
        y = unit(new_y, page_units), just = text$just,
        gp = textInternal$gp, rot = textInternal$rot,
        check.overlap = textInternal$check.overlap,
        name = name
    )

    # =========================================================================
    # ADD GROB TO OBJECT
    # =========================================================================

    text$grobs <- text

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("text[", text$name, "]")
    invisible(text)
}

#' Create a page for a plotgardener layout
#' 
#' @usage pageCreate(
#'     width = 8.5,
#'     height = 11,
#'     default.units = "inches",
#'     bg = NA,
#'     xgrid = 0.5,
#'     ygrid = 0.5,
#'     showGuides = TRUE,
#'     params = NULL
#' )
#'
#' @param width A numeric or unit object specifying page width.
#' Default value is \code{width = 8}.
#' @param height A numeric or unit object specifying page height.
#' Default value is \code{height = 11}.
#' @param default.units A string indicating the default units to use if
#' \code{width} or \code{height} are only given as numerics.
#' Default value is \code{default.units = "inches"}.
#' @param bg Character value indicating page background color.
#' Default value is \code{bg = NA}.
#' @param xgrid A numeric indicating the increment by which to place
#' vertical gridlines. Default value is \code{xgrid = 0.5}.
#' @param ygrid A numeric indicating the increment by which to place
#' horizontal gridlines. Default value is \code{ygrid = 0.5}.
#' @param showGuides A logical value indicating whether to draw a
#' black border around the entire page and guiding rulers along the top and
#' left side of the page. Default value is \code{showOutline = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#'
#' @examples
#' ## Create a 6-inch wide, 4.5-inch high page
#' pageCreate(width = 6, height = 4.5, default.units = "inches")
#'
#' ## Create a 14-cm wide, 10-cm high page
#' pageCreate(width = 14, height = 10, default.units = "cm")
#' @details \code{width} and \code{height} must be specified in the same units.
#'
#' @return None.
#'
#' @export
pageCreate <- function(width = 8.5, height = 11, default.units = "inches",
                        bg = NA, xgrid = 0.5, ygrid = 0.5, showGuides = TRUE,
                        params = NULL) {

    # =========================================================================
    # FUNCTION
    # =========================================================================

    errorcheck_pageCreate <- function(object) {

        ## Width and height can't be negative
        if (as.numeric(object$width) <= 0) {
            stop("`width` cannot be 0 or negative.", call. = FALSE)
        }

        if (as.numeric(object$height) <= 0) {
            stop("`height` cannot be 0 or negative.", call. = FALSE)
        }


        ## Width and height need to be of the same units
        widthUnit <- gsub("[0-9]|[.]", "", object$width)
        heightUnit <- gsub("[0-9]|[.]", "", object$height)
        if (widthUnit != heightUnit) {
            stop("`width` and `height` must be in the same units. ",
                "`width` detected as", "`", widthUnit, "`",
                "and `height` detected as", "`", heightUnit, "`", ".",
                call. = FALSE
            )
        }

        ## Page units must be a valid option
        page_units <- gsub("[0-9]|[.]", "", page$width)
        if (!page_units %in% validUnits) {
            message <- paste(c(
                "Invalid page units. Options for page units are:",
                validUnits
            ),
            collapse = " "
            )
            stop(message, call. = FALSE)
        }
    }

    # =========================================================================
    # MAKE NEW PAGE
    # =========================================================================

    grid.newpage()
    assign("pg_vpTree", list(), envir = pgEnv)

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    page <- parseParams(params = params, 
                        defaultArgs = formals(eval(match.call()[[1]])),
                        declaredArgs = lapply(match.call()[-1], eval.parent, 
                                            n = 2),
                        class = "page")
    
    # =========================================================================
    # DEFAULT UNITS
    # =========================================================================

    if (!"unit" %in% class(page$width)) {
        if (!is.numeric(page$width)) {
            stop("`width` is neither a unit object nor a numeric value. ",
                "Cannot create `plotgardener` page.", call. = FALSE)
        }

        if (is.null(page$default.units)) {
            stop("`width` detected as numeric. `default.units` ",
                "must be specified.", call. = FALSE)
        }

        if (!page$default.units %in% validUnits) {
            message <- paste(c("Invalid default units. ",
                            "Options for page units are:", validUnits),
                collapse = " "
            )
            stop(message, call. = FALSE)
        }

        page$width <- unit(page$width, page$default.units)
    }

    if (!"unit" %in% class(page$height)) {
        if (!is.numeric(page$height)) {
            stop("`height` is neither a unit object or a numeric value. ",
                "Cannot create `plotgardener` page.", call. = FALSE)
        }

        if (is.null(page$default.units)) {
            stop("`height` detected as numeric. `default.units` ",
                "must be specified.",
                call. = FALSE
            )
        }


        if (!page$default.units %in% validUnits) {
            message <- paste(c("Invalid default units. Options for page ",
                            "units are:", validUnits),
                collapse = " "
            )
            stop(message, call. = FALSE)
        }

        page$height <- unit(page$height, page$default.units)
    }

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    errorcheck_pageCreate(object = page)

    # =========================================================================
    # ASSIGN PAGE PARAMETERS
    # =========================================================================
    page_height <- as.numeric(page$height)
    assign("page_height", page_height, envir = pgEnv)

    page_units <- gsub("[0-9]|[.]", "", page$width)
    assign("page_units", page_units, envir = pgEnv)

    page_width <- as.numeric(page$width)

    # =========================================================================
    # VIEWPORT
    # =========================================================================

    page_vp <- viewport(
        x = unit(0.5, "npc"), y = unit(0.5, "npc"),
        width = page$width, height = page$height,
        xscale = c(0, page_width),
        yscale = rev(c(0, page_height)),
        name = "page"
    )

    # =========================================================================
    # INITIALIZE GTREE
    # =========================================================================

    assign("guide_grobs", gTree(name = "guide_grobs", vp = page_vp),
        envir = pgEnv
    )
    
    # =========================================================================
    # BACKGROUND
    # =========================================================================
    
    background <- rectGrob(gp = gpar(fill = page$bg, col = NA))
    assign("guide_grobs",
            addGrob(
                gTree = get("guide_grobs", envir = pgEnv),
                child = background
            ),
            envir = pgEnv
    )
    # =========================================================================
    # SHOW OUTLINE/RULER/UNITS
    # =========================================================================

    if (page$showGuides == TRUE) {
        border <- rectGrob()
        assign("guide_grobs",
            addGrob(
                gTree = get("guide_grobs", envir = pgEnv),
                child = border
            ),
            envir = pgEnv
        )


        if (page_units == "inches") {
            div <- 1 / 16
            x0 <- 0
            x1 <- -1 / 32
            y0 <- page_height
            y1 <- page_height + 1 / 32
            xsegs <- segmentsGrob(
                x0 = seq(0, page_width, div), y0 = y0,
                x1 = seq(0, page_width, div), y1 = y1,
                default.units = page_units,
                gp = gpar(col = "black")
            )
            ysegs <- segmentsGrob(
                x0 = x0, y0 = seq(0, page_height, div),
                x1 = x1, y1 = seq(0, page_height, div),
                default.units = "native",
                gp = gpar(col = "black")
            )

            for (i in seq(1, 4)) {
                div <- div * 2
                x0 <- x1
                x1 <- x1 - 1 / 32
                y0 <- y1
                y1 <- y1 + 1 / 32
                v <- segmentsGrob(
                    x0 = xsegs$x0[xsegs$x0 %in% unit(seq(0, page_width, div), 
                                                     page_units)],
                    y0 = y0,
                    x1 = xsegs$x0[xsegs$x0 %in% unit(seq(0, page_width, div),
                                                     page_units)],
                    y1 = y1, default.units = page_units,
                    gp = gpar(col = "black")
                )
                h <- segmentsGrob(
                    x0 = x0,
                    y0 = ysegs$y1[ysegs$y1 %in% unit(seq(0, page_height, div),
                                                     "native")],
                    x1 = x1,
                    y1 = ysegs$y1[ysegs$y1 %in% unit(seq(0, page_height, div),
                                                     "native")],
                    default.units = "native",
                    gp = gpar(col = "black")
                )

                assign("guide_grobs",
                    addGrob(
                        gTree = get("guide_grobs", envir = pgEnv),
                        child = v
                    ),
                    envir = pgEnv
                )
                assign("guide_grobs",
                    addGrob(
                        gTree = get("guide_grobs", envir = pgEnv),
                        child = h
                    ),
                    envir = pgEnv
                )
            }

            hLabel <- textGrob(
                label = seq(0, page_width, div),
                x = seq(0, page_width, div),
                y = y0, vjust = -0.5,
                default.units = page_units
            )
            vLabel <- textGrob(
                label = seq(0, page_height, div),
                x = x0,
                y = seq(0, page_height, div),
                hjust = 1.5,
                default.units = "native"
            )
        } else if (page_units == "cm") {
            tickH <- convertUnit(
                x = unit(1 / 32, "inches"),
                unitTo = "cm", valueOnly = TRUE
            )
            div <- 1 / 10
            x0 <- 0
            x1 <- -3 * tickH
            y0 <- page_height
            y1 <- page_height + 3 * tickH
            xsegs <- segmentsGrob(
                x0 = seq(0, page_width, div),
                y0 = y0,
                x1 = seq(0, page_width, div),
                y1 = y1,
                default.units = page_units,
                gp = gpar(col = "black")
            )
            ysegs <- segmentsGrob(
                x0 = x0,
                y0 = seq(0, page_height, div),
                x1 = x1,
                y1 = seq(0, page_height, div),
                default.units = "native",
                gp = gpar(col = "black")
            )


            div2 <- 1 / 2
            v2 <- segmentsGrob(
                x0 = seq(0, page_width, div2),
                y0 = page_height + 3 * tickH,
                x1 = seq(0, page_width, div2),
                y1 = page_height + 4 * tickH,
                default.units = page_units,
                gp = gpar(col = "black")
            )
            h2 <- segmentsGrob(
                x0 = -3 * tickH,
                y0 = seq(0, page_height, div2),
                x1 = -4 * tickH,
                y1 = seq(0, page_height, div2),
                default.units = "native",
                gp = gpar(col = "black")
            )
            assign("guide_grobs",
                addGrob(
                    gTree = get("guide_grobs", envir = pgEnv),
                    child = v2
                ),
                envir = pgEnv
            )
            assign("guide_grobs",
                addGrob(gTree = get("guide_grobs",
                    envir = pgEnv
                ), child = h2),
                envir = pgEnv
            )

            div3 <- 1
            v3 <- segmentsGrob(
                x0 = seq(0, page_width, div3),
                y0 = page_height + 4 * tickH,
                x1 = seq(0, page_width, div3),
                y1 = page_height + 5 * tickH,
                default.units = page_units,
                gp = gpar(col = "black")
            )
            h3 <- segmentsGrob(
                x0 = -4 * tickH,
                y0 = seq(0, page_height, div3),
                x1 = -5 * tickH,
                y1 = seq(0, page_height, div3),
                default.units = "native",
                gp = gpar(col = "black")
            )
            assign("guide_grobs",
                addGrob(
                    gTree = get("guide_grobs", envir = pgEnv),
                    child = v3
                ),
                envir = pgEnv
            )
            assign("guide_grobs",
                addGrob(
                    gTree = get("guide_grobs", envir = pgEnv),
                    child = h3
                ),
                envir = pgEnv
            )

            hLabel <- textGrob(
                label = seq(0, page_width, div3),
                x = seq(0, page_width, div3),
                y = page_height + 4 * tickH,
                vjust = -0.5,
                default.units = page_units
            )
            vLabel <- textGrob(
                label = seq(0, page_height, div3),
                x = -4 * tickH,
                y = seq(0, page_height, div3),
                hjust = 1.5,
                default.units = "native"
            )
        } else if (page_units == "mm") {
            tickH <- convertUnit(
                x = unit(1 / 32, "inches"),
                unitTo = "mm", valueOnly = TRUE
            )
            div <- 1
            x0 <- 0
            x1 <- -3 * tickH
            y0 <- page_height
            y1 <- page_height + 3 * tickH
            xsegs <- segmentsGrob(
                x0 = seq(0, page_width, div),
                y0 = y0,
                x1 = seq(0, page_width, div),
                y1 = y1,
                default.units = page_units,
                gp = gpar(col = "black")
            )
            ysegs <- segmentsGrob(
                x0 = x0,
                y0 = seq(0, page_height, div),
                x1 = x1,
                y1 = seq(0, page_height, div),
                default.units = "native",
                gp = gpar(col = "black")
            )

            div2 <- 5
            v2 <- segmentsGrob(
                x0 = seq(0, page_width, div2),
                y0 = page_height + 3 * tickH,
                x1 = seq(0, page_width, div2),
                y1 = page_height + 4 * tickH,
                default.units = page_units,
                gp = gpar(col = "black")
            )
            h2 <- segmentsGrob(
                x0 = -3 * tickH,
                y0 = seq(0, page_height, div2),
                x1 = -4 * tickH,
                y1 = seq(0, page_height, div2),
                default.units = "native",
                gp = gpar(col = "black")
            )
            assign("guide_grobs",
                addGrob(
                    gTree = get("guide_grobs", envir = pgEnv),
                    child = v2
                ),
                envir = pgEnv
            )
            assign("guide_grobs",
                addGrob(
                    gTree = get("guide_grobs", envir = pgEnv),
                    child = h2
                ),
                envir = pgEnv
            )

            div3 <- 10
            v3 <- segmentsGrob(
                x0 = seq(0, page_width, div3),
                y0 = page_height + 4 * tickH,
                x1 = seq(0, page_width, div3),
                y1 = page_height + 5 * tickH,
                default.units = page_units,
                gp = gpar(col = "black")
            )
            h3 <- segmentsGrob(
                x0 = -4 * tickH,
                y0 = seq(0, page_height, div3),
                x1 = -5 * tickH,
                y1 = seq(0, page_height, div3),
                default.units = "native",
                gp = gpar(col = "black")
            )
            assign("guide_grobs",
                addGrob(
                    gTree = get("guide_grobs", envir = pgEnv),
                    child = v3
                ),
                envir = pgEnv
            )
            assign("guide_grobs",
                addGrob(
                    gTree = get("guide_grobs", envir = pgEnv),
                    child = h3
                ),
                envir = pgEnv
            )

            hLabel <- textGrob(
                label = seq(0, page_width, div3),
                x = seq(0, page_width, div3),
                y = page_height + 4 * tickH,
                vjust = -0.5, default.units = page_units
            )
            vLabel <- textGrob(
                label = seq(0, page_height, div3),
                x = -4 * tickH,
                y = seq(0, page_height, div3),
                hjust = 1.5, default.units = "native"
            )
        } else {
            tickH <- convertUnit(
                x = unit(1 / 32, "inches"),
                unitTo = page_units, valueOnly = TRUE
            )
            div <- 1 / 10
            x0 <- 0
            x1 <- -3 * tickH
            y0 <- page_height
            y1 <- page_height + 3 * tickH
            xsegs <- segmentsGrob(
                x0 = seq(0, page_width, div),
                y0 = y0,
                x1 = seq(0, page_width, div),
                y1 = y1,
                default.units = page_units,
                gp = gpar(col = "black")
            )
            ysegs <- segmentsGrob(
                x0 = x0,
                y0 = seq(0, page_height, div),
                x1 = x1,
                y1 = seq(0, page_height, div),
                default.units = "native",
                gp = gpar(col = "black")
            )


            div2 <- 1 / 2
            v2 <- segmentsGrob(
                x0 = seq(0, page_width, div2),
                y0 = page_height + 3 * tickH,
                x1 = seq(0, page_width, div2),
                y1 = page_height + 4 * tickH,
                default.units = page_units,
                gp = gpar(col = "black")
            )
            h2 <- segmentsGrob(
                x0 = -3 * tickH,
                y0 = seq(0, page_height, div2),
                x1 = -4 * tickH,
                y1 = seq(0, page_height, div2),
                default.units = "native",
                gp = gpar(col = "black")
            )
            assign("guide_grobs",
                addGrob(
                    gTree = get("guide_grobs", envir = pgEnv),
                    child = v2
                ),
                envir = pgEnv
            )
            assign("guide_grobs",
                addGrob(
                    gTree = get("guide_grobs", envir = pgEnv),
                    child = h2
                ),
                envir = pgEnv
            )

            div3 <- 1
            v3 <- segmentsGrob(
                x0 = seq(0, page_width, div3),
                y0 = page_height + 4 * tickH,
                x1 = seq(0, page_width, div3),
                y1 = page_height + 5 * tickH,
                default.units = page_units,
                gp = gpar(col = "black")
            )
            h3 <- segmentsGrob(
                x0 = -4 * tickH,
                y0 = seq(0, page_height, div3),
                x1 = -5 * tickH,
                y1 = seq(0, page_height, div3),
                default.units = "native",
                gp = gpar(col = "black")
            )
            assign("guide_grobs",
                addGrob(
                    gTree = get("guide_grobs", envir = pgEnv),
                    child = v3
                ),
                envir = pgEnv
            )
            assign("guide_grobs",
                addGrob(gTree = get("guide_grobs",
                    envir = pgEnv
                ), child = h3),
                envir = pgEnv
            )

            hLabel <- textGrob(
                label = seq(0, page_width, div3),
                x = seq(0, page_width, div3),
                y = page_height + 4 * tickH,
                vjust = -0.5, default.units = page_units
            )
            vLabel <- textGrob(
                label = seq(0, page_height, div3),
                x = -4 * tickH,
                y = seq(0, page_height, div3),
                hjust = 1.5, default.units = "native"
            )
        }

        assign("guide_grobs",
            addGrob(
                gTree = get("guide_grobs", envir = pgEnv),
                child = xsegs
            ),
            envir = pgEnv
        )
        assign("guide_grobs",
            addGrob(
                gTree = get("guide_grobs", envir = pgEnv),
                child = ysegs
            ),
            envir = pgEnv
        )
        assign("guide_grobs",
            addGrob(
                gTree = get("guide_grobs", envir = pgEnv),
                child = hLabel
            ),
            envir = pgEnv
        )
        assign("guide_grobs",
            addGrob(
                gTree = get("guide_grobs", envir = pgEnv),
                child = vLabel
            ),
            envir = pgEnv
        )


        ## Unit annotation
        unitLabel <- textGrob(
            label = page_units, x = 0,
            y = page_height, hjust = 1.75,
            vjust = -1.5, default.units = page_units,
            just = c("right", "bottom")
        )
        assign("guide_grobs",
            addGrob(
                gTree = get("guide_grobs", envir = pgEnv),
                child = unitLabel
            ),
            envir = pgEnv
        )
        
        # =====================================================================
        # X AND Y GRIDLINES
        # =====================================================================
        
        ## Draw x and y gridlines
        tryCatch(expr = {
            xGrid <- segmentsGrob(
                x0 = seq(0, page_width, page$xgrid),
                y0 = 0,
                x1 = seq(0, page_width, page$xgrid),
                y1 = page$height,
                default.units = page_units,
                gp = gpar(col = "grey50", lty = 2, lwd = 0.5)
            )
            
            yGrid <- segmentsGrob(
                x0 = 0,
                y0 = seq(0, page_height, page$ygrid),
                x1 = page_width,
                y1 = seq(0, page_height, page$ygrid),
                default.units = "native",
                gp = gpar(col = "grey50", lty = 2, lwd = 0.5)
            )
            
            assign("guide_grobs",
                    addGrob(
                        gTree = get("guide_grobs", envir = pgEnv),
                        child = xGrid
                    ),
                    envir = pgEnv
            )
            assign("guide_grobs",
                    addGrob(
                        gTree = get("guide_grobs", envir = pgEnv),
                        child = yGrid
                    ),
                    envir = pgEnv
            )
        }, error = function(e) {
            return()
        })
        
        }

    # =========================================================================
    # DRAW GROBS
    # =========================================================================

    grid.draw(get("guide_grobs", envir = pgEnv))
    downViewport("page")
}

#' Add a y-axis to a plot
#' 
#' @usage annoYaxis(
#'     plot,
#'     at = NULL,
#'     label = TRUE,
#'     main = TRUE,
#'     scipen = 999,
#'     axisLine = FALSE,
#'     params = NULL,
#'     ...
#' )
#'
#' @param plot Plot object to annotate with y-axis.
#' @param at A numeric vector of y-value locations for tick marks.
#' @param label A logical value indicating whether to draw the labels
#' on the tick marks, or an expression or character vector which specify
#' the labels to use.
#' If not logical, must be the same length as the \code{at} argument.
#' @param main A logical value indicating whether to draw the y-axis at
#' the left of the plot. Default value is \code{main = TRUE}. Options are:
#' \itemize{
#' \item{\code{TRUE}: }{y-axis is drawn at the left of the plot.}
#' \item{\code{FALSE}: }{y-axis is drawn at the right of the plot.}
#' }
#' @param scipen An integer indicating the penalty to be applied when
#' deciding to print numeric values in fixed or exponential notation.
#' Default value is \code{scipen = 999}.
#' @param axisLine A logical value indicating whether to show the axis line.
#' Default value is \code{axisLine = FALSE}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{yaxis} object containing
#' relevant \link[grid]{grob} information.
#'
#' @examples
#' ## Load Hi-C data
#' library(plotgardenerData)
#' data("IMR90_HiC_10kb")
#'
#' ## Create page
#' pageCreate(width = 4, height = 3.5, default.units = "inches")
#'
#' ## Plot and place a square Hi-C plot
#' hicPlot <- plotHicSquare(
#'     data = IMR90_HiC_10kb, resolution = 10000,
#'     zrange = c(0, 70),
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19",
#'     x = 1, y = 0.5, width = 2.5, height = 2.5,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Add standard y-axis to Hi-C plot
#' annoYaxis(
#'     plot = hicPlot, at = c(28000000, 29000000, 30300000),
#'     fontsize = 10
#' )
#'
#' ## Annotate genome label on x-axis
#' annoGenomeLabel(plot = hicPlot, x = 1, y = 3.03)
#'
#' ## Annotate heatmap legend
#' annoHeatmapLegend(
#'     plot = hicPlot,
#'     x = 3.6, y = 0.5, width = 0.12, height = 1.2
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
annoYaxis <- function(plot, at = NULL, label = TRUE, main = TRUE,
                        scipen = 999, axisLine = FALSE, params = NULL, ...) {

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    yInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "yInternal"
    )

    ## Set gp
    yInternal$gp <- setGP(
        gpList = gpar(),
        params = yInternal, ...
    )
    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    if (is.null(yInternal$plot)) stop("argument \"plot\" is missing, ",
                                        "with no default.", call. = FALSE)
    check_page(error = "Cannot add an y-axis without a `plotgardener` page.")

    # =========================================================================
    # SAVE USER'S SCIPEN AND SET OURS TEMPORARILY
    # =========================================================================

    oo <- options(scipen = yInternal$scipen)
    on.exit(options(oo))

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    yAxis <- structure(list(grobs = NULL), class = "yaxis")

    # =========================================================================
    # CREATE GROB WITHOUT DRAWING
    # =========================================================================

    yGrob <- yaxisGrob(
        at = yInternal$at, label = yInternal$label,
        main = yInternal$main, gp = yInternal$gp,
        vp = yInternal$plot$grobs$vp
    )

    # =========================================================================
    # GET CENTER OF INPUT PLOT VIEWPORT BASED ON INPUT PLOT TYPE AND JUST
    # =========================================================================

    # Get appropriate plot viewport
    plotVP <- getAnnoViewport(plot = yInternal$plot)
    
    adjusted_vp <- adjust_vpCoords(viewport = plotVP)

    # =========================================================================
    # SET AT
    # =========================================================================

    if (is.null(yInternal$at)) {
        yInternal$at <- c(plotVP$yscale[1], plotVP$yscale[2])
    }

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## Make viewport name
    currentViewports <- current_viewports()
    vp_name <- paste0(
        "yaxis",
        length(grep(
            pattern = "yaxis",
            x = currentViewports
        )) + 1
    )

    ## Define viewport
    if (yInternal$main == TRUE) {
        vp <- viewport(
            width = widthDetails(yGrob), height = plotVP$height,
            x = adjusted_vp[[1]] - 0.5 * (plotVP$width),
            y = adjusted_vp[[2]] - 0.5 * (plotVP$height),
            just = c("right", "bottom"), yscale = plotVP$yscale,
            name = vp_name
        )
    } else if (yInternal$main == FALSE) {
        vp <- viewport(
            width = widthDetails(yGrob), height = plotVP$height,
            x = adjusted_vp[[1]] + 0.5 * (plotVP$width),
            y = adjusted_vp[[2]] - 0.5 * (plotVP$height),
            just = c("left", "bottom"), yscale = plotVP$yscale,
            name = vp_name
        )
    }

    # =========================================================================
    # PLOT
    # =========================================================================

    yGrob <- yaxisGrob(
        at = yInternal$at, label = yInternal$label,
        main = yInternal$main, gp = yInternal$gp,
        vp = vp
    )
    
    if (!yInternal$axisLine){
        yGrob <- removeGrob(yGrob, "major")
    } 
    
    grid.draw(yGrob)
    
    yaxis_grobs <- gTree(vp = vp, children = gList(yGrob))
    yAxis$grobs <- yaxis_grobs

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("yaxis[", vp_name, "]")
    invisible(yAxis)
}

#' Make a \code{assembly} object for alternate TxDb, OrgDb,and BSgenome
#' genomic annotation packages
#' 
#' @usage assembly(
#'     Genome,
#'     TxDb,
#'     OrgDb,
#'     gene.id.column = "ENTREZID",
#'     display.column = "SYMBOL",
#'     BSgenome = NULL
#' )
#'
#' @param Genome String indicating the name of the genome assembly.
#' @param TxDb String of existing TxDb package name or a TxDb object.
#' @param OrgDb String of the desired OrgDb package name.
#' @param gene.id.column String of the TxDb column name that refers to
#' the given TxDb gene IDs.
#' Default value is \code{gene.id.column = "ENTREZID"}.
#' @param display.column String of the OrgDb column name that refers to
#' the type of gene symbol to be displayed in plots.
#' Default value is \code{display.column = "SYMBOL"}.
#' @param BSgenome String of the desired BSgenome package name.
#'
#' @return Returns a \code{assembly} object containing all input parameters.
#'
#' @examples
#' ## Create a custom `assembly` object for hg38/GRCh38 packages
#' newAssembly <- assembly(
#'     Genome = "hg38_GRCh38",
#'     TxDb = "TxDb.Hsapiens.UCSC.hg38.knownGene",
#'     OrgDb = "org.Hs.eg.db",
#'     BSgenome = "BSgenome.Hsapiens.NCBI.GRCh38"
#' )
#' @seealso \link[GenomicFeatures]{TxDb}, \link[AnnotationDbi]{OrgDb-class},
#' \link[BSgenome]{BSgenome}
#'
#' @export
assembly <- function(Genome, TxDb, OrgDb, gene.id.column = "ENTREZID",
                        display.column = "SYMBOL", BSgenome = NULL) {
    object <- structure(list(
        Genome = Genome, TxDb = TxDb, OrgDb = OrgDb,
        gene.id.column = gene.id.column,
        display.column = display.column
    ),
    class = "assembly"
    )

    if (is(object$TxDb, "TxDb")) {
        object$TxDb$packageName <- paste0("TxDb.", Genome)
    }

    if (!is.null(BSgenome)) {
        object$BSgenome <- BSgenome
    }

    invisible(object)
}

#' Plot genomic range elements in a pileup or collapsed format
#' 
#' @usage plotRanges(
#'     data,
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     assembly = "hg38",
#'     fill = "#7ecdbb",
#'     linecolor = NA,
#'     order = "width",
#'     collapse = FALSE,
#'     boxHeight = unit(2, "mm"),
#'     spaceWidth = 0.02,
#'     spaceHeight = 0.3,
#'     limitLabel = TRUE,
#'     strandSplit = FALSE,
#'     bg = NA,
#'     baseline = FALSE,
#'     baseline.color = "grey",
#'     baseline.lwd = 1,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL,
#'     ...
#' )
#'
#' @param data Data to be plotted; as a character value specifying
#' a BED file path, a data frame in BED format, a character value
#' specifying a .bam file path where a bam index file (.bam.bai)
#' is in the same directory, or a \link[GenomicRanges]{GRanges} object.
#' @param chrom Chromosome of region to be plotted, as a string.
#' @param chromstart Integer start position on chromosome to be plotted.
#' @param chromend Integer end position on chromosome to be plotted.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param fill A single character value, a vector, or a 
#' \link[plotgardener]{colorby} object specifying fill colors of range elements.
#' Default value is \code{fill = "#7ecdbb"}.
#' @param linecolor A single character value, a vector, or a
#' \link[plotgardener]{colorby} object specifying the color of the lines
#' outlining range elements. Default value is \code{linecolor = NA}.
#' Special options include:
#' \itemize{
#' \item{\code{NA}: }{No line color.}
#' \item{\code{"fill"}: }{Same color as \code{fill}.}
#' } .
#' @param order A character value specifying how to order pileup data
#' before assigning rows. Default value is \code{order = "width"}. Options 
#' include:
#' \itemize{
#' \item{\code{"width"}: }{Ordered by decreasing width of elements.}
#' \item{\code{"random"}: }{Ordered randomly in each function call.}
#' } .
#' @param collapse A logical value indicating whether to collapse
#' range elements into a single row, or into
#' two rows if \code{strandSplit = TRUE}.
#' If \code{collapse = TRUE}, \code{boxHeight} will be ignored and elements
#' will be the height of the entire plot if \code{strandSplit = FALSE} or
#' be the height of half of the entire plot if \code{strandSplit = TRUE}.
#' Default value is \code{collapse = FALSE}.
#' @param boxHeight A numeric or unit object specifying height of range element
#' boxes. Default value is \code{boxHeight = unit(2, "mm")}.
#' @param spaceWidth A numeric value specifying the width of minimum spacing
#' between range element boxes, as a fraction of the plot's genomic range.
#' Default value is \code{spaceWidth = 0.02}.
#' @param spaceHeight A numeric value specifying the height of spacing between
#' range element boxes on different rows, as a fraction of boxHeight.
#' Default value is \code{spaceHeight = 0.3}.
#' @param limitLabel A logical value indicating whether to draw a "+"
#' when not all elements can be plotted in the plotting space. Default 
#' value is \code{limitLabel = TRUE}.
#' @param strandSplit A logical value indicating whether plus and
#' minus-stranded elements should be separated. Elements can only be
#' split by strand if a \code{strand} column is found in \code{data}.
#' Default value is \code{strandSplit = FALSE}.
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param baseline Logical value indicating whether to include a
#' baseline along the x-axis. Default value is \code{baseline = FALSE}.
#' @param baseline.color Baseline color.
#' Default value is \code{baseline.color = "grey"}.
#' @param baseline.lwd Baseline line width.
#' Default value is \code{baseline.lwd = 1}.
#' @param x A numeric or unit object specifying ranges plot x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying ranges plot y-location.
#' The character value will
#' place the ranges plot y relative to the bottom of the most recently
#' plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying ranges plot width.
#' @param height A numeric or unit object specifying ranges plot height.
#' @param just Justification of ranges plot relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use
#' if \code{x}, \code{y}, \code{width}, or \code{height} are only given
#' as numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output should
#' be produced. Default value \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{ranges} object containing relevant
#' genomic region, coloring data, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load ranges data in BED format
#' library(plotgardenerData)
#' data("IMR90_ChIP_CTCF_reads")
#'
#' ## Create page
#' pageCreate(width = 7.5, height = 5, default.units = "inches")
#'
#' ## Plot and place a pileup ranges plot
#' pileupPlot <- plotRanges(
#'     data = IMR90_ChIP_CTCF_reads, chrom = "chr21",
#'     chromstart = 29073000, chromend = 29074000,
#'     assembly = "hg19",
#'     order = "random",
#'     fill = colorby("strand", palette = 
#'                 colorRampPalette(c("#7ecdbb", "#37a7db"))),
#'     strandSplit = TRUE, 
#'     x = 0.5, y = 0.25, width = 6.5, height = 4.25,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Annotate genome label
#' annoGenomeLabel(
#'     plot = pileupPlot, x = 0.5, y = 4.5,
#'     just = c("left", "top")
#' )
#'
#' ## Add text labels
#' plotText(
#'     label = "+ strand", fontcolor = "#37a7db", fontsize = 12,
#'     x = 0.5, y = 1.25, just = "left"
#' )
#' plotText(
#'     label = "- strand", fontcolor = "#7ecdbb", fontsize = 12,
#'     x = 0.5, y = 3.5, just = "left"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @details
#' A ranges plot can be placed on a plotgardener coordinate page by providing
#' plot placement parameters:
#' \preformatted{
#' plotRanges(data, chrom,
#'             chromstart = NULL, chromend = NULL,
#'             x, y, width, height, just = c("left", "top"),
#'             default.units = "inches")
#' }
#' This function can also be used to quickly plot an unannotated BED plot
#' by ignoring plot placement parameters:
#' \preformatted{
#' plotRanges(data, chrom,
#'             chromstart = NULL, chromend = NULL)
#' }
#'
#' @export
plotRanges <- function(data, chrom, chromstart = NULL, chromend = NULL,
                        assembly = "hg38", fill = "#7ecdbb",
                        linecolor = NA, order = "width", collapse = FALSE, 
                        boxHeight = unit(2, "mm"), spaceWidth = 0.02,
                        spaceHeight = 0.3, limitLabel = TRUE,
                        strandSplit = FALSE, bg = NA,
                        baseline = FALSE, baseline.color = "grey",
                        baseline.lwd = 1,
                        x = NULL, y = NULL, width = NULL, height = NULL,
                        just = c("left", "top"), default.units = "inches",
                        draw = TRUE, params = NULL, ...) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors
    errorcheck_plotPileup <- function(pileupPlot, fill, bed, order) {

        ## Genomic region
        regionErrors(chromstart = pileupPlot$chromstart,
                    chromend = pileupPlot$chromend)
        
        ## Fill/colorby checks
        checkColorby(fill = fill,
                    colorby = TRUE,
                    data = bed)
        
        ## Check order parameter options
        if (!order %in% c("width", "random")){
            stop("Invalid `order` parameter.", call. = FALSE)
        }
    }

    ## Define a function that parses the yscale based on split strands
    strand_scale <- function(strandSplit, height) {
        if (strandSplit == TRUE) {
            yscale <- c(-height / 2, height / 2)
        } else {
            yscale <- c(0, height)
        }

        return(yscale)
    }
    
    ## Define a function that orders input data based on "order" parameter
    orderData <- function(data, order){
        if (order == "width"){
            # Order data by decreasing width of elements
            orderedData <- data[order(data[, "width"], decreasing = TRUE), ]
            
        } else if (order == "random"){
            # Order data randomly
            orderedData <- data[sample(nrow(data)), ]
        }
        
        return(orderedData)
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    pileInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "pileInternal"
    )

    ## Parse gp
    pileInternal$gp <- setGP(
        gpList = gpar(),
        params = pileInternal, ...
    )
    
    ## Justification
    pileInternal$just <- justConversion(just = pileInternal$just)

    # =========================================================================
    # CHECK ARGUMENT ERROS
    # =========================================================================

    if (is.null(pileInternal$data)) stop("argument \"data\" is missing, ",
                                            "with no default.", call. = FALSE)
    if (is.null(pileInternal$chrom)) stop("argument \"chrom\" is missing, ",
                                            "with no default.", call. = FALSE)
    
    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    pileupPlot <- structure(list(
        chrom = pileInternal$chrom,
        chromstart = pileInternal$chromstart,
        chromend = pileInternal$chromend,
        assembly = pileInternal$assembly,
        color_palette = NULL,
        zrange = NULL,
        x = pileInternal$x, y = pileInternal$y,
        width = pileInternal$width,
        height = pileInternal$height,
        just = pileInternal$just, grobs = NULL
    ),
    class = "ranges"
    )
    attr(x = pileupPlot, which = "plotted") <- pileInternal$draw

    # =========================================================================
    # CHECK PLACEMENT ERRORS
    # =========================================================================

    check_placement(object = pileupPlot)

    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    pileupPlot$assembly <- parseAssembly(assembly = pileupPlot$assembly)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    pileupPlot <- defaultUnits(
        object = pileupPlot,
        default.units = pileInternal$default.units
    )
    
    pileInternal$boxHeight <- misc_defaultUnits(
        value = pileInternal$boxHeight,
        name = "boxHeight",
        default.units = pileInternal$default.units
    )

    # =========================================================================
    # READ IN FILE OR DATAFRAME
    # =========================================================================

    bed <- read_rangeData(data = pileInternal$data,
                        assembly = pileupPlot$assembly,
                        chrom = pileupPlot$chrom,
                        start = pileupPlot$chromstart,
                        end = pileupPlot$chromend)

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    errorcheck_plotPileup(
        pileupPlot = pileupPlot,
        fill = pileInternal$fill,
        bed = bed,
        order = pileInternal$order
    )

    ## chrom format and data chrom format
    chromDataAgreement(data = bed, chrom = pileupPlot$chrom,
                    type = "ranges")
    
    # =========================================================================
    # GENOMIC SCALE
    # =========================================================================
    
    scaleChecks <- genomicScale(object = pileupPlot,
                                objectInternal = pileInternal,
                                plotType = "ranges plot")
    pileupPlot <- scaleChecks[[1]]
    pileInternal <- scaleChecks[[2]]
    
    # =========================================================================
    # COLORS
    # =========================================================================
    
    rangeColors <- parseColors(data = bed,
                                fill = pileInternal$fill,
                                object = pileupPlot,
                                subset = "ranges")
    if (length(rangeColors[[1]]) > 0){
        bed$color <- rangeColors[[1]]
    } else {
        bed$color <- rep("#7ecdbb", nrow(bed))
    }
    
    pileupPlot <- rangeColors[[2]]
    bed$linecolor <- lineColors(linecolor = pileInternal$linecolor,
                                fillcolors = bed$color,
                                data = bed,
                                object = pileupPlot,
                                subset = "ranges")
    
    # =========================================================================
    # SUBSET DATA FOR CHROMOSOME AND ANY OVERLAPPING REGIONS
    # =========================================================================

    if (!is.null(pileupPlot$chromstart) & !is.null(pileupPlot$chromend)) {
        bed <- bed[which(bed[, "chrom"] == pileupPlot$chrom 
                    & bed[, "start"] <=
            pileupPlot$chromend & bed[, "end"] >=
            pileupPlot$chromstart), ]
    } else {
        bed <- data.frame(matrix(nrow = 0, ncol = 3))
    }

    ## Add width column
    bed$width <- bed[, "end"] - bed[, "start"]
    # =========================================================================
    # SEPARATE DATA INTO STRANDS
    # =========================================================================

    if (pileInternal$strandSplit == TRUE) {

        ## Look for column named 'strand'
        if (!any(colnames(bed) == "strand")) {
            stop("No `strand` column found in data. ",
                "Cannot split data based on strand.", call. = FALSE)
        } else {
            posStrand <- bed[which(bed[, "strand"] == "+"), ]
            minStrand <- bed[which(bed[, "strand"] == "-"), ]
        }
    }

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## If placing information is provided but plot == TRUE,
    ## set up it's own viewport
    ## Not translating into page_coordinates
    if (is.null(pileupPlot$x) | is.null(pileupPlot$y)) {
        yscale <- strand_scale(
            strandSplit = pileInternal$strandSplit,
            height = 0.5
        )
        
        vp <- viewport(
            height = unit(0.5, "snpc"), width = unit(1, "snpc"),
            x = unit(0.5, "npc"), y = unit(0.5, "npc"),
            clip = "on",
            xscale = pileInternal$xscale,
            yscale = yscale,
            just = "center",
            name = "ranges1"
        )

        if (pileInternal$draw == TRUE) {
            grid.newpage()
        }
    } else {
        
        ## Get viewport name
        currentViewports <- current_viewports()
        vp_name <- paste0(
            "ranges",
            length(grep(
                pattern = "ranges",
                x = currentViewports
            )) + 1
        )
        
        addViewport(vp_name)

        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = pileupPlot)

        yscale <- strand_scale(
            strandSplit = pileInternal$strandSplit,
            height = convertHeight(page_coords$height,
                unitTo = get("page_units",
                    envir = pgEnv
                ),
                valueOnly = TRUE
            )
        )

        ## Make viewport
        vp <- viewport(
            height = page_coords$height, width = page_coords$width,
            x = page_coords$x, y = page_coords$y,
            clip = "on",
            xscale = pileInternal$xscale,
            yscale = yscale,
            just = pileInternal$just,
            name = vp_name
        )
    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS WITH BACKGROUND
    # =========================================================================

    backgroundGrob <- rectGrob(
        gp = gpar(
            fill = pileInternal$bg,
            col = NA
        ),
        name = "background"
    )
    assign("pileup_grobs", gTree(
        vp = vp,
        children = gList(backgroundGrob)
    ),
    envir = pgEnv
    )

    # =========================================================================
    # DETERMINE ROWS FOR EACH ELEMENT
    # =========================================================================

    if (is.null(pileupPlot$x) & is.null(pileupPlot$y)) {
        pushViewport(vp)
        boxHeight <- convertHeight(pileInternal$boxHeight,
            unitTo = "npc", valueOnly = TRUE
        )
        spaceHeight <- boxHeight * (pileInternal$spaceHeight)
        upViewport()
    } else {
        boxHeight <- convertHeight(pileInternal$boxHeight,
            unitTo = get("page_units",
                envir = pgEnv
            ),
            valueOnly = TRUE
        )
        spaceHeight <- boxHeight * (pileInternal$spaceHeight)
    }


    if (pileInternal$collapse == FALSE) {
        
        ## Calculate number of element rows that will fit
        maxRows <- floor((as.numeric(vp$height) + spaceHeight) /
            (boxHeight + spaceHeight))
        wiggle <- abs(pileupPlot$chromend - pileupPlot$chromstart) *
            pileInternal$spaceWidth

        if (pileInternal$strandSplit == FALSE) {

            ## Order data
            bed <- orderData(data = bed, order = pileInternal$order)
            
            ## Assign rows
            rowData <- assignRows(data = bed[,c("start", "end")], 
                                maxRows = maxRows,
                                wiggle = wiggle, rowCol = 2,
                                limitLabel = pileInternal$limitLabel,
                                gTree = "pileup_grobs",
                                extraData = bed[,c("color", "linecolor")],
                                colNames = c("color", "linecolor"))
            
            ## Calculate y-coordinates
            rowData$y <- rowData$row * (boxHeight + spaceHeight)

        } else {
            
            ## Order data
            posStrand <- orderData(data = posStrand, order = pileInternal$order)
            minStrand <- orderData(data = minStrand, order = pileInternal$order)
            
            ## Assign rows
            posData <- assignRows(data = posStrand[,c("start", "end")],
                                maxRows = maxRows * 0.5,
                                wiggle = wiggle, rowCol = 2,
                                limitLabel = pileInternal$limitLabel,
                                gTree = "pileup_grobs",
                                extraData = posStrand[,c("color", "linecolor")],
                                colNames = c("color", "linecolor"))
            minData <- assignRows(data = minStrand[,c("start", "end")],
                                maxRows = maxRows * 0.5,
                                wiggle = wiggle, rowCol = 2,
                                limitLabel = pileInternal$limitLabel,
                                side = "bottom",
                                gTree = "pileup_grobs",
                                extraData = minStrand[,c("color", "linecolor")],
                                colNames = c("color", "linecolor"))
            
            ## Calculate y-coordinates
            posData$y <- (0.5 * spaceHeight) + posData$row *
                (boxHeight + spaceHeight)
            minData$y <- ((0.5 * spaceHeight + boxHeight) + minData$row *
                                (boxHeight + spaceHeight)) * -1
            
            ## Combine plus and minus strand data
            rowData <- rbind(posData, minData)
        }

    } else {
        if (pileInternal$strandSplit == FALSE) {
            boxHeight <- as.numeric(vp$height)
            rowData <- bed
            ## y-coordinates all the same
            rowData$y <- rep(0, nrow(rowData))
        } else {
            boxHeight <- (1 - spaceHeight) * as.numeric(vp$height) * 0.5
            if (nrow(posStrand) > 0) {
                posStrand$y <- vp$yscale[2] - boxHeight
            } else {
                posStrand <- data.frame()
            }
            if (nrow(minStrand) > 0) {
                minStrand$y <- vp$yscale[1]
            } else {
                minStrand <- data.frame()
            }

            ## Combine plus and minus strand data
            rowData <- rbind(posStrand, minStrand)
            
        }
    }
    
    
    # =====================================================================
    # MAKE GROBS
    # =====================================================================
    
    if (nrow(rowData) > 0) {
        
        rowData$width <- rowData[,"end"] - rowData[,"start"]

        alpha <- 1
        if ("alpha" %in% names(pileInternal$gp)) {
            alpha <- pileInternal$gp$alpha
        }

        bedRects <- rectGrob(
            x = rowData$start,
            y = rowData$y,
            width = rowData$width,
            height = boxHeight,
            just = c("left", "bottom"),
            default.units = "native",
            gp = gpar(
                fill = rowData$color,
                col = rowData$linecolor,
                alpha = alpha
            )
        )
        assign("pileup_grobs",
            addGrob(
                gTree = get("pileup_grobs", envir = pgEnv),
                child = bedRects
            ),
            envir = pgEnv
        )

        if ((pileInternal$strandSplit == TRUE |
            pileInternal$baseline == TRUE) &
            pileInternal$collapse == FALSE) {
            lineGrob <- segmentsGrob(
                x0 = unit(0, "npc"), x1 = unit(1, "npc"),
                y0 = unit(0, "native"), y1 = unit(0, "native"),
                gp = gpar(
                    col = pileInternal$baseline.color,
                    lwd = pileInternal$baseline.lwd
                )
            )
            assign("pileup_grobs",
                addGrob(
                    gTree = get("pileup_grobs", envir = pgEnv),
                    child = lineGrob
                ),
                envir = pgEnv
            )
        }
    } else {
        if (pileInternal$txdbChecks == TRUE) {
            warning("No range data to plot.", call. = FALSE)
        }
    }

    # =========================================================================
    # IF PLOT == TRUE, DRAW GROBS
    # =========================================================================

    if (pileInternal$draw == TRUE) {
        grid.draw(get("pileup_grobs", envir = pgEnv))
    }
    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    pileupPlot$grobs <- get("pileup_grobs", envir = pgEnv)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("ranges[", vp$name, "]")
    invisible(pileupPlot)
}

#' Annotates text within a plot
#' 
#' @usage annoText(
#'     label,
#'     fontcolor = "black",
#'     fontsize = 12,
#'     rot = 0,
#'     check.overlap = FALSE,
#'     plot,
#'     x,
#'     y,
#'     just = "center",
#'     default.units = "native",
#'     params = NULL,
#'     ...
#' )
#'
#' @param label Character or expression of text to be plotted.
#' @param fontcolor A character value specifying text fontcolor.
#' Default value is \code{fontcolor = "black"}.
#' @param fontsize A numeric specifying text fontsize in points.
#' Default value is \code{fontsize = 12}.
#' @param rot A numeric specifying the angle to rotate the text.
#' Default value is \code{rot = 0}.
#' @param check.overlap A logical value to indicate whether to check for
#' and omit overlapping text. Default value is \code{check.overlap = FALSE}.
#' @param plot Input plotgardener plot to internally place text relative to.
#' @param x A numeric vector or unit object specifying text x-location.
#' @param y A numeric vector or unit object specifying text y-location.
#' @param just Justification of text relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = "center"}.
#' @param default.units A string indicating the default units to use if
#' \code{x} or \code{y} are only given as numerics or numeric vectors.
#' Default value is \code{default.units = "native"}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{text} object containing
#' relevant placement and \link[grid]{grob} information.
#'
#' @examples
#' ## Create a page
#' pageCreate(width = 4, height = 4, default.units = "inches")
#'
#' ## Plot text relative to a plotgardener plot
#' library(plotgardenerData)
#' data("IMR90_HiC_10kb")
#' hicPlot <- plotHicSquare(
#'     data = IMR90_HiC_10kb, chrom = "chr21",
#'     chromstart = 28000000, chromend = 29500000,
#'     assembly = "hg19",
#'     zrange = c(0, 70),
#'     x = 0.5, y = 0.5, width = 3, height = 3,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#' annoGenomeLabel(
#'     plot = hicPlot, x = 0.5, y = 3.55, scale = "Mb",
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' annoText(
#'     label = "Loop", fontsize = 8, plot = hicPlot,
#'     x = 29075000, y = 28150000,
#'     just = "center", default.units = "native"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @seealso \link[grid]{grid.text}
#'
#' @export
annoText <- function(label, fontcolor = "black", fontsize = 12, rot = 0,
                        check.overlap = FALSE, plot, x, y, just = "center",
                        default.units = "native", params = NULL, ...) {

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    textInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "textInternal"
    )

    ## Set gp
    textInternal$gp <- gpar(
        col = textInternal$fontcolor,
        fontsize = textInternal$fontsize
    )
    textInternal$gp <- setGP(
        gpList = textInternal$gp,
        params = textInternal, ...
    )
    
    ## Justification
    textInternal$just <- justConversion(just = textInternal$just)

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    text <- structure(list(
        label = textInternal$label,
        x = textInternal$x, y = textInternal$y,
        just = textInternal$just, grobs = NULL
    ),
    class = "text"
    )

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_page(error = "Cannot annotate text without a `plotgardener` page.")
    if (is.null(text$label)) stop("argument \"label\" is missing, ",
                                    "with no default.", call. = FALSE)
    if (is.null(textInternal$plot)) stop("argument \"plot\" is missing, ",
                                            "with no default.", call. = FALSE)
    if (is.null(text$x)) stop("argument \"x\" is missing, ",
                                "with no default.", call. = FALSE)
    if (is.null(text$y)) stop("argument \"y\" is missing, ",
                                "with no default.", call. = FALSE)

    # =========================================================================
    # DEFINE PARAMETERS
    # =========================================================================

    ## Get page_height and its units from pgEnv through bb_pageCreate
    page_height <- get("page_height", envir = pgEnv)
    page_units <- get("page_units", envir = pgEnv)
    
    text$x <- misc_defaultUnits(value = text$x,
                                name = "x",
                                default.units = 
                                    textInternal$default.units)
    text$y <- misc_defaultUnits(value = text$y,
                                name = "y",
                                default.units = 
                                    textInternal$default.units,
                                funName = "annoText",
                                yBelow = FALSE)

    # Get appropriate plot viewport
    plotVP <- getAnnoViewport(plot = textInternal$plot)
    
    ## Convert plot viewport to bottom left to get position on entire page
    plotVP_bottomLeft <- vp_bottomLeft(viewport = plotVP)

    ## Push plot viewport to convert x/y from plot native units to page units
    seekViewport(plotVP$name)
    new_x <- convertX(text$x, unitTo = page_units, valueOnly = TRUE)
    new_y <- convertY(text$y, unitTo = page_units, valueOnly = TRUE)

    seekViewport(name = "page")

    ## Add additional page units to new_x and new_y
    new_x <- as.numeric(plotVP_bottomLeft[[1]]) + new_x
    new_y <- as.numeric(plotVP_bottomLeft[[2]]) + new_y

    # =========================================================================
    # MAKE GROB
    # =========================================================================
    name <- paste0(
        "text",
        length(grep(
            pattern = "text",
            x = grid.ls(
                print = FALSE,
                recursive = FALSE
            )
        )) + 1
    )
    text <- grid.text(
        label = text$label, x = unit(new_x, page_units),
        y = unit(new_y, page_units), just = text$just,
        gp = textInternal$gp, rot = textInternal$rot,
        check.overlap = textInternal$check.overlap,
        name = name
    )

    # =========================================================================
    # ADD GROB TO OBJECT
    # =========================================================================

    text$grobs <- text

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("text[", text$name, "]")
    invisible(text)
}

# Define a function to read in various kinds of genomic range data
#' @importFrom plyranges %>%
#' @importFrom GenomicRanges GRanges
read_rangeData <- function(data, assembly, chrom = NULL, 
                        start = NULL, end = NULL, type = "range"){
    
    if (!"data.frame" %in% class(data)) {
        if (!is(data, "GRanges")) {
            if (file_ext(data) == "bam") {
                indexFile <- paste0(data, ".bai")
                if (!file.exists(indexFile)) {
                    stop("Cannot read in bam file without a ",
                        "corresponding bam index file (.bai) in the ",
                        "same directory.", call. = FALSE)
                }
                data <- plyranges::read_bam(data) %>%
                    plyranges::filter_by_overlaps(GenomicRanges::GRanges(
                        seqnames = chrom,
                        ranges = IRanges::IRanges(
                            start = start,
                            end = end
                        )
                    )) %>%
                    dplyr::mutate()
            } else if (file_ext(data) %in% c("bw", "bigWig",
                                            "bigwig", "bedgraph")) {

                data <- readBigwig(
                    file = data,
                    chrom = chrom,
                    chromstart = start,
                    chromend = end
                )
            } else {
                data <- data.table::fread(data)
            }
        } else {
            
            ## check GRanges genome with assembly input
            checkAssemblyMatch(data = data, assembly = assembly)
            
        }
    }
    
    data <- as.data.frame(data)
    
    if (type == "range"){
        ## Rename columns if necessary
        colnames(data)[seq(1, 3)] <- c("chrom", "start", "end")
        
        ## Check column input types
        columnClasses <- list("start" = TRUE, "end" = TRUE)
        if (!is(data[, "start"], "integer") &
            !is(data[, "start"], "numeric")){
            columnClasses["start"] <- FALSE
        }
        if (!is(data[, "end"], "integer") &
            !is(data[, "end"], "numeric")){
            columnClasses["end"] <- FALSE
        }
        
        if (any(columnClasses == FALSE)){
            
            ## Get the ones that are wrong
            wrongClasses <- names(which(columnClasses == FALSE))
            stop(cat(wrongClasses, sep = ", "), 
            " are not the correct input type. ",
            "Chromosome column must be a character and chromstart and",
            " chromend columns must be integers or numerics.", call. = FALSE)
        }
        
        
    } else if (type == "GWAS") {
        
        ## Rename chrom and position columns
        colnames(data)[seq(1, 2)] <- c("chrom", "pos")
        ## column data types will be checked in plotManhattan errorchecks
        
    }
    
    return(data)
    
}

# Define a function to read in various kinds of genomic paired range data
read_pairedData <- function(data, assembly, warning = FALSE){
    
    if (!"data.frame" %in% class(data)) {
        if (!is(data, "GInteractions")) {
            data <- as.data.frame(data.table::fread(data))
        } else {
            ## check GInteractions genome with assembly input
            checkAssemblyMatch(data = data, assembly = assembly)
            
            ## Reorder GInteractions columns
            data <- as.data.frame(data)
            dataSubset <- data[, c(
                "seqnames1", "start1", "end1",
                "seqnames2", "start2", "end2"
            )]
            
            data <- data[, which(!colnames(data) %in%
                                colnames(dataSubset))]
            data <- cbind(dataSubset, data)
        }
    } else {
        data <- as.data.frame(data)
    }
    
    ## Rename columns
    colnames(data)[seq(1, 6)] <- c("chrom1", "start1", "end1",
                                "chrom2", "start2", "end2")
    
    ## Check column input types
    columnClasses <- list("start1" = TRUE, "end1" = TRUE,
                        "start2" = TRUE, "end2" = TRUE)
    if (!is(data[, "start1"], "integer") &
        !is(data[, "start1"], "numeric")){
        columnClasses["start1"] <- FALSE
    }
    if (!is(data[, "start2"], "integer") &
        !is(data[, "start2"], "numeric")){
        columnClasses["start2"] <- FALSE
    }
    if (!is(data[, "end1"], "integer") &
        !is(data[, "end1"], "numeric")){
        columnClasses["end1"] <- FALSE
    }
    if (!is(data[, "end2"], "integer") &
        !is(data[, "end2"], "numeric")){
        columnClasses["end2"] <- FALSE
    }
    
    if (any(columnClasses == FALSE)){
        
        ## Get the ones that are wrong
        wrongClasses <- names(which(columnClasses == FALSE))
        stop(wrongClasses, " are not the correct input type. ",
            "Chromosome columns must be a character and chromstart and",
            " chromend columns must be integers or numerics.", call. = FALSE)
    }
    
    ## Check anchor orders and try to reorder if necessary
    anchor1 <- GRanges(seqnames = data[,"chrom1"], 
                       ranges = IRanges(start = data[,"start1"], 
                                        end = data[,"end1"]))
    
    anchor2 <- GRanges(seqnames = data[,"chrom2"], 
                       ranges = IRanges(start = data[,"start2"], 
                                        end = data[,"end2"]))
    
    swap <- anchor2 < anchor1
    if (any(swap)){
        # Swap any anchors where anchor2 < anchor1
        temp <- anchor1[swap]
        anchor1[swap] <- anchor2[swap]
        anchor2[swap] <- temp
        # Convert back to 6 column bedpe format
        swapped_data <- cbind(as.data.frame(anchor1)[, c("seqnames", "start", "end")],
                              as.data.frame(anchor2)[,c("seqnames", "start", "end")])
        colnames(swapped_data) <- c("chrom1", "start1", "end1", 
                                    "chrom2", "start2", "end2")
        # Join back with any trailing data columns
        data <- cbind(swapped_data, data[,-c(1:6)])
        warning("One or more pairs contained unordered anchors and were",
                " swapped for plotting.", call. = FALSE)
    }    
    
    if (warning == TRUE){
        if (nrow(data) < 1){
            warning("\'data\' input contains no values.", call. = FALSE)
            }
    }
    return(data)
    }
    
# Define a function that checks matching for GRanges/GInteractions
# objects and declared assembly
checkAssemblyMatch <- function(data, assembly){
    
    genome <- unique(GenomeInfoDb::genome(data))
    if (!is.na(genome)){
        if (genome != assembly$Genome){
            warning("Input data assembly detected as ",
                    genome, " and plotgardener assembly ",
                    "detected as ", assembly$Genome, ".",
                    .call = FALSE)
        }
    }    
}

## Define a function to grab the name of a viewport
viewport_name <- function(viewport) {
    return(viewport$name)
}

## Define a function to add a plot viewport to internal list of
## valid "last plotted" viewports
addViewport <- function(vpName) {
    pg_vpTree <- get("pg_vpTree", envir = pgEnv)
    pg_vpTree[length(pg_vpTree) + 1] <- vpName
    assign("pg_vpTree", pg_vpTree, envir = pgEnv)
}

## Define a function to get a list of current viewports
current_viewports <- function() {
    if (!"page" %in% names(lapply(
        current.vpTree()$children,
        viewport_name
    ))) {
        current <- as.list(names(lapply(
            current.vpTree()$children,
            viewport_name
        )))
    } else {
        page_children <- names(lapply(
            current.vpTree()$children$page$children,
            viewport_name
        ))
        current <- as.list(page_children)
    }

    return(current)
}

## Define a function to convert viewport x and y into center just
adjust_vpCoords <- function(viewport) {
    vp_y <- viewport$y
    ## left
    if (identical(viewport$justification, c(0, 0.5))) {
        vp_x <- viewport$x + (0.5 * viewport$width)
    } else if (identical(viewport$justification, c(1, 0.5))) {
        ## right
        vp_x <- viewport$x - (0.5 * viewport$width)
    } else if (identical(viewport$justification, c(0.5, 0))) {
        ## bottom
        vp_x <- viewport$x
        vp_y <- vp_y + (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(0.5, 1))) {
        ## top
        vp_x <- viewport$x
        vp_y <- vp_y - (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(0, 1))) {
        ## left top
        vp_x <- viewport$x + (0.5 * viewport$width)
        vp_y <- vp_y - (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(1, 1))) {
        ## right top
        vp_x <- viewport$x - (0.5 * viewport$width)
        vp_y <- vp_y - (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(0, 0))) {
        ## left bottom
        vp_x <- viewport$x + (0.5 * viewport$width)
        vp_y <- vp_y + (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(1, 0))) {
        ## right bottom
        vp_x <- viewport$x - (0.5 * viewport$width)
        vp_y <- vp_y + (0.5 * viewport$height)
    } else {
        ## center
        vp_x <- viewport$x
    }

    return(list(vp_x, vp_y))
}

## Define a function to change viewport x and y-coordinates to top left
vp_topLeft <- function(viewport) {
    if (identical(viewport$justification, c(0, 0.5))) {
        ## left
        vp_x <- viewport$x
        vp_y <- viewport$y + (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(1, 0.5))) {
        ## right
        vp_x <- viewport$x - (viewport$width)
        vp_y <- viewport$y + (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(0.5, 0))) {
        ## bottom
        vp_x <- viewport$x - (0.5 * viewport$width)
        vp_y <- viewport$y + (viewport$height)
    } else if (identical(viewport$justification, c(0.5, 1))) {
        ## top
        vp_x <- viewport$x - (0.5 * viewport$width)
        vp_y <- viewport$y
    } else if (identical(viewport$justification, c(0, 1))) {
        ## left top
        vp_x <- viewport$x
        vp_y <- viewport$y
    } else if (identical(viewport$justification, c(1, 1))) {
        ## right top
        vp_x <- viewport$x - (viewport$width)
        vp_y <- viewport$y
    } else if (identical(viewport$justification, c(0, 0))) {
        ## left bottom
        vp_x <- viewport$x
        vp_y <- viewport$y + (viewport$height)
    } else if (identical(viewport$justification, c(1, 0))) {
        ## right bottom
        vp_x <- viewport$x - (viewport$width)
        vp_y <- viewport$y + (viewport$height)
    } else {
        ## center
        vp_x <- viewport$x - (0.5 * viewport$width)
        vp_y <- viewport$y + (0.5 * viewport$height)
    }

    return(list(vp_x, vp_y))
}

## Define a function to change viewport x and y-coordinates to bottom left
vp_bottomLeft <- function(viewport) {
    if (identical(viewport$justification, c(0, 0.5))) {
        ## left
        vp_x <- viewport$x
        vp_y <- viewport$y - (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(1, 0.5))) {
        ## right
        vp_x <- viewport$x - (viewport$width)
        vp_y <- viewport$y - (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(0.5, 0))) {
        ## bottom
        vp_x <- viewport$x - (0.5 * viewport$width)
        vp_y <- viewport$y
    } else if (identical(viewport$justification, c(0.5, 1))) {
        ## top
        vp_x <- viewport$x - (0.5 * viewport$width)
        vp_y <- viewport$y - (viewport$height)
    } else if (identical(viewport$justification, c(0, 1))) {
        ## left top
        vp_x <- viewport$x
        vp_y <- viewport$y - (viewport$height)
    } else if (identical(viewport$justification, c(1, 1))) {
        ## right top
        vp_x <- viewport$x - (viewport$width)
        vp_y <- viewport$y - (viewport$height)
    } else if (identical(viewport$justification, c(0, 0))) {
        ## left bottom
        vp_x <- viewport$x
        vp_y <- viewport$y
    } else if (identical(viewport$justification, c(1, 0))) {
        ## right bottom
        vp_x <- viewport$x - (viewport$width)
        vp_y <- viewport$y
    } else {
        ## center
        vp_x <- viewport$x - (0.5 * viewport$width)
        vp_y <- viewport$y - (0.5 * viewport$height)
    }

    return(list(vp_x, vp_y))
}

## Define a function to change viewport x and y-coordinates to bottom right
vp_bottomRight <- function(viewport) {
    if (identical(viewport$justification, c(0, 0.5))) {
        ## left
        vp_x <- viewport$x + viewport$width
        vp_y <- viewport$y - (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(1, 0.5))) {
        ## right
        vp_x <- viewport$x
        vp_y <- viewport$y - (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(0.5, 0))) {
        ## bottom
        vp_x <- viewport$x + (0.5 * viewport$width)
        vp_y <- viewport$y
    } else if (identical(viewport$justification, c(0.5, 1))) {
        ## top
        vp_x <- viewport$x + (0.5 * viewport$width)
        vp_y <- viewport$y - (viewport$height)
    } else if (identical(viewport$justification, c(0, 1))) {
        ## left top
        vp_x <- viewport$x + viewport$width
        vp_y <- viewport$y - (viewport$height)
    } else if (identical(viewport$justification, c(1, 1))) {
        ## right top
        vp_x <- viewport$x
        vp_y <- viewport$y - (viewport$height)
    } else if (identical(viewport$justification, c(0, 0))) {
        ## left bottom
        vp_x <- viewport$x + viewport$width
        vp_y <- viewport$y
    } else if (identical(viewport$justification, c(1, 0))) {
        ## right bottom
        vp_x <- viewport$x
        vp_y <- viewport$y
    } else {
        ## center
        vp_x <- viewport$x + (0.5 * viewport$width)
        vp_y <- viewport$y - (0.5 * viewport$height)
    }

    return(list(vp_x, vp_y))
}

vp_topRight <- function(viewport) {
    if (identical(viewport$justification, c(0, 0.5))) {
        ## left
        vp_x <- viewport$x + viewport$width
        vp_y <- viewport$y + (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(1, 0.5))) {
        ## right
        vp_x <- viewport$x
        vp_y <- viewport$y + (0.5 * viewport$height)
    } else if (identical(viewport$justification, c(0.5, 0))) {
        ## bottom
        vp_x <- viewport$x + (0.5 * viewport$width)
        vp_y <- viewport$y + viewport$height
    } else if (identical(viewport$justification, c(0.5, 1))) {
        ## top
        vp_x <- viewport$x + (0.5 * viewport$width)
        vp_y <- viewport$y
    } else if (identical(viewport$justification, c(0, 1))) {
        ## left top
        vp_x <- viewport$x + viewport$width
        vp_y <- viewport$y
    } else if (identical(viewport$justification, c(1, 1))) {
        ## right top
        vp_x <- viewport$x
        vp_y <- viewport$y
    } else if (identical(viewport$justification, c(0, 0))) {
        ## left bottom
        vp_x <- viewport$x + viewport$width
        vp_y <- viewport$y + viewport$height
    } else if (identical(viewport$justification, c(1, 0))) {
        ## right bottom
        vp_x <- viewport$x
        vp_y <- viewport$y + viewport$height
    } else {
        ## center
        vp_x <- viewport$x + (0.5 * viewport$width)
        vp_y <- viewport$y + (0.5 * viewport$height)
    }

    return(list(vp_x, vp_y))
}

## Define a function to convert to page units
convert_page <- function(object) {

    ## Get page_height and its units from pgEnv
    page_height <- get("page_height", envir = pgEnv)
    page_units <- get("page_units", envir = pgEnv)

    ## Convert x and y coordinates and height and width to same page_units
    old_x <- object$x
    old_y <- object$y
    old_height <- object$height
    old_width <- object$width
    new_x <- convertX(old_x, unitTo = page_units)
    new_y <- convertY(unit(page_height,
        units = page_units
    ) - convertY(old_y,
        unitTo = page_units
    ),
    unitTo = page_units
    )
    new_height <- convertHeight(old_height, unitTo = page_units)
    new_width <- convertWidth(old_width, unitTo = page_units)

    object$x <- new_x
    object$y <- new_y
    object$height <- new_height
    object$width <- new_width


    return(object)
}

## Parse y-coordinates for plots relative to bottom of last plot
plot_belowY <- function(y_coord) {
    prevPlots <- unlist(get("pg_vpTree", envir = pgEnv))

    if (length(prevPlots) == 0) {
        stop("No previous plot detected. Cannot define ",
            "a \'below\' y-coordinate.",
            call. = FALSE
        )
    }

    lastPlot <- prevPlots[length(prevPlots)]
    ## Go into viewport to get coordinates/dimensions
    seekViewport(name = lastPlot)
    x <- current.viewport()$x
    y <- current.viewport()$y
    width <- current.viewport()$width
    height <- current.viewport()$height
    just <- current.viewport()$just

    ## Exit viewport
    upViewport()

    ## Convert to bottom
    bottomCoords <- vp_bottomLeft(viewport(
        x = x, y = y,
        width = width, height = height,
        just = just
    ))

    ## Parse number and convert to page units
    space <- utils::type.convert(gsub("b", "", y_coord), as.is = TRUE)
    space <- unit(space, get("page_units", envir = pgEnv))

    new_y <- (unit(
        get("page_height", envir = pgEnv),
        get("page_units", envir = pgEnv)
    ) - bottomCoords[[2]]) + space
    new_y <- convertY(new_y, unitTo = get("page_units", envir = pgEnv))

    return(new_y)
}

## Define a function to distinguish between plots with 
## multiple viewports for certain annotation functions
getAnnoViewport <- function(plot){
    
    if (is(plot, "genes")){
        plotVP <- plot$grobs$children$background$vp
    } else if (is(plot, "hicTriangle") |
            is(plot, "hicRectangle")){
        plotVP <- plot$outsideVP
    } else {
        plotVP <- plot$grobs$vp
    }
    
    return(plotVP)
    
}

## Define a function that converts chromstart/chromend to page units for
## multi-chromosome manhattan plot
convertManhattan <- function(object, manhattanPlot) {

    ## Get assembly data
    if (is(object$assembly$TxDb, "TxDb")) {
        txdbChecks <- TRUE
    } else {
        
        if (!requireNamespace(object$assembly$TxDb, quietly = TRUE)){
            txdbChecks <- FALSE
        } else {
            txdbChecks <- TRUE
        }
        
    }

    if (txdbChecks == TRUE) {
        if (is(object$assembly$TxDb, "TxDb")) {
            tx_db <- object$assembly$TxDb
        } else {
            tx_db <- eval(parse(text = paste0(as.name(object$assembly$TxDb), 
                                            "::", 
                                            as.name(object$assembly$TxDb))))
        }

        assembly_data <- as.data.frame(setDT(as.data.frame(
            GenomeInfoDb::seqlengths(tx_db)
        ),
        keep.rownames = TRUE
        ))
        colnames(assembly_data) <- c("chrom", "length")
        assembly_data <- assembly_data[which(assembly_data[, "chrom"] %in%
            manhattanPlot$chrom), ]

        ## Get the offset based on spacer for the assembly
        offsetAssembly <- spaceChroms(
            assemblyData = assembly_data,
            space = manhattanPlot$space
        )
        offsetAssembly <- offsetAssembly[which(
            offsetAssembly$chrom == object$chrom
        ), ]

        ## Convert chromstart and chromend to chrom offsetAssembly range
        oldRange <- offsetAssembly[, "length"] - 1
        newRange <- offsetAssembly[, "end"] - offsetAssembly[, "start"]
        newStart <- (((object$chromstart - 1) * newRange) / oldRange) +
            offsetAssembly[, "start"]
        newEnd <- (((object$chromend - 1) * newRange) / oldRange) +
            offsetAssembly[, "start"]

        ## Convert new chromstart and chromend to page units
        start <- convertX(unit(newStart, "native"),
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
        end <- convertX(unit(newEnd, "native"),
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )

        return(list(start, end))
    }
}

test_that("Viewport conversions", {
    pageCreate(width = 2, height = 2, default.units = "inches")
    testVP <- viewport(
        x = 1, y = 1,
        width = 1, height = 1,
        just = "center",
        default.units = "inches"
    )
    expect_equal(
        plotgardener:::vp_topLeft(testVP),
        list(unit(0.5, "inches"), unit(1.5, "inches"))
    )
    expect_equal(
        plotgardener:::vp_bottomLeft(testVP),
        list(unit(0.5, "inches"), unit(0.5, "inches"))
    )
    expect_equal(
        plotgardener:::vp_topRight(testVP),
        list(unit(1.5, "inches"), unit(1.5, "inches"))
    )
    expect_equal(
        plotgardener:::vp_bottomRight(testVP),
        list(unit(1.5, "inches"), unit(0.5, "inches"))
    )

    testVP <- viewport(
        x = 0.25, y = 0.25,
        width = 1.5, height = 1,
        just = c("left", "bottom"),
        default.units = "inches"
    )
    expect_equal(
        plotgardener:::adjust_vpCoords(testVP),
        list(unit(1, "inches"), unit(0.75, "inches"))
    )
})

test_that("Viewport order, naming, and numbering", {
    library(plotgardenerData)
    data("IMR90_DNAloops_pairs")
    pageCreate(width = 3, height = 5, default.units = "inches")
    arches <- suppressMessages(plotPairsArches(
        data = IMR90_DNAloops_pairs,
        chrom = "chr21", chromstart = 28000000, chromend = 30300000,
        assembly = "hg19",
        x = 0.5, y = 2.5, width = 2, height = 0.25,
        just = c("left", "top"), default.units = "inches",
        fill = "black", linecolor = "black", flip = TRUE
    ))
    expect_equal(plotgardener:::viewport_name(arches$grobs$vp), "arches1")
    expect_setequal(
        unlist(plotgardener:::current_viewports()),
        "arches1"
    )
    expect_equal(current.viewport()$name, "page")
    
    data("IMR90_ChIP_H3K27ac_signal")
    suppressMessages(plotSignal(
        data = IMR90_ChIP_H3K27ac_signal,
        chrom = "chr21", chromstart = 28000000, chromend = 30300000,
        assembly = "hg19",
        x = 0.5, y = 2.75, width = 2, height = 0.5,
        just = c("left", "top"), default.units = "inches"
    ))
    expect_setequal(
        unlist(plotgardener:::current_viewports()),
        c("arches1", "signal1_h")
    )
    suppressMessages(plotPairsArches(
        data = IMR90_DNAloops_pairs,
        chrom = "chr21", chromstart = 28000000, chromend = 30300000,
        assembly = "hg19",
        x = 0.5, y = 2.5, width = 2, height = 0.25,
        just = c("left", "top"), default.units = "inches",
        fill = "black", linecolor = "black", flip = TRUE
    ))
    expect_setequal(
        unlist(plotgardener:::current_viewports()),
        c("arches1", "signal1_h", "arches2")
    )

    pagePlotRemove(plot = arches)
    expect_setequal(
        unlist(plotgardener:::current_viewports()),
        c("signal1_h", "arches2")
    )
    
})

test_that("Below-y coordinate calculation", {
    library(plotgardenerData)
    data("IMR90_HiC_10kb")
    pageCreate(width = 3, height = 5, default.units = "inches")
    suppressMessages(plotHicSquare(
        data = IMR90_HiC_10kb,
        chrom = "chr21",
        chromstart = 28000000, chromend = 30300000,
        assembly = "hg19",
        x = 0.5, y = 0.5, width = 2, height = 2,
        just = c("left", "top"), default.units = "inches"
    ))
    expect_equal(plotgardener:::plot_belowY("0b"), unit(2.5, "inches"))
})

test_that("draw parameter and pagePlotPlace", {
    library(plotgardenerData)
    data("IMR90_ChIP_H3K27ac_signal")
    pageCreate(width = 3, height = 3, default.units = "inches")

    expect_error(signalPlot <- plotSignal(
        data = IMR90_ChIP_H3K27ac_signal,
        chrom = "chr21", chromstart = 28000000, chromend = 30300000,
        assembly = "hg19",
        x = 0.25,
        draw = TRUE
    ))

    signalPlot <- suppressMessages(plotSignal(
        data = IMR90_ChIP_H3K27ac_signal,
        chrom = "chr21", chromstart = 28000000, chromend = 30300000,
        assembly = "hg19",
        x = 0.25,
        draw = FALSE
    ))
    expect_equal(
        unlist(plotgardener:::current_viewports()),
        NULL
    )

    signalPlot <- suppressMessages(pagePlotPlace(
        plot = signalPlot,
        x = 0.5, y = 0.5, width = 2, height = 1,
        just = c("left", "top"), default.units = "inches"
    ))
    expect_setequal(
        unlist(plotgardener:::current_viewports()),
        c("signal1_h")
    )
    expect_equal(signalPlot$x, unit(0.5, "inches"))
})

test_that("page unit conversions", {
    
    pageCreate(width = 3, height = 3, default.units = "inches")
    # Same units but convert to proper y-coordinate
    testObject <- list("x" = unit(0.5, "inches"),
                   "y" = unit(0.5, "inches"),
                   "width" = unit(1, "inches"),
                   "height" = unit(1, "inches"))
    expect_equal(plotgardener:::convert_page(testObject),
                 list("x" = unit(0.5, "inches"),
                      "y" = unit(2.5, "inches"),
                      "width" = unit(1, "inches"),
                      "height" = unit(1, "inches")))
    
    # Different units and proper y-coordinate conversion
    testObject2 <- list("x" = unit(0.5, "npc"),
                        "y" = unit(0.5, "npc"),
                        "width" =  unit(1, "npc"),
                        "height" = unit(1, "npc"))
    expect_equal(plotgardener:::convert_page(testObject2),
                 list("x" = unit(1.5, "inches"),
                      "y" = unit(1.5, "inches"),
                      "width" = unit(3, "inches"),
                      "height" = unit(3, "inches")))
})

test_that("annotation viewports", {
    
    ## Not adding annotation viewports with addViewport
    library(plotgardenerData)
    data("IMR90_HiC_10kb")
    pageCreate(width = 3, height = 5, default.units = "inches")
    suppressMessages(hicPlot <- plotHicSquare(
        data = IMR90_HiC_10kb,
        chrom = "chr21",
        chromstart = 28000000, chromend = 30300000,
        assembly = "hg19",
        x = 0.5, y = 0.5, width = 2, height = 2,
        just = c("left", "top"), default.units = "inches"
    ))
    suppressMessages(annoHeatmapLegend(plot = hicPlot, x = 2.6, y = 0.5, 
                                            height = 0.5, width = 0.1))
    expect_equal(unlist(get("pg_vpTree", envir = pgEnv)),
                 c("hicSquare1"))
    
    ## Getting appropriate annotation viewports for genes, hic triangle/rects
    
    library("TxDb.Hsapiens.UCSC.hg19.knownGene")
    library("org.Hs.eg.db")

    ## Set genomic coordinates
    paramssmall <- pgParams(
        chrom = "chr8",
        chromstart = 1, chromend = 3000000,
        assembly = "hg19", width = 7
    )
    
    pageCreate(width = 7.5, height = 3.5, default.units = "inches")
    genesPlot <- suppressMessages(plotGenes(
            params = paramssmall,
            geneHighlights = data.frame(
                "gene" = c("DLGAP2"),
                "color" = c("#225EA8")
            ),
            geneBackground = "grey",
            x = 0.25, y = 2.25, height = 0.75,
            just = c("left", "top"), default.units = "inches"
        ))
    expect_equal(plotgardener:::getAnnoViewport(genesPlot),
                 genesPlot$grobs$children$background$vp)
    

    pageCreate(width = 4, height = 2.5, default.units = "inches")
    hicPlot <- suppressMessages(plotHicTriangle(
        data = IMR90_HiC_10kb, resolution = 10000,
        zrange = c(0, 70),
        chrom = "chr21",
        chromstart = 28000000, chromend = 30300000,
        assembly = "hg19",
        x = 2, y = 0.5, width = 3, height = 1.5,
        just = "top", default.units = "inches"
    ))
    expect_equal(plotgardener:::getAnnoViewport(hicPlot),
                 hicPlot$outsideVP)
})

## Download font files found in inst/extdata

## Regular
download.file(
    url = "https://www.download-free-fonts.com/details/96003/proxima-nova",
    destfile = "inst/extdata/proximanova-regular.otf")

## Semi-bold
download.file(
    url = "https://www.download-free-fonts.com/details/92405/proxima-nova-semibold",
    destfile = "inst/extdata/proximanova-semibold.otf")

## Regular italic
download.file(
    url = "https://www.download-free-fonts.com/details/93063/proxima-nova-regular-italic",
    destfile = "inst/extdata/proximanova-regitalic.otf")

#' Place a plot that has been previously created but not drawn
#' 
#' @usage pagePlotPlace(
#'     plot,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL
#' )
#'
#' @param plot Plot object to be placed, defined by the
#' output of a plotgardener plotting function.
#' @param x A numeric or unit object specifying plot x-location.
#' @param y A numeric, unit object, or character containing a "b" combined
#' with a numeric value specifying plot y-location.
#' The character value will place the plot y relative to the bottom
#' of the most recently plotted plot according to the units
#' of the plotgardener page.
#' @param width A numeric or unit object specifying plot width.
#' @param height A numeric or unit object specifying plot height.
#' @param just Justification of plot relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use
#' if \code{x}, \code{y}, \code{width}, or \code{height} are only
#' given as numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output
#' should be produced. Default value is \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#'
#' @return Function will update dimensions of an input plot and
#' return an updated plot object.
#'
#' @examples
#' ## Load Hi-C data
#' library(plotgardenerData)
#' data("IMR90_HiC_10kb")
#'
#' ## Create, but do not plot, square Hi-C plot
#' hicPlot <- plotHicSquare(
#'     data = IMR90_HiC_10kb, resolution = 10000,
#'     zrange = c(0, 70),
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     draw = FALSE
#' )
#'
#' ## Create page
#' pageCreate(width = 3.75, height = 3.5, default.units = "inches")
#'
#' ## Place Hi-C plot on page
#' pagePlotPlace(
#'     plot = hicPlot,
#'     x = 0.25, y = 0.25, width = 3, height = 3,
#'     just = c("left", "top"),
#'     default.units = "inches", draw = TRUE
#' )
#'
#' ## Annotate heatmap legend
#' annoHeatmapLegend(
#'     plot = hicPlot,
#'     x = 3.4, y = 0.25, width = 0.12, height = 1.2,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
pagePlotPlace <- function(plot, x = NULL, y = NULL, width = NULL,
                            height = NULL, just = c("left", "top"),
                            default.units = "inches",
                            draw = TRUE, params = NULL) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    set_x <- function(object, val) {
        if (is.null(val)) {
            object["x"] <- list(NULL)
        } else {
            object$x <- val
        }

        return(object)
    }

    set_y <- function(object, val) {
        if (is.null(val)) {
            object["y"] <- list(NULL)
        } else {
            object$y <- val
        }

        return(object)
    }

    set_width <- function(object, val) {
        if (is.null(val)) {
            object["width"] <- list(NULL)
        } else {
            object$width <- val
        }

        return(object)
    }

    set_height <- function(object, val) {
        if (is.null(val)) {
            object["height"] <- list(NULL)
        } else {
            object$height <- val
        }

        return(object)
    }

    set_values <- function(object, x, y, width, height) {
        object <- set_x(object = object, val = x)
        object <- set_y(object = object, val = y)
        object <- set_width(object = object, val = width)
        object <- set_height(object = object, val = height)

        return(object)
    }

    replace_value <- function(val, new) {
        return(new[val])
    }

    ## Define a function to parse coordinates
    parse_coordinates <- function(inputPlot, outputPlot) {

        ## Make sublists of the dimensions/coords of the input/output plots
        inputCoords <- list(
            x = inputPlot$x, y = inputPlot$y,
            width = inputPlot$width, height = inputPlot$height,
            just = inputPlot$just
        )
        outputCoords <- list(
            x = outputPlot$x, y = outputPlot$y,
            width = outputPlot$width,
            height = outputPlot$height, just = outputPlot$just
        )

        ## Determine which values in the output plot are NULL
        to_replace <- names(outputCoords[vapply(
            outputCoords,
            is.null, logical(1)
        )])
        not_replace <- outputCoords[!vapply(
            outputCoords,
            is.null, logical(1)
        )]
        ## Get corresponding values for those that are NULL from the input plot
        replaced <- unlist(lapply(to_replace, replace_value,
            new = inputCoords
        ),
        recursive = FALSE
        )

        ## Recombine values that weren't replaced and those that were
        new_coords <- c(not_replace, replaced)

        outputPlot <- set_values(
            object = outputPlot, x = new_coords$x,
            y = new_coords$y, width = new_coords$width,
            height = new_coords$height
        )
        outputPlot$just <- new_coords$just

        ## Return object
        return(outputPlot)
    }

    ## Define a function that renames grobs and copies to a new gtree
    copy_grobs <- function(grob) {
        new_name <- grobName(grob)

        grob$name <- new_name
        assign("new_gtree",
            addGrob(
                gTree = get("new_gtree", envir = pgEnv),
                child = grob
            ),
            envir = pgEnv
        )
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    place <- parseParams(params = params, 
                            defaultArgs = formals(eval(match.call()[[1]])),
                            declaredArgs = lapply(match.call()[-1], eval.parent,
                                                n = 2),
                            class = "place")
    ## Justification
    place$just <- justConversion(place$just)
    
    # =========================================================================
    # ERRORS
    # =========================================================================

    if (is.null(place$plot)) stop("argument \"plot\" is missing, ",
                                    "with no default.", call. = FALSE)

    # =========================================================================
    # INITIALIZE PLOT OBJECT COPY
    # =========================================================================

    object <- place$plot

    # =========================================================================
    # PARSE UNITS FOR INPUTS
    # =========================================================================

    if (!is.null(place$x)) {
        place$x <- misc_defaultUnits(value = place$x, 
                                        name = "x",
                                        default.units = place$default.units)
    }
    if (!is.null(place$y)) {
        place$y <- misc_defaultUnits(value = place$y, 
                                        name = "y",
                                        default.units = place$default.units)
    }
    if (!is.null(place$width)) {
        place$width <- misc_defaultUnits(value = place$width, 
                                        name = "width",
                                        default.units = place$default.units)
    }
    if (!is.null(place$height)) {
        place$height <- misc_defaultUnits(value = place$height, 
                                            name = "height",
                                            default.units = 
                                                place$default.units)
    }

    # =========================================================================
    # UPDATE DIMENSIONS AND COORDINATES OF PLOT OBJECT BASED ON INPUTS
    # =========================================================================

    object <- set_values(
        object = object, x = place$x, y = place$y,
        width = place$width, height = place$height
    )
    object$just <- place$just
    attr(x = object, which = "plotted") <- place$draw

    # =========================================================================
    # INHERIT DIMENSIONS/COOORDINATES WHERE NULL
    # =========================================================================

    object <- parse_coordinates(
        inputPlot = place$plot,
        outputPlot = object
    )

    # =========================================================================
    # CALL ERRORS
    # =========================================================================

    check_placement(object = object)

    # =========================================================================
    # DEFINE A NEW VIEWPORT
    # =========================================================================

    ## Get viewport name
    currentViewports <- current_viewports()
    num <-
        length(grep(
            pattern = gsub(
                pattern = "[0-9]",
                replacement = "",
                x = object$grobs$vp$name
            ),
            x = currentViewports
        )) + 1

    vp_name <- gsub("[0-9]", replacement = num, x = object$grobs$vp$name)

    ## If full placing information isn't provided but plot == TRUE,
    ## set up it's own viewport separate from bb_makepage
    ## Not translating into page_coordinates
    if (is.null(object$x) | is.null(object$y) |
        is.null(object$width) | is.null(object$height)) {
        new_vp <- viewport(
            height = unit(1, "snpc"), width = unit(1, "snpc"),
            x = unit(0.5, "npc"), y = unit(0.5, "npc"),
            clip = "on",
            xscale = object$grobs$vp$xscale,
            yscale = object$grobs$vp$yscale,
            just = "center",
            name = vp_name
        )

        if (place$draw == TRUE) {
            grid.newpage()
            warning("Plot placement will only fill up the graphical device.",
                call. = FALSE
            )
        }
    } else {
        addViewport(vp_name)
        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = object)

        ## Make viewport
        new_vp <- viewport(
            height = page_coords$height, width = page_coords$width,
            x = page_coords$x, y = page_coords$y,
            clip = "on",
            xscale = object$grobs$vp$xscale,
            yscale = object$grobs$vp$yscale,
            just = place$just,
            name = vp_name
        )
    }

    # =========================================================================
    # RENAME GROBS
    # =========================================================================

    assign("new_gtree", gTree(vp = new_vp), envir = pgEnv)
    invisible(lapply(object$grobs$children, copy_grobs))

    # =========================================================================
    # ASSIGN NEW GROBS TO OBJECT
    # =========================================================================

    object$grobs <- get("new_gtree", envir = pgEnv)

    # =========================================================================
    # IF DRAW == TRUE, DRAW GROBS
    # =========================================================================

    if (place$draw == TRUE) {
        grid.draw(object$grobs)
    }

    # =========================================================================
    # RETURN UPDATED OBJECT
    # =========================================================================

    message(gsub(
        pattern = "[0-9]",
        replacement = "",
        x = vp_name
    ), "[", vp_name, "]")
    invisible(object)
}

getExons <- function(assembly, chromosome, start, stop) {
    if (is(assembly$TxDb, "TxDb")) {
        tx_db <- assembly$TxDb
    } else {
        tx_db <- eval(parse(text = paste0(as.name(assembly$TxDb),
                                        "::",
                                        as.name(assembly$TxDb))))
    }

    if (length(assembly$OrgDb) == 1){
        
        ## Custom orgDb
        if (is(assembly$OrgDb, "OrgDb")){
            org_db <- assembly$OrgDb
        } else {
            org_db <- eval(parse(text = paste0(as.name(assembly$OrgDb),
                                               "::",
                                               as.name(assembly$OrgDb))))
        }
    }
    
    genes_on_chrom <- suppressMessages(GenomicFeatures::genes(tx_db,
        filter = list(tx_chrom = chromosome)
    )) ## Still GRanges
    genes_in_range <- genes_on_chrom[genes_on_chrom@ranges@start <= stop &
        genes_on_chrom@ranges@start +
            genes_on_chrom@ranges@width >= start]
    txs_wo_symbols <- suppressMessages(AnnotationDbi::select(tx_db,
        keys = genes_in_range$gene_id,
        columns = AnnotationDbi::columns(tx_db),
        keytype = "GENEID"
    ))
    ## Double check filtering of chromosome
    txs_wo_symbols <- txs_wo_symbols[which(txs_wo_symbols$TXCHROM==chromosome),]

    if (assembly$gene.id.column == assembly$display.column) {
        txs_w_symbols <- txs_wo_symbols
    } else if (assembly$gene.id.column == "ORF") {
        txs_wo_symbols <- cbind(txs_wo_symbols,
            "SHORTORF" = sub("-.+", "", txs_wo_symbols$GENEID)
        )
        gene_symbols <- suppressMessages(AnnotationDbi::select(org_db,
            keys = sub("-.+", "", genes_in_range$gene_id),
            columns = assembly$display.column,
            keytype = "ORF"
        ))
        txs_w_symbols <- merge(txs_wo_symbols, gene_symbols,
            by.x = "SHORTORF", by.y = "ORF"
        )
    } else {
        gene_symbols <- suppressMessages(AnnotationDbi::select(org_db,
            keys = genes_in_range$gene_id,
            columns = assembly$display.column,
            keytype = assembly$gene.id.column
        ))
        txs_w_symbols <- merge(txs_wo_symbols, gene_symbols,
            by.x = "GENEID", by.y = assembly$gene.id.column
        )
    }

    return(txs_w_symbols)
}

#' Remove guides from a plotgardener page
#'
#' @return None.
#'
#' @examples
#' ## Make a page
#' pageCreate(width = 7, height = 4, default.units = "inches")
#'
#' ## Hide page guides
#' pageGuideHide()
#' 
#' @note 
#' Please note that due to the implementation of `grid` removal functions,
#' using `pageGuideHide` within a `pdf` call will result in the rendering of a 
#' separate, new page with the plot guides removed. To avoid this artifact,
#' hide guides in the `pageCreate` function call with `showGuides = FALSE`.
#' 
#' @export
pageGuideHide <- function() {
    if (length(get("guide_grobs", envir = pgEnv)$children) == 0) {
        stop("No `plotgardener` page guides exist.")
    }

    ## Get the list of grobs from the guide grobs gTree and convert to gPaths
    grob_list <- lapply(
        get("guide_grobs", envir = pgEnv)$children,
        convert_gpath
    )
    ## Get the last grob
    last_grob <- grob_list[length(grob_list)]

    ## Remove the last grob from the list of grobs
    grob_list <- grob_list[-length(grob_list)]

    ## Remove all grobs except last one, not redrawing each time (to save time)
    invisible(lapply(grob_list, grid.remove, redraw = FALSE))

    ## Remove last grob with redrawing, now removing all the grobs
    invisible(lapply(last_grob, grid.remove))
}

#' Read a bigWig file and return it as a data frame
#' 
#' @usage readBigwig(
#'     file,
#'     chrom = NULL,
#'     chromstart = 1,
#'     chromend = .Machine$integer.max,
#'     strand = "*",
#'     params = NULL
#' )
#'
#' @param file A character value specifying the path to the bigwig file.
#' @param chrom Chromosome of data as a string, if data for a specific
#' chromosome is desired.
#' @param chromstart Integer start position on chromosome.
#' @param chromend Integer end position on chromosome.
#' @param strand A character value specifying strand.
#' Default value is \code{strand = "*"}. Options are:
#' \itemize{
#' \item{\code{"+"}: }{Plus strand.}
#' \item{\code{"-"}: }{Minus strand.}
#' \item{\code{"*"}: }{Plus and minus strands.}
#' }
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#'
#' @return Returns a 6-column dataframe of bigwig information.
#' 
#' @examples 
#' if (.Platform$OS.type != "windows"){
#'     bwFile <- system.file("extdata/test.bw", package="plotgardenerData")
#' 
#'     ## Read in entire file
#'     bwData <- readBigwig(file = bwFile)
#' 
#'     ## Read in specified region
#'     bwRegion <- readBigwig(file = bwFile,
#'                             chrom = "chr2",
#'                             chromstart = 1,
#'                             chromend = 1500)
#' }
#' 
#' @details This function does not work on Windows.
#' 
#' @seealso \link[rtracklayer]{import.bw}
#' 
#' @export
readBigwig <- function(file, chrom = NULL, chromstart = 1,
                        chromend = .Machine$integer.max,
                        strand = "*", params = NULL) {

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================
        
    bigwig <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "bigwig"
    )

    # =========================================================================
    # ERRORS
    # =========================================================================

    if (is.null(bigwig$file)) {
        stop("argument \"file\" is missing, with no default.",
            call. = FALSE
        )
    }

    if (bigwig$chromend < bigwig$chromstart - 1) {
        stop("End must be >= start - 1.", call. = FALSE)
    }

    # =========================================================================
    # READ FILE
    # =========================================================================

    if (!is.null(bigwig$chrom)) {
        as.data.frame(rtracklayer::import.bw(bigwig$file,
            which = GenomicRanges::GRanges(paste0(
                bigwig$chrom,
                ":",
                bigwig$chromstart,
                "-",
                bigwig$chromend,
                ":",
                bigwig$strand
            ))
        ))
    } else {
        as.data.frame(rtracklayer::import.bw(bigwig$file))
    }
}

#' Plot paired-end genomic range elements
#' 
#' @usage plotPairs(
#'     data,
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     assembly = "hg38",
#'     fill = "#1f4297",
#'     linecolor = NA,
#'     bg = NA,
#'     boxHeight = unit(2, "mm"),
#'     spaceWidth = 0.02,
#'     spaceHeight = 0.3,
#'     limitLabel = TRUE,
#'     baseline = FALSE,
#'     baseline.color = "grey",
#'     baseline.lwd = 1,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL,
#'     ...
#' )
#'
#' @param data A string specifying the BEDPE file path, a dataframe
#' in BEDPE format specifying data to be plotted, or a
#' \link[InteractionSet]{GInteractions} object.
#' @param chrom Chromosome of region to be plotted, as a string.
#' @param chromstart Integer start position on chromosome to be plotted.
#' @param chromend Integer end position on chromosome to be plotted.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param fill A single character value, a vector, or 
#' a \link[plotgardener]{colorby} object specifying fill colors of
#' paired range elements. Default value is \code{fill = "#1f4297"}.
#' @param linecolor A single character value, a vector, or a
#' \link[plotgardener]{colorby} object specifying the color of the lines
#' outlining paired range elements. Default value is \code{linecolor = NA}.
#' Special options include:
#' \itemize{
#' \item{\code{NA}: }{No line color.}
#' \item{\code{"fill"}: }{Same color as \code{fill}.}
#' }
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param boxHeight A numeric or unit object specifying height of boxes
#' at either end of paired range elements.
#' Default value is \code{boxHeight = unit(2, "mm")}.
#' @param spaceWidth A numeric specifying the width of spacing between
#' paired range elements, as a fraction of the plot's genomic range.
#' Default value is \code{spaceWidth = 0.02}.
#' @param spaceHeight A numeric specifying the height of space between
#' boxes of paired range elements on different rows.
#' Default value is \code{spaceHeight = 0.3}.
#' @param limitLabel A logical value indicating whether to draw a "+"
#' when not all elements can be plotted in the plotting space. Default 
#' value is \code{limitLabel = TRUE}.
#' @param baseline Logical value indicating whether to include a baseline
#' along the x-axis. Default value is \code{baseline = FALSE}.
#' @param baseline.color Baseline color.
#' Default value is \code{baseline.color = "grey"}.
#' @param baseline.lwd Baseline line width.
#' Default value is \code{baseline.lwd = 1}.
#' @param x A numeric or unit object specifying paired range plot x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying paired range plot y-location.
#' The character value will
#' place the paired range plot y relative to the bottom of the most recently
#' plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying paired range plot width.
#' @param height A numeric or unit object specifying paired range plot height.
#' @param just Justification of paired range plot relative
#' to its (x, y) location.
#' If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use
#' if \code{x}, \code{y}, \code{width}, or \code{height} are only given
#' as numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics
#' output should be produced.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{pairs} object containing relevant
#' genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load paired ranges data in BEDPE format
#' library(plotgardenerData)
#' data("IMR90_DNAloops_pairs")
#'
#' ## Set the coordinates
#' params <- pgParams(
#'     chrom = "chr21",
#'     chromstart = 27900000, chromend = 30700000,
#'     assembly = "hg19",
#'     width = 7
#' )
#'
#' ## Create a page
#' pageCreate(width = 7.5, height = 2.1, default.units = "inches")
#'
#' ## Add a length column
#' IMR90_DNAloops_pairs$length <- 
#'         (IMR90_DNAloops_pairs$start2 - IMR90_DNAloops_pairs$start1) / 1000
#'
#' ## Plot the data
#' bedpePlot <- plotPairs(
#'     data = IMR90_DNAloops_pairs, params = params,
#'     fill = colorby("length", palette = 
#'                 colorRampPalette(c("dodgerblue2", "firebrick2"))),
#'     lwd = 2, spaceHeight = .7,
#'     x = 0.25, y = 0.25, height = 1.5,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Annotate genome label
#' annoGenomeLabel(plot = bedpePlot, x = 0.25, y = 1.78, scale = "Mb")
#'
#' ## Add heatmap legend
#' annoHeatmapLegend(
#'     plot = bedpePlot, fontcolor = "black",
#'     x = 7.0, y = 0.25,
#'     width = 0.10, height = 1, fontsize = 10
#' )
#'
#' ## Add heatmap legend label
#' plotText(
#'     label = "Kb", rot = 90, x = 6.9, y = 0.75,
#'     just = c("center", "center"), fontsize = 10
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @details
#' #' A paired ranges plot can be placed on a plotgardener coordinate page
#' by providing plot placement parameters:
#' \preformatted{
#' plotPairs(data, chrom,
#'             chromstart = NULL, chromend = NULL,
#'             x, y, width, height, just = c("left", "top"),
#'             default.units = "inches")
#' }
#' This function can also be used to quickly plot an unannotated paired
#' ranges plot by ignoring plot placement parameters:
#' \preformatted{
#' plotPairs(data, chrom,
#'             chromstart = NULL, chromend = NULL)
#' }
#'
#' @export
plotPairs <- function(data, chrom, chromstart = NULL, chromend = NULL,
                        assembly = "hg38", fill = "#1f4297",
                        linecolor = NA, bg = NA, boxHeight = unit(2, "mm"),
                        spaceWidth = 0.02, spaceHeight = 0.3,
                        limitLabel = TRUE,
                        baseline = FALSE, baseline.color = "grey",
                        baseline.lwd = 1,
                        x = NULL, y = NULL, width = NULL, height = NULL,
                        just = c("left", "top"), default.units = "inches",
                        draw = TRUE, params = NULL, ...) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors
    errorcheck_plotPairs <- function(bedpeData, bedpePlot, fill) {

        ## Genomic region
        regionErrors(chromstart = bedpePlot$chromstart,
                    chromend = bedpePlot$chromend)
        
        ## Fill colorby checks
        checkColorby(fill = fill,
                        colorby = TRUE,
                        data = bedpeData)
            
        }
        
    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    bedpeInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "bedpeInternal"
    )

    ## Parse gp
    bedpeInternal$gp <- setGP(
        gpList = gpar(),
        params = bedpeInternal, ...
    )
    
    ## Justification
    bedpeInternal$just <- justConversion(just = bedpeInternal$just)

    # =========================================================================
    # CHECK ARGUMENT ERRORS
    # =========================================================================
    if (is.null(bedpeInternal$data)) stop("argument \"data\" is missing, ",
                                            "with no default.", call. = FALSE)
    if (is.null(bedpeInternal$chrom)) stop("argument \"chrom\" is missing, ",
                                            "with no default.", call. = FALSE)
    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    bedpe <- structure(list(
        bedpeData = NULL, chrom = bedpeInternal$chrom,
        chromstart = bedpeInternal$chromstart,
        chromend = bedpeInternal$chromend,
        assembly = bedpeInternal$assembly,
        color_palette = NULL,
        zrange = NULL,
        x = bedpeInternal$x, y = bedpeInternal$y,
        width = bedpeInternal$width,
        height = bedpeInternal$height,
        just = bedpeInternal$just, grobs = NULL
    ),
    class = "pairs"
    )
    attr(x = bedpe, which = "plotted") <- bedpeInternal$draw

    # =========================================================================
    # CHECK PLACEMENT
    # =========================================================================

    check_placement(object = bedpe)

    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    bedpe$assembly <- parseAssembly(assembly = bedpe$assembly)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    bedpe <- defaultUnits(
        object = bedpe,
        default.units = bedpeInternal$default.units
    )
    
    bedpeInternal$boxHeight <- misc_defaultUnits(
        value = bedpeInternal$boxHeight,
        name = "boxHeight",
        default.units = bedpeInternal$default.units
    )
    
    # =========================================================================
    # READ IN FILE OR DATAFRAME
    # =========================================================================

    bedpeData <- read_pairedData(data = bedpeInternal$data,
                            assembly = bedpe$assembly)
    
    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    errorcheck_plotPairs(
        bedpeData = bedpeData, bedpePlot = bedpe,
        fill = bedpeInternal$fill
    )
    
    ## chrom format and data chrom format
    chromDataAgreement(data = bedpeData, chrom = bedpe$chrom,
                        type = "pairs")

    # =========================================================================
    # ORGANIZE DATA
    # =========================================================================

    ## Get appropriate starts/stops
    start1 <- apply(bedpeData[, c("start1", "end1")], 1, min)
    stop1 <- apply(bedpeData[, c("start1", "end1")], 1, max)
    start2 <- apply(bedpeData[, c("start2", "end2")], 1, min)
    stop2 <- apply(bedpeData[, c("start2", "end2")], 1, max)
    bedpeData$start1 <- start1
    bedpeData$end1 <- stop1
    bedpeData$start2 <- start2
    bedpeData$end2 <- stop2

    # =========================================================================
    # GENOMIC SCALE
    # =========================================================================

    scaleChecks <- genomicScale(object = bedpe,
                                objectInternal = bedpeInternal,
                                plotType = "paired data plot")
    bedpe <- scaleChecks[[1]]
    bedpeInternal <- scaleChecks[[2]]
    
    # =========================================================================
    # COLORS
    # =========================================================================
    
    pairColors <- parseColors(data = bedpeData,
                                fill = bedpeInternal$fill,
                                object = bedpe,
                                subset = "pairs")
    if (length(pairColors[[1]]) > 0){
        bedpeData$color <- pairColors[[1]]
    } else {
        bedpeData$color <- rep("#1f4297", nrow(bedpeData))
    }
    
    bedpe <- pairColors[[2]]
    bedpeData$linecolor <- lineColors(linecolor = bedpeInternal$linecolor,
                                    fillcolors = bedpeData$color,
                                    data = bedpeData,
                                    object = bedpe,
                                    subset = "pairs")

    # =========================================================================
    # SUBSET DATA FOR CHROMOSOME AND ANY OVERLAPPING REGIONS
    # =========================================================================

    if (!is.null(bedpe$chromstart) & !is.null(bedpe$chromend)) {
        bedpeData <- bedpeData[which(bedpeData[, "chrom1"] == bedpe$chrom &
                                 bedpeData[, "chrom2"] == bedpe$chrom),]
        overlappingRanges <- as.data.frame(subsetByOverlaps(ranges = 
                                IRanges(start = bedpe$chromstart, 
                                        end = bedpe$chromend),
                                x = IRanges(start = bedpeData[,"start1"], 
                                            end = bedpeData[,"end2"])))
        bedpeData <- bedpeData[which(bedpeData[,"start1"] %in% 
                                 overlappingRanges$start &
                                 bedpeData[,"end2"] %in% 
                                 overlappingRanges$end),]
    } else {
        bedpeData <- data.frame(matrix(nrow = 0, ncol = 6))
    }

    # =========================================================================
    # GET BOX WIDTHS AND TOTAL DISTANCES
    # =========================================================================

    bedpeData$width1 <- bedpeData[, "end1"] - bedpeData[, "start1"]
    bedpeData$width2 <- bedpeData[, "end2"] - bedpeData[, "start2"]
    bedpeData$pos1 <- rowMeans(bedpeData[, c("start1", "end1")])
    bedpeData$pos2 <- rowMeans(bedpeData[, c("start2", "end2")])
    bedpeData$distance <- abs(bedpeData$pos2 - bedpeData$pos1)

    # =========================================================================
    # SORT BY DISTANCE FOR PRETTIER PLOTTING
    # =========================================================================

    bedpeData <- bedpeData[order(bedpeData$distance, decreasing = TRUE), ]

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## If placing information is provided but plot == TRUE,
    ## set up it's own viewport separate
    ## Not translating into page_coordinates
    if (is.null(bedpe$x) | is.null(bedpe$y)) {
        vp <- viewport(
            height = unit(0.5, "snpc"), width = unit(1, "snpc"),
            x = unit(0.5, "npc"), y = unit(0.5, "npc"),
            clip = "on",
            xscale = bedpeInternal$xscale,
            yscale = c(0, 1),
            just = "center",
            name = "pairs1"
        )

        if (bedpeInternal$draw == TRUE) {
            grid.newpage()
        }
    } else {
        
        ## Get viewport name
        currentViewports <- current_viewports()
        vp_name <- paste0(
            "pairs",
            length(grep(
                pattern = "pairs",
                x = currentViewports
            )) + 1
        )
        
        addViewport(vp_name)

        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = bedpe)

        ## Make viewport
        vp <- viewport(
            height = page_coords$height, width = page_coords$width,
            x = page_coords$x, y = page_coords$y,
            clip = "on",
            xscale = bedpeInternal$xscale,
            yscale = c(0, convertHeight(page_coords$height,
                unitTo = get("page_units",
                    envir = pgEnv
                ),
                valueOnly = TRUE
            )),
            just = bedpeInternal$just,
            name = vp_name
        )
    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS WITH BACKGROUND
    # =========================================================================

    backgroundGrob <- rectGrob(gp = gpar(
        fill = bedpeInternal$bg,
        col = NA
    ), name = "background")
    assign("bedpe_grobs", gTree(
        vp = vp,
        children = gList(backgroundGrob)
    ),
    envir = pgEnv
    )

    # =========================================================================
    # DETERMINE ROWS FOR EACH ELEMENT
    # =========================================================================
    if (nrow(bedpeData) > 0) {
        
        if (is.null(bedpe$x) & is.null(bedpe$y)) {
            pushViewport(vp)
            boxHeight <- convertHeight(bedpeInternal$boxHeight,
                                    unitTo = "npc", valueOnly = TRUE
            )
            spaceHeight <- boxHeight * (bedpeInternal$spaceHeight)
            upViewport()
        } else {
            boxHeight <- convertHeight(bedpeInternal$boxHeight,
                                    unitTo = get("page_units", 
                                                    envir = pgEnv),
                                    valueOnly = TRUE
            )
            spaceHeight <- boxHeight * (bedpeInternal$spaceHeight)
        }

        ## Determine how many pair elements are going to fit
        maxRows <- floor((as.numeric(vp$height) + spaceHeight) /
                            (boxHeight + spaceHeight))
        wiggle <- abs(bedpe$chromend - bedpe$chromstart) *
            bedpeInternal$spaceWidth
        
        ## Assign rows
        rowData <- assignRows(data = bedpeData[,c("start1","end2","start2")],
                            maxRows = maxRows,
                            wiggle = wiggle,
                            rowCol = 3,
                            limitLabel = bedpeInternal$limitLabel,
                            gTree = "bedpe_grobs",
                            extraData = bedpeData[,c("color", "linecolor", 
                                                "width1",
                                                "width2", "pos1",
                                                "pos2", "distance")],
                            colNames = c("color", "linecolor", 
                                        "width1", "width2",
                                        "pos1", "pos2", "distance"))
        
        ## Calculate y-coordinates
        rowData$y <- rowData$row * (boxHeight + spaceHeight)
        
        # =====================================================================
        # MAKE GROBS
        # =====================================================================

        if (bedpeInternal$baseline == TRUE) {
            baselineGrob <- segmentsGrob(
                x0 = unit(0, "npc"), y0 = 0,
                x1 = unit(1, "npc"), y1 = 0,
                default.units = "native",
                gp = gpar(
                    col = bedpeInternal$baseline.color,
                    lwd = bedpeInternal$baseline.lwd
                )
            )
            assign("bedpe_grobs",
                addGrob(
                    gTree = get("bedpe_grobs", envir = pgEnv),
                    child = baselineGrob
                ),
                envir = pgEnv
            )
        }

        bedpeInternal$gp$fill <- rowData$color
        bedpeInternal$gp$col <- rowData$linecolor

        bedpeRect1 <- rectGrob(
            x = rowData[,"start1"],
            y = rowData$y,
            width = rowData$width1,
            height = boxHeight,
            just = c("left", "bottom"),
            default.units = "native",
            gp = bedpeInternal$gp
        )

        bedpeRect2 <- rectGrob(
            x = rowData[,"start2"],
            y = rowData$y,
            width = rowData$width2,
            height = boxHeight,
            just = c("left", "bottom"),
            default.units = "native",
            gp = bedpeInternal$gp
        )

        bedpeInternal$gp$col <- rowData$color
        bedpeInternal$gp$lineend <- "butt"

        bedpeLine <- segmentsGrob(
            x0 = rowData$pos1,
            y0 = rowData$y + 0.5 * boxHeight,
            x1 = rowData$pos2,
            y1 = rowData$y + 0.5 * boxHeight,
            default.units = "native",
            gp = bedpeInternal$gp
        )

        assign("bedpe_grobs",
            addGrob(
                gTree = get("bedpe_grobs", envir = pgEnv),
                child = bedpeLine
            ),
            envir = pgEnv
        )
        assign("bedpe_grobs",
            addGrob(
                gTree = get("bedpe_grobs", envir = pgEnv),
                child = bedpeRect1
            ),
            envir = pgEnv
        )
        assign("bedpe_grobs",
            addGrob(
                gTree = get("bedpe_grobs", envir = pgEnv),
                child = bedpeRect2
            ),
            envir = pgEnv
        )
    } else {
        if (bedpeInternal$txdbChecks == TRUE) {
            warning("Data contains no values.", call. = FALSE)
        }
    }

    # =========================================================================
    # IF PLOT == TRUE, DRAW GROBS
    # =========================================================================

    if (bedpeInternal$draw == TRUE) {
        grid.draw(get("bedpe_grobs", envir = pgEnv))
    }

    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    bedpe$grobs <- get("bedpe_grobs", envir = pgEnv)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================
    message("pairs[", vp$name, "]")
    invisible(bedpe)
}

#' Plot a triangular Hi-C interaction matrix in a rectangular format
#' 
#' @usage plotHicRectangle(
#'     data,
#'     resolution = "auto",
#'     zrange = NULL,
#'     norm = "KR",
#'     matrix = "observed",
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     assembly = "hg38",
#'     palette = colorRampPalette(brewer.pal(n = 9, "YlGnBu")),
#'     colorTrans = "linear",
#'     flip = FALSE,
#'     bg = NA,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL,
#'     quiet = FALSE
#' )
#'
#' @param data Path to .hic or .(m)cool file as a string or a 3-column 
#' dataframe of interaction counts in sparse upper triangular format.
#' @param resolution A numeric specifying the width in basepairs
#' of each pixel. For files, "auto" will attempt to choose a
#' resolution based on the size of the region. For
#' dataframes, "auto" will attempt to detect the resolution the
#' dataframe contains.
#' @param zrange A numeric vector of length 2 specifying the range of
#' interaction scores to plot, where extreme values will be set to the
#' max or min.
#' @param norm Character value specifying hic data normalization method,
#' if giving .hic or .(m)cool file. This value must be found in the .hic 
#' or .(m)cool file.
#' Default value is \code{norm = "KR"}.
#' @param matrix Character value indicating the type of matrix to output for 
#' .hic files.
#' Default value is \code{matrix = "observed"}. Options are:
#' \itemize{
#' \item{\code{"observed"}: }{Observed counts.}
#' \item{\code{"oe"}: }{Observed/expected counts.}
#' \item{\code{"log2oe"}: }{Log2 transformed observed/expected counts.}
#' }
#' @param chrom Chromosome of region to be plotted, as a string.
#' @param chromstart Integer start position on chromosome to be plotted.
#' @param chromend Integer end position on chromosome to be plotted.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param palette A function describing the color palette to use for
#' representing scale of interaction scores. Default value is
#' \code{palette =  colorRampPalette(brewer.pal(n = 9, "YlGnBu"))}.
#' @param colorTrans A string specifying how to scale Hi-C colors.
#' Options are "linear", "log", "log2", or "log10".
#' Default value is \code{colorTrans = "linear"}.
#' @param flip A logical indicating whether to flip the orientation of
#' the Hi-C matrix over the x-axis. Default value is \code{flip = FALSE}.
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param x A numeric or unit object specifying rectangle
#' Hi-C plot x-location.
#' @param y A numeric, unit object, or character containing a "b" combined
#' with a numeric value specifying rectangle Hi-C plot y-location.
#' The character value will
#' place the rectangle Hi-C plot y relative to the bottom of the most
#' recently plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying the width of the
#' Hi-C plot rectangle.
#' @param height A numeric or unit object specifying the height of the
#' Hi-C plot rectangle.
#' @param just Justification of rectangle Hi-C plot relative to
#' its (x, y) location. If there are two values, the first value
#' specifies horizontal justification and the second value specifies
#' vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use
#' if \code{x}, \code{y}, \code{width}, or \code{height} are only given
#' as numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output should
#' be produced. Default value is \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param quiet A logical indicating whether or not to print messages.
#'
#' @return Returns a \code{hicRectangle} object containing
#' relevant genomic region, Hi-C data, placement,
#' and \link[grid]{grob} information.
#'
#' @examples
#' ## Load Hi-C data
#' library(plotgardenerData)
#' data("IMR90_HiC_10kb")
#'
#' ## Create a page
#' pageCreate(width = 6, height = 3.5, default.units = "inches")
#'
#' ## Plot and place rectangle Hi-C plot
#' hicPlot <- plotHicRectangle(
#'     data = IMR90_HiC_10kb, resolution = 10000,
#'     zrange = c(0, 70),
#'     chrom = "chr21",
#'     chromstart = 28950000, chromend = 29800000,
#'     assembly = "hg19",
#'     x = 0.5, y = 0.5, width = 5, height = 2.5,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Annotate x-axis genome label
#' annoGenomeLabel(
#'     plot = hicPlot, scale = "Kb", x = 0.5, y = 3.03,
#'     just = c("left", "top")
#' )
#'
#' ## Annotate heatmap legend
#' annoHeatmapLegend(
#'     plot = hicPlot, x = 5.6, y = 0.5,
#'     width = 0.13, height = 1.5,
#'     just = c("left", "top")
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @details
#' This function is similar is \link[plotgardener]{plotHicTriangle} but
#' will fill in additional pixels around the
#' the triangular portion of the plot to make a rectangle. The x-axis
#' represents the genomic coordinates and the y-axis corresponds to distance in
#' Hi-C bins.
#'
#' A rectangle Hi-C plot can be placed on a plotgardener coordinate
#' page by providing plot placement parameters:
#' \preformatted{
#' plotHicRectangle(data, chrom,
#'                     chromstart = NULL, chromend = NULL,
#'                     x, y, width, height, just = c("left", "top"),
#'                     default.units = "inches")
#' }
#' This function can also be used to quickly plot an unannotated
#' rectangle Hi-C plot by ignoring plot placement parameters:
#' \preformatted{
#' plotHicRectangle(data, chrom,
#'                     chromstart = NULL, chromend = NULL)
#' }
#'
#' @seealso \link[plotgardener]{readHic}, \link[plotgardener]{readCool},
#' \link[plotgardener]{plotHicTriangle}
#'
#' @export
plotHicRectangle <- function(data, resolution = "auto", zrange = NULL,
                                norm = "KR", matrix = "observed", chrom,
                                chromstart = NULL, chromend = NULL,
                                assembly = "hg38",
                                palette = colorRampPalette(brewer.pal(
                                    n = 9, "YlGnBu"
                                )),
                                colorTrans = "linear", flip = FALSE, 
                                bg = NA,
                                x = NULL, y = NULL,
                                width = NULL, height = NULL,
                                just = c("left", "top"),
                                default.units = "inches", draw = TRUE,
                                params = NULL, quiet = FALSE) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors for plotTriangleHic
    errorcheck_plotHicRectangle <- function(hic, hicPlot, norm) {

        ###### hic/cool/mcool/norm 
        hicErrors(hic = hic, 
                    norm = norm)

        ## Genomic region errors
        regionErrors(chromstart = hicPlot$chromstart,
                    chromend = hicPlot$chromend)

        ##### zrange errors
        rangeErrors(range = hicPlot$zrange)
    }

    ## Define a function that adjusts chromstart/chromend to include
    ## additional data for rectangle
    rect_region <- function(inputHeight, inputWidth, chromstart, chromend) {
        if (!is.null(chromstart) & !is.null(chromend)) {
            dimRatio <- inputHeight / inputWidth
            rectChromstart <- chromstart - ((chromend - chromstart) * dimRatio)
            rectChromend <- chromend + ((chromend - chromstart) * dimRatio)
        } else {
            rectChromstart <- NULL
            rectChromend <- NULL
        }
        
        return(list(rectChromstart, rectChromend))
    }

    ## Define a function that subsets data for rectangle Hi-C plot
    subset_data <- function(hic, hicPlot) {
        if (nrow(hic) > 0) {
            hic <- hic[which(hic[, "x"] >= floor(hicPlot$chromstart /
                hicPlot$resolution) *
                hicPlot$resolution &
                hic[, "x"] < hicPlot$chromend &
                hic[, "y"] >= floor(hicPlot$chromstart / hicPlot$resolution) *
                    hicPlot$resolution &
                hic[, "y"] < hicPlot$chromend), ]
        }

        return(hic)
    }

    rect_vpScale <- function(hicPlot, hicPlotInternal) {
        if (!is.null(hicPlot$chromstart) & !is.null(hicPlot$chromend)) {

            # updated chromstart
            in_xscale <- c(hicPlot$chromstart, hicPlot$chromend)
            # input chromstart
            out_xscale <- c(
                hicPlotInternal$chromstart,
                hicPlotInternal$chromend
            )
        } else {
            in_xscale <- c(0, 1)
            out_xscale <- c(0, 1)
        }

        return(list(in_xscale, out_xscale))
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================
    
    rhicInternal <- parseParams(params = params, 
                                    defaultArgs = formals(eval(
                                        match.call()[[1]])),
                                    declaredArgs = lapply(
                                        match.call()[-1], eval.parent, n = 2),
                                    class = "rhicInternal")
    ## Justification
    rhicInternal$just <- justConversion(just = rhicInternal$just)

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    hicPlot <- structure(list(
        chrom = rhicInternal$chrom,
        chromstart = rhicInternal$chromstart,
        chromend = rhicInternal$chromend,
        altchrom = rhicInternal$chrom,
        altchromstart = rhicInternal$chromstart,
        altchromend = rhicInternal$chromend,
        assembly = rhicInternal$assembly,
        resolution = rhicInternal$resolution,
        x = rhicInternal$x, y = rhicInternal$y,
        width = rhicInternal$width,
        height = rhicInternal$height,
        just = rhicInternal$just,
        color_palette = NULL,
        colorTrans = rhicInternal$colorTrans,
        zrange = rhicInternal$zrange,
        flip = rhicInternal$flip,
        outsideVP = NULL, grobs = NULL
    ),
    class = "hicRectangle"
    )
    attr(x = hicPlot, which = "plotted") <- rhicInternal$draw

    # =========================================================================
    # CHECK PLACEMENT/ARGUMENT ERRORS
    # =========================================================================

    if (is.null(rhicInternal$data)) stop("argument \"data\" is missing, ",
                                            "with no default.", call. = FALSE)
    if (is.null(rhicInternal$chrom)) stop("argument \"chrom\" is missing, ",
                                            "with no default.", call. = FALSE)
    check_placement(object = hicPlot)

    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    hicPlot$assembly <- parseAssembly(assembly = hicPlot$assembly)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    hicPlot <- defaultUnits(
        object = hicPlot,
        default.units = rhicInternal$default.units
    )

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    errorcheck_plotHicRectangle(
        hic = rhicInternal$data,
        hicPlot = hicPlot,
        norm = rhicInternal$norm
    )

    # =========================================================================
    # GENOMIC SCALE
    # =========================================================================
    
    scaleChecks <- genomicScale(object = hicPlot,
                                objectInternal = rhicInternal,
                                plotType = "rectangle Hi-C plot")
    hicPlot <- scaleChecks[[1]]
    rhicInternal <- scaleChecks[[2]]

    # =========================================================================
    # ADJUST RESOLUTION
    # =========================================================================

    if (rhicInternal$resolution == "auto") {
        hicPlot <- adjust_resolution(
            hic = rhicInternal$data,
            hicPlot = hicPlot
        )
    } else {
        hicPlot <- hic_limit(
            hic = rhicInternal$data,
            hicPlot = hicPlot
        )
    }

    # =========================================================================
    # ADJUST CHROMSTART TO GRAB MORE DATA
    # =========================================================================

    if (is.null(hicPlot$x) & is.null(hicPlot$y)) {
        inputHeight <- 0.5
        inputWidth <- 1
    } else {
        inputHeight <- convertHeight(hicPlot$height,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
        inputWidth <- convertWidth(hicPlot$width,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
    }


    adjRegion <- rect_region(
        inputHeight = inputHeight, inputWidth = inputWidth,
        chromstart = hicPlot$chromstart,
        chromend = hicPlot$chromend
    )

    hicPlot$chromstart <- adjRegion[[1]]
    hicPlot$altchromstart <- adjRegion[[1]]
    hicPlot$chromend <- adjRegion[[2]]
    hicPlot$altchromend <- adjRegion[[2]]
    
    # =========================================================================
    # READ IN DATA
    # =========================================================================

    hic <- read_data(
        hic = rhicInternal$data, hicPlot = hicPlot,
        norm = rhicInternal$norm, assembly = hicPlot$assembly,
        type = rhicInternal$matrix,
        quiet = rhicInternal$quiet
    )

    # =========================================================================
    # SUBSET DATA
    # =========================================================================

    hic <- subset_data(hic = hic, hicPlot = hicPlot)
    
    # =========================================================================
    # GET LOWER TRIANGULAR FOR FLIP
    # =========================================================================
    
    if (rhicInternal$flip == TRUE){
        hic <- hic[, c("y", "x", "counts")]
        colnames(hic) <- c("x", "y", "counts")
    }
    
    # =========================================================================
    # SET ZRANGE AND SCALE DATA
    # =========================================================================

    hicPlot <- set_zrange(hic = hic, hicPlot = hicPlot)
    hic$counts[hic$counts <= hicPlot$zrange[1]] <- hicPlot$zrange[1]
    hic$counts[hic$counts >= hicPlot$zrange[2]] <- hicPlot$zrange[2]

    # =========================================================================
    # CONVERT NUMBERS TO COLORS
    # =========================================================================

    ## if we don't have an appropriate zrange
    ## (even after setting it based on a null zrange), can't scale to colors
    if (!is.null(hicPlot$zrange) & length(unique(hicPlot$zrange)) == 2) {
        if (grepl("log", rhicInternal$colorTrans) == TRUE) {
            logBase <- utils::type.convert(gsub("log", "", 
                                                rhicInternal$colorTrans), 
                                    as.is = TRUE)
            if (is.na(logBase)) {
                logBase <- exp(1)
            }

            ## Won't scale to log if negative values
            if (any(hic$counts < 0)) {
                stop("Negative values in Hi-C data. Cannot scale ",
                "colors on a log scale. Please set `colorTrans = 'linear'`.",
                    call. = FALSE
                )
            }


            hic$counts <- log(hic$counts, base = logBase)
            hic$color <- mapColors(vector = hic$counts,
                palette = rhicInternal$palette,
                range = log(hicPlot$zrange, logBase)
            )
        } else {
            hic$color <- mapColors(vector = hic$counts,
                palette = rhicInternal$palette,
                range = hicPlot$zrange
            )
        }

        hicPlot$color_palette <- rhicInternal$palette
    }

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## Viewport scale
    scale <- rect_vpScale(
        hicPlot = hicPlot,
        hicPlotInternal = rhicInternal
    )
    
    ## Inner viewport y-coordinate
    if (rhicInternal$flip == TRUE){
        y <- unit(1, "npc")
    } else {
        y <- unit(0, "npc")
    }

    if (is.null(hicPlot$x) | is.null(hicPlot$y)) {
        vp_name <- "hicRectangle1"
        inside_vp <- viewport(
            height = unit(4 / sqrt(2), "npc"),
            width = unit(2 / sqrt(2), "npc"),
            x = unit(scale[[1]][1], "native"),
            y = y,
            xscale = scale[[1]],
            yscale = scale[[1]],
            just = c("left", "bottom"),
            name = "hicRectangle1_inside",
            angle = -45
        )
        
        # Number of bins along yscale
        num_pixelsWidth <- 
            (rhicInternal$chromend - rhicInternal$chromstart)/hicPlot$resolution
        per_pixel <- 1/num_pixelsWidth
        num_pixelsHeight <- 0.5/per_pixel

        outside_vp <- viewport(
            height = unit(0.5, "snpc"),
            width = unit(1, "snpc"),
            x = unit(0.5, "npc"),
            y = unit(0.5, "npc"),
            xscale = scale[[2]],
            yscale = c(0, num_pixelsHeight),
            clip = "on",
            just = "center",
            name = "hicRectangle1_outside"
        )


        if (rhicInternal$draw == TRUE) {
            grid.newpage()
        }
    } else {
        
        ## Get viewport name
        currentViewports <- current_viewports()
        vp_name <- paste0(
            "hicRectangle",
            length(grep(
                pattern = "hicRectangle",
                x = currentViewports
            )) + 1
        )

        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = hicPlot)

        ## Get length of side of inside viewport
        vp_side <- (as.numeric(page_coords$width) + 2 *
            as.numeric(page_coords$height)) / sqrt(2)
            
        inside_vp <- viewport(
                height = unit(
                    vp_side,
                    get("page_units", envir = pgEnv)
                ),
                width = unit(
                    vp_side,
                    get("page_units", envir = pgEnv)
                ),
                x = unit(scale[[1]][1], "native"),
                y = y,
                xscale = scale[[1]],
                yscale = scale[[1]],
                just = c("left", "bottom"),
                name = paste0(vp_name, "_inside"),
                angle = -45
            )
        
        # Number of bins along yscale
        num_pixelsWidth <- 
            (rhicInternal$chromend - rhicInternal$chromstart)/hicPlot$resolution
        per_pixel <- as.numeric(page_coords$width)/num_pixelsWidth
        num_pixelsHeight <- as.numeric(page_coords$height)/per_pixel
        
        outside_vp <- viewport(
                height = page_coords$height,
                width = page_coords$width,
                x = page_coords$x, y = page_coords$y,
                just = hicPlot$just,
                xscale = scale[[2]],
                yscale = c(0, num_pixelsHeight),
                clip = "on",
                name = paste0(vp_name, "_outside")
            ) 
            
        addViewport(paste0(vp_name, "_outside"))
    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS WITH BACKGROUND
    # =========================================================================
    
    hicPlot$outsideVP <- outside_vp
    backgroundGrob <- rectGrob(gp = gpar(
        fill = rhicInternal$bg,
        col = NA
    ), name = "background")
    assign("hic_grobs3", gTree(vp = inside_vp, children = gList(backgroundGrob)),
        envir = pgEnv
    )
    
    # =========================================================================
    # MAKE GROBS
    # =========================================================================

    if (!is.null(hicPlot$chromstart) & !is.null(hicPlot$chromend)) {
        if (nrow(hic) > 0) {
            hic_squares <- rectGrob(
                x = hic$x,
                y = hic$y,
                just = c("left", "bottom"),
                width = hicPlot$resolution,
                height = hicPlot$resolution,
                gp = gpar(col = NA, fill = hic$color),
                default.units = "native"
            )

            assign("hic_grobs3",
                addGrob(
                    gTree = get("hic_grobs3", envir = pgEnv),
                    child = hic_squares
                ),
                envir = pgEnv
            )
        } else {
            if (!is.na(hicPlot$resolution)){
                warning("No data found in region.", call. = FALSE)
            }
        }
    }


    # ========================================================================
    # IF DRAW == TRUE, DRAW GROBS
    # ========================================================================

    if (rhicInternal$draw == TRUE) {
        pushViewport(outside_vp)
        grid.draw(get("hic_grobs3", envir = pgEnv))
        upViewport()
    }

    # =========================================================================
    # ADD GROBS TO OBJECT AND RESET CHROMSTART AND CHROMEND
    # =========================================================================

    hicPlot$grobs <- get("hic_grobs3", envir = pgEnv)
    hicPlot$chromstartAdjusted <- hicPlot$chromstart
    hicPlot$chromendAdjusted <- hicPlot$chromend
    hicPlot$chromstart <- rhicInternal$chromstart
    hicPlot$chromend <- rhicInternal$chromend

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("hicRectangle[", vp_name, "]")
    invisible(hicPlot)
}

#' Plot a raster object within a plotgardener layout
#' 
#' @usage plotRaster(
#'     image,
#'     x,
#'     y,
#'     width,
#'     height,
#'     just = "center",
#'     default.units = "inches",
#'     interpolate = TRUE,
#'     params = NULL,
#'     ...
#' )
#'
#' @param image Any R object that can be coerced to a raster object.
#' @param x A numeric vector or unit object specifying raster x-locations.
#' @param y A numeric vector, unit object, or a character vector of values
#' containing a "b" combined with a numeric value specifying
#' raster y-locations.
#' The character vector will place raster y relative to the bottom
#' of the most recently plotted plot according to the units
#' of the plotgardener page.
#' @param width A numeric vector or unit object specifying raster widths.
#' @param height A numeric vector or unit object specifying raster heights.
#' @param just Justification of text relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and
#' \code{"top"}. Default value is \code{just = "center"}.
#' @param default.units A string indicating the default units
#' to use if \code{x}, \code{y}, \code{width}, or \code{height}
#' are only given as numerics or numeric vectors.
#' Default value is \code{default.units = "inches"}.
#' @param interpolate A logical value indicating whether to linearly
#' interpolate the image. Default value is \code{interpolate = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{raster} object containing
#' relevant placement and \link[grid]{grob} information.
#'
#' @examples
#' library(png)
#'
#' ## Load images
#' 
#' pg_type <- readPNG(system.file("images",
#'     "pg-wordmark.png",
#'     package = "plotgardener"
#' ))
#' 
#' gene_gnome <- readPNG(system.file("images",
#'     "pg-gnome-hole-shadow.png",
#'     package = "plotgardener"
#' ))
#' 
#' rlogo <- readPNG(system.file("images", "Rlogo.png", 
#'                 package = "plotgardener"))
#'
#' ## Create page
#' pageCreate(width = 5, height = 6)
#'
#' ## Plot images
#' plotRaster(
#'     image = pg_type,
#'     x = 2.5, y = 0.25, width = 4, height = 1.5,
#'     just = "top"
#' )
#' 
#' plotRaster(
#'     image = gene_gnome,
#'     x = 2.5, y = 2.25, width = 3.5, height = 3.5,
#'     just = "top"
#' )
#' 
#' plotRaster(
#'     image = rlogo,
#'     x = 1, y = 1.5, width = 0.5, height = 0.45,
#'     just = c("left", "top")
#' )
#'
#' ## Hide page guies
#' pageGuideHide()
#' @seealso \link[grid]{grid.raster}
#'
#' @export
plotRaster <- function(image, x, y, width, height, just = "center",
                        default.units = "inches", interpolate = TRUE,
                        params = NULL, ...) {


    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    rastInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "rastInternal"
    )

    ## Set gp
    rastInternal$gp <- setGP(
        gpList = gpar(),
        params = rastInternal, ...
    )
    
    ## Justification
    rastInternal$just <- justConversion(just = rastInternal$just)

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    rast <- structure(list(
        image = rastInternal$image,
        x = rastInternal$x, y = rastInternal$y,
        width = rastInternal$width,
        height = rastInternal$height,
        just = rastInternal$just,
        interpolate = rastInternal$interpolate,
        grobs = NULL,
        gp = rastInternal$gp
    ), class = "raster")

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_page(error = "Cannot plot raster without a plotgardener page.")
    if (is.null(rast$image)) stop("argument \"image\" is ",
                                    "missing, with no default.", call. = FALSE)
    if (is.null(rast$x)) {
        stop("argument \"x\" is missing, with no default.",
            call. = FALSE
        )
    }
    if (is.null(rast$y)) {
        stop("argument \"y\" is missing, with no default.",
            call. = FALSE
        )
    }
    if (is.null(rast$width)) stop("argument \"width\" is missing, ",
                                    "with no default.", call. = FALSE)
    if (is.null(rast$height)) stop("argument \"height\" is missing, ",
                                    "with no default.", call. = FALSE)


    # =========================================================================
    # DEFINE PARAMETERS
    # =========================================================================

    ## Get page_height and its units from pgEnv
    page_height <- get("page_height", envir = pgEnv)
    page_units <- get("page_units", envir = pgEnv)
    
    rast <- defaultUnits(
        object = rast,
        default.units = rastInternal$default.units
    )
    
    ## Convert coordinates to page_units
    new_x <- convertX(rast$x, unitTo = page_units, valueOnly = TRUE)
    new_y <- convertY(rast$y, unitTo = page_units, valueOnly = TRUE)
    new_width <- convertWidth(rast$width,
        unitTo = page_units, valueOnly = TRUE
    )
    new_height <- convertHeight(rast$height,
        unitTo = page_units, valueOnly = TRUE
    )

    # =========================================================================
    # MAKE GROB
    # =========================================================================
    name <- paste0(
        "raster",
        length(grep(
            pattern = "raster",
            x = grid.ls(
                print = FALSE,
                recursive = FALSE
            )
        )) + 1
    )
    rast <- grid.raster(
        image = rast$image, x = unit(new_x, page_units),
        y = unit(page_height - new_y, page_units),
        width = unit(new_width, page_units),
        height = unit(new_height, page_units),
        just = rast$just,
        interpolate = rast$interpolate,
        gp = rast$gp
    )

    # =========================================================================
    # ADD GROB TO OBJECT
    # =========================================================================

    rast$grobs <- rast

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("raster[", name, "]")
    invisible(rast)
}

#' Display the default genomic annotation packages associated with a
#' genome build
#'
#' @param Genome String indicating the name of the genome assembly.
#'
#' @return Returns a list of the default data packages for a genome build.
#'
#' @examples
#' ## View default genomic annotation packages associated with "hg19"
#' defaultPackages(Genome = "hg19")
#'
#' ## View default genomic annotation packages associated with "mm9"
#' defaultPackages(Genome = "mm9")
#' @export
defaultPackages <- function(Genome) {

    availDefaults <- default_genomePackages$Genome

    if (!Genome %in% availDefaults) {
        stop("Inputted genome not an available default. To see the included ",
            "defaults, use `genomes()`.", call. = FALSE)
    }

    defaults <- default_genomePackages[
        default_genomePackages$Genome == Genome,c("Genome",
                                                "TxDb", 
                                                "OrgDb",
                                                "gene.id.column",
                                                "display.column",
                                                "BSgenome")]
    
    return(str(defaults))
}

#' Maps a numeric or character vector to a color palette and returns
#' the vector of colors
#' @param vector Vector to map to color.
#' @param palette Color palette function.
#' @param range Range of values to map for a numerical value.
#' 
#' @examples 
#' ## Load paired ranges data in BEDPE format
#' library(plotgardenerData)
#' data("IMR90_DNAloops_pairs")
#' 
#' ## Add a length column
#' IMR90_DNAloops_pairs$length <- (IMR90_DNAloops_pairs$start2 - 
#'         IMR90_DNAloops_pairs$start1) / 1000
#' 
#' ## Map length column to a vector of colors
#' colors <- mapColors(vector = IMR90_DNAloops_pairs$length,
#'             palette = colorRampPalette(c("dodgerblue2", "firebrick2")))
#'             
#' ## Pass color vector into bbPlotPairsArches
#' heights <- IMR90_DNAloops_pairs$length / max(IMR90_DNAloops_pairs$length)    
#' pageCreate(width = 7.5, height = 2.1, default.units = "inches",
#'             showGuides = FALSE, xgrid = 0, ygrid = 0)       
#' params <- pgParams(
#'     chrom = "chr21",
#'     chromstart = 27900000, chromend = 30700000,
#'     assembly = "hg19",
#'     width = 7
#' )
#' 
#' archPlot <- plotPairsArches(
#'     data = IMR90_DNAloops_pairs, params = params,
#'     fill = colors,
#'     linecolor = "fill",
#'     archHeight = heights, alpha = 1,
#'     x = 0.25, y = 0.25, height = 1.5,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )            
#' 
#' annoGenomeLabel(plot = archPlot, x = 0.25, y = 1.78, scale = "Mb") 
#' annoHeatmapLegend(
#'     plot = archPlot, fontcolor = "black",
#'     x = 7.0, y = 0.25,
#'     width = 0.10, height = 1, fontsize = 10
#' )
#' plotText(
#'     label = "Kb", rot = 90, x = 6.9, y = 0.75,
#'     just = c("center", "center"),
#'     fontsize = 10
#' )
#' 
#' @details 
#' This function allows for the manual mapping of a numerical or factor
#' vector to a palette of colors. For a more automatic implementation 
#' of this functionality in plotgardener functions,  
#' \link[plotgardener]{colorby} objects can be used.
#' 
#' @return 
#' Returns a character vector of color values. If the input vector is 
#' numerical, this vector will have additional `palette` and `range`
#' attributes.
#' 
#' @seealso \link[plotgardener]{colorby}
#' 
#' @export
mapColors <- function(vector, palette, range = NULL){
    
    ## Define a function to catch errors
    error_mapColors <- function(vector, palette, range){
        
        ## palette errors
        if (!is(palette, "function")){
            stop("Please provide a palette function.", call. = FALSE)
        }
        
        ## range errors
        rangeErrors(range = range)
        
        # Numerical vector for breaks if no range is provided
        if (is(vector, "numeric") | is(vector, "integer")){
            if (length(unique(vector)) == 1){
                
                if (is.null(range)){
                    warning("Not enough numerical values to map ",
                            "to colors without a range.", call. = FALSE)
                    vector <- NULL
                }
                
            }
        }
        
        return(vector)
        
    }
    
    ## Catch errors and update to NULL vector if necessary
    vector <- error_mapColors(vector = vector,
                            palette = palette,
                            range = range)
    
    if (is(vector, "numeric") | is(vector, "integer")){
        
        ## Update range, if necessary
        if (is.null(range)){
            breaks <- seq(min(vector), max(vector), length.out = 100)
            range <- c(min(vector), max(vector))
        } else {
            vector[which(vector < range[1])] <- range[1]
            vector[which(vector > range[2])] <- range[2]
            breaks <- seq(range[1], range[2], length.out = 100)
        }

        ## Map numbers to colors    
        colors <- palette(length(breaks) + 1)    
        colorVector <- as.character(cut(vector, c(-Inf, breaks, Inf), 
                                        labels = colors))
        attr(colorVector, "range") <- range
        
    } else {
        
        ## Convert if not a factor
        if (!is(vector, "factor")){
            vector <- as.factor(vector)
        }
        
        ## Map color palette to factor levels
        colors <- palette(length(levels(vector)))
        names(colors) <- levels(vector)
        colorVector <- colors[vector]
        
    } 
    attr(colorVector, "palette") <- palette
    return(colorVector)
    
}

## Color palette and range default assignments for mapColors
## Returns an updated object with the color palette and range
colorDefaults <- function(vector, palette = NULL, range = NULL, object){
    if (is(vector, "numeric") | is(vector, "integer")){
        
        if (is.null(palette)){
            palette <- colorRampPalette(brewer.pal(
                n = 9, "YlGnBu"
            ))
        }
        
        if (is.null(range)){
            
            range <- c(min(vector), max(vector))
            
            ## Switch back to NULL if invalid range
            if (range[1] >= range[2]){
                range <- NULL
            } 
            
        }
        
        object$zrange <- range
        
    } else {
        
        ## Convert if not a factor
        if (!is(vector, "factor")){
            vector <- as.factor(vector)
        }
        
        if (is.null(palette)){
            palette <- colorRampPalette(suppressWarnings(
                brewer.pal(n = length(levels(vector)),
                        "Paired")))
        }
        
    }
    
    object$color_palette <- palette
    
    return(object)
}

## Define a function that will parse a vector of colors vs. a colorby object
## Returns the final vector of colors and an updated plot object
# @param data Associated data, for finding `colorby` column
# @param fill Input fill - will either be a single value, a vector, or 
# a colorby object
# @param object The plot object, to be updated with any color_palette
# and zrange information
# @param subset A string describing the type of data, which will determine
# how to subset it. Options are ranges, pairs, pairs_clip, or manhattan.
parseColors <- function(data, fill, object, subset = NULL){
    
    ## `colorby` class
    if (is(fill, "colorby")){

        colorbyCol <- data[, fill$column]
        
        ## Scale numeric colorby data by the subsetted plotted region
        if ((is(colorbyCol, "numeric") | is(colorbyCol, "integer")) 
                & is.null(object$zrange)){
            
            if (fill$scalePerRegion == TRUE){
                if (subset == "ranges"){
                    subData <- data[which(data[,"chrom"] == object$chrom &
                                    data[,"start"] <= object$chromend &
                                    data[,"end"] >= object$chromstart),]
                    
                } else if (subset == "pairs"){
                    subData <- data[which(data[, "chrom1"] == object$chrom &
                                            data[, "chrom2"] == object$chrom),]
                    overlappingRanges <- 
                        as.data.frame(subsetByOverlaps(ranges = 
                                IRanges(start = object$chromstart, 
                                        end = object$chromend),
                                x = IRanges(start = subData[,"start1"], 
                                            end = subData[,"end2"])))
                    subData <- subData[which(subData[,"start1"] %in% 
                                                overlappingRanges$start &
                                            subData[,"end2"] %in% 
                                                overlappingRanges$end),]
                } else if (subset == "pairs_clip"){
                    subData <- data[which(data[,"chrom1"] == object$chrom &
                                data[,"chrom2"] == object$chrom &
                                data[,"start1"] >= object$chromstart &
                                data[,"end1"] <= object$chromend &
                                data[,"start2"] >= object$chromstart &
                                data[,"end2"] <= object$chromend),]
                    
                } else if (subset == "pairs_noachor"){
                    subData <- data[which(data[,"chrom1"] == object$chrom &
                                        data[,"chrom2"] == object$chrom &
                                        ((data[,"start1"] >= object$chromstart &
                                        data[,"start1"] <= object$chromend) |
                                        (data[,"end2"] >= object$chromstart &
                                        data[,"end2"] <= object$chromend))), ]
                } else if (subset == "manhattan"){
                    subData <- data[which(data[,"chrom"] == object$chrom &
                                            data[,"pos"] >= object$chromstart &
                                            data[,"pos"] <= object$chromend),]
                } else {
                    subData <- data
                }
                
                range <- range(subData[,fill$column])
                if (range[1] >= range[2]){
                    range <- NULL
                }
                
                fill$range <- range
            }
            
        }
        
        ## Default palette and range
        object <- colorDefaults(vector = colorbyCol,
                                palette = fill$palette,
                                range = fill$range,
                                object = object)
        
        ## Pass into mapColors
        colors <- mapColors(vector = colorbyCol,
                            palette = object$color_palette,
                            range = object$zrange)
    } else {
        
        if (length(fill) == 1){
            colors <- as.character(rep(fill, nrow(data)))
        } else {
            colors <- as.character(rep(fill,
                        ceiling(nrow(data) / length(fill))
            )[seq(1, nrow(data))])
        }
        
        if (!is.null(attributes(fill))){
            object$color_palette <- attr(fill, "palette")
            object$zrange <- attr(fill, "range")
        }
        
    }
    
    return(list(colors, object))
    
}

## Define a function that will parse the objects for linecolors and 
## return a vector of linecolors
# @param linecolor The linecolor parameter value
# @param fillcolors The mapped vector of fillcolors, for use if 
# linecolor == "fill"
# @param data Associated data, for finding `colorby` column
# @param object The plot object
# @param subset A string describing the type of data, which will determine
# how to subset it. Options are ranges, pairs, or pairs_clip.
lineColors <- function(linecolor, fillcolors, data, object, subset = NULL){
    
    if (is.null(linecolor)){
        linecolor <- NA
    }
    
    if (!all(is.na(linecolor))){
        if (all(linecolor == "fill")){
            linecolors <- fillcolors
        } else {
            linecolors <- parseColors(data = data,
                                        fill = linecolor,
                                        object = object,
                                        subset = subset)[[1]]
        }
    } else {
        linecolors <- NA
    }
    
    return(linecolors)
    
}

## Define a function that makes a color transparent
# @param color color string
# @param alpha Alpha value of color
makeTransparent <- function(color, alpha) {
    if (is.null(alpha)) {
        alpha <- 1
    }

    rgb <- grDevices::col2rgb(color)
    transp <- rgb(rgb[1], rgb[2], rgb[3],
        alpha = alpha * 255,
        maxColorValue = 255
    )
    return(transp)
}

test_that("colorby object created", {
    object1 <- colorby(column = "foo")
    object2 <- colorby(column = "foo", range = c(0, 1))

    expect_equal(class(object1), "colorby")
    expect_equal(class(object2), "colorby")
})

test_that("mapped colors", {
    ## Numeric vector color mappings
    numVector <- c(1, 2, 3, 2, 1)
    colorVector <- mapColors(vector = numVector,
                palette = colorRampPalette(c("blue", "red", "black")),
                range = NULL)
    expect_setequal(colorVector, c("#0000FF", "#FF0000", "#050000", "#FF0000", 
                                "#0000FF"))
    colorVector <- mapColors(vector = numVector,
                                palette = colorRampPalette(c("blue", "red", "black")),
                                range = c(1, 2))
    
    expect_setequal(colorVector, c("#0000FF", "#050000", "#050000", 
                                   "#050000", "#0000FF"))
    
    
    ## Factor vector where levels are defaulted to: cat, dog, pig
    factVector <- factor(c("dog", "cat", "pig", "cat"))
    ## cat mapped to blue, dog mapped to red, pig mapped to black
    colorVector <- mapColors(vector = factVector,
                                palette = colorRampPalette(c("blue", "red", "black")))
    expect_mapequal(colorVector[levels(factVector)], c("dog" = "#FF0000", "cat" = "#0000FF",
                                      "pig" = "#000000"))
    
    ## Factor vector where levels are: dog, cat, pig
    factVector <- factor(c("dog", "cat", "pig", "cat"))
    levels(factVector) <- c("dog", "cat", "pig")
    ## dog mapped to blue, cat mapped to red, pig mapped to black
    colorVector <- mapColors(vector = factVector,
                                palette = colorRampPalette(c("blue", "red", "black")))
    expect_mapequal(colorVector[levels(factVector)],
                    c("dog" = "#0000FF", "cat" = "#FF0000", "pig" = "#000000"))
    
    
    ## Subset of factor vector with four levels, but only three values present
    factVector <- factor(c("dog", "cat", "pig", "cat", "giraffe"))
    factVector <- factVector[1:4]
    # levels are cat, dog, giraffe, pig
    ## cat mapped to blue, dog mapped to red, giraffe mapped to black, pig mapped to yellow
    colorVector <- mapColors(vector = factVector,
                                palette = colorRampPalette(c("blue", "red", "black", "yellow")))
    expect_mapequal(colorVector[c("dog", "cat", "pig")],
                    c("cat" = "#0000FF", "dog" = "#FF0000", "pig" = "#FFFF00"))
    
    ## Non-numeric, non-factor vector
    nonnumVector <- c("dog", "cat", "pig", "pig")
    # cat mapped to blue, dog mapped to red, pig mapped to black
    colorVector <- mapColors(vector = nonnumVector,
                                palette = colorRampPalette(c("blue", "red", "black")))
    expect_mapequal(colorVector[c("dog", "cat", "pig")],
                    c("cat" = "#0000FF", "dog" = "#FF0000", "pig" = "#000000"))
    
})

## Define a function that checks formatting agreement between given chrom
## and the chromosome in provided data 
# @param data Input data
# @param chrom Input chrom
# @param Type of data, either "ranges" or "pairs"
chromDataAgreement <- function(data, chrom, type){
    chrom_chrCheck <- grepl("chr", chrom)
    if (type == "ranges"){
        ## Just check first column 
        data_chrCheck <- all(grepl("chr", data[,"chrom"]))
    } else if (type == "pairs"){
        ## Check chr1 and chr2 columns
        data_chrCheck <- all(grepl("chr", data[,"chrom1"])) &
            all(grepl("chr", data[,"chrom2"]))
    }
    
    
    if (chrom_chrCheck != data_chrCheck){
        warning("Format of chromosome in data does not match ",
                "format of `chrom`.", call. = FALSE)
    }
    
}

## Define a function that checks for whole chromosome data and
## sets the plot xscale accordingly
# @param object plot object
# @param objectInternal internal plot object
# @param plotType string of plot type to show up in error message
genomicScale <- function(object, objectInternal, plotType) {
    if (is.null(object$chromstart) & is.null(object$chromend)) {
        if (is(object$assembly$TxDb, "TxDb")) {
            txdbChecks <- TRUE
        } else {
            
            if (!requireNamespace(object$assembly$TxDb, quietly = TRUE)){
                txdbChecks <- FALSE
                warning("`", object$assembly$TxDb, "` not available. Please",
                        " load to generate ", plotType, ".", call. = FALSE)
            } else {
                txdbChecks <- TRUE
            }
            
        }
        objectInternal$xscale <- c(0, 1)
        if (txdbChecks == TRUE) {
            if (is(object$assembly$TxDb, "TxDb")) {
                tx_db <- object$assembly$TxDb
            } else {
                tx_db <- eval(parse(text = paste0(as.name(object$assembly$TxDb),
                                            "::",
                                            as.name(object$assembly$TxDb))))
            }
            assembly_data <- GenomeInfoDb::seqlengths(tx_db)
            if (!object$chrom %in% names(assembly_data)) {
                warning("Chromosome ",
                        "'", object$chrom, "' ",
                        "not found in ",
                        "`", tx_db$packageName, "`",
                        " and data for entire chromosome cannot be plotted.",
                        call. = FALSE
                )
            } else {
                object$chromstart <- 1
                object$chromend <- assembly_data[[object$chrom]]
                if (class(object) %in% c("hicTriangle", "hicRectangle")) {
                    object$altchromstart <- 1
                    object$altchromend <- assembly_data[[object$chrom]]
                }
                objectInternal$xscale <- c(object$chromstart, object$chromend)
            }    
            
        }

    } else {
        txdbChecks <- TRUE
        objectInternal$xscale <- c(object$chromstart, object$chromend)
    }

    objectInternal$txdbChecks <- txdbChecks

    return(list(object, objectInternal))
}

## Define a function that checks for and gets gene/transcript data
# @param object plot object
# @param objectInternal internal plot object
geneData <- function(object, objectInternal) {

    ## TxDb
    if (is(object$assembly$TxDb, "TxDb")) {
        txdbChecks <- TRUE
    } else {
        
        if (!requireNamespace(object$assembly$TxDb, quietly = TRUE)){
            txdbChecks <- FALSE
            warning("`", object$assembly$TxDb, "` not available. Please",
                    " load to plot genes or transcripts.", call. = FALSE)
        } else {
            txdbChecks <- TRUE
        }
        
    }

    ## Check for matching `gene.id.column` and `display.column` to determine
    ## need for orgDb
    
    if (object$assembly$gene.id.column != object$assembly$display.column){

        ## Custom OrgDb
        if (is(object$assembly$OrgDb, "OrgDb")){
            orgdbChecks <- TRUE
        } else {
            if (!requireNamespace(object$assembly$OrgDb, quietly = TRUE)){
                orgdbChecks <- FALSE
                warning("`", object$assembly$OrgDb, "` not available. Please load",
                        " to plot genes or transcripts.", call. = FALSE)
            } else {
                orgdbChecks <- TRUE
            }
            
        }
        
    } else {
        orgdbChecks <- TRUE
    }
    

    ## Data
    data <- data.frame(matrix(ncol = 22, nrow = 0))
    xscale <- c(0, 1)

    if (txdbChecks == TRUE && orgdbChecks == TRUE) {

        ## Load txdb
        if (is(object$assembly$TxDb, "TxDb")) {
            tx_db <- object$assembly$TxDb
        } else {
            tx_db <- eval(parse(text = paste0(as.name(object$assembly$TxDb),
                                            "::",
                                            as.name(object$assembly$TxDb))))
        }

        genome <- GenomeInfoDb::seqlengths(tx_db)

        if (object$assembly$gene.id.column ==
            object$assembly$display.column) {
            objectInternal$displayCol <- "GENEID"
        } else {
            objectInternal$displayCol <- object$assembly$display.column
        }

        if (!object$chrom %in% names(genome)) {
            warning("Chromosome ", "'", object$chrom, "'",
                "not found in ", "`", tx_db$packageName, "`",
                " and data for entire chromosome cannot be plotted.",
                call. = FALSE
            )
        } else {
            if (is.null(object$chromstart) & is.null(object$chromend)) {
                object$chromstart <- 1
                object$chromend <- genome[[object$chrom]]
            }

            data <- getExons(
                assembly = object$assembly,
                chromosome = object$chrom,
                start = object$chromstart,
                stop = object$chromend
            )
            xscale <- c(object$chromstart, object$chromend)
        }
    }

    objectInternal$xscale <- xscale
    objectInternal$data <- data
    
    return(list(object, objectInternal))
}

## Define a function that will by default prioritize genes by citations
# (if available) or gene lengths
# @param data data frame of gene or transcript data
# @param assembly assembly associated with gene data
# @param transcript a logical indicating whether or not we're
# plotting transcripts or not
defaultGenePriorities <- function(data, assembly, transcript = FALSE, 
                                geneHighlights = NULL, displayCol = "SYMBOL") {

    availCitations <- default_genomePackages[
        !is.na(default_genomePackages$Citations),]$Genome

    ## Define assemblies whose TxDb IDs will need to be converted to
    ## ENTREZID from a different ID
    convertIDs <- list(
        dm3 = "ENSEMBL", dm6 = "ENSEMBL",
        rn4 = "ENSEMBL", sacCer2 = "ORF",
        sacCer3 = "ORF"
    )

    assemblyName <- assembly$Genome
    ## If assembly is included in package, access citations
    if (any(availCitations %in% assemblyName)) {
        
        name <- default_genomePackages[
            default_genomePackages$Genome %in% assemblyName,]$Genome
        
        ## Convert necessary builds to ENTREZID
        if (name %in% names(convertIDs)) {

            ## Load associated OrgDb
            org_db <- eval(parse(text = paste0(as.name(assembly$OrgDb),
                                            "::",
                                            as.name(assembly$OrgDb))))

            ## Convert gene ids in data to ENTREZID based on previous keytype
            entrezIDs <- suppressMessages(
                AnnotationDbi::select(org_db,
                    keys = data$GENEID,
                    columns = "ENTREZID",
                    keytype = convertIDs[[name]]
                )
            )
            data$ENTREZID <- entrezIDs$ENTREZID
        } else {
            data$ENTREZID <- data$GENEID
        }

        ## Get internal citation data and match based on ENTREZID
        citationData <- default_genomePackages[
            default_genomePackages$Genome == name,]$Citations
        citationData <- eval(parse(text = citationData))
        updatedData <- suppressMessages(dplyr::left_join(
            x = data,
            y = citationData,
            by = "ENTREZID"
        ))

        ## Set any missing citations to 0
        updatedData[is.na(updatedData$Citations), ]$Citations <-
            rep(0, nrow(updatedData[is.na(updatedData$Citations), ]))

        if (transcript == TRUE) {
            updatedData <-
                updatedData[duplicated(updatedData$TXNAME) == FALSE, ]
        }


        ## Order based on citation number
        updatedData <- updatedData[order(updatedData$Citations,
            decreasing = TRUE
        ), ]
    } else {

        ## With no internal citation data, set default priority
        ## based on gene/transcript length
        updatedData <- data[order(data$length, decreasing = TRUE), ]
    }

    ## Put any gene/transcript highlights at the top of the priority
    
    if (!is.null(geneHighlights)){
        if (transcript == FALSE){
            updatedData <- updatedData[c(which(updatedData[[displayCol]] 
                                               %in% geneHighlights), 
                                         which(!updatedData[[displayCol]] 
                                               %in% geneHighlights)),]
        } else {
            updatedData <- updatedData[c(which(updatedData[, "TXNAME"] 
                                               %in% geneHighlights), 
                                         which(!updatedData[, "TXNAME"] 
                                               %in% geneHighlights)),]
        }
            
    }
    
    ## Return data with priorities
    return(updatedData)
}

## Define a function that determines the chromosome offsets for a plot
## with multiple chromosomes (manhattan plots)
# @param assemblyData data.frame of an assembly's chromosomes and lengths
# @param space the space between each chrom as a fraction of plot width
spaceChroms <- function(assemblyData, space) {

    ## Determine the offset for each chromsome
    cumsums <- cumsum(as.numeric(assemblyData[, "length"]))
    spacer <- cumsums[length(cumsums)] * space
    additionalSpace <- (seq(1, length(cumsums) - 0)) * spacer

    ## Start position
    startPos <- c(0, cumsums[seq(1, length(cumsums) - 1)])
    startPos <- startPos + additionalSpace
    assemblyData[, "start"] <- startPos

    ## Stop Position
    stopPos <- cumsums + (seq(1, (length(cumsums)))) * spacer
    assemblyData[, "end"] <- stopPos

    return(assemblyData)
}

test_that("chromDataAgreement", {
    library(plotgardenerData)
    ## Ranges
    data("IMR90_ChIP_CTCF_reads")
    ## match
    expect_silent(plotgardener:::chromDataAgreement(data = IMR90_ChIP_CTCF_reads,
                                                chrom = "chr21",
                                                type = "ranges"))
    ## don't match
    expect_warning(plotgardener:::chromDataAgreement(data = IMR90_ChIP_CTCF_reads,
                                                chrom = "21",
                                                type = "ranges"))
    ## Pairs
    data("IMR90_DNAloops_pairs")
    ## match
    expect_silent(plotgardener:::chromDataAgreement(data = IMR90_DNAloops_pairs,
                                                chrom = "chr21",
                                                type = "pairs"))
    ## don't match
    expect_warning(plotgardener:::chromDataAgreement(data = IMR90_DNAloops_pairs,
                                                chrom = "21",
                                                type = "pairs"))
})

test_that("genomicScale", {
    
    ## Has TxDb and full chromosome xscale
    library("TxDb.Hsapiens.UCSC.hg19.knownGene")
    testObject <- list("chrom" = "chr1",
                    "chromstart" = NULL,
                    "chromend" = NULL,
                    "assembly" = plotgardener:::parseAssembly("hg19"))
    testObjectInternal <- list()
    scale <- plotgardener:::genomicScale(object = testObject,
                                     objectInternal = testObjectInternal,
                                     plotType = "genes")[[2]]$xscale
    expect_equal(scale, c(1, 249250621))
    
    ## Throws wrong chromosome warning
    testObject <- list("chrom" = "chrHello",
                       "chromstart" = NULL,
                       "chromend" = NULL,
                       "assembly" = plotgardener:::parseAssembly("hg19"))
    expect_warning(plotgardener:::genomicScale(object = testObject,
                                           objectInternal = testObjectInternal,
                                           plotType = "genes"))
    scale2 <- suppressWarnings(plotgardener:::genomicScale(object = testObject,
                                        objectInternal = testObjectInternal,
                                        plotType = "genes"))[[2]]$xscale
    expect_equal(scale2, c(0, 1))
})

test_that("geneData", {
    
    ## TxDb and OrgDb gets data
    library("TxDb.Hsapiens.UCSC.hg19.knownGene")
    library("org.Hs.eg.db")
    testObject <- list("chrom" = "chr1",
                        "assembly" = plotgardener:::parseAssembly("hg19"))
    testObjectInternal <- list()
    
    expect_silent(plotgardener:::geneData(object = testObject,
                                      objectInternal = testObjectInternal))
})

#' plotgardener: Coordinate-based Genomic Visualization Package for R
#'
#' plotgardener is a coordinate-based genomic visualization package for R.
#' It grants users the ability to programmatically produce complex,
#' multi-paneled figures. Tailored for genomics, plotgardener allows users
#' to visualize large complex genomic datasets and
#' provides exquisite control over how plots are placed and arranged on
#' a page.
#' 
#' @author 
#' \strong{Maintainer}: Nicole Kramer \email{nekramer@live.unc.edu}
#' (\href{https://orcid.org/0000-0001-9617-9671}{ORCID})
#' 
#' Authors:
#' \itemize{
#'     \item Eric S. Davis \email{esdavis@live.unc.edu}
#'     (\href{https://orcid.org/0000-0003-4051-3217}{ORCID})
#'     \item Craig Wenger \email{craig.wenger@gmail.com}
#'     (\href{https://orcid.org/0000-0002-7361-8456}{ORCID})
#'     \item Douglas H. Phanstiel \email{douglas_phanstiel@med.unc.edu}
#'     [copyright holder]
#' }
#' 
#' Other contributors:
#' \itemize{
#'     \item Sarah Parker \email{sarmae@live.unc.edu} [contributor]
#'     \item Erika Deoudes \email{ed@erikadudes.com} [artist]
#'     \item Michael Love \email{milove@email.unc.edu} [contributor]
#' }
#' 
#' @seealso 
#' Useful links:
#' \itemize{
#'     \item \url{https://phanstiellab.github.io/plotgardener}
#'     \item \url{https://github.com/PhanstielLab/plotgardener}
#' }
#' @docType package
#' @name plotgardener
#' @useDynLib plotgardener
#' @importFrom grDevices colorRampPalette
#' @importFrom grDevices dev.size
#' @importFrom curl has_internet
#' @importFrom methods hasArg
#' @importFrom methods is
#' @importFrom stats na.omit
#' @importFrom utils str
#' @importFrom Rcpp sourceCpp
#' @importFrom data.table fread
#' @importFrom data.table setDT
#' @importFrom ggplotify as.grob
#' @importFrom ggplotify base2grob
#' @importFrom RColorBrewer brewer.pal
#' @importFrom tools file_ext
#' @importFrom dplyr anti_join
#' @importFrom dplyr left_join
#' @importFrom dplyr inner_join
#' @importFrom dplyr bind_rows
#' @importFrom dplyr select
#' @importFrom dplyr group_by
#' @importFrom purrr map
#' @importFrom purrr pmap
#' @import grid
#' @importFrom strawr straw
#' @importFrom strawr readHicBpResolutions
#' @importFrom IRanges IRanges
#' @importFrom IRanges subsetByOverlaps
#' @importFrom withr with_pdf
#' @importFrom GenomeInfoDb keepStandardChromosomes
#' @importFrom GenomicRanges makeGRangesFromDataFrame
"_PACKAGE"

#' pgParams: plotgardener parameters object
#'
#' Creates an object of class "pgParams" that can be used by
#' plotgardener functions. pgParams can be used to set a set of parameters
#' to be shared across multiple functions.
#'
#' pgParams generates arguments from exported plotgardener functions at
#' loading time of the package. Arguments defined in a pgParams object
#' can be passed into the \code{params} argument of plotgardener functions.
#' params arguments can be overridden from within plotgardener functions.
#'
#' pgParams also provides an alternative region definition mechanism.
#' Given a gene name and genome assembly, pgParams returns the appropriate
#' "chrom", "chromstart", and "chromend" with a default buffer of
#' \code{(gene length) / 2} added to the ends of the gene coordinates.
#' The buffer amount can be set manually with the \code{geneBuffer}
#' parameter. Buffer extending beyond the length of the chromosome
#' will be trimmed.
#'
#' @param gene (optional) String naming a gene used to set the
#' chrom, chromstart, and chromend arguments.
#'
#' @param geneBuffer (optional) Integer base-pairs to extend the
#' start and end of a gene defined by argument \code{gene}.
#' Can be one integer or a vector of length 2, where the first integer
#' will extend the start of the gene and the second integer
#' will extend the end of the gene.
#'
#' @param assembly String defining the genome build.
#' Default value is \code{assembly = "hg38"}.
#' 
#'
#' @param ... This function will take any plotgardener function
#' parameters and their values:
#' \itemize{
#' \item{\code{alpha}}
#' \item{\code{altchrom}}
#' \item{\code{altchromend}}
#' \item{\code{altchromstart}}
#' \item{\code{archHeight}}
#' \item{\code{arrow}}
#' \item{\code{at}}
#' \item{\code{axis}}
#' \item{\code{axisLine}}
#' \item{\code{baseline}}
#' \item{\code{baseline.color}}
#' \item{\code{baseline.lwd}}
#' \item{\code{bg}}
#' \item{\code{binCap}}
#' \item{\code{binSize}}
#' \item{\code{border}}
#' \item{\code{boxHeight}}
#' \item{\code{boxWidth}}
#' \item{\code{breaks}}
#' \item{\code{BSgenome}}
#' \item{\code{cex}}
#' \item{\code{check.overlap}}
#' \item{\code{chrom}}
#' \item{\code{chromend}}
#' \item{\code{chromstart}}
#' \item{\code{clip}}
#' \item{\code{collapse}}
#' \item{\code{colorbyStrand}}
#' \item{\code{colorTrans}}
#' \item{\code{column}}
#' \item{\code{commas}}
#' \item{\code{curvature}}
#' \item{\code{data}}
#' \item{\code{default.units}}
#' \item{\code{digits}}
#' \item{\code{display.column}}
#' \item{\code{draw}}
#' \item{\code{extend}}
#' \item{\code{file}}
#' \item{\code{fill}}
#' \item{\code{flip}}
#' \item{\code{fontcolor}}
#' \item{\code{fontsize}}
#' \item{\code{geneBackground}}
#' \item{\code{geneHighlights}}
#' \item{\code{gene.id.column}}
#' \item{\code{geneOrder}}
#' \item{\code{Genome}}
#' \item{\code{half}}
#' \item{\code{height}}
#' \item{\code{id}}
#' \item{\code{id.lengths}}
#' \item{\code{image}}
#' \item{\code{interpolate}}
#' \item{\code{just}}
#' \item{\code{label}}
#' \item{\code{labels}}
#' \item{\code{leadSNP}}
#' \item{\code{legend}}
#' \item{\code{length}}
#' \item{\code{limitLabel}}
#' \item{\code{linecolor}}
#' \item{\code{lineend}}
#' \item{\code{linejoin}}
#' \item{\code{lty}}
#' \item{\code{lwd}}
#' \item{\code{main}}
#' \item{\code{margin}}
#' \item{\code{matrix}}
#' \item{\code{negData}}
#' \item{\code{norm}}
#' \item{\code{OrgDb}}
#' \item{\code{orientation}}
#' \item{\code{palette}}
#' \item{\code{pch}}
#' \item{\code{plot}}
#' \item{\code{quiet}}
#' \item{\code{r}}
#' \item{\code{range}}
#' \item{\code{resolution}}
#' \item{\code{res_scale}}
#' \item{\code{rot}}
#' \item{\code{scale}}
#' \item{\code{scientific}}
#' \item{\code{scipen}}
#' \item{\code{sequence}}
#' \item{\code{shift}} 
#' \item{\code{showBands}}
#' \item{\code{showGuides}}
#' \item{\code{sigCol}}
#' \item{\code{sigLine}}
#' \item{\code{sigVal}}
#' \item{\code{spaceHeight}}
#' \item{\code{spaceWidth}}
#' \item{\code{strand}}
#' \item{\code{strandLabels}}
#' \item{\code{strandSplit}}
#' \item{\code{stroke}}
#' \item{\code{style}}
#' \item{\code{tcl}}
#' \item{\code{ticks}}
#' \item{\code{title}}
#' \item{\code{TxDb}}
#' \item{\code{type}}
#' \item{\code{width}}
#' \item{\code{x}}
#' \item{\code{xgrid}}
#' \item{\code{x0}}
#' \item{\code{x1}}
#' \item{\code{y}}
#' \item{\code{ygrid}}
#' \item{\code{ymax}}
#' \item{\code{y0}}
#' \item{\code{y1}}
#' \item{\code{zrange}}
#' }
#'
#' @return Returns an object of class \code{pgParams}
#' containing plotgardener function arguments.
#'
#' @examples
#' ## Load hg19 genomic annotation packages
#' library("TxDb.Hsapiens.UCSC.hg19.knownGene")
#' library("org.Hs.eg.db")
#'
#' ## Define parameters
#' p1 <- pgParams(gene = "IL1B", assembly = "hg19")
#'
#' ## Optionally add more parameters
#' p2 <- pgParams(fontsize = 10, assembly = "hg19")
#'
#' ## Combine parameters and pass them to a plotgardener function
#' plotGenes(params = c(p1, p2))
#' @export pgParams
#' @export c

## Define params function skeleton (defined onLoad in zzz.R)
pgParams <- function() {}

## Define concatenate method for pgParams objects within default concatenate
## method to use when
## any pgParams object is found

#' Combine multiple pgParams objects into a vector
#'
#' @param ... \link[plotgardener]{pgParams} objects to be concatenated.
#' @param recursive logical. If \code{recursive = TRUE}, the function
#' recursively descends through lists
#' (and pairlists) combining all their elements into a vector.
#'
#' @return \code{NULL} or an expression or a vector of an appropriate mode.
#' (With no arguments the value is \code{NULL}.)
#'
#' @examples
#' ## Define parameters
#' p1 <- pgParams(chrom = "chr1", assembly = "hg19")
#'
#' ## Define another set of parameters
#' p2 <- pgParams(fontsize = 10, assembly = "hg19")
#'
#' ## Combine parameters into one `pgParams` object
#' pTotal <- c(p1, p2)
"c" <- function(..., recursive = FALSE) {

    ## Check all classes of inputs to concatenate
    inputClasses <- unlist(lapply(list(...), class))
    ## If any are found to be `pgParams` objects, they will all be combined
    ## into one `pgParams` object
    if (any(inputClasses == "pgParams")) {
        if (!all(inputClasses == "pgParams")) {
            warning("Attempting to concatenate parameters not of ",
                    "class `pgParams` with `pgParams` objects. ",
                    "Coercing all parameters into a `pgParams` object.",
                call. = FALSE
            )
        }

        ## Combine arguments into a single list
        combArgs <- unlist(list(...), recursive = FALSE)
        ## Define allowed duplicates (i.e assembly="hg19")
        allowed <- c("assembly")

        ## Find duplicated argument names
        dupArgs <- combArgs[duplicated(names(combArgs))]

        ## Check for duplicate arguments that aren't allowed
        if (any(!names(dupArgs) %in% allowed)) {
            badDupArgs <- names(dupArgs)[!names(dupArgs) %in% allowed]
            message <- sprintf(
                "Parameter(s) %s are duplicated.",
                paste(shQuote(badDupArgs), collapse = ",")
            )
            stop(message, call. = FALSE)
        }

        ## Check that each allowed duplicate argument name has the same value
        for (a in allowed) {
            dups <- combArgs[names(combArgs) %in% a]
            if (length(unique(unlist(dups))) != 1) {
                stop(sQuote(a), "must be the same when combining ",
                    "params objects.", call. = FALSE)
            }
        }

        ## Return combined object
        return(structure(
            .Data = combArgs[!duplicated(names(combArgs))],
            class = "pgParams"
        ))
    } else {
        ## Otherwise we will just call the primitive concatenate function
        .Primitive("c")(...)
    }
}

## Plot a base R plot in a plotgardener layout
#
# @param plot Plot formula of base R plotting functions.
# @param x A numeric or unit object specifying plot x-location.
# @param y A numeric, unit object, or character containing a "b"
# combined with a numeric value specifying plot y-location.
# The character value will
# place the plot y relative to the bottom of the most recently plotted
# plot according to the units of the plotgardener page.
# @param width A numeric or unit object specifying plot width.
# @param height A numeric or unit object specifying plot height.
# @param just Justification of base plot relative to its (x, y) location.
# If there are two values, the first value specifies horizontal
# justification and the second value specifies vertical justification.
# Possible string values are: \code{"left"}, \code{"right"},
# \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
# Default value is \code{just = c("left", "top")}.
# @param default.units A string indicating the default units to use
# if \code{x}, \code{y}, \code{width}, or \code{height} are only given
# as numerics. Default value is \code{default.units = "inches"}.
# @param bg Character value indicating background color.
# Default value is \code{bg = NA}.
# @param params An optional \link[plotgardener]{pgParams} object
# containing relevant function parameters.
#
# @return Returns a \code{base} object containing
# relevant placement and \link[grid]{grob} information.
#
# @examples
# ## Define base R plot
# p <- ~ plot(1:10) + abline(v = 2)
#
# ## Create page
# pageCreate(width = 5, height = 4, default.units = "inches")
#
# ## Place base R plot in page
# plotBase(
#     plot = p,
#     x = 0.5, y = 0.5, width = 4, height = 3,
#     just = c("left", "top"), default.units = "inches"
# )
#
# ## Add title
# plotText(
#     label = "Base R Plot", fontsize = 14, fontface = "bold",
#     x = 2.75, y = 0.5
# )
#
# ## Remove page guides
# pageGuideHide()
plotBase <- function(plot, x, y, width, height, just = c("left", "top"),
                        default.units = "inches", bg = NA, params = NULL) {

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    baseInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "baseInternal"
    )
    
    ## Justification
    baseInternal$just <- justConversion(just = baseInternal$just)

    # =========================================================================
    # INITIALIZE PLOT OBJECT
    # =========================================================================

    base <- structure(list(
        x = baseInternal$x, y = baseInternal$y,
        width = baseInternal$width,
        height = baseInternal$height,
        just = baseInternal$just, grobs = NULL
    ),
    class = "base"
    )

    # =========================================================================
    # CALL ERRORS
    # =========================================================================

    if (is.null(baseInternal$plot)) {
        stop("argument \"plot\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(baseInternal$x)) {
        stop("argument \"x\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(baseInternal$y)) {
        stop("argument \"y\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(baseInternal$width)) {
        stop("argument \"width\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(baseInternal$height)) {
        stop("argument \"height\" is missing, with no default.",
            call. = FALSE
        )
    }

    check_page(error = "Must have a plotgardener page before
                adding a base R plot.")

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    base <- defaultUnits(
        object = base,
        default.units = baseInternal$default.units
    )

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## Convert coordinates into same units as page
    page_coords <- convert_page(object = base)

    ## Name viewport
    currentViewports <- current_viewports()
    vp_name <- paste0(
        "base",
        length(grep(
            pattern = "base",
            x = currentViewports
        )) + 1
    )
    addViewport(vp_name)

    ## Make viewport
    vp <- viewport(
        height = page_coords$height, width = page_coords$width,
        x = page_coords$x, y = page_coords$y,
        just = baseInternal$just, name = vp_name
    )

    # =========================================================================
    # CONVERT PLOT TO A GROB
    # =========================================================================

    gtree <- ggplotify::base2grob(baseInternal$plot)

    # =========================================================================
    # ASSIGN VIEWPORT TO GTREE
    # =========================================================================

    gtree$vp <- vp

    # =========================================================================
    # BACKGROUND AND BORDER
    # =========================================================================

    plotChildren <- gtree$childrenOrder
    backgroundGrob <- rectGrob(gp = gpar(
        fill = baseInternal$bg,
        col = NA
    ), name = "background")
    gtree <- addGrob(gTree = gtree, child = backgroundGrob)
    gtree$childrenOrder <- c("background", plotChildren)

    # =========================================================================
    # DRAW GTREE
    # =========================================================================

    grid.draw(gtree)

    # =========================================================================
    # ADD GTREE TO OBJECT
    # =========================================================================

    base$grobs <- gtree

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("base[", vp_name, "]")
    invisible(base)
}

#' Annotate genomic coordinates along the x or y-axis of a plot
#' 
#' @usage annoGenomeLabel(
#'     plot,
#'     fontsize = 10,
#'     fontcolor = "black",
#'     linecolor = "black",
#'     margin = unit(1, "mm"),
#'     scale = "bp",
#'     commas = TRUE,
#'     sequence = TRUE,
#'     boxWidth = 0.5,
#'     axis = "x",
#'     at = NULL,
#'     tcl = 0.5,
#'     x,
#'     y,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     params = NULL,
#'     ...
#' )
#'
#' @param plot Input plot to annotate genomic coordinates.
#' Genomic coordinates and assembly will be inherited from \code{plot}.
#' @param fontsize A numeric specifying text fontsize in points.
#' Default value is \code{fontsize = 10}.
#' @param fontcolor A character value indicating the color for text.
#' Default value is \code{fontcolor = "black"}.
#' @param linecolor A character value indicating the color of
#' the genome label axis. Default value is \code{linecolor = "black"}.
#' @param margin A numeric or unit vector specifying space between axis
#' and coordinate labels. Default value is \code{margin = unit(1, "mm")}.
#' @param scale A character value indicating the scale of the coordinates
#' along the genome label. Default value is \code{scale = "bp"}. Options are:
#' \itemize{
#' \item{\code{"bp"}: }{base pairs.}
#' \item{\code{"Kb"}: }{kilobase pairs. 1 kilobase pair is equal to
#' 1000 base pairs.}
#' \item{\code{"Mb"}: }{megabase pairs. 1 megabase pair is equal to
#' 1000000 base pairs.}
#' }
#' @param commas A logical value indicating whether to include commas in
#' start and stop labels. Default value is \code{commas = TRUE}.
#' @param sequence A logical value indicating whether to include sequence
#' information above the label of an x-axis (only at appropriate resolutions).
#' @param boxWidth A numeric value indicating the width of the boxes
#' representing sequence information at appropriate resolutions.
#' Default value is \code{boxWidth = 0.5}.
#' @param axis A character value indicating along which axis to
#' add genome label. Sequence information will not be displayed along a y-axis.
#' Default value is \code{axis = "x"}.
#' Options are:
#' \itemize{
#' \item{\code{"x"}: }{Genome label will be plotted along the x-axis.}
#' \item{\code{"y"}: }{Genome label will be plotted along the y-axis.
#' This is typically used for a square Hi-C plot made with
#' \code{plotHicSquare}.}
#' }
#' @param at A numeric vector of x-value locations for tick marks.
#' @param tcl A numeric specifying the length of tickmarks as a fraction of
#' text height. Default value is \code{tcl = 0.5}.
#' @param x A numeric or unit object specifying genome label x-location.
#' @param y A numeric, unit object, or character containing a "b" combined
#' with a numeric value specifying genome label y-location.
#' The character value will place the genome label y relative to the bottom
#' of the most recently plotted plot according to the units of the
#' plotgardener page.
#' @param just Justification of genome label relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal justification
#' and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"}, \code{"centre"},
#' \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use
#' if \code{x} or \code{y} are only given as numerics.
#' Default value is \code{default.units = "inches"}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param ... Additional grid graphical parameters or digit specifications.
#' See \link[grid]{gpar} and \link[base]{formatC}.
#'
#' @return Returns a \code{genomeLabel} object containing
#' relevant genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load hg19 genomic annotation packages
#' library("TxDb.Hsapiens.UCSC.hg19.knownGene")
#' library("org.Hs.eg.db")
#'
#' ## Create page
#' pageCreate(width = 5, height = 2, default.units = "inches")
#'
#' ## Plot and place gene track on page
#' genesPlot <- plotGenes(
#'     chrom = "chr8",
#'     chromstart = 1000000, chromend = 2000000,
#'     assembly = "hg19", fill = c("grey", "grey"),
#'     fontcolor = c("grey", "grey"),
#'     x = 0.5, y = 0.25, width = 4, height = 1,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Annotate x-axis genome labels at different scales
#' annoGenomeLabel(
#'     plot = genesPlot, scale = "Mb",
#'     x = 0.5, y = 1.25, just = c("left", "top"),
#'     default.units = "inches"
#' )
#' annoGenomeLabel(
#'     plot = genesPlot, scale = "Kb",
#'     x = 0.5, y = 1.5, just = c("left", "top"),
#'     default.units = "inches"
#' )
#' annoGenomeLabel(
#'     plot = genesPlot, scale = "bp",
#'     x = 0.5, y = 1.75, just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
annoGenomeLabel <- function(plot, fontsize = 10, fontcolor = "black",
                            linecolor = "black", margin = unit(1, "mm"),
                            scale = "bp", commas = TRUE, sequence = TRUE,
                            boxWidth = 0.5, axis = "x", at = NULL,
                            tcl = 0.5, x, y, just = c("left", "top"),
                            default.units = "inches", params = NULL, ...) {


    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================
    
    genomeLabelInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "genomeLabelInternal"
    )
    
    # =========================================================================
    # CATCH ARGUMENT/PLOT INPUT ERRORS
    # =========================================================================
    if (is.null(genomeLabelInternal$plot)) {
        stop("argument \"plot\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(genomeLabelInternal$x)) {
        stop("argument \"x\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(genomeLabelInternal$y)) {
        stop("argument \"y\" is missing, with no default.", call. = FALSE)
    }
    

    ## Check that input plot is a valid type of plot to be annotated
    if (!is(genomeLabelInternal$plot, "manhattan")) {

        ## Manhattan plots can do whole genome assembly but other plots can't
        inputNames <- attributes(genomeLabelInternal$plot)$names
        if (!("chrom" %in% inputNames) |
            !("chromstart" %in% inputNames) |
            !("chromend" %in% inputNames)) {
            stop("Invalid input plot. Please input a plot that has genomic ",
            "coordinates associated with it.", call. = FALSE)
        }
    }

    # =========================================================================
    # ASSIGN PARAMETERS BASED ON PLOT INPUT
    # =========================================================================

    chrom <- genomeLabelInternal$plot$chrom
    chromstart <- genomeLabelInternal$plot$chromstart
    chromend <- genomeLabelInternal$plot$chromend
    assembly <- genomeLabelInternal$plot$assembly
    x <- genomeLabelInternal$x
    y <- genomeLabelInternal$y
    length <- genomeLabelInternal$plot$width
    if (genomeLabelInternal$axis == "y") {
        length <- genomeLabelInternal$plot$height
        chrom <- genomeLabelInternal$plot$altchrom
        chromstart <- genomeLabelInternal$plot$grobs$vp$yscale[1]
        chromend <- genomeLabelInternal$plot$grobs$vp$yscale[2]
    }
    
    just <- justConversion(just = genomeLabelInternal$just)
    
    ## Whole genome Manhattan plot spacing
    space <- genomeLabelInternal$plot$space

    # =========================================================================
    # CALL PLOTGENOMELABEL
    # =========================================================================

    genomeLabel <- plotGenomeLabel(
        chrom = chrom, chromstart = chromstart,
        chromend = chromend, assembly = assembly,
        fontsize = genomeLabelInternal$fontsize,
        fontcolor = genomeLabelInternal$fontcolor,
        linecolor = genomeLabelInternal$linecolor,
        margin = genomeLabelInternal$margin,
        scale = genomeLabelInternal$scale,
        commas = genomeLabelInternal$commas,
        sequence = genomeLabelInternal$sequence,
        boxWidth = genomeLabelInternal$boxWidth,
        axis = genomeLabelInternal$axis,
        at = genomeLabelInternal$at,
        tcl = genomeLabelInternal$tcl,
        x = x, y = y, length = length,
        just = just,
        default.units = genomeLabelInternal$default.units,
        space = space, params = params, ...
    )

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    invisible(genomeLabel)
}

#' Add an x-axis to a plot
#' 
#' @usage annoXaxis(
#'     plot,
#'     at = NULL,
#'     label = TRUE,
#'     main = TRUE,
#'     scipen = 999,
#'     axisLine = FALSE,
#'     params = NULL,
#'     ...
#' )
#'
#' @param plot Plot object to annotate with x-axis.
#' @param at A numeric vector of x-value locations for tick marks.
#' @param label A logical value indicating whether to draw the labels on
#' the tick marks, or an expression or character vector which specify
#' the labels to use.
#' If not logical, must be the same length as the \code{at} argument.
#' @param main A logical value indicating whether to draw the x-axis at the
#' bottom of the plot. Default value is \code{main = TRUE}. Options are:
#' \itemize{
#' \item{\code{TRUE}: }{x-axis is drawn at the bottom of the plot.}
#' \item{\code{FALSE}: }{x-axis is drawn at the top of the plot.}
#' }
#' @param scipen An integer indicating the penalty to be applied when
#' deciding to print numeric values in fixed or exponential notation.
#' Default value is \code{scipen = 999}.
#' @param axisLine A logical value indicating whether to show the axis line.
#' Default value is \code{axisLine = FALSE}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{xaxis} object containing
#' relevant \link[grid]{grob} information.
#'
#' @examples
#' ## Load transcript information
#' library("TxDb.Hsapiens.UCSC.hg19.knownGene")
#' library("org.Hs.eg.db")
#'
#' ## Create page
#' pageCreate(width = 7.5, height = 4.5, default.units = "inches")
#'
#' ## Plot gene transcripts
#' transcriptPlot <- plotTranscripts(
#'     chrom = "chr1",
#'     chromstart = 1000000,
#'     chromend = 2000000,
#'     assembly = "hg19",
#'     x = 0.5, y = 0,
#'     width = 6.5, height = 4,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Add standard x-axis to transcript plot
#' annoXaxis(
#'     plot = transcriptPlot,
#'     at = c(1000000, 1250000, 1500000, 1750000, 2000000),
#'     fontsize = 8
#' )
#' plotText(
#'     label = "Basepairs", fontsize = 10, fontface = "bold",
#'     x = 3.75, y = 4.3, just = "top"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
annoXaxis <- function(plot, at = NULL, label = TRUE, main = TRUE,
                        scipen = 999, axisLine = FALSE, params = NULL, ...) {

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    xInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "xInternal"
    )

    ## Set gp
    xInternal$gp <- setGP(
        gpList = gpar(),
        params = xInternal, ...
    )

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    if (is.null(xInternal$plot)) stop("argument \"plot\" is missing, ",
                                        "with no default.", call. = FALSE)
    check_page(error = "Cannot add an x-axis without a `plotgardener` page.")

    # =========================================================================
    # SAVE USER'S SCIPEN AND SET OURS TEMPORARILY
    # =========================================================================

    oo <- options(scipen = xInternal$scipen)
    on.exit(options(oo))

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    xAxis <- structure(list(grobs = NULL), class = "xaxis")

    # =========================================================================
    # CREATE GROB WITHOUT DRAWING
    # =========================================================================

    xGrob <- xaxisGrob(
        at = xInternal$at, label = xInternal$label,
        main = xInternal$main, gp = xInternal$gp,
        vp = xInternal$plot$grobs$vp
    )

    # =========================================================================
    # GET CENTER OF INPUT PLOT VIEWPORT BASED ON INPUT PLOT TYPE AND JUST
    # =========================================================================

    # Get appropriate plot viewport
    plotVP <- getAnnoViewport(plot = xInternal$plot)

    adjusted_vp <- adjust_vpCoords(viewport = plotVP)

    # =========================================================================
    # SET AT
    # =========================================================================

    if (is.null(xInternal$at)) {
        xInternal$at <- c(plotVP$xscale[1], plotVP$xscale[2])
    }

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## Make viewport name
    currentViewports <- current_viewports()
    vp_name <- paste0(
        "xaxis",
        length(grep(
            pattern = "xaxis",
            x = currentViewports
        )) + 1
    )

    ## Define viewport
    if (xInternal$main == TRUE) {
        vp <- viewport(
            width = plotVP$width, height = heightDetails(xGrob),
            x = adjusted_vp[[1]] - 0.5 * (plotVP$width),
            y = adjusted_vp[[2]] - 0.5 * (plotVP$height),
            just = c("left", "top"), xscale = plotVP$xscale,
            name = vp_name
        )
    } else if (xInternal$main == FALSE) {
        vp <- viewport(
            width = plotVP$width, height = heightDetails(xGrob),
            x = adjusted_vp[[1]] - 0.5 * (plotVP$width),
            y = adjusted_vp[[2]] + 0.5 * (plotVP$height),
            just = c("left", "bottom"), xscale = plotVP$xscale,
            name = vp_name
        )
    }


    # =========================================================================
    # PLOT
    # =========================================================================

    xGrob <- grid.xaxis(
        at = xInternal$at, label = xInternal$label,
        main = xInternal$main, gp = xInternal$gp, vp = vp
    )
    if (!xInternal$axisLine) grid.remove(paste0(xGrob$name, "::major"))
    xaxis_grobs <- gTree(vp = vp, children = gList(xGrob))
    xAxis$grobs <- xaxis_grobs

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("xaxis[", vp_name, "]")
    invisible(xAxis)
}

#' Read a .hic file and return Hi-C data as a dataframe
#' 
#' @usage readHic(
#'     file,
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     altchrom = NULL,
#'     altchromstart = NULL,
#'     altchromend = NULL,
#'     assembly = "hg38",
#'     resolution = "auto",
#'     res_scale = "BP",
#'     zrange = NULL,
#'     norm = "KR",
#'     matrix = "observed",
#'     params = NULL,
#'     quiet = FALSE
#' )
#'
#' @param file A character value specifying the path to the .hic file.
#' @param chrom Chromosome of data, as a string.
#' @param chromstart Integer start position on chromosome.
#' @param chromend Integer end position on chromosome.
#' @param altchrom Alternate chromosome for interchromosomal data,
#' as a string.
#' @param altchromstart Alternate chromosome integer start position
#' for interchromosomal data.
#' @param altchromend Alternate chromosome integer end position
#' for interchromosomal data.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param resolution A numeric specifying the width of each pixel.
#' "auto" will attempt to choose a resolution in basepairs based on
#' the size of the region.
#' @param res_scale A character value specifying the resolution scale.
#' Default value is \code{res_scale = "BP"}. Options are:
#' \itemize{
#' \item{\code{"BP"}: }{Base pairs.}
#' \item{\code{"FRAG"}: }{Fragments.}
#' }
#' @param zrange A numeric vector of length 2 specifying the range of
#' interaction scores, where extreme values will be set to the max or min.
#' @param norm Character value specifying hic data normalization method.
#' This value must be found in the .hic file.
#' Default value is \code{norm = "KR"}.
#' @param matrix Character value indicating the type of matrix to output.
#' Default value is \code{matrix = "observed"}. Options are:
#' \itemize{
#' \item{\code{"observed"}: }{Observed counts.}
#' \item{\code{"oe"}: }{Observed/expected counts.}
#' \item{\code{"log2oe"}: }{Log2 transformed observed/expected counts.}
#' }
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param quiet A logical indicating whether or not to print messages.
#'
#' @return Returns a 3-column dataframe in sparse upper triangular
#' format with the following columns: \code{chrom}, \code{altchrom},
#' \code{counts}.
#' 
#' @examples 
#' hicFile <- system.file("extdata/test_chr22.hic", package="plotgardenerData")
#' 
#' ## Read in data for all chr22 file at 2.5Mb bp resolution
#' hicData <- readHic(file = hicFile, chrom = "22",
#'                     assembly = "hg19",
#'                     resolution = 2500000) 
#'                         
#' ## Read in region `chr22:20000000-47500000` at 100 Kb resolution
#' hicData10Kb <- readHic(file = hicFile, chrom = "22",
#'                         chromstart = 20000000, chromend = 47500000,
#'                         assembly = "hg19",
#'                         resolution = 100000)                     
#'
#' @seealso \link[strawr]{straw}
#'
#' @export
readHic <- function(file, chrom, chromstart = NULL, chromend = NULL,
                    altchrom = NULL, altchromstart = NULL,
                    altchromend = NULL, assembly = "hg38",
                    resolution = "auto", res_scale = "BP",
                    zrange = NULL, norm = "KR", matrix = "observed",
                    params = NULL, quiet = FALSE) {


    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors for readHic
    errorcheck_readHic <- function(hic, chrom, chromstart, chromend,
                                zrange, altchrom, altchromstart,
                                altchromend, norm, res_scale, assembly) {

        ## hic input needs to be a path to a .hic file
        if (!is(hic, "character")) {
            stop("Invalid input. Input needs to be a path to a .hic file.",
                call. = FALSE
            )
        }

        if ((file_ext(hic) != "hic")) {
            stop("Invalid input. File must have a \".hic\" extension",
                call. = FALSE
            )
        }
        
        ## Check that chrom is in file
        chroms <- strawr::readHicChroms(normalizePath(hic))[, "name"]
        if (!chrom %in% chroms){
            stop("`chrom` not found in file. Check file chromosome names",
                 " with `strawr::readHicChroms`.", call. = FALSE)
        }

        ## Genomic region
        regionErrors(chromstart = chromstart,
                    chromend = chromend)
        
        if (!is.null(altchrom)) {
            
            if (!altchrom %in% chroms){
                stop("`altchrom` not found in file. Check file chromosome names",
                     " with `strawr::readHicChroms`,", call. = FALSE)
            }
            

            ## Can't specify altchrom without a chrom
            if (is.null(chrom)) {
                stop("Specified \'altchrom\', but did not give \'chrom\'.",
                    call. = FALSE
                )
            }
            
            regionErrors(chromstart = altchromstart,
                        chromend = altchromend)
            
            ## If giving same chrom and altchrom, need to specify
            ## chromstart/chromend and altchromstart/altchromend
            
            if (chrom == altchrom) {
                if (is.null(chromstart) |
                    is.null(chromend) |
                    is.null(altchromstart) |
                    is.null(altchromend)) {
                    stop("If giving the same \'chrom\' and \'altchrom\', ",
                        "please specify \'chromstart\', \'chromend\', ",
                        "\'altchromstart\', and \'altchromend\'. ",
                        "If trying to get all interactions between one ",
                        "chromosome, just specify \'chrom\'.", call. = FALSE)
                }
            }
        }

        ## zrange errors
        rangeErrors(range = zrange)

        ## Check for valid "res_scale" parameter
        if (!(res_scale %in% c("BP", "FRAG"))) {
            stop("Invalid \'res_scale\'.  Options are \'BP\' and \'FRAG\'.",
                call. = FALSE
            )
        }
    }

    ## Define a function that determines a best resolution for size of region
    auto_resolution <- function(file, chromstart, chromend) {
        fileResolutions <- strawr::readHicBpResolutions(file)
        if (is.null(chromstart) & is.null(chromend)) {
            autoRes <- max(fileResolutions)
        } else {
            dataRange <- chromend - chromstart
            if (dataRange >= 150000000) {
                autoRes <- max(fileResolutions)
            } else if (dataRange >= 75000000 & dataRange < 150000000) {
                autoRes <- 250000
                autoRes <- fileResolutions[which(
                    abs(fileResolutions - autoRes) == min(
                        abs(fileResolutions - autoRes)
                    )
                )]
            } else if (dataRange >= 35000000 & dataRange < 75000000) {
                autoRes <- 100000
                autoRes <- fileResolutions[which(
                    abs(fileResolutions - autoRes) == min(
                        abs(fileResolutions - autoRes)
                    )
                )]
            } else if (dataRange >= 20000000 & dataRange < 35000000) {
                autoRes <- 50000
                autoRes <- fileResolutions[which(
                    abs(fileResolutions - autoRes) == min(
                        abs(fileResolutions - autoRes)
                    )
                )]
            } else if (dataRange >= 5000000 & dataRange < 20000000) {
                autoRes <- 25000
                autoRes <- fileResolutions[which(
                    abs(fileResolutions - autoRes) == min(
                        abs(fileResolutions - autoRes)
                    )
                )]
            } else if (dataRange >= 3000000 & dataRange < 5000000) {
                autoRes <- 10000
                autoRes <- fileResolutions[which(
                    abs(fileResolutions - autoRes) == min(
                        abs(fileResolutions - autoRes)
                    )
                )]
            } else {
                autoRes <- 5000
                autoRes <- fileResolutions[which(
                    abs(fileResolutions - autoRes) == min(
                        abs(fileResolutions - autoRes)
                    )
                )]
            }
        }

        return(as.integer(autoRes))
    }

    ## Define a function to parse chromosome/region for Straw
    parse_region <- function(chrom, chromstart, chromend, assembly) {
        strawChrom <- chrom

        if (is.null(chromstart) & is.null(chromend)) {
            regionStraw <- strawChrom
        } else {

            ## Keep chromstart and chromend without scientific notation
            ## for processing with Straw

            chromstart <- format(chromstart, scientific = FALSE)
            chromend <- format(chromend, scientific = FALSE)
            regionStraw <- paste(strawChrom, chromstart, chromend, sep = ":")
        }

        return(regionStraw)
    }

    ## Define a function to reorder chromsomes to put "chrom" input in col1
    orderChroms <- function(hic, chrom, altchrom, assembly) {
        
        chrom <- gsub("chr", "", chrom)
        altchrom <- gsub("chr", "", altchrom)
        
        if (!"X" %in% chrom & !"Y" %in% chrom) {
            chrom <- utils::type.convert(chrom, as.is = TRUE)
        }

        if (!"X" %in% altchrom & !"Y" %in% altchrom) {
            altchrom <- utils::type.convert(altchrom, as.is = TRUE)
        }

        ## CASE 1: two numbers
        if (all(is(chrom, "numeric"), is(altchrom, "numeric"))) {
            if (chrom > altchrom) {
                hic <- hic[, c("y", "x", "counts")]
            }
        } else if (any(is(chrom, "numeric"), is(altchrom, "numeric"))) {
            ## CASE 2: number and X/Y
            if (is(altchrom, "numeric")) {
                hic <- hic[, c("y", "x", "counts")]
            }
        } else {
            ## CASE 3: X and Y
            if ("Y" %in% chrom) {
                hic <- hic[, c("y", "x", "counts")]
            }
        }

        return(hic)
    }

    ## Define a function to rename columns
    rename_columns <- function(upper, chrom, altchrom) {
        if (is.null(altchrom)) {
            colnames(upper) <- c(paste0(chrom, "_A"), 
                            paste0(chrom, "_B"), "counts")
        } else {
            colnames(upper) <- c(chrom, altchrom, "counts")
        }

        return(upper)
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    rhic <- parseParams(params = params, 
                        defaultArgs = formals(eval(match.call()[[1]])),
                        declaredArgs = lapply(match.call()[-1], 
                                            eval.parent, n = 2),
                        class = "rhic")
    
    if (is.null(rhic$file)) stop("argument \"file\" is missing, ",
                                    "with no default.", call. = FALSE)
    if (is.null(rhic$chrom)) stop("argument \"chrom\" is missing, ",
                                    "with no default.", call. = FALSE)

    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    rhic$assembly <- parseAssembly(assembly = rhic$assembly)

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    errorcheck_readHic(
        hic = rhic$file, chrom = rhic$chrom,
        chromstart = rhic$chromstart,
        chromend = rhic$chromend, zrange = rhic$zrange,
        altchrom = rhic$altchrom,
        altchromstart = rhic$altchromstart,
        altchromend = rhic$altchromend, norm = rhic$norm,
        res_scale = rhic$res_scale,
        assembly = rhic$assembly$Genome
    )

    # =========================================================================
    # SET PARAMETERS
    # =========================================================================

    parse_chromstart <- rhic$chromstart
    parse_chromend <- rhic$chromend
    parse_altchromstart <- rhic$altchromstart
    parse_altchromend <- rhic$altchromend


    ## For off diagonal plotting, grabbing whole symmetric region
    if (!is.null(rhic$altchrom)) {
        if (rhic$chrom == rhic$altchrom) {
            parse_chromstart <- min(rhic$chromstart, rhic$altchromstart)
            parse_chromend <- max(rhic$chromend, rhic$altchromend)
        }
    }

    # =========================================================================
    # PARSE REGIONS
    # =========================================================================

    chromRegion <- parse_region(
        chrom = rhic$chrom,
        chromstart = parse_chromstart,
        chromend = parse_chromend,
        assembly = rhic$assembly$Genome
    )

    if (is.null(rhic$altchrom)) {
        altchromRegion <- chromRegion
    } else {
        if (rhic$chrom == rhic$altchrom) {
            altchromRegion <- chromRegion
        } else {
            altchromRegion <- parse_region(
                chrom = rhic$altchrom,
                chromstart = parse_altchromstart,
                chromend = parse_altchromend,
                assembly = rhic$assembly$Genome
            )
        }
    }

    # =========================================================================
    # ADJUST RESOLUTION
    # =========================================================================

    if (rhic$resolution == "auto") {
        rhic$resolution <- auto_resolution(
            file = rhic$file,
            chromstart = rhic$chromstart,
            chromend = rhic$chromend
        )
        rhic$res_scale <- "BP"
    }

    # =========================================================================
    # EXTRACT SPARSE UPPER TRIANGULAR USING STRAW
    # =========================================================================

    errorFunction <- function(c) {
        upper <- data.frame(matrix(nrow = 0, ncol = 3))
        colnames(upper) <- c("x", "y", "counts")
        return(upper)
    }

    log <- FALSE
    if (rhic$matrix == "logoe") {
        rhic$matrix <- "oe"
        log <- TRUE
    }
    
    upper <-
        tryCatch(strawr::straw(
            norm = rhic$norm,
            fname = normalizePath(rhic$file),
            chr1loc = toString(chromRegion),
            chr2loc = toString(altchromRegion),
            unit = rhic$res_scale,
            binsize = rhic$resolution,
            matrix = rhic$matrix
        ),
        error = errorFunction
        )

    if (log == TRUE) {
        upper[, "counts"] <- log2(upper[, "counts"])
    }


    # =========================================================================
    # REORDER COLUMNS BASED ON CHROM/ALTCHROM INPUT
    # =========================================================================

    if (!is.null(rhic$altchrom)) {
        upper <- orderChroms(
            hic = upper, chrom = rhic$chrom,
            altchrom = rhic$altchrom,
            assembly = rhic$assembly$Genome
        )
        colnames(upper) <- c("x", "y", "counts")
    }

    # =========================================================================
    # SCALE DATA WITH ZRANGE
    # =========================================================================

    scaled_data <- scale_data(upper = upper, zrange = rhic$zrange)

    # =========================================================================
    # FORMAT DATA IN PROPER ORDER AND WITH LABELS
    # =========================================================================

    renamed_data <- rename_columns(
        upper = scaled_data,
        chrom = rhic$chrom,
        altchrom = rhic$altchrom
    )

    # =========================================================================
    # REMOVE NAN VALUES
    # =========================================================================

    renamed_data <- na.omit(renamed_data)

    # =========================================================================
    # RETURN DATAFRAME
    # =========================================================================
    if (nrow(renamed_data) == 0) {
        warning("No data found in region. Suggestions: check that ",
                "chromosome names match genome assembly; ",
                "check region; check available resolutions ",
                "with `strawr::readHicBpResolutions()`.", call. = FALSE)
    } else {
        if (!rhic$quiet) {
            message(
                "Read in hic file with ",
                rhic$norm, " normalization at ",
                rhic$resolution, " ", rhic$res_scale,
                " resolution."
            )
        }
    }
    return(renamed_data)
}

#' Plot paired-end genomic range data in an arch style
#' 
#' @usage plotPairsArches(
#'     data,
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     assembly = "hg38",
#'     style = "2D",
#'     flip = FALSE,
#'     curvature = 5,
#'     archHeight = NULL,
#'     fill = "#1f4297",
#'     linecolor = NA,
#'     alpha = 0.4,
#'     bg = NA,
#'     clip = FALSE,
#'     clip.noAnchor = TRUE,
#'     range = NULL,
#'     baseline = FALSE,
#'     baseline.color = "grey",
#'     baseline.lwd = 1,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL,
#'     ...
#' )
#'
#' @param data A string specifying the BEDPE file path, a dataframe
#' in BEDPE format specifying data to be plotted, or a
#' \link[InteractionSet]{GInteractions} object.
#' @param chrom Chromosome of region to be plotted, as a string.
#' @param chromstart Integer start position on chromosome to be plotted.
#' @param chromend Integer end position on chromosome to be plotted.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param style Character value describing the style of arches.
#' Default value is \code{style = "2D"}. Options are:
#' \itemize{
#' \item{\code{"2D"}: }{Arches will be drawn in a 2-dimensional style.}
#' \item{\code{"3D"}: }{Arches will be drawn in a 3-dimensional style.}
#' }
#' @param flip Logical value indicating whether to reflect arches over
#' the x-axis. Default value is \code{flip = FALSE}.
#' @param curvature Numeric indicating the number of points along the
#' arch curvature. Default value is \code{curvature = 5}.
#' @param archHeight Single numeric value, numeric vector, or column name 
#' in data specifying the arch heights. When NULL, all arches will be the 
#' same height, filling up the given plot area.
#' @param fill A single character value, a vector, or a 
#' \link[plotgardener]{colorby} object specifying fill colors of arches.
#' Default value is \code{fill = #1f4297"}.
#' @param linecolor A single character value, a vector, or a
#' \link[plotgardener]{colorby} object specifying the color of the lines
#' outlining arches. Default value is \code{linecolor = NA}.
#' Special options include:
#' \itemize{
#' \item{\code{NA}: }{No line color.}
#' \item{\code{"fill"}: }{Same color as \code{fill}.}
#' }
#' @param alpha Numeric value specifying transparency.
#' Default value is \code{alpha = 0.4}.
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param clip A logical value indicating whether to clip any
#' arches that get cutoff in the given genomic region.
#' Default value is \code{clip = FALSE}.
#' @param clip.noAnchor A logical value indicating whether to clip
#' any arches that overlap the given genomic region but do not 
#' have an anchor in that region. Default value is \code{clip.noAnchor = TRUE}.
#' @param range A numeric vector of length 2 specifying the y-range
#' of \code{archHeight} to plot (c(min, max)).
#' @param baseline Logical value indicating whether to include
#' a baseline along the x-axis. Default value is \code{baseline = FALSE}.
#' @param baseline.color Baseline color.
#' Default value is \code{baseline.color = "grey"}.
#' @param baseline.lwd Baseline line width.
#' Default value is \code{baseline.lwd = 1}.
#' @param x A numeric or unit object specifying pair arches plot x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying BEDPE arches plot y-location.
#' The character value will
#' place the pair arches plot y relative to the bottom of the most
#' recently plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying pair arches plot width.
#' @param height A numeric or unit object specifying pair arches plot height.
#' @param just Justification of pair arches plot relative to its (x, y)
#' location. If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use if
#' \code{x}, \code{y}, \code{width}, or \code{height} are only given as
#' numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output should be
#' produced. Default value is \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{arches} object containing relevant
#' genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load paired ranges data in BEDPE format
#' library(plotgardenerData)
#' data("IMR90_DNAloops_pairs")
#'
#' ## Set the coordinates
#' params <- pgParams(
#'     chrom = "chr21",
#'     chromstart = 27900000, chromend = 30700000,
#'     assembly = "hg19",
#'     width = 7
#' )
#'
#' ## Create a page
#' pageCreate(width = 7.5, height = 2.1, default.units = "inches")
#'
#' ## Add a length column to color by
#' IMR90_DNAloops_pairs$length <- 
#'         (IMR90_DNAloops_pairs$start2 - IMR90_DNAloops_pairs$start1) / 1000
#'
#' ## Translate lengths into heights
#' IMR90_DNAloops_pairs$h <- 
#'         IMR90_DNAloops_pairs$length / max(IMR90_DNAloops_pairs$length)
#'
#' ## Plot the data
#' archPlot <- plotPairsArches(
#'     data = IMR90_DNAloops_pairs, params = params,
#'     fill = colorby("length", palette = 
#'                 colorRampPalette(c("dodgerblue2", "firebrick2"))),
#'     linecolor = "fill",
#'     archHeight = "h", alpha = 1,
#'     x = 0.25, y = 0.25, height = 1.5,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Annotate genome label
#' annoGenomeLabel(plot = archPlot, x = 0.25, y = 1.78, scale = "Mb")
#'
#'
#' ## Annotate heatmap legend
#' annoHeatmapLegend(
#'     plot = archPlot, fontcolor = "black",
#'     x = 7.0, y = 0.25,
#'     width = 0.10, height = 1, fontsize = 10
#' )
#'
#' ## Add the heatmap legend title
#' plotText(
#'     label = "Kb", rot = 90, x = 6.9, y = 0.75,
#'     just = c("center", "center"),
#'     fontsize = 10
#' )
#'
#'
#' ## Hide page guides
#' pageGuideHide()
#' @details
#' A pair arches plot can be placed on a plotgardener coordinate page
#' by providing plot placement parameters:
#' \preformatted{
#' plotPairsArches(data chrom,
#'                 chromstart = NULL, chromend = NULL,
#'                 x, y, width, height, just = c("left", "top"),
#'                 default.units = "inches")
#' }
#' This function can also be used to quickly plot an unannotated pair
#' arches plot by ignoring plot placement parameters:
#' \preformatted{
#' plotPairsArches(data, chrom,
#'                 chromstart = NULL, chromend = NULL)
#' }
#'
#' @export
plotPairsArches <- function(data, chrom, chromstart = NULL, chromend = NULL,
                            assembly = "hg38", style = "2D", flip = FALSE,
                            curvature = 5, archHeight = NULL,
                            fill = "#1f4297",
                            linecolor = NA, alpha = 0.4, bg = NA,
                            clip = FALSE, clip.noAnchor = TRUE, 
                            range = NULL, baseline = FALSE,
                            baseline.color = "grey", baseline.lwd = 1,
                            x = NULL, y = NULL, width = NULL, height = NULL,
                            just = c("left", "top"),
                            default.units = "inches", draw = TRUE,
                            params = NULL, ...) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors
    errorcheck_plotArches <- function(bedpe, archesPlot, style, fill) {
        ## Genomic region
        regionErrors(chromstart = archesPlot$chromstart,
                    chromend = archesPlot$chromend)

        if (!style %in% c("3D", "2D")) {
            stop("Invalid \'style\' input. Options are \'3D\' and \'2D\'.",
                call. = FALSE
            )
        }

        ## Fill colorby checks
        checkColorby(fill = fill,
                        colorby = TRUE,
                        data = bedpe)
        
        rangeErrors(range = archesPlot$range)
    }

    ## Define a function that will produce a yscale for arches based on height
    ## and range
    height_yscale <- function(heights, flip, range) {
        if (is.null(range)){
            if (length(heights) == 1) {
                if (flip == FALSE) {
                    yscale <- c(0, heights)
                } else {
                    yscale <- c(heights, 0)
                }
            } else {
                if (flip == FALSE) { 
                    yscale <- c(0, max(heights))
                } else {
                    yscale <- c(max(heights), 0)
                }
            }
        } else {
            if (flip == FALSE){
                yscale <- range
            } else {
                yscale <- rev(range)
            }
        }
        
        return(yscale)
    }

    ## Define a function that normalizes arch heights
    normHeights <- function(height, min, max) {

        ## First normalize from 0 to 1
        newHeight <- (height - min) / (max - min)

        ## Then scale to a range of 1.38
        finalHeight <- newHeight * 1.38

        return(finalHeight)
    }

    ## Define a function that creates ribbon arch grobs
    drawRibbons <- function(df, style, arch, flip, transp, gp) {

        x1 <- min(df$start1, df$start2)
        x2 <- min(df$end1, df$end2)
        y1 <- max(df$start1, df$start2)
        y2 <- max(df$end1, df$end2)
        
        
        fillCol <- df$color
        lineCol <- df$linecolor
        outerHeight <- df$normHeight
        gp$fill <- fillCol
        gp$col <- lineCol
        gp$alpha <- transp

        ## Calculate innerHeight
        anchor1 <- x2 - x1
        anchor2 <- y2 - y1
        if (anchor1 == anchor2){
            innerHeight <- outerHeight - 0.01
        } else {
            
            diff1 <- abs(y1-x2)
            diff2 <- abs(y2-x1)
            innerHeight <- outerHeight*((y1-x2)/(y2-x1))
        }

        if (style == "3D") {
            x1 <- df$end1
            x2 <- df$start1
        }
        
        ## Designate bezier control points
        innerX <- unit(
            seq(x2, y1, length.out = arch)[c(1, 2, seq((arch - 1), arch))],
            "native"
        )
        outerX <- unit(
            seq(x1, y2, length.out = arch)[c(1, 2, seq((arch - 1), arch))],
            "native"
        )

        if (flip == FALSE) {
            ## Switch y-positions for top plotting
            innerY <- unit(c(0, innerHeight, innerHeight, 0), "npc")
            outerY <- unit(c(0, outerHeight, outerHeight, 0), "npc")
        } else {
            ## Switch y-positions for bottom plotting
            innerY <- unit(c(1, 1 - innerHeight, 1 - innerHeight, 1), "npc")
            outerY <- unit(c(1, 1 - outerHeight, 1 - outerHeight, 1), "npc")
        }

        ## Calculate loop arcs using bezier curves
        innerLoop <- bezierGrob(x = innerX, y = innerY)
        outerLoop <- bezierGrob(x = outerX, y = outerY)

        ## Extract points from bezier curves
        innerBP <- bezierPoints(innerLoop)
        outerBP <- bezierPoints(outerLoop)
        
        ## Connect points, convert to proper units and draw polygons
        archGrob <- polygonGrob(
            x = unit(
                c(
                    convertX(outerBP$x, "native"),
                    rev(convertX(innerBP$x, "native"))
                ),
                "native"
            ),
            y = unit(
                c(
                    convertY(outerBP$y, "npc"),
                    rev(convertY(innerBP$y, "npc"))
                ),
                "npc"
            ),
            gp = gp
        )
        assign("arches_grobs",
            addGrob(
                gTree = get("arches_grobs", envir = pgEnv),
                child = archGrob
            ),
            envir = pgEnv
        )
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    archInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "archInternal"
    )

    ## Set gp
    archInternal$gp <- setGP(
        gpList = gpar(),
        params = archInternal, ...
    )
    
    ## Justification
    archInternal$just <- justConversion(just = archInternal$just)

    # =========================================================================
    # CHECK ARGUMENT ERRORS
    # =========================================================================
    if (is.null(archInternal$data)) stop("argument \"data\" is missing, ",
                                            "with no default.", call. = FALSE)
    if (is.null(archInternal$chrom)) stop("argument \"chrom\" is missing, ",
                                            "with no default.", call. = FALSE)
    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    archesPlot <- structure(list(
        bedpe = NULL, chrom = archInternal$chrom,
        chromstart = archInternal$chromstart,
        chromend = archInternal$chromend,
        assembly = archInternal$assembly,
        color_palette = NULL,
        zrange = NULL,
        range = archInternal$range,
        x = archInternal$x, y = archInternal$y,
        width = archInternal$width,
        height = archInternal$height,
        just = archInternal$just, grobs = NULL
    ),
    class = "arches"
    )
    attr(x = archesPlot, which = "plotted") <- archInternal$draw

    # =========================================================================
    # CHECK PLACEMENT ERRORS
    # =========================================================================

    check_placement(object = archesPlot)

    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    archesPlot$assembly <- parseAssembly(assembly = archesPlot$assembly)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    archesPlot <- defaultUnits(
        object = archesPlot,
        default.units = archInternal$default.units
    )

    # =========================================================================
    # READ IN FILE OR DATAFRAME
    # =========================================================================

    bedpe <- read_pairedData(data = archInternal$data,
                            assembly = archesPlot$assembly)
    
    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    errorcheck_plotArches(
        bedpe = bedpe, archesPlot = archesPlot,
        style = archInternal$style,
        fill = archInternal$fill
    )
    
    ## chrom format and data chrom format
    chromDataAgreement(data = bedpe, chrom = archesPlot$chrom,
                    type = "pairs")

    # =========================================================================
    # GENOMIC SCALE
    # =========================================================================

    scaleChecks <- genomicScale(object = archesPlot,
                                objectInternal = archInternal,
                                plotType = "paired data arches")
    archesPlot <- scaleChecks[[1]]
    archInternal <- scaleChecks[[2]]
    
    # =========================================================================
    # COLORS
    # =========================================================================
    
    if (archInternal$clip == TRUE){
        subset <- "pairs_clip"
    } else {
        if (archInternal$clip.noAnchor == TRUE){
            subset <- "pairs_noanchor"
        } else {
            subset <- "pairs"
        }
    }
    
    archColors <- parseColors(data = bedpe,
                                fill = archInternal$fill,
                                object = archesPlot,
                                subset = subset)
    if (length(archColors[[1]]) > 0){
        bedpe$color <- archColors[[1]]
    } else {
        bedpe$color <- rep("#1f4297", nrow(bedpe))
    }
    
    archesPlot <- archColors[[2]]
    
    bedpe$linecolor <- lineColors(linecolor = archInternal$linecolor,
                                    fillcolors = bedpe$color,
                                    data = bedpe,
                                    object = archesPlot,
                                    subset = subset)
    
    # =========================================================================
    # SUBSET DATA
    # =========================================================================

    if (!is.null(archesPlot$chromstart) & !is.null(archesPlot$chromend)) {
        if (archInternal$clip == TRUE) {
            bedpe <- bedpe[which(bedpe[, "chrom1"] == archesPlot$chrom &
                bedpe[, "chrom2"] == archesPlot$chrom &
                bedpe[, "start1"] >= archesPlot$chromstart &
                bedpe[, "end1"] <= archesPlot$chromend &
                bedpe[, "start2"] >= archesPlot$chromstart &
                bedpe[, "end2"] <= archesPlot$chromend), ]
        } else {
            if (archInternal$clip.noAnchor == TRUE){
                bedpe <- bedpe[which(bedpe[, "chrom1"] == archesPlot$chrom &
                                    bedpe[, "chrom2"] == archesPlot$chrom &
                                ((bedpe[, "start1"] >= archesPlot$chromstart &
                                bedpe[, "start1"] <= archesPlot$chromend) |
                                (bedpe[, "end2"] >= archesPlot$chromstart &
                                bedpe[, "end2"] <= archesPlot$chromend))), ]
            } else {
                bedpe <- bedpe[which(bedpe[, "chrom1"] == archesPlot$chrom &
                                        bedpe[, "chrom2"] == archesPlot$chrom),]
                overlappingRanges <- as.data.frame(subsetByOverlaps(ranges = 
                                        IRanges(start = archesPlot$chromstart, 
                                                end = archesPlot$chromend),
                                        x = IRanges(start = bedpe[,"start1"], 
                                                    end = bedpe[,"end2"])))
                bedpe <- bedpe[which(bedpe[,"start1"] %in% 
                                        overlappingRanges$start &
                                        bedpe[,"end2"] %in% 
                                        overlappingRanges$end),]
            }
        }
    } else {
        bedpe <- data.frame(matrix(nrow = 0, ncol = 6))
    }

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## If placing information is provided but plot == TRUE,
    ## set up it's own viewport separate from bb_makepage
    ## Not translating into page_coordinates
    if (is.null(archesPlot$x) | is.null(archesPlot$y)) {
        vp <- viewport(
            height = unit(0.5, "npc"), width = unit(1, "npc"),
            x = unit(0.5, "npc"), y = unit(0.5, "npc"),
            xscale = archInternal$xscale,
            clip = "on",
            just = "center",
            name = "arches1"
        )

        if (archInternal$draw == TRUE) {
            grid.newpage()
        }
        
    } else {
        
        ## Get viewport name
        currentViewports <- current_viewports()
        vp_name <- paste0(
            "arches",
            length(grep(
                pattern = "arches",
                x = currentViewports
            )) + 1
        )
        
        addViewport(vp_name)

        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = archesPlot)

        ## Make viewport
        vp <- viewport(
            height = page_coords$height, width = page_coords$width,
            x = page_coords$x, y = page_coords$y,
            xscale = archInternal$xscale,
            clip = "on",
            just = archInternal$just,
            name = vp_name
        )
    }

    # =========================================================================
    # HEIGHTS
    # =========================================================================

    if (nrow(bedpe) > 0) {
        if (is.null(archInternal$archHeight)) {
            bedpe$height <- rep(1, nrow(bedpe))
        } else if (is(archInternal$archHeight, "numeric")){
            if (length(archInternal$archHeight) == 1){
                bedpe$height <- rep(archInternal$archHeight, nrow(bedpe))
            } else {
                if (length(archInternal$archHeight) < nrow(bedpe)){
                        stop("`archHeight` vector is shorter than the", 
                            " number of plotted arches.", call. = FALSE)
                } else if (length(archInternal$archHeight) > nrow(bedpe)){
                    warning("`archHeight` vector is longer than the number ",
                            "of plotted arches. `archHeight` vector will",
                            " be truncated.", call. = FALSE)
                }
                bedpe$height <- archInternal$archHeight[seq(1, nrow(bedpe))]
            }
            yscale <- height_yscale(
                        heights = bedpe$height,
                        flip = archInternal$flip,
                        range = archInternal$range
                    )
            vp$yscale <- yscale
        } else {
            if (!archInternal$archHeight %in% colnames(bedpe)){
                stop("Column name for `archHeight` not found in data.",
                    call. = FALSE)
            }
            bedpe$height <- bedpe[, archInternal$archHeight]
            yscale <- height_yscale(
                        heights = bedpe$height,
                        flip = archInternal$flip,
                        range = archInternal$range
                    )
            vp$yscale <- yscale
            
        }

        if (length(bedpe$height) > 0) {
            bedpe$normHeight <- lapply(bedpe$height, normHeights,
                min = min(vp$yscale),
                max = max(vp$yscale)
            )
        }
    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS WITH BACKGROUND
    # =========================================================================

    backgroundGrob <- rectGrob(
        gp = gpar(fill = archInternal$bg, col = NA),
        name = "background"
    )
    assign("arches_grobs", gTree(vp = vp, children = gList(backgroundGrob)),
        envir = pgEnv
    )

    # =========================================================================
    # GROBS
    # =========================================================================

    if (nrow(bedpe) > 0) {
        if (archInternal$baseline == TRUE) {
            baselineGrob <- segmentsGrob(
                x0 = unit(0, "npc"), y0 = 0,
                x1 = unit(1, "npc"), y1 = 0,
                default.units = "native",
                gp = gpar(
                    col = archInternal$baseline.color,
                    lwd = archInternal$baseline.lwd
                )
            )
            assign("arches_grobs",
                addGrob(
                    gTree = get("arches_grobs", envir = pgEnv),
                    child = baselineGrob
                ),
                envir = pgEnv
            )
        }
        
        invisible(apply(bedpe, 1, drawRibbons,
            style = archInternal$style,
            arch = archInternal$curvature,
            flip = archInternal$flip,
            transp = archInternal$alpha, gp = archInternal$gp
        ))
    } else {
        if (archInternal$txdbChecks == TRUE) {
            warning("Data contains no values.", call. = FALSE)
        }
    }

    # =========================================================================
    # IF PLOT == TRUE, DRAW GROBS
    # =========================================================================

    if (archInternal$draw == TRUE) {
        grid.draw(get("arches_grobs", envir = pgEnv))
    }

    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    archesPlot$grobs <- get("arches_grobs", envir = pgEnv)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("arches[", vp$name, "]")
    invisible(archesPlot)
}

## Define a function to adjust/detect resolution based on .hic file/dataframe
# @param hic hic data argument
# @param hicPlot hic plot object
adjust_resolution <- function(hic, hicPlot) {
    if (!("data.frame" %in% class(hic))) {
        if (!is.null(hicPlot$chromstart) & !is.null(hicPlot$chromend)) {
            if (file_ext(hic) == "hic"){
                fileResolutions <- strawr::readHicBpResolutions(hic)
            } else {
                fileResolutions <- readCoolBpResolutions(hic)
            }
            
            ## Get range of data and try to pick a resolution
            dataRange <- hicPlot$chromend - hicPlot$chromstart
            if (dataRange >= 150000000) {
                bestRes <- max(fileResolutions)
            } else if (dataRange >= 75000000 & dataRange < 150000000) {
                bestRes <- 250000
                bestRes <- fileResolutions[which(
                    abs(fileResolutions - bestRes) == min(
                        abs(fileResolutions - bestRes)
                    )
                )]
            } else if (dataRange >= 35000000 & dataRange < 75000000) {
                bestRes <- 100000
                bestRes <- fileResolutions[which(
                    abs(fileResolutions - bestRes) == min(
                        abs(fileResolutions - bestRes)
                    )
                )]
            } else if (dataRange >= 20000000 & dataRange < 35000000) {
                bestRes <- 50000
                bestRes <- fileResolutions[which(
                    abs(fileResolutions - bestRes) == min(
                        abs(fileResolutions - bestRes)
                    )
                )]
            } else if (dataRange >= 5000000 & dataRange < 20000000) {
                bestRes <- 25000
                bestRes <- fileResolutions[which(
                    abs(fileResolutions - bestRes) == min(
                        abs(fileResolutions - bestRes)
                    )
                )]
            } else if (dataRange >= 3000000 & dataRange < 5000000) {
                bestRes <- 10000
                bestRes <- fileResolutions[which(
                    abs(fileResolutions - bestRes) == min(
                        abs(fileResolutions - bestRes)
                    )
                )]
            } else {
                bestRes <- 5000
                bestRes <- fileResolutions[which(
                    abs(fileResolutions - bestRes) == min(
                        abs(fileResolutions - bestRes)
                    )
                )]
            }

            hicPlot$resolution <- as.integer(bestRes)
        }
    } else {

        ## Try to detect resolution from data
        offDiag <- hic[which(hic[, 1] != hic[, 2]), ]
        bpDiffs <- abs(offDiag[, 2] - offDiag[, 1])
        predRes <- min(bpDiffs)

        hicPlot$resolution <- as.integer(predRes)
    }

    return(hicPlot)
}

## Define a function that detects bin limit for plotting Hi-C data
# @param hic hic data argument
# @param hicPlot hic plot object
hic_limit <- function(hic, hicPlot){
    ## Calculate bin number
    dataRange <- hicPlot$chromend - hicPlot$chromstart
    binNumber <- dataRange/hicPlot$resolution
    
    if (binNumber > 1000){
        
        if (!("data.frame" %in% class(hic))) {
            
            ## Overwrite manual resolution for Hi-C file
            hicPlotNew <- adjust_resolution(hic = hic, hicPlot = hicPlot)
            newRes <- hicPlotNew$resolution
            hicPlot$resolution <- newRes
            warning("Attempting to plot too many Hi-C pixels. Adjusting to ",
                    "a resolution of ", newRes, " BP.", call. = FALSE)
        } else {
            warning(hicPlot$resolution, " BP resolution detected in ",
            "dataframe. Attempting to plot too many Hi-C pixels. Please ",
            "read in data at a lower resolution before attempting to plot.", 
            call. = FALSE)
            hicPlot$resolution <- NA
        }
    
    }
    
    return(hicPlot)
}

## Define a function that reads in hic data for plotHic functions
# @param hic hic data argument
# @param hicPlot hic plot object
# @param norm normalization factor
# @param assembly genome assembly
# @param type matrix type
# @param quiet message quiet parameter
read_data <- function(hic, hicPlot, norm, assembly, type, quiet) {

    ## if file, read in
    if (!("data.frame" %in% class(hic))) {
        # .hic file
        if (file_ext(hic) == "hic"){
            if (!is.null(hicPlot$chromstart) & !is.null(hicPlot$chromend) &
                !is.na(hicPlot$resolution)) {
                readchromstart <- hicPlot$chromstart - hicPlot$resolution
                readchromend <- hicPlot$chromend + hicPlot$resolution
                readaltchromstart <- hicPlot$altchromstart - hicPlot$resolution
                readaltchromend <- hicPlot$altchromend + hicPlot$resolution
                hic <- suppressWarnings(readHic(
                    file = hic, chrom = hicPlot$chrom,
                    chromstart = readchromstart,
                    chromend = readchromend,
                    assembly = assembly,
                    resolution = hicPlot$resolution,
                    zrange = hicPlot$zrange,
                    norm = norm,
                    altchrom = hicPlot$altchrom,
                    altchromstart = readaltchromstart,
                    altchromend = readaltchromend,
                    matrix = type
                ))
            } else {
                hic <- data.frame(matrix(nrow = 0, ncol = 3))
            }
        } else {
            
            if (!is.null(hicPlot$chromstart) & !is.null(hicPlot$chromend) &
                !is.na(hicPlot$resolution)){
                
                readchromstart <- hicPlot$chromstart - hicPlot$resolution
                readchromend <- hicPlot$chromend + hicPlot$resolution
                readaltchromstart <- hicPlot$altchromstart - hicPlot$resolution
                readaltchromend <- hicPlot$altchromend + hicPlot$resolution

                # .(m)cool file 
                hic <- suppressWarnings(readCool(
                    file = hic, chrom = hicPlot$chrom,
                    chromstart = readchromstart,
                    chromend = readchromend,
                    altchrom = hicPlot$altchrom,
                    altchromstart = readaltchromstart,
                    altchromend = readaltchromend,
                    resolution = hicPlot$resolution,
                    norm = norm,
                    zrange = hicPlot$zrange
                ))
                
            } else {
                hic <- data.frame(matrix(nrow = 0, ncol = 3))
            }
        }
        
    } else {
    
        if (!is.null(hicPlot$chromstart) & !is.null(hicPlot$chromend) &
            !is.na(hicPlot$resolution)) {
            if (!quiet) {
                message(
                    "Read in dataframe.  Assuming \'chrom\' in column1 ",
                    "and \'altchrom\' in column2. ",
                    hicPlot$resolution, " BP resolution detected."
                )
            }
            ## plotHicRectangle specific warning for missing data
            if (is(hicPlot, "hicRectangle")){
                if (hicPlot$chromstart < min(hic[, 1]) |
                    hicPlot$chromend > max(hic[, 1])) {
                    warning("`plotHicRectangle` requires additional data to",
                " plot a rectangular plot. Data is missing from input ",
                "dataframe for region and plot will be a trapezoid. To avoid ",
                "this missing data, call `plotHicRectangle` with full .hic or ",
                " .(m)cool file.", call. = FALSE
                    )
                }
            }
            
        } else {
            hic <- data.frame(matrix(nrow = 0, ncol = 3))
        }
    }

    ## Rename columns for later processing
    colnames(hic) <- c("x", "y", "counts")
    hic <- na.omit(hic)

    return(hic)
}

## Define a function that sets the Hi-C zrange
# @param hic hic data argument
# @param hicPlot hic plot object
set_zrange <- function(hic, hicPlot) {

    ## no zrange, only one value
    if (is.null(hicPlot$zrange) & length(unique(hic$counts)) == 1) {
        zrange <- c(unique(hic$counts), unique(hic$counts))
        hicPlot$zrange <- zrange
    }

    ## no zrange, multiple values
    if (is.null(hicPlot$zrange) & length(unique(hic$counts)) > 1) {
        if (grepl("log", hicPlot$colorTrans) == TRUE) {
            zrange <- c(0.0001, max(hic$counts))
        } else {
            zrange <- c(0, max(hic$counts))
        }

        hicPlot$zrange <- zrange
    }

    return(hicPlot)
}

## Define a function that parses an inherited half of a Hi-C plot
# @param hic hic plot object
inherit_half <- function(hic) {
    if (is(hic, "hicSquare")) {
        half <- hic$half
    } else if (is(hic, "hicTriangle") |
        is(hic, "hicRectangle")) {
        half <- "top"
    }

    return(half)
}

## Define a function to scale data with zrange
scale_data <- function(upper, zrange) {
    if (!is.null(zrange)) {
        upper$counts[upper$counts <= zrange[1]] <- zrange[1]
        upper$counts[upper$counts >= zrange[2]] <- zrange[2]
    } else {
        
        # if null, zrange will be set to (0, max(data))
        upper$counts[upper$counts <= 0] <- 0
    }
    
    return(upper)
}

test_that("adjust_resolution", {
    library(plotgardenerData)
    data("IMR90_HiC_10kb")
    ## Detect appropriate resolution from data
    expect_equal(plotgardener:::adjust_resolution(hic = IMR90_HiC_10kb,
                                              hicPlot = NULL)$resolution,
                 10000)
    ## Grab a resolution in a file
    hicFile <- system.file("extdata/test_chr22.hic", package="plotgardenerData")
    hic_plot <- list("chromstart" = 20000000,
                     "chromend" = 47500000)
    expect_equal(plotgardener:::adjust_resolution(hic = hicFile,
                                              hicPlot = hic_plot)$resolution,
                 100000)
    
    ## Grab a close resolution to one in a file
    hic_plot <- list("chromstart" = 20000000,
                     "chromend" = 40000000)
    expect_equal(plotgardener:::adjust_resolution(hic = hicFile,
                                              hicPlot = hic_plot)$resolution,
                 100000)
    
})

test_that("hic_limit", {
    library(plotgardenerData)
    hicFile <- system.file("extdata/test_chr22.hic", package="plotgardenerData")
    
    ## Appropriate number of bins
    hic_plot <- list("chromstart" = 20000000,
                     "chromend" = 47500000,
                     "resolution" = 100000)
    expect_silent(plotgardener:::hic_limit(hic = hicFile,
                                       hicPlot = hic_plot))
    
    ## Hic file and readjusts bin number
    hic_plot <- list("chromstart" = 20000000,
                     "chromend" = 47500000,
                     "resolution" = 5000)
    expect_warning(plotgardener:::hic_limit(hic = hicFile,
                                        hicPlot = hic_plot))
    expect_equal(suppressWarnings(plotgardener:::hic_limit(hic = hicFile,
                                      hicPlot = hic_plot)$resolution),
                 100000)
    
    ## Data frame NA resolution
    data("IMR90_HiC_10kb")
    expect_warning(plotgardener:::hic_limit(hic = IMR90_HiC_10kb,
                                        hicPlot = hic_plot))
    expect_equal(suppressWarnings(plotgardener:::hic_limit(hic = IMR90_HiC_10kb,
                                      hicPlot = hic_plot)$resolution),
                 NA)
})

test_that("set_zrange", {
    library(plotgardenerData)
    data("IMR90_HiC_10kb")
    ## already has a zrange
    hic_plot <- list("zrange" = c(0, 10))
    
    expect_equal(plotgardener:::set_zrange(IMR90_HiC_10kb, 
                                       hicPlot = hic_plot)$zrange,
                 c(0, 10))
    
    
    ## no zrange, multiple values
    hic_plot <- list("zrange" = NULL, "colorTrans" = "linear")
    expect_equal(plotgardener:::set_zrange(IMR90_HiC_10kb, 
                                       hicPlot = hic_plot)$zrange,
                 c(0, 70))
    
    ## no zrange, only one value
    IMR90_HiC_10kb$counts <- 1
    expect_equal(plotgardener:::set_zrange(IMR90_HiC_10kb, 
                                       hicPlot = hic_plot)$zrange,
                 c(1, 1))
})

test_that("inherit_half", {
    
    ## square hic half , top
    library(plotgardenerData)
    data("IMR90_HiC_10kb")
    pageCreate(width = 3, height = 3, default.units = "inches")
    hicPlot <- suppressMessages(plotHicSquare(
            data = IMR90_HiC_10kb, resolution = 10000,
            zrange = c(0, 70),
            chrom = "chr21",
            chromstart = 28000000, chromend = 30300000,
            assembly = "hg19",
            half = "top",
            x = 0.5, y = 0.5, width = 2, height = 2,
            just = c("left", "top"),
            default.units = "inches"
        ))
    expect_equal(plotgardener:::inherit_half(hicPlot),
                 "top")
    
    ## triangle hic half, always top
    pageCreate(width = 4, height = 2.5, default.units = "inches")

    ## Plot and place triangle Hi-C plot
    hicPlot <- suppressMessages(plotHicTriangle(
        data = IMR90_HiC_10kb, resolution = 10000,
        zrange = c(0, 70),
        chrom = "chr21",
        chromstart = 28000000, chromend = 30300000,
        assembly = "hg19",
        x = 2, y = 0.5, width = 3, height = 1.5,
        just = "top", default.units = "inches"
    ))
    hicPlot$half <- "testing"
    expect_equal(plotgardener:::inherit_half(hicPlot),
                 "top")
})

#' Plot a rectangle within a plotgardener layout
#' 
#' @usage plotRect(
#'     x,
#'     y,
#'     width,
#'     height,
#'     just = "center",
#'     default.units = "inches",
#'     linecolor = "black",
#'     lwd = 1,
#'     lty = 1,
#'     fill = NA,
#'     alpha = 1,
#'     params = NULL,
#'     ...
#' )
#'
#' @param x A numeric vector or unit object specifying rectangle x-locations.
#' @param y A numeric vector, unit object, or a character vector of values
#' containing a "b" combined with a numeric value specifying
#' rectangle y-locations.
#' The character vector will place rectangle y-locations relative to
#' the bottom of the most recently plotted plot according to
#' the units of the plotgardener page.
#' @param width A numeric vector or unit object specifying rectangle widths.
#' @param height A numeric vector or unit object specifying rectangle heights.
#' @param just Justification of rectangle relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal justification
#' and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = "center"}.
#' @param default.units A string indicating the default units to use if
#' \code{x}, \code{y}, \code{width}, and \code{height} are only given as
#' numerics or numeric vectors.
#' Default value is \code{default.units = "inches"}.
#' @param linecolor A character value specifying rectangle line color.
#' Default value is \code{linecolor = "black"}.
#' @param lwd A numeric specifying rectangle line width.
#' Default value is \code{lwd = 1}.
#' @param lty A numeric specifying rectangle line type.
#' Default value is \code{lty = 1}.
#' @param fill A character value specifying rectangle fill color.
#' Default value is \code{fill = NA}.
#' @param alpha Numeric value specifying color transparency.
#' Default value is \code{alpha = 1}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{rect} object containing
#' relevant placement and \link[grid]{grob} information.
#'
#' @examples
#' ## Create a page
#' pageCreate(width = 7.5, height = 6, default.units = "inches")
#'
#' ## Plot one rectangle with no fill
#' plotRect(
#'     x = 0.5, y = 0.5, width = 3, height = 3,
#'     just = c("left", "top"), default.units = "inches",
#'     lwd = 2, fill = NA
#' )
#'
#'
#' ## Plot two rectangles with same width and height at different locations
#' plotRect(
#'     x = 4, y = c(0.5, 2.25), width = 3, height = 1.25,
#'     just = c("left", "top"), default.units = "inches",
#'     fill = "#7ecdbb"
#' )
#'
#' ## Plot two rectangles with different widths, heights,
#' ## locations, and colors
#' plotRect(
#'     x = 3.75, y = c(4, 5.25), width = c(6.5, 4.5),
#'     height = c(1, 0.25),
#'     just = "top", default.units = "inches",
#'     fill = c("#7ecdbb", "#37a7db"), linecolor = NA, alpha = 0.4
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @seealso \link[grid]{grid.rect}
#'
#' @export
plotRect <- function(x, y, width, height, just = "center",
                        default.units = "inches", linecolor = "black",
                        lwd = 1, lty = 1, fill = NA, alpha = 1,
                        params = NULL, ...) {

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    rectInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "rectInternal"
    )

    ## Set gp
    rectInternal$gp <- gpar(
        col = rectInternal$linecolor,
        fill = rectInternal$fill,
        lwd = rectInternal$lwd,
        lty = rectInternal$lty,
        alpha = rectInternal$alpha
    )
    rectInternal$gp <- setGP(
        gpList = rectInternal$gp,
        params = rectInternal, ...
    )
    
    ## Justification
    rectInternal$just <- justConversion(just = rectInternal$just)

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    rect <- structure(list(
        x = rectInternal$x, y = rectInternal$y,
        width = rectInternal$width,
        height = rectInternal$height,
        just = rectInternal$just,
        grobs = NULL, gp = rectInternal$gp
    ),
    class = "rect"
    )

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_page(error = "Cannot plot rectangle without a `plotgardener` page.")
    if (is.null(rect$x)) {
        stop("argument \"x\" is missing, with no default.",
            call. = FALSE
        )
    }
    if (is.null(rect$y)) {
        stop("argument \"y\" is missing, with no default.",
            call. = FALSE
        )
    }
    if (is.null(rect$width)) {
        stop("argument \"width\" is missing, with no default.",
            call. = FALSE
        )
    }
    if (is.null(rect$height)) {
        stop("argument \"height\" is missing, with no default.",
            call. = FALSE
        )
    }
    
    checkColorby(fill = rect$gp$fill,
                    colorby = FALSE)

    # =========================================================================
    # DEFINE PARAMETERS
    # =========================================================================

    ## Get page_height and its units from pgEnv
    page_height <- get("page_height", envir = pgEnv)
    page_units <- get("page_units", envir = pgEnv)
    
    rect$x <- misc_defaultUnits(
        value = rect$x,
        name = "x",
        default.units = rectInternal$default.units
    )
    rect$y <- misc_defaultUnits(
        value = rect$y,
        name = "y",
        default.units = rectInternal$default.units
    )
    rect$width <- misc_defaultUnits(
        value = rect$width,
        name = "width",
        default.units = rectInternal$default.units
    )
    rect$height <- misc_defaultUnits(
        value = rect$height,
        name = "height",
        default.units = rectInternal$default.units
    )

    ## Convert coordinates to page_units
    new_x <- convertX(rect$x, unitTo = page_units, valueOnly = TRUE)
    new_y <- convertY(rect$y, unitTo = page_units, valueOnly = TRUE)
    new_width <- convertWidth(rect$width,
        unitTo = page_units, valueOnly = TRUE
    )
    new_height <- convertHeight(rect$height,
        unitTo = page_units, valueOnly = TRUE
    )

    # =========================================================================
    # MAKE GROB
    # =========================================================================
    name <- paste0(
        "rect",
        length(grep(
            pattern = "rect",
            x = grid.ls(
                print = FALSE,
                recursive = FALSE
            )
        )) + 1
    )
    rect <- grid.rect(
        x = unit(new_x, page_units),
        y = unit(page_height - new_y, page_units),
        width = unit(new_width, page_units),
        height = unit(new_height, page_units),
        just = rect$just, gp = rect$gp,
        name = name
    )

    # =========================================================================
    # ADD GROB TO OBJECT
    # =========================================================================

    rect$grobs <- rect

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("rect[", rect$name, "]")
    invisible(rect)
}

#' Add a color scale legend for heatmap-style plots
#' 
#' @usage annoHeatmapLegend(
#'     plot,
#'     orientation = "v",
#'     fontsize = 8,
#'     fontcolor = "dark grey",
#'     scientific = FALSE,
#'     digits = 1,
#'     ticks = FALSE,
#'     breaks = NULL,
#'     border = FALSE,
#'     x,
#'     y,
#'     width,
#'     height,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     params = NULL,
#'     ...
#' )
#'
#' @param plot Heatmap-style plot object to add heatmap legend for.
#' @param orientation A string specifying legend orientation.
#' Default value is \code{orientation = "v"}. Options are:
#' \itemize{
#' \item{\code{"v"}: }{Vertical legend orientation.}
#' \item{\code{"h"}: }{Horizontal legend orientation.}
#' }
#' @param fontsize A numeric specifying text fontsize in points.
#' Default value is \code{fontsize = 8}.
#' @param fontcolor Character value specfying text fontcolor.
#' Default value is \code{fontcolor = "dark grey"}.
#' @param scientific Logical value specifying if numeric color value labels
#' should be encoded in scientific format.
#' Default value is \code{scientific = FALSE}.
#' @param digits Numeric specifying how many significant digits to include
#' of numeric color value labels. Default value is \code{digits = 1}.
#' @param ticks Logical value specifying if tick marks on the heatmap
#' colorbar should be visible. Default value is \code{ticks = FALSE}.
#' @param breaks A numeric vector specifying tick breaks.
#' Default value is \code{breaks = NULL}.
#' @param border Logical value indicating whether to add a border around
#' heatmap legend. Default value is \code{border = FALSE}.
#' @param x A numeric or unit object specifying x-location of legend.
#' @param y A numeric, unit object, or character containing a "b" combined
#' with a numeric value specifying y-location of legend.
#' The character value will place the legend y relative to the bottom of the
#' most recently plotted plot according to the units of
#' the plotgardener page.
#' @param width A numeric or unit object specifying width of legend.
#' @param height A numeric or unit object specifying height of legend.
#' @param just Justification of heatmap legend relative to
#' its (x, y) location. If there are two values, the first value specifies
#' horizontal justification and the second value specifies vertical
#' justification. Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use if
#' \code{x}, \code{y}, \code{width}, or \code{height} are only given as
#' numerics. Default value is \code{default.units = "inches"}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{heatmapLegend} object with relevant
#' color value, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load Hi-C data
#' library(plotgardenerData)
#' data("IMR90_HiC_10kb")
#'
#' ## Create page
#' pageCreate(width = 4, height = 3.5, default.units = "inches")
#'
#' ## Plot and place a square Hi-C plot
#' hicPlot <- plotHicSquare(
#'     data = IMR90_HiC_10kb, resolution = 10000,
#'     zrange = c(0, 70),
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19",
#'     x = 0.5, y = 0.5, width = 2.5, height = 2.5,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Add heatmap legend
#' annoHeatmapLegend(
#'     plot = hicPlot,
#'     x = 3.2, y = 0.5, width = 0.12, height = 1.2,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Annotate genome label
#' annoGenomeLabel(
#'     plot = hicPlot, x = 0.5, y = 3.03, scale = "Mb",
#'     just = c("left", "top")
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
annoHeatmapLegend <- function(plot, orientation = "v", fontsize = 8,
                                fontcolor = "dark grey", scientific = FALSE,
                                digits = 1, ticks = FALSE, breaks = NULL,
                                border = FALSE, x, y, width, height,
                                just = c("left", "top"),
                                default.units = "inches", params = NULL, ...) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors for annoHeatmapLegend
    errorcheck_annoHeatmapLegend <- function(heatmapLegend, orientation) {

        ## checking min_val and max val
        if (heatmapLegend$min_val >
            heatmapLegend$max_val) {
            warning("/'min_val/' is larger than /'max_val/'. ",
                    "Legend labels may be incorrect.", call. = FALSE)
        }

        ## check proper orientation
        if (!orientation %in% c("v", "h")) {
            stop("Invalid /'orientation/' parameter. Options are 'v' or 'h'.",
                call. = FALSE
            )
        }
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    heatmapLegendInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "heatmapLegendInternal"
    )

    ## Set gp
    heatmapLegendInternal$gp <-
        gpar(fontsize = heatmapLegendInternal$fontsize)
    heatmapLegendInternal$gp <- setGP(
        gpList = heatmapLegendInternal$gp,
        params = heatmapLegendInternal, ...
    )
    if ("col" %in% names(heatmapLegendInternal$gp)) {
        heatmapLegendInternal$gp$linecol <- heatmapLegendInternal$gp$col
    } else {
        heatmapLegendInternal$gp$linecol <- "dark grey"
    }
    heatmapLegendInternal$gp$col <- heatmapLegendInternal$fontcolor

    ## Justification
    heatmapLegendInternal$just <- 
        justConversion(just = heatmapLegendInternal$just)
    
    # =========================================================================
    # INITIAL ERRORS
    # =========================================================================

    if (is.null(heatmapLegendInternal$plot)) {
        stop("argument \"plot\" is missing, with no default.", call. = FALSE)
    }

    if (is.null(heatmapLegendInternal$plot$color_palette)) {
        stop("Cannot add heatmap legend to an input plot ",
            "that does not have a color palette.", call. = FALSE)
    }

    if (is.null(heatmapLegendInternal$plot$zrange)) {
        stop("Cannot add heatmap legend to an input plot ",
            "that does not have a zrange.", call. = FALSE)
    }

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    heatmapLegend <- structure(list(
        color_palette = heatmapLegendInternal$plot$color_palette,
        min_val = heatmapLegendInternal$plot$zrange[1],
        max_val = heatmapLegendInternal$plot$zrange[2],
        x = heatmapLegendInternal$x,
        y = heatmapLegendInternal$y,
        width = heatmapLegendInternal$width,
        height = heatmapLegendInternal$height,
        just = heatmapLegendInternal$just,
        grobs = NULL
    ), class = "heatmapLegend")

    # =========================================================================
    # CALL ERRORS
    # =========================================================================

    check_page(error = "Must have a `plotgardener` page with a plot before
                adding a heatmap legend.")
    errorcheck_annoHeatmapLegend(
        heatmapLegend = heatmapLegend,
        orientation = heatmapLegendInternal$orientation
    )
    if (is.null(heatmapLegend$x)) {
        stop("argument \"x\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(heatmapLegend$y)) {
        stop("argument \"y\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(heatmapLegend$width)) {
        stop("argument \"width\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(heatmapLegend$height)) {
        stop("argument \"height\" is missing, with no default.",
            call. = FALSE
        )
    }

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    heatmapLegend <- defaultUnits(
        object = heatmapLegend,
        default.units = heatmapLegendInternal$default.units
    )

    # =========================================================================
    # VIEWPORTS
    # =========================================================================
    ## Convert coordinates into same units as page
    page_coords <- convert_page(object = heatmapLegend)

    ## Make viewport name
    currentViewports <- current_viewports()
    vp_name <- paste0(
        "heatmapLegend",
        length(grep(
            pattern = "heatmapLegend",
            x = currentViewports
        )) + 1
    )

    ## Make viewport
    vp <- viewport(
        height = page_coords$height, width = page_coords$width,
        x = page_coords$x, y = page_coords$y,
        just = heatmapLegend$just, name = vp_name
    )

    pushViewport(vp)

    # =========================================================================
    # SCALE COLORS
    # =========================================================================

    ## Linear scaling
    minVal <- heatmapLegend$min_val
    maxVal <- heatmapLegend$max_val

    ## Log scaling
    if (!is.null(heatmapLegendInternal$plot$colorTrans)) {
        if (grepl("log", heatmapLegendInternal$plot$colorTrans) == TRUE) {
            logBase <- utils::type.convert(gsub(
                "log", "",
                heatmapLegendInternal$plot$colorTrans
            ), as.is = TRUE)
            if (is.na(logBase)) {
                logBase <- exp(1)
            }

            minVal <- log(heatmapLegend$min_val, base = logBase)
            maxVal <- log(heatmapLegend$max_val, base = logBase)
        }
    }

    color_scale <- mapColors(
        vector = seq(minVal, maxVal, length.out = 100),
        palette = heatmapLegend$color_palette
    )

    # =========================================================================
    # TICK BREAKS
    # ==========================================================================

    if (heatmapLegendInternal$ticks == TRUE) {
        if (!is.null(heatmapLegendInternal$breaks)) {
            breaks <- heatmapLegendInternal$breaks
            breaks <- breaks[which(breaks >= heatmapLegend$min_val &
                breaks <= heatmapLegend$max_val)]
        } else {
            breaks <- pretty(seq(minVal, maxVal, length.out = 100))
            if (!is.null(heatmapLegendInternal$plot$colorTrans)) {
                if (grepl(
                    "log",
                    heatmapLegendInternal$plot$colorTrans
                ) == TRUE) {
                    breaks <- pretty(seq(minVal, maxVal, length.out = 100), 20)
                    breaks <- breaks[which(breaks > minVal & breaks < maxVal)]
                    breaks <- breaks[seq((length(breaks) - 4), length(breaks))]
                    breaks <- logBase^breaks
                }
            }
        }

        heatmapLegend$ticks <- breaks
    }


    # =========================================================================
    # INITIALIZE GTREE
    # =========================================================================

    assign("heatmapLegend_grobs", gTree(vp = vp), envir = pgEnv)

    # =========================================================================
    # VERTICAL ORIENTATION
    # =========================================================================
    if (heatmapLegendInternal$orientation == "v") {
        digitLab <- textGrob(
            label = 0, x = 0.5, y = 0,
            just = c("center", "bottom"),
            default.units = "npc",
            gp = heatmapLegendInternal$gp
        )
        lowLab <- textGrob(
            label = format(heatmapLegend$min_val,
                scientific = heatmapLegendInternal$scientific,
                digits = heatmapLegendInternal$digits
            ),
            x = 0.5, y = 0, just = c("center", "bottom"),
            default.units = "npc",
            gp = heatmapLegendInternal$gp
        )
        highLab <- textGrob(
            label = format(heatmapLegend$max_val,
                scientific = heatmapLegendInternal$scientific,
                digits = heatmapLegendInternal$digits
            ),
            x = 0.5, y = 1, just = c("center", "top"),
            default.units = "npc",
            gp = heatmapLegendInternal$gp
        )

        lH <- convertHeight(
            x = grobHeight(lowLab),
            unitTo = "npc", valueOnly = TRUE
        )
        hH <- convertHeight(
            x = grobHeight(highLab),
            unitTo = "npc", valueOnly = TRUE
        )
        dH <- convertHeight(
            x = grobHeight(digitLab),
            unitTo = "npc", valueOnly = TRUE
        )

        new_height <- 1 - (lH + hH + dH)
        yMax <- 1 - (hH + (0.5 * dH))
        color_scale <- rasterGrob(rev(color_scale),
            width = page_coords$width,
            height = unit(new_height, "npc"),
            y = unit(yMax, "npc"), x = unit(0.5, "npc"), just = "top"
        )
        if (heatmapLegendInternal$ticks == TRUE) {
            tickVP <- viewport(
                x = unit(0.5, "npc"), y = unit(yMax, "npc"),
                width = page_coords$width,
                height = unit(new_height, "npc"),
                just = "top",
                yscale = c(
                    heatmapLegend$min_val,
                    heatmapLegend$max_val
                ),
                name = paste0(vp_name, "_ticks")
            )
            leftIDs <- seq(1, length(breaks))
            rightIDs <- seq(
                (length(breaks) + 1),
                (length(breaks) + length(breaks))
            )
            tickGrobs <- polylineGrob(
                x = unit(c(
                    rep(c(0, 0.15), length(breaks)),
                    (rep(c(0.85, 1), length(breaks)))
                ), "npc"),
                y = c(
                    unlist(lapply(breaks, rep, 2)),
                    unlist(lapply(breaks, rep, 2))
                ),
                id = c(
                    unlist(lapply(leftIDs, rep, 2)),
                    unlist(lapply(rightIDs, rep, 2))
                ),
                default.units = "native",
                gp = gpar(col = heatmapLegendInternal$gp$linecol),
                vp = tickVP
            )
        }

        if (heatmapLegendInternal$border == TRUE) {
            heatmapLegendInternal$gp$fill <- NA
            heatmapLegendInternal$gp$col <-
                heatmapLegendInternal$gp$linecol
            borderGrob <- rectGrob(
                y = unit(1 - (hH + (0.5 * dH)), "npc"),
                just = "top",
                width = page_coords$width,
                height = unit(new_height, "npc"),
                gp = heatmapLegendInternal$gp
            )
        }
    }

    # =========================================================================
    # HORIZONTAL ORIENTATION
    # =========================================================================
    if (heatmapLegendInternal$orientation == "h") {
        digitLab <- textGrob(
            label = 0, x = 0, y = 0.5,
            just = c("left", "center"), default.units = "npc",
            gp = heatmapLegendInternal$gp
        )
        lowLab <- textGrob(
            label = format(heatmapLegend$min_val,
                scientific = heatmapLegendInternal$scientific,
                digits = heatmapLegendInternal$digits
            ),
            x = 0, y = 0.5, just = c("left", "center"),
            default.units = "npc",
            gp = heatmapLegendInternal$gp
        )
        highLab <- textGrob(
            label = format(heatmapLegend$max_val,
                scientific = heatmapLegendInternal$scientific,
                digits = heatmapLegendInternal$digits
            ),
            x = 1, y = 0.5, just = c("right", "center"),
            default.units = "npc",
            gp = heatmapLegendInternal$gp
        )

        lW <- convertWidth(
            x = grobWidth(lowLab), unitTo = "npc",
            valueOnly = TRUE
        )
        hW <- convertWidth(
            x = grobWidth(highLab), unitTo = "npc",
            valueOnly = TRUE
        )
        dW <- convertWidth(
            x = grobWidth(digitLab), unitTo = "npc",
            valueOnly = TRUE
        )

        new_width <- 1 - (hW + lW + dW)
        xMin <- lW + (0.5 * dW)
        color_scale <- rasterGrob(matrix(
            data = color_scale,
            nrow = 1,
            ncol = length(color_scale)
        ),
        width = unit(new_width, "npc"),
        height = page_coords$height,
        x = unit(xMin, "npc"), just = "left"
        )

        if (heatmapLegendInternal$ticks == TRUE) {
            tickVP <- viewport(
                x = unit(xMin, "npc"), y = unit(0.5, "npc"),
                width = unit(new_width, "npc"),
                height = page_coords$height,
                just = "left",
                xscale = c(
                    heatmapLegend$min_val,
                    heatmapLegend$max_val
                ),
                name = paste0(vp_name, "_ticks")
            )
            bottomIDs <- seq(1, length(breaks))
            topIDs <- seq(
                (length(breaks) + 1),
                (length(breaks) + length(breaks))
            )
            tickGrobs <- polylineGrob(
                x = c(
                    unlist(lapply(breaks, rep, 2)),
                    unlist(lapply(breaks, rep, 2))
                ),
                y = unit(c(
                    rep(c(0, 0.15), length(breaks)),
                    rep(c(0.85, 1), length(breaks))
                ), "npc"),
                id = c(
                    unlist(lapply(bottomIDs, rep, 2)),
                    unlist(lapply(topIDs, rep, 2))
                ),
                default.units = "native",
                gp = gpar(col = heatmapLegendInternal$gp$linecol),
                vp = tickVP
            )
        }

        if (heatmapLegendInternal$border == TRUE) {
            heatmapLegendInternal$gp$fill <- NA
            heatmapLegendInternal$gp$col <-
                heatmapLegendInternal$gp$linecol
            borderGrob <- rectGrob(
                x = unit(lW + (0.5 * dW), "npc"),
                just = "left",
                width = unit(new_width, "npc"),
                height = page_coords$height,
                gp = heatmapLegendInternal$gp
            )
        }
    }

    ## Go back to root viewport
    upViewport()

    # =========================================================================
    # ADD GROBS TO GTREE AND ASSIGN TO OBJECT
    # =========================================================================

    ## Add grobs to gTree
    assign("heatmapLegend_grobs",
        setChildren(get("heatmapLegend_grobs", envir = pgEnv),
            children = gList(lowLab, highLab, color_scale)
        ),
        envir = pgEnv
    )
    if (heatmapLegendInternal$border == TRUE) {
        assign("heatmapLegend_grobs",
            addGrob(
                gTree = get("heatmapLegend_grobs", envir = pgEnv),
                child = borderGrob
            ),
            envir = pgEnv
        )
    }

    if (heatmapLegendInternal$ticks == TRUE) {
        assign("heatmapLegend_grobs",
            addGrob(
                gTree = get("heatmapLegend_grobs", envir = pgEnv),
                child = tickGrobs
            ),
            envir = pgEnv
        )
    }

    ## Add grobs to object
    heatmapLegend$grobs <- get("heatmapLegend_grobs", envir = pgEnv)
    grid.draw(heatmapLegend$grobs)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("heatmapLegend[", vp_name, "]")
    invisible(heatmapLegend)
}

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
    fig.align = "center",
    fig.width = 3,
    fig.height = 3,
    collapse = TRUE,
    warning = FALSE,
    message = FALSE
)
library(grid)
library(plotgardener)
library(plotgardenerData)

## ----hic_quickplot, eval=TRUE, echo=TRUE, message=FALSE-----------------------
## Load plotgardener
library(plotgardener)

## Load example Hi-C data
library(plotgardenerData)
data("IMR90_HiC_10kb")

## Quick plot Hi-C data
plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19"
)

## ----signal_quickplot, eval=TRUE, echo=TRUE, message=FALSE--------------------
## Load plotgardener
library(plotgardener)

## Load example signal data
library(plotgardenerData)
data("IMR90_ChIP_H3K27ac_signal")

## Quick plot signal data
plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19"
)

## ----gene_quickplot, eval=TRUE, echo=TRUE, message=FALSE----------------------
## Load plotgardener
library(plotgardener)

## Load hg19 genomic annotation packages
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)

## Quick plot genes
plotGenes(
    assembly = "hg19",
    chrom = "chr21", chromstart = 28000000, chromend = 30300000
)

## ----gwas_quickplot, eval=TRUE, echo=TRUE, message=FALSE----------------------
## Load plotgardener
library(plotgardener)

## Load hg19 genomic annotation packages
library(TxDb.Hsapiens.UCSC.hg19.knownGene)

## Load example GWAS data
library(plotgardenerData)
data("hg19_insulin_GWAS")

## Quick plot GWAS data
plotManhattan(
    data = hg19_insulin_GWAS, 
    assembly = "hg19",
    fill = c("steel blue", "grey"),
    ymax = 1.1, cex = 0.20
)

## ----quickpage, echo=TRUE, fig.height=4, fig.width=4, message=FALSE-----------
pageCreate(width = 3.25, height = 3.25, default.units = "inches")

## ----eval=FALSE, echo=TRUE, message=FALSE-------------------------------------
# data("IMR90_HiC_10kb")
# hicPlot <- plotHicSquare(
#     data = IMR90_HiC_10kb,
#     chrom = "chr21", chromstart = 28000000, chromend = 30300000,
#     assembly = "hg19",
#     x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
# )

## ----quickpageHic, echo=FALSE, fig.height=4, fig.width=4, message=FALSE-------
pageCreate(width = 3.25, height = 3.25, default.units = "inches")
data("IMR90_HiC_10kb")
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)

## ----eval=FALSE, echo=TRUE, message=FALSE-------------------------------------
# annoHeatmapLegend(
#     plot = hicPlot,
#     x = 2.85, y = 0.25, width = 0.1, height = 1.25, default.units = "inches"
# )
# 
# annoGenomeLabel(
#     plot = hicPlot,
#     x = 0.25, y = 2.75, width = 2.5, height = 0.25, default.units = "inches"
# )

## ----quickpageAnno, echo=FALSE, fig.height=4, fig.width=4, message=FALSE------
pageCreate(width = 3.25, height = 3.25, default.units = "inches")
data("IMR90_HiC_10kb")
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)
annoHeatmapLegend(
    plot = hicPlot,
    x = 2.85, y = 0.25, width = 0.1, height = 1.25, default.units = "inches"
)

annoGenomeLabel(
    plot = hicPlot,
    x = 0.25, y = 2.75, width = 2.5, height = 0.25, default.units = "inches"
)

## ----eval=FALSE, echo=TRUE, message=FALSE-------------------------------------
# pageGuideHide()

## ----quickpageHide, echo=FALSE, fig.height=4, fig.width=4, message=FALSE------
pageCreate(
    width = 3.25, height = 3.25, default.units = "inches",
    xgrid = 0, ygrid = 0, showGuides = FALSE
)
data("IMR90_HiC_10kb")
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)
annoHeatmapLegend(
    plot = hicPlot,
    x = 2.85, y = 0.25, width = 0.1, height = 1.25, default.units = "inches"
)

annoGenomeLabel(
    plot = hicPlot,
    x = 0.25, y = 2.75, width = 2.5, height = 0.25, default.units = "inches"
)

## ----eval=FALSE, echo=TRUE, message=FALSE-------------------------------------
# pdf(width = 3.25, height = 3.25)
# 
# pageCreate(width = 3.25, height = 3.25, default.units = "inches")
# data("IMR90_HiC_10kb")
# hicPlot <- plotHicSquare(
#     data = IMR90_HiC_10kb,
#     chrom = "chr21", chromstart = 28000000, chromend = 30300000,
#     assembly = "hg19",
#     x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
# )
# annoHeatmapLegend(
#     plot = hicPlot,
#     x = 2.85, y = 0.25, width = 0.1, height = 1.25, default.units = "inches"
# )
# 
# annoGenomeLabel(
#     plot = hicPlot,
#     x = 0.25, y = 2.75, width = 2.5, height = 0.25, default.units = "inches"
# )
# pageGuideHide()
# 
# dev.off()

## -----------------------------------------------------------------------------
sessionInfo()

## Define a function for `pgParams` and parameter parsing logic
# @param params pgParams object to override default arguments of
# parent function
# @param defaultArgs List of defaults for each argument of parent function
# @param declaredArgs List of arguments to override all others
# @param class Name of internal function class
parseParams <- function(params = params,
                        defaultArgs = formals(eval(match.call()[[1]])),
                        declaredArgs = lapply(match.call()[-1],
                            eval.parent,
                            n = 2
                        ),
                        class) {
    ## Remove 'params' and '...' from defaultArgs and declaredArgs
    defaultArgs[["params"]] <- NULL
    declaredArgs[["params"]] <- NULL

    if ("..." %in% names(defaultArgs)) {
        defaultArgs[["..."]] <- NULL
    }
    if ("..." %in% names(declaredArgs)) {
        declaredArgs[["..."]] <- NULL
    }

    ## If params are supplied override matching defaultArguments
    if (!is.null(params)) {
        if (is(params, "pgParams")) {
            ## Replace matching defaultArgs with params
            matchedParams <- params[na.omit(sort(match(
                names(defaultArgs),
                names(params)
            )))]
            defaultArgs[na.omit(match(
                names(params),
                names(defaultArgs)
            ))] <- matchedParams
        } else {
            warning("Input object ignored. Object must be a",
                " \'pgParams\' class object.",
                call. = FALSE
            )
        }
    }

    ## Replace default args with declared args
    if (length(declaredArgs) != 0) {
        suppressWarnings(defaultArgs[names(defaultArgs)
        %in% names(declaredArgs)] <- declaredArgs)
    }
    ## Set arguments without default to NULL
    unset <- unlist(lapply(defaultArgs, is.name))
    defaultArgs[unset] <- lapply(lapply(defaultArgs[unset], deparse), as.null)

    ## Add arguments to object and evaluate
    object <- structure(
        .Data = defaultArgs,
        class = class
    )
    object <- lapply(object, eval, rlang::ns_env("plotgardener"))

    return(object)
}

## Define a function that parses gpar parameters
# @param gpList Input gpar() class list
# @param params Internal function object
# @param ... Additional arguments passed in from parent function call
setGP <- function(gpList, params, ...) {
    availGPs <- c("fill", "col", "lty", "lwd", "cex", "fontsize", 
                  "lineheight", "font", "fontfamily", "alpha", "lineend",
                  "linejoin", "linemitre", "lex")
    gpMatches <- params[which(names(params) %in% availGPs)]
    gpList[names(gpMatches)] <- gpMatches
    gpList[names(list(...))] <- list(...)
    ## Reset with fontface first
    if ("fontface" %in% names(gpList)) {
        otherParams <- gpList
        gpList <- gpar(fontface = gpList$fontface)
        gpList[names(otherParams)] <- otherParams
        gpList$font <- NULL
    }

    return(gpList)
}

## Define a function that checks chromstart/chromend 
## region errors
regionErrors <- function(chromstart, chromend){
    
    ## Can't have only one NULL chromstart or chromend
    if ((is.null(chromstart) &
            !is.null(chromend)) |
            (is.null(chromend) &
            !is.null(chromstart))) {
        stop("Cannot have one \'NULL\' \'chromstart\' or ",
            "\'chromend\'.", call. = FALSE)
    }
    
    if (!is.null(chromstart) & !is.null(chromend)){
        
        ## Can't have a 0 bp wide region
        if (chromstart == chromend) {
            stop("Genomic region is 0 bp wide.", call. = FALSE)
        }
        
        ## start can't be larger than end
        if (chromstart > chromend) {
            stop("\'chromstart\' should not be larger than \'chromend\'.",
                call. = FALSE
            )
        }
        
    }
}

## Define a function that checks just and gets corresponding numeric value
justConversion <- function(just){
    
    ## Convert input just to comma-separated string for finding in dataframe
    just <- paste(just, collapse = ", ")
    
    ## Valid combinations of string and numeric justifications
    validJusts <- c(plotJusts$just, plotJusts$numeric)
    
    ## Throw error if not a valid Just
    if (!just %in% validJusts){
        stop("Invalid `just` option.", call. = FALSE)
    }
    
    ## Convert to robust numeric values
    if (!just %in% plotJusts$numeric){
        just <- plotJusts[plotJusts$just == just,]$numeric
    }
    
    just <- as.numeric(unlist(strsplit(just, split = ", ")), 
                                as.is = TRUE)
    
    return(just)
}

## Define a function that checks the format of range parameters
rangeErrors <- function(range){
    
    if (!is.null(range)){
        
        ## Needs to be a vector
        if (!is.vector(range)) {
            stop("\'(z)range\' must be a vector of length 2.", call. = FALSE)
        }
        
        ## Vector needs to be length 2
        if (length(range) != 2) {
            stop("\'(z)range\' must be a vector of length 2.", call. = FALSE)
        }
        
        ## Vector needs to be numbers
        if (!is.numeric(range)) {
            stop("\'(z)range\' must be a vector of two numbers.",
                call. = FALSE
            )
        }
        
        ## second value should be larger than the first value
        if (range[1] >= range[2]) {
            stop("\'(z)range\' must be a vector of two numbers ",
                "in which the 2nd value is larger than the 1st.",
                call. = FALSE
            )
        }
        
    }
    
}

## Define a function that checks for hic input errors
hicErrors <- function(hic, norm){
    
    ## if it's a dataframe or datatable, it needs to be properly formatted
    if (is(hic, "data.frame") && ncol(hic) != 3) {
        stop("Invalid dataframe format.  Input a dataframe with 3 ",
            "columns: chrA, chrB, counts.", call. = FALSE)
    }
    
    if (!is(hic, "data.frame")) {
        
        ## if it's a file path, it needs to be a .hic, .cool, or .mcool file
        if (!file_ext(hic) %in% c("hic", "cool", "mcool")) {
            stop("Invalid input. File must have a \".hic\", \".cool\", or",
                 "\".mcool\" extension.",
                 call. = FALSE
            )
        }
        
        ## if it's a valid file, it needs to have a valid norm
        if (is.null(norm)) {
            stop("If providing .hic file, please specify \'norm\'.",
                call. = FALSE
            )
        }
    }
}

## Define a function to get the assembly info based on a string (ie default)
## or assembly object
# @param assembly assembly input from a plot object
parseAssembly <- function(assembly) {
    
    availDefaults <- default_genomePackages$Genome

    ## If it's just a string, get the default
    if (is(assembly, "character")) {
        if (!assembly %in% availDefaults) {
            stop("\'assembly\' not available as a default. Please make a ",
                "assembly object with `assembly()` or pick an assembly ",
                "from the defaults listed with `genomes()`.",
                call. = FALSE
            )
        }

        assemblyData <- default_genomePackages[
            default_genomePackages$Genome == assembly,]
        assemblyData <- assembly(
            Genome = assemblyData$Genome,
            TxDb = assemblyData$TxDb,
            OrgDb = assemblyData$OrgDb,
            gene.id.column = assemblyData$gene.id.column,
            display.column = assemblyData$display.column,
            BSgenome = assemblyData$BSgenome
        )

        ## If it's a assembly object, use those
    } else if (is(assembly, "assembly")) {
        assemblyData <- assembly
    } else {
        stop("Invalid \'assembly\' type. Please make a assembly object ",
            "with `assembly()` or input an assembly string from the ",
            "defaults listed with `genomes()`.",
            call. = FALSE
        )
    }


    return(assemblyData)
}

## Define a function that converts coordinates/dimensions
## for standard plot objects into default units
# @param object Function object containing x, y, width, height valus
# @param default.units String value of default.units
defaultUnits <- function(object, default.units) {
    if (!(is.null(object$x)) & !(is.null(object[["y"]]))) {
        if (!"unit" %in% class(object$x)) {
            if (!is.numeric(object$x)) {
                stop("x-coordinate is neither a unit object nor a ",
                    "numeric value. Cannot place object.",
                    call. = FALSE
                )
            }

            if (is.null(default.units)) {
                stop("x-coordinate detected as numeric.\'default.units\' ",
                    "must be specified.",
                    call. = FALSE
                )
            }

            object$x <- unit(object$x, default.units)
        }


        if (!"unit" %in% class(object$y)) {

            ## Check for "below" y-coord
            if (grepl("b", object$y) == TRUE) {
                if (grepl("^[ac-zA-Z]+$", object$y) == TRUE) {
                    stop("\'below\' y-coordinate detected with additional ",
                        "letters. Cannot parse y-coordinate.",
                        call. = FALSE
                    )
                }

                if (is.na(suppressWarnings(as.numeric(gsub("b", "", 
                                                    object$y))))) {
                    stop("\'below\' y-coordinate does not have a numeric ",
                        "associated with it. Cannot parse y-coordinate.",
                        call. = FALSE
                    )
                }

                object$y <- plot_belowY(y_coord = object$y)
            } else {
                if (!is.numeric(object$y)) {
                    stop("y-coordinate is neither a unit object nor a ",
                        "numeric value. Cannot place plot.",
                        call. = FALSE
                    )
                }

                if (is.null(default.units)) {
                    stop("y-coordinate detected as numeric. \'default.units\' ",
                        "must be specified.",
                        call. = FALSE
                    )
                }

                object$y <- unit(object$y, default.units)
            }
        }

        if (!"unit" %in% class(object$width)) {
            if (!is.numeric(object$width)) {
                stop("width is neither a unit object nor a numeric value. ",
                    "Cannot place plot.",
                    call. = FALSE
                )
            }

            if (is.null(default.units)) {
                stop("width detected as numeric. \'default.units\' must ",
                    "be specified.",
                    call. = FALSE
                )
            }

            object$width <- unit(object$width, default.units)
        }

        if (!"unit" %in% class(object$height)) {
            if (!is.numeric(object$height)) {
                stop("height is neither a unit object nor a numeric ",
                    "value. Cannot place plot.",
                    call. = FALSE
                )
            }

            if (is.null(default.units)) {
                stop("height detected as numeric.v\'default.units\' ",
                    "must be specified.",
                    call. = FALSE
                )
            }

            object$height <- unit(object$height, default.units)
        }
    }

    return(object)
}

## Define a function that converts coordinates/dimensions
## for other miscellaneous elements into default units
# @param value value to be checked/converted
# @param name string name identifying kind of value
# @param default.units String value of default.units
# @param funName String value of function name called within
# @param yBelow Logical indicating whether to allow "below" y coords
misc_defaultUnits <- function(value, name, default.units,
                            funName = NULL, yBelow = TRUE) {
    if (!"unit" %in% class(value)) {
        ## Check for y
        if (grepl("y", name)) {
            ## Check for "below" y-coord
            if (all(grepl("b", value))) {
                if (yBelow == FALSE) {
                    stop("\'below\' ", name, "-coordinate detected. Cannot ",
                        "parse \'below\' ", name, "-coordinate for ",
                        funName, ".",
                        call. = FALSE
                    )
                } else {
                    ## "below" y-coord additional letters
                    if (any(grepl("^[ac-zA-Z]+$", value))) {
                        stop("\below\' ", name, "-coordinate detected with ",
                            "additional letters. Cannot parse ",
                            name, "-coordinate.",
                            call. = FALSE
                        )
                    }
                    ## "below" y-coord missing a number
                    if (any(is.na(suppressWarnings(as.numeric(gsub("b", "", 
                                                            value)))))) {
                        stop("\below\' ", name, "-coordinate does not have ",
                            "a numeric associated with it. Cannot parse ",
                            name, "-coordinate.",
                            call. = FALSE
                        )
                    }

                    value <- unit(
                        unlist(lapply(value, plot_belowY)),
                        get("page_units", envir = pgEnv)
                    )
                }
            } else {
                ## y-coord, not detected as "below"
                if (!is.numeric(value)) {
                    stop(name, "-coordinate is neither a unit object nor a ",
                        "numeric value. Cannot place plot.",
                        call. = FALSE
                    )
                }
                if (is.null(default.units)) {
                    stop(name, "-coordinate detected as numeric. ",
                        "\'default.units\' must be specified.",
                        call. = FALSE
                    )
                }
                value <- unit(value, default.units)
            }
        } else {
            if (grepl("x", name)) {
                name <- paste0(name, "-coordinate")
            }

            if (!is.numeric(value)) {
                stop(name, " is neither a unit object nor a ",
                    "numeric value. Cannot place plot.",
                    call. = FALSE
                )
            }
            if (is.null(default.units)) {
                stop(name, " detected as numeric. ",
                    "\'default.units\' must be specified.",
                    call. = FALSE
                )
            }
            value <- unit(value, default.units)
        }
    }

    return(value)
}

## Define a function to catch errors for functions that don't handle
## colorby and for colorby related errors
checkColorby <- function(fill, colorby = TRUE, data = NULL){
    ## colorby not allowed for some functions
    if (colorby == FALSE){
        if (is(fill, "colorby")){
            stop("`fill` cannot be a `colorby` object for this function.",
                call. = FALSE)
        }
    } else {
        ## If colorby allowed, check for appropriate colorby class,
        ## column in data, and number of colorby column in data
        if (all(c(!is(fill, "character"), !is(fill, "factor"), !is.na(fill)))){
            
            if (!is(fill, "colorby")){
                stop("`colorby` not of class \"colorby\". Input colorby ",
                    "information with `colorby()`.", call. = FALSE)
            }
            
            ## Check for `colorby` column
            if (!any(colnames(data) == fill$column)) {
                stop("`colorby` column not found in data. Check ",
                    "`colorby` column name.",
                    call. = FALSE
                )
            }
            
            if (length(which(colnames(data) == fill$column)) > 1) {
                stop("Multiple matching `colorby` columns found in data. ",
                    "Please provide `colorby` column name with only ",
                    "one occurrence.", call. = FALSE)
            }
            
        }
        
    }
    
}

test_that("parseParams", {
    
    test <- function(params = NULL, alpha, hic, altchrom = 1, altchromend = NULL, 
                     arch = "blah", ...) {
        ## Access default arguments of parent function like this:
        defArgs <- formals(eval(match.call()[[1]]))
        ## Access user-declared arguments of parent function like this:
        decArgs <- lapply(match.call()[-1], eval)
        ## Call parseParams like this:
        x <- plotgardener:::parseParams(params = params, defaultArgs = defArgs, 
                                    declaredArgs = decArgs,
                                    class = "object")
        ## Crete internal object like this:
        object <- structure(
            .Data = x,
            class = "object"
        )
        return(object)
    }
    
    ## All default parameters
    expect_equal(test(),
                 structure(
                     .Data = list("alpha" = NULL,
                     "hic" = NULL,
                     "altchrom" = 1,
                     "altchromend" = NULL,
                     "arch" = "blah"),
                     class = "object"
                 ))
    
    ## Default argument replaced
    expect_equal(test(arch = "not_blah"),
                 structure(
                     .Data = list("alpha" = NULL,
                                  "hic" = NULL,
                                  "altchrom" = 1,
                                  "altchromend" = NULL,
                                  "arch" = "not_blah"),
                     class = "object"
                 ))
    
    ## Multiple default replacements
    expect_equal(test(alpha = 10, altchrom = 2),
                 structure(
                     .Data = list("alpha" = 10,
                                  "hic" = NULL,
                                  "altchrom" = 2,
                                  "altchromend" = NULL,
                                  "arch" = "blah"),
                     class = "object"
                 ))
    ## Overriding pgParams parameter
    expect_equal(test(params = pgParams(alpha = 100), arch = "not_blah", alpha = 10),
                 structure(
                     .Data = list("alpha" = 10,
                                  "hic" = NULL,
                                  "altchrom" = 1,
                                  "altchromend" = NULL,
                                  "arch" = "not_blah"),
                     class = "object"
                 ))
    
    ## Warning without a pgParams object
    expect_warning(test(params = c(hic = "no")))
})

test_that("setGP", {
    
    ## Empty gpar
    expect_equal(plotgardener:::setGP(
        gpList = gpar(),
        params = NULL
    ), gpar())
    
    ## One gpar parameter replaced
    expect_equal(plotgardener:::setGP(
        gpList = gpar(),
        params = NULL,
        lwd = 2
    ), gpar(lwd = 2))

    ## Multiple gpar parameters replaced
    expect_equal(plotgardener:::setGP(
        gpList = gpar(),
        params = NULL,
        lwd = 2, lty = 2
    ), gpar(lwd = 2, lty = 2))
    
})

test_that("regionErrors", {
    
    ## No errors
    expect_silent(plotgardener:::regionErrors(chromstart = 1000000,
                               chromend = 2000000))
    ## 0 bp wide region error
    expect_error(plotgardener:::regionErrors(chromstart = 1000000,
                                             chromend = 1000000))
    ## One null chromstart/chromend
    expect_error(plotgardener:::regionErrors(chromstart = 1000000,
                                            chromend = NULL))
    
    ## chromstart bigger than chromend
    expect_error(plotgardener:::regionErrors(chromstart = 2000000,
                                            chromend = 1000000))
})

test_that("justConversion", {
    
    ## left, top should be 0, 1
    expect_equal(plotgardener:::justConversion(just = c("left", "top")),
                 c(0, 1))
    
    ## top, left should be 0, 1
    expect_equal(plotgardener:::justConversion(just = c("top", "left")),
                 c(0, 1))
    
    ## Invalid just option error
    expect_error(plotgardener:::justConversion(just = "invalid"))
    
})

test_that("parseAssembly", {
    
    ## Invalid default assembly
    expect_error(plotgardener:::parseAssembly(assembly = "none"))
    
    ## Default hg19 assembly
    expect_equal(plotgardener:::parseAssembly(assembly = "hg19"),
                 structure(.Data = list("Genome" = "hg19",
                                        "TxDb" = "TxDb.Hsapiens.UCSC.hg19.knownGene",
                                        "OrgDb" = "org.Hs.eg.db",
                                        "gene.id.column" = "ENTREZID",
                                        "display.column" = "SYMBOL",
                                        "BSgenome" = "BSgenome.Hsapiens.UCSC.hg19"),
                           class = "assembly"))
    
    ## Input bb_assembly object just returns itself
    assemblyobject <- assembly(Genome = "testing",
                                  TxDb = "TxDb",
                                  OrgDb = "OrgDb")
    
    expect_equal(plotgardener:::parseAssembly(assembly = assemblyobject),
                 structure(.Data = list("Genome" = "testing",
                                        "TxDb" = "TxDb",
                                        "OrgDb" = "OrgDb",
                                        "gene.id.column" = "ENTREZID",
                                        "display.column" = "SYMBOL"),
                           class = "assembly"))
})

test_that("defaultUnits", {
    
    ## No coordinates or dimensions need to be converted
    testObject <- list("x" = unit(1, "inches"),
                       "y" = unit(2, "inches"),
                       "width" = unit(3, "npc"),
                       "height" = unit(4, "cm"))
    expect_equal(plotgardener:::defaultUnits(object = testObject, 
                                         default.units = "inches"),
                 testObject)
    expect_equal(plotgardener:::misc_defaultUnits(value = unit(1, "inches"),
                                              name = "x0",
                                              default.units = "npc"),
                 unit(1, "inches"))
    
    ## Some coordinates converted to default units
    testObject <- list("x" = 1,
                       "y" = unit(2, "inches"),
                       "width" = 3,
                       "height" = unit(4, "cm"))
    expect_equal(plotgardener:::defaultUnits(object = testObject, 
                                         default.units = "inches"),
                 list("x" = unit(1, "inches"),
                      "y" = unit(2, "inches"),
                      "width" = unit(3, "inches"),
                      "height" = unit(4, "cm")))
    expect_equal(plotgardener:::misc_defaultUnits(value = 1,
                                              name = "x0",
                                              default.units = "npc"),
                 unit(1, "npc"))
    
    ## below y-coordinate errors
    testObject <- list("x" = 1,
                       "y" = "plb",
                       "width" = 3,
                       "height" = unit(4, "cm"))
    expect_error(plotgardener:::defaultUnits(object = testObject,
                                         default.units = "inches"))
    expect_error(plotgardener:::misc_defaultUnits(value = "plb",
                                              name = "y0",
                                              default.units = "npc"))
})

#' Plot genomic coordinates along the x or y-axis of a plotgardener plot
#' 
#' @usage plotGenomeLabel(
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     assembly = "hg38",
#'     fontsize = 10,
#'     fontcolor = "black",
#'     linecolor = "black",
#'     margin = unit(1, "mm"),
#'     scale = "bp",
#'     commas = TRUE,
#'     sequence = TRUE,
#'     boxWidth = 0.5,
#'     axis = "x",
#'     at = NULL,
#'     tcl = 0.5,
#'     x,
#'     y,
#'     length,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     params = NULL,
#'     ...
#' )
#'
#' @param chrom Chromosome of genome label, as a string,
#' or a character vector of chromosomes for a whole genome Manhattan plot.
#' @param chromstart Integer start of genome label.
#' @param chromend Integer end of genome label.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' @param fontsize A numeric specifying text fontsize in points.
#' Default value is \code{fontsize = 10}.
#' @param fontcolor A character value indicating the color for text.
#' Default value is \code{fontcolor = "black"}.
#' @param linecolor A character value indicating the color of
#' the genome label axis. Default value is \code{linecolor = "black"}.
#' @param margin A numeric or unit vector specifying space between axis
#' and coordinate labels. Default value is \code{margin = unit(1, "mm")},
#' @param scale A character value indicating the scale of the coordinates
#' along the genome label. Default value is \code{scale = "bp"}. Options are:
#' \itemize{
#' \item{\code{"bp"}: }{base pairs.}
#' \item{\code{"Kb"}: }{kilobase pairs. 1 kilobase pair is equal to
#' 1000 base pairs.}
#' \item{\code{"Mb"}: }{megabase pairs. 1 megabase pair is equal to
#' 1000000 base pairs.}
#' }
#' @param commas A logical value indicating whether to include commas in
#' start and stop labels. Default value is \code{commas = TRUE}.
#' @param sequence A logical value indicating whether to include sequence
#' information above the label of an x-axis (only at appropriate resolutions).
#' @param boxWidth A numeric value indicating the width of the boxes
#' representing sequence information at appropriate resolutions.
#' Default value is \code{boxWidth = 0.5}.
#' @param axis A character value indicating along which axis to
#' add genome label. Sequence information will not be displayed along a y-axis.
#' Default value is \code{axis = "x"}.
#' Options are:
#' \itemize{
#' \item{\code{"x"}: }{Genome label will be plotted along the x-axis.}
#' \item{\code{"y"}: }{Genome label will be plotted along the y-axis.
#' This is typically used for a square Hi-C plot made with
#' \code{plotHicSquare}.}
#' }
#' @param at A numeric vector of x-value locations for tick marks.
#' @param tcl A numeric specifying the length of tickmarks as a
#' fraction of text height. Default value is \code{tcl = 0.5}.
#' @param x A numeric or unit object specifying genome label x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying genome label y-location.
#' The character value will
#' place the genome label y relative to the bottom of the most recently
#' plotted plot according to the units of the plotgardener page.
#' @param length A numeric or unit object specifying length of
#' genome label axis.
#' @param just Justification of genome label relative to its (x, y)
#' location. If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"},
#' and \code{"top"}. Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to
#' use if \code{x}, \code{y}, or \code{length} are only given as numerics.
#' Default value is \code{default.units = "inches"}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters or digit specifications.
#' See \link[grid]{gpar} and \link[base]{formatC}.
#'
#' @return Returns a \code{genomeLabel} object containing
#' relevant genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load hg19 genomic annotation packages
#' library("TxDb.Hsapiens.UCSC.hg19.knownGene")
#' library("org.Hs.eg.db")
#' library("BSgenome.Hsapiens.UCSC.hg19")
#'
#' ## Create page
#' pageCreate(width = 5, height = 3, default.units = "inches")
#'
#' ## Plot and place gene track on page
#' genesPlot <- plotGenes(
#'     chrom = "chr8",
#'     chromstart = 1000000, chromend = 2000000,
#'     assembly = "hg19", fill = c("grey", "grey"),
#'     fontcolor = c("grey", "grey"),
#'     x = 0.5, y = 0.25, width = 4, height = 1,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Plot x-axis genome labels at different scales
#' plotGenomeLabel(
#'     chrom = "chr8",
#'     chromstart = 1000000, chromend = 2000000,
#'     assembly = "hg19",
#'     scale = "Mb",
#'     x = 0.5, y = 1.25, length = 4, just = c("left", "top"),
#'     default.units = "inches"
#' )
#' plotGenomeLabel(
#'     chrom = "chr8",
#'     chromstart = 1000000, chromend = 2000000,
#'     assembly = "hg19",
#'     scale = "Kb",
#'     x = 0.5, y = 1.5, length = 4, just = c("left", "top"),
#'     default.units = "inches"
#' )
#' plotGenomeLabel(
#'     chrom = "chr8",
#'     chromstart = 1000000, chromend = 2000000,
#'     assembly = "hg19",
#'     scale = "bp",
#'     x = 0.5, y = 1.75, length = 4, just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Plot a different genomic label region, zooming in enough
#' ## to see base pairs
#' plotGenomeLabel(
#'     chrom = "chr8",
#'     chromstart = 1000000, chromend = 1000050,
#'     assembly = "hg19",
#'     x = 0.25, y = 2.2, length = 4.5
#' )
#' plotGenomeLabel(
#'     chrom = "chr8",
#'     chromstart = 1000000, chromend = 1000020,
#'     assembly = "hg19",
#'     x = 0, y = 2.6, length = 5
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
plotGenomeLabel <- function(chrom, chromstart = NULL, chromend = NULL,
                            assembly = "hg38", fontsize = 10,
                            fontcolor = "black", linecolor = "black",
                            margin = unit(1, "mm"),
                            scale = "bp", commas = TRUE, sequence = TRUE,
                            boxWidth = 0.5, axis = "x", at = NULL,
                            tcl = 0.5, x, y, length,
                            just = c("left", "top"),
                            default.units = "inches", params = NULL, ...) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors for plotGenomeLabel
    errorcheck_plotGenomeLabel <- function(scale, ticks, object, axis) {

        ## Check that scale is an appropriate value
        if (!scale %in% c("bp", "Kb", "Mb")) {
            stop("Invalid \'scale\'. Options are \'bp\', \'Kb\', or \'Mb\'.",
                call. = FALSE
            )
        }

        if (!is.null(ticks)) {

            ## Can't have ticks if label is genome assembly for manhattan plot
            if (is.null(object$chrom)) {
                stop("Cannot add tick marks to a genome label of entire ",
                    "genome assembly.", call. = FALSE)
            }

            ## Make sure ticks fall within the chromstart to chromend range
            if (range(ticks)[1] < object$chromstart |
                range(ticks)[2] > object$chromend) {
                stop("Given tick locations do not fall within ",
                    "the genomic range.",
                    call. = FALSE
                )
            }
        }

        if (!axis %in% c("x", "y")) {
            stop("Invalid \'axis\'. Options are \'x\' or \'y\'.", call. = FALSE)
        }
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    genomeLabelInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "genomeLabelInternal"
    )

    ## Parsing for "space" from input Manhattan plot from annoGenomeLabel
    additionalParams <- list(...)
    if ("space" %in% names(additionalParams)) {
        genomeLabelInternal$space <- additionalParams$space
    }

    ## Assign "gp"
    genomeLabelInternal$gp <- gpar(
        fontsize = genomeLabelInternal$fontsize,
        col = genomeLabelInternal$linecolor,
        fontcolor = genomeLabelInternal$fontcolor,
        lineend = "butt"
    )
    genomeLabelInternal$gp <- setGP(
        gpList = genomeLabelInternal$gp,
        params = genomeLabelInternal, ...
    )
    
    ## Justification
    genomeLabelInternal$just <- 
        justConversion(genomeLabelInternal$just)
    
    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    genomeLabel <- structure(list(
        chrom = genomeLabelInternal$chrom,
        chromstart = genomeLabelInternal$chromstart,
        chromend = genomeLabelInternal$chromend,
        assembly = genomeLabelInternal$assembly,
        x = genomeLabelInternal$x,
        y = genomeLabelInternal$y,
        width = NULL, height = NULL,
        just = genomeLabelInternal$just,
        grobs = NULL
    ), class = "genomeLabel")

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================
    
    if (is.null(genomeLabel$x)) stop("argument \"x\" is missing, ",
                                        "with no default.", call. = FALSE)
    
    if (is.null(genomeLabel$y)) stop("argument \"y\" is missing, ",
                                        "with no default.", call. = FALSE)
    
    if (is.null(genomeLabel$chrom)) stop("argument \"chrom\" is missing, ",
                                            "with no default.", call. = FALSE)
    
    if (is.null(genomeLabelInternal$length)) {
        stop("argument \"length\" is missing, ",
            "with no default.",
            call. = FALSE
        )
    }
    
    if (base::length(genomeLabel$chrom) == 1) {
        if (is.null(genomeLabel$chromstart)) stop("argument \"chromstart\" ",
                                                    "is missing, with no ",
                                                    "default.", call. = FALSE)

        if (is.null(genomeLabel$chromend)) stop("argument \"chromend\" ",
                                                "is missing, with no ",
                                                "default.", call. = FALSE)
    } else {
        
        if (is.null(genomeLabelInternal$space)) {
            genomeLabelInternal$space <- 0.01
        }
    }

    check_page(error = paste("Cannot plot a genome label without",
                            "a `plotgardener` page."))
    errorcheck_plotGenomeLabel(
        scale = genomeLabelInternal$scale,
        ticks = genomeLabelInternal$at,
        object = genomeLabel,
        axis = genomeLabelInternal$axis
    )
    
    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    genomeLabel$assembly <-
        parseAssembly(assembly = genomeLabel$assembly)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================
    
    genomeLabel$x <- misc_defaultUnits(value = genomeLabel$x,
                                        name = "x",
                                        default.units = 
                                        genomeLabelInternal$default.units)
    genomeLabel$y <- misc_defaultUnits(
        value = genomeLabel$y,
        name = "y",
        default.units = genomeLabelInternal$default.units)
    genomeLabelInternal$length <- misc_defaultUnits(
        value = genomeLabelInternal$length,
        name = "length",
        default.units = genomeLabelInternal$default.units)
    genomeLabelInternal$margin <- misc_defaultUnits(
        value = genomeLabelInternal$margin,
        name = "margin",
        default.units = genomeLabelInternal$default.units)
    
    # =========================================================================
    # LABEL DEPTH
    # =========================================================================

    genomeLabelInternal$margin <- 
        convertHeight(genomeLabelInternal$margin,
                    unitTo = get("page_units", envir = pgEnv)
        )
    genomeLabelInternal$tgH <- convertHeight(heightDetails(textGrob(
        label = genomeLabelInternal$scale,
        x = 0.5, y = 0.5,
        default.units = "npc",
        gp = genomeLabelInternal$gp
    )),
    unitTo = get("page_units", envir = pgEnv)
    )
    
    if (!is.null(genomeLabelInternal$at)) {
        genomeLabelInternal$tick_height <- 
            genomeLabelInternal$tgH * (genomeLabelInternal$tcl)
        genomeLabelInternal$depth <- 
            convertHeight(genomeLabelInternal$tgH + 
                        genomeLabelInternal$tick_height + 
                        0.5 * genomeLabelInternal$tgH + 
                        genomeLabelInternal$margin,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
    } else {
        genomeLabelInternal$tick_height <- NULL
        genomeLabelInternal$depth <- 
            convertHeight(genomeLabelInternal$tgH + 
                        genomeLabelInternal$margin,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
    }

    # =========================================================================
    # GENOME LABEL FOR SINGLE CHROMOSOME
    # =========================================================================
    
    if (base::length(genomeLabel$chrom) == 1){
        
        vp_name <- plotChromGenomeLabel(genomeLabel = genomeLabel,
                                genomeLabelInternal = genomeLabelInternal,
                                ...)
        
    } else {
    # =========================================================================
    # GENOME LABEL FOR MANHATTAN PLOT
    # =========================================================================
        vp_name <- plotManhattanGenomeLabel(genomeLabel = genomeLabel,
                                genomeLabelInternal = genomeLabelInternal)
        
    }

    # =========================================================================
    # ASSIGN GROBS TO OBJECT
    # =========================================================================

    genomeLabel$grobs <- get("genomeLabel_grobs", envir = pgEnv)
    grid.draw(genomeLabel$grobs)

    # =========================================================================
    # ASSIGN DIMENSIONS BASED ON AXIS
    # =========================================================================

    genomeLabel$width <- genomeLabelInternal$length
    genomeLabel$height <- genomeLabelInternal$depth
    if (genomeLabelInternal$axis == "y") {
        genomeLabel$width <- genomeLabelInternal$depth
        genomeLabel$height <- genomeLabelInternal$length
    }

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("genomeLabel[", vp_name, "]")
    invisible(genomeLabel)
}

# Plots a standard genome label for a single chromosomal region
# @param genomeLabel genomeLabel object from plotGenomeLabel
# @param genomeLabelInternal genomeLabelInternal object 
# from plotGenomeLabel
plotChromGenomeLabel <- function(genomeLabel, 
                                    genomeLabelInternal, ...){
    
    # =========================================================================
    # FUNCTIONS
    # =========================================================================
    
    ## Define a function that adds commas to chromstart/chromend labels
    comma_labels <- function(object, commas, fact, ...) {
        digits <- list(...)$digits
        if (is.null(digits)){
            if (fact == 1){
                digits <- rep(0, 2)
            } else {
                digits <- rep(1, 2)
            }
        }
        if (length(digits) == 1){
            digits <- rep(digits, 2)
        }
        
        roundedStart <- round(object$chromstart / fact, digits[1])
        if ((roundedStart * fact) != object$chromstart) {
            roundedStart <- paste0("~", roundedStart)
            warning("Start label is rounded.", call. = FALSE)
        }
        
        roundedEnd <- round(object$chromend / fact, digits[2])
        if ((roundedEnd * fact) != object$chromend) {
            roundedEnd <- paste0("~", roundedEnd)
            warning("End label is rounded.", call. = FALSE)
        }

        if (commas == TRUE) {
            chromstartlabel <- formatC(roundedStart,
                                    format = "f",
                                    big.mark = ",", digits = digits[1]
            )
            chromendlabel <- formatC(roundedEnd,
                                    format = "f",
                                    big.mark = ",", digits = digits[2]
            )
        } else {
            chromstartlabel <- roundedStart
            chromendlabel <- roundedEnd
        }
        
        return(list(chromstartlabel, chromendlabel))
    }
    
    ## Define a function that makes the label viewport
    chrom_viewport <- function(object, length, depth, seqType,
                            vp_name, seqHeight, just, axis){
        
        ## No matter the orientation, convert to page units
        convertedPageCoords <- convert_page(object = structure(list(
            width = length,
            height = unit(
                depth,
                get("page_units", envir = pgEnv)
            ),
            x = object$x,
            y = object$y
        ),
        class = "genomeLabelInternal"
        ))
        ## Add "length" and "depth" into converted dimensions
        convertedPageCoords$length <- convertedPageCoords$width
        convertedPageCoords$depth <- convertedPageCoords$height
        
        ## Compile new dimensions into a new dummy viewport,
        ## where the default is along the x-axis
        convertedViewport <- viewport(
            width = convertedPageCoords$length,
            height = convertedPageCoords$depth,
            x = convertedPageCoords$x,
            y = convertedPageCoords$y, just = just
        )
        
        if (!is.null(seqType)) {
            
            ## Get x and y coordinates of top left of what
            ## would be the entire viewport
            topLeftViewport <- vp_topLeft(viewport = convertedViewport)
            seq_height <- unit(seqHeight, get("page_units", envir = pgEnv))
            ## One vp for genome
            vp1 <- viewport(
                width = convertedPageCoords$width,
                height = unit(depth, get("page_units", envir = pgEnv)),
                x = topLeftViewport[[1]],
                y = topLeftViewport[[2]] - seq_height,
                just = c("left", "top"),
                name = paste0(vp_name, "_01"),
                xscale = c(object$chromstart, object$chromend),
                yscale = c(0, depth)
            )
            ## One vp for sequence
            vp2 <- viewport(
                width = convertedPageCoords$width,
                height = seq_height,
                x = topLeftViewport[[1]],
                y = topLeftViewport[[2]],
                just = c("left", "top"),
                name = paste0(vp_name, "_02"),
                clip = "on",
                xscale = c(object$chromstart, object$chromend)
            )
            
            ## Combine viewports into one
            vp <- vpList(vp1, vp2)
        } else {
            if (axis == "y") {
                
                
                ## Update converted viewport for y-axis
                convertedViewport <- viewport(
                    width = convertedPageCoords$depth,
                    height = convertedPageCoords$length,
                    x = convertedPageCoords$x,
                    y = convertedPageCoords$y,
                    just = just
                )
                ## Get x and y coords of bottom right to rotate vp
                bottomRightViewport <-
                    vp_bottomRight(viewport = convertedViewport)
                
                ## Make x-axis equivalent viewport and rotate into
                ## dimensions of given y-axis viewport
                vp <- viewport(
                    width = convertedPageCoords$length,
                    height = convertedPageCoords$depth,
                    x = bottomRightViewport[[1]] -
                        convertedPageCoords$depth,
                    y = bottomRightViewport[[2]],
                    just = c("left", "top"),
                    name = vp_name,
                    xscale = c(object$chromstart, object$chromend),
                    yscale = c(0, depth),
                    angle = 90
                )
            } else {
                vp <- viewport(
                    width = convertedPageCoords$width,
                    height = convertedPageCoords$height,
                    x = convertedPageCoords$x,
                    y = convertedPageCoords$y,
                    just = just,
                    name = vp_name,
                    xscale = c(object$chromstart, object$chromend),
                    yscale = c(0, depth)
                )
            }
        }
        
        return(vp)
    }
    
    ## Define a function that makes tick, line, and text grobs for
    ## chrom/chromstart/chromend labels
    chrom_grobs <- function(ticks, seqType, scale, chromLabel,
                            startLabel, endLabel, object, vp,
                            yaxis) {
        margin <- convertHeight(object$margin,
                                unitTo = get("page_units", envir = pgEnv),
                                valueOnly = TRUE
        )
        
        height <- convertHeight(object$depth,
                                unitTo = get("page_units", envir = pgEnv),
                                valueOnly = TRUE
        )
        
        if (!is.null(seqType)) {
            assign("genomeLabel_grobs", gTree(), envir = pgEnv)
            chrom_vp <- vp[[1]]
            
            if (!is.null(ticks)) {
                tgH <- convertHeight(object$tgH,
                                    unitTo = get("page_units", envir = pgEnv),
                                    valueOnly = TRUE
                )
                tick_height <- convertHeight(object$tick_height,
                                            unitTo = get("page_units", 
                                                        envir = pgEnv),
                                            valueOnly = TRUE
                )
                x_coords <- ticks
                y0_coord <- height
                y1_coords <- rep(height - tick_height, length(ticks))
                yLabel <- unit(height - (tick_height + margin), "native")
                
                tickGrobs <- segmentsGrob(
                    x0 = x_coords,
                    y0 = rep(y0_coord, length(ticks)),
                    x1 = x_coords,
                    y1 = y1_coords,
                    vp = chrom_vp,
                    gp = object$gp,
                    default.units = "native"
                )
                line <- segmentsGrob(
                    x0 = unit(0, "npc"),
                    x1 = unit(1, "npc"),
                    y0 = y0_coord,
                    y1 = y0_coord,
                    vp = chrom_vp,
                    gp = object$gp,
                    default.units = "native"
                )
                object$gp$col <- object$gp$fontcolor
                startLab <- textGrob(
                    label = paste(startLabel, scale),
                    x = unit(0, "npc"), y = yLabel,
                    just = c("left", "top"),
                    vp = chrom_vp,
                    gp = object$gp
                )
                endLab <- textGrob(
                    label = paste(endLabel, scale),
                    x = unit(1, "npc"), y = yLabel,
                    just = c("right", "top"),
                    vp = chrom_vp,
                    gp = object$gp
                )
                object$gp$fontface <- "bold"
                chromLab <- textGrob(
                    label = chromLabel,
                    x = unit(0.5, "npc"), y = yLabel,
                    vp = chrom_vp,
                    gp = object$gp, just = c("center", "top")
                )
                
                assign("genomeLabel_grobs",
                    setChildren(get("genomeLabel_grobs", envir = pgEnv),
                                    children = gList(
                                                line, chromLab, startLab,
                                                endLab, tickGrobs
                                        )
                        ),
                        envir = pgEnv
                )
            } else {
                yLabel <- unit(height - margin, "native")
                line <- segmentsGrob(
                    x0 = unit(0, "npc"), x1 = unit(1, "npc"),
                    y0 = height, y1 = height,
                    vp = chrom_vp,
                    gp = object$gp, default.units = "native"
                )
                object$gp$col <- object$gp$fontcolor
                startLab <- textGrob(
                    label = paste(startLabel, scale, sep = " "),
                    x = unit(0, "npc"), y = yLabel,
                    vp = chrom_vp,
                    just = c("left", "top"),
                    gp = object$gp
                )
                endLab <- textGrob(
                    label = paste(endLabel, scale, sep = " "),
                    x = unit(1, "npc"), y = yLabel,
                    vp = chrom_vp,
                    just = c("right", "top"),
                    gp = object$gp
                )
                object$gp$fontface <- "bold"
                chromLab <- textGrob(
                    label = chromLabel, x = unit(0.5, "npc"),
                    y = yLabel,
                    vp = chrom_vp,
                    gp = object$gp,
                    just = c("center", "top")
                )
                
                assign("genomeLabel_grobs",
                    setChildren(get("genomeLabel_grobs", envir = pgEnv),
                            children = gList(
                                        line, chromLab,
                                        startLab, endLab
                                        )
                    ),
                    envir = pgEnv
                )
            }
        } else {
            assign("genomeLabel_grobs", gTree(vp = vp), envir = pgEnv)
            
            if (!is.null(ticks)) {
                tgH <- convertHeight(object$tgH,
                                    unitTo = get("page_units", envir = pgEnv),
                                    valueOnly = TRUE
                )
                tick_height <- convertHeight(object$tick_height,
                                            unitTo = get("page_units", 
                                                        envir = pgEnv),
                                            valueOnly = TRUE
                )
                x_coords <- ticks
                
                if (yaxis == TRUE) {
                    y0_coord <- 0
                    y1_coords <- rep(tick_height, length(ticks))
                    yLabel <- unit(tick_height + margin, "native")
                    
                    tickGrobs <- segmentsGrob(
                        x0 = x_coords,
                        y0 = rep(y0_coord, length(ticks)),
                        x1 = x_coords, y1 = y1_coords,
                        gp = object$gp, default.units = "native"
                    )
                    line <- segmentsGrob(
                        x0 = unit(0, "npc"), x1 = unit(1, "npc"),
                        y0 = y0_coord, y1 = y0_coord,
                        gp = object$gp, default.units = "native"
                    )
                    object$gp$col <- object$gp$fontcolor
                    startLab <- textGrob(
                        label = paste(startLabel, scale),
                        x = unit(0, "npc"), y = yLabel,
                        just = c("left", "bottom"),
                        gp = object$gp
                    )
                    endLab <- textGrob(
                        label = paste(endLabel, scale),
                        x = unit(1, "npc"), y = yLabel,
                        just = c("right", "bottom"),
                        gp = object$gp
                    )
                    object$gp$fontface <- "bold"
                    chromLab <- textGrob(
                        label = chromLabel,
                        x = unit(0.5, "npc"), y = yLabel,
                        gp = object$gp, just = c("center", "bottom")
                    )
                } else {
                    y0_coord <- height
                    y1_coords <- rep(height - tick_height, length(ticks))
                    yLabel <- unit(height - (tick_height + margin), "native")
                    tickGrobs <- segmentsGrob(
                        x0 = x_coords,
                        y0 = rep(y0_coord, length(ticks)),
                        x1 = x_coords, y1 = y1_coords,
                        gp = object$gp, default.units = "native"
                    )
                    line <- segmentsGrob(
                        x0 = unit(0, "npc"), x1 = unit(1, "npc"),
                        y0 = y0_coord, y1 = y0_coord,
                        gp = object$gp, default.units = "native"
                    )
                    object$gp$col <- object$gp$fontcolor
                    startLab <- textGrob(
                        label = paste(startLabel, scale),
                        x = unit(0, "npc"),
                        y = unit(tgH + 0.25 * tgH, "native"),
                        just = c("left", "top"),
                        gp = object$gp
                    )
                    endLab <- textGrob(
                        label = paste(endLabel, scale),
                        x = unit(1, "npc"),
                        y = unit(tgH + 0.25 * tgH, "native"),
                        just = c("right", "top"),
                        gp = object$gp
                    )
                    object$gp$fontface <- "bold"
                    chromLab <- textGrob(
                        label = chromLabel, x = unit(0.5, "npc"),
                        y = unit(tgH + 0.25 * tgH, "native"),
                        gp = object$gp, just = c("center", "top")
                    )
                }
                
                assign("genomeLabel_grobs",
                    setChildren(get("genomeLabel_grobs", envir = pgEnv),
                                children = gList(
                                            line, chromLab, startLab,
                                            endLab, tickGrobs
                                        )
                        ),
                    envir = pgEnv
                )
            } else {
                if (yaxis == TRUE) {
                    yLabel <- unit(margin, "native")
                    line <- segmentsGrob(
                        x0 = unit(0, "npc"), x1 = unit(1, "npc"),
                        y0 = unit(0, "npc"), y1 = unit(0, "npc"),
                        gp = object$gp
                    )
                    object$gp$col <- object$gp$fontcolor
                    startLab <- textGrob(
                        label = paste(startLabel, scale, sep = " "),
                        x = unit(0, "npc"), y = yLabel,
                        just = c("left", "bottom"),
                        gp = object$gp
                    )
                    endLab <- textGrob(
                        label = paste(endLabel, scale, sep = " "),
                        x = unit(1, "npc"), y = yLabel,
                        just = c("right", "bottom"),
                        gp = object$gp
                    )
                    object$gp$fontface <- "bold"
                    chromLab <- textGrob(
                        label = chromLabel, x = unit(0.5, "npc"),
                        y = yLabel,
                        gp = object$gp,
                        just = c("center", "bottom")
                    )
                } else {
                    yLabel <- unit(height - margin, "native")
                    line <- segmentsGrob(
                        x0 = unit(0, "npc"), x1 = unit(1, "npc"),
                        y0 = height, y1 = height,
                        gp = object$gp, default.units = "native"
                    )
                    object$gp$col <- object$gp$fontcolor
                    startLab <- textGrob(
                        label = paste(startLabel, scale, sep = " "),
                        x = unit(0, "npc"), y = yLabel,
                        just = c("left", "top"),
                        gp = object$gp
                    )
                    endLab <- textGrob(
                        label = paste(endLabel, scale, sep = " "),
                        x = unit(1, "npc"), y = yLabel,
                        just = c("right", "top"),
                        gp = object$gp
                    )
                    object$gp$fontface <- "bold"
                    chromLab <- textGrob(
                        label = chromLabel, x = unit(0.5, "npc"),
                        y = yLabel,
                        gp = object$gp,
                        just = c("center", "top")
                    )
                }
                
                
                
                assign("genomeLabel_grobs",
                    setChildren(get("genomeLabel_grobs", envir = pgEnv),
                                children = gList(
                                            line, chromLab,
                                            startLab, endLab
                                )
                        ),
                    envir = pgEnv
                )
            }
        }
    }
    
    ## Define a function that makes sequence grobs (boxes or letters)
    seq_grobs <- function(object, seqHeight, seqType, assembly, chromLabel, vp,
                        boxWidth, gparParams) {
        
        bsgenome <- eval(parse(text = paste0(as.name(object$assembly$BSgenome),
                                            "::",
                                            as.name(object$assembly$BSgenome))))
        ## Get sequence in that region
        sequence <- strsplit(as.character(BSgenome::getSeq(
            bsgenome,
            GenomicRanges::GRanges(
                seqnames = chromLabel,
                ranges = IRanges::IRanges(
                    start = object$chromstart,
                    end = object$chromend
                )
            )
        )),
        split = ""
        )
        ## Make dataframe of sequence letter, position, and color
        dfSequence <- data.frame(
            "nucleotide" = unlist(sequence),
            "pos" = seq(object$chromstart, object$chromend),
            "col" = "grey"
        )
        
        ## Make colors A = green, T = red, G = orange, C = blue
        invisible(tryCatch(dfSequence[which(
            dfSequence$nucleotide == "A"
        ), ]$col <- "#7CD95B",
        error = function(e) {}
        ))
        invisible(tryCatch(dfSequence[which(
            dfSequence$nucleotide == "T"
        ), ]$col <- "#F1686C",
        error = function(e) {}
        ))
        invisible(tryCatch(dfSequence[which(
            dfSequence$nucleotide == "G"
        ), ]$col <- "#FFDD12",
        error = function(e) {}
        ))
        invisible(tryCatch(dfSequence[which(
            dfSequence$nucleotide == "C"
        ), ]$col <- "#5566FF",
        error = function(e) {}
        ))
        
        seq_vp <- vp[[2]]
        
        ## Make grobs based on seqType
        if (seqType == "letters") {
            seqGrobs <- textGrob(
                label = dfSequence$nucleotide, x = dfSequence$pos,
                y = unit(0.5, "npc"), just = "center",
                vp = seq_vp,
                default.units = "native",
                gp = gpar(
                    col = dfSequence$col,
                    fontsize = gparParams$gp$fontsize - 2
                )
            )
        } else if (seqType == "boxes") {
            seqGrobs <- rectGrob(
                x = dfSequence$pos, y = unit(1, "npc"),
                width = boxWidth,
                height = unit(
                    seqHeight - 0.05 * seqHeight,
                    get("page_units", envir = pgEnv)
                ),
                just = c("center", "top"),
                vp = seq_vp,
                default.units = "native",
                gp = gpar(col = NA, fill = dfSequence$col)
            )
        }
        
        assign("genomeLabel_grobs",
                addGrob(
                    gTree = get("genomeLabel_grobs", envir = pgEnv),
                    child = seqGrobs
                ),
                envir = pgEnv
        )
    }
    
    # =========================================================================
    # COMMAS
    # =========================================================================
    
    ## Determine scale of labels
    if (genomeLabelInternal$scale == "bp") {
        fact <- 1
    }
    if (genomeLabelInternal$scale == "Mb") {
        fact <- 1000000
    }
    if (genomeLabelInternal$scale == "Kb") {
        fact <- 1000
    }
    
    commaLabels <- comma_labels(
            object = genomeLabel,
            commas = genomeLabelInternal$commas,
            fact = fact, ...
        )
    chromstartlabel <- commaLabels[[1]]
    chromendlabel <- commaLabels[[2]]
    
    # =========================================================================
    # NUCLEOTIDE SEQUENCE INFORMATION
    # =========================================================================
    
    seq_height <- heightDetails(textGrob(
        label = "A",
        x = 0.5, y = 0.5,
        default.units = "npc",
        gp = gpar(fontsize = genomeLabelInternal$gp$fontsize - 2)
    ))
    seq_height <- convertHeight(seq_height + 0.05 * seq_height,
                                unitTo = get("page_units", envir = pgEnv)
    )
    
    seqType <- NULL
    if (genomeLabelInternal$sequence == TRUE) {
        if (genomeLabelInternal$axis == "x") {
            labelWidth <- convertWidth(genomeLabelInternal$length,
                                    unitTo = "inches",
                                    valueOnly = TRUE
            )
            bpWidth <- convertWidth(widthDetails(textGrob(
                label = "A",
                x = 0.5, y = 0.5,
                default.units = "npc",
                gp = gpar(fontsize = genomeLabelInternal$gp$fontsize - 2)
            )),
            unitTo = "inches",
            valueOnly = TRUE
            )
            seqRange <- genomeLabel$chromend - genomeLabel$chromstart
            seqWidth <- bpWidth * seqRange
            
            if (seqWidth <= labelWidth) {
                seqType <- "letters"
            } else if (seqWidth / labelWidth <= 9) {
                seqType <- "boxes"
            }
        }
    }
    
    ## Check for BSgenome packages and reset seqType if necessary
    if (!is.null(seqType)) {
        if (!is.null(genomeLabel$assembly$BSgenome)) {
            
            if (!requireNamespace(genomeLabel$assembly$BSgenome, 
                                quietly = TRUE)){
                bsChecks <- FALSE
                warning("`", genomeLabel$assembly$BSgenome, 
                        "` not available. ",
                        "Sequence information will not be displayed.", 
                        call. = FALSE)
            } else {
                bsChecks <- TRUE
            }
            
            if (bsChecks == FALSE) {
                seqType <- NULL
            }
        } else {
            warning("No `BSgenome` package found for the input assembly. ",
                    "Sequence information cannot be displayed.", call. = FALSE)
            seqType <- NULL
        }
    }
    
    if (!is.null(seqType)) {
        seq_height <- convertHeight(seq_height,
                                    unitTo = get("page_units", envir = pgEnv),
                                    valueOnly = TRUE
        )
        genomeLabelInternal$depth <- unit(
            genomeLabelInternal$depth + seq_height,
            get("page_units", envir = pgEnv)
        )
    } else {
        genomeLabelInternal$depth <- unit(
            genomeLabelInternal$depth,
            get("page_units", envir = pgEnv)
        )
    }
    
    # =========================================================================
    # VIEWPORTS
    # =========================================================================
    ## Name viewport
    currentViewports <- current_viewports()
    vp_name <- paste0(
        "genomeLabel",
        base::length(grep(
            pattern = "genomeLabel",
            x = currentViewports
        )) + 1
    )
    
    ## Make viewport
    vp <- chrom_viewport(
        object = genomeLabel,
        length = genomeLabelInternal$length,
        depth = genomeLabelInternal$depth,
        seqType = seqType,
        seqHeight = seq_height,
        vp_name = vp_name, just = genomeLabel$just,
        axis = genomeLabelInternal$axis
    )
    
    # =========================================================================
    # GROBS AND GTREE
    # =========================================================================
    
    chrom_grobs(
        ticks = genomeLabelInternal$at,
        seqType = seqType,
        scale = genomeLabelInternal$scale,
        chromLabel = genomeLabel$chrom, 
        startLabel = chromstartlabel, endLabel = chromendlabel,
        object = genomeLabelInternal, vp = vp,
        yaxis = (genomeLabelInternal$axis == "y")
    )
    
    ## Sequence grobs if applicable
    if (!is.null(seqType)) {
        seq_grobs(
            object = genomeLabel, seqHeight = seq_height,
            seqType = seqType, assembly = genomeLabel$assembly,
            chromLabel = genomeLabel$chrom, vp = vp,
            boxWidth = genomeLabelInternal$boxWidth,
            gparParams = genomeLabelInternal
        )
    }
    
    return(vp_name)
}

# Plots a genome label for a multi-chromosomal Manhattan plot
# @param genomeLabel genomeLabel object from plotGenomeLabel
# @param genomeLabelInternal genomeLabelInternal object 
# from plotGenomeLabel
plotManhattanGenomeLabel <- function(genomeLabel, genomeLabelInternal){
    
    # =========================================================================
    # FUNCTIONS
    # =========================================================================
    
    ## Define a function that makes the label viewport
    manhattan_viewport <- function(object, length, depth,
                                vp_name, just, axis, space){
        
        ## Convert to page units
        convertedPageCoords <- convert_page(object = structure(list(
            width = length,
            height = unit(
                depth,
                get("page_units", envir = pgEnv)
            ),
            x = object$x,
            y = object$y
        ),
        class = "genomeLabelInternal"
        ))
        ## Add "length" and "depth" into converted dimensions
        convertedPageCoords$length <- convertedPageCoords$width
        convertedPageCoords$depth <- convertedPageCoords$height
        
        ## Compile new dimensions into a new dummy viewport,
        ## where the default is along the x-axis
        convertedViewport <- viewport(
            width = convertedPageCoords$length,
            height = convertedPageCoords$depth,
            x = convertedPageCoords$x,
            y = convertedPageCoords$y, just = just
        )
        
        
        ## Get assembly data
        if (is(object$assembly$TxDb, "TxDb")) {
            txdbChecks <- TRUE
        } else {
            
            if (!requireNamespace(object$assembly$TxDb, quietly = TRUE)){
                txdbChecks <- FALSE
                warning("`", object$assembly$TxDb, "` not available. Please ",
                "install to label genome.", call. = FALSE)
            } else {
                txdbChecks <- TRUE
            }
            
        }
        
        if (txdbChecks == TRUE) {
            if (is(object$assembly$TxDb, "TxDb")) {
                tx_db <- object$assembly$TxDb
            } else {
                tx_db <- eval(parse(text = paste0(as.name(object$assembly$TxDb),
                                        "::",
                                        as.name(object$assembly$TxDb))))
            }
            
            assembly_data <- as.data.frame(setDT(as.data.frame(
                GenomeInfoDb::seqlengths(tx_db)
            ),
            keep.rownames = TRUE
            ))
            colnames(assembly_data) <- c("chrom", "length")
            assembly_data <- assembly_data[which(assembly_data[, "chrom"] %in%
                                                object$chrom), ]
            ## get the offsets based on spacer for the assembly
            offsetAssembly <- spaceChroms(
                assemblyData = assembly_data,
                space = space
            )
            cumsums <- cumsum(as.numeric(assembly_data[, "length"]))
            spacer <- cumsums[length(cumsum(
                as.numeric(assembly_data[, "length"])
            ))] * space
            xscale <- c(0, max(offsetAssembly[, "end"]) + spacer)
        } else {
            xscale <- c(0, 1)
        }
        
        
        if (axis == "y") {
            ## Update converted viewport for y-axis
            convertedViewport <- viewport(
                width = convertedPageCoords$depth,
                height = convertedPageCoords$length,
                x = convertedPageCoords$x,
                y = convertedPageCoords$y, just = just
            )
            ## Get x and y coordinates of bottom right to rotate
            ## x-axis viewport
            bottomRightViewport <-
                vp_bottomRight(viewport = convertedViewport)
            ## Make x-axis equivalent viewport and rotate into
            ## dimensions of given y-axis viewport
            vp <- viewport(
                width = convertedPageCoords$length,
                height = convertedPageCoords$depth,
                x = bottomRightViewport[[1]] - convertedPageCoords$depth,
                y = bottomRightViewport[[2]],
                just = c("left", "top"),
                name = vp_name,
                xscale = c(object$chromstart, object$chromend),
                yscale = c(0, depth),
                angle = 90
            )
        } else {
            vp <- viewport(
                width = convertedPageCoords$width,
                height = convertedPageCoords$height,
                x = convertedPageCoords$x,
                y = convertedPageCoords$y,
                just = just,
                name = vp_name,
                xscale = xscale,
                yscale = c(0, depth)
            )
        }
        
        return(vp)
        
    }
    
    ## Define a function that makes line and text grobs for whole assembly
    ## labels in Manhattan plots
    genome_grobs <- function(object, vp, gp, space) {
        
        ## Initialize gTree
        assign("genomeLabel_grobs", gTree(vp = vp), envir = pgEnv)
        
        ## Get assembly data
        if (is(object$assembly$TxDb, "TxDb")) {
            txdbChecks <- TRUE
        } else {
            
            if (!requireNamespace(object$assembly$TxDb, quietly = TRUE)){
                txdbChecks <- FALSE
            } else {
                txdbChecks <- TRUE
            }
        }
        
        if (txdbChecks == TRUE) {
            if (is(object$assembly$TxDb, "TxDb")) {
                tx_db <- object$assembly$TxDb
            } else {
                tx_db <- eval(parse(text = 
                                        paste0(as.name(object$assembly$TxDb),
                                            "::",
                                            as.name(object$assembly$TxDb))))
            }
            
            assembly_data <- as.data.frame(setDT(as.data.frame(
                GenomeInfoDb::seqlengths(tx_db)
            ),
            keep.rownames = TRUE
            ))
            colnames(assembly_data) <- c("chrom", "length")
            assembly_data <- assembly_data[which(assembly_data[, "chrom"] %in%
                                                    object$chrom), ]
            ## Get the offsets based on spacer for the assembly
            offsetAssembly <- spaceChroms(
                assemblyData = assembly_data,
                space = space
            )
            
            ## Get the centers of each chrom
            chromCenters <- (offsetAssembly[, "start"] + 
                                offsetAssembly[, "end"]) / 2
            
            margin <- convertHeight(object$margin,
                                    unitTo = get("page_units", envir = pgEnv),
                                    valueOnly = TRUE
            )
            
            line <- segmentsGrob(
                x0 = unit(0, "npc"), x1 = unit(1, "npc"),
                y0 = unit(1, "npc"), y1 = unit(1, "npc"), gp = gp
            )
            gp$col <- gp$fontcolor
            labels <- textGrob(
                label = gsub("chr", "", offsetAssembly[, 1]),
                x = chromCenters,
                y = unit(1, "npc") - unit(margin, "native"),
                just = c("center", "top"),
                gp = gp,
                default.units = "native"
            )
            assign("genomeLabel_grobs",
                setChildren(get("genomeLabel_grobs", envir = pgEnv),
                        children = gList(line, labels)
                    ),
                envir = pgEnv
            )
        }
    }
    
    # =========================================================================
    # VIEWPORTS
    # =========================================================================
    ## Name viewport
    currentViewports <- current_viewports()
    vp_name <- paste0(
        "genomeLabel",
        base::length(grep(
            pattern = "genomeLabel",
            x = currentViewports
        )) + 1
    )
    
    ## Make viewport
    vp <- manhattan_viewport(
        object = genomeLabel,
        length = genomeLabelInternal$length,
        depth = genomeLabelInternal$depth,
        vp_name = vp_name, just = genomeLabel$just,
        axis = genomeLabelInternal$axis,
        space = genomeLabelInternal$space
    )
    
    # =========================================================================
    # GROBS AND GTREE
    # =========================================================================
    
    genome_grobs(
        object = genomeLabelInternal, vp = vp,
        gp = genomeLabelInternal$gp,
        space = genomeLabelInternal$space
    )
    
    return(vp_name)
}

#' Plot a circle within a plotgardener layout
#' 
#' @usage plotCircle(
#'     x,
#'     y,
#'     r,
#'     default.units = "inches",
#'     linecolor = "black",
#'     lwd = 1,
#'     lty = 1,
#'     fill = NA,
#'     alpha = 1,
#'     params = NULL,
#'     ...
#' )
#'
#' @param x A numeric vector or unit object specifying circle
#' x-locations relative to center.
#' @param y A numeric vector, unit object, or a character vector
#' of values containing a "b" combined with a numeric value
#' specifying circle y-locations relative to center.
#' The character vector will place circle y-locations relative to
#' the bottom of the most recently plotted plot according
#' to the units of the plotgardener page.
#' @param r A numeric vector or unit object specifying radii.
#' @param default.units A string indicating the default units to use
#' if \code{r}, \code{x}, or \code{y} are only given as numerics or
#' numeric vectors. Default value is \code{default.units = "inches"}.
#' @param linecolor A character value specifying circle line color.
#' Default value is \code{linecolor = "black"}.
#' @param lwd A numeric specifying circle line width.
#' Default value is \code{lwd = 1}.
#' @param lty A numeric specifying circle line type.
#' Default value is \code{lty = 1}.
#' @param fill A character value specifying circle fill color.
#' Default value is \code{fill = NA}.
#' @param alpha Numeric value specifying color transparency.
#' Default value is \code{alpha = 1}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{circle} object containing
#' relevant placement and \link[grid]{grob} information.
#'
#' @examples
#' ## Create a page
#' pageCreate(width = 2, height = 2, default.units = "inches")
#'
#' ## Plot two circles, one at a time
#' plotCircle(
#'     x = 0.6, y = 0.5, r = 0.1, fill = "black",
#'     default.units = "inches"
#' )
#' plotCircle(
#'     x = 1.4, y = 0.5, r = 0.1, fill = "black",
#'     default.units = "inches"
#' )
#'
#' ## Plot a vector of circles
#' xVals <- 1 + (0.5 * cos(seq(0, pi, pi / 8)))
#' yVals <- 1 + (0.5 * sin(seq(0, pi, pi / 8)))
#' plotCircle(x = xVals, y = yVals, r = 0.05, default.units = "inches")
#'
#' ## Hide page guides
#' pageGuideHide()
#' @seealso \link[grid]{grid.circle}
#'
#' @export
plotCircle <- function(x, y, r, default.units = "inches",
                        linecolor = "black", lwd = 1, lty = 1,
                        fill = NA, alpha = 1, params = NULL, ...) {


    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    circleInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "circleInternal"
    )

    ## Set gp
    circleInternal$gp <- gpar(
        col = circleInternal$linecolor,
        fill = circleInternal$fill,
        lwd = circleInternal$lwd,
        lty = circleInternal$lty,
        alpha = circleInternal$alpha
    )
    circleInternal$gp <- setGP(
        gpList = circleInternal$gp,
        params = circleInternal, ...
    )


    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    circle <- structure(list(
        x = circleInternal$x,
        y = circleInternal$y,
        r = circleInternal$r, grobs = NULL,
        gp = circleInternal$gp
    ), class = "circle")

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_page(error = "Cannot plot circle without a `plotgardener` page.")
    if (is.null(circle$x)) {
        stop("argument \"x\" is missing, with no default.",
            call. = FALSE
        )
    }
    if (is.null(circle$y)) {
        stop("argument \"y\" is missing, with no default.",
            call. = FALSE
        )
    }
    if (is.null(circle$r)) {
        stop("argument \"r\" is missing, with no default.",
            call. = FALSE
        )
    }
    
    checkColorby(fill = circle$gp$fill,
                colorby = FALSE)

    # =========================================================================
    # DEFINE PARAMETERS
    # =========================================================================

    ## Get page_height and its units from pgEnv
    page_height <- get("page_height", envir = pgEnv)
    page_units <- get("page_units", envir = pgEnv)
    
    circle$x <- misc_defaultUnits(value = circle$x,
                                    name = "x",
                                    default.units = 
                                        circleInternal$default.units)
    
    circle$y <- misc_defaultUnits(value = circle$y,
                                    name = "y",
                                    default.units = 
                                        circleInternal$default.units)
    
    circle$r <- misc_defaultUnits(value = circle$r,
                                    name = "r",
                                    default.units = 
                                        circleInternal$default.units)

    ## Convert coordinates to page_units
    new_x <- convertX(circle$x, unitTo = page_units, valueOnly = TRUE)
    new_y <- convertY(circle$y, unitTo = page_units, valueOnly = TRUE)
    new_r <- convertUnit(circle$r, unitTo = page_units, valueOnly = TRUE)

    # =========================================================================
    # MAKE GROB
    # =========================================================================
    name <- paste0(
        "circle",
        length(grep(
            pattern = "circle",
            x = grid.ls(
                print = FALSE,
                recursive = FALSE
            )
        )) + 1
    )
    circle <- grid.circle(
        x = unit(new_x, page_units),
        y = unit(page_height - new_y, page_units),
        r = unit(new_r, page_units),
        gp = circle$gp,
        name = name
    )

    # =========================================================================
    # ADD GROB TO OBJECT
    # =========================================================================

    circle$grobs <- circle

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("circle[", circle$name, "]")
    invisible(circle)
}

#' Plot multiple signal tracks in line with each other
#' 
#' @usage plotMultiSignal(
#'    data,
#'    binSize = NA, 
#'    binCap = TRUE, 
#'    negData = FALSE,
#'    chrom, 
#'    chromstart = NULL, 
#'    chromend = NULL,
#'    assembly = "hg38", 
#'    linecolor= "#37a7db",
#'    fill = NA, 
#'    ymax = 1, 
#'    range = NULL, 
#'    scale = FALSE,
#'    label = NULL,
#'    bg = NA, 
#'    baseline = TRUE, 
#'    baseline.color = "grey",
#'    baseline.lwd = 1, 
#'    orientation = "h", 
#'    x = NULL, 
#'    y = NULL,
#'    width = NULL,
#'    height = NULL,
#'    just = c("left", "top"),
#'    gapdistance = .2,
#'    default.units = "inches", 
#'    draw = TRUE,
#'    params = NULL, ...
#' )
#'
#' @param data List of data to be plotted as character values specifying 
#' multiple bigwig file paths, dataframes in BED format, or
#' \link[GenomicRanges]{GRanges} objects with metadata column \code{score}.
#' @param binSize A numeric specifying the length of each data
#' bin in basepairs. Default value is \code{binSize = NA}.
#' @param binCap A logical value indicating whether the function will
#' limit the number of data bins to 8,000.
#' Default value is \code{binCap = TRUE}.
#' @param negData A logical value indicating whether any of the data has both
#' positive and negative scores and the y-axis of each signal track
#' should be split. Default value is \code{negData = FALSE}.
#' @param chrom Chromosome of region to be plotted, as a string.
#' @param chromstart Integer start position on chromosome to be plotted.
#' @param chromend Integer end position on chromosome to be plotted.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param linecolor A character value or vector of character values specifying 
#' the line color(s) outlining the signal tracks.
#' Default value is \code{linecolor = "#37a7db"}.
#' @param fill A character value or vector specifying
#' the fill color(s) of the signal tracks. Default value is \code{fill = NA}.
#' @param ymax A numeric specifying the fraction of the max y-value
#' to set as the height of each plot. Default value is \code{ymax = 1}.
#' @param range A numeric vector of length 2 specifying the y-range
#' of data to plot (c(min, max)) in each signal track. If \code{range = NULL},
#' an optimal range for all signal tracks will be calculated.
#' @param scale A logical value indicating whether to include a data
#' scale label in the top left corner of each plot.
#' Default value is \code{scale = FALSE}.
#' @param label An optional character vector to conveniently add text labels
#' to signal tracks. If \code{scale = TRUE}, the labels will be drawn in the 
#' top right of the signal tracks. Otherwise, the label will be drawn in the 
#' top left of the plot. For more customizable labels, 
#' use \link[plotgardener]{plotText}.
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param baseline Logical value indicating whether to include a
#' baseline along the x-axis. Default value is \code{baseline = TRUE}.
#' @param baseline.color Baseline color.
#' Default value is \code{baseline.color = "grey"}.
#' @param baseline.lwd Baseline line width.
#' Default value is \code{baseline.lwd = 1}.
#' @param orientation A string specifying signal track orientations.
#' Default value is \code{orientation = "h"}. Options are:
#' \itemize{
#' \item{\code{"v"}: }{Vertical signal track orientations, where signal tracks
#' will be stacked from left to right.}
#' \item{\code{"h"}: }{Horizontal signal track orientations, where signal tracks
#' will be stacked from top to bottom.}
#' }
#' @param x A numeric vector or unit object specifying the overall multisignal 
#' x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying overall multisignal plot y-location.
#' The character value will
#' place the multisignal plot y relative to the bottom of the most recently
#' plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying overall multisignal plot 
#' width.
#' @param height A numeric or unit object specifying overall multisignal plot 
#' height.
#' @param just Justification of overall multisignal plot relative to 
#' its (x, y) location. If there are two values, the first value specifies 
#' horizontal justification and the second value specifies vertical 
#' justification. Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param gapdistance A numeric or unit object 
#' specifying space between plots. Default value is \code{gapdistance = 0.2}.
#' @param default.units A string indicating the default units to use
#' if \code{x} or \code{y} are only given as numerics.
#' Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output should be
#' produced. Default value \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a list of \code{signal} objects containing relevant
#' genomic region, placement, and \link[grid]{grob} information for each signal
#' track.
#'
#' @examples
#' library("plotgardenerData")
#' data("GM12878_ChIP_CTCF_signal")
#' data("IMR90_ChIP_CTCF_signal")
#' data("GM12878_ChIP_H3K27ac_signal")
#' data("IMR90_ChIP_H3K27ac_signal")
#' library("RColorBrewer")
#'
#' ## List of multiple signal datasets
#' signalList <- list(GM12878_ChIP_CTCF_signal, GM12878_ChIP_H3K27ac_signal, 
#'     IMR90_ChIP_CTCF_signal, IMR90_ChIP_H3K27ac_signal)
#' 
#' ## Create page
#' pageCreate(width = 6.9, height = 3.5, default.units = "inches")
#'
#' ## Plot multiple signals
#' multisignal <- plotMultiSignal(signalList, chrom = "chr21",
#'                                chromstart = 28150000, chromend = 29150000,
#'                                linecolor = c(brewer.pal(n = 9,"YlGnBu")[4],
#'                                              brewer.pal(n = 9,"YlGnBu")[5],
#'                                              brewer.pal(n = 9,"YlGnBu")[6],
#'                                              brewer.pal(n = 9,"YlGnBu")[7]),
#'                                label = c("GM12878 CTCF", "GM12878 H3K27ac",
#'                                          "IMR90 CTCF", "IMR90 H3K27ac"),
#'                                assembly = "hg19",
#'                                x = 0.2, y = 0.2,
#'                                width = 6.5, height = 3,
#'                                default.units = "inches",
#'                                gapdistance = 0.1)
#'                                
#' ## Plot genome label
#' plotGenomeLabel(
#'     chrom = "chr21",
#'     chromstart = 28150000, chromend = 29150000,
#'     assembly = "hg19",
#'     scale = "Kb",
#'     x = 0.2, y = 3.25, length = 6.5,
#'     default.units = "inches"
#' )                                
#' 
#' ## Hide page guides
#' pageGuideHide()              
#' @export
plotMultiSignal<- function(data, 
                           binSize = NA, 
                           binCap = TRUE, 
                           negData = FALSE,
                           chrom, 
                           chromstart = NULL, 
                           chromend = NULL,
                           assembly = "hg38", 
                           linecolor = "#37a7db",
                           fill = NA,  
                           ymax = 1, 
                           range = NULL, 
                           scale = FALSE,
                           label = NULL,
                           bg = NA, 
                           baseline = TRUE, 
                           baseline.color = "grey",
                           baseline.lwd = 1, 
                           orientation = "h",
                           x = NULL, 
                           y = NULL, 
                           width = NULL,
                           height = NULL, 
                           just = c("left", "top"),
                           gapdistance = 0.2,
                           default.units = "inches", 
                           draw = TRUE,
                           params = NULL, ...) {
  
    # =========================================================================
    # FUNCTIONS
    # =========================================================================
    
    ## Define a function to fill in colors
    setColors <- function(colorList, nTracks){
        # exit recursive with list of colors of the correct length
        if (length(colorList) == nTracks){
            return(colorList)
        }
            
        # if there are too few colors for the number of tracks, 
        # repeat the colors provided
        else if (length(colorList) < nTracks){
            setColors(append(colorList, colorList), nTracks)
        }
        # if there are too many colors for the number of tracks, 
        # truncate the color list
        else if(length(colorList) > nTracks){
            return(colorList[seq(1, nTracks)])
        }
            
    }
    
    ## Define a function to calculate x coordinates of each track
    getXCoordinates <- function(x, nTracks, width, orientation, gapdistance){
        # create a list for the x coordinates
        xList <- rep(x, nTracks)
        # if the orientation is h, the x coordinates stay the same, so return 
        # a list of the same x
        if (orientation == "h"){
            return(xList)
        } 
        
        else if (orientation == "v"){
            # calculating the width of each plot 
            internalWidth <- (width - (gapdistance * (nTracks-1)))/nTracks
            # first plot won't change x, others are shifting to the right 
            for (i in 2:nTracks){
                xList[i]<- (xList[i-1] + internalWidth + gapdistance)
            }
                
            return(xList)
        } 
        
    }
    
    ## Define a function to calculate y coordinates of each track
    getYCoordinates <- function(y, nTracks, height, orientation, gapdistance){
        # create a list for the y coordinates
        yList <- rep(y, nTracks)
        # if the orientation is v, the y coordinates stay the same, so return 
        # a list of the same y
        if (orientation == "v"){
            return(yList)
        }
        
        else if (orientation == "h"){
            # calculating the height of each plot
            internalHeight <- (height - (gapdistance * (nTracks-1)))/nTracks
            # first plot won't change y, others are shifting down
            for (i in 2:nTracks){
                yList[i]<- (yList[i-1] + internalHeight + gapdistance) 
            }
                
            return(yList)
        } 

    }
    
    ## Define a function to get and add a signal gtree to one multisignal gtree 
    getGrobs <- function(object){
        
        assign("pg_multiSignals",
               addGrob(
                   gTree = get("pg_multiSignals", envir = pgEnv),
                   child = object$grobs
               ),
               envir = pgEnv
        )
        
    }
    
    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================
  
    multisigInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "multisigInternal"
    )
  
    ## Set gp
    multisigInternal$gp <- setGP(
        gpList = gpar(),
        params = multisigInternal, ...
    )
  
    ## Justification
    multisigInternal$just <- justConversion(just = multisigInternal$just)
  
    # =========================================================================
    # CATCH ERRORS
    # =========================================================================
  
    if (is.null(multisigInternal$data)) stop("argument \"orientation\" is",
                                     "missing, with no default.", call. = FALSE)
  
    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================
  
    multisigInternal$assembly <- parseAssembly(assembly = 
                                               multisigInternal$assembly)
    
    # =========================================================================
    # PARSE UNITS
    # =========================================================================
    
    multisigInternal <- defaultUnits(
        object = multisigInternal,
        default.units = multisigInternal$default.units
    )
  
    multisigInternal$gapdistance <- 
        misc_defaultUnits(value = multisigInternal$gapdistance,
                          name = "gapdistance",
                          default.units = multisigInternal$default.units)
    
    # =========================================================================
    # READ IN FILES/DATAFRAMES AND SET RANGE
    # =========================================================================
  
    signal <- lapply(multisigInternal$data, read_rangeData,
                     assembly = multisigInternal$assembly,
                     chrom = multisigInternal$chrom,
                     start = multisigInternal$chromstart,
                     end = multisigInternal$chromend)
    
    
    range <- calcSignalRange(data = signal,
                             chrom = multisigInternal$chrom,
                             chromstart = multisigInternal$chromstart,
                             chromend = multisigInternal$chromend,
                             assembly = multisigInternal$assembly,
                             negData = multisigInternal$negData)
    
    # =========================================================================
    # SET PLACEMENT COORDINATES, COLORS, AND LABELS
    # =========================================================================
  
    nTracks <- length(multisigInternal$data)

    xList <- getXCoordinates(x = multisigInternal$x, 
                            nTracks = nTracks, 
                            width = multisigInternal$width, 
                            orientation = multisigInternal$orientation, 
                            gapdistance = multisigInternal$gapdistance)
  
    yList <- getYCoordinates(y = multisigInternal$y,  
                            nTracks = nTracks, 
                            height = multisigInternal$height, 
                            orientation = multisigInternal$orientation, 
                            gapdistance = multisigInternal$gapdistance)
  
    if (multisigInternal$orientation == "h"){
        multisigInternal$height <- (multisigInternal$height - 
                    (multisigInternal$gapdistance * (nTracks-1)))/nTracks
    } else if (multisigInternal$orientation == "v"){
        multisigInternal$width <- (multisigInternal$width - 
                    (multisigInternal$gapdistance * (nTracks-1)))/nTracks
    }
    
    linecolorList <- setColors(multisigInternal$linecolor, nTracks)
    fillList <- setColors(multisigInternal$fill, nTracks)
    
    if (is.null(multisigInternal$label)){
        #multisigInternal$label <- rep(multisigInternal$label, nTracks)
        multisigInternal$label <- vector(mode = "list", length = nTracks)
    }
    
    # =========================================================================
    # CALL PLOTSIGNAL
    # =========================================================================
  
    ## Save to a group object?
    sigObjects <- purrr::pmap(list(multisigInternal$data, xList, yList, 
                    linecolorList, fillList, rep(FALSE, nTracks), 
                    multisigInternal$label), 
        \(d, x, y, l, f, draw, lab){
            suppressMessages(plotSignal(data = d, x = x, y = y, 
                        linecolor = l,
                        height = multisigInternal$height, 
                        width = multisigInternal$width,
                        range = range, 
                        orientation = multisigInternal$orientation, 
                        scale = multisigInternal$scale,
                        label = lab,
                        binSize = multisigInternal$binSize, 
                        binCap = multisigInternal$binCap, 
                        negData = multisigInternal$negData,
                        chrom = multisigInternal$chrom, 
                        chromstart = multisigInternal$chromstart, 
                        chromend = multisigInternal$chromend,
                        assembly = multisigInternal$assembly, 
                        fill = f, 
                        ymax = multisigInternal$ymax, 
                        bg = multisigInternal$bg, 
                        baseline = multisigInternal$baseline,
                        baseline.color = multisigInternal$baseline.color, 
                        baseline.lwd = multisigInternal$baseline.lwd, 
                        just = multisigInternal$just,
                        default.units = multisigInternal$default.units, 
                        draw = draw))
        })
    
    # =========================================================================
    # GET AND DRAW GROBS
    # =========================================================================
    
    name <- paste0(
        "multisignal",
        length(grep(
            pattern = "multisignal",
            x = grid.ls(
                print = FALSE,
                recursive = FALSE
            )
        )) + 1
    )
    
    assign("pg_multiSignals", gTree(name = name), envir = pgEnv)
    invisible(lapply(sigObjects, getGrobs))
    
    sigGrobs <- get("pg_multiSignals", envir = pgEnv)

    # Call grid.draw to draw all these grobs at once
    if (multisigInternal$draw == TRUE){
        grid.draw(sigGrobs)
    }
    
    # =========================================================================
    # RETURN OBJECT
    # =========================================================================
    
    message("multisignal[", name, "]")
    invisible(sigObjects)
}  

#' Calculate a score range for multiple signals
#' 
#' @usage calcSignalRange(
#'     data,
#'     chrom = NULL,
#'     chromstart = 1,
#'     chromend = .Machine$integer.max,
#'     assembly = "hg38",
#'     negData = FALSE)
#' 
#' @param data List of data to be plotted as character values specifying 
#' multiple bigwig file paths, dataframes in BED format, or
#' \link[GenomicRanges]{GRanges} objects with metadata column \code{score}.
#' @param chrom Chromosome of data region ragne as a string, if range for a 
#' specific chromosome is desired.
#' @param chromstart Integer start position on chromosome to get data range.
#' @param chromend Integer end position on chromosome to get data range.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param negData A logical value indicating whether any of the data has both
#' positive and negative scores and the signal range should be adjusted
#' accordingly. Default value is \code{negData = FALSE}. 
#' 
#' @return Returns a vector of length 2 with the calculated c(min, max) range.
#' 
#' @examples
#' library("plotgardenerData")
#' data("GM12878_ChIP_CTCF_signal")
#' data("IMR90_ChIP_CTCF_signal")
#' data("GM12878_ChIP_H3K27ac_signal")
#' data("IMR90_ChIP_H3K27ac_signal")
#' 
#' calcSignalRange(data = list(GM12878_ChIP_CTCF_signal, 
#'                             GM12878_ChIP_H3K27ac_signal, 
#'                             IMR90_ChIP_CTCF_signal, 
#'                             IMR90_ChIP_H3K27ac_signal),
#'                 chrom = "chr21",
#'                 chromstart = 28150000, chromend = 29150000,
#'                 assembly = "hg38", negData = FALSE)
#' 
#' @export
calcSignalRange <- function(data, chrom = NULL, chromstart = 1, 
                            chromend = .Machine$integer.max, 
                            assembly = "hg38", negData = FALSE){
    
    # Read and process data with read_rangeData()
    data <- lapply(data, read_rangeData,
                   assembly = assembly,
                   chrom = chrom,
                   start = chromstart,
                   end = chromend)
    
    # calculating the max from the processed data scores
    rangeMax <- lapply(data, dplyr::select, "score") %>%
        lapply(max) %>%
        unlist() %>%
        max
    # if no negative data, lower bound of range = 0
    if (negData == FALSE){
        rangeMin <- 0 
    }
        
    # if there are negative values, lower bound of range is the min value 
    else {
        rangeMin <- lapply(data, dplyr::select, "score") %>%
        lapply(min) %>%
        unlist() %>%
        min
    }
    return(c(rangeMin, rangeMax))
}

#' Plot a polygon within a plotgardener layout
#' 
#' @usage plotPolygon(
#'     x,
#'     y,
#'     default.units = "inches",
#'     linecolor = "black",
#'     lwd = 1,
#'     lty = 1,
#'     fill = NA,
#'     alpha = 1,
#'     id = NULL,
#'     id.lengths = NULL,
#'     params = NULL,
#'     ...
#' )
#'
#' @param x A numeric vector or unit object specifying polygon
#' vertex x-locations.
#' @param y A numeric vector, unit object, or a character vector
#' of values containing a "b" combined with a numeric value specifying
#' polygon vertex y-locations.
#' The character vector will place polygon vertex y-locations relative
#' to the bottom of the most recently plotted plot according
#' to the units of the plotgardener page.
#' @param default.units A string indicating the default units to use
#' if \code{x} or \code{y} are only given as numeric vectors.
#' Default value is \code{default.units = "inches"}.
#' @param linecolor A character value specifying polygon line color.
#' Default value is \code{linecolor = "black"}.
#' @param lwd A numeric specifying polygon line width.
#'  Default value is \code{lwd = 1}.
#' @param lty A numeric specifying polygon line type.
#' Default value is \code{lty = 1}.
#' @param fill A character value specifying polygon fill color.
#' Default value is \code{fill = NA}.
#' @param alpha Numeric value specifying color transparency.
#' Default value is \code{alpha = 1}.
#' @param id A numeric vector used to separate locations in \code{x} and
#' \code{y} into multiple polygons. All locations with the same \code{id}
#' belong to the same polygon.
#' @param id.lengths A numeric vector used to separate locations in
#' \code{x} and \code{y} into multiple polygons. Specifies consecutive
#' blocks of locations which make up separate polygons.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{polygon} object containing relevant
#' placement and \link[grid]{grob} information.
#'
#' @examples
#' ## Create a page
#' pageCreate(width = 7.5, height = 6, default.units = "inches")
#'
#' ## Plot complex polygons one at a time
#' plotPolygon(
#'     x = c(2.6, 4.65, 4.75, 6.05, 1.4, 1.3),
#'     y = c(2.5, 3.1, 3.5, 4, 3.15, 2.8),
#'     fill = "#4a168e", linecolor = NA
#' )
#'
#' plotPolygon(
#'     x = c(4.65, 4.75, 6.05, 5.05, 4.4),
#'     y = c(3.1, 3.5, 4, 1.45, 1.2),
#'     fill = "#9d28b0", linecolor = NA
#' )
#'
#' ## Plot multiple triangles with different id's and colors
#' plotPolygon(
#'     x = c(
#'         0.45, 6.05, 3, 3, 6.05, 5.25, 4.4, 5.05, 4.95,
#'         1.3, 2.6, 1, 4.4, 4.95, 5, 4.95, 5, 6.25
#'     ),
#'     y = c(
#'         2.85, 4, 5.55, 5.55, 4, 5.55, 1.2, 1.45, 1.1,
#'         2.8, 2.5, 2.1, 1.2, 1.1, 0.45, 1.1, 0.45, 1.1
#'     ),
#'     id = c(1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5, 6, 6, 6),
#'     fill = c(
#'         "#ce93d9", "#bb6ac9", "#4a168e",
#'         "#7b1fa0", "#bb6ac9", "#ce93d9"
#'     ),
#'     linecolor = NA
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @seealso \link[grid]{grid.polygon}
#'
#' @export
plotPolygon <- function(x, y, default.units = "inches",
                        linecolor = "black", lwd = 1, lty = 1,
                        fill = NA, alpha = 1, id = NULL,
                        id.lengths = NULL, params = NULL, ...) {


    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    polygonInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "polygonInternal"
    )

    ## Set gp
    polygonInternal$gp <- gpar(
        col = polygonInternal$linecolor,
        fill = polygonInternal$fill,
        lwd = polygonInternal$lwd,
        lty = polygonInternal$lty,
        alpha = polygonInternal$alpha
    )
    polygonInternal$gp <- setGP(
        gpList = polygonInternal$gp,
        params = polygonInternal, ...
    )

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    polygon <- structure(list(
        x = polygonInternal$x,
        y = polygonInternal$y,
        id = polygonInternal$id,
        id.lengths = polygonInternal$id.lengths,
        grobs = NULL,
        gp = polygonInternal$gp
    ),
    class = "polygon"
    )

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_page(error = "Cannot plot polygon without a plotgardener page.")
    if (is.null(polygon$x)) {
        stop("argument \"x\" is missing, with no default.",
            call. = FALSE
        )
    }
    if (is.null(polygon$y)) {
        stop("argument \"y\" is missing, with no default.",
            call. = FALSE
        )
    }
    
    checkColorby(fill = polygon$gp$fill,
                    colorby = FALSE)

    # =========================================================================
    # DEFINE PARAMETERS
    # =========================================================================

    ## Get page_height and its units from pgEnv
    page_height <- get("page_height", envir = pgEnv)
    page_units <- get("page_units", envir = pgEnv)
    
    polygon$x <- misc_defaultUnits(
        value = polygon$x,
        name = "x",
        default.units = polygonInternal$default.units
    )

    polygon$y <- misc_defaultUnits(
        value = polygon$y,
        name = "y",
        default.units = polygonInternal$default.units
    )

    ## Convert coordinates to page_units
    new_x <- convertX(polygon$x, unitTo = page_units, valueOnly = TRUE)
    new_y <- convertY(polygon$y, unitTo = page_units, valueOnly = TRUE)

    # =========================================================================
    # MAKE GROB
    # =========================================================================
    name <- paste0(
        "polygon",
        length(grep(
            pattern = "polygon",
            x = grid.ls(
                print = FALSE,
                recursive = FALSE
            )
        )) + 1
    )
    polygon <- grid.polygon(
        x = unit(new_x, page_units),
        y = unit(page_height - new_y, page_units),
        id = polygon$id,
        id.lengths = polygon$id.lengths,
        name = name,
        gp = polygon$gp
    )

    # =========================================================================
    # ADD GROB TO OBJECT
    # =========================================================================

    polygon$grobs <- polygon

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("polygon[", polygon$name, "]")
    invisible(polygon)
}

#' Display the included available default genome assemblies
#'
#' @return Returns the included available default genome assemblies
#'
#' @examples
#' genomes()
#' @export
genomes <- function() {
    
    availDefaults <- default_genomePackages$Genome

    return(cat(availDefaults, sep = "\n"))
}

#' Plot a legend
#' 
#' @usage plotLegend(
#'     legend,
#'     fill = NULL,
#'     pch = NULL,
#'     lty = NULL,
#'     orientation = "v",
#'     title = NULL,
#'     fontsize = 10,
#'     border = TRUE,
#'     bg = NA,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL,
#'     ...
#' )
#'
#' @param legend A character or expression vector to appear in the legend.
#' @param fill If specified, this argument will produce boxes filled with
#' the specified colors to appear beside the legend text.
#' @param pch The plotting symbols appearing in the legend, as a
#' numeric vector.
#' @param lty The line types for lines appearing in the legend.
#' @param orientation A string specifying legend orientation.
#' Default value is \code{orientation = "v"}. Options are:
#' \itemize{
#' \item{\code{"v"}: }{Vertical legend orientation.}
#' \item{\code{"h"}: }{Horizontal legend orientation.}
#' }
#' @param title A character value giving a title to be placed at
#' the top of the legend.
#' @param fontsize A numeric specifying text fontsize in points.
#' Default value is \code{fontsize = 10}.
#' @param border Logical value indicating whether to add a border
#' around heatmap legend. Default value is \code{border = TRUE}.
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param x A numeric or unit object specifying legend x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying legend y-location.
#' The character value will
#' place the legend y relative to the bottom of the most recently
#' plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying legend width.
#' @param height A numeric or unit object specifying legend height.
#' @param just Justification of legend relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use
#' if \code{x}, \code{y}, \code{width}, or \code{height} are only given
#' as numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output should
#' be produced. Default value is \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{legend} object containing relevant
#' placement and \link[grid]{grob} information.
#'
#' @examples
#' ## Load BED data
#' library(plotgardenerData)
#' data("IMR90_ChIP_CTCF_reads")
#'
#' ## Create page
#' pageCreate(width = 7.5, height = 4, default.units = "inches")
#'
#' ## Plot a pileup plot, coloring elements by strand
#' pileupPlot <- plotRanges(
#'     data = IMR90_ChIP_CTCF_reads, chrom = "chr21",
#'     chromstart = 29072500, chromend = 29075000,
#'     assembly = "hg19",
#'     fill = colorby("strand", palette = 
#'                 colorRampPalette(c("steel blue", "light salmon"))),
#'     x = 0.5, y = 3.5, width = 6.5, height = 3.5,
#'     just = c("left", "bottom"),
#'     default.units = "inches"
#' )
#'
#' ## Add a legend depicting strand colors
#' legendPlot <- plotLegend(
#'     legend = c("- strand", "+ strand"),
#'     fill = c("steel blue", "light salmon"),
#'     border = FALSE,
#'     x = 5, y = 0.5, width = 1.5, height = 0.7,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Annotate genome label
#' annoGenomeLabel(
#'     plot = pileupPlot, x = 0.5, y = 3.5,
#'     just = c("left", "top")
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
plotLegend <- function(legend, fill = NULL, pch = NULL, lty = NULL,
                        orientation = "v", title = NULL, fontsize = 10,
                        border = TRUE,
                        bg = NA, x = NULL, y = NULL, width = NULL,
                        height = NULL, just = c("left", "top"),
                        default.units = "inches", draw = TRUE,
                        params = NULL, ...) {
    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    legInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "legInternal"
    )

    ## Set gp
    legInternal$gp <- setGP(
        gpList = gpar(),
        params = legInternal, ...
    )

    
    
    ## Reset lty
    if (is.null(legInternal$gp$lty)) {
        legInternal$gp$lty <- NULL
    }

    ## Justification
    legInternal$just <- justConversion(just = legInternal$just)
    
    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    legendPlot <- structure(list(
        x = legInternal$x, y = legInternal$y,
        width = legInternal$width,
        height = legInternal$height,
        just = legInternal$just, grobs = NULL
    ),
    class = "legend"
    )
    attr(x = legendPlot, which = "plotted") <- legInternal$draw

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    if (is.null(legInternal$legend)) stop("argument \"legend\" is missing, ",
                                            "with no default.", call. = FALSE)

    check_placement(object = legendPlot)
    
    checkColorby(fill = legInternal$fill,
                    colorby = FALSE)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    legendPlot <- defaultUnits(
        object = legendPlot,
        default.units = legInternal$default.units
    )

    textHeightfile <- file.path(tempdir(), "textHeight.pdf")
    on.exit(unlink(textHeightfile))
    textHeight <- with_pdf(textHeightfile, 
                           width = dev.size()[1],
                           height = dev.size()[2],
                           heightDetails(textGrob(label = "A",
                                gp = gpar(fontsize = legInternal$fontsize))))

    textGrobs <- lapply(legInternal$legend, textGrob,
        gp = gpar(fontsize = legInternal$fontsize)
    )
    textWidthsfile <- file.path(tempdir(), "textWidths.pdf")
    on.exit(unlink(textWidthsfile))
    
    textWidths <- with_pdf(textWidthsfile, 
                           width = dev.size()[1],
                           height = dev.size()[2],
                           lapply(textGrobs, widthDetails))
    
    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## If placing information is provided but plot == TRUE,
    ## set up it's own viewport separate
    ## Not translating into page_coordinates
    if (is.null(legendPlot$x) | is.null(legendPlot$y)) {
        vp <- viewport(
            height = unit(0.125, "snpc"), width = unit(0.20, "snpc"),
            x = unit(0.5, "npc"), y = unit(0.5, "npc"),
            just = "center",
            yscale = c(0, 0.125),
            xscale = c(0, 0.20),
            name = "legend1"
        )
        
        textHeightfile <- file.path(tempdir(), "textHeight.pdf")
        on.exit(unlink(textHeightfile))
        
        textHeight <- with_pdf(textHeightfile, 
                               width = dev.size()[1],
                               height = dev.size()[2],{
                     pushViewport(vp)
                     convertHeight(textHeight, unitTo = "native", 
                                   valueOnly = TRUE)
                 })
        
        textWidthsfile <- file.path(tempdir(), "textWidths.pdf")
        on.exit(unlink(textWidthsfile))
        textWidths <- with_pdf(textWidthsfile,
                               width = dev.size()[1],
                               height = dev.size()[2],{
                                   pushViewport(vp)
                                   lapply(textWidths, 
                                          convertWidth, 
                                          unitTo = "native", valueOnly = TRUE)
                               })
        height <- 0.125
        width <- 0.20

        if (legInternal$draw == TRUE) {
            grid.newpage()
        }
    } else {
        
        ## Get viewport name
        currentViewports <- current_viewports()
        vp_name <- paste0(
            "legend",
            length(grep(
                pattern = "legend",
                x = currentViewports
            )) + 1
        )

        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = legendPlot)
        addViewport(vp_name)

        height <- convertHeight(page_coords$height,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
        width <- convertWidth(page_coords$width,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
        ## Make viewport
        vp <- viewport(
            height = page_coords$height, width = page_coords$width,
            x = page_coords$x, y = page_coords$y,
            just = legInternal$just,
            yscale = c(0, height),
            xscale = c(0, width),
            name = vp_name
        )

        textHeight <- convertHeight(textHeight,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
        textWidths <- lapply(textWidths, convertWidth,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS
    # =========================================================================

    assign("legend_grobs", gTree(vp = vp), envir = pgEnv)

    # =========================================================================
    # GROBS
    # =========================================================================

    ## Border
    if (legInternal$border == TRUE) {
        
        if (is.null(legInternal$gp$border.lty)){
            legInternal$gp$border.lty <- 1
        }
        if (is.null(legInternal$gp$border.linecolor)){
            legInternal$gp$border.linecolor <- "black"
        }
        
        border <- rectGrob(gp = gpar(fill = legInternal$bg,
                                    lty = legInternal$gp$border.lty,
                                    col = legInternal$gp$border.linecolor))
    } else {
        legInternal$gp$fill <- legInternal$bg
        legInternal$gp$col <- NA
        border <- rectGrob(gp = legInternal$gp)
    }

    assign("legend_grobs",
        addGrob(get("legend_grobs", envir = pgEnv),
            child = border
        ),
        envir = pgEnv
    )

    ## Title
    if (!is.null(legInternal$title)) {

        if (legInternal$orientation == "h") {
            remainingSpace <- height - textHeight * 2
            spaceNo <- 3
        } else {
            remainingSpace <- height - textHeight *
                (length(legInternal$legend) + 1)
            spaceNo <- length(legInternal$legend) + 2
        }

        ## Remove lty
        lty <- legInternal$gp$lty
        legInternal$gp$lty <- NULL
        ## Remove cex for text
        cex <- legInternal$gp$cex
        legInternal$gp$cex <- NULL
        
        ## Reset col for title
        if (!is.null(legInternal$gp$col)){
            if (is.na(legInternal$gp$col)){
                legInternal$gp$col <- "black"
            } 
        }
        titleGrob <- textGrob(
            label = legInternal$title,
            x = unit(0.5, "npc"),
            y = height - remainingSpace / spaceNo,
            just = "top", gp = legInternal$gp,
            default.units = "native"
        )
        assign("legend_grobs",
            addGrob(get("legend_grobs", envir = pgEnv),
                child = titleGrob
            ),
            envir = pgEnv
        )

        legInternal$gp$lty <- lty
        legInternal$gp$cex <- cex
    } else {
        if (legInternal$orientation == "h") {
            remainingSpace <- height - textHeight
            spaceNo <- 2
        } else {
            remainingSpace <- height - textHeight *
                length(legInternal$legend)
            spaceNo <- length(legend) + 1
        }
    }


    ## Colors
    ## Only take the first number of colors for the length of legend
    fillcolors <- legInternal$fill[seq(1, length(legInternal$legend))]
    ## Spacing and label coordinates
    spaceHeight <- remainingSpace / spaceNo

    if (legInternal$orientation == "h") {
        ycoords <- spaceHeight
        remainingWidth <- width - (sum(unlist(textWidths)) +
            textHeight *
                length(legInternal$legend))
        width_spaces <- 2 * length(legInternal$legend) + 1
        widthSpace <- remainingWidth / width_spaces
        if (widthSpace < 0) {
            widthSpace <- 0.1 * textHeight
        }

        addTexts <- function(factor, textWidths) {
            totalText <- sum(textWidths[seq(0, factor)])
            return(totalText)
        }

        textWidth <- c(
            0,
            unlist(textWidths)[seq(
                1, (length(legInternal$legend) - 1)
            )]
        )
        df <- as.data.frame(cbind(
            "factor" = seq(0, (length(legInternal$legend) - 1)),
            "firstSpace" = rep(widthSpace, length(legInternal$legend))
        ))
        df$totalText <- unlist(lapply(df$factor, addTexts,
            textWidths = unlist(textWidths)
        ))

        xcoords <- df$firstSpace + df$factor *
            (2 * widthSpace + textHeight) + df$totalText

        xpch <- xcoords + 0.5 * textHeight
        ypch <- rep(
            spaceHeight + 0.5 * textHeight,
            length(legInternal$legend)
        )

        x0s <- xcoords
        y0s <- spaceHeight + 0.5 * textHeight
        x1s <- x0s + textHeight
        y1s <- spaceHeight + 0.5 * textHeight
    } else {
        ycoords <- seq(
            from = spaceHeight, to = height,
            by = (spaceHeight + textHeight)
        )[seq(1, length(legInternal$legend))]
        xcoords <- textHeight * 2

        xpch <- rep(textHeight * 2, length(legInternal$legend))
        ypch <- ycoords + 0.5 * textHeight

        x0s <- textHeight
        y0s <- ycoords + 0.5 * textHeight
        x1s <- 3 * textHeight
        y1s <- ycoords + 0.5 * textHeight

        fillcolors <- rev(fillcolors)
    }

    ## Symbols
    if (!is.null(legInternal$pch)) {
        ## Only take the first number of symbols for the length of legend
        pchs <- legInternal$pch[seq(1, length(legInternal$legend))]
        if (legInternal$orientation == "v") {
            pchs <- rev(pchs)
        }

        legInternal$gp$col <- fillcolors

        labelSymbols <- pointsGrob(
            x = xpch, y = ypch,
            pch = pchs,
            gp = legInternal$gp,
            default.units = "native"
        )
        assign("legend_grobs",
            addGrob(get("legend_grobs", envir = pgEnv),
                child = labelSymbols
            ),
            envir = pgEnv
        )

        ## Lines
    } else if (!is.null(lty)) {
        ## Only take the number of linetypes for the length of legend
        if (length(lty) < length(legend)){
            ltys <- rep(lty, length(legend))
        } else {
            ltys <- lty
        }
        ltys <- ltys[seq(1, length(legend))]
        lty <- legInternal$gp$lty
        legInternal$gp$lty <- ltys
        legInternal$gp$col <- fillcolors
        labelLines <- segmentsGrob(
            x0 = x0s, y0 = y0s,
            x1 = x1s, y1 = y1s,
            gp = legInternal$gp,
            default.units = "native"
        )
        assign("legend_grobs",
            addGrob(get("legend_grobs", envir = pgEnv),
                child = labelLines
            ),
            envir = pgEnv
        )

        legInternal$gp$lty <- lty
    } else {
        labelColors <- rectGrob(
            x = xcoords, y = ycoords,
            width = textHeight, height = textHeight,
            just = c("left", "bottom"),
            gp = gpar(fill = fillcolors, col = NA),
            default.units = "native"
        )
        assign("legend_grobs",
            addGrob(get("legend_grobs", envir = pgEnv),
                child = labelColors
            ),
            envir = pgEnv
        )
    }

    legInternal$gp$fontsize <- legInternal$fontsize

    if (is.null(legInternal$gp$fontcolor)) {
        legInternal$gp$fontcolor <- "black"
        legInternal$gp$col <- "black"
    } else {
        legInternal$gp$col <- legInternal$gp$fontcolor
    }
    legInternal$gp$lty <- NULL
    legInternal$gp$cex <- NULL

    ## Text labels
    if (legInternal$orientation == "h") {
        labelText <- textGrob(
            label = legInternal$legend,
            x = xcoords + textHeight + widthSpace,
            y = ycoords + 0.5 * textHeight,
            just = c("left", "center"),
            gp = legInternal$gp, default.units = "native"
        )
    } else {
        labelText <- textGrob(
            label = rev(legInternal$legend),
            x = xcoords + 2 * textHeight,
            y = ycoords + 0.5 * textHeight,
            just = c("left", "center"),
            gp = legInternal$gp, default.units = "native"
        )
    }

    assign("legend_grobs",
        addGrob(get("legend_grobs", envir = pgEnv),
            child = labelText
        ),
        envir = pgEnv
    )


    # =========================================================================
    # IF PLOT == TRUE, DRAW GROBS
    # =========================================================================

    if (legInternal$draw == TRUE) {
        grid.draw(get("legend_grobs", envir = pgEnv))
    }
    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    legendPlot$grobs <- get("legend_grobs", envir = pgEnv)

    # ========================================================================
    # RETURN OBJECT
    # ========================================================================

    message("legend[", vp$name, "]")
    invisible(legendPlot)
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

checkRow <- function(x, maxRows, rowCol, wig) {
    .Call('_plotgardener_checkRow', PACKAGE = 'plotgardener', x, maxRows, rowCol, wig)
}

rebinBigwig <- function(bigwig, bins) {
    .Call('_plotgardener_rebinBigwig', PACKAGE = 'plotgardener', bigwig, bins)
}

#' Annotate domains in a Hi-C plot
#'
#' @usage annoDomains(
#'     plot,
#'     data,
#'     half = "inherit",
#'     linecolor = "black",
#'     params = NULL,
#'     ...
#' )
#'
#' @param plot Hi-C plot object from \code{plotHicSquare} or
#' \code{plotHicTriangle} on which to annotate pixels.
#' @param data A string specifying the BED file path, a dataframe in BED
#' format, or a \link[GenomicRanges]{GRanges} object specifying
#' domain ranges.
#' @param half Character value specifying which half of hic plots
#' to annotate. Triangle Hi-C plots will always default to the entirety of
#' the triangular plot. Default value is \code{half = "inherit"}. Options are:
#' \itemize{
#' \item{\code{"inherit"}: }{Domains will be annotated on the \code{half}
#' inherited by the input Hi-C plot.}
#' \item{\code{"both"}: }{Domains will be annotated on both halves of the
#' diagonal of a square Hi-C plot.}
#' \item{\code{"top"}: }{Domains will be annotated on the upper diagonal
#' half of a square Hi-C plot.}
#' \item{\code{"bottom"}: }{Domains will be annotated ont the bottom diagonal
#' half of a square Hi-C plot.}
#' }
#' @param linecolor A character value specifying the color of the domain
#' annotations. Default value is \code{linecolor = "black"}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{domain} object containing relevant
#' genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Define a GRanges object with TAD ranges
#' library(GenomicRanges)
#' library(IRanges)
#' domains <- GRanges("chr21",
#'     ranges = IRanges(
#'         start = c(28210000, 29085000, 29430000, 29700000),
#'         end = c(29085000, 29430000, 29700000, 30125000)
#'     )
#' )
#'
#' ## Load Hi-C data
#' library(plotgardenerData)
#' data("IMR90_HiC_10kb")
#'
#' ## Create page
#' pageCreate(width = 4.5, height = 4, default.units = "inches")
#'
#' ## Plot and place a square Hi-C plot
#' hicPlot <- plotHicSquare(
#'     data = IMR90_HiC_10kb, resolution = 10000,
#'     zrange = c(0, 70),
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19",
#'     x = 0.5, y = 0.5, width = 3, height = 3,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Annotate domains on bottom half 0f Hi-C plot
#' annoDomains(
#'     plot = hicPlot, data = domains,
#'     half = "bottom", linecolor = "red"
#' )
#'
#' ## Annotate heatmap legend
#' annoHeatmapLegend(
#'     plot = hicPlot,
#'     x = 3.6, y = 0.5, width = 0.12, height = 1.2,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Annotate genome label
#' annoGenomeLabel(
#'     plot = hicPlot, x = 0.5, y = 3.53, scale = "Mb",
#'     just = c("left", "top")
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
annoDomains <- function(plot, data, half = "inherit",
                        linecolor = "black", params = NULL, ...) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that checks errors for annoDomains
    errorcheck_annoDomains <- function(hic, half) {

        ###### hic #####

        ## check type of input for hic
        if (!class(hic) %in% c(
            "hicSquare", "hicTriangle",
            "hicRectangle"
        )) {
            stop("Input plot must be a plot of class \'hicSquare\', ",
                "\'hicTriangle\', or \'hicRectangle\'.",
                call. = FALSE
            )
        }

        ###### half #####

        ## half needs to be a valid option
        if (!half %in% c("inherit", "both", "top", "bottom")) {
            stop("Invalid \'half\'.  Options are \'inherit\', ",
                "\'both\', \'top\', or \'bottom\'.",
                call. = FALSE
            )
        }

        ## half needs to be able to align with what kind of hic plot is plotted
        if (is(hic, "hicSquare")) {
            if (hic$chrom == hic$altchrom) {
                if ((hic$half == "top" | hic$half == "bottom") &&
                    (half == "both")) {
                    stop("Invalid \'half\' of plot to annotate.",
                        call. = FALSE
                    )
                }

                if (hic$half == "top" & half == "bottom") {
                    stop("Invalid \'half\' of plot to annotate.",
                        call. = FALSE
                    )
                }

                if (hic$half == "bottom" & half == "top") {
                    stop("Invalid \'half\' of plot to annotate.",
                        call. = FALSE
                    )
                }
            } else {
                stop("Cannot annotate domains for an intrachromosomal ",
                    "square Hi-C plot.",
                    call. = FALSE
                )
            }
        } else if (is(hic, "hicTriangle") |
            is(hic, "hicRectangle")) {
            if (half == "both" | half == "bottom") {
                warning("Plot of class \'",
                    class(hic),
                    "\' detected. Pixels will automatically be annotated ",
                    "in the upper triangular of the plot.",
                    call. = FALSE
                )
            }
        }
    }

    ## Define a function that creates annotation grobs
    domainAnnotation <- function(df, object, half) {
        if (half == "bottom") {
            x0_1 <- utils::type.convert(df["start"], as.is = TRUE)
            x1_1 <- utils::type.convert(df["end"], as.is = TRUE)
            y_1 <- utils::type.convert(df["start"], as.is = TRUE)

            x_2 <- utils::type.convert(df["end"], as.is = TRUE)
            y0_2 <- utils::type.convert(df["start"], as.is = TRUE)
            y1_2 <- utils::type.convert(df["end"], as.is = TRUE)

            seg1 <- segmentsGrob(
                x0 = x0_1, x1 = x1_1,
                y0 = y_1, y1 = y_1,
                default.units = "native",
                gp = object$gp
            )

            seg2 <- segmentsGrob(
                x0 = x_2, x1 = x_2,
                y0 = y0_2, y1 = y1_2,
                default.units = "native",
                gp = object$gp
            )

            assign("domain_grobs",
                addGrob(
                    get("domain_grobs", envir = pgEnv),
                    child = seg1
                ),
                envir = pgEnv
            )
            assign("domain_grobs",
                addGrob(
                    get("domain_grobs", envir = pgEnv),
                    child = seg2
                ),
                envir = pgEnv
            )
        } else if (half == "top") {
            x_1 <- utils::type.convert(df["start"], as.is = TRUE)
            y0_1 <- utils::type.convert(df["start"], as.is = TRUE)
            y1_1 <- utils::type.convert(df["end"], as.is = TRUE)

            x0_2 <- utils::type.convert(df["start"], as.is = TRUE)
            x1_2 <- utils::type.convert(df["end"], as.is = TRUE)
            y_2 <- utils::type.convert(df["end"], as.is = TRUE)
            seg1 <- segmentsGrob(
                x0 = x_1, x1 = x_1,
                y0 = y0_1, y1 = y1_1,
                default.units = "native",
                gp = object$gp
            )
                
            seg2 <- segmentsGrob(
                x0 = x0_2, x1 = x1_2,
                y0 = y_2, y1 = y_2,
                default.units = "native",
                gp = object$gp
            )

            assign("domain_grobs",
                addGrob(
                    get("domain_grobs", envir = pgEnv),
                    child = seg1
                ),
                envir = pgEnv
            )
            assign("domain_grobs",
                addGrob(
                    get("domain_grobs", envir = pgEnv),
                    child = seg2
                ),
                envir = pgEnv
            )
        } else if (half == "both") {
            x0_1 <- utils::type.convert(df["start"], as.is = TRUE)
            x1_1 <- utils::type.convert(df["end"], as.is = TRUE)
            y_1 <- utils::type.convert(df["start"], as.is = TRUE)
            x_2 <- utils::type.convert(df["end"], as.is = TRUE)
            y0_2 <- utils::type.convert(df["start"], as.is = TRUE)
            y1_2 <- utils::type.convert(df["end"], as.is = TRUE)


            x_1 <- utils::type.convert(df["start"], as.is = TRUE)
            y0_1 <- utils::type.convert(df["start"], as.is = TRUE)
            y1_1 <- utils::type.convert(df["end"], as.is = TRUE)
            x0_2 <- utils::type.convert(df["start"], as.is = TRUE)
            x1_2 <- utils::type.convert(df["end"], as.is = TRUE)
            y_2 <- utils::type.convert(df["end"], as.is = TRUE)


            seg1 <- segmentsGrob(
                x0 = x0_1, x1 = x1_1,
                y0 = y_1, y1 = y_1,
                default.units = "native",
                gp = object$gp
            )

            seg2 <- segmentsGrob(
                x0 = x_2, x1 = x_2,
                y0 = y0_2, y1 = y1_2,
                default.units = "native",
                gp = object$gp
            )

            seg3 <- segmentsGrob(
                x0 = x_1, x1 = x_1,
                y0 = y0_1, y1 = y1_1,
                default.units = "native",
                gp = object$gp
            )

            seg4 <- segmentsGrob(
                x0 = x0_2, x1 = x1_2,
                y0 = y_2, y1 = y_2,
                default.units = "native",
                gp = object$gp
            )

            assign("domain_grobs",
                addGrob(
                    get("domain_grobs", envir = pgEnv),
                    child = seg1
                ),
                envir = pgEnv
            )
            assign("domain_grobs",
                addGrob(
                    get("domain_grobs", envir = pgEnv),
                    child = seg2
                ),
                envir = pgEnv
            )
            assign("domain_grobs",
                addGrob(
                    get("domain_grobs", envir = pgEnv),
                    child = seg3
                ),
                envir = pgEnv
            )
            assign("domain_grobs",
                addGrob(
                    get("domain_grobs", envir = pgEnv),
                    child = seg4
                ),
                envir = pgEnv
            )
        }
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    domainsInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(
            match.call()[[1]]
        )),
        declaredArgs = lapply(
            match.call()[-1], eval.parent,
            n = 2
        ),
        class = "domainsInternal"
    )
    domainsInternal$gp <- setGP(
        gpList = gpar(),
        params = domainsInternal, ...
    )

    domainsInternal$gp$col <- domainsInternal$linecolor
    domainsInternal$gp$lineend <- "square"

    # =========================================================================
    # INITIALIZE OBJECT: GET REGION/DIMENSIONS FROM HIC PLOT INPUT
    # =========================================================================

    domains <- structure(list(
        hicClass = class(domainsInternal$plot),
        chrom = domainsInternal$plot$chrom,
        chromstart = domainsInternal$plot$chromstart,
        chromend = domainsInternal$plot$chromend,
        assembly = domainsInternal$plot$assembly,
        x = domainsInternal$plot$x,
        y = domainsInternal$plot$y,
        width = domainsInternal$plot$width,
        height = domainsInternal$plot$height,
        just = domainsInternal$plot$just, grobs = NULL,
        outsideVP = NULL
    ),
    class = "domain"
    )

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_page(error = "Cannot annotate Hi-C domains without a
                `plotgardener` page.")
    if (is.null(domainsInternal$plot)) {
        stop("argument \"plot\" is missing, ",
            "with no default.",
            call. = FALSE
        )
    }
    if (is.null(domainsInternal$data)) {
        stop("argument \"data\" is missing, ",
            "with no default.",
            call. = FALSE
        )
    }

    errorcheck_annoDomains(
        hic = domainsInternal$plot,
        half = domainsInternal$half
    )

    # =========================================================================
    # PARSE INHERITED HALF
    # =========================================================================

    half <- domainsInternal$half
    if (half == "inherit") {
        half <- inherit_half(hic = domainsInternal$plot)
    }

    if (is(domainsInternal$plot, "hicTriangle")  |
        is(domainsInternal$plot, "hicRectangle")) {
        if (domainsInternal$plot$flip == TRUE){
            half <- "bottom"
        } else {
            half <- "top"
        }
        
    }

    # =========================================================================
    # READ IN FILE, DATAFRAME OR GRANGES
    # =========================================================================

    bed <- read_rangeData(
        data = domainsInternal$data,
        assembly = domains$assembly
    )
    
    ## chrom format and data chrom format
    chromDataAgreement(data = bed, chrom = domains$chrom,
                    type = "ranges")

    # =========================================================================
    # SUBSET FOR DOMAINS IN REGION
    # =========================================================================

    bed_subset <- bed[which(bed[, "chrom"] == domains$chrom 
                            & bed[, "start"] <=
        domains$chromend & bed[, "end"] >=
        domains$chromstart), ]

    # =========================================================================
    # VIEWPORTS
    # =========================================================================
    ## Name viewport
    currentViewports <- current_viewports()
    vp_name <- paste0(
        "domain",
        length(grep(
            pattern = "domain",
            x = currentViewports
        )) + 1
    )
    
    ## Make viewport based on hic input viewport
    if (is(domainsInternal$plot, "hicSquare")) {
        vp <- viewport(
            height = domainsInternal$plot$grobs$vp$height,
            width = domainsInternal$plot$grobs$vp$width,
            x = domainsInternal$plot$grobs$vp$x,
            y = domainsInternal$plot$grobs$vp$y,
            clip = "on",
            xscale = domainsInternal$plot$grobs$vp$xscale,
            yscale = domainsInternal$plot$grobs$vp$yscale,
            just = domainsInternal$plot$grobs$vp$justification,
            name = paste0(vp_name, "_inside")
        )

        vpClip <- NULL
    } else if (is(domainsInternal$plot, "hicTriangle")) {
        width <- convertUnit(domainsInternal$plot$outsideVP$width,
            unitTo = get("page_units", pgEnv), valueOnly = TRUE
        )

        vp <- viewport(
            height = unit(width / sqrt(2), get("page_units", pgEnv)),
            width = unit(width / sqrt(2), get("page_units", pgEnv)),
            x = unit(0, "npc"), y = unit(0, "npc"),
            xscale = domainsInternal$plot$grobs$vp$xscale,
            yscale = domainsInternal$plot$grobs$vp$yscale,
            just = c("left", "bottom"),
            name = paste0(vp_name, "_inside"),
            angle = -45
        )

        vpClip <- viewport(
            height = domainsInternal$plot$outsideVP$height,
            width = domainsInternal$plot$outsideVP$width,
            x = domainsInternal$plot$outsideVP$x,
            y = domainsInternal$plot$outsideVP$y,
            just = domainsInternal$plot$outsideVP$justification,
            clip = "on",
            name = paste0(vp_name, "_outside")
        )
        if (domainsInternal$plot$flip == TRUE){
            vp$y <- unit(1, "npc")
        }
        
    } else if (is(domainsInternal$plot, "hicRectangle")) {
        side <- convertUnit(domainsInternal$plot$grobs$vp$width,
            unitTo = get("page_units", pgEnv)
        )

        vp <- viewport(
            height = side, width = side,
            x = unit(domainsInternal$plot$grobs$vp$xscale[1], "native"),
            y = unit(0, "npc"),
            xscale = domainsInternal$plot$grobs$vp$xscale,
            yscale = domainsInternal$plot$grobs$vp$yscale,
            just = c("left", "bottom"),
            name = paste0(vp_name, "_inside"),
            angle = -45
        )
        vpClip <- viewport(
            height = domainsInternal$plot$outsideVP$height,
            width = domainsInternal$plot$outsideVP$width,
            x = domainsInternal$plot$outsideVP$x,
            y = domainsInternal$plot$outsideVP$y,
            just = domainsInternal$plot$outsideVP$justification,
            xscale = domainsInternal$plot$outsideVP$xscale,
            clip = "on",
            name = paste0(vp_name, "_outside")
        )
        if (domainsInternal$plot$flip == TRUE){
            vp$y <- unit(1, "npc")
        }
    }

    # =========================================================================
    # INITIALIZE GTREE
    # =========================================================================

    domains$outsideVP <- vpClip
    assign("domain_grobs", gTree(vp = vp), envir = pgEnv)

    # =========================================================================
    # GROBS
    # =========================================================================

    if (nrow(bed_subset) > 0) {
        invisible(apply(bed_subset, 1, domainAnnotation,
            object = domainsInternal,
            half = half
        ))
    } else {
        warning("No domains found in region.", call. = FALSE)
    }

    # =========================================================================
    # ADD GROBS TO GLIST AND OBJECT
    # =========================================================================

    domains$grobs <- get("domain_grobs", envir = pgEnv)

    if (!is.null(vpClip)) {
        pushViewport(vpClip)
        grid.draw(domains$grobs)
        upViewport()
    } else {
        grid.draw(domains$grobs)
    }


    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("domain[", vp_name, "]")
    invisible(domains)
}

#' Plot a gene track for a specified genomic region
#' 
#' @usage plotGenes(
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     assembly = "hg38",
#'     fontsize = 8,
#'     fontcolor = c("#669fd9", "#abcc8e"),
#'     fill = c("#669fd9", "#abcc8e"),
#'     geneOrder = NULL,
#'     geneHighlights = NULL,
#'     geneBackground = "grey",
#'     strandLabels = TRUE,
#'     stroke = 0.1,
#'     bg = NA,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = unit(0.6, "inches"),
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL
#' )
#'
#' @param chrom Chromosome of region to be plotted, as a string.
#' @param chromstart Integer start position on chromosome to be plotted.
#' @param chromend Integer end position on chromosome to be plotted.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param fontsize A numeric specifying text fontsize in points.
#' Default value is \code{fontsize = 8}.
#' @param fontcolor A character value or vector of length 2 indicating
#' the fontcolors for the plus strand and minus strand gene labels.
#' The first value will color the plus strand gene labels and
#' the second value will color the minus strand gene labels.
#' Default value is \code{fontcolor = c("#669fd9", "#abcc8e")}.
#' @param fill A character value or vector of length 2 indicating the
#' strand fill colors for the plus strand and minus strand plot elements.
#' The first value will color the plus strand plot elements and
#' the second label will color the minus strand plot elements.
#' Default value is \code{fill = c("#669fd9", "#abcc8e")}.
#' @param geneOrder An ordered character vector of gene names to
#' prioritize when labeling genes.
#' @param geneHighlights A two-column dataframe with a column named "gene"
#' containing gene names as strings to highlight and a named column "color"
#' containing corresponding highlight colors.
#' @param geneBackground If \code{geneHighlights} is given, a character
#' value indicating the color for genes that are not highlighted.
#' @param strandLabels A logical value indicating whether to include
#' + and - strand labels to the left of the gene track.
#' @param stroke A numeric value indicating the stroke width for gene
#' body outlines. Default value is \code{stroke = 0.1}.
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param x A numeric or unit object specifying genes plot x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying genes plot y-location.
#' The character value will
#' place the genes plot y relative to the bottom of the most recently
#' plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying genes plot width.
#' @param height A numeric or unit object specifying genes plot height.
#' @param just Justification of genes plot relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use if
#' \code{x}, \code{y}, \code{width}, or \code{height} are only given
#' as numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output
#' should be produced. Default value is \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#'
#' @return Returns a \code{genes} object containing
#' relevant genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load hg19 genomic annotation packages
#' library("TxDb.Hsapiens.UCSC.hg19.knownGene")
#' library("org.Hs.eg.db")
#'
#' ## Set genomic coordinates
#' paramssmall <- pgParams(
#'     chrom = "chr8",
#'     chromstart = 1, chromend = 3000000,
#'     assembly = "hg19", width = 7
#' )
#' paramsbig <- pgParams(
#'     chrom = "chr8",
#'     chromstart = 1, chromend = 146364022,
#'     assembly = "hg19", width = 7
#' )
#' ## Set colors
#' cols <- c("#41B6C4", "#225EA8")
#'
#' ## Create page
#' pageCreate(width = 7.5, height = 3.5, default.units = "inches")
#'
#' ## Plot genes big
#' genesPlot <- plotGenes(
#'     params = paramsbig, fill = cols,
#'     fontcolor = cols,
#'     x = 0.25, y = 0.25, height = 0.75,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Annotate genome label
#' annoGenomeLabel(
#'     plot = genesPlot, x = 0.25, y = 1.0,
#'     scale = "Mb", just = c("left", "top")
#' )
#'
#' ## Plot genes small
#' genesPlot <- plotGenes(
#'     params = paramssmall,
#'     geneHighlights = data.frame(
#'         "gene" = c("DLGAP2"),
#'         "color" = c("#225EA8")
#'     ),
#'     geneBackground = "grey",
#'     x = 0.25, y = 2.25, height = 0.75,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Annotate genome label
#' annoGenomeLabel(
#'     plot = genesPlot, x = 0.25, y = 3.0, scale = "Mb",
#'     just = c("left", "top")
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @details
#' A gene track can be placed on a page by providing
#' plot placement parameters:
#' \preformatted{
#' plotGenes(chrom, chromstart = NULL, chromend = NULL,
#'             x, y, width, height, just = c("left", "top"),
#'             default.units = "inches")
#' }
#' This function can be used to quickly plot an unnannotated gene track
#' by ignoring plot placement parameters:
#' \preformatted{
#' plotGenes(chrom, chromstart = NULL, chromend = NULL)
#' }
#'
#' Genomic annotation information is acquired through
#' \link[GenomicFeatures]{TxDb} and \link[AnnotationDbi]{OrgDb-class}
#' packages, as determined
#' through the \code{assembly} parameter. To avoid overcrowding of gene name
#' labels, plotted gene labels are by default prioritized according to
#' citation counts.
#'
#' @seealso \link[plotgardener]{assembly},
#' \link[plotgardener]{genomes}, \link[plotgardener]{defaultPackages}
#'
#' @export
plotGenes <- function(chrom, chromstart = NULL, chromend = NULL,
                        assembly = "hg38", fontsize = 8,
                        fontcolor = c("#669fd9", "#abcc8e"),
                        fill = c("#669fd9", "#abcc8e"),
                        geneOrder = NULL, geneHighlights = NULL,
                        geneBackground = "grey", strandLabels = TRUE,
                        stroke = 0.1, bg = NA, x = NULL, y = NULL,
                        width = NULL, height = unit(0.6, "inches"),
                        just = c("left", "top"), default.units = "inches",
                        draw = TRUE, params = NULL) {
    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that checks errors for plotGenes
    errorcheck_plotGenes <- function(chromstart, chromend, fill) {
        
        ## Genomic region errors
        regionErrors(chromstart = chromstart, chromend = chromend)
        
        ## Make sure fill isn't colorby
        checkColorby(fill = fill,
                        colorby = FALSE)
    }

    ## Define a function that gets total lengths and centers of visible genes
    get_geneCenters <- function(geneData, object) {
        minStart <- min(geneData$TXSTART)
        if (minStart < object$chromstart){
            minStart <- object$chromstart
        }
        maxEnd <- max(geneData$TXEND)
        if (maxEnd > object$chromend){
            maxEnd <- object$chromend
        }
        
        geneLength <- maxEnd - minStart
        geneCenter <- mean(c(minStart, maxEnd))
        return(list(geneLength, geneCenter))
    }

    ## Define a function that prioritizes genes based on internal
    ## priorities and/or user-defined geneOrder
    gene_priorities <- function(genes, geneOrder, displayCol) {

        ## Split list into the ones in geneOrder and the ones not
        subset <- genes[which(genes[[displayCol]] %in% geneOrder), ]
        remaining <- genes[which(!genes[[displayCol]] %in% geneOrder), ]

        ## Put the geneOrder subset into the same order
        subset <- subset[match(geneOrder, subset[[displayCol]]), ]
        subset <- subset[which(!is.na(subset[[displayCol]])), ]

        ## Recombine lists, putting geneOrder section at the top
        combined <- rbind(subset, remaining)

        return(combined)
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    genesInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "genesInternal"
    )
    
    ## Justification
    genesInternal$just <- justConversion(just = genesInternal$just)

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    genes <- structure(list(
        chrom = genesInternal$chrom,
        chromstart = genesInternal$chromstart,
        chromend = genesInternal$chromend,
        assembly = genesInternal$assembly,
        x = genesInternal$x, y = genesInternal$y,
        width = genesInternal$width,
        height = genesInternal$height,
        just = genesInternal$just, grobs = NULL
    ),
    class = "genes"
    )
    attr(x = genes, which = "plotted") <- genesInternal$draw

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    if (is.null(genes$chrom)) stop("argument \"chrom\" is missing, ",
                                    "with no default.", call. = FALSE)
    errorcheck_plotGenes(
        chromstart = genes$chromstart,
        chromend = genes$chromend,
        fill = genesInternal$fill
    )
    check_placement(object = genes)

    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    genes$assembly <- parseAssembly(assembly = genes$assembly)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    genes <- defaultUnits(
        object = genes,
        default.units = genesInternal$default.units
    )

    # =========================================================================
    # GET APPROPRIATE BUILD DATA
    # =========================================================================

    buildData <- geneData(object = genes,
                        objectInternal = genesInternal)
    genes <- buildData[[1]]
    genesInternal <- buildData[[2]]
    displayCol <- genesInternal$displayCol

    # =========================================================================
    # SUBSET DATA BY STRAND
    # =========================================================================
    data <- genesInternal$data
    ## Genes on plus strand and genes on minus strand
    plus_genes <- data[which(data$TXSTRAND == "+"), ]
    minus_genes <- data[which(data$TXSTRAND == "-"), ]

    # =========================================================================
    # COLORS AND HIGHLIGHTS
    # =========================================================================

    ## If fontcolor and fill are length 1, change to length 2
    if (length(genesInternal$fontcolor) == 1) {
        genesInternal$fontcolor <- rep(genesInternal$fontcolor, 2)
    }
    if (length(genesInternal$fill) == 1) {
        genesInternal$fill <- rep(genesInternal$fill, 2)
    }

    ## Add strandColor and fontColors
    if (nrow(plus_genes) > 0) {
        plus_genes$strandColor <- genesInternal$fill[1]
        plus_genes$fontColor <- genesInternal$fontcolor[1]
    }

    if (nrow(minus_genes) > 0) {
        minus_genes$strandColor <- genesInternal$fill[2]
        minus_genes$fontColor <- genesInternal$fontcolor[2]
    }


    ## Find genes to be highlighted
    if (!is.null(genesInternal$geneHighlights)) {
        colnames(genesInternal$geneHighlights) <- c(
            displayCol,
            "strandColor"
        )
        plus_genes$strandColor <- NULL
        minus_genes$strandColor <- NULL

        plusHighlight <- plus_genes[which(plus_genes[[displayCol]] %in%
            genesInternal$geneHighlights
            [[displayCol]]), ]
        minusHighlight <- minus_genes[which(minus_genes[[displayCol]] %in%
            genesInternal$geneHighlights
            [[displayCol]]), ]
        plusBackground <- plus_genes[which(!plus_genes[[displayCol]] %in%
            genesInternal$geneHighlights
            [[displayCol]]), ]
        minusBackground <- minus_genes[which(!minus_genes[[displayCol]] %in%
            genesInternal$geneHighlights
            [[displayCol]]), ]

        # Change highlight genes to highlight color
        plusHighlight <- merge(plusHighlight, genesInternal$geneHighlights,
            by = displayCol
        )
        plusHighlight$fontColor <- plusHighlight$strandColor

        minusHighlight <- merge(minusHighlight, genesInternal$geneHighlights,
            by = displayCol
        )
        minusHighlight$fontColor <- minusHighlight$strandColor

        # Change background genes to background color
        plusBackground$strandColor <- rep(
            genesInternal$geneBackground[1],
            nrow(plusBackground)
        )
        plusBackground$fontColor <- rep(
            genesInternal$geneBackground[1],
            nrow(plusBackground)
        )
        minusBackground$strandColor <- rep(
            genesInternal$geneBackground[1],
            nrow(minusBackground)
        )
        minusBackground$fontColor <- rep(
            genesInternal$geneBackground[1],
            nrow(minusBackground)
        )

        ## Automatically change fontcolor for +/- strand label
        genesInternal$fontcolor[1] <- genesInternal$geneBackground[1]
        genesInternal$fontcolor[2] <- genesInternal$geneBackground[1]

        ## Put highlight and background genes back together
        plus_genes <- rbind(plusHighlight, plusBackground)
        minus_genes <- rbind(minusHighlight, minusBackground)
    }

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## Define text grob for "+" and "-" viewport scaling
    tG <- textGrob(label = "+", gp = gpar(
        fontsize =
            genesInternal$fontsize
    ))

    if (is.null(genes$x) | is.null(genes$y)) {
        if (genesInternal$strandLabels == TRUE) {

            ## Make viewport for "+" and "-" labels to the left of genetrack
            
            # Calculate viewport with in temporary graphics device to avoid
            # page
            
            file <- file.path(tempdir(), "tG.pdf")
            on.exit(unlink(file))
            vp_labelW <- with_pdf(file,
                                  width = dev.size()[1],
                                  height = dev.size()[2],
                                  convertWidth(widthDetails(tG) * 2,
                                               unitTo = "npc"))
            
            
            vp_label <- viewport(
                height = unit(.12, "npc"),
                width = vp_labelW,
                x = unit(0, "npc"), y = unit(0.5, "npc"),
                just = "left",
                name = "genes1_label"
            )

            vp_gene <- viewport(
                height = unit(.12, "npc"),
                width = unit(1, "npc") - vp_labelW,
                x = vp_labelW, y = unit(0.5, "npc"),
                clip = "on",
                xscale = genesInternal$xscale,
                just = "left",
                name = "genes1"
            )
        } else {
            vp_gene <- viewport(
                height = unit(.12, "npc"),
                width = unit(1, "npc"),
                x = unit(0, "npc"), y = unit(0.5, "npc"),
                clip = "on",
                xscale = genesInternal$xscale,
                just = "left",
                name = "genes1"
            )
        }

        if (genesInternal$draw == TRUE) {
            grid.newpage()
        }
    } else {
        
        ## Name viewport
        currentViewports <- current_viewports()
        vp_name <- paste0(
            "genes",
            length(intersect(
                grep(
                    pattern = "genes",
                    x = currentViewports
                ),
                grep(
                    pattern = "label",
                    x = currentViewports,
                    invert = TRUE
                )
            )) + 1
        )
        
        addViewport(vp_name)

        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = genes)

        ## Make viewport for gene track
        vp_gene <- viewport(
            height = page_coords$height,
            width = page_coords$width,
            x = page_coords$x, y = page_coords$y,
            clip = "on",
            xscale = genesInternal$xscale,
            just = genesInternal$just,
            name = vp_name
        )

        if (genesInternal$strandLabels == TRUE) {

            ## Make viewport for "+" and "-" labels based on above viewport
            topLeft_vp <- vp_topLeft(viewport = vp_gene)

            vp_label <- viewport(
                height = page_coords$height,
                width = convertWidth(widthDetails(tG) * 2,
                    unitTo = get("page_units",
                        envir = pgEnv
                    )
                ),
                x = topLeft_vp[[1]], y = topLeft_vp[[2]],
                just = c("right", "top"),
                name = paste0(vp_name, "_label")
            )
        }
    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS WITH BACKGROUND
    # =========================================================================

    backgroundGrob <- rectGrob(
        gp = gpar(
            fill = genesInternal$bg,
            col = NA
        ),
        name = "background", vp = vp_gene
    )
    assign("gene_grobs", gTree(children = gList(backgroundGrob)),
        envir = pgEnv
    )

    # =========================================================================
    # MAKE GROBS
    # =========================================================================

    if (nrow(data) > 0) {

        ##########################################################
        ## GENE LINES ONLY
        ##########################################################

        if ((genes$chromend - genes$chromstart) >= 25000000) {
            if (nrow(plus_genes) > 0) {
                plus_lines <- unique(plus_genes[,c("TXSTART", "TXEND", 
                                                "fontColor", "strandColor")])
                plus_geneGrobs <- rectGrob(
                    x = plus_lines$TXSTART,
                    y = unit(0.63, "npc"),
                    width = plus_lines$TXEND - plus_lines$TXSTART,
                    height = unit(0.18, "npc"),
                    just = "left",
                    gp = gpar(
                        fill = plus_lines$strandColor,
                        col = plus_lines$strandColor,
                        lwd = genesInternal$stroke
                    ),
                    vp = vp_gene, default.units = "native"
                )
                assign("gene_grobs",
                    addGrob(get("gene_grobs", envir = pgEnv),
                        child = plus_geneGrobs
                    ),
                    envir = pgEnv
                )
            }

            if (nrow(minus_genes) > 0) {
                minus_lines <- unique(minus_genes[,c("TXSTART", "TXEND", 
                                                "fontColor", "strandColor")])
                minus_geneGrobs <- rectGrob(
                    x = minus_lines$TXSTART,
                    y = unit(0.37, "npc"),
                    width = minus_lines$TXEND - minus_lines$TXSTART,
                    height = unit(0.18, "npc"),
                    just = "left",
                    gp = gpar(
                        fill = minus_lines$strandColor,
                        col = minus_lines$strandColor,
                        lwd = genesInternal$stroke
                    ),
                    vp = vp_gene, default.units = "native"
                )
                assign("gene_grobs",
                    addGrob(get("gene_grobs", envir = pgEnv),
                        child = minus_geneGrobs
                    ),
                    envir = pgEnv
                )
            }
        } else {
            if (nrow(plus_genes) > 0) {
                ##########################################################
                ## GENE LINES
                ##########################################################
                plus_lines <- unique(plus_genes[,c("TXSTART", "TXEND", 
                                                "fontColor", "strandColor")])
                plus_geneGrobs <- rectGrob(
                    x = plus_lines$TXSTART,
                    y = unit(0.63, "npc"),
                    width = plus_lines$TXEND - plus_lines$TXSTART,
                    height = unit(0.05, "npc"),
                    just = "left",
                    gp = gpar(
                        fill = plus_lines$strandColor,
                        col = plus_lines$strandColor,
                        lwd = genesInternal$stroke
                    ),
                    vp = vp_gene, default.units = "native"
                )

                ##########################################################
                ## GENE EXONS
                ###########################################################

                plus_exonsGrobs <- rectGrob(
                    x = plus_genes$EXONSTART,
                    y = unit(0.63, "npc"),
                    width = plus_genes$EXONEND - plus_genes$EXONSTART,
                    height = unit(0.1, "npc"),
                    just = "left",
                    gp = gpar(
                        fill = plus_genes$strandColor,
                        col = NA
                    ),
                    vp = vp_gene, default.units = "native"
                )


                ##########################################################
                ## GENE CDS
                ##########################################################

                ## Get CDS regions that aren't NA
                poscdsData <- plus_genes[which(!is.na(plus_genes$CDSSTART)), ]
                if (nrow(poscdsData) > 0) {
                    plus_cdsGrobs <- rectGrob(
                        x = poscdsData$CDSSTART,
                        y = unit(0.63, "npc"),
                        width = poscdsData$CDSEND - poscdsData$CDSSTART,
                        height = unit(0.18, "npc"),
                        just = "left",
                        gp = gpar(
                            fill = poscdsData$strandColor,
                            col = poscdsData$strandColor,
                            lwd = 1.25
                        ),
                        vp = vp_gene, default.units = "native"
                    )
                    assign("gene_grobs",
                        addGrob(get("gene_grobs", envir = pgEnv),
                            child = plus_cdsGrobs
                        ),
                        envir = pgEnv
                    )
                }

                assign("gene_grobs",
                    addGrob(get("gene_grobs", envir = pgEnv),
                        child = plus_geneGrobs
                    ),
                    envir = pgEnv
                )
                assign("gene_grobs",
                    addGrob(get("gene_grobs", envir = pgEnv),
                        child = plus_exonsGrobs
                    ),
                    envir = pgEnv
                )
            }

            if (nrow(minus_genes) > 0) {

                ##########################################################
                ## GENE LINES
                ##########################################################
                minus_lines <- unique(minus_genes[,c("TXSTART", "TXEND", 
                                                "fontColor", "strandColor")])
                minus_geneGrobs <- rectGrob(
                    x = minus_lines$TXSTART,
                    y = unit(0.37, "npc"),
                    width = minus_lines$TXEND - minus_lines$TXSTART,
                    height = unit(0.05, "npc"),
                    just = "left",
                    gp = gpar(
                        fill = minus_lines$strandColor,
                        col = minus_lines$strandColor,
                        lwd = genesInternal$stroke
                    ),
                    vp = vp_gene, default.units = "native"
                )

                ##########################################################
                ## GENE EXONS
                ###########################################################

                minus_exonsGrobs <- rectGrob(
                    x = minus_genes$EXONSTART,
                    y = unit(0.37, "npc"),
                    width = minus_genes$EXONEND - minus_genes$EXONSTART,
                    height = unit(0.1, "npc"),
                    just = "left",
                    gp = gpar(
                        fill = minus_genes$strandColor,
                        col = NA
                    ),
                    vp = vp_gene, default.units = "native"
                )

                ##########################################################
                ## GENE CDS
                ##########################################################

                ## Get CDS regions that aren't NA
                mincdsData <- minus_genes[which(!is.na(minus_genes$CDSSTART)), ]
                if (nrow(mincdsData) > 0) {
                    minus_cdsGrobs <- rectGrob(
                        x = mincdsData$CDSSTART,
                        y = unit(0.37, "npc"),
                        width = mincdsData$CDSEND - mincdsData$CDSSTART,
                        height = unit(0.18, "npc"),
                        just = "left",
                        gp = gpar(
                            fill = mincdsData$strandColor,
                            col = mincdsData$strandColor,
                            lwd = 1.25
                        ),
                        vp = vp_gene, default.units = "native"
                    )
                    assign("gene_grobs",
                        addGrob(get("gene_grobs", envir = pgEnv),
                            child = minus_cdsGrobs
                        ),
                        envir = pgEnv
                    )
                }

                assign("gene_grobs",
                    addGrob(get("gene_grobs", envir = pgEnv),
                        child = minus_geneGrobs
                    ),
                    envir = pgEnv
                )
                assign("gene_grobs",
                    addGrob(get("gene_grobs", envir = pgEnv),
                        child = minus_exonsGrobs
                    ),
                    envir = pgEnv
                )
            }
        }

        ##########################################################
        ## GENE NAME LABELS
        ##########################################################

        ## Split into mini dataframes based on GENEID
        separatedplusGenes <- split(plus_genes, plus_genes$GENEID)
        separatedminusGenes <- split(minus_genes, minus_genes$GENEID)

        ## For every GENEID dataframe, get length and center
        ## location of each total gene
        plusgeneCenters <- lapply(separatedplusGenes, get_geneCenters,
                                object = genes)
        plusgeneCenters <- data.frame(
            GENEID = names(plusgeneCenters),
            length = unlist(purrr::map(plusgeneCenters, 1)),
            labelLoc = unlist(purrr::map(plusgeneCenters, 2))
        )
        minusgeneCenters <- lapply(separatedminusGenes, get_geneCenters, 
                                object = genes)
        minusgeneCenters <- data.frame(
            GENEID = names(minusgeneCenters),
            length = unlist(purrr::map(minusgeneCenters, 1)),
            labelLoc = unlist(purrr::map(minusgeneCenters, 2))
        )

        ## Get representative value of each shown gene name
        plusgeneNames <- plus_genes[duplicated(plus_genes[[displayCol]]) ==
            FALSE, ]
        minusgeneNames <- minus_genes[duplicated(minus_genes[[displayCol]]) ==
            FALSE, ]

        ## Add column with center location of each gene label
        plusgeneNames <- suppressMessages(dplyr::left_join(
            x = plusgeneNames,
            y = plusgeneCenters,
            by = "GENEID"
        ))
        minusgeneNames <- suppressMessages(dplyr::left_join(
            x = minusgeneNames,
            y = minusgeneCenters,
            by = "GENEID"
        ))

        ## Add all the gene names in the region to object
        geneNames <- c(
            plusgeneNames[[displayCol]],
            minusgeneNames[[displayCol]]
        )
        genes$genes <- geneNames

        ## DECLUTTER LABELS
        
        ## Put genes in order of default gene prioritization
        ## based on citation/gene length
        if (nrow(plusgeneNames) > 0){
            
            ## Put genes in order of default gene prioritization
            ## based on citation/gene length
            plusgeneNames <- defaultGenePriorities(
                data = plusgeneNames,
                assembly = genes$assembly,
                geneHighlights = genesInternal$geneHighlights[[displayCol]],
                displayCol = displayCol
            )
        
            if (!is.null(genesInternal$geneOrder)) {
                ## Integrate geneOrder and default prioritization
                plusgeneNames <- gene_priorities(
                    genes = plusgeneNames,
                    geneOrder = genesInternal$geneOrder,
                    displayCol = displayCol
                )
            }
            
            ## Get which gene names aren't cutoff
            checkedplusLabels <- apply(data.frame(
                "label" = plusgeneNames[[displayCol]],
                "labelLoc" = plusgeneNames$labelLoc
            ),
            1, cutoffLabel,
            fontsize = genesInternal$fontsize,
            xscale = genesInternal$xscale,
            vp = vp_gene,
            unit = "inches"
            )
            plusgeneNames[[displayCol]] <- checkedplusLabels
            plusgeneNames <- plusgeneNames[!is.na(
                plusgeneNames[[displayCol]]
            ), ]

            if (nrow(plusgeneNames) > 0) {
                plus_names <- textGrob(
                    label = plusgeneNames[[displayCol]],
                    x = plusgeneNames$labelLoc,
                    y = unit(0.85, "npc"),
                    gp = gpar(
                        col = plusgeneNames$fontColor,
                        fontsize = genesInternal$fontsize
                    ),
                    vp = vp_gene,
                    default.units = "native",
                    check.overlap = TRUE
                )

                assign("gene_grobs",
                    addGrob(get("gene_grobs", envir = pgEnv),
                        child = plus_names
                    ),
                    envir = pgEnv
                )
            }
        }

        if (nrow(minusgeneNames) > 0) {
            ## Put genes in order of default gene prioritization
            ## based on citation/gene length
            minusgeneNames <- defaultGenePriorities(
                data = minusgeneNames,
                assembly = genes$assembly,
                geneHighlights = genesInternal$geneHighlights[[displayCol]],
                displayCol = displayCol
            )
            
            if (!is.null(genesInternal$geneOrder)) {
                ## Integrate geneOrder and default prioritization
                minusgeneNames <- gene_priorities(
                    genes = minusgeneNames,
                    geneOrder = genesInternal$geneOrder,
                    displayCol = displayCol
                )
                
            }
            
            checkedminusLabels <- apply(data.frame(
                "label" = minusgeneNames[[displayCol]],
                "labelLoc" = minusgeneNames$labelLoc
            ),
            1, cutoffLabel,
            fontsize = genesInternal$fontsize,
            xscale = genesInternal$xscale,
            vp = vp_gene,
            unit = "inches"
            )
            minusgeneNames[[displayCol]] <- checkedminusLabels
            minusgeneNames <- minusgeneNames[!is.na(
                minusgeneNames[[displayCol]]
            ), ]

            if (nrow(minusgeneNames) > 0) {
                minus_names <- textGrob(
                    label = minusgeneNames[[displayCol]],
                    x = minusgeneNames$labelLoc,
                    y = unit(0.15, "npc"),
                    gp = gpar(
                        col = minusgeneNames$fontColor,
                        fontsize = genesInternal$fontsize
                    ),
                    vp = vp_gene,
                    default.units = "native",
                    check.overlap = TRUE
                )
                assign("gene_grobs",
                    addGrob(get("gene_grobs", envir = pgEnv),
                        child = minus_names
                    ),
                    envir = pgEnv
                )
            }
        }

        ##########################################################
        ## + AND - LABELS
        ##########################################################

        if (genesInternal$strandLabels == TRUE) {
            plus_label <- textGrob(
                label = "+", y = unit(0.63, "npc"),
                gp = gpar(
                    fontsize = genesInternal$fontsize + 2,
                    col = genesInternal$fontcolor[1],
                    fontface = "bold"
                ), vp = vp_label
            )
            minus_label <- textGrob(
                label = "-", y = unit(0.37, "npc"),
                gp = gpar(
                    fontsize = genesInternal$fontsize + 2,
                    col = genesInternal$fontcolor[2],
                    fontface = "bold"
                ), vp = vp_label
            )

            assign("gene_grobs",
                addGrob(get("gene_grobs", envir = pgEnv),
                    child = plus_label
                ),
                envir = pgEnv
            )
            assign("gene_grobs",
                addGrob(get("gene_grobs", envir = pgEnv),
                    child = minus_label
                ),
                envir = pgEnv
            )
        }
    }

    # =========================================================================
    # IF PLOT == TRUE, DRAW GROBS
    # =========================================================================

    if (genesInternal$draw == TRUE) {
        grid.draw(get("gene_grobs", envir = pgEnv))
    }

    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    genes$grobs <- get("gene_grobs", envir = pgEnv)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("genes[", vp_gene$name, "]")
    invisible(genes)
}

## Define a function that removes gene and transcript
## name labels that will be cutoff
## @param df data.frame of genes in region
## @param fontsize fontsize of labels
## @param xscale vector of genomic region of viewport
## @param vp associated viewport where genes/transcripts are plotted
## @param unit for plotTranscripts, unit indicator
cutoffLabel <- function(df, fontsize, xscale, vp, unit) {
    label <- df[1]
    location <- utils::type.convert(df[2], as.is = TRUE)
    
    ## Update viewport fontsize for proper text size calculation
    vp$gp <- gpar(fontsize = fontsize)
    
    if (unit == "npc"){
        downViewport(name = vp$name)
        labelWidth <- convertWidth(widthDetails(textGrob(
            label = label,
            gp = gpar(fontsize = fontsize)
        )),
        unitTo = "native", valueOnly = TRUE
        )
        upViewport()
    } else {
        pushViewport(vp)
        labelWidth <- convertWidth(widthDetails(textGrob(
            label = label,
            gp = gpar(fontsize = fontsize)
        )),
        unitTo = "native", valueOnly = TRUE
        )
        upViewport()
    }
    
    leftBound <- location - 0.5 * labelWidth
    rightBound <- location + 0.5 * labelWidth
    
    if (leftBound < xscale[1] | rightBound > xscale[2]) {
        return(NA)
    } else {
        return(label)
    }
}

#' Plot a Hi-C interaction matrix in a square format
#' 
#' @usage plotHicSquare(
#'     data,
#'     resolution = "auto",
#'     zrange = NULL,
#'     norm = "KR",
#'     matrix = "observed",
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     altchrom = NULL,
#'     altchromstart = NULL,
#'     altchromend = NULL,
#'     assembly = "hg38",
#'     palette = colorRampPalette(brewer.pal(n = 9, "YlGnBu")),
#'     colorTrans = "linear",
#'     half = "both",
#'     yaxisDir = "increase",
#'     bg = NA,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL,
#'     quiet = FALSE
#' )
#'
#' @param data Path to .hic or .(m)cool file as a string or a 3-column dataframe 
#' of interaction counts in sparse upper triangular format.
#' @param resolution A numeric specifying the width in
#' basepairs of each pixel. For files, "auto" will attempt
#' to choose a resolution based on the size of the region. For
#' dataframes, "auto" will attempt to detect the resolution the
#' dataframe contains.
#' @param zrange A numeric vector of length 2 specifying the range
#' of interaction scores to plot, where extreme values will be set
#' to the max or min.
#' @param norm Character value specifying hic data normalization method,
#' if giving .hic or .(m)cool file. This value must be found in the .hic or
#' .(m)cool file. Default value is \code{norm = "KR"}.
#' @param matrix Character value indicating the type of matrix to output for
#' .hic files.
#' Default value is \code{matrix = "observed"}. Options are:
#' \itemize{
#' \item{\code{"observed"}: }{Observed counts.}
#' \item{\code{"oe"}: }{Observed/expected counts.}
#' \item{\code{"log2oe"}: }{Log2 transformed observed/expected counts.}
#' }
#' @param chrom Chromosome of region to be plotted, as a string.
#' @param chromstart Integer start position on chromosome to be plotted.
#' @param chromend Integer end position on chromosome to be plotted.
#' @param altchrom Alternate chromosome for off-diagonal plotting
#' or interchromosomal plotting, as a string.
#' @param altchromstart Alternate chromosome integer start position
#' for off-diagonal plotting or interchromosomal plotting.
#' @param altchromend Alternate chromosome integer end position
#' for off-diagonal plotting or interchromosomal plotting.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param palette A function describing the color palette to use for
#' representing scale of interaction scores.
#' Default value is
#' \code{palette =  colorRampPalette(brewer.pal(n = 9, "YlGnBu"))}.
#' @param colorTrans A string specifying how to scale Hi-C colors.
#' Options are "linear", "log", "log2", or "log10".
#' Default value is \code{colorTrans = "linear"}.
#' @param half A character value indicating which diagonal regions to plot.
#' For intrachromosomal plotting, options are \code{"both"}, \code{"top"},
#' or \code{"bottom"}. For off-diagonal or interchromosomal plotting,
#' options are \code{"top"} or \code{"bottom"}.
#' Default value is \code{half = "both"}.
#' \itemize{
#' \item{\code{"both"}: }{Both diagonal halves.}
#' \item{\code{"top"}: }{Half above the diagonal.}
#' \item{\code{"bottom"}: }{Half below the diagonal.}
#' }
#' @param yaxisDir A string specifying the genomic direction of the y-axis.
#' Options are \code{"increase"}, where the bottom left corner of the Hi-C map
#' indicates the origin, and \code{"decrease"}, where the top left corner of the
#' Hi-C map indicates the origin. This will change the direction of the diagonal
#' for intrachromosomal maps.
#' Default value is \code{yaxisDir = "increase"}.
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param x A numeric or unit object specifying square Hi-C plot x-location.
#' @param y A numeric, unit object, or character containing a "b" combined
#' with a numeric value specifying square Hi-C plot y-location.
#' The character value will
#' place the square Hi-C plot y relative to the bottom of the most recently
#' plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying square Hi-C plot width.
#' @param height A numeric or unit object specifying square Hi-C plot height.
#' @param just Justification of square Hi-C plot relative to
#' its (x, y) location. If there are two values, the first value specifies
#' horizontal justification and the second value specifies vertical
#' justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use if
#' \code{x}, \code{y}, \code{width}, or \code{height} are only given as
#' numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output should be
#' produced. Default value is \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param quiet A logical indicating whether or not to print messages.
#'
#' @return Returns a \code{hicSquare} object containing relevant
#' genomic region, Hi-C data, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load Hi-C data
#' library(plotgardenerData)
#' data("IMR90_HiC_10kb")
#'
#' ## Create a page
#' pageCreate(width = 3, height = 3, default.units = "inches")
#'
#' ## Plot and place Hi-C plot
#' hicPlot <- plotHicSquare(
#'     data = IMR90_HiC_10kb, resolution = 10000,
#'     zrange = c(0, 70),
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19",
#'     x = 0.5, y = 0.5, width = 2, height = 2,
#'     just = c("left", "top"),
#'     default.units = "inches", bg = "black"
#' )
#'
#' ## Annotate heatmap legend
#' annoHeatmapLegend(
#'     plot = hicPlot, x = 2.6, y = 0.5,
#'     width = 0.12, height = 1.2,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Annotate x-axis and y-axis genome labels
#' annoGenomeLabel(
#'     plot = hicPlot, scale = "Mb", axis = "x",
#'     x = 0.5, y = 2.53, just = c("left", "top")
#' )
#' annoGenomeLabel(
#'     plot = hicPlot, scale = "Mb", axis = "y",
#'     x = 0.47, y = 0.5, just = c("right", "top")
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @details
#' A square Hi-C plot can be placed on a plotgardener coordinate page
#' by providing plot placement parameters:
#' \preformatted{
#' plotHicSquare(data, chrom,
#'                 chromstart = NULL, chromend = NULL,
#'                 x, y, width, height, just = c("left", "top"),
#'                 default.units = "inches")
#' }
#' This function can be used to quickly plot an unannotated
#' square Hi-C plot by ignoring plot placement parameters:
#' \preformatted{
#' plotHicSquare(data, chrom,
#'                 chromstart = NULL, chromend = NULL)
#' }
#'
#' @seealso \link[plotgardener]{readHic}, \link[plotgardener]{readCool}
#'
#' @export
plotHicSquare <- function(data, resolution = "auto", zrange = NULL,
                            norm = "KR", matrix = "observed", chrom,
                            chromstart = NULL, chromend = NULL,
                            altchrom = NULL,
                            altchromstart = NULL, altchromend = NULL,
                            assembly = "hg38",
                            palette = colorRampPalette(brewer.pal(
                                n = 9, "YlGnBu"
                            )),
                            colorTrans = "linear",
                            half = "both", yaxisDir = "increase", bg = NA, 
                            x = NULL, y = NULL, width = NULL,
                            height = NULL, just = c("left", "top"),
                            default.units = "inches",
                            draw = TRUE, params = NULL, quiet = FALSE) {
    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors for plotHicSquare
    errorcheck_plotHicSquare <- function(hic, hicPlot, norm, yaxisDir) {
        
        ###### hic/cool/mcool/norm 
        hicErrors(hic = hic, norm = norm)

        ###### chrom/chromstart/chromend/
        ###### altchrom/altchromstart/altchromend
        
        regionErrors(chromstart = hicPlot$chromstart,
                    chromend = hicPlot$chromend)
        
        if (!is.null(hicPlot$altchrom)) {

            ## Can't specify altchrom without a chrom
            if (is.null(hicPlot$chrom)) {
                stop("Specified \'altchrom\', but did not give \'chrom\'.",
                    call. = FALSE
                )
            }

            regionErrors(chromstart = hicPlot$altchromstart,
                        chromend = hicPlot$altchromend)


            if (!is.null(hicPlot$chromstart) & !is.null(hicPlot$chromend) &
                !is.null(hicPlot$altchromstart) &
                !is.null(hicPlot$altchromend)) {

                ## Check to see if region is square
                if ((hicPlot$chromend - hicPlot$chromstart) !=
                    (hicPlot$altchromend - hicPlot$altchromstart)) {
                    warning("Trying to plot non-square region.", call. = FALSE)
                }
            }
        }

        ###### zrange #####
        rangeErrors(range = hicPlot$zrange)

        ###### half #####

        if (is.null(hicPlot$altchrom)) {
            if (!(hicPlot$half %in% c("both", "top", "bottom"))) {
                stop("Invalid \'half\'.  Options are \'both\', ",
                    "\top\', or \'bottom\'.",
                    call. = FALSE
                )
            }
        } else {
            if (!hicPlot$half %in% c("top", "bottom")) {
                stop("Invalid \'half\' for off-diagonal and ",
                    "interchromosomal plotting.  Options are \'top\' ",
                    "or \'bottom\'.", call. = FALSE)
            }
        }
        
        ##### yaxisDir #####
        if (!yaxisDir %in% c("increase", "decrease")){
            stop("Invalid \'yaxisDir\'. Options are \'increase\' ",
                 "or \'decrease\'.", call. = FALSE)
        }
        
    }

    ## Define a function that checks for and gets whole chromosome
    ## starts/ends based on an assembly TxDb
    get_wholeChrom <- function(chrom, assembly) {
        chromstart <- NULL
        chromend <- NULL

        if (is(assembly$TxDb, "TxDb")) {
            txdbChecks <- TRUE
        } else {
            
            if (!requireNamespace(assembly$TxDb, quietly = TRUE)){
                txdbChecks <- FALSE
                warning("`", assembly$TxDb, "` not available. Please install",
                        " to plot full chromosome Hi-C map.", call. = FALSE)
            } else {
                txdbChecks <- TRUE
            }
            
        }
        if (txdbChecks == TRUE) {
            if (is(assembly$TxDb, "TxDb")) {
                tx_db <- assembly$TxDb
            } else {
                tx_db <- eval(parse(text = paste0(as.name(assembly$TxDb),
                                                "::",
                                                as.name(assembly$TxDb))))
            }

            assembly_data <- GenomeInfoDb::seqlengths(tx_db)

            if (!chrom %in% names(assembly_data)) {
                warning("Chromosome",
                    "'", chrom, "'",
                    "not found in", "`", assembly$TxDb$packageName, "`",
                    "and data for entire chromosome cannot be plotted.",
                    call. = FALSE
                )
            } else {
                chromstart <- 1
                chromend <- assembly_data[[chrom]]
            }
        }


        return(list(chromstart, chromend))
    }

    ## Define a function that subsets data
    subset_data <- function(hic, hicPlot) {
        if (nrow(hic) > 0) {
            if (is.null(hicPlot$altchrom)) {
                hic <- hic[which(hic[, "x"] >= hicPlot$chromstart -
                    hicPlot$resolution &
                    hic[, "x"] <= hicPlot$chromend + hicPlot$resolution &
                    hic[, "y"] >= hicPlot$chromstart - hicPlot$resolution &
                    hic[, "y"] <= hicPlot$chromend + hicPlot$resolution), ]
            } else {
                hic <- hic[which(hic[, "x"] >= hicPlot$chromstart -
                        hicPlot$resolution &
                        hic[, "x"] <= hicPlot$chromend + hicPlot$resolution &
                        hic[, "y"] >= hicPlot$altchromstart -
                            hicPlot$resolution &
                        hic[, "y"] <= hicPlot$altchromend +
                            hicPlot$resolution), ]
            }
        }

        return(hic)
    }

    ## Define a function that sets viewport xscale and yscale
    vp_scale <- function(hicPlot, yaxisDir) {
        if (!is.null(hicPlot$chromstart) & !is.null(hicPlot$chromend)) {
            if (is.null(hicPlot$altchrom)) {
                xscale <- c(hicPlot$chromstart, hicPlot$chromend)
                yscale <- xscale
            } else {
                if (hicPlot$half == "bottom") {
                    xscale <- c(hicPlot$chromstart, hicPlot$chromend)
                    yscale <- c(hicPlot$altchromstart, hicPlot$altchromend)
                }

                if (hicPlot$half == "top") {
                    xscale <- c(hicPlot$altchromstart, hicPlot$altchromend)
                    yscale <- c(hicPlot$chromstart, hicPlot$chromend)
                }
            }
        } else {
            xscale <- c(0, 1)
            yscale <- c(0, 1)
        }
        
        if (yaxisDir == "decrease"){
            yscale <- rev(yscale)
        }
        

        return(list(xscale, yscale))
    }

    ## Define a function that subsets the hic dataframe into which will
    ## be squares and which will be triangles
    hic_shapes <- function(hic, hicPlot, half) {
        if (!is.null(hicPlot$altchrom)) {

            ## all squares
            squares <- hic
            triangles <- NULL
        } else {
            if (half == "both") {

                ## all squares
                squares <- hic
                triangles <- NULL
            } else if (half == "top") {

                ## squares for top half
                ## triangles for diagonal

                squares <- hic[which(hic[, "y"] > hic[, "x"]), ]
                triangles <- hic[which(hic[, "y"] == hic[, "x"]), ]
            } else if (half == "bottom") {

                ## squares for bottom half
                ## triangles for diagonal

                squares <- hic[which(hic[, "y"] < hic[, "x"]), ]
                triangles <- hic[which(hic[, "y"] == hic[, "x"]), ]
            }
        }

        return(list(squares, triangles))
    }

    ## Define a function that makes grobs for the square hic diagonal
    hic_diagonal <- function(hic, hicPlot, half) {
        col <- hic["color"]
        x <- utils::type.convert(hic["x"], as.is = TRUE)
        y <- utils::type.convert(hic["y"], as.is = TRUE)

        xleft <- x
        xright <- x + hicPlot$resolution
        ybottom <- y
        ytop <- y + hicPlot$resolution

        if (half == "top") {
            hic_triangle <- polygonGrob(
                x = c(xleft, xleft, xright),
                y = c(ybottom, ytop, ytop),
                gp = gpar(col = NA, fill = col),
                default.units = "native"
            )
        } else if (half == "bottom") {
            hic_triangle <- polygonGrob(
                x = c(xleft, xright, xright),
                y = c(ybottom, ybottom, ytop),
                gp = gpar(col = NA, fill = col),
                default.units = "native"
            )
        }

        assign("hic_grobs",
            addGrob(
                gTree = get("hic_grobs", envir = pgEnv),
                child = hic_triangle
            ),
            envir = pgEnv
        )
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    hicInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "hicInternal"
    )
    
    ## Justification
    hicInternal$just <- justConversion(just = hicInternal$just)

    if (is.null(hicInternal$quiet)) hicInternal$quiet <- FALSE

    if (is.null(hicInternal$data)) stop("argument \"data\" is missing, ",
                                        "with no default.", call. = FALSE)
    if (is.null(hicInternal$chrom)) stop("argument \"chrom\" is missing, ",
                                            "with no default.", call. = FALSE)

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    hicPlot <- structure(list(
        chrom = hicInternal$chrom,
        chromstart = hicInternal$chromstart,
        chromend = hicInternal$chromend,
        altchrom = hicInternal$altchrom,
        altchromstart = hicInternal$altchromstart,
        altchromend = hicInternal$altchromend,
        assembly = hicInternal$assembly,
        resolution = hicInternal$resolution,
        x = hicInternal$x, y = hicInternal$y,
        width = hicInternal$width,
        height = hicInternal$height,
        just = hicInternal$just,
        color_palette = NULL,
        colorTrans = hicInternal$colorTrans,
        zrange = hicInternal$zrange,
        half = hicInternal$half,
        grobs = NULL
    ), class = "hicSquare")
    attr(x = hicPlot, which = "plotted") <- hicInternal$draw

    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    hicPlot$assembly <- parseAssembly(assembly = hicPlot$assembly)

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_placement(object = hicPlot)
    errorcheck_plotHicSquare(
        hic = hicInternal$data,
        hicPlot = hicPlot,
        norm = hicInternal$norm,
        yaxisDir = hicInternal$yaxisDir
    )

    # =========================================================================
    # PARSE UNITS AND Y-COORD
    # =========================================================================

    hicPlot <- defaultUnits(
        object = hicPlot,
        default.units = hicInternal$default.units
    )
    
    if (!is.null(hicPlot$x) & !is.null(hicPlot$y)){
        
        ## Convert width and height to same unit to check that they're the same
        width <- convertWidth(hicPlot$width, unitTo = get("page_units", 
                                                        envir = pgEnv))
        height <- convertHeight(hicPlot$height, unitTo = get("page_units",
                                                            envir = pgEnv))
        
        if (!identical(width, height)){
            stop("Attempting to plot square Hi-C plot with different width and",
                " height. Use `plotHicTriangle` or `plotHicRectangle` ",
                " for non-square Hi-C plots.", call. = FALSE)
        }
        
    }
    
    # =========================================================================
    # GENOMIC SCALE
    # =========================================================================


    if (is.null(hicPlot$chromstart) & is.null(hicPlot$chromend)) {
        chromData <- get_wholeChrom(
            chrom = hicPlot$chrom,
            assembly = hicPlot$assembly
        )
        hicPlot$chromstart <- chromData[[1]]
        hicPlot$chromend <- chromData[[2]]
    }

    if (!is.null(hicPlot$altchrom)) {
        if (is.null(hicPlot$altchromstart) & is.null(hicPlot$altchromend)) {
            altchromData <- get_wholeChrom(
                chrom = hicPlot$altchrom,
                assembly = hicPlot$assembly
            )
            hicPlot$altchromstart <- altchromData[[1]]
            hicPlot$altchromend <- altchromData[[2]]
        }
    }
    
    # =========================================================================
    # SWAP HALVES BASED ON YAXISDIR
    # =========================================================================
    
    if (hicInternal$yaxisDir == "decrease" & hicInternal$half == "top"){
        hicInternal$half <- "bottom"
    } else if (hicInternal$yaxisDir == "decrease" & hicInternal$half == "bottom"){
        hicInternal$half <- "top"
    }   

    # =========================================================================
    # ADJUST RESOLUTION
    # =========================================================================

    if (hicPlot$resolution == "auto") {
        hicPlot <- adjust_resolution(
            hic = hicInternal$data,
            hicPlot = hicPlot
        )
    } else {
        hicPlot <- hic_limit(
            hic = hicInternal$data,
            hicPlot = hicPlot
        )
    }

    # =========================================================================
    # READ IN DATA
    # =========================================================================

    hic <- read_data(
        hic = hicInternal$data,
        hicPlot = hicPlot,
        norm = hicInternal$norm,
        assembly = hicPlot$assembly,
        type = hicInternal$matrix,
        quiet = hicInternal$quiet
    )

    # =========================================================================
    # SUBSET DATA
    # =========================================================================

    hic <- subset_data(hic = hic, hicPlot = hicPlot)
    
    # =========================================================================
    # MAKE SYMMETRIC
    # =========================================================================

    hicFlip <- hic[, c("y", "x", "counts")]
    colnames(hicFlip) <- c("x", "y", "counts")
    hic <- unique(rbind(hic, hicFlip))
    colnames(hic) <- c("x", "y", "counts")

    # =========================================================================
    # SET ZRANGE AND SCALE DATA
    # =========================================================================

    hicPlot <- set_zrange(hic = hic, hicPlot = hicPlot)
    hic$counts[hic$counts <= hicPlot$zrange[1]] <- hicPlot$zrange[1]
    hic$counts[hic$counts >= hicPlot$zrange[2]] <- hicPlot$zrange[2]

    # =========================================================================
    # CONVERT NUMBERS TO COLORS
    # =========================================================================

    ## if we don't have an appropriate zrange (even after setting it
    ## based on a null zrange), can't scale to colors
    if (!is.null(hicPlot$zrange) & length(unique(hicPlot$zrange)) == 2) {

        ## Log color scale
        if (grepl("log", hicInternal$colorTrans) == TRUE) {
            logBase <- utils::type.convert(gsub("log", "", 
                                                hicInternal$colorTrans), 
                                as.is = TRUE)
            if (is.na(logBase)) {
                logBase <- exp(1)
            }

            ## Won't scale to log if negative values
            if (any(hic$counts < 0)) {
                stop("Negative values in Hi-C data. Cannot scale colors on a ",
                "log scale. Please set `colorTrans = 'linear'`.", call. = FALSE)
            }

            hic$counts <- log(hic$counts, base = logBase)
            hic$color <- mapColors(vector = hic$counts,
                palette = hicInternal$palette,
                range = log(hicPlot$zrange, logBase)
            )
        } else {
            hic$color <- mapColors(vector = hic$counts,
                palette = hicInternal$palette,
                range = hicPlot$zrange
            )
        }


        hicPlot$color_palette <- hicInternal$palette
    }

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## Get viewport xscale and yscale
    scale <- vp_scale(hicPlot = hicPlot, yaxisDir = hicInternal$yaxisDir)

    ## If placing information is provided but plot == TRUE, set up it's own
    ## viewport separate from bb_makepage
    ## Not translating into page_coordinates
    if (is.null(hicPlot$x) | is.null(hicPlot$y)) {
        vp <- viewport(
            height = unit(1, "snpc"), width = unit(1, "snpc"),
            x = unit(0.5, "npc"), y = unit(0.5, "npc"),
            clip = "on",
            xscale = scale[[1]], yscale = scale[[2]],
            just = "center",
            name = "hicSquare1"
        )

        if (hicInternal$draw == TRUE) {
            grid.newpage()
        }
    } else {
        
        ## Get viewport name
        currentViewports <- current_viewports()
        vp_name <- paste0(
            "hicSquare",
            length(grep(
                pattern = "hicSquare",
                x = currentViewports
            )) + 1
        )
        
        addViewport(vp_name)

        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = hicPlot)

        ## Make viewport
        vp <- viewport(
            height = page_coords$height, width = page_coords$width,
            x = page_coords$x, y = page_coords$y,
            clip = "on",
            xscale = scale[[1]], yscale = scale[[2]],
            just = hicInternal$just,
            name = vp_name
        )
    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS WITH BACKGROUND
    # =========================================================================
    
    backgroundGrob <- rectGrob(gp = gpar(
        fill = hicInternal$bg,
        col = NA
    ), name = "background")
    assign("hic_grobs", gTree(vp = vp, children = gList(backgroundGrob)),
        envir = pgEnv
    )
    
    # =========================================================================
    # MAKE GROBS
    # =========================================================================

    if (!is.null(hicPlot$chromstart) & !is.null(hicPlot$chromend)) {
        if (nrow(hic) > 0) {

            ## Determine which grobs will be squares [[1]] and which
            ## will be triangles [[2]]
            shapes <- hic_shapes(
                hic = hic, hicPlot = hicPlot,
                half = hicInternal$half
            )

            if (!is.null(shapes[[1]])) {

                ## Make square grobs and add to grob gTree
                hic_squares <- rectGrob(
                    x = shapes[[1]]$x,
                    y = shapes[[1]]$y,
                    just = c("left", "bottom"),
                    width = hicPlot$resolution,
                    height = hicPlot$resolution,
                    gp = gpar(col = NA, fill = shapes[[1]]$color),
                    default.units = "native"
                )

                assign("hic_grobs",
                    addGrob(
                        gTree = get("hic_grobs", envir = pgEnv),
                        child = hic_squares
                    ),
                    envir = pgEnv
                )
            }

            ## Make triangle grobs and add to grob gTree
            if (!is.null(shapes[[2]])) {
                invisible(apply(shapes[[2]], 1, hic_diagonal,
                    hicPlot = hicPlot,
                    half = hicInternal$half
                ))
            }
        } else {

            if (!is.na(hicPlot$resolution)){
                warning("No data found in region.", call. = FALSE)
            }

        }
    }


    # =========================================================================
    # IF PLOT == TRUE, DRAW GROBS
    # =========================================================================

    if (hicInternal$draw == TRUE) {
        grid.draw(get("hic_grobs", envir = pgEnv))
    }

    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    hicPlot$grobs <- get("hic_grobs", envir = pgEnv)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================
    if (is.null(hicPlot$altchrom)) {
        hicPlot$altchrom <- hicPlot$chrom
        hicPlot$altchromstart <- hicPlot$chromstart
        hicPlot$altchromend <- hicPlot$chromend
    }

    message("hicSquare[", vp$name, "]")
    invisible(hicPlot)
}

#' Annotates zoom lines for a specified genomic region of a plot
#' 
#' @usage annoZoomLines(
#'     plot,
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     y0,
#'     x1 = NULL,
#'     y1,
#'     extend = 0,
#'     default.units = "inches",
#'     linecolor = "grey",
#'     lty = 2,
#'     params = NULL,
#'     ...
#' )
#'
#' @param plot Input plot to annotate genomic region zoom lines from.
#' @param chrom Chromosome of region to draw zoom lines from, as a string.
#' @param chromstart Integer start position on chromosome to draw
#' zoom lines from.
#' @param chromend Integer end position on chromosome to draw
#' zoom lines from.
#' @param y0 A numeric vector or unit object indicating the starting
#' y-values of the zoom line segments. If two values are given,
#' the first value will correspond to the left zoom line and the
#' second value will correspond to the right zoom line.
#' @param x1 A numeric vector or unit object indicating the stopping
#' x-values of the zoom line segments. If two values are given,
#' the first value will correspond to the left zoom line and the
#' second value will correspond to the right zoom line. If NULL,
#' straight lines from zoomed genomic region will be drawn.
#' @param y1 A numeric vector or unit object indicating the stopping
#' y-values of the zoom line segments. If two values are given,
#' the first value will correspond to the left zoom line and the
#' second value will correspond to the right zoom line.
#' @param extend A numeric vector or unit object indicating the length
#' to extend straight lines from each end
#' of the zoom line segments. If two values are given, the first value
#' will correspond to the top extension length
#' and the second value will correspond to the bottom extension length.
#' Default value is \code{extend = 0}.
#' @param default.units A string indicating the default units to use
#' if \code{y0}, \code{x1}, \code{y1}, or \code{extend} are only given
#' as numerics or numeric vectors.
#' Default value is \code{default.units = "inches"}.
#' @param linecolor A character value specifying zoom line color.
#' Default value is \code{linecolor = "grey"}.
#' @param lty A numeric specifying zoom line type.
#' Default value is \code{lty = 2}.
#' @param params An optional \link[plotgardener]{pgParams}
#' object containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{zoom} object containing
#' relevant genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Create a page
#' pageCreate(width = 7.5, height = 4.75, default.units = "inches")
#'
#' ## Plot and place a Manhattan plot
#' library(plotgardenerData)
#' library("TxDb.Hsapiens.UCSC.hg19.knownGene")
#' data("hg19_insulin_GWAS")
#' manhattanPlot <- plotManhattan(
#'     data = hg19_insulin_GWAS, assembly = "hg19",
#'     fill = c("grey", "#37a7db"),
#'     sigLine = FALSE,
#'     col = "grey", lty = 2, range = c(0, 14),
#'     x = 0.5, y = 0, width = 6.5, height = 2,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#' annoYaxis(
#'     plot = manhattanPlot, at = c(0, 2, 4, 6, 8, 10, 12, 14),
#'     axisLine = TRUE, fontsize = 8
#' )
#'
#' ## Annotate zoom lines for a region on chromsome 21
#' zoomRegion <- pgParams(
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19"
#' )
#' annoZoomLines(
#'     plot = manhattanPlot, params = zoomRegion,
#'     y0 = 2, x1 = c(0.5, 7), y1 = 2.5, extend = c(0, 1.1),
#'     default.units = "inches",
#'     lty = 3
#' )
#'
#' ## Annotate highlight region for zoom region
#' annoHighlight(
#'     plot = manhattanPlot, params = zoomRegion,
#'     y = 2, height = 2, just = c("left", "bottom"),
#'     default.units = "inches",
#'     fill = "red", alpha = 0.8
#' )
#'
#' ## Plot Manhattan plot data and signal track under zoom lines
#' manhattanPlotZoom <- plotManhattan(
#'     data = hg19_insulin_GWAS,
#'     fill = "grey",
#'     sigLine = FALSE,
#'     baseline = TRUE,
#'     params = zoomRegion, range = c(0, 14),
#'     x = 0.5, y = 2.6,
#'     width = 6.5, height = 1
#' )
#' data("IMR90_ChIP_H3K27ac_signal")
#' signalPlot <- plotSignal(
#'     data = IMR90_ChIP_H3K27ac_signal, params = zoomRegion,
#'     range = c(0, 45),
#'     x = 0.5, y = "b0.1",
#'     width = 6.5, height = 0.65,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Plot genome label
#' plotGenomeLabel(
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19",
#'     x = 0.5, y = 4.4, length = 6.5,
#'     default.units = "inches"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
annoZoomLines <- function(plot, chrom, chromstart = NULL, chromend = NULL,
                            y0, x1 = NULL, y1, extend = 0,
                            default.units = "inches", linecolor = "grey",
                            lty = 2, params = NULL, ...) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors for annoZoomLines
    errorcheck_annoZoomLines <- function(object) {
        if (!object$chrom %in% object$plot$chrom) {
            stop(object$chrom, "not found in input plot. ",
                "Cannot annotate zoom lines.", call. = FALSE)
        }

        if (length(object$chrom) > 1) {
            stop("Cannot annotate zoom lines for multiple chromosome regions ",
                "in one function call.", call. = FALSE)
        }
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    zoomInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "zoomInternal"
    )

    ## Set gp
    zoomInternal$gp <- gpar(
        col = zoomInternal$linecolor,
        lty = zoomInternal$lty
    )
    zoomInternal$gp <- setGP(
        gpList = zoomInternal$gp,
        params = zoomInternal, ...
    )

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    zoom <- structure(list(
        chrom = zoomInternal$chrom,
        chromstart = zoomInternal$chromstart,
        chromend = zoomInternal$chromend,
        assembly = zoomInternal$plot$assembly,
        x0 = NULL, y0 = zoomInternal$y0,
        x1 = zoomInternal$x1, y1 = zoomInternal$y1,
        extend = zoomInternal$extend, grobs = NULL
    ),
    class = "zoom"
    )

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_page(error = paste("Cannot annotate zoom lines without a", 
                            "`plotgardener` page."))
    if (is.null(zoomInternal$plot)) stop("argument \"plot\" is missing, ",
                                            "with no default.", call. = FALSE)
    if (is.null(zoom$chrom)) {
        stop("argument \"chrom\" is missing, with no default.",
            call. = FALSE
        )
    }
    if (is.null(zoom$y0)) {
        stop("argument \"y0\" is missing, with no default.",
            call. = FALSE
        )
    }
    if (is.null(zoom$y1)) {
        stop("argument \"y1\" is missing, with no default.",
            call. = FALSE
        )
    }
    errorcheck_annoZoomLines(object = zoomInternal)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    ## y0
    zoom$y0 <- misc_defaultUnits(value = zoom$y0,
                                    name = "y0",
                                    default.units = 
                                        zoomInternal$default.units,
                                    funName = "annoZoomLines",
                                    yBelow = FALSE)
    
    if (length(zoom$y0) == 1) {
        zoom$y0 <- rep(zoom$y0, 2)
    }

    ## y1
    zoom$y1 <- misc_defaultUnits(value = zoom$y1,
                                    name = "y1",
                                    default.units = 
                                        zoomInternal$default.units,
                                    funName = "annoZoomLines",
                                    yBelow = FALSE)

    if (length(zoom$y1) == 1) {
        zoom$y1 <- rep(zoom$y1, 2)
    }

    ## extend
    zoom$extend <- misc_defaultUnits(value = zoom$extend,
                                    name = "extend",
                                    default.units = 
                                        zoomInternal$default.units)

    if (length(zoom$extend) == 1) {
        zoom$extend <- rep(zoom$extend, 2)
    }

    # =========================================================================
    # WHOLE CHROM GENOMIC SCALE
    # =========================================================================
    
    scaleChecks <- genomicScale(object = zoom,
                                objectInternal = zoomInternal,
                                plotType = "zoom lines")
    zoom <- scaleChecks[[1]]

    # =========================================================================
    # PARSE GENOMIC REGION FOR X0
    # =========================================================================
    page_units <- get("page_units", envir = pgEnv)
    
    ## Get appropriate plot viewport
    plotVP <- getAnnoViewport(plot = zoomInternal$plot)
    
    ## Convert plot viewport to bottom left to get left position on entire page
    plotVP_bottomLeft <- vp_bottomLeft(viewport = plotVP)

    ## Convert plot genomic coordinates to position on page
    seekViewport(plotVP$name)

    if (!is.null(zoom$chromstart) & !is.null(zoom$chromend)) {
        if (is(zoomInternal$plot, "manhattan")) {

            ## Multiple chromosome manhattan plot
            if (length(zoomInternal$plot$chrom) > 1) {
                convertedCoords <- convertManhattan(
                    object = zoom,
                    manhattanPlot = zoomInternal$plot
                )
                x0_1 <- convertedCoords[[1]]
                x0_2 <- convertedCoords[[2]]
            } else {
                x0_1 <- convertX(unit(zoom$chromstart, "native"),
                    unitTo = page_units, valueOnly = TRUE
                )
                x0_2 <- convertX(unit(zoom$chromend, "native"),
                    unitTo = page_units, valueOnly = TRUE
                )
            }
        } else {
            x0_1 <- convertX(unit(zoom$chromstart, "native"),
                unitTo = page_units, valueOnly = TRUE
            )
            x0_2 <- convertX(unit(zoom$chromend, "native"),
                unitTo = page_units, valueOnly = TRUE
            )
        }

        ## Add additional page units to x0_1 and x0_2
        x0_1 <- as.numeric(plotVP_bottomLeft[[1]]) + x0_1
        x0_2 <- as.numeric(plotVP_bottomLeft[[1]]) + x0_2

        zoom$x0 <- unit(c(x0_1, x0_2), page_units)
    }

    seekViewport("page")

    # =========================================================================
    # PARSE X1
    # =========================================================================

    if (is.null(zoom$x1)) {
        zoom$x1 <- zoom$x0
    } else {
        if (!"unit" %in% class(zoom$x1)) {
            if (!is.numeric(zoom$x1)) {
                stop("x1-coordinate is neither a unit object or a numeric ",
                    "value. Cannot annotate zoom lines.", call. = FALSE)
            }

            if (is.null(zoomInternal$default.units)) {
                stop("x1-coordinate detected as numeric.\'default.units\' ",
                    "must be specified.", call. = FALSE)
            }

            zoom$x1 <- unit(zoom$x1, zoomInternal$default.units)
        }

        if (length(zoom$x1) == 1) {
            zoom$x1 <- rep(zoom$x1, 2)
        }
    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS
    # =========================================================================
    name <- paste0(
        "zoom",
        length(grep(
            pattern = "zoom",
            x = grid.ls(
                print = FALSE,
                recursive = FALSE
            )
        )) + 1
    )
    assign("zoom_grobs", gTree(name = name), envir = pgEnv)

    if (!is.null(zoom$chromstart) & !is.null(zoom$chromend)) {
        # =====================================================================
        # ZOOM SEGMENTS
        # =====================================================================
        page_height <- get("page_height", envir = pgEnv)
        zoomSegment_left <- segmentsGrob(
            x0 = zoom$x0[1],
            y0 = unit(page_height, page_units) - zoom$y0[1],
            x1 = zoom$x1[1],
            y1 = unit(page_height, page_units) - zoom$y1[1],
            gp = zoomInternal$gp
        )
        zoomSegment_right <- segmentsGrob(
            x0 = zoom$x0[2],
            y0 = unit(page_height, page_units) - zoom$y0[2],
            x1 = zoom$x1[2],
            y1 = unit(page_height, page_units) - zoom$y1[2],
            gp = zoomInternal$gp
        )

        assign("zoom_grobs",
            addGrob(
                gTree = get("zoom_grobs", envir = pgEnv),
                child = zoomSegment_left
            ),
            envir = pgEnv
        )
        assign("zoom_grobs",
            addGrob(
                gTree = get("zoom_grobs", envir = pgEnv),
                child = zoomSegment_right
            ),
            envir = pgEnv
        )

        # =====================================================================
        # EXTEND SEGMENTS
        # =====================================================================

        topy1_left <- (unit(page_height, page_units) - zoom$y0[1]) +
            zoom$extend[1]
        topy1_right <- (unit(page_height, page_units) - zoom$y0[2]) +
            zoom$extend[1]
        bottomy1_left <- (unit(page_height, page_units) - zoom$y1[1]) -
            zoom$extend[2]
        bottomy1_right <- (unit(page_height, page_units) - zoom$y1[2]) -
            zoom$extend[2]


        extend_topLeft <- segmentsGrob(
            x0 = zoom$x0[1],
            y0 = unit(page_height, page_units) - zoom$y0[1],
            x1 = zoom$x0[1],
            y1 = topy1_left,
            gp = zoomInternal$gp
        )
        extend_topRight <- segmentsGrob(
            x0 = zoom$x0[2],
            y0 = unit(page_height, page_units) - zoom$y0[2],
            x1 = zoom$x0[2],
            y1 = topy1_right,
            gp = zoomInternal$gp
        )
        extend_bottomLeft <- segmentsGrob(
            x0 = zoom$x1[1],
            y0 = unit(page_height, page_units) - zoom$y1[1],
            x1 = zoom$x1[1],
            y1 = bottomy1_left,
            gp = zoomInternal$gp
        )
        extend_bottomRight <- segmentsGrob(
            x0 = zoom$x1[2],
            y0 = unit(page_height, page_units) - zoom$y1[2],
            x1 = zoom$x1[2],
            y1 = bottomy1_right,
            gp = zoomInternal$gp
        )

        assign("zoom_grobs",
            addGrob(
                gTree = get("zoom_grobs", envir = pgEnv),
                child = extend_topLeft
            ),
            envir = pgEnv
        )
        assign("zoom_grobs",
            addGrob(
                gTree = get("zoom_grobs", envir = pgEnv),
                child = extend_topRight
            ),
            envir = pgEnv
        )
        assign("zoom_grobs",
            addGrob(
                gTree = get("zoom_grobs", envir = pgEnv),
                child = extend_bottomLeft
            ),
            envir = pgEnv
        )
        assign("zoom_grobs",
            addGrob(
                gTree = get("zoom_grobs", envir = pgEnv),
                child = extend_bottomRight
            ),
            envir = pgEnv
        )
    }

    # =========================================================================
    # ADD GTREE TO OBJECT
    # =========================================================================

    zoom$grobs <- get("zoom_grobs", envir = pgEnv)
    grid.draw(zoom$grobs)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("zoom[", zoom$grobs$name, "]")
    invisible(zoom)
}

#' Plot a chromosome ideogram with or without cytobands
#'
#' @usage plotIdeogram(
#'     chrom,
#'     assembly = "hg38",
#'     data = NULL,
#'     orientation = "h",
#'     flip = FALSE,
#'     showBands = TRUE,
#'     fill = NULL,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL
#' )
#'
#' @param chrom Chromosome to be plotted, as a string.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param data Custom cytoband data, as a dataframe with the following
#' columns: "seqnames", "start", "end", "width", "strand",
#' "name", "gieStain".
#' @param orientation Character value indicating the orientation
#' of the ideogram. Default value is \code{orientation = "h"}.
#' Options are:
#' \itemize{
#' \item{\code{"v"}: }{Vertical ideogram orientation.}
#' \item{\code{"h"}: }{Horizontal ideogram orientation.}
#' }
#' @param flip Logical value indicating whether to reverse the start and end
#' positions of the ideogram. If \code{flip = FALSE} (default), the ideogram
#' starts at the top/left and ends at the bottom/right. If \code{flip = TRUE},
#' the start and end positions are reversed, meaning the ideogram starts at the
#' bottom/right and ends at the top/left.
#' @param showBands Logical value indicating whether to draw
#' colored cytobands within ideogram.
#' Default value is \code{showBands = TRUE}.
#' @param fill (optional) A vector specifying alternate colors for cytoband
#' stains. To change specific gieStain values (i.e. gneg, gpos, etc.) to
#' specific colors, this vector can be named. This vector must have the same
#' number of colors as there are gieStain values for each genome assembly.
#' @param x A numeric or unit object specifying ideogram x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying ideogram y-location.
#' The character value will
#' place the ideogram y relative to the bottom of the most recently
#' plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying ideogram width.
#' @param height A numeric or unit object specifying ideogram height.
#' @param just Justification of ideogram relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal justification
#' and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use if
#' \code{x}, \code{y}, \code{width}, or \code{height} are only given as
#' numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output should be
#' produced. Default value is \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#'
#' @return Returns a \code{ideogram} object containing relevant
#' genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load Giemsa stain band information and genomic
#' ## annotation data for hg19 genome assembly
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' library(AnnotationHub)
#'
#' ## Create page
#' pageCreate(width = 4.5, height = 1, default.units = "inches")
#'
#' ## Plot and place ideogram
#' ideogramPlot <- plotIdeogram(
#'     chrom = "chr2", assembly = "hg19",
#'     x = 0.25, y = 0.25, width = 4, height = 0.3,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Plot text
#' plotText(
#'     label = "Chromosome 2", fontcolor = "dark grey",
#'     x = 4.25, y = 0.65, just = "right"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @details
#' An ideogram can be placed on a plotgardener coordinate page by
#' providing plot placement parameters:
#' \preformatted{
#' plotIdeogram(chrom,
#'                 x, y, width, height, just = c("left", "top"),
#'                 default.units = "inches")
#' }
#' This function can also be used to quickly plot an unannotated ideogram
#' by ignoring plot placement parameters:
#' \preformatted{
#' plotIdeogram(chrom)
#' }
#' If no data is provided, Giemsa stain band data will first try to
#' fetch UCSC with AnnotationHub. The results are cached for faster access,
#' but these cached items can be deleted. If no internet connection is
#' available and AnnotationHub has not previously cached the data, custom
#' Giemsa stain band data can be loaded with the `data` parameter.
#'
#' @seealso \link[AnnotationHub]{AnnotationHub}
#'
#' @export
plotIdeogram <- function(chrom, assembly = "hg38", data = NULL,
                            orientation = "h", flip = FALSE,
                            showBands = TRUE, fill = NULL,
                            x = NULL, y = NULL,
                            width = NULL, height = NULL,
                            just = c("left", "top"), default.units = "inches",
                            draw = TRUE, params = NULL) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that checks errors for plotIdeogram
    errorcheck_plotIdeogram <- function(orientation) {
        if (!orientation %in% c("v", "h")) {
            stop("Invalid /'orientation/' parameter. Options are 'v' or 'h'.",
                call. = FALSE
            )
        }
    }

    ## Define a function to get cytoBand data for a genome assembly
    cytoAssembly <- function(assembly) {

        ## Get string assembly name
        assemblyName <- assembly$Genome

        ## Check in defaults for data
        if(!any(cytoband_AH_assembly$assembly %in% assemblyName)){
            warning("UCSC cytoBand data not available for the given genome",
                    " assembly. Default data can only be found for the",
                    " following assemblies:",
                    cat(cytoband_AH_assembly$assembly, sep = ", "),
                    ". Please provide custom data for input assembly.",
                    call. = FALSE)

            cytoData <- NULL
        } else {

            # Load data from AHCytoBands
            if (!requireNamespace("AnnotationHub",
                    quietly = TRUE)){

                warning("Please install `AnnotationHub` ",
                        "to plot an ideogram for a default",
                        " genome assembly.", call. = FALSE)
                cytoData <- NULL

            } else {

                assemblyName <- cytoband_AH_assembly[
                    cytoband_AH_assembly$assembly%in% assemblyName,]$assembly

                # Get name of AH object for assembly
                AH_id <- cytoband_AH_assembly[cytoband_AH_assembly$assembly ==
                                                assemblyName,]$AH

                # Check for internet
                if (has_internet()){

                    # Load AHCytoBands data
                    cytobands <- suppressMessages(AnnotationHub::query(
                        AnnotationHub::AnnotationHub(), "AHCytoBands"))

                    # Grab data for assembly
                    cytoData <- as.data.frame(
                        suppressMessages(cytobands[[AH_id]]))
                } else {
                    # Try with localHub=TRUE for cache
                    errorFunction <- function(c){
                        return(NULL)
                    }

                    cytobands <-
                        tryCatch(
                            suppressMessages(
        AnnotationHub::query(AnnotationHub::AnnotationHub(localHub = TRUE),
                        "AHCytoBands")),
                    error = errorFunction
                        )

                    if (!is.null(cytobands)){
                        cytoData <- as.data.frame(
                            suppressMessages(cytobands[[AH_id]]))
                    } else {
                        cytoData <- NULL
                    }

                }

            }

        }

        return(cytoData)
    }

    ## Define a function to check that a chromosome name is in a TxDb
    checkChroms <- function(chrom, txdb) {
        if (is(txdb, "TxDb")) {
            tx_db <- txdb
        } else {
            tx_db <- eval(parse(text = paste0(as.name(txdb), "::",
                                            as.name(txdb))))
        }

        txdbChroms <- GenomeInfoDb::seqlevels(tx_db)
        if (chrom %in% txdbChroms) {
            return(TRUE)
        } else {
            warning("'", chrom, "'",
                "not found in", txdb$packageName, ".",
                call. = FALSE
            )
            return(FALSE)
        }
    }

    ## Define a function that draws bands that fall within left curved regions
    curvedBands_left <- function(df, xCurve, yCurve, ymax) {
        start <- utils::type.convert(df["start"], as.is = TRUE)
        end <- utils::type.convert(df["end"], as.is = TRUE)
        col <- df["color"]

        if (end > max(xCurve)) {
            xpoints <- c(xCurve[which(xCurve >= start)], end, end)
            ypoints <- c(yCurve[which(xCurve >= start)], 0, ymax)
        } else {
            xpoints <- xCurve[which(xCurve >= start & xCurve <= end)]
            ypoints <- yCurve[which(xCurve >= start & xCurve <= end)]
        }

        if (length(xpoints) > 0 & length(ypoints) > 0) {
            curvedGrob <- polygonGrob(
                x = xpoints, y = ypoints,
                default.units = "native",
                gp = gpar(fill = col, col = NA)
            )

            assign("ideogram_grobs",
                addGrob(get("ideogram_grobs", envir = pgEnv),
                    child = curvedGrob
                ),
                envir = pgEnv
            )
        }
    }

    ## Define a function that draws bands that fall within right curved regions
    curvedBands_right <- function(df, xCurve, yCurve, ymax) {
        start <- utils::type.convert(df["start"], as.is = TRUE)
        end <- utils::type.convert(df["end"], as.is = TRUE)
        col <- df["color"]
        if (start < min(xCurve)) {
            xpoints <- c(xCurve[which(xCurve <= end)], start, start)
            ypoints <- c(yCurve[which(xCurve <= end)], ymax, 0)
        } else {
            xpoints <- xCurve[which(xCurve >= start & xCurve <= end)]
            ypoints <- yCurve[which(xCurve >= start & xCurve <= end)]
        }

        if (length(xpoints) > 0 & length(ypoints) > 0) {
            curvedGrob <- polygonGrob(
                x = xpoints, y = ypoints,
                default.units = "native",
                gp = gpar(fill = col, col = NA)
            )

            assign("ideogram_grobs",
                addGrob(get("ideogram_grobs", envir = pgEnv),
                    child = curvedGrob
                ),
                envir = pgEnv
            )
        }
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    ideoInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "ideoInternal"
    )

    ## Justification
    ideoInternal$just <- justConversion(just = ideoInternal$just)

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    ideogramPlot <- structure(list(
        chrom = ideoInternal$chrom,
        chromstart = 1, chromend = NULL,
        assembly = ideoInternal$assembly,
        colors = NULL,
        x = ideoInternal$x, y = ideoInternal$y,
        width = ideoInternal$width,
        height = ideoInternal$height,
        just = ideoInternal$just, grobs = NULL
    ),
    class = "ideogram"
    )
    attr(x = ideogramPlot, which = "plotted") <- ideoInternal$draw

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    if (is.null(ideogramPlot$chrom)) {
        stop("argument \"chrom\" is missing, with no default.", call. = FALSE)
    }

    check_placement(object = ideogramPlot)
    errorcheck_plotIdeogram(orientation = ideoInternal$orientation)

    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    ideogramPlot$assembly <-
        parseAssembly(assembly = ideogramPlot$assembly)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    ideogramPlot <- defaultUnits(
        object = ideogramPlot,
        default.units = ideoInternal$default.units
    )

    # =========================================================================
    # GET APPROPRIATE BUILD DATA
    # =========================================================================

    if (is.null(ideoInternal$data)){
        data <- cytoAssembly(assembly = ideogramPlot$assembly)
    } else {
        data <- as.data.frame(ideoInternal$data)
        colnames(data) <- c("seqnames", "start", "end", "width", "strand",
                            "name", "gieStain")
    }

    ## TxDb data
    if (is(ideogramPlot$assembly$TxDb, "TxDb")){
        genome <- ideogramPlot$assembly$TxDb
    } else {
        if (!requireNamespace(ideogramPlot$assembly$TxDb, quietly = TRUE)){
            warning("`", ideogramPlot$assembly$TxDb, "` not available. ",
            "Please install to plot ideogram.", call. = FALSE)
            genome <- NULL
        } else {
            genome <- eval(parse(text =
                        paste0(as.name(ideogramPlot$assembly$TxDb), "::",
                        as.name(ideogramPlot$assembly$TxDb))))
        }
    }

    chromLength <- 1
    if (!is.null(data) & !is.null(genome)) {

        chromCheck <- checkChroms(chrom = ideoInternal$chrom,
                                txdb = ideogramPlot$assembly$TxDb)

        if (chromCheck == TRUE) {

            # =================================================================
            # ADD COLORS
            # =================================================================

            if (!is.null(ideoInternal$fill)){

                ## Check that length of fill vector is the same length as the
                ## of gieStain values in the data
                if (length(unique(data$gieStain)) != length(ideoInternal$fill)){
                    warning("`fill` color vector is not the same length as",
                            " number of gieStain values. Using default colors.")
                    colors <- cytobandColors
                } else {

                    if (is.null(names(ideoInternal$fill))){

                        ## No names, assign in order of levels
                        data$gieStain <- as.factor(data$gieStain)

                        colors <- data.frame("gieStain" = levels(data$gieStain),
                                             "color" = ideoInternal$fill)

                    } else {

                        ## Assign colors based on names
                        colors$gieStain <-
                            data.frame("gieStain" = names(ideoInternal$fill),
                                       "color" = ideoInternal$fill)
                    }

                }

            } else {
                colors <- cytobandColors
            }

            data <- dplyr::left_join(data, colors, by = "gieStain")

            ## Add stains/colors to object
            objectCols <- unique(data[,c("gieStain", "color")])
            row.names(objectCols) <- NULL
            ideogramPlot$colors <- objectCols

            # =================================================================
            # SUBSET FOR CHROMOSOME
            # =================================================================

            data <- data[which(data[, 1] == ideogramPlot$chrom), ]
            data$seqnames <- as.character(data$seqnames)
            data$strand <- as.character(data$strand)
            data$name <- as.character(data$name)
            data$gieStain <- as.character(data$gieStain)
            chromLength <- GenomeInfoDb::seqlengths(genome)[[
            ideogramPlot$chrom]]
            ideogramPlot$chromend <- chromLength
        }
    }

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## If placing information is provided but plot == TRUE,
    ## set up it's own viewport separate from bb_makepage
    ## Not translating into page_coordinates
    if (is.null(ideogramPlot$x) | is.null(ideogramPlot$y)) {
        height <- 0.075
        width <- 1

        scaleRatio <- width / height
        yscale <- chromLength / scaleRatio

        angleAdjust <- ifelse(ideoInternal$flip, yes = 180, no = 0)

        if (ideoInternal$orientation == "h") {
            vp <- viewport(
                height = unit(height, "snpc"),
                width = unit(width, "snpc"),
                x = unit(0.5, "npc"), y = unit(0.5, "npc"),
                xscale = c(0, chromLength),
                yscale = c(0, yscale),
                angle = 0 + angleAdjust,
                just = "center",
                name = "ideogram1"
            )
        } else {
            height <- 1
            width <- 0.075
            vp <- viewport(
                height = unit(width, "snpc"),
                width = unit(height, "snpc"),
                x = unit(0.5, "npc"), y = unit(0.5, "npc"),
                xscale = c(0, chromLength),
                yscale = c(0, yscale),
                angle = -90 + angleAdjust,
                just = "center",
                name = "ideogram1"
            )
        }

        if (ideoInternal$draw == TRUE) {
            grid.newpage()
        }
    } else {

        ## Get viewport name
        currentViewports <- current_viewports()
        vp_name <- paste0("ideogram", length(grep(
            pattern = "ideogram",
            x = currentViewports
        )) + 1)

        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = ideogramPlot)
        addViewport(vp_name)

        height <- convertHeight(page_coords$height,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
        width <- convertWidth(page_coords$width,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
        scaleRatio <- max(c(width, height)) / min(c(width, height))
        yscale <- chromLength / scaleRatio

        if (ideoInternal$orientation == "h") {
            ## Make viewport based on user inputs
            vp <- viewport(
                height = page_coords$height,
                width = page_coords$width,
                x = page_coords$x, y = page_coords$y,
                xscale = c(0, chromLength),
                yscale = c(0, yscale),
                just = ideoInternal$just,
                name = vp_name)

            ## Convert viewport to bottom left (bottom left of horizontal)
            if(ideoInternal$flip) {
                vp_br <- vp_bottomRight(viewport = vp)
                vp <- viewport(
                    height = page_coords$height,
                    width = page_coords$width,
                    x = vp_br[[1]], y = vp_br[[2]],
                    xscale = c(0, chromLength),
                    yscale = c(0, yscale),
                    angle = 180,
                    just = c("left", "top"),
                    name = vp_name
                ) }

        } else {
            ## Make viewport based on user inputs
            vpOG <- viewport(
                height = page_coords$height,
                width = page_coords$width,
                x = page_coords$x, y = page_coords$y,
                just = ideoInternal$just
            )

            ## Convert viewport to bottom left (bottom left of horizontal)
            ## if flip == TRUE
            if(ideoInternal$flip) {
                vp_bl <- vp_bottomLeft(viewport = vpOG)
                vp <- viewport(
                    height = page_coords$width,
                    width = page_coords$height,
                    x = vp_bl[[1]], y = vp_bl[[2]],
                    xscale = c(0, chromLength),
                    yscale = c(0, yscale),
                    angle = 90,
                    just = c("left", "top"),
                    name = vp_name
                )
            }
            ## Convert viewport to top right (top right of horizontal)
            ## if flip == FALSE
            else{
                vp_tr <- vp_topRight(viewport = vpOG)
                vp <- viewport(
                    height = page_coords$width,
                    width = page_coords$height,
                    x = vp_tr[[1]], y = vp_tr[[2]],
                    xscale = c(0, chromLength),
                    yscale = c(0, yscale),
                    angle = -90,
                    just = c("left", "top"),
                    name = vp_name
                )
            }
        }
    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS
    # =========================================================================

    assign("ideogram_grobs", gTree(vp = vp), envir = pgEnv)

    if (!is.null(data) & !is.null(genome)) {
        if (chromCheck == TRUE) {

            # =================================================================
            # CHROMOSOME GROBS
            # =================================================================

            ## Generate points along curves for the ends
            r <- vp$yscale[2] * 0.5
            leftAngles <- seq(pi / 2, 3 * pi / 2, pi / 500)
            rightAngles <- seq(3 * pi / 2, 5 * pi / 2, pi / 500)

            leftXpoints <- r + r * cos(leftAngles)
            leftYpoints <- r + r * sin(leftAngles)

            rightXpoints <- (chromLength - r) + r * cos(rightAngles)
            rightYpoints <- r + r * sin(rightAngles)


            if (nrow(data) > 1) {

                ## FIRST BAND ##
                firstBand <- data[which(data$start == 1), ]
                data <- subset(data, data$start != 1)

                if (firstBand$end > max(leftXpoints)) {
                    firstBand_Xpoints <- c(
                        leftXpoints, firstBand$end,
                        firstBand$end
                    )
                    firstBand_Ypoints <- c(leftYpoints, 0, vp$yscale[2])
                } else {
                    firstBand_Xpoints <- leftXpoints[which(leftXpoints <=
                        firstBand$end)]
                    firstBand_Ypoints <- leftYpoints[which(leftXpoints <=
                        firstBand$end)]
                }

                if (ideoInternal$showBands == TRUE) {
                    firstBand_grob <- polygonGrob(
                        x = firstBand_Xpoints,
                        y = firstBand_Ypoints,
                        default.units = "native",
                        gp = gpar(
                            fill = firstBand$color,
                            col = NA
                        )
                    )

                    assign("ideogram_grobs",
                        addGrob(get("ideogram_grobs", envir = pgEnv),
                            child = firstBand_grob
                        ),
                        envir = pgEnv
                    )
                }


                ## LAST BAND ##
                lastBand <- data[which(data$end == chromLength), ]
                data <- subset(data, data$end != chromLength)

                if (lastBand$start < min(rightXpoints)) {
                    lastBand_Xpoints <- c(
                        rightXpoints, lastBand$start,
                        lastBand$start
                    )
                    lastBand_Ypoints <- c(rightYpoints, vp$yscale[2], 0)
                } else {
                    lastBand_Xpoints <- rightXpoints[which(rightXpoints >=
                        lastBand$start)]
                    lastBand_Ypoints <- rightYpoints[which(rightXpoints >=
                        lastBand$start)]
                }
                if (ideoInternal$showBands == TRUE) {
                    lastBand_grob <- polygonGrob(
                        x = lastBand_Xpoints,
                        y = lastBand_Ypoints,
                        default.units = "native",
                        gp = gpar(
                            fill = lastBand$color,
                            col = NA
                        )
                    )

                    assign("ideogram_grobs",
                        addGrob(get("ideogram_grobs", envir = pgEnv),
                            child = lastBand_grob
                        ),
                        envir = pgEnv
                    )
                }



                if (ideoInternal$assembly %in% c("hg18", "hg19", "hg38")) {
                    ## CENTER BANDS ##
                    leftCent <- data[which(data$gieStain == "acen"), ][1, ]
                    leftCent_length <- leftCent$end - leftCent$start
                    rightCent <- data[which(data$gieStain == "acen"), ][2, ]
                    rightCent_length <- rightCent$end - rightCent$start
                    centerX <- leftCent$end
                    data <- subset(data, data$gieStain != "acen")

                    ## Generate points along curves for the centers
                    centerleftXpoints <- (centerX - r * 0.75) +
                        r * cos(rightAngles)
                    centerleftYpoints <- r + r * sin(rightAngles)
                    centerleftYpoints <- centerleftYpoints[which(
                        centerleftXpoints <= (rightCent$end - 0.5 *
                            rightCent_length)
                    )]
                    centerleftXpoints <- centerleftXpoints[which(
                        centerleftXpoints <= (rightCent$end - 0.5 *
                            rightCent_length)
                    )]

                    centerrightXpoints <- (centerX + r * 0.75) + r *
                        cos(leftAngles)
                    centerrightYpoints <- r + r * sin(leftAngles)
                    centerrightYpoints <- centerrightYpoints[which(
                        centerrightXpoints >= (leftCent$start + 0.5 *
                            leftCent_length)
                    )]
                    centerrightXpoints <- centerrightXpoints[which(
                        centerrightXpoints >= (leftCent$start + 0.5 *
                            leftCent_length)
                    )]

                    ## CENTER LEFT BAND ##
                    if (leftCent$start < min(centerleftXpoints)) {
                        leftCent_Xpoints <- c(
                            centerleftXpoints, leftCent$start,
                            leftCent$start
                        )
                        leftCent_Ypoints <- c(
                            centerleftYpoints,
                            vp$yscale[2], 0
                        )
                    } else {
                        leftCent_Xpoints <- centerleftXpoints[which(
                            centerleftXpoints >= leftCent$start
                        )]
                        leftCent_Ypoints <- centerleftYpoints[which(
                            centerleftXpoints >= leftCent$start
                        )]
                    }

                    if (ideoInternal$showBands == TRUE) {
                        leftCent_grob <- polygonGrob(
                            x = leftCent_Xpoints,
                            y = leftCent_Ypoints,
                            default.units = "native",
                            gp = gpar(fill = leftCent$color, col = NA)
                        )

                        assign("ideogram_grobs",
                            addGrob(get("ideogram_grobs", envir = pgEnv),
                                child = leftCent_grob
                            ),
                            envir = pgEnv
                        )
                    }


                    ## CENTER RIGHT BAND ##

                    if (rightCent$end > max(centerrightXpoints)) {
                        rightCent_Xpoints <- c(
                            centerrightXpoints, rightCent$end,
                            rightCent$end
                        )
                        rightCent_Ypoints <- c(
                            centerrightYpoints, 0,
                            vp$yscale[2]
                        )
                    } else {
                        rightCent_Xpoints <- centerrightXpoints[which(
                            centerrightXpoints <= rightCent$end
                        )]
                        rightCent_Ypoints <- centerrightYpoints[which(
                            centerrightXpoints <= rightCent$end
                        )]
                    }

                    if (ideoInternal$showBands == TRUE) {
                        rightCent_grob <- polygonGrob(
                            x = rightCent_Xpoints,
                            y = rightCent_Ypoints,
                            default.units = "native",
                            gp = gpar(
                                fill = rightCent$color,
                                col = NA
                            )
                        )

                        assign("ideogram_grobs",
                            addGrob(get("ideogram_grobs", envir = pgEnv),
                                child = rightCent_grob
                            ),
                            envir = pgEnv
                        )
                    }

                    ## GET ANY BANDS THAT FALL WITHIN CENTER CURVED REGIONS ##
                    if (ideoInternal$showBands == TRUE) {
                        inleftcurvedBands <- data[which(
                            data$end > min(centerleftXpoints) &
                                data$end <= centerX
                        ), ]
                        inrightcurvedBands <- data[which(
                            data$start < max(centerrightXpoints) &
                                data$start >= centerX
                        ), ]
                        if (nrow(inleftcurvedBands > 0)) {
                            invisible(apply(inleftcurvedBands,
                                1,
                                curvedBands_right,
                                xCurve = centerleftXpoints,
                                yCurve = centerleftYpoints,
                                ymax = vp$yscale[2]
                            ))
                        }
                        if (nrow(inrightcurvedBands > 0)) {
                            invisible(apply(inrightcurvedBands,
                                1,
                                curvedBands_left,
                                xCurve = centerrightXpoints,
                                yCurve = centerrightYpoints,
                                ymax = vp$yscale[2]
                            ))
                        }

                        ## REMAINING BANDS ##
                        data <- suppressMessages(dplyr::anti_join(
                            data, inleftcurvedBands
                        ))
                        data <- suppressMessages(dplyr::anti_join(
                            data, inrightcurvedBands
                        ))
                    }
                }


                if (ideoInternal$showBands == TRUE) {
                    ## GET ANY BANDS THAT FALL WITHIN OUTSIDE CURVED REGIONS ##
                    leftcurvedBands <- data[which(data$start <
                        max(leftXpoints)), ]
                    rightcurvedBands <- data[which(data$start >=
                        min(rightXpoints)), ]

                    if (nrow(leftcurvedBands > 0)) {
                        invisible(apply(leftcurvedBands,
                            1,
                            curvedBands_left,
                            xCurve = leftXpoints,
                            yCurve = leftYpoints,
                            ymax = vp$yscale[2]
                        ))
                    }
                    if (nrow(rightcurvedBands > 0)) {
                        invisible(apply(rightcurvedBands,
                            1,
                            curvedBands_right,
                            xCurve = rightXpoints,
                            yCurve = rightYpoints,
                            ymax = vp$yscale[2]
                        ))
                    }

                    ## REMAINING BANDS ##
                    data <- suppressMessages(dplyr::anti_join(
                        data,
                        leftcurvedBands
                    ))
                    data <- suppressMessages(dplyr::anti_join(
                        data,
                        rightcurvedBands
                    ))

                    rectBands <- rectGrob(
                        x = data$start, y = unit(0.5, "npc"),
                        width = data$width, height = unit(1, "npc"),
                        just = "left", default.units = "native",
                        gp = gpar(fill = data$color, col = NA)
                    )
                    assign("ideogram_grobs",
                        addGrob(get("ideogram_grobs", envir = pgEnv),
                            child = rectBands
                        ),
                        envir = pgEnv
                    )
                }
            }


            # =================================================================
            # OUTLINE GROBS
            # =================================================================

            if (ideoInternal$assembly %in% c("hg18", "hg19", "hg38")) {
                topIntersectY <- sqrt(r^2 - ((r * 0.75)^2)) + r
                bottomIntersectY <- -1 * sqrt(r^2 - ((r * 0.75)^2)) + r

                lbottomX <- centerleftXpoints[which(
                    centerleftXpoints <= centerX &
                        centerleftYpoints <= bottomIntersectY
                )]
                lbottomY <- centerleftYpoints[which(
                    centerleftXpoints <= centerX &
                        centerleftYpoints <= bottomIntersectY
                )]

                rbottomX <- centerrightXpoints[which(
                    centerrightXpoints >= centerX &
                        centerrightYpoints <= bottomIntersectY
                )]
                rbottomY <- centerrightYpoints[which(
                    centerrightXpoints >= centerX &
                        centerrightYpoints <= bottomIntersectY
                )]

                rtopX <- centerrightXpoints[which(
                    centerrightXpoints >= centerX &
                        centerrightYpoints >= topIntersectY
                )]
                rtopY <- centerrightYpoints[which(
                    centerrightXpoints >= centerX &
                        centerrightYpoints >= topIntersectY
                )]

                ltopX <- centerleftXpoints[which(
                    centerleftXpoints <= centerX &
                        centerleftYpoints >= topIntersectY
                )]
                ltopY <- centerleftYpoints[which(
                    centerleftXpoints <= centerX &
                        centerleftYpoints >= topIntersectY
                )]

                Xoutline <- c(
                    leftXpoints, lbottomX, centerX, rbottomX,
                    rightXpoints, rtopX, centerX, ltopX
                )
                Youtline <- c(
                    leftYpoints, lbottomY, bottomIntersectY, rbottomY,
                    rightYpoints, rtopY, topIntersectY, ltopY
                )
            } else {
                Xoutline <- c(leftXpoints, rightXpoints)
                Youtline <- c(leftYpoints, rightYpoints)
            }

            outlineGrob <- polygonGrob(
                x = Xoutline, y = Youtline,
                default.units = "native",
                gp = gpar(fill = NA, col = "#d0cfd4")
            )
            assign("ideogram_grobs",
                addGrob(get("ideogram_grobs", envir = pgEnv),
                    child = outlineGrob
                ),
                envir = pgEnv
            )
        }
    }

    # =========================================================================
    # IF PLOT == TRUE, DRAW GROBS
    # =========================================================================

    if (ideoInternal$draw == TRUE) {
        grid.draw(get("ideogram_grobs", envir = pgEnv))
    }
    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    ideogramPlot$grobs <- get("ideogram_grobs", envir = pgEnv)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("ideogram[", vp$name, "]")
    invisible(ideogramPlot)
}

#' Handle plotgardener color scaling parameters
#'
#' \code{colorby} should be used to create a set of parameters
#' that specify color scaling for the functions \code{plotPairs},
#' \code{plotPairsArches}, and \code{plotRanges}.
#'
#' @param column String specifying name of data column to scale colors by.
#' @param palette (optional) A function describing the color palette to use for
#' color scaling.
#' @param range (optional) A numeric vector specifying the range of values to
#' apply a color scale to.
#' @param scalePerRegion A logical value indicating whether to adjust 
#' NULL range of numerical `colorby` values to subset of data in a plotted
#' genomic region. Default value is \code{scalePerRegion = FALSE}.
#'
#' @return Returns a "\code{colorby}" object.
#'
#' @examples
#' ## Load paired ranges data in BEDPE format
#' library(plotgardenerData)
#' data("IMR90_DNAloops_pairs")
#'
#' ## Add a length column
#' IMR90_DNAloops_pairs$length <- 
#'         (IMR90_DNAloops_pairs$start2 - IMR90_DNAloops_pairs$start1) / 1000
#'
#' ## Plot pairs with colorby object set for `length` column
#' bedpePlot <- plotPairs(
#'     data = IMR90_DNAloops_pairs,
#'     chrom = "chr21",
#'     chromstart = 27900000, chromend = 30700000,
#'     assembly = "hg19",
#'     fill = colorby("length", palette = 
#'                 colorRampPalette(c("dodgerblue2", "firebrick2"))),
#'     lwd = 2, spaceHeight = .7,
#' )
#' @export
colorby <- function(column, palette = NULL, range = NULL, 
                    scalePerRegion = FALSE) {
    colorbyObject <- structure(list(column = column, palette = palette, 
                                    range = range, 
                                    scalePerRegion = scalePerRegion),
        class = "colorby"
    )
    return(colorbyObject)
}

#' Annotates a highlight box around a specified genomic region of a
#' plot
#' 
#' @usage annoHighlight(
#'     plot,
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     fill = "grey",
#'     linecolor = NA,
#'     alpha = 0.4,
#'     y,
#'     height,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     params = NULL,
#'     ...
#' )
#'
#' @param plot Input plot on which to annotate genomic region.
#' @param chrom Chromosome of region to be highlighted, as a string.
#' @param chromstart Integer start position on chromosome to be highlighted.
#' @param chromend Integer end position on chromosome to be highlighted.
#' @param fill A character value specifying highlight box fill color.
#' Default value is \code{fill = "grey"}.
#' @param linecolor A character value specifying highlight box line color.
#' Default value is \code{linecolor = NA}.
#' @param alpha Numeric value specifying color transparency.
#' Default value is \code{alpha = 0.4}.
#' @param y A numeric, unit object, or character containing a "b" combined
#' with a numeric value specifying square highlight box y-location.
#' The character value will place the highlight box y relative to the
#' bottom of the most recently plotted plot according to the
#' units of the \code{plotgardener} page.
#' @param height A numeric or unit object specifying highlight box height.
#' @param just Justification of highlight box relative to its (x, y)
#' location. If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use if
#' \code{y} or \code{height} are only given as numerics or numeric vectors.
#' Default value is \code{default.units = "inches"}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{highlight} object containing relevant
#' genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Create a page
#' pageCreate(width = 7.5, height = 1.5, default.units = "inches")
#'
#' ## Plot and place a signal plot
#' library(plotgardenerData)
#' data("IMR90_ChIP_H3K27ac_signal")
#' region <- pgParams(
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19",
#'     range = c(0, 45)
#' )
#' signalPlot <- plotSignal(
#'     data = IMR90_ChIP_H3K27ac_signal, params = region,
#'     x = 0.5, y = 0.25, width = 6.5, height = 0.65,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Highlight genomic region on signal plot
#' annoHighlight(
#'     plot = signalPlot,
#'     chrom = "chr21",
#'     chromstart = 29000000, chromend = 29125000,
#'     y = 0.25, height = 1, just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Plot text label
#' plotText(
#'     label = "region of interest", fontsize = 8, fontcolor = "black",
#'     x = 3.5, y = 0.2, just = "bottom", default.units = "inches"
#' )
#'
#' ## Plot genome label
#' plotGenomeLabel(
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19",
#'     x = 0.5, y = 1.3, length = 6.5, default.units = "inches"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
annoHighlight <- function(plot, chrom, chromstart = NULL, chromend = NULL,
                            fill = "grey", linecolor = NA, alpha = 0.4,
                            y, height, just = c("left", "top"),
                            default.units = "inches", params = NULL, ...) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors for annoHighlight
    errorcheck_annoHighlight <- function(object, fill) {
        if (!object$chrom %in% object$plot$chrom) {
            stop(object$chrom,
                "not found in input plot. Cannot annotate highlight.",
                call. = FALSE
            )
        }

        if (length(object$chrom) > 1) {
            stop("Cannot highlight multiple chromosome ",
            "regions in one function call.", call. = FALSE)
        }
        
        checkColorby(fill = fill,
                    colorby = FALSE)
    }

    ## Define a function that resets y to a top-based justification
    y_Pagetop <- function(y, height, just) {
        page_height <- get("page_height", envir = pgEnv)
        page_units <- get("page_units", envir = pgEnv)
        y <- convertY(unit(page_height, units = page_units) - 
            convertY(y, unitTo = page_units), unitTo = page_units)
        height <- convertHeight(height, unitTo = page_units)
        if (identical(just, c(0, 0.5))) {
            ## left
            topy <- y + 0.5 * height
        } else if (identical(just, c(1, 0.5))) {
            ## right
            topy <- y + 0.5 * height
        } else if (identical(just, c(0.5, 0))) {
            ## bottom
            topy <- y + height
        } else if (identical(just, c(0.5, 1))) {
            ## top
            topy <- y
        } else if (identical(just, c(0, 1))) {
            ## left top
            topy <- y
        } else if (identical(just, c(1, 1))) {
            ## right top
            topy <- y
        } else if (identical(just, c(0, 0))) {
            ## left bottom
            topy <- y + height
        } else if (identical(just, c(1, 0))) {
            ## right bottom
            topy <- y + height
        } else {
            ## center
            topy <- y + 0.5 * height
        }
        
        return(topy)
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    highlightInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "highlightInternal"
    )

    ## Set gp
    highlightInternal$gp <- gpar(
        fill = highlightInternal$fill,
        col = highlightInternal$linecolor,
        alpha = highlightInternal$alpha
    )
    highlightInternal$gp <- setGP(
        gpList = highlightInternal$gp,
        params = highlightInternal, ...
    )

    ## Justification
    highlightInternal$just <- 
        justConversion(just = highlightInternal$just)
    
    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    highlight <- structure(list(
        chrom = highlightInternal$chrom,
        chromstart = highlightInternal$chromstart,
        chromend = highlightInternal$chromend,
        assembly = highlightInternal$plot$assembly,
        x = NULL, y = highlightInternal$y,
        width = NULL,
        height = highlightInternal$height,
        just = highlightInternal$just,
        grobs = NULL
    ),
    class = "highlight"
    )

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_page(error = "Cannot add highlight annotation
                without a `plotgardener` page.")
    if (is.null(highlightInternal$plot)) {
        stop("argument \"plot\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(highlightInternal$chrom)) {
        stop("argument \"chrom\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(highlight$y)) {
        stop("argument \"y\" is missing, with no default.", call. = FALSE)
    }
    if (is.null(highlight$height)) {
        stop("argument \"height\" is missing, with no default.",
            call. = FALSE
        )
    }
    errorcheck_annoHighlight(object = highlightInternal,
                                fill = highlightInternal$gp$fill)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    page_units <- get("page_units", envir = pgEnv)

    highlight$y <- misc_defaultUnits(value = highlight$y,
                                        name = "y",
                                        default.units = 
                                            highlightInternal$default.units)
    highlight$height <- misc_defaultUnits(value = highlight$height,
                                        name = "height",
                                        default.units = 
                                            highlightInternal$default.units)

    if (is(highlightInternal$plot, "genes")) {
        plotVP <- highlightInternal$plot$grobs$children$background$vp
    } else if (is(highlightInternal$plot, "hicTriangle")  |
        is(highlightInternal$plot, "hicRectangle")) {
        plotVP <- highlightInternal$plot$outsideVP
    } else {
        plotVP <- highlightInternal$plot$grobs$vp
    }

    # =========================================================================
    # WHOLE CHROM GENOMIC SCALE
    # =========================================================================

    scaleChecks <- genomicScale(object = highlight,
                                objectInternal = highlightInternal,
                                plotType = "highlight")
    highlight <- scaleChecks[[1]]
    
    # =========================================================================
    # DETERMINE X AND WIDTH BASED ON GENOMIC REGION
    # =========================================================================

    ## Get plot viewport
    if (is(highlightInternal$plot, "genes")) {
        plotVP <- highlightInternal$plot$grobs$children$background$vp
    } else if (is(highlightInternal$plot, "hicTriangle")  |
        is(highlightInternal$plot, "hicRectangle")) {
        plotVP <- highlightInternal$plot$outsideVP
    } else {
        plotVP <- highlightInternal$plot$grobs$vp
    }

    ## Convert plot viewport to bottom left to get left position on entire page
    plotVP_bottomLeft <- vp_bottomLeft(viewport = plotVP)

    ## Convert plot genomic coordinates to position on page
    seekViewport(plotVP$name)

    if (!is.null(highlight$chromstart) & !is.null(highlight$chromend)) {
        if (is(highlightInternal$plot, "manhattan")) {

            ## Multiple chromosome manhattan plot
            if (length(highlightInternal$plot$chrom) > 1) {
                convertedCoords <- convertManhattan(
                    object = highlight,
                    manhattanPlot = highlightInternal$plot
                )
                start <- convertedCoords[[1]]
                end <- convertedCoords[[2]]
            } else {
                start <- convertX(unit(highlight$chromstart, "native"),
                    unitTo = page_units, valueOnly = TRUE
                )
                end <- convertX(unit(highlight$chromend, "native"),
                    unitTo = page_units, valueOnly = TRUE
                )
            }
        } else {
            start <- convertX(unit(highlight$chromstart, "native"),
                unitTo = page_units, valueOnly = TRUE
            )
            end <- convertX(unit(highlight$chromend, "native"),
                unitTo = page_units, valueOnly = TRUE
            )
        }

        width <- end - start
        ## Add additional page units to start
        start <- as.numeric(plotVP_bottomLeft[[1]]) + start
    }

    seekViewport("page")

    # =========================================================================
    # USE JUSTIFICATION TO DETERMINE PAGE-ADJUSTED TOP Y-COORD
    # =========================================================================

    top_y <- y_Pagetop(
        y = highlight$y,
        height = highlight$height,
        just = highlight$just
    )

    # =========================================================================
    # HIGHLIGHT GROB
    # =========================================================================

    name <- paste0(
        "highlight",
        length(grep(
            pattern = "highlight",
            x = grid.ls(
                print = FALSE,
                recursive = FALSE
            )
        )) + 1
    )

    if (!is.null(highlight$chromstart) & !is.null(highlight$chromend)) {
        
        if (width == 0){
            
            highlightInternal$gp$col <- highlightInternal$gp$fill
            
            highlightGrob <- grid.segments(
                x0 = unit(start, page_units), 
                x1 = unit(start, page_units),
                y0 = top_y,
                y1 = top_y - highlight$height,
                gp = highlightInternal$gp, name = name
            )
        } else {
            highlightGrob <- grid.rect(
                x = unit(start, page_units), y = top_y,
                width = unit(width, page_units),
                height = highlight$height,
                just = c("left", "top"),
                gp = highlightInternal$gp, name = name
            )
        }
        highlight$grobs <- highlightGrob
    }

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("highlight[", name, "]")
    invisible(highlight)
}

#' Check for .(m)cool file and contents
#' @author Sarah Parker
#' 
#' @param file Path to .(m)cool file
#' 
#' @importFrom glue glue glue_collapse
#' @importFrom rlang abort
#' @importFrom rhdf5 H5Fis_hdf5 h5ls
#' @importFrom dplyr pull
.checkCool <- function(file){
    
    ## Check if file is hdf5
    isHDF5 <- H5Fis_hdf5(file)
    
    if(!isHDF5){
        abort(c("File must be a `.cool` or `.mcool` file",
                "x" = glue("{file} is not in HDF5 format")))
    }
    
    lvl1contents <- h5ls(file, recursive = 1)
    expectedContents <- c("bins", "chroms", "indexes", "pixels")
    
    ## Check if it is mcool or cool
    if (nrow(lvl1contents) == 1){
        ## mcool file has 1 row-resolutions    
        
        ## Get deeper contents of mcool
        lvl2contents <- h5ls(file, recursive = 3) |>
            pull(name) |>
            unique()
        
        ## Check for expected datasets and resolutions
        
        if (all(expectedContents %in% lvl2contents) & 
           lvl1contents$name == "resolutions"){
            return(".mcool")
        } 
        
    } else {
        ## check that cool file contains expected datasets
        if (all(expectedContents %in% lvl1contents$name)){
            return(".cool")
        } 
    }
    
    ## Abort with message if not a cool file and doesn't contain expected contents
    expectedNames <- glue_collapse(glue("`{expectedContents}`"), sep = ", ")
    abort(c("File must be a `.cool` or `.mcool` file",
            "x" = glue("{file} does not contain expected datasets"),
            "i" = glue("Expected datasets {expectedNames}")))
    
}

#' Read basepair resolutions from an .(m)cool file
#' @author Sarah Parker
#'
#' @param file A character value specifying the path to the .(m)cool file
#' @importFrom rhdf5 h5ls h5read
#'
#' @returns Vector of basepair resolutions
#' 
#' @export
readCoolBpResolutions <- function(file){
    
    ## Check if file is `.mcool` or `.cool`
    fileType <- .checkCool(file)
    
    ## find all valid resolutions
    if(fileType == ".mcool"){
        ## get contents from cool file
        contents <- h5ls(file, recursive = 2)
        
        res <- contents[contents$group == "/resolutions","name"] |>
            as.integer() |>
            sort()
    } else {
        ## .cool files only have one resolution, calculate from bins
        start <- h5read(file, name = "/bins/start", index = list(1))
        end <- h5read(file, name = "/bins/end", index = list(1))
        res <- as.integer(end - start)
    }
    
    return(res)
}


#' Read normalizations included in .(m)cool files
#' @author Sarah Parker, Nicole Kramer
#'
#' @details
#' The "BALANCE" normalization refers to applying the pre-calculated matrix 
#' balancing weights in the `weight` dataset of `file`, typically present
#' in files created using cooler. VC is vanilla coverage, 
#' VC_SQRT is square root of vanilla coverage, 
#' and KR is Knight-Ruiz normalization.
#' 
#' Please note that if using a file from HiC-Pro, ICE normalizations will come
#' from files stored in a separate folder, and thus will not contain any 
#' normalizations explicitly called "ICE" or "BALANCE" since values are 
#' included already normalized. This normalization can be specified as "NONE".
#' 
#' @param file A character value specifying the path to the .(m)cool file
#' @param resolution optional, specify which resolution(s) to read 
#' normalization types from. Default is all resolutions in `file`.
#' 
#' @importFrom rlang arg_match
#' @importFrom rhdf5 h5ls
#'
#' @returns A vector or list of vectors of available normalizations
#' 
#' @export
readCoolNorms <- function(file, resolution = NULL){
    
    readBpNorm <- function(resolutionPath, file){
        bpNorm <- h5read(file, name = paste0(resolutionPath, "/bins")) |>
            names()
        bpNorm <- bpNorm[!(bpNorm %in% c("chrom", "start", "end"))] |>
            gsub("weight","BALANCE", x = _) |> # replace "weight" with "BALANCE"
            c("NONE") # add "NONE" for raw counts
        
        return(bpNorm)
    }
    
    fileType <- .checkCool(file)
    
    if (is.null(resolution)){
        if (fileType == ".mcool"){
            ## Get all resolutions from mcool file
            resolutions <- readCoolBpResolutions(file)
            
            ## Set dataset paths for each resolution
            datasetPaths <- paste0("/resolutions/", as.integer(resolutions))
            
            ## Get normalizations from the names of datasets in bins
            fileNorms <- lapply(datasetPaths, readBpNorm, file)
            names(fileNorms) <- resolutions
            
        } else {
            
            ## Get normalizations just from /bins
            fileNorms <- readBpNorm("", file)
        }
        
    } else {
        
        if (!resolution %in% readCoolBpResolutions(file)) {
            abort(c(
                glue("resolution={resolution} is not found in {file}."),
                "i"= glue("Use `readCoolBpResolutions({file})` to \\
                          see available resolutions.")
            ))
        }
        
        datasetPath <- ""
        ## if `.mcool` file, add the proper resolution to path
        if (fileType == ".mcool"){
            datasetPath <- paste0("/resolutions/", as.integer(resolution))
        }
        
        fileNorms <- readBpNorm(datasetPath, file)
        
    }
    
    return(fileNorms)
}


#' Read chromosomes included in .(m)cool files
#' @author Sarah Parker, Nicole Kramer
#' @param file A character value specifying the path to the .(m)cool file
#' @param resolution optional, specify which resolution(s) to read 
#' chromosomes from. Default is all resolutions in `file`.
#' 
#' @importFrom rhdf5 h5read
#'
#' @returns Data frame or list of data frames of chromosome names and lengths
#'
#' @export
readCoolChroms <- function(file, resolution = NULL){
    
    readBpChrom <- function(resolutionPath, file){
        bpChrom <- h5read(file, name = paste0(resolutionPath, "/chroms")) |>
            as.data.frame()
        
        ## add index column of the order of chromosomes
        bpChrom$index <- 1:nrow(bpChrom)
        return(bpChrom)
    }
    
    ## check if input is a cool file
    fileType <- .checkCool(file)
    
    if (is.null(resolution)){
        if (fileType == ".mcool"){
            
            ## Get all resolutions from mcool file
            resolutions <- readCoolBpResolutions(file)
            
            ## Set dataset paths for each resolution
            datasetPaths <- paste0("/resolutions/", as.integer(resolutions))
            
            ## Get chroms for each resolution
            chromInfo <- lapply(datasetPaths, readBpChrom, file)
            names(chromInfo) <- resolutions
            
        } else {
            chromInfo <- readBpChrom("", file)
        }
    } else {
        
        if (!resolution %in% readCoolBpResolutions(file)) {
            abort(c(
                glue("resolution={resolution} is not found in {file}."),
                "i"= glue("Use `readCoolBpResolutions({file})` to \\
                          see available resolutions.")
            ))
        }

        datasetPath <- ""
        
        ## if `.mcool` file, add the proper resolution to path
        if (fileType == ".mcool"){
            datasetPath <- paste0("/resolutions/", as.integer(resolution))
        }
    
        chromInfo <- readBpChrom(datasetPath, file)
        
    }
    
    return(chromInfo)
}


#' Determine best resolution for size of region for .(m)cool files
#' 
#' @param file Path to .(m)cool file
#' @param chromstart Chromstart of region
#' @param chromend Chromend of region
.coolAutoResolution <- function(file, chromstart, chromend){
    
    fileResolutions <- readCoolBpResolutions(file)
    
    if (is.null(chromstart) & is.null(chromend)){
        autoRes <- max(fileResolutions)
    } else {
        dataRange <- chromend - chromstart
        if (dataRange >= 150000000) {
            autoRes <- max(fileResolutions)
        } else if (dataRange >= 75000000 & dataRange < 150000000) {
            autoRes <- 250000
            autoRes <- fileResolutions[which(
                abs(fileResolutions - autoRes) == min(
                    abs(fileResolutions - autoRes)
                )
            )]
        } else if (dataRange >= 35000000 & dataRange < 75000000) {
            autoRes <- 100000
            autoRes <- fileResolutions[which(
                abs(fileResolutions - autoRes) == min(
                    abs(fileResolutions - autoRes)
                )
            )]
        } else if (dataRange >= 20000000 & dataRange < 35000000) {
            autoRes <- 50000
            autoRes <- fileResolutions[which(
                abs(fileResolutions - autoRes) == min(
                    abs(fileResolutions - autoRes)
                )
            )]
        } else if (dataRange >= 5000000 & dataRange < 20000000) {
            autoRes <- 25000
            autoRes <- fileResolutions[which(
                abs(fileResolutions - autoRes) == min(
                    abs(fileResolutions - autoRes)
                )
            )]
        } else if (dataRange >= 3000000 & dataRange < 5000000) {
            autoRes <- 10000
            autoRes <- fileResolutions[which(
                abs(fileResolutions - autoRes) == min(
                    abs(fileResolutions - autoRes)
                )
            )]
        } else {
            autoRes <- 5000
            autoRes <- fileResolutions[which(
                abs(fileResolutions - autoRes) == min(
                    abs(fileResolutions - autoRes)
                )
            )]
        }
    }
    
    return(as.integer(autoRes))
}

#' Add (alt)chromstart and (alt)chromend for NULL (alt)chrom region of 
#' .(m)cool files
#' 
#' @param file Path to .(m)cool file
#' @param chrom Chromosome of region; can also be altchromosome
#' @param resolution Resolution to read chromsome info from
.coolRegion <- function(file, chrom, resolution){
    
    chromInfo <- readCoolChroms(file, resolution = resolution)
    chromLength <- chromInfo[chromInfo$name == chrom, "length"]
    
    return(list(1, chromLength))
}

#' Read in data for a bin chunk
#' 
#' @param binChunk The binChunk indeces to read
#' @param file Path to .(m)cool file
#' @param bin_offsets Read in bin1 offsets
#' @param binChunkSize Size of bin chunk, for comparison against the end of 
#' the bin chunk
#' @param datasetPath Dataset path, for specifying resolution in .mcool file
#' @param end1bin Bin where end1 starts
#' @param start2bin Bin for chr2 starts
#' @param end2bin Bin for end2 starts
#' 
#' @importFrom rhdf5 h5read
.pullBinChunks <- function(binChunk, file, bin_offsets, binChunkSize,
                           datasetPath, end1bin,
                           start2bin, end2bin){
    
    binChunkEnd <- binChunk + binChunkSize - 1
    
    if (binChunkEnd > bin_offsets[end1bin+1]+1){
        binChunkEnd <- bin_offsets[end1bin+1]+1
    }
    if (binChunkEnd > binChunk){
        bin2s <- h5read(file, 
                        name = paste0(datasetPath,"/pixels/bin2_id"),
                        index = list(binChunk:binChunkEnd)) 
        
        ## Find indexes for interactions with all bin2s between start2 and end2
        count_idx <- which(bin2s %in% start2bin:end2bin) + binChunk - 1
    } else {
        count_idx <- NA
    }
    
    return(count_idx)
}


#' Error checking function for .(m)cool files
#' 
#' @param file Path to .(m)cool file
#' @param chrom User-inputted chromosome
#' @param chromstart User-inputted chromstart, can still be NULL at this point.
#' @param chromend User-inputted chromend, can still be NULL at this point.
#' @param zrange User-inputted zrange.
#' @param altchrom User-inputted alt chromosome.
#' @param altchromstart User-inputted alt chromstart.
#' @param altchromend User-inputted alt chromend.
#' @param norm User-inputted normalization.
#' @param resolution Resolution, either user-inputted or determined by 'auto'.
#' 
#' @importFrom glue glue
#' @importFrom rlang abort
.checkCoolErrors <- function(file, chrom, chromstart, chromend, zrange,
                       altchrom, altchromstart, altchromend, norm, resolution){
    ## File input
    .checkCool(file)
    
    ## Norm
    fileNorms <- readCoolNorms(file, resolution = resolution)
    if (!norm %in% fileNorms){
        abort(c(
            glue("norm={norm} is not found in {file}."),
            "i" = glue("Use `readCoolNorms({file})` to see available norms.")
        ))
    }
    
    ## Chroms
    chromInfo <- readCoolChroms(file, resolution = resolution)
    
    if (!chrom %in% chromInfo$name){
        abort(c(
            glue("chrom={chrom} not found in {file}."),
            "i" = glue("Check file chromosome names with \\
                       `readCoolChroms({file}).")
        ))
    }
    
    ## Genomic region
    regionErrors(chromstart = chromstart, chromend = chromend)
    
    ## Check that chromstart is in bounds
    if (!is.null(chromstart)){
        chromLength <- chromInfo[chromInfo$name == chrom, "length"]
        if (chromstart < 0 | chromstart > chromLength){
            abort(c(glue("chromstart must be between 0 and chromosome end."),
                    "i" = "{chrom} length is {chromLength} bp."))
        }
    }
    
    if (!is.null(altchrom)){
        if (!altchrom %in% chromInfo$name){
            abort(c(
                glue("altchrom={altchrom} not found in {file}."),
                "i" = glue("Check file chromosome names with \\
                           `readCoolChroms({file}).")
            ))
        }
        
        ## Can't specify altchrom without a chrom
        if (is.null(chrom)){
            abort(c("Specified altchrom={altchrom} but did not give chrom."))
        }
        
        regionErrors(chromstart = altchromstart,
                     chromend = altchromend)
        
        altchromLength <- chromInfo[chromInfo$name == altchrom, "length"]
        if (altchromstart < 0 | altchromstart > altchromLength){
            abort(c(glue("altchromstart must be between 0 and alt chromosome end."),
                    "i" = "{altchrom} length is {altchromLength} bp."))
        }
        
        ## If giving same chrom and altchrom, need to specify
        ## chromstart/chromend and altchromstart/altchromend
        
        if (chrom == altchrom) {
            if (is.null(chromstart) |
                is.null(chromend) |
                is.null(altchromstart) |
                is.null(altchromend)) {
                
                abort(c(glue("No chromstart, chromend, altchromstart, and \\
                             altchromend given for same chrom and altchrom."),
                        "i" = glue("If trying to get all interactions between \\
                                   one chromsome, just specify chrom.")))
                
            }
        }
        
    }
    
    ## zrange errors
    rangeErrors(range = zrange)
    
}

#' Read a .(m)cool file and return Hi-C data as a dataframe
#' @author Sarah Parker, Nicole Kramer
#' @usage readCool(
#'     file,
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     altchrom = NULL,
#'     altchromstart = NULL,
#'     altchromend = NULL,
#'     resolution = "auto",
#'     zrange = NULL,
#'     norm = "NONE",
#'     binChunkSize = 5e6,
#'     params = NULL,
#'     quiet = FALSE
#' )
#' 
#' @param file A character value specifying the path to the .(m)cool file.
#' @param chrom Chromosome of data, as a string.
#' @param chromstart Integer start position on chromosome.
#' @param chromend Integer end position on chromosome.
#' @param altchrom Alternate chromosome for interchromosomal data,
#' as a string.
#' @param altchromstart Alternate chromosome integer start position
#' for interchromosomal data.
#' @param altchromend Alternate chromosome integer end position
#' for interchromosomal data.
#' @param resolution A numeric specifying the width of each pixel.
#' "auto" will attempt to choose a resolution in basepairs based on
#' the size of the region.
#' @param zrange A numeric vector of length 2 specifying the range of
#' interaction scores, where extreme values will be set to the max or min.
#' @param norm Character value specifying hic data normalization method.
#' This value must be found in the .(m)cool file.
#' Default value is \code{norm = "NONE"}.
#' @param binChunkSize A numeric specifying the number of bin indices to read 
#' from a file for a given region at a given resolution. If the total amount of 
#' data is larger than the \code{binChunkSize}, data will be read in multiple
#' chunks. Default value is \code{binChunkSize = 5e6}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param quiet A logical indicating whether or not to print messages.
#' 
#' 
#' @return Returns a 3-column dataframe in sparse upper triangular
#' format with the following columns: \code{chrom}, \code{altchrom},
#' \code{counts}.
#' 
#' @examples
#' 
#' ## .cool file
#' coolFile <- file.path(tempdir(), "Rao2014-IMR90-MboI-allreps-filtered.1000kb.cool")
#' download.file(url = "https://usgs2.osn.mghpcc.org/cooler01/examples/hg19/Rao2014-IMR90-MboI-allreps-filtered.1000kb.cool",
#'     destfile = coolFile, mode = "wb")
#' 
#' ## Read in region `chr2:10000000-22000000` at 1000Kb cool file resolution
#' coolData <- readCool(file = coolFile, chrom = "chr2", chromstart = 10000000,
#'                      chromend = 22000000,
#'                      resolution = 1000000)
#' 
#' ## .mcool file
#' mcoolFile <- file.path(tempdir(), "LEUK_HEK_PJA27_inter_30.mcool")
#' download.file(url = "https://zenodo.org/records/10906240/files/LEUK_HEK_PJA27_inter_30.mcool?download=1",
#'     destfile = mcoolFile, mode = "wb")
#'
#' ## Read in region `chr2:1000000-5000000` at 100Kb resolution
#' mcoolData_100Kb <- readCool(file = mcoolFile, chrom = "2",
#'                             chromstart = 1000000, chromend = 5000000,
#'                             resolution = 100000)
#' 
#' ## Read in data for chr2 at 2500Kb resolution 
#' mcoolData_2500Kb <- readCool(file = mcoolFile, chrom = "2",
#'                              resolution = 2500000)
#' @seealso \link[plotgardener]{readHic}
#'
#' @importFrom rlang inform warn
#' @export
readCool <- function(file, chrom, chromstart = NULL, chromend = NULL, 
                     altchrom = NULL, altchromstart = NULL, altchromend = NULL, 
                     resolution = "auto", zrange = NULL, norm = "NONE",
                     binChunkSize = 5e6, params = NULL, quiet = FALSE){
    
    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================
    
    rcool <- parseParams(params = params, 
                        defaultArgs = formals(eval(match.call()[[1]])),
                        declaredArgs = lapply(match.call()[-1], 
                                              eval.parent, n = 2),
                        class = "rcool")
    
    if (is.null(rcool$file)){
        abort(c("argument \"file\" is missing, with no default."))}

    if (is.null(rcool$chrom)){
        abort(c("argument \"chrom\" is missing, with no default."))}
    
    # =========================================================================
    # ADJUST RESOLUTION
    # =========================================================================

    if (rcool$resolution == "auto") {
        rcool$resolution <- .coolAutoResolution(
            file = rcool$file,
            chromstart = rcool$chromstart,
            chromend = rcool$chromend
        )
    } 

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    .checkCoolErrors(
        file = rcool$file, chrom = rcool$chrom,
        chromstart = rcool$chromstart,
        chromend = rcool$chromend, zrange = rcool$zrange,
        altchrom = rcool$altchrom,
        altchromstart = rcool$altchromstart,
        altchromend = rcool$altchromend, norm = rcool$norm,
        resolution = rcool$resolution
    )

    # =========================================================================
    # SET REGION PARAMETERS
    # =========================================================================
    
    if (is.null(rcool$chromstart) & is.null(rcool$chromend)){
        chrRegion <- .coolRegion(file = rcool$file,
                                 chrom = rcool$chrom,
                                 resolution = rcool$resolution)
        
        rcool$chromstart <- chrRegion[[1]]
        rcool$chromend <- chrRegion[[2]]
    }

    
    ## For off diagonal plotting, grabbing whole symmetric region
    if (!is.null(rcool$altchrom)) {
        
        if (is.null(rcool$altchromstart) & is.null(rcool$altchromend)){
            altchrRegion <- .coolRegion(file = rcool$file,
                                        chrom = rcool$altchrom,
                                        resolution = rcool$resolution)
            rcool$altchromstart <- altchrRegion[[1]]
            rcool$altchromend <- altchrRegion[[2]]
        }
        
        
        if (rcool$chrom == rcool$altchrom) {
            rcool$chromstart <- min(rcool$chromstart, rcool$altchromstart)
            rcool$chromend <- max(rcool$chromend, rcool$altchromend)
        }
    } else {
        rcool$altchrom <- rcool$chrom
        rcool$altchromstart <- rcool$chromstart
        rcool$altchromend <- rcool$chromend
        
    }
    # =========================================================================
    # EXTRACT SPARSE UPPER TRIANGULAR COUNT MATRIX
    # =========================================================================

    fileType <- .checkCool(rcool$file)
    chrInfo <- readCoolChroms(rcool$file, rcool$resolution)
    datasetPath <- ""
    if (fileType == ".mcool"){
        datasetPath <- paste0("/resolutions/", as.integer(rcool$resolution))
    }

    ## Find bin IDs for both chrom locations -----------------------------------
    ## adjust starts and ends to start of bins
    
    start1 <- (rcool$chromstart %/% rcool$resolution) * rcool$resolution
    start2 <- (rcool$altchromstart %/% rcool$resolution) * rcool$resolution

    end1 <- (rcool$chromend %/% rcool$resolution) * rcool$resolution
    end2 <- (rcool$altchromend %/% rcool$resolution) * rcool$resolution
    
    ## Get vector of chromosome offsets 
    chrom_offsets <- h5read(rcool$file, 
                            name = paste0(datasetPath, "/indexes/chrom_offset"))
    
    ## find bin id for chr1:start1:end1
    chr1indx <- chrInfo[chrInfo$name == rcool$chrom, "index"]
    
    ## get start1 bin
    chr1_starts <- h5read(rcool$file, name = paste0(datasetPath, "/bins/start"),
                          index = list((chrom_offsets[chr1indx]+1):
                                           chrom_offsets[chr1indx+1]))
    start1bin <- which(chr1_starts == start1) + chrom_offsets[chr1indx] - 1
    
    ## get end1 bin (i.e. bin where end1 starts)
    end1bin <- which(chr1_starts == end1) + chrom_offsets[chr1indx] - 1
    
    ## find bin id for chr2:start2:end2
    chr2indx <- chrInfo[chrInfo$name == rcool$altchrom, "index"]
    
    ## get start2 bin
    chr2_starts <- h5read(rcool$file, name = paste0(datasetPath,"/bins/start"),
                          index = list((chrom_offsets[chr2indx]+1):
                                           chrom_offsets[chr2indx+1]))
    start2bin <- which(chr2_starts == start2) + chrom_offsets[chr2indx] - 1

    ## get end2 bin
    end2bin <- which(chr2_starts == end2) + chrom_offsets[chr2indx] - 1
    
    ## Extract counts and match locations --------------------------------------
    
    ## Get bin offsets for counts
    bin_offsets <- h5read(rcool$file, 
                          name = paste0(datasetPath,"/indexes/bin1_offset"))
                          
    ## Pull all bin2 ids for interactions with all bin1s between start1 and end1
    ## Read 5 million indices at a time for more efficient calling
    allBin1s <- (bin_offsets[start1bin+1]+1):(bin_offsets[end1bin+1]+1)
    
    if (length(allBin1s) > rcool$binChunkSize){
        binChunks <- seq(bin_offsets[start1bin+1]+1,
                         bin_offsets[end1bin+1]+1,
                         binChunkSize)
        
        
        count_idx <- na.omit(unlist(lapply(binChunks, .pullBinChunks, 
                                           file = rcool$file,
               bin_offsets = bin_offsets, binChunkSize = rcool$binChunkSize,
               datasetPath = datasetPath, end1bin = end1bin,
               start2bin = start2bin, end2bin = end2bin)))
        
    } else {
        bin2s <- h5read(rcool$file, 
                        name = paste0(datasetPath,"/pixels/bin2_id"),
                        index = list(allBin1s)) 
        
        ## Find indexes for interactions with all bin2s between start2 and end2
        count_idx <- which(bin2s %in% start2bin:end2bin) + 
            bin_offsets[start1bin+1]
    }
    
    ## Pull out bin1 ids, bin2 ids, and counts for all interactions in slice
    bin1ids <- h5read(rcool$file, name = paste0(datasetPath,"/pixels/bin1_id"), 
                      index = list(count_idx))
    
    bin2ids <- h5read(rcool$file, name = paste0(datasetPath,"/pixels/bin2_id"), 
                      index = list(count_idx))
    
    counts <- h5read(rcool$file, name = paste0(datasetPath,"/pixels/count"), 
                     index = list(count_idx)) |>
        #defaults to integer, needs to be numeric to convert to NA correctly
        as.numeric()
    
    ## Multiply by normalization factors, if applicable
    if (rcool$norm == "BALANCE"){
        bin1norm <- h5read(rcool$file, 
                           name = paste0(datasetPath,"/bins/weight"),
                           list(as.numeric(bin1ids+1)))
        bin2norm <- h5read(rcool$file, 
                           name = paste0(datasetPath,"/bins/weight"),
                           list(as.numeric(bin2ids+1)))
        counts <- counts / (bin1norm * bin2norm)
    } else if (rcool$norm != "NONE"){
        bin1norm <- h5read(rcool$file, 
                           name = paste0(datasetPath,"/bins/", rcool$norm),
                           list(as.numeric(bin1ids+1)))
        bin2norm <- h5read(rcool$file, 
                           name = paste0(datasetPath,"/bins/", rcool$norm),
                           list(as.numeric(bin2ids+1)))
        counts <- counts / (bin1norm * bin2norm)
    }
    
    ## Get genomic locations for each bin id 
    xs <- h5read(rcool$file, 
                 name = paste0(datasetPath,"/bins/start"),
                 index = list(as.numeric(bin1ids+1)))
    ys <- h5read(rcool$file, 
                 name = paste0(datasetPath,"/bins/start"),
                 index = list(as.numeric(bin2ids+1)))
    
    ## create sparse upper triangular matrix
    upper <- data.frame(x = xs, y = ys, counts = counts)
    
    # =========================================================================
    # SCALE DATA WITH ZRANGE
    # =========================================================================
    upper <- scale_data(upper = upper, zrange = rcool$zrange)
    
    # =========================================================================
    # FORMAT DATA IN PROPER ORDER AND WITH LABELS
    # =========================================================================
    
    ## Rename columns based on chrom/altchrom
    if (rcool$chrom == rcool$altchrom){
        colnames(upper) <- c(paste0(rcool$chrom, "_A"),
                             paste0(rcool$altchrom, "_B"),
                             "counts")
    } else {
        colnames(upper) <- c(rcool$chrom, rcool$altchrom, "counts")
    }
    
    # =========================================================================
    # REMOVE NAN VALUES
    # =========================================================================
    
    upper <- na.omit(upper)
    
    # =========================================================================
    # RETURN DATAFRAME
    # =========================================================================
    if (nrow(upper) == 0) {
        warn(c(glue("No data found in region.")))
    } else {
        if (!rcool$quiet) {
            inform(c(glue("Read in {fileType} file with {rcool$norm} \\
                          normalization at {rcool$resolution} BP resolution.")))
        }
    }
    return(upper)
    
    
}

test_that("read_rangeData", {
    library(GenomicRanges)
    library(plotgardenerData)
    ## GRanges reading
    gr <- GRanges(seqnames = "chr1", strand = c("+", "-", "+"),
                  ranges = IRanges(start = c(1,3,5), width = 3))
    values(gr) <- DataFrame(score = c(0.1, 0.5, 0.3))
    
    expectedgr <- as.data.frame(gr)
    colnames(expectedgr)[1:3] <- c("chrom", "start", "end")
    
    expect_equal(plotgardener:::read_rangeData(data = gr,
                              assembly = "hg19"),
                 expectedgr)
    
    ## Errors for invalid column types
    expectedgr$start <- as.character(expectedgr$start)
    expectedgr$end <- as.character(expectedgr$end)
    expect_error(plotgardener:::read_rangeData(data = expectedgr,
                              assembly = "hg19"))
    
})

test_that("read_pairedData", {
    ## GInteractions reading
    library(GenomicRanges)
    library(InteractionSet)
    all.regions <- GRanges("chrA", IRanges(0:9*10+1, 1:10*10))
    index.1 <- c(1,2,3)
    index.2 <- c(4,5,6)
    region.1 <- all.regions[index.1]
    region.2 <- all.regions[index.2]
    gi <- GInteractions(region.1, region.2)
    
    expectedgi <- as.data.frame(gi)[,c(1,2,3,6,7,8,4,5,9,10)]
    
    colnames(expectedgi)[1:6] <- c("chrom1", "start1", "end1",
                                   "chrom2", "start2", "end2")
    expect_equal(plotgardener:::read_pairedData(data = gi,
                                           assembly = "hg19"),
                 expectedgi)
    
    ## Warning for out of order anchors
    index.3 <- c(1,6,8)
    index.4 <- c(2,4,7)
    region.3 <- all.regions[index.3]
    region.4 <- all.regions[index.4]
    gi2 <- GInteractions(region.3, region.4)
    expect_warning(plotgardener:::read_pairedData(data = gi2,
                                                  assembly = "hg19"))
    
    ## Errors for invalid column types
    expectedgi$start1 <- as.character(expectedgi$start1)
    expectedgi$end2 <- as.character(expectedgi$end2)
    expect_error(plotgardener:::read_pairedData(data = expectedgi,
                                            assembly = "hg19"))
    
})

test_that("checkAssemblyMatch", {
    library("TxDb.Hsapiens.UCSC.hg19.knownGene")
    ## warning for invalid matching
    tx_db <- TxDb.Hsapiens.UCSC.hg19.knownGene
    expect_warning(plotgardener:::checkAssemblyMatch(data = tx_db,
            assembly = plotgardener:::parseAssembly("hg38")))
})

test_that("readHic", {
    library("plotgardenerData")
    
    hicFile <- system.file("extdata/test_chr22.hic", package="plotgardenerData")
    
    ## Check that Hi-C file reads in with correct dimension
    hicData <- readHic(file = hicFile, chrom = "22",
                       chromstart = 20000000, chromend = 20300000,
                       assembly = "hg19",
                       resolution = 100000) 
    expect_equal(nrow(hicData), 10)
    expect_equal(min(hicData[,1]), 20000000)
    expect_equal(max(hicData[,1]), 20300000)
})

test_that("readCool", {
    
    ## .cool file
    coolFile <- file.path(tempdir(), "Rao2014-IMR90-MboI-allreps-filtered.1000kb.cool")
    download.file(url = "https://usgs2.osn.mghpcc.org/cooler01/examples/hg19/Rao2014-IMR90-MboI-allreps-filtered.1000kb.cool",
                            destfile = coolFile, mode = "wb")
    on.exit(unlink(coolFile))
    
    # File type
    expect_equal(.checkCool(file = coolFile), ".cool")
    
    # Resolutions
    expect_equal(readCoolBpResolutions(file = coolFile), 1000000)
    expect_error(readCoolNorms(file = coolFile, resolution = 5000), "resolution")
    expect_error(readCoolChroms(file = coolFile, resolution = 5000), "resolution")
    
    # Norms
    expect_equal(readCoolNorms(file = coolFile), c("BALANCE", "NONE"))
    
    # Chroms
    cool_chroms <- readCoolChroms(file = coolFile) |>
        pull(name)
    expect_setequal(cool_chroms, paste0("chr", c(seq(1:22), "X", "Y", "M")))
    expect_error(.checkCoolErrors(file = coolFile, chrom = "2",
                                  chromstart = NULL, chromend = NULL,
                                  zrange = NULL, altchrom = NULL,
                                  altchromstart = NULL, altchromend = NULL,
                                  norm = "NONE", resolution = 1000000), 
                 "chrom")
    
    ## .mcool file
    mcoolFile <- file.path(tempdir(), "LEUK_HEK_PJA27_inter_30.mcool")
    download.file(url = "https://zenodo.org/records/10906240/files/LEUK_HEK_PJA27_inter_30.mcool?download=1",
                  destfile = mcoolFile, mode = "wb")
    on.exit(unlink(mcoolFile))
    
    # File type
    expect_equal(.checkCool(file = mcoolFile), ".mcool")
    
    # Resolutions
    expect_setequal(readCoolBpResolutions(file = mcoolFile),
                    c(5000, 10000, 25000, 50000, 100000, 250000, 500000,
                      1000000, 2500000))
    expect_error(readCoolNorms(file = mcoolFile, resolution = 2500), 
                 "resolution")
    
    # Norms
    # Vector of norms for one resolution
    expect_setequal(readCoolNorms(file = mcoolFile, resolution = 10000),
                    c("KR", "VC", "VC_SQRT", "NONE"))
    # List of vectors for all resolutions
    expect_type(readCoolNorms(file = mcoolFile), "list")
    
    # Chroms
    expect_type(readCoolChroms(file = mcoolFile), "list")
    expect_error(.checkCoolErrors(file = mcoolFile, chrom = "chr2",
                                  chromstart = NULL, chromend = NULL,
                                  zrange = NULL, altchrom = NULL,
                                  altchromstart = NULL, altchromend = NULL,
                                  norm = "NONE", resolution = 1000000), 
                 "chrom")
    
})

#' Plot any kind of signal track data for a single chromosome
#' 
#' @usage plotSignal(
#'     data,
#'     binSize = NA,
#'     binCap = TRUE,
#'     negData = FALSE,
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     assembly = "hg38",
#'     linecolor = "#37a7db",
#'     fill = NA,
#'     ymax = 1,
#'     range = NULL,
#'     scale = FALSE,
#'     label = NULL,
#'     bg = NA,
#'     baseline = TRUE,
#'     baseline.color = "grey",
#'     baseline.lwd = 1,
#'     orientation = "h",
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL,
#'     ...
#' )
#'
#' @param data Data to be plotted as a character value specifying a
#' bigwig file path, a dataframe in BED format, or a
#' \link[GenomicRanges]{GRanges} object with metadata column \code{score}.
#' Either one \code{data} argument or a list of two can be provided, where
#' the second \code{data} will be plotted below the x-axis if positive.
#' The second \code{data} can also be negative data.
#' @param binSize A numeric specifying the length of each data
#' bin in basepairs. Default value is \code{binSize = NA}.
#' @param binCap A logical value indicating whether the function will
#' limit the number of data bins to 8,000.
#' Default value is \code{binCap = TRUE}.
#' @param negData A logical value indicating whether the provided data has 
#' negative scores. Default value is \code{negData = FALSE}.
#' @param chrom Chromosome of region to be plotted, as a string.
#' @param chromstart Integer start position on chromosome to be plotted.
#' @param chromend Integer end position on chromosome to be plotted.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param linecolor A character value or vector of length 2 specifying the
#' line color(s) outlining the signal track(s).
#' Default value is \code{linecolor = "#37a7db"}.
#' @param fill A character value or vector of length 2 specifying
#' the fill color(s) of the signal track(s). Default value is \code{fill = NA}.
#' @param ymax A numeric specifying the fraction of the max y-value
#' to set as the height of the plot. Default value is \code{ymax = 1}.
#' @param range A numeric vector of length 2 specifying the y-range
#' of data to plot (c(min, max)).
#' @param scale A logical value indicating whether to include a data
#' scale label in the top left corner of the plot.
#' Default value is \code{scale = FALSE}.
#' @param label An optional character value to conveniently add a text label
#' to the plot. If \code{scale = TRUE}, the label will be draw in the top right
#' of the plot. Otherwise, the label will be drawn in the top left of the plot.
#' For more customizable labels, use \link[plotgardener]{plotText}.
#' Default value is \code{label = NULL}. 
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param baseline Logical value indicating whether to include a
#' baseline along the x-axis. Default value is \code{baseline = TRUE}.
#' @param baseline.color Baseline color.
#' Default value is \code{baseline.color = "grey"}.
#' @param baseline.lwd Baseline line width.
#' Default value is \code{baseline.lwd = 1}.
#' @param orientation A string specifying signal track orientation.
#' Default value is \code{orientation = "h"}. Options are:
#' \itemize{
#' \item{\code{"v"}: }{Vertical signal track orientation.}
#' \item{\code{"h"}: }{Horizontal signal track orientation.}
#' }
#' @param x A numeric or unit object specifying signal plot x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying signal plot y-location.
#' The character value will
#' place the signal plot y relative to the bottom of the most recently
#' plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying signal plot width.
#' @param height A numeric or unit object specifying signal plot height.
#' @param just Justification of signal plot relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal justification
#' and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use if
#' \code{x}, \code{y}, \code{width}, or \code{height} are only given as
#' numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output should be
#' produced. Default value \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{signal} object containing relevant
#' genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load signal data
#' library(plotgardenerData)
#' data("IMR90_ChIP_H3K27ac_signal")
#' data("GM12878_ChIP_H3K27ac_signal")
#'
#' ## Create a page
#' pageCreate(width = 7.5, height = 2.1, default.units = "inches")
#'
#' ## Define region
#' region <- pgParams(
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19",
#'     range = c(0, 45)
#' )
#'
#' ## Plot and place signal plots
#' signal1 <- plotSignal(
#'     data = IMR90_ChIP_H3K27ac_signal, params = region,
#'     x = 0.5, y = 0.25, width = 6.5, height = 0.65,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' signal2 <- plotSignal(
#'     data = GM12878_ChIP_H3K27ac_signal, params = region,
#'     linecolor = "#7ecdbb",
#'     x = 0.5, y = 1, width = 6.5, height = 0.65,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Plot genome label
#' plotGenomeLabel(
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19",
#'     x = 0.5, y = 1.68, length = 6.5,
#'     default.units = "inches"
#' )
#'
#' ## Add text labels
#' plotText(
#'     label = "IMR90", fonsize = 10, fontcolor = "#37a7db",
#'     x = 0.5, y = 0.25, just = c("left", "top"),
#'     default.units = "inches"
#' )
#' plotText(
#'     label = "GM12878", fonsize = 10, fontcolor = "#7ecdbb",
#'     x = 0.5, y = 1, just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @details
#' #A signal track can be placed on a plotgardener coordinate page
#' by providing plot placement parameters:
#' \preformatted{
#' plotSignal(data, chrom,
#'             chromstart = NULL, chromend = NULL,
#'             x, y, width, height, just = c("left", "top"),
#'             default.units = "inches")
#' }
#' This function can also be used to quickly plot an unannotated
#' signal track by ignoring plot placement parameters:
#' \preformatted{
#' plotSignal(data, chrom,
#'             chromstart = NULL, chromend = NULL)
#' }
#'
#' @export
plotSignal <- function(data, binSize = NA, binCap = TRUE, negData = FALSE,
                        chrom, chromstart = NULL, chromend = NULL,
                        assembly = "hg38", linecolor = "#37a7db",
                        fill = NA, ymax = 1, range = NULL, scale = FALSE,
                        label = NULL, bg = NA, baseline = TRUE, 
                        baseline.color = "grey", baseline.lwd = 1, 
                        orientation = "h", x = NULL, y = NULL, width = NULL,
                        height = NULL, just = c("left", "top"),
                        default.units = "inches", draw = TRUE,
                        params = NULL, ...) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that catches errors for plotSignal
    errorcheck_plotSignal <- function(signal, signaltrack, fill) {
        dfChecks <- function(signal) {
            if (!"data.frame" %in% class(signal)) {
                if (!"GRanges" %in% class(signal)) {
                    if (!file_ext(signal) %in% c(
                        "bw", "bigWig",
                        "bigwig", "bedgraph"
                    )) {
                        stop("Invalid input. File must have a valid bigwig or ",
                            "bedgraph extension.", call. = FALSE)
                    }
                }
            }
        }

        if (is(signal, "list")) {
            if (length(signal) > 2) {
                stop("Invalid signal input. More than 2 signals provided.",
                    call. = FALSE
                )
            }

            invisible(lapply(signal, dfChecks))
        } else {
            dfChecks(signal = signal)
        }

        ## Genomic region
        regionErrors(chromstart = signaltrack$chromstart,
                        chromend = signaltrack$chromend)

        ## Range errors
        rangeErrors(range = signaltrack$range)
        
        checkColorby(fill = fill,
                        colorby = FALSE)
    }

    ## Define a function that reads in signal data for plotSignal
    read_signal <- function(signal, signaltrack) {

        signal <- read_rangeData(data = signal,
                                assembly = signaltrack$assembly,
                                chrom = signaltrack$chrom,
                                start = signaltrack$chromstart,
                                end = signaltrack$chromend)
        
        ## Check for overlapping data ranges
        if (any(IRanges::overlapsAny(
            GenomicRanges::makeGRangesFromDataFrame(signal),
            drop.self = TRUE
        ) == TRUE)) {
            stop("Data ranges cannot overlap. Please check `start` ",
                "and `end` column ranges.", call. = FALSE)
        }

        return(signal)
    }

    ## Define a function that formats/filters signal data
    format_data <- function(signal, signaltrack) {
        if (!any(colnames(signal) == "score")) {
            stop("Cannot find associated `score` column in data.",
                call. = FALSE
            )
        } else {
            ## Grab chrom, start, end and a "score" column
            signal <- signal[c("chrom", "start", "end", "score")]
        }

        ## Ensure the chromosome is a character
        signal[, "chrom"] <- as.character(signal[, "chrom"])

        ## Filter for desired region
        signal <- signal[
            which(signal[, "chrom"] == signaltrack$chrom &
                ((signal[, "start"] > signaltrack$chromstart &
                    signal[, "start"] < signaltrack$chromend |
                    signal[, "end"] > signaltrack$chromstart &
                        signal[, "end"] < signaltrack$chromend))),
            (2:4)
        ]
        ## Remove any duplicate rows
        signal <- signal[!duplicated(signal), ]

        ## Remove any NaN score values
        signal <- na.omit(signal)
        return(signal)
    }

    ## Define a function that checks and adjust the number/sizes of bins
    check_binNum <- function(signaltrack, binCap) {
        if (!is.na(signaltrack$binSize)) {
            if (signaltrack$binSize %% 0.25 != 0) {
                updated_binSize <- round(signaltrack$binSize / 0.25) * 0.25
                signaltrack$binSize <- updated_binSize
            }


            binNum <- (signaltrack$chromend - signaltrack$chromstart) /
                signaltrack$binSize
            signaltrack$binNum <- binNum

            if (!is.nan(binNum)) {

                ## Scale back binNum and print warning if binNum is
                ## greater than 8000
                if (binNum > 8000 && binCap == TRUE) {
                    updated_binNum <- 8000
                    updated_binSize <- (signaltrack$chromend -
                        signaltrack$chromstart) / binNum
                    signaltrack$binNum <- updated_binNum
                    signaltrack$binSize <- updated_binSize
                    warning("Too many bins: adjusting to 8000 bins of size ",
                        binSize, ". To override try binCap = FALSE.",
                        call. = FALSE
                    )
                }

                ## Scale bin size to 1 if binNum is larger than span
                if (binNum > (signaltrack$chromend - signaltrack$chromstart)) {
                    updated_binNum <- (signaltrack$chromend -
                        signaltrack$chromstart)
                    updated_binSize <- 1
                    signaltrack$binNum <- updated_binNum
                    signaltrack$binSize <- updated_binSize
                    warning("Number of bins larger than plot length: ",
                        "adjusting to ", binNum, " bins of size 1.",
                        call. = FALSE
                    )
                }
            } else {
                signaltrack$binSize <- NA
            }
        }

        return(signaltrack)
    }

    ## Define a function that bins, links, sorts, and combines data
    parseData <- function(signal, signaltrack) {
        if (!is.na(signaltrack$binSize)) {

            # =================================================================
            # BIN DATA
            # =================================================================
            ## Find the max signal value for each bin

            binChromend <- signaltrack$binSize * signaltrack$binNum +
                signaltrack$chromstart + signaltrack$binSize

            binDF <- data.frame(
                "start" = seq(
                    signaltrack$chromstart,
                    binChromend - signaltrack$binSize,
                    signaltrack$binSize
                ),
                "end" = seq(
                    signaltrack$chromstart + signaltrack$binSize,
                    binChromend,
                    signaltrack$binSize
                )
            )
            binDF$score <- rebinBigwig(signal, binDF)

            ## Use binned data as new signal data
            newSignal <- binDF
            # =================================================================
            # LINKING REGIONS
            # =================================================================

            linking_regions <- cbind(
                "start" = newSignal[seq(1, (nrow(newSignal) - 1)), "end"],
                "end" = newSignal[seq(2, nrow(newSignal)), "start"]
            )
            
            linking_regions <- matrix(linking_regions[which(
                linking_regions[, "start"] != linking_regions[, "end"]
            ), ], ncol = 2, dimnames = list(NULL, c("start", "end")))

            if (nrow(linking_regions) > 0) {
                linking_regions <- cbind(linking_regions, "score" = 0)
                
                ## Add linking regions to signaltrack
                newSignal <- rbind(newSignal, linking_regions)
            }

            # =================================================================
            # SORT AND COMBINE DATA
            # =================================================================

            ## Sort data
            newSignal <- newSignal[order(newSignal[, "start"]), ]
            
            ## Convert two columns to one
            newSignal <- cbind(
                "x" = as.vector(t(newSignal[, c("start", "end")])),
                "score" = as.vector(t(newSignal[, c("score", "score")]))
            )

            signal <- newSignal
        }


        return(signal)
    }

    ## Define a function that adjusts the range
    set_range <- function(signal1, signal2, signaltrack, split, pos = TRUE) {
        if (split == TRUE) {

            ## posSignal
            if (pos == TRUE) {
                if (is.null(signaltrack$range)) {
                    if (nrow(signal1) >= 2){
                        if (max(signal2[,"score"]) > 0){
                            signaltrack$range[2] <- signaltrack$ymax *
                                max(signal2[, "score"])
                        } else {
                        signaltrack$range[2] <- 1
                        }
                        
                    } else {
                        signaltrack$range[2] <- 1
                    }
                }
            }
        
            ## negSignal
            if (pos == FALSE) {
                if (is.na(signaltrack$range[1])) {
                    if (nrow(signal1) >= 2 ){
                        if (min(signal2[,"score"]) < 0){
                            signaltrack$range[1] <- signaltrack$ymax *
                                min(signal2[, "score"])
                        } else {
                        signaltrack$range[1] <- -1
                        }
                        
                    } else {
                        signaltrack$range[1] <- -1
                    }
                }
            }
        
        } else {
            ## top = TRUE
            if (pos == TRUE){
                if (is.null(signaltrack$range)) {
                    if (nrow(signal1) >= 2){
                        if (max(signal2[,"score"]) > 0){
                            signaltrack$range <- c(0, signaltrack$ymax *
                                                       max(signal2[, "score"]))
                        } else {
                        signaltrack$range <- c(0, 1)
                        }
                    
                } else {
                    signaltrack$range <- c(0, 1)
                }
            }
        }
            ## top = FALSE
            if (pos == FALSE){
                if (is.null(signaltrack$range)) {
                    if (nrow(signal1) >= 2){
                        if (min(signal2[,"score"]) < 0){
                            signaltrack$range <- c(signaltrack$ymax *
                                                    min(signal2[, "score"]), 0)
                        } else {
                        signaltrack$range <- c(-1, 0)
                        }
                    
                } else {
                    signaltrack$range <- c(-1, 0)
                }
            }

            }
        }

        return(signaltrack)
    }

    ## Define a function that parses out one vs. two fillcolors/linecolors
    parseColors <- function(color) {
        if (length(color) >= 2) {
            posCol <- color[1]
            negCol <- color[2]
        } else {
            posCol <- color
            negCol <- color
        }

        return(list(posCol, negCol))
    }

    ## Define a function that makes a grob for a signal (pos/neg)
    sigGrob <- function(signal, fillCol, lineCol, gp) {
        gp$col <- lineCol
        if (!is.null(fillCol) & !is.na(fillCol)) {
            if ("alpha" %in% names(gp)) {
                fillCol <- makeTransparent(color = fillCol, alpha = gp$alpha)
            }

            gp$fill <- fillCol

            sigGrob <- polygonGrob(
                x = c(
                    signal[1, "x"], signal[, "x"],
                    signal[nrow(signal), "x"]
                ),
                y = c(0, signal[, "score"], 0), gp = gp,
                default.units = "native"
            )
        } else {
            sigGrob <- segmentsGrob(
                x0 = signal[seq(1, length(signal[, "x"]) - 1), "x"],
                y0 = signal[seq(1, length(signal[, "score"]) - 1), "score"],
                x1 = signal[seq(2, length(signal[, "x"])), "x"],
                y1 = signal[seq(2, length(signal[, "score"])), "score"],
                gp = gp, default.units = "native"
            )
        }


        ## Add grob to gtree
        assign("signal_grobs",
            addGrob(
                gTree = get("signal_grobs", envir = pgEnv),
                child = sigGrob
            ),
            envir = pgEnv
        )
    }

    ## Define a function that finds data that falls out of the plot's
    ## range and draws a tiny black line to indicate it
    cutoffGrobs <- function(signal, signaltrack, side) {
        grobCutoffs <- function(df, side) {
            x0 <- df[1]
            x1 <- df[2]

            if (side == "top") {
                y <- 1
            } else {
                y <- 0
            }

            cutoffGrob <- segmentsGrob(
                x0 = x0, x1 = x1, y0 = unit(y, "npc"),
                y1 = unit(y, "npc"),
                gp = gpar(lwd = 1, col = "grey"),
                default.units = "native"
            )
            assign("signal_grobs",
                addGrob(
                    gTree = get("signal_grobs", envir = pgEnv),
                    child = cutoffGrob
                ),
                envir = pgEnv
            )
        }

        if (side == "top") {
            outsideData <- which(signal[, "score"] > signaltrack$range[2])
        } else {
            outsideData <- which(signal[, "score"] < signaltrack$range[1])
        }

        ## Get index pairs of outside data
        outsidePairs <- as.integer(outsideData + 1)
        ## Combine and order
        Outsidei <- c(outsideData, outsidePairs)
        Outsidei <- Outsidei[order(Outsidei)]
        ## Get xcoords
        signal <- as.data.frame(signal)
        Outside <- signal[Outsidei, 1]
        ## x0s are odd indeces and x1s are even
        x0s <- Outside[c(TRUE, FALSE)]
        x1s <- Outside[c(FALSE, TRUE)]
        pairs <- data.frame("x0" = x0s, "x1" = x1s)

        invisible(apply(pairs, 1, grobCutoffs, side = side))
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    sigInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "sigInternal"
    )

    ## Set gp
    sigInternal$gp <- setGP(
        gpList = gpar(),
        params = sigInternal, ...
    )
    
    ## Justification
    sigInternal$just <- justConversion(just = sigInternal$just)

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    signal_track <- structure(list(
        chrom = sigInternal$chrom,
        chromstart = sigInternal$chromstart,
        chromend = sigInternal$chromend,
        assembly = sigInternal$assembly,
        binSize = sigInternal$binSize,
        binNum = NULL, range = sigInternal$range,
        ymax = sigInternal$ymax,
        x = sigInternal$x, y = sigInternal$y,
        width = sigInternal$width,
        height = sigInternal$height,
        just = sigInternal$just, grobs = NULL
    ),
    class = "signal"
    )
    attr(x = signal_track, which = "plotted") <- sigInternal$draw
    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    if (is.null(sigInternal$data)) stop("argument \"data\" is missing, ",
                                        "with no default.", call. = FALSE)
    if (is.null(sigInternal$chrom)) stop("argument \"chrom\" is missing, ",
                                            "with no default.", call. = FALSE)

    check_placement(object = signal_track)
    errorcheck_plotSignal(
        signal = sigInternal$data,
        signaltrack = signal_track,
        fill = sigInternal$fill
    )

    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    signal_track$assembly <- parseAssembly(assembly = signal_track$assembly)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    signal_track <- defaultUnits(
        object = signal_track,
        default.units = sigInternal$default.units
    )

    # =========================================================================
    # GENOMIC SCALE
    # =========================================================================

    scaleChecks <- genomicScale(object = signal_track,
                                objectInternal = sigInternal,
                                plotType = "signal track")
    signal_track <- scaleChecks[[1]]
    sigInternal <- scaleChecks[[2]]

    # =========================================================================
    # SET BINSIZE
    # =========================================================================

    if (is.na(signal_track$binSize) == TRUE) {
        if (!is.null(signal_track$chromstart)) {
            binSize <- (signal_track$chromend - signal_track$chromstart) / 2000
            signal_track$binSize <- binSize
        }
    }

    # =========================================================================
    # CHECK AND ADJUST BIN NUMBER/BIN SIZE
    # =========================================================================

    signal_track <- check_binNum(
        signaltrack = signal_track,
        binCap = sigInternal$binCap
    )

    # =========================================================================
    # READ IN, FORMAT, FILTER, BIN, LINK AND SORT DATA
    # =========================================================================
    
    if (is(sigInternal$data, "list")) {
        signal <- lapply(sigInternal$data, read_signal,
            signaltrack = signal_track
        )
        signal <- lapply(signal, format_data, signaltrack = signal_track)
        posSignal <- signal[[1]]
        negSignal <- signal[[2]]
        
        if (any(posSignal[, "score"] < 0)){
            stop("Two signal files detected and negative scores detected ",
                "in signal data. To plot negative values while specifying two ",
                "files, negative scores must be supplied in the second file in",
                " the list.", call. = FALSE)
        }

        if (!all(negSignal[, "score"] >= 0) & !all(negSignal[, "score"] <= 0)){
            stop("Second signal file has mixed positive and negative values. ",
            "Please make signal scores in second file entirely positive ",
            "or entirely negative.",
            .call = FALSE)
        }
        
        split <- TRUE
    } else {
        signal <- read_signal(
            signal = sigInternal$data,
            signaltrack = signal_track
        )
        signal <- format_data(signal = signal, signaltrack = signal_track)

        if (any(signal[, "score"] < 0)) {
            if (sigInternal$negData == FALSE) {
                warning("Negative scores detected in signal data. To make ",
                "an entirely positive signal track, ",
                "please remove negative scores from data.", call. = FALSE)
            }
            
            if (all(signal[, "score"] <= 0)) {
                top <- FALSE
                negSignal <- signal[which(signal[, "score"] <= 0), ]
                negSignal[, "score"] <- negSignal[, "score"] * -1
                posSignal <- negSignal
                split <- FALSE
            } else {
                posSignal <- signal[which(signal[, "score"] >= 0), ]
                negSignal <- signal[which(signal[, "score"] < 0), ]
                negSignal[, "score"] <- negSignal[, "score"] * -1
                split <- TRUE 
            }

        } else {
            top <- TRUE
            posSignal <- signal
            split <- FALSE
            if (sigInternal$negData == TRUE) {
                negSignal <- data.frame()
                split <- TRUE
            }
        }
    }


    # =========================================================================
    # BIN, LINK, AND SORT DATA AND FIX Y-LIMITS
    # =========================================================================

    if (split == TRUE) {
        if (nrow(posSignal) >= 2) {
            posSignal2 <- parseData(
                signal = posSignal,
                signaltrack = signal_track
            )
        } else {
            posSignal2 <- data.frame()
        }

        signal_track <- set_range(
            signal1 = posSignal, signal2 = posSignal2,
            signaltrack = signal_track, split = TRUE
        )
 
        if (nrow(negSignal) >= 2) {
            
            ## Check if the negative signal is already negative
            if (any(negSignal[,"score"] < 0)){
                negSignal[,"score"] <- negSignal[,"score"] * -1
            }
            
            
            negSignal2 <- parseData(
                signal = negSignal,
                signaltrack = signal_track
            )
            negSignal2[, "score"] <- negSignal2[, "score"] * -1
        } else {
            negSignal2 <- data.frame()
        }


        signal_track <- set_range(
            signal1 = negSignal, signal2 = negSignal2,
            signaltrack = signal_track, split = TRUE,
            pos = FALSE
        )


        if (signal_track$range[1] == 0 & signal_track$range[2] == 0) {
            signal_track$range <- c(-1, 1)
        }
    } else {
        if (nrow(posSignal) >= 2) {
            posSignal2 <- parseData(
                signal = posSignal,
                signaltrack = signal_track
            )
            
            if (top == FALSE){
                posSignal2[, "score"] <- posSignal2[,"score"] * -1
            }
            
        } else {
            posSignal2 <- data.frame()
        }
        
        signal_track <- set_range(
            signal1 = posSignal, signal2 = posSignal2,
            signaltrack = signal_track, split = FALSE,
            pos = top
        )

    }

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## If placing information is provided but plot == TRUE,
    ## set up it's own viewport separate from bb_makepage
    ## Not translating into page_coordinates
    if (is.null(signal_track$x) | is.null(signal_track[["y"]])) {

        if (sigInternal$orientation == "h"){

            vp <- viewport(
                height = unit(0.25, "snpc"), width = unit(1, "snpc"),
                x = unit(0.5, "npc"), y = unit(0.5, "npc"),
                clip = "on",
                xscale = sigInternal$xscale,
                yscale = c(signal_track$range[1], signal_track$range[2]),
                just = "center",
                name = "signal1_h"
                )
            } else if (sigInternal$orientation == "v"){

                ## outside clipping viewport
                vpClip <- viewport(
                    x = unit(0.5, "npc"),
                    y = unit(0.5, "npc"),
                    width = unit(0.25, "snpc"),
                    height = unit(1, "snpc"),
                    just = "center",
                    clip = "on",
                    xscale = c(signal_track$range[2], signal_track$range[1]),
                    yscale = sigInternal$xscale,
                    name = "signal1_vClip"

                )
                pushViewport(vpClip)
                height <- convertWidth(unit(1, "npc"), unitTo = "inches")
                width <- convertHeight(unit(1, "npc"), unitTo = "inches")
                upViewport()
                ## Make rotated, horizontal viewport
                vp <- viewport(
                    height = height, width = width,
                    x = unit(1, "npc"), y = unit(0, "npc"),
                    just = c("left", "bottom"),
                    xscale = sigInternal$xscale,
                    yscale = c(signal_track$range[1], signal_track$range[2]),
                    name = "signal1_v",
                    angle = 90
                )
            }

        if (sigInternal$draw == TRUE) {
            grid.newpage()
        }
        } else {
            
        ## Get viewport name
        currentViewports <- current_viewports()
        vp_name <- paste0(
            "signal",
            length(grep(pattern = "signal",
                        x = currentViewports)) + 1
            )

        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = signal_track)

        if (sigInternal$orientation == "h"){

            ## Make viewport
            vp <- viewport(
                height = page_coords$height, width = page_coords$width,
                x = page_coords$x, y = page_coords$y,
                clip = "on",
                xscale = sigInternal$xscale,
                yscale = c(signal_track$range[1], signal_track$range[2]),
                just = sigInternal$just,
                name = paste0(vp_name, "_h")
            )
            addViewport(paste0(vp_name, "_h"))
        } else if (sigInternal$orientation == "v"){

            ## outside clipping viewport
            vpClip <- viewport(
                x = page_coords$x,
                y = page_coords$y,
                width = page_coords$width,
                height = page_coords$height,
                just = sigInternal$just,
                clip = "on",
                xscale = c(signal_track$range[2], signal_track$range[1]),
                yscale = sigInternal$xscale,
                name = paste0(vp_name, "_vClip")

            )
            ## Make rotated, horizontal viewport
            vp <- viewport(
                height = page_coords$width, width = page_coords$height,
                x = unit(1, "npc"), y = unit(0, "npc"),
                just = c("left", "bottom"),
                xscale = sigInternal$xscale,
                yscale = c(signal_track$range[1], signal_track$range[2]),
                name = paste0(vp_name, "_v"),
                angle = 90
            )
            addViewport(paste0(vp_name, "_vClip"))
        }

    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS WITH BACKGROUND
    # =========================================================================

    backgroundGrob <- rectGrob(gp = gpar(
        fill = sigInternal$bg,
        col = NA
    ), name = "background")
    assign("signal_grobs", gTree(vp = vp, children = gList(backgroundGrob)),
        envir = pgEnv
    )

    # =========================================================================
    # MAKE GROBS
    # =========================================================================

    if (!is.na(signal_track$binSize)) {
        if (split == TRUE) {
            fills <- parseColors(sigInternal$fill)
            lines <- parseColors(sigInternal$linecolor)

            if (nrow(posSignal) >= 2) {
                sigGrob(
                    signal = posSignal2, fillCol = fills[[1]],
                    lineCol = lines[[1]], gp = sigInternal$gp
                )
                ## Find and make cutoff lines
                cutoffGrobs(
                    signal = posSignal2, signaltrack = signal_track,
                    side = "top"
                )
            } else {
                sigInternal$gp$col <- lines[[1]]
                posGrob <- segmentsGrob(
                    x0 = 0, y0 = unit(0, "native"),
                    x1 = 1, y1 = unit(0, "native"),
                    gp = sigInternal$gp
                )
                assign("signal_grobs",
                    addGrob(
                        gTree = get("signal_grobs", envir = pgEnv),
                        child = posGrob
                    ),
                    envir = pgEnv
                )
                warning("Not enough top signal data to plot.", call. = FALSE)
            }


            if (nrow(negSignal) >= 2) {
                sigGrob(
                    signal = negSignal2, fillCol = fills[[2]],
                    lineCol = lines[[2]], gp = sigInternal$gp
                )
                ## Find and make cutoff lines
                cutoffGrobs(
                    signal = negSignal2, signaltrack = signal_track,
                    side = "bottom"
                )
            } else {
                sigInternal$gp$col <- lines[[2]]
                negGrob <- segmentsGrob(
                    x0 = 0, y0 = unit(0, "native"),
                    x1 = 1, y1 = unit(0, "native"),
                    gp = sigInternal$gp
                )
                assign("signal_grobs",
                    addGrob(
                        gTree = get("signal_grobs", envir = pgEnv),
                        child = negGrob
                    ),
                    envir = pgEnv
                )
                warning("Not enough bottom signal data to plot.",
                    call. = FALSE
                )
            }


            lineGrob <- segmentsGrob(
                x0 = unit(0, "npc"), x1 = unit(1, "npc"),
                y0 = 0, y1 = 0,
                gp = gpar(
                    col = sigInternal$baseline.color,
                    lwd = sigInternal$baseline.lwd
                ),
                default.units = "native"
            )
            assign("signal_grobs",
                addGrob(
                    gTree = get("signal_grobs", envir = pgEnv),
                    child = lineGrob
                ),
                envir = pgEnv
            )
        } else {
            if (nrow(posSignal) >= 2) {
                if (sigInternal$baseline == TRUE) {
                    baselineGrob <- segmentsGrob(
                        x0 = unit(0, "npc"),
                        x1 = unit(1, "npc"),
                        y0 = 0, y1 = 0,
                        gp = gpar(
                            col = sigInternal$baseline.color,
                            lwd = sigInternal$baseline.lwd
                        ),
                        default.units = "native"
                    )
                    assign("signal_grobs",
                        addGrob(
                            gTree = get("signal_grobs", envir = pgEnv),
                            child = baselineGrob
                        ),
                        envir = pgEnv
                    )
                }

                sigGrob(
                    signal = posSignal2, fillCol = sigInternal$fill[1],
                    lineCol = sigInternal$linecolor[1],
                    gp = sigInternal$gp
                )
                
                ## Find and make cutoff lines
                if (top == TRUE){
                    cutoffGrobs(
                        signal = posSignal2, signaltrack = signal_track,
                        side = "top"
                    )
                } else {
                    cutoffGrobs(
                        signal = posSignal2, signaltrack = signal_track,
                        side = "bottom"
                    )
                }
                
            } else {
                sigInternal$gp$col <- sigInternal$linecolor
                
                signalGrob <- segmentsGrob(
                    x0 = 0, y0 = unit(0, "native"),
                    x1 = 1, y1 = unit(0, "native"),
                    gp = sigInternal$gp
                )
                assign("signal_grobs",
                    addGrob(
                        gTree = get("signal_grobs", envir = pgEnv),
                        child = signalGrob
                    ),
                    envir = pgEnv
                )
                warning("Not enough data within range to plot.", call. = FALSE)
            }
        }
        # =====================================================================
        # SCALE
        # =====================================================================

        ## Add scale of the range of data in the top left corner
        if (sigInternal$scale == TRUE) {
            upperLim <- round(signal_track$range[2], digits = 4)
            lowerLim <- round(signal_track$range[1], digits = 4)
            scaleGrob <- textGrob(
                label = paste0("[", lowerLim, " - ", upperLim, "]"),
                just = c("left", "top"), x = 0, y = 1,
                gp = sigInternal$gp
            )

            ## Add grob to gtree
            assign("signal_grobs",
                addGrob(
                    gTree = get("signal_grobs", envir = pgEnv),
                    child = scaleGrob
                ),
                envir = pgEnv
            )
        }
        
        # =====================================================================
        # LABEL
        # =====================================================================
        
        if (!is.null(sigInternal$label)){
            if (sigInternal$scale == TRUE){
                labelGrob <- textGrob(
                    label = sigInternal$label,
                    just = c("right", "top"), x = 1, y = 1,
                    gp = sigInternal$gp
                )
            } else {
                labelGrob <- textGrob(
                    label = sigInternal$label,
                    just = c("left", "top"), x = 0, y = 1,
                    gp = sigInternal$gp
                )
            }
            
            ## Add grob to gtree
            assign("signal_grobs",
                   addGrob(
                       gTree = get("signal_grobs", envir = pgEnv),
                       child = labelGrob
                   ),
                   envir = pgEnv
            )
    
        }
        
    }

    # =========================================================================
    # IF PLOT == TRUE, DRAW GROBS
    # =========================================================================

    if (sigInternal$draw == TRUE) {

        if (sigInternal$orientation == "v"){
            pushViewport(vpClip)
            grid.draw(get("signal_grobs", envir = pgEnv))
            upViewport()
        } else if (sigInternal$orientation == "h"){
            grid.draw(get("signal_grobs", envir = pgEnv))
        }

    }

    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    signal_track$grobs <- get("signal_grobs", envir = pgEnv)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("signal[", vp$name, "]")
    invisible(signal_track)
}

#' Draw a line segment within a plotgardener layout
#' 
#' @usage plotSegments(
#'     x0,
#'     y0,
#'     x1,
#'     y1,
#'     default.units = "inches",
#'     linecolor = "black",
#'     lwd = 1,
#'     lty = 1,
#'     lineend = "butt",
#'     linejoin = "mitre",
#'     arrow = NULL,
#'     params = NULL,
#'     ...
#' )
#'
#' @param x0 A numeric vector or unit object indicating the
#' starting x-values of the line segments.
#' @param y0 A numeric vector, unit object, or a character vector
#' of values containing a "b" combined with a numeric value specifying
#' starting y-values of the line segments.
#' The character vector will place starting y-values relative to the
#' bottom of the most recently plotted plot according to the
#' units of the plotgardener page.
#' @param x1 A numeric vector or unit object indicating the stopping
#' x-values of the line segments.
#' @param y1 A numeric vector, unit object, or a character vector of v
#' alues containing a "b" combined with a numeric value specifying
#' stopping y-values of the line segments.
#' The character vector will place stopping y-values relative to the
#' bottom of the most recently plotted plot according to the
#' units of the plotgardener page.
#' @param default.units A string indicating the default units to use
#' if \code{x0}, \code{y0}, \code{x1}, or \code{y1} are only given as
#' numeric vectors. Default value is \code{default.units = "inches"}.
#' @param linecolor A character value specifying segment line color.
#' Default value is \code{linecolor = "black"}.
#' @param lwd A numeric specifying segment line width.
#' Default value is \code{lwd = 1}.
#' @param lty A numeric specifying segment line type.
#' Default value is \code{lty = 1}.
#' @param lineend A character value specifying line end style.
#' Default value is \code{lineend = "butt"}. Options are:
#' \itemize{
#' \item{\code{"round"}: Segment ends are rounded.}
#' \item{\code{"butt"}: Segment ends end exactly where ended.}
#' \item{\code{"square"}: Segment ends are squared.}
#' }
#' @param linejoin A character value specifying line join style.
#' Default value is \code{linejoin = "mitre"}. Options are:
#' \itemize{
#' \item{\code{"round"}: }{Line joins are rounded.}
#' \item{\code{"mitre"}: }{Line joins are sharp corners.}
#' \item{\code{"bevel"}: }{Line joins are flattened corners.}
#' }
#' @param arrow A list describing arrow heads to place at either end of
#' the line segments, as produced by the \link[grid]{arrow} function.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{segments} object containing relevant
#' placement and \link[grid]{grob} information.
#'
#' @examples
#' library(grid)
#' ## Create a page
#' pageCreate(width = 7.5, height = 6, default.units = "inches")
#'
#' ## Plot one line segment
#' plotSegments(
#'     x0 = 3.75, y0 = 0.25, x1 = 3.75, y1 = 5.75,
#'     default.units = "inches",
#'     lwd = 3, lty = 2
#' )
#'
#' ## Plot multiple line segments at different locations in different colors
#' plotSegments(
#'     x0 = 0.5, y0 = c(1, 3, 5), x1 = 3.25, y1 = c(1, 3, 5),
#'     default.units = "inches",
#'     lwd = 2, linecolor = c("#7ecdbb", "#37a7db", "grey")
#' )
#'
#' ## Plot a line segment with an arrowhead
#' plotSegments(
#'     x0 = 4.5, y0 = 0.5, x1 = 7, y1 = 3,
#'     default.units = "inches",
#'     arrow = arrow(type = "closed"), fill = "black"
#' )
#'
#' ## Plot lines with round lineends
#' plotSegments(
#'     x0 = c(4, 7), y0 = 3.5, x1 = 5.5, y1 = 4.5,
#'     default.units = "inches",
#'     lwd = 5, lineend = "round"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @seealso \link[grid]{grid.segments}, \link[grid]{arrow}
#'
#' @export
plotSegments <- function(x0, y0, x1, y1, default.units = "inches",
                            linecolor = "black", lwd = 1, lty = 1,
                            lineend = "butt", linejoin = "mitre",
                            arrow = NULL, params = NULL, ...) {


    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    segmentsInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "segmentsInternal"
    )

    ## Set gp
    segmentsInternal$gp <- gpar(
        col = segmentsInternal$linecolor,
        lwd = segmentsInternal$lwd,
        lty = segmentsInternal$lty,
        lineend = segmentsInternal$lineend,
        linejoin = segmentsInternal$linejoin
    )
    segmentsInternal$gp <- setGP(
        gpList = segmentsInternal$gp,
        params = segmentsInternal, ...
    )

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    segments <- structure(list(
        x0 = segmentsInternal$x0,
        y0 = segmentsInternal$y0,
        x1 = segmentsInternal$x1,
        y1 = segmentsInternal$y1,
        arrow = segmentsInternal$arrow,
        grobs = NULL,
        gp = segmentsInternal$gp
    ),
    class = "segmentsInternal"
    )

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_page(error = "Cannot plot segment without a plotgardener page.")
    if (is.null(segments$x0)) stop("argument \"x0\" is missing, ",
                                    "with no default.", call. = FALSE)
    if (is.null(segments$y0)) stop("argument \"y0\" is missing, ",
                                    "with no default.", call. = FALSE)
    if (is.null(segments$x1)) stop("argument \"x1\" is missing, ",
                                    "with no default.", call. = FALSE)
    if (is.null(segments$y1)) stop("argument \"y1\" is missing, ",
                                    "with no default.", call. = FALSE)

    # =========================================================================
    # DEFINE PARAMETERS
    # =========================================================================

    ## Get page_height and its units from pgEnv
    page_height <- get("page_height", envir = pgEnv)
    page_units <- get("page_units", envir = pgEnv)
    
    
    segments$x0 <- misc_defaultUnits(
        value = segments$x0,
        name = "x0",
        default.units = segmentsInternal$default.units
    )
    
    segments$y0 <- misc_defaultUnits(
        value = segments$y0,
        name = "y0",
        default.units = segmentsInternal$default.units
    )
    
    segments$x1 <- misc_defaultUnits(
        value = segments$x1,
        name = "x1",
        default.units = segmentsInternal$default.units
    )

    segments$y1 <- misc_defaultUnits(
        value = segments$y1,
        name = "y1",
        default.units = segmentsInternal$default.units
    )

    ## Convert coordinates to page_units
    new_x0 <- convertX(segments$x0, unitTo = page_units, valueOnly = TRUE)
    new_y0 <- convertY(segments$y0, unitTo = page_units, valueOnly = TRUE)
    new_x1 <- convertX(segments$x1, unitTo = page_units, valueOnly = TRUE)
    new_y1 <- convertY(segments$y1, unitTo = page_units, valueOnly = TRUE)

    # =========================================================================
    # MAKE GROB
    # =========================================================================
    name <- paste0(
        "segments",
        length(grep(
            pattern = "segments",
            x = grid.ls(
                print = FALSE,
                recursive = FALSE
            )
        )) + 1
    )
    segments <- grid.segments(
        x0 = unit(new_x0, page_units),
        y0 = unit(page_height - new_y0, page_units),
        x1 = unit(new_x1, page_units),
        y1 = unit(page_height - new_y1, page_units),
        arrow = segments$arrow,
        gp = segments$gp,
        name = name
    )

    # =========================================================================
    # ADD GROB TO OBJECT
    # =========================================================================

    segments$grobs <- segments

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("segments[", segments$name, "]")
    invisible(segments)
}

#' Reshow guides drawn with \code{pageCreate},
#' \code{pageGuideHorizontal}, and \code{pageGuideVertical}
#'
#' @seealso \link[plotgardener]{pageCreate},
#' \link[plotgardener]{pageGuideHorizontal},
#' \link[plotgardener]{pageGuideVertical}
#'
#' @return None.
#'
#' @examples
#' ## Load Hi-C data
#' library(plotgardenerData)
#' data("IMR90_HiC_10kb")
#'
#' ## Create a page
#' pageCreate(width = 3, height = 3, default.units = "inches")
#'
#' ## Add a page guide
#' pageGuideHorizontal(y = 0.5, default.units = "inches")
#'
#' ## Plot and place Hi-C plot
#' hicPlot <- plotHicSquare(
#'     data = IMR90_HiC_10kb, resolution = 10000,
#'     zrange = c(0, 70),
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     x = 0.5, y = 0.5, width = 2, height = 2,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#'
#' ## Re-show page guides
#' pageGuideShow()
#'
#' ## Annotate genome label
#' annoGenomeLabel(
#'     plot = hicPlot, scale = "Mb", axis = "x",
#'     x = 0.5, y = 2.53, just = c("left", "top")
#' )
#' @export
pageGuideShow <- function() {
    if (length(get("guide_grobs", envir = pgEnv)$children) == 0) {
        stop("No `plotgardener` page guides were previously drawn.")
    }

    add_guideGrobs <- function(child) {
        grid.add("guide_grobs", child = child, redraw = FALSE)
    }

    ## get the guide grobs
    grobList <- get("guide_grobs", envir = pgEnv)$children

    ## Get the last grob
    last_grob <- grobList[length(grobList)][[1]]

    ## Remove the last grob from the list of grobs
    grobList <- grobList[-length(grobList)]

    ## Re-add grobs to guide_grobs gTree without re-drawing
    invisible(lapply(grobList, add_guideGrobs))

    ## Re-add last grob, this time redrawing
    grid.add("guide_grobs", child = last_grob)
}

#' Plot gene transcripts in a pileup style for a single chromosome
#' 
#' @usage plotTranscripts(
#'     chrom,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     assembly = "hg38",
#'     fill = c("#669fd9", "#abcc8e"),
#'     colorbyStrand = TRUE,
#'     strandSplit = FALSE,
#'     boxHeight = unit(2, "mm"),
#'     spaceWidth = 0.02,
#'     spaceHeight = 0.3,
#'     limitLabel = TRUE,
#'     transcriptHighlights = NULL,
#'     transcriptFilter = NULL,
#'     fontsize = 8,
#'     labels = "transcript",
#'     stroke = 0.1,
#'     bg = NA,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL
#' )
#'
#' @param chrom Chromosome of region to be plotted, as a string.
#' @param chromstart Integer start position on chromosome to be plotted.
#' @param chromend Integer end position on chromosome to be plotted.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param fill Character value(s) as a single value or vector
#' specifying fill colors of transcripts.
#' Default value is \code{fill = c("#669fd9", "#abcc8e")}.
#' @param colorbyStrand A logical value indicating whether to
#' color plus and minus strands by the first two colors in
#' a \code{fill} vector, where plus strand transcripts will be
#' colored by the first \code{fill} color and
#' minus strand transcripts will be colored by the second \code{fill}
#' color. Default value is \code{colorbyStrand = TRUE}.
#' @param strandSplit A logical value indicating whether plus and
#' minus-stranded transcripts should be separated, with plus strand
#' transcripts plotted above the x-axis and minus strand transcripts
#' plotted below the x-axis. Default value is \code{strandSplit = FALSE}.
#' @param boxHeight A numeric or unit object specifying height of transcripts.
#' Default value is \code{boxHeight = unit(2, "mm")}.
#' @param spaceWidth A numeric value specifying the width of minimum spacing
#' between transcripts, as a fraction of the plot's genomic range.
#' Default value is \code{spaceWidth = 0.02}.
#' @param spaceHeight A numeric value specifying the height of spacing
#' between transcripts on different rows, as a fraction of \code{boxHeight}.
#' Default value is \code{spaceHeight = 0.3}.
#' @param limitLabel A logical value indicating whether to draw a "+"
#' when not all elements can be plotted in the plotting space. Default 
#' value is \code{limitLabel = TRUE}.
#' @param transcriptHighlights A two-column dataframe with a column named
#' "transcript" or "gene" containing transcript names or their associated gene 
#' names as strings to highlight and a column named "color" containing 
#' corresponding highlight colors.
#' @param transcriptFilter A character vector of the names of transcripts to 
#' display (default is \code{NULL}, no filtering)
#' @param fontsize A numeric specifying text fontsize in points.
#' Default value is \code{fontsize = 8}.
#' @param labels A character value describing the format of
#' transcript text labels. Default value is \code{labels = "trancript"}.
#' Options are:
#' \itemize{
#' \item{\code{NULL}: }{No labels.}
#' \item{\code{"transcript"}: }{Transcript name labels.}
#' \item{\code{"gene"}: }{Gene name labels.}
#' \item{\code{"both"}: }{Combined transcript and gene name labels with
#' the format "gene name:transcript name".}
#' }
#' @param stroke A numeric value indicating the stroke width for
#' transcript body outlines. Default value is \code{stroke = 0.1}.
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param x A numeric or unit object specifying transcript plot x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying transcript plot y-location.
#' The character value will
#' place the transcript plot y relative to the bottom of the most recently
#' plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying transcript plot width.
#' @param height A numeric or unit object specifying transcript plot height.
#' @param just Justification of transcript plot relative to
#' its (x, y) location. If there are two values, the first value specifies
#' horizontal justification and the second value specifies vertical
#' justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use if
#' \code{x}, \code{y}, \code{width}, or \code{height} are only given as
#' numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output should be
#' produced. Default value is \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#'
#' @return Returns a \code{transcripts} object containing relevant
#' genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load hg19 genomic annotation packages
#' library("TxDb.Hsapiens.UCSC.hg19.knownGene")
#' library("org.Hs.eg.db")
#'
#' ## Create page
#' pageCreate(width = 7.5, height = 3.5, default.units = "inches")
#'
#' ## Plot and place transcripts
#' plotTranscripts(
#'     chrom = "chr8", chromstart = 1000000, chromend = 2000000,
#'     assembly = "hg19", labels = "gene",
#'     x = 0.5, y = 0.5, width = 6.5, height = 2.5,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Plot genome label
#' plotGenomeLabel(
#'     chrom = "chr8", chromstart = 1000000, chromend = 2000000,
#'     assembly = "hg19",
#'     x = 0.5, y = 3.03, length = 6.5, default.units = "inches"
#' )
#'
#' ## Plot a legend
#' plotLegend(
#'     legend = c("+ strand", "- strand"),
#'     fill = c("#669fd9", "#abcc8e"), border = FALSE,
#'     x = 0.5, y = 1, width = 1, height = 0.5,
#'     just = c("left", "top")
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @details
#' A transcripts plot can be placed on a plotgardener coordinate page
#' by providing plot placement parameters:
#' \preformatted{
#' plotTranscripts(chrom, chromstart = NULL, chromend = NULL,
#'                 x, y, width, height, just = c("left", "top"),
#'                 default.units = "inches")
#' }
#' This function can also be used to quickly plot an unannotated
#' transcripts plot by ignoring plot placement parameters:
#' \preformatted{
#' plotTranscripts(chrom, chromstart = NULL, chromend = NULL)
#' }
#'
#' Genomic annotation information is acquired through
#' \link[GenomicFeatures]{TxDb} and \link[AnnotationDbi]{OrgDb-class} packages,
#' as determined through the \code{assembly} parameter.
#'
#' @seealso \link[plotgardener]{assembly},
#' \link[plotgardener]{genomes}, \link[plotgardener]{defaultPackages}
#'
#' @export
plotTranscripts <- function(chrom, chromstart = NULL, chromend = NULL,
                            assembly = "hg38",
                            fill = c("#669fd9", "#abcc8e"),
                            colorbyStrand = TRUE, strandSplit = FALSE,
                            boxHeight = unit(2, "mm"), spaceWidth = 0.02,
                            spaceHeight = 0.3, limitLabel = TRUE,
                            transcriptHighlights = NULL,
                            transcriptFilter = NULL,
                            fontsize = 8,
                            labels = "transcript", stroke = 0.1, bg = NA,
                            x = NULL, y = NULL, width = NULL,
                            height = NULL, just = c("left", "top"),
                            default.units = "inches", draw = TRUE,
                            params = NULL) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that checks errors for plotTranscripts
    errorcheck_plotTranscripts <- function(transcriptPlot, labels, fill) {

        ## Genomic region
        regionErrors(chromstart = transcriptPlot$chromstart,
                    chromend = transcriptPlot$chromend)

        if (!is.null(labels)){
            if (!labels %in% c("transcript", "gene", "both")) {
                stop("Invalid \'labels\' input. Options are \'NULL\', ",
                     "\'transcript\', \'gene\', or \'both\'.", call. = FALSE)
            }
        }
        
        checkColorby(fill = fill,
                        colorby = FALSE)
    }

    ## Define a function that parses the yscale based on split strands
    strand_scale <- function(strandSplit, height) {
        if (strandSplit == TRUE) {
            yscale <- c(-height / 2, height / 2)
        } else {
            yscale <- c(0, height)
        }

        return(yscale)
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    transcriptsInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "transcriptsInternal"
    )
    
    ## Justification
    transcriptsInternal$just <- 
        justConversion(just = transcriptsInternal$just)

    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    transcripts <- structure(list(
        chrom = transcriptsInternal$chrom,
        chromstart = transcriptsInternal$chromstart,
        chromend = transcriptsInternal$chromend,
        assembly = transcriptsInternal$assembly,
        x = transcriptsInternal$x,
        y = transcriptsInternal$y,
        width = transcriptsInternal$width,
        height = transcriptsInternal$height,
        just = transcriptsInternal$just,
        grobs = NULL
    ), class = "transcripts")
    attr(x = transcripts, which = "plotted") <- transcriptsInternal$draw

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    if (is.null(transcripts$chrom)) {
        stop("argument \"chrom\" is missing, with no default.",
            call. = FALSE
        )
    }
    check_placement(object = transcripts)
    errorcheck_plotTranscripts(
        transcriptPlot = transcripts,
        labels = transcriptsInternal$labels,
        fill = transcriptsInternal$fill
    )

    # =========================================================================
    # PARSE ASSEMBLY
    # =========================================================================

    transcripts$assembly <-
        parseAssembly(assembly = transcripts$assembly)

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    transcripts <- defaultUnits(
        object = transcripts,
        default.units = transcriptsInternal$default.units
    )
    
    transcriptsInternal$boxHeight <- misc_defaultUnits(
        value = transcriptsInternal$boxHeight,
        name = "boxHeight",
        default.units = transcriptsInternal$default.units
    )
    
    # =========================================================================
    # GET APPROPRIATE BUILD DATA
    # =========================================================================

    buildData <- geneData(object = transcripts,
                        objectInternal = transcriptsInternal)
    transcripts <- buildData[[1]]
    transcriptsInternal <- buildData[[2]]
    data <- transcriptsInternal$data
    ## Get transcript lengths
    data$length <- data$TXEND - data$TXSTART

    ## filter down to only a select set of transcripts
    if (!is.null(transcriptsInternal$transcriptFilter)) {
        data <- data[which(data[,"TXNAME"] %in%
                     transcriptsInternal$transcriptFilter),]
    }
    
    # =========================================================================
    # COLORS AND HIGHLIGHTS
    # =========================================================================

    if (transcriptsInternal$colorbyStrand == TRUE) {
        if (length(transcriptsInternal$fill) == 1) {
            posCol <- transcriptsInternal$fill
            negCol <- transcriptsInternal$fill
        } else {
            posCol <- transcriptsInternal$fill[1]
            negCol <- transcriptsInternal$fill[2]
        }

        pos <- data[which(data$TXSTRAND == "+"), ]
        pos$color <- rep(posCol, nrow(pos))
        neg <- data[which(data$TXSTRAND == "-"), ]
        neg$color <- rep(negCol, nrow(neg))
        data <- rbind(pos, neg)
    } else {
        data$color <- rep(transcriptsInternal$fill[1], nrow(data))
    }
    
    ## Find transcripts to be highlighted
    if (!is.null(transcriptsInternal$transcriptHighlights)){
        
        # check column name of transcriptHighlights
        if (colnames(transcriptsInternal$transcriptHighlights)[1] == "transcript"){
            transcriptHighlights <- data[which(data[,"TXNAME"] %in% 
                transcriptsInternal$transcriptHighlights[,"transcript"]),]
            transcriptHighlights$color <- NULL
            transcriptBackground <- data[which(!data[,"TXNAME"] %in% 
                transcriptsInternal$transcriptHighlights[,"transcript"]),]
            # Change highlight transcripts to highlight color
            transcriptHighlights <- 
                merge(transcriptHighlights, 
                    transcriptsInternal$transcriptHighlights,
                    by.x = "TXNAME", by.y = "transcript")
            
        } else if 
        (colnames(transcriptsInternal$transcriptHighlights)[1] == "gene"){
            transcriptHighlights <- 
                data[which(data[[transcripts$assembly$display.column]] %in% 
                    transcriptsInternal$transcriptHighlights[,"gene"]),]
            transcriptHighlights$color <- NULL
            transcriptBackground <- 
                data[which(!data[[transcripts$assembly$display.column]] %in% 
                    transcriptsInternal$transcriptHighlights[,"gene"]),]
            # Change highlight transcripts to highlight color
            transcriptHighlights <- 
                merge(transcriptHighlights, 
                    transcriptsInternal$transcriptHighlights,
                    by.x = transcripts$assembly$display.column, by.y = "gene")
            
        }
        
        ## Put highlight and other transcripts back together
        data <- rbind(transcriptHighlights, transcriptBackground)
    }
    

    # =========================================================================
    # SEPARATE DATA INTO STRANDS
    # =========================================================================

    if (transcriptsInternal$strandSplit == TRUE) {
        posStrand <- data[which(data$TXSTRAND == "+"), ]
        minStrand <- data[which(data$TXSTRAND == "-"), ]
    }

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    if (is.null(transcripts$x) | is.null(transcripts$y)) {
        height <- 0.5
        yscale <- strand_scale(
            strandSplit = transcriptsInternal$strandSplit,
            height = height
        )

        vp <- viewport(
            height = unit(0.5, "snpc"), width = unit(1, "snpc"),
            x = unit(0.5, "npc"), y = unit(0.5, "npc"),
            clip = "on",
            xscale = transcriptsInternal$xscale,
            yscale = yscale,
            just = "center",
            name = "transcripts1"
        )

        if (transcriptsInternal$draw == TRUE) {
            grid.newpage()
        }
    } else {
        ## Name viewport
        currentViewports <- current_viewports()
        vp_name <- paste0(
            "transcripts",
            length(grep(
                pattern = "transcripts",
                x = currentViewports
            )) + 1
        )
        
        addViewport(vp_name)

        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = transcripts)

        height <- convertHeight(page_coords$height,
            unitTo = get("page_units",
                envir = pgEnv
            ),
            valueOnly = TRUE
        )
        yscale <- strand_scale(
            strandSplit = transcriptsInternal$strandSplit,
            height = height
        )

        ## Make viewport for gene track
        vp <- viewport(
            height = page_coords$height, width = page_coords$width,
            x = page_coords$x, y = page_coords$y,
            clip = "on",
            xscale = transcriptsInternal$xscale,
            yscale = yscale,
            just = transcriptsInternal$just,
            name = vp_name
        )
    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS WITH BACKGROUND
    # =========================================================================

    backgroundGrob <- rectGrob(gp = gpar(
        fill = transcriptsInternal$bg,
        col = NA
    ), name = "background")
    assign("transcript_grobs", gTree(vp = vp, children = gList(backgroundGrob)),
        envir = pgEnv
    )

    # =========================================================================
    # DETERMINE ROWS FOR EACH ELEMENT
    # =========================================================================

    ## Determine how many rows are going to fit based on
    ## boxHeight, spaceHeight, and fontsize
    if (is.null(transcriptsInternal$labels)) {
        textHeight <- unit(0, "npc")
    } else {
        textHeight <- heightDetails(textGrob(
            label = "A",
            gp = gpar(fontsize = transcriptsInternal$fontsize)
        ))
    }


    if (is.null(transcripts$x) & is.null(transcripts$y)) {
        pushViewport(vp)
        boxHeight <- convertHeight(transcriptsInternal$boxHeight,
            unitTo = "npc", valueOnly = TRUE
        )
        spaceHeight <- boxHeight * (transcriptsInternal$spaceHeight)
        textHeight <- convertHeight(textHeight,
            unitTo = "npc",
            valueOnly = TRUE
        )
        upViewport()
        unit <- "npc"
    } else {
        boxHeight <- convertHeight(transcriptsInternal$boxHeight,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
        spaceHeight <- boxHeight * (transcriptsInternal$spaceHeight)
        textHeight <- convertHeight(textHeight,
            unitTo = get("page_units", envir = pgEnv),
            valueOnly = TRUE
        )
        unit <- get("page_units", envir = pgEnv)
    }

    maxRows <- floor(height / (boxHeight + spaceHeight +
        textHeight + 0.25 * textHeight))
    wiggle <- abs(transcripts$chromend - transcripts$chromstart) *
        transcriptsInternal$spaceWidth

    if (transcriptsInternal$strandSplit == FALSE) {
        
        ## Get one representative row per transcript for ordering
        repData <- data[duplicated(data$TXNAME) == FALSE, ]
        
        ## Access default transcript prioritization
        repData <- defaultGenePriorities(
            data = repData,
            assembly = transcripts$assembly,
            transcript = TRUE
        )
        
        ## Assign rows
        rowData <- assignRows(data = repData[,c("TXSTART", "TXEND", "TXID")],
                            maxRows = maxRows,
                            wiggle = wiggle, 
                            rowCol = 3,
                            limitLabel = transcriptsInternal$limitLabel,
                            gTree = "transcript_grobs")
        
        ## Recombine row data with original data with all transcript details
        rowData <- suppressMessages(dplyr::left_join(
            x = data,
            y = rowData[,c("row", "TXID")],
            by = "TXID"
        ))
        
        ## Calculate y-coordinates
        rowData$y <- rowData$row * (boxHeight + spaceHeight + textHeight +
                                        0.25 * textHeight)
    } else {
        
        ## Get one rep set of data per unique transcript for ordering
        repPos <- posStrand[duplicated(posStrand$TXNAME) == FALSE, ]
        repMin <- minStrand[duplicated(minStrand$TXNAME) == FALSE, ]
        
        ## Order transcripts based on gene priorities
        repPos <- defaultGenePriorities(
            data = repPos,
            assembly = transcripts$assembly,
            geneHighlights = 
                transcriptsInternal$transcriptHighlights[,"transcript"],
            transcript = TRUE
        )
        repMin <- defaultGenePriorities(
            data = repMin,
            assembly = transcripts$assembly,
            geneHighlights = 
                transcriptsInternal$transcriptHighlights[,"transcript"],
            transcript = TRUE
        )
        
        ## Assign rows
        posData <- assignRows(data = repPos[,c("TXSTART", "TXEND", "TXID")],
                            maxRows = floor(maxRows / 2),
                            wiggle = wiggle, rowCol = 3,
                            limitLabel = transcriptsInternal$limitLabel,
                            gTree = "transcript_grobs")
        minData <- assignRows(data = repMin[,c("TXSTART", "TXEND", "TXID")],
                            maxRows = floor(maxRows / 2),
                            wiggle = wiggle, rowCol = 3,
                            limitLabel = transcriptsInternal$limitLabel,
                            gTree = "transcript_grobs",
                            side = "bottom")
        
        ## Recombine row data with original data
        posData <- suppressMessages(dplyr::left_join(
            x = posStrand,
            y = posData[,c("row", "TXID")],
            by = "TXID"
        ))
        minData <- suppressMessages(dplyr::left_join(
            x = minStrand,
            y = minData[,c("row", "TXID")],
            by = "TXID"
        ))
        
        ## Calculate y-coordinates
        posData$y <- (0.5 * spaceHeight) + posData$row *
            (boxHeight + spaceHeight + textHeight + 0.25 * textHeight)
        minData$y <- ((0.5 * spaceHeight + boxHeight + textHeight +
                        0.25 * textHeight) + minData$row *
                            (boxHeight + spaceHeight +
                                textHeight + 0.25 * textHeight)) * -1
        
        ## Combine pos and neg strand data into one 
        rowData <- rbind(posData, minData)
        
    }
    
    # =========================================================================
    # MAKE GROBS
    # =========================================================================

    if (nrow(rowData) > 0) {

        ##########################################################
        ## TRANSCRIPT LINES ONLY
        ##########################################################

        if ((transcripts$chromend - transcripts$chromstart) >= 25000000) {
            transcriptLine <- rectGrob(
                x = rowData$TXSTART,
                y = rowData$y,
                width = rowData$TXEND - rowData$TXSTART,
                height = boxHeight,
                just = c("left", "bottom"),
                gp = gpar(
                    fill = rowData$color,
                    col = rowData$color,
                    lwd = transcriptsInternal$stroke
                ),
                default.units = "native"
            )
        } else {

            ##########################################################
            ## TRANSCRIPT LINES
            ##########################################################

            transcriptLine <- rectGrob(
                x = rowData$TXSTART,
                y = rowData$y + 0.5 * boxHeight,
                width = rowData$TXEND - rowData$TXSTART,
                height = boxHeight * 0.2,
                just = "left",
                gp = gpar(
                    fill = rowData$color,
                    col = rowData$color,
                    lwd = transcriptsInternal$stroke
                ),
                default.units = "native"
            )

            ##########################################################
            ## TRANSCRIPT EXONS
            ##########################################################

            transcriptExons <- rectGrob(
                x = rowData$EXONSTART,
                y = rowData$y + 0.5 * boxHeight,
                width = rowData$EXONEND - rowData$EXONSTART,
                height = boxHeight * 0.65,
                just = "left",
                gp = gpar(fill = rowData$color, col = NA),
                default.units = "native"
            )
            assign("transcript_grobs",
                addGrob(get("transcript_grobs", envir = pgEnv),
                    child = transcriptExons
                ),
                envir = pgEnv
            )

            ##########################################################
            ## TRANSCRIPT CDS
            ##########################################################

            ## Get CDS regions that aren't NA
            cdsData <- rowData[which(!is.na(rowData$CDSSTART)), ]
            if (nrow(cdsData) > 0) {
                transcriptCds <- rectGrob(
                    x = cdsData$CDSSTART,
                    y = cdsData$y + 0.5 * boxHeight,
                    width = cdsData$CDSEND - cdsData$CDSSTART,
                    height = boxHeight,
                    just = "left",
                    gp = gpar(
                        fill = cdsData$color,
                        col = cdsData$color,
                        lwd = 1.25
                    ),
                    default.units = "native"
                )
                assign("transcript_grobs",
                    addGrob(get("transcript_grobs", envir = pgEnv),
                        child = transcriptCds
                    ),
                    envir = pgEnv
                )
            }
        }

        assign("transcript_grobs",
            addGrob(get("transcript_grobs", envir = pgEnv),
                child = transcriptLine
            ),
            envir = pgEnv
        )


        ##########################################################
        ## TRANSCRIPT NAME LABELS
        ##########################################################

        if (!is.null(transcriptsInternal$labels)) {

            ## Get representative transcript names
            transcriptNames <- rowData[duplicated(rowData$TXNAME) == FALSE, ]

            ## Add column with center location of each transcript label
            transcriptNames$labelLoc <- rowMeans(
                transcriptNames[c("TXSTART", "TXEND")]
            )

            if (transcriptsInternal$labels == "transcript") {
                label <- transcriptNames$TXNAME
            } else if (transcriptsInternal$labels == "gene") {
                label <- transcriptNames[[
                transcripts$assembly$display.column]]
            } else {
                label <- paste0(
                    transcriptNames[[
                    transcripts$assembly$display.column]],
                    ":", transcriptNames$TXNAME
                )
            }

            ## Get which names aren't cutoff
            checkedLabels <- apply(data.frame(
                "label" = label,
                "labelLoc" =
                    transcriptNames$labelLoc
            ),
            1, cutoffLabel,
            fontsize = transcriptsInternal$fontsize,
            xscale = transcriptsInternal$xscale,
            vp = vp, unit = unit
            )
            transcriptNames$label <- checkedLabels
            transcriptNames <- transcriptNames[!is.na(transcriptNames$label), ]

            if (nrow(transcriptNames) > 0) {
                transcript_names <- textGrob(
                    label = transcriptNames$label,
                    x = transcriptNames$labelLoc,
                    y = transcriptNames$y + boxHeight + textHeight * 0.25,
                    just = "bottom",
                    gp = gpar(
                        col = transcriptNames$color,
                        fontsize = transcriptsInternal$fontsize
                    ),
                    default.units = "native",
                    check.overlap = TRUE
                )

                assign("transcript_grobs",
                    addGrob(get("transcript_grobs", envir = pgEnv),
                        child = transcript_names
                    ),
                    envir = pgEnv
                )
            }
        }
    }

    # =========================================================================
    # IF PLOT == TRUE, DRAW GROBS
    # =========================================================================

    if (transcriptsInternal$draw == TRUE) {
        grid.draw(get("transcript_grobs", envir = pgEnv))
    }

    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    transcripts$grobs <- get("transcript_grobs", envir = pgEnv)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("transcripts[", vp$name, "]")
    invisible(transcripts)
}

#' Annotate pixels in a Hi-C plot
#' 
#' @usage annoPixels(
#'     plot,
#'     data,
#'     type = "box",
#'     half = "inherit",
#'     shift = 4,
#'     params = NULL,
#'     quiet = FALSE,
#'     ...
#' )
#'
#' @param plot Hi-C plot object from \code{plotHicSquare} or
#' \code{plotHicTriangle} on which to annotate pixels.
#' @param data A string specifying the BEDPE file path, a dataframe in BEDPE
#' format specifying pixel positions, or a
#' \link[InteractionSet]{GInteractions} object specifying pixel
#' positions.
#' @param type Character value specifying type of annotation.
#' Default value is \code{type = "box"}. Options are:
#' \itemize{
#' \item{\code{"box"}: }{Boxes are drawn around each pixel.}
#' \item{\code{"circle"}: }{Circles are drawn around each pixel.}
#' \item{\code{"arrow"}: }{Arrows are drawn pointing to each pixel.}
#' }
#' @param half Character value specifying which half of hic plots
#' to annotate. Triangle Hi-C plots will always default to the entirety of
#' the triangular plot. Default value is \code{half = "inherit"}. Options are:
#' \itemize{
#' \item{\code{"inherit"}: }{Pixels will be annotated on the \code{half}
#' inherited by the input Hi-C plot.}
#' \item{\code{"both"}: }{Pixels will be annotated on both halves of the
#' diagonal of a square Hi-C plot.}
#' \item{\code{"top"}: }{Pixels will be annotated on the upper diagonal
#' half of a square Hi-C plot.}
#' \item{\code{"bottom"}: }{Pixels will be annotated on the bottom diagonal
#' half of a square Hi-C plot.}
#' }
#' @param shift Numeric specifying the number of pixels on either end of
#' main pixel in a box or circle. Numeric specifying number of pixels
#' for the length of an arrow.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#' @param quiet A logical indicating whether or not to print messages.
#'
#' @return Returns a \code{pixel} object containing relevant
#' genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load Hi-C data and BEDPE data
#' library(plotgardenerData)
#' data("IMR90_HiC_10kb")
#' data("IMR90_DNAloops_pairs")
#'
#' ## Create page
#' pageCreate(width = 4.5, height = 4, default.units = "inches")
#'
#' ## Plot and place a square Hi-C plot
#' hicPlot <- plotHicSquare(
#'     data = IMR90_HiC_10kb, resolution = 10000,
#'     zrange = c(0, 70),
#'     chrom = "chr21",
#'     chromstart = 28000000, chromend = 30300000,
#'     assembly = "hg19",
#'     x = 0.5, y = 0.5, width = 3, height = 3,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Annotate loops of both sides of Hi-C plot with squares
#' pixels <- annoPixels(
#'     plot = hicPlot, data = IMR90_DNAloops_pairs, type = "box",
#'     half = "both"
#' )
#'
#' ## Annotate loops on one side of Hi-C plot with arrows
#' ## and the other side with circles
#' pagePlotRemove(plot = pixels)
#' pixels1 <- annoPixels(
#'     plot = hicPlot, data = IMR90_DNAloops_pairs,
#'     type = "arrow", half = "top", shift = 8
#' )
#' pixels2 <- annoPixels(
#'     plot = hicPlot, data = IMR90_DNAloops_pairs,
#'     type = "circle", half = "bottom"
#' )
#'
#' ## Annotate heatmap legend
#' annoHeatmapLegend(
#'     plot = hicPlot,
#'     x = 3.6, y = 0.5, width = 0.12, height = 1.2,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Annotate genome label
#' annoGenomeLabel(
#'     plot = hicPlot, x = 0.5, y = 3.53, scale = "Mb",
#'     just = c("left", "top")
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
annoPixels <- function(plot, data, type = "box", half = "inherit",
                        shift = 4, params = NULL, quiet = FALSE, ...) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================
    ## Define a function to catch errors for annoPixels
    errorcheck_annoLoops <- function(hic, loops, half, type, quiet) {

        ###### hic #####

        ## check type of input for hic
        if (!class(hic) %in% c(
            "hicSquare", "hicTriangle",
            "hicRectangle"
        )) {
            stop("Input plot must be a plot of class \'hicSquare\', ",
                "\'hicTriangle\', or \'hicRectangle\'.", call. = FALSE)
        }

        ###### loops #####

        ## if data.frame/data.table needs to be properly formatted
        if ("data.frame" %in% class(loops) && ncol(loops) < 6) {
            stop("Invalid dataframe format. ",
                "Dataframe must be in BEDPE format.", call. = FALSE)
        }

        if ("data.frame" %in% class(loops) && nrow(loops) < 1) {
            stop("\'data\' input contains no values.", call. = FALSE)
        }


        ## if it's a file path, it needs to exist
        if (!"data.frame" %in% class(loops)) {
            if (!is(loops, "GInteractions")) {
                ## File existence
                if (!file.exists(loops)) {
                    stop("File", loops, "does not exist.", call. = FALSE)
                }
            }
        }

        ###### half #####

        ## half needs to be a valid option
        if (!half %in% c("inherit", "both", "top", "bottom")) {
            stop("Invalid \'half\'.  Options are \'inherit\',
                \'both\', \'top\', or \'bottom\'.", call. = FALSE)
        }

        ## half needs to be able to align with what kind of hic plot is plotted
        if (is(hic, "hicSquare")) {
            if (hic$chrom == hic$altchrom) {
                if ((hic$half == "top" | hic$half == "bottom") &&
                    (half == "both")) {
                    stop("Invalid \'half\' of plot to annotate.",
                        call. = FALSE
                    )
                }

                if (hic$half == "top" & half == "bottom") {
                    stop("Invalid \'half\' of plot to annotate.",
                        call. = FALSE
                    )
                }

                if (hic$half == "bottom" & half == "top") {
                    stop("Invalid \'half\' of plot to annotate.",
                        call. = FALSE
                    )
                }
            } else {
                if (hic$half == "bottom") {
                    if (!quiet) {
                        message("Attempting to annotate pixels where",
                            hic$chrom, "is on the x-axis and",
                            hic$altchrom, "is on the y-axis.",
                            call. = FALSE
                        )
                    }
                } else if (hic$half == "top") {
                    if (!quiet) {
                        message("Attempting to annotate pixels where",
                            hic$altchrom, "is on the x-axis and",
                            hic$chrom, "is on the y-axis.",
                            call. = FALSE
                        )
                    }
                }
            }
        } else if (is(hic, "hicTriangle") |
            is(hic, "hicRectangle")) {
            if (half == "both" | half == "bottom") {
                warning("Plot of class \'",
                    class(hic),
                    "\' detected. Pixels will automatically be annotated ",
                    "in the upper triangular of the plot.",
                    call. = FALSE
                )
            }
        }

        ###### annotation #####

        ## Check type of annotation
        if (!type %in% c("box", "circle", "arrow")) {
            stop("Invalid \'type\' of annotation.  Options are \'box\', ",
                "\'circle\', or \'arrow\'.", call. = FALSE)
        }
    }

    ## Define a function that subsets loop data for hic region
    subset_loops <- function(hic, loopData, object, plotObject) {

        ## chrom always in col1
        ## altchrom always in col4
        ## triangle hic plots will not have altchrom parameters
        if (is(hic, "hicTriangle")) {
            loops_subset <- loopData[which(
                loopData[, "chrom1"] == object$chrom &
                loopData[, "chrom2"] == object$chrom &
                loopData[, "start1"] >= object$chromstart &
                loopData[, "end1"] <= object$chromend &
                loopData[, "start2"] >= object$chromstart &
                loopData[, "end2"] <= object$chromend), ]
        } else if (is(hic, "hicRectangle")){
            loops_subset <- loopData[which(
                loopData[, "chrom1"] == object$chrom &
                    loopData[, "chrom2"] == object$chrom &
                    loopData[, "start1"] >= plotObject$chromstartAdjusted &
                    loopData[, "end1"] <= plotObject$chromendAdjusted &
                    loopData[, "start2"] >= plotObject$chromstartAdjusted &
                    loopData[, "end2"] <= plotObject$chromendAdjusted), ]
        } else {
            loops_subset <- loopData[which(
                loopData[, "chrom1"] == object$chrom &
                loopData[, "chrom2"] == object$altchrom &
                loopData[, "start1"] >= object$chromstart &
                loopData[, "end1"] <= object$chromend &
                loopData[, "start2"] >= object$altchromstart &
                loopData[, "end2"] <= object$altchromend), ]
        }

        return(loops_subset)
    }

    ## Define a function to add box annotation
    boxAnnotation <- function(df, hic, object, shift, half) {
        side <- (utils::type.convert(df["end2"], as.is = TRUE) - 
                    utils::type.convert(df["start2"], as.is = TRUE)) +
            (2 * shift * hic$resolution)

        if (half == "bottom") {
            center_x <- 0.5 * (utils::type.convert(df["start2"], 
                                        as.is = TRUE) + 
                        utils::type.convert(df["end2"], 
                                        as.is = TRUE))
            center_y <- 0.5 * (utils::type.convert(df["start1"], 
                                        as.is = TRUE) + 
                        utils::type.convert(df["end1"], 
                                        as.is = TRUE))
            rect1 <- rectGrob(
                x = center_x, y = center_y, width = side,
                height = side, default.units = "native",
                gp = object$gp
            )

            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = rect1
                ),
                envir = pgEnv
            )
        } else if (half == "top") {
            center_x <- 0.5 * (utils::type.convert(df["start1"], as.is = TRUE) 
                            + utils::type.convert(df["end1"], as.is = TRUE))
            center_y <- 0.5 * (utils::type.convert(df["start2"], as.is = TRUE) 
                            + utils::type.convert(df["end2"], as.is = TRUE))
            rect1 <- rectGrob(
                x = center_x, y = center_y, width = side,
                height = side, default.units = "native",
                gp = object$gp
            )

            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = rect1
                ),
                envir = pgEnv
            )
        } else if (half == "both") {

            ## BOTTOM
            center_x1 <- 0.5 * (utils::type.convert(df["start2"], as.is = TRUE) 
                                + utils::type.convert(df["end2"], as.is = TRUE))
            center_y1 <- 0.5 * (utils::type.convert(df["start1"], as.is = TRUE) 
                                + utils::type.convert(df["end1"], as.is = TRUE))

            ## TOP
            center_x2 <- 0.5 * (utils::type.convert(df["start1"], as.is = TRUE) 
                                + utils::type.convert(df["end1"], as.is = TRUE))
            center_y2 <- 0.5 * (utils::type.convert(df["start2"], as.is = TRUE) 
                                + utils::type.convert(df["end2"], as.is = TRUE))

            rect1 <- rectGrob(
                x = center_x1, y = center_y1, width = side,
                height = side, default.units = "native",
                gp = object$gp
            )
            rect2 <- rectGrob(
                x = center_x2, y = center_y2, width = side,
                height = side, default.units = "native",
                gp = object$gp
            )

            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = rect1
                ),
                envir = pgEnv
            )
            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = rect2
                ),
                envir = pgEnv
            )
        }
    }

    ## Define a function to add circle annotation
    circleAnnotation <- function(df, hic, object, shift, half) {
        radius <- (0.5 * (utils::type.convert(df["end2"], as.is = TRUE) - 
                        utils::type.convert(df["start2"], 
                                as.is = TRUE))) +
            (shift * hic$resolution)

        if (half == "bottom") {
            center_x <- 0.5 * (utils::type.convert(df["start2"], as.is = TRUE)
                            + utils::type.convert(df["end2"], as.is = TRUE))
            center_y <- 0.5 * (utils::type.convert(df["start1"], as.is = TRUE) 
                            + utils::type.convert(df["end1"], as.is = TRUE))
            circ1 <- circleGrob(
                x = center_x, y = center_y,
                r = radius, default.units = "native",
                gp = object$gp
            )

            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = circ1
                ),
                envir = pgEnv
            )
        } else if (half == "top") {
            center_x <- 0.5 * (utils::type.convert(df["start1"], as.is = TRUE) 
                            + utils::type.convert(df["end1"], as.is = TRUE))
            center_y <- 0.5 * (utils::type.convert(df["start2"], as.is = TRUE) 
                            + utils::type.convert(df["end2"], as.is = TRUE))
            circ1 <- circleGrob(
                x = center_x, y = center_y,
                r = radius, default.units = "native",
                gp = object$gp
            )

            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = circ1
                ),
                envir = pgEnv
            )
        } else if (half == "both") {

            ## BOTTOM
            center_x1 <- 0.5 * (utils::type.convert(df["start2"], 
                                                    as.is = TRUE) + 
                            utils::type.convert(df["end2"], 
                                            as.is = TRUE))
            center_y1 <- 0.5 * (utils::type.convert(df["start1"], 
                                                    as.is = TRUE) + 
                            utils::type.convert(df["end1"], 
                                            as.is = TRUE))

            ## TOP
            center_x2 <- 0.5 * (utils::type.convert(df["start1"], as.is = TRUE) 
                                + utils::type.convert(df["end1"], as.is = TRUE))
            center_y2 <- 0.5 * (utils::type.convert(df["start2"], as.is = TRUE) 
                                + utils::type.convert(df["end2"], as.is = TRUE))

            circ1 <- circleGrob(
                x = center_x1, y = center_y1,
                r = radius, default.units = "native",
                gp = object$gp
            )
            circ2 <- circleGrob(
                x = center_x2, y = center_y2,
                r = radius, default.units = "native",
                gp = object$gp
            )

            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = circ1
                ),
                envir = pgEnv
            )
            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = circ2
                ),
                envir = pgEnv
            )
        }
    }

    ## Define a function to add arrow annotation
    arrowAnnotation <- function(df, hic, object, shift, half) {
        if (half == "bottom") {
            x0 <- utils::type.convert(df["end2"], as.is = TRUE) + 
                (0.5 * (utils::type.convert(df["end2"], as.is = TRUE) -
                utils::type.convert(df["start2"], as.is = TRUE)))
            y0 <- utils::type.convert(df["start1"], as.is = TRUE) - 
                (0.5 * (utils::type.convert(df["end2"], as.is = TRUE) -
                utils::type.convert(df["start2"], as.is = TRUE)))

            arrow1 <- segmentsGrob(
                x0 = x0, y0 = y0,
                x1 = x0 + (shift * hic$resolution),
                y1 = y0 - (shift * hic$resolution),
                arrow = arrow(
                    length = unit(0.1, "inches"),
                    ends = "first",
                    type = "closed"
                ),
                default.units = "native",
                gp = object$gp
            )

            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = arrow1
                ),
                envir = pgEnv
            )
        } else if (half == "top") {
            x0 <- utils::type.convert(df["start1"], as.is = TRUE) - 
                (0.5 * (utils::type.convert(df["end2"], as.is = TRUE) -
                utils::type.convert(df["start2"], as.is = TRUE)))
            y0 <- utils::type.convert(df["end2"], as.is = TRUE) +
                (0.5 * (utils::type.convert(df["end2"], as.is = TRUE) -
                utils::type.convert(df["start2"], as.is = TRUE)))

            arrow1 <- segmentsGrob(
                x0 = x0, y0 = y0,
                x1 = x0 - (shift * hic$resolution),
                y1 = y0 + (shift * hic$resolution),
                arrow = arrow(
                    length = unit(0.1, "inches"),
                    ends = "first",
                    type = "closed"
                ),
                default.units = "native",
                gp = object$gp
            )

            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = arrow1
                ),
                envir = pgEnv
            )
        } else if (half == "both") {

            ## BOTTOM
            x01 <- utils::type.convert(df["end2"], as.is = TRUE) + 
                (0.5 * (utils::type.convert(df["end2"], as.is = TRUE) -
                utils::type.convert(df["start2"], as.is = TRUE)))
            y01 <- utils::type.convert(df["start1"], as.is = TRUE) - 
                (0.5 * (utils::type.convert(df["end2"], as.is = TRUE) -
                utils::type.convert(df["start2"], as.is = TRUE)))

            ## TOP
            x02 <- utils::type.convert(df["start1"], as.is = TRUE) - 
                (0.5 * (utils::type.convert(df["end2"], as.is = TRUE) -
                utils::type.convert(df["start2"], as.is = TRUE)))
            y02 <- utils::type.convert(df["end2"], as.is = TRUE) +
                (0.5 * (utils::type.convert(df["end2"], as.is = TRUE) -
                utils::type.convert(df["start2"], as.is = TRUE)))

            arrow1 <- segmentsGrob(
                x0 = x01, y0 = y01,
                x1 = x01 + (shift * hic$resolution),
                y1 = y01 - (shift * hic$resolution),
                arrow = arrow(
                    length = unit(0.1, "inches"),
                    ends = "first",
                    type = "closed"
                ),
                default.units = "native",
                gp = object$gp
            )
            arrow2 <- segmentsGrob(
                x0 = x02, y0 = y02,
                x1 = x02 - (shift * hic$resolution),
                y1 = y02 + (shift * hic$resolution),
                arrow = arrow(
                    length = unit(0.1, "inches"),
                    ends = "first",
                    type = "closed"
                ),
                default.units = "native",
                gp = object$gp
            )

            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = arrow1
                ),
                envir = pgEnv
            )
            assign("loop_grobs",
                addGrob(
                    gTree = get("loop_grobs", envir = pgEnv),
                    child = arrow2
                ),
                envir = pgEnv
            )
        }
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================
    
    loopsInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "loopsInternal"
    )

    ## Set gp
    loopsInternal$gp <- setGP(
        gpList = gpar(),
        params = loopsInternal, ...
    )

    # =========================================================================
    # INITIALIZE OBJECT: GET REGION/DIMENSIONS FROM HIC PLOT INPUT
    # =========================================================================

    loops <- structure(list(
        chrom = loopsInternal$plot$chrom,
        chromstart = loopsInternal$plot$chromstart,
        chromend = loopsInternal$plot$chromend,
        altchrom = loopsInternal$plot$altchrom,
        altchromstart = loopsInternal$plot$altchromstart,
        altchromend = loopsInternal$plot$altchromend,
        assembly = loopsInternal$plot$assembly,
        x = loopsInternal$plot$x,
        y = loopsInternal$plot$y,
        width = loopsInternal$plot$width,
        height = loopsInternal$plot$height,
        just = loopsInternal$plot$just, grobs = NULL
    ),
    class = "pixel"
    )

    # =========================================================================
    # CATCH ERRORS
    # =========================================================================

    check_page(error = "Cannot annotate Hi-C pixels without a
                `plotgardener` page.")
    if (is.null(loopsInternal$plot)) stop("argument \"plot\" is missing, ",
                                            "with no default.", call. = FALSE)
    if (is.null(loopsInternal$data)) stop("argument \"data\" is missing, ",
                                            "with no default.", call. = FALSE)

    errorcheck_annoLoops(
        hic = loopsInternal$plot,
        loops = loopsInternal$data,
        half = loopsInternal$half,
        type = loopsInternal$type,
        quiet = loopsInternal$quiet
    )

    # =========================================================================
    # PARSE INHERITED HALF
    # =========================================================================

    half <- loopsInternal$half
    if (half == "inherit") {
        half <- inherit_half(hic = loopsInternal$plot)
    }

    if (is(loopsInternal$plot, "hicTriangle")  |
        is(loopsInternal$plot, "hicRectangle")) {
        if (loopsInternal$plot$flip == TRUE){
            half <- "bottom"
        } else {
            half <- "top"
        }
        
    }

    # =========================================================================
    # READ IN FILE, DATAFRAME OR GINTERACTIONS
    # =========================================================================

    loopData <- read_pairedData(data = loopsInternal$data,
                            assembly = loops$assembly,
                            warning = TRUE)

    ## chrom format and data chrom format
    chromDataAgreement(data = loopData, chrom = loops$chrom,
                    type = "pairs")

    # =========================================================================
    # SUBSET FOR LOOPS IN REGION
    # =========================================================================
    loops_subset <- subset_loops(
        hic = loopsInternal$plot, loopData = loopData,
        object = loops, plotObject = loopsInternal$plot
    )
    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## Name viewport
    currentViewports <- current_viewports()
    vp_name <- paste0(
        "pixel",
        length(grep(
            pattern = "pixel",
            x = currentViewports
        )) + 1
    )

    ## Make viewport based on hic input viewport
    if (is(loopsInternal$plot, "hicSquare")) {
        vp <- viewport(
            height = loopsInternal$plot$grobs$vp$height,
            width = loopsInternal$plot$grobs$vp$width,
            x = loopsInternal$plot$grobs$vp$x,
            y = loopsInternal$plot$grobs$vp$y,
            clip = "on",
            xscale = loopsInternal$plot$grobs$vp$xscale,
            yscale = loopsInternal$plot$grobs$vp$yscale,
            just = loopsInternal$plot$grobs$vp$justification,
            name = vp_name
        )
    } else if (is(loopsInternal$plot, "hicTriangle")) {
        vp <- viewport(
            height = loopsInternal$plot$grobs$vp$height,
            width = loopsInternal$plot$grobs$vp$width,
            x = unit(0, "npc"),
            y =  unit(0, "npc"),
            xscale = loopsInternal$plot$grobs$vp$xscale,
            yscale = loopsInternal$plot$grobs$vp$yscale,
            just = c("left", "bottom"),
            name = vp_name,
            angle = -45
        )
        
        if (loopsInternal$plot$flip == TRUE){
            vp$y <- unit(1, "npc")

        }
        
    } else if (is(loopsInternal$plot, "hicRectangle")) {
        side <- convertUnit(loopsInternal$plot$grobs$vp$width,
            unitTo = get("page_units", pgEnv)
        )

        vp <- viewport(
            height = side, width = side,
            x = unit(loopsInternal$plot$grobs$vp$xscale[1], "native"), 
            y = unit(0, "npc"),
            xscale = loopsInternal$plot$grobs$vp$xscale,
            yscale = loopsInternal$plot$grobs$vp$yscale,
            just = c("left", "bottom"),
            name = vp_name,
            angle = -45
        )
        if (loopsInternal$plot$flip == TRUE){
            vp$y <- unit(1, "npc")
            
        }
    }

    # =========================================================================
    # INITIALIZE GTREE OF GROBS
    # =========================================================================

    assign("loop_grobs", gTree(vp = vp), envir = pgEnv)

    # =========================================================================
    # PLOT
    # =========================================================================

    if (nrow(loops_subset) > 0) {
        if (loopsInternal$type == "box") {
            loopsInternal$gp$fill <- NA
            invisible(apply(loops_subset, 1, boxAnnotation,
                hic = loopsInternal$plot, object = loopsInternal,
                shift = loopsInternal$shift, half = half
            ))
        } else if (loopsInternal$type == "circle") {
            loopsInternal$gp$fill <- NA
            invisible(apply(loops_subset, 1, circleAnnotation,
                hic = loopsInternal$plot, object = loopsInternal,
                shift = loopsInternal$shift, half = half
            ))
        } else if (loopsInternal$type == "arrow") {
            if (is.null(loopsInternal$gp$col) &
                is.null(loopsInternal$gp$fill)) {
                loopsInternal$gp$fill <- "black"
            } else {
                if (is.null(loopsInternal$gp$fill)) {
                    loopsInternal$gp$fill <- loopsInternal$gp$col
                }
            }

            invisible(apply(loops_subset, 1, arrowAnnotation,
                hic = loopsInternal$plot, object = loopsInternal,
                shift = loopsInternal$shift, half = half
            ))
        }
    } else {
        warning("No pixels found in region.", call. = FALSE)
    }


    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    loops$grobs <- get("loop_grobs", envir = pgEnv)
    
    if (is(loopsInternal$plot, "hicRectangle") | 
        is(loopsInternal$plot, "hicTriangle")){
        seekViewport(name = loopsInternal$plot$outsideVP$name)
        grid.draw(loops$grobs)
        seekViewport("page")
    } else {
        grid.draw(loops$grobs)
    }
    
    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("pixel[", vp_name, "]")
    invisible(loops)
}

#' Draw a horizontal guideline at a specified y-coordinate
#' on a plotgardener page
#' 
#' @usage pageGuideHorizontal(
#'     y,
#'     default.units = "inches",
#'     linecolor = "grey55",
#'     params = NULL,
#'     ...
#' )
#'
#' @param y A numeric or unit object specifying y-coordinate of guide.
#' @param default.units A string indicating the default units to use
#' if \code{y} is only given as a numeric.
#' Default value is \code{default.units = "inches"}.
#' @param linecolor Character value indicating color of guideline.
#' Default value is \code{linecolor = "grey55"}.
#' @param params An optional \link[plotgardener]{pgParams} object
#' containing relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @examples
#' ## Create a page
#' pageCreate(width = 6, height = 5, default.units = "inches")
#'
#' ## Add red horizontal guideline at y = 2.5 inches
#' pageGuideHorizontal(y = 2.5, linecolor = "red")
#' @return None.
#'
#' @export
pageGuideHorizontal <- function(y, default.units = "inches",
                                linecolor = "grey55", params = NULL, ...) {


    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    hguide <- parseParams(params = params, 
                            defaultArgs = formals(eval(match.call()[[1]])),
                            declaredArgs = lapply(match.call()[-1], 
                                                eval.parent, n = 2),
                            class = "hguide")

    ## Set gp
    hguide$gp <- gpar(col = hguide$linecolor)
    hguide$gp <- setGP(gpList = hguide$gp, params = hguide, ...)
    # =========================================================================
    # ERRORS
    # =========================================================================

    if (is.null(hguide$y)) {
        stop("argument \"y\" is missing, with no default.",
            call. = FALSE
        )
    }

    # =========================================================================
    # DEFAULT UNITS
    # =========================================================================

    y <- misc_defaultUnits(value = hguide$y, 
                        name = "y",
                        default.units = hguide$default.units,
                        funName = "pageGuideHorizontal",
                        yBelow = FALSE)

    # =========================================================================
    # MAKE GROB AND ASSIGN TO GTREE
    # =========================================================================

    y <- convertY(y,
        unitTo = get("page_units", envir = pgEnv),
        valueOnly = TRUE
    )

    guide <- grid.segments(
        x0 = unit(0, units = "npc"),
        x1 = unit(1, units = "npc"),
        y0 = get("page_height", envir = pgEnv) - y,
        y1 = get("page_height", envir = pgEnv) - y,
        default.units = get("page_units", envir = pgEnv),
        gp = hguide$gp
    )
    assign("guide_grobs",
        addGrob(
            gTree = get("guide_grobs", envir = pgEnv),
            child = guide
        ),
        envir = pgEnv
    )
}

#' Plot a ggplot2 plot, gtable, or grob object in a plotgardener layout
#' 
#' @usage plotGG(
#'     plot,
#'     x,
#'     y,
#'     width,
#'     height,
#'     just = c("left", "top"),
#'     default.units = "inches",
#'     params = NULL
#' )
#'
#' @param plot ggplot, gtable, or grob object.
#' @param x A numeric or unit object specifying ggplot x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying ggplot y-location.
#' The character value will
#' place the ggplot y relative to the bottom of the most recently
#' plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying ggplot width.
#' @param height A numeric or unit object specifying ggplot height.
#' @param just Justification of ggplot relative to its (x, y) location.
#' If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param default.units A string indicating the default units to use
#' if \code{x}, \code{y}, \code{width}, or \code{height} are only given
#' as numerics. Default value is \code{default.units = "inches"}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#'
#' @return Returns a \code{pg_gg} object containing
#' relevant placement and \link[grid]{grob} information.
#'
#' @seealso \link[ggplot2]{ggplot}
#'
#' @examples
#' ## Create a plot using ggplot2
#' library(ggplot2)
#' p <- ggplot(mtcars) +
#'     geom_point(aes(mpg, disp))
#'
#' ## Create a page
#' pageCreate(width = 4, height = 4, default.units = "inches")
#'
#' ## Place ggplot in page
#' plotGG(
#'     plot = p, x = 0.5, y = 0.5, width = 3, height = 3,
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Add title
#' plotText(
#'     label = "mtcars", fontsize = 14, fontface = "bold",
#'     x = 1, y = 0.35
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @export
plotGG <- function(plot, x, y, width, height, just = c("left", "top"),
                    default.units = "inches", params = NULL) {


    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    ggInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "ggInternal"
    )

    ## Justification
    ggInternal$just <- justConversion(just = ggInternal$just)
    
    # =========================================================================
    # ERRORS
    # =========================================================================

    if (is.null(ggInternal$plot)) stop("argument \"plot\" is missing, ",
                                        "with no default.", call. = FALSE)
    if (is.null(ggInternal$x)) stop("argument \"x\" is missing, ",
                                        "with no default.", call. = FALSE)
    if (is.null(ggInternal$y)) stop("argument \"y\" is missing, ",
                                        "with no default.", call. = FALSE)
    if (is.null(ggInternal$width)) stop("argument \"width\" is missing, ",
                                        "with no default.", call. = FALSE)
    if (is.null(ggInternal$height)) stop("argument \"height\" is missing, ",
                                            "with no default.", call. = FALSE)

    # =========================================================================
    # INITIALIZE PLOT OBJECT
    # =========================================================================

    ggPlot <- structure(list(
        width = ggInternal$width,
        height = ggInternal$height,
        x = ggInternal$x, y = ggInternal$y,
        just = ggInternal$just, grobs = NULL
    ),
    class = "pg_gg"
    )

    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    ggPlot <- defaultUnits(
        object = ggPlot,
        default.units = ggInternal$default.units
    )

    # =========================================================================
    # VIEWPORTS
    # =========================================================================

    ## Convert coordinates into same units as page
    page_coords <- convert_page(object = ggPlot)

    ## Name viewport
    currentViewports <- current_viewports()
    vp_name <- paste0(
        "gg",
        length(grep(
            pattern = "gg",
            x = currentViewports
        )) + 1
    )

    addViewport(vp_name)

    ## Make viewport for ggplot
    vp <- viewport(
        height = page_coords$height, width = page_coords$width,
        x = page_coords$x, y = page_coords$y,
        just = ggInternal$just, name = vp_name
    )

    # =========================================================================
    # PRINT GGPLOT
    # =========================================================================

    ggPlot$grobs <- as.grob(ggInternal$plot)
    ggPlot$grobs$vp <- vp

    grid.draw(ggPlot$grobs)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("gg[", vp_name, "]")
    invisible(ggPlot)
}

## Define a function to turn gTree child into a gPath
# @param grob grob to convert to gpath
convert_gpath <- function(grob) {

    ## Get the name of the grob
    name <- grob$name

    ## Turn it into a gPath
    gpath <- gPath(name)

    return(gpath)
}

## Define a function to make sure a page viewport exists
# @param error Error message if page doesn't exist
check_page <- function(error) {
    
    if (is.null(current.vpPath())){
        stop(error, call. = FALSE)
    } else {
        if (!grepl("page", as.character(current.vpPath()))){
            stop(error, call. = FALSE)
    }
    
    }
}

## Define a function to check dimensions/placing coordinates
# @param object Plot object with dimensions/coordinates/plotted attribute
check_placement <- function(object) {
    if (attributes(object)$plotted == TRUE) {

        ## If giving placement coordinates
        if (!is.null(object$x) | !is.null(object[["y"]])) {

            ## 1. Need both an x and y coordinate
            if (!is.null(object$x) & is.null(object[["y"]])) {
                stop("Placement detected with y value missing.", call. = FALSE)
            }

            if (!is.null(object[["y"]]) & is.null(object$x)) {
                stop("Placement detected with x value missing.", call. = FALSE)
            }

            ## 2. Need plot dimensions
            if (is.null(object$width)) {
                stop("Placement detected with plot width missing.",
                    call. = FALSE
                )
            }

            if (as.numeric(object$width) == 0) {
                stop("Plot width cannot be 0.", call. = FALSE)
            }

            if (is.null(object$height)) {
                stop("Placement detected with plot height missing.",
                    call. = FALSE
                )
            }

            if (as.numeric(object$height) == 0) {
                stop("Plot height cannot be 0.", call. = FALSE)
            }


            ## 3. Need a page
            check_page(error = paste("Must make a `plotgardener` page with",
                                    "`pageCreate()` before placing a plot."))
        }
    }
}

## Define a character vector of valid coordinate systems to work in
validUnits <- c(
    "npc", "native", "inches", "cm", "mm", "points",
    "bigpts", "picas", "dida",
    "cicero", "scaledpts", "char", "lines", "snpc"
)

## Define a function to assign rows for pileup-style data
## (plotPairs, plotRanges, plotTranscripts)
# @param data The data to assign rows to, with start in col1 and
# end in col2. This can only be numeric values.
# @param maxRows Maximum number of rows.
# @param rowCol Number of column in `data` that corresponds to
# the row column. This will depend on the number of columns included
# in `data`. This is indexed from 0 for C++ syntax.
# @param limitLabel Logical whether to plot '+' when some elements
# can't fit.
# @param side Side of a plot that rows are being assigned.
# @param gTree Name of gTree of associated fxn for adding limit grobs,
# if necessary
# @param extraData Additional data to add on to data after rows have
# been assigned. This is so non-numeric columns can be conserved.
# @param colNames A vector of column names for the extraData for
# appropriate column naming after row assignment and data combining.
assignRows <- function(data, maxRows, wiggle, rowCol, limitLabel, side = "top",
                    gTree, extraData = NULL, colNames = NULL){

    if (nrow(data) > 0){
        ## Initialize a row column
        data$row <- 0

        ## Convert to numeric matrix for Rcpp function parsing
        dataMatrix <- as.matrix(data)

        ## Assign a row for each element
        rowData <- as.data.frame(checkRow(dataMatrix, maxRows, rowCol, wiggle))

        ## Combine with extra data columns after row assignment
        if (!is.null(extraData)){
            rowData <- cbind(rowData, extraData)
            colNames <- c(colnames(data), colNames)
        } else {
            colNames <- colnames(data)
        }

        ## Update column names
        colnames(rowData) <- colNames

        ## Remove and warn if any data does not get assigned a row
        if (any(rowData$row == 0)){
            rowData <- rowData[which(rowData$row != 0), ]
            message <- "Not enough plotting space for all provided elements."

            if (limitLabel == TRUE){

                message <- paste("Not enough plotting space for all provided",
                    "elements. ('+' indicates elements not shown.)")

                if (side == "top"){
                    y <- unit(1, "npc")
                    just <- c("right", "top")
                } else{
                    y <- unit(0, "npc")
                    just <- c("right", "bottom")
                }

                limitGrob <- textGrob(
                    label = "+", x = unit(1, "npc"),
                    y = y,
                    just = just,
                    gp = gpar(col = "grey", fontsize = 6)
                )
                assign(gTree,
                        addGrob(
                            gTree = get(gTree, envir = pgEnv),
                            child = limitGrob
                        ),
                        envir = pgEnv
                )

            }


            warning(message, call. = FALSE)


        }

        ## Change row index to 0 to calculate y
        rowData$row <- rowData$row - 1
    } else {
        rowData <- data.frame()
    }

    return(rowData)
}

test_that("convert_gpath", {
    
    testGrob <- rectGrob()
    ## Grob becomes a gpath
    expect_true(is(plotgardener:::convert_gpath(testGrob), "gPath"))
})

test_that("check_placement", {
    
    testObject <- list("x" = NULL,
                       "y" = NULL)
    
    attr(testObject, "plotted") <- FALSE
    ## doesn't check if not plotted
    expect_silent(plotgardener:::check_placement(testObject))
    
    ## error one null x or y
    testObject <- list("x" = unit(3, "inches"),
                       "y" = NULL)
    
    attr(testObject, "plotted") <- TRUE
    expect_error(plotgardener:::check_placement(testObject))
    
    ## error for 0 width
    testObject <- list("x" = unit(2, "inches"),
                       "y" = unit(0.5, "npc"),
                        "width" = unit(3, "inches"),
                       "height" = unit(0, "inches"))
    
    attr(testObject, "plotted") <- TRUE
    expect_error(plotgardener:::check_placement(testObject))
    
    ## No errors with all checks
    pageCreate()
    testObject <- list("x" = unit(2, "inches"),
                       "y" = unit(0.5, "npc"),
                       "width" = unit(3, "inches"),
                       "height" = unit(3, "inches"))
    attr(testObject, "plotted") <- TRUE
    expect_silent(plotgardener:::check_placement(testObject))
    
})

test_that("assignRows", {
    library(plotgardenerData)
    data("IMR90_ChIP_CTCF_reads")
    
    ## set seed
    set.seed(nrow(IMR90_ChIP_CTCF_reads))
    
    IMR90_ChIP_CTCF_reads <- IMR90_ChIP_CTCF_reads[
        which(IMR90_ChIP_CTCF_reads[, "chrom"] == "chr21"
              & IMR90_ChIP_CTCF_reads[, "start"] <=
                  29074000 & IMR90_ChIP_CTCF_reads[, "end"] >=
                  29073000), ]
    
    ## Message without limitLabel 
    expect_warning(plotgardener:::assignRows(data = IMR90_ChIP_CTCF_reads[, c(2,3)],
                          maxRows = 3,
                          wiggle = 10,
                          rowCol = 2, 
                          limitLabel = FALSE,
                          gTree = NULL),
                   regexp = "Not enough plotting space for all provided elements.")
    
    ## Message with limitLabel
    assign("pileup_grobs", gTree(), envir = pgEnv)
    expect_warning(plotgardener:::assignRows(data = IMR90_ChIP_CTCF_reads[, c(2,3)],
                                         maxRows = 3,
                                         wiggle = 10,
                                         rowCol = 2, 
                                         limitLabel = TRUE,
                                         gTree = "pileup_grobs"))
})

#' Plot a Manhattan plot
#' 
#' @usage plotManhattan(
#'     data,
#'     sigVal = 5e-08,
#'     chrom = NULL,
#'     chromstart = NULL,
#'     chromend = NULL,
#'     assembly = "hg38",
#'     fill = "black",
#'     pch = 19,
#'     cex = 0.25,
#'     leadSNP = NULL,
#'     sigLine = FALSE,
#'     sigCol = NULL,
#'     trans = "-log10",
#'     range = NULL,
#'     yscale_reverse = FALSE,
#'     space = 0.01,
#'     bg = NA,
#'     baseline = FALSE,
#'     baseline.color = "grey",
#'     baseline.lwd = 1,
#'     x = NULL,
#'     y = NULL,
#'     width = NULL,
#'     height = NULL,
#'     just = c("left", "top"),
#'     flip = FALSE,
#'     default.units = "inches",
#'     draw = TRUE,
#'     params = NULL,
#'     ...
#' )
#'
#' @param data Data to be plotted, as a character value specifying a
#' file path of GWAS data, a dataframe, or a \link[GenomicRanges]{GRanges}
#' object. Each of these data types must have the following columns:
#' \itemize{
#' \item{\code{"chrom"}: }{Chromosome names. This column must be a character.}
#' \item{\code{"pos"}: }{Chromosomal position. This column must be
#' an integer or numeric.}
#' \item{\code{"p"}: }{p-value or similar measure. This column must be numeric.
#' Values will be converted according to the \code{trans} parameter.}
#' \item{\code{"snp"}(optional): }{SNP name or rsid.
#' This column should be a character.}
#' }
#' @param sigVal A numeric specifying the significance level of p-values.
#' Along with data p-values, this value will be converted according to the
#' \code{trans} parameter.
#' Default value is \code{sigVal = 5e-08}.
#' @param chrom Chromosome of region to be plotted, as a string.
#' If left \code{NULL}, all chromosomes found in data will be plotted.
#' @param chromstart Integer start position on chromosome to be plotted.
#' @param chromend Integer end position on chromosome to be plotted.
#' @param assembly Default genome assembly as a string or a
#' \link[plotgardener]{assembly} object.
#' Default value is \code{assembly = "hg38"}.
#' @param fill A single character value, a vector, or a 
#' \link[plotgardener]{colorby} object specifying fill colors of data points.
#' For a Manhattan plot with multiple chromosomes, a vector of colors 
#' will be used to color points of different chromosomes.
#' Default value is \code{fill = "black"}.
#' @param pch A numeric value or numeric vector specifying point symbols.
#' If \link[plotgardener]{colorby} object is supplied for \code{fill},
#' point symbols will be mapped to
#' \code{colorby} values. Default value is \code{pch = 19}.
#' @param cex A numeric indicating the amount by which points should be
#' scaled relative to the default. Default value is \code{cex = 0.25}.
#' @param leadSNP A list specifying the lead SNP in the desired region and
#' any associated aesthetic features of the lead SNP data point and text label.
#' The lead SNP should be specified as a character with the name slot
#' \code{"snp"} in the list. Accepted lead SNP aesthetic
#' features in the list include
#' \code{fill}, \code{pch}, \code{cex}, \code{fontcolor}, and \code{fontsize}.
#' @param sigLine Logical value indicating whether to draw a line at the
#' significance level indicated with \code{sigVal}.
#' Default value is \code{sigLine = FALSE}.
#' @param sigCol Single character value specifying the color of
#' significant data points.
#' @param trans Character value specifying the transformation to apply to the
#' "p" column plotted along the y-axis. For no transformation, set value to the 
#' empty character "". Default value is \code{trans = "-log10"}.
#' @param range A numeric vector of length 2 specifying the y-range
#' of p-values to plot (c(min, max)).
#' @param yscale_reverse Logical value indicating whether to reverse the y-scale
#' and order points from max to min.
#' @param space A numeric value indicating the space between each
#' chromosome as a fraction of the width of the plot, if plotting multiple
#' chromosomes. Default value is \code{space = 0.01}.
#' @param bg Character value indicating background color.
#' Default value is \code{bg = NA}.
#' @param baseline Logical value indicating whether to include a
#' baseline along the x-axis. Default value is \code{baseline = FALSE}.
#' @param baseline.color Baseline color. Default value
#' is \code{baseline.color = "grey"}.
#' @param baseline.lwd Baseline line width. Default value
#' is \code{baseline.lwd = 1}.
#' @param x A numeric or unit object specifying Manhattan plot x-location.
#' @param y A numeric, unit object, or character containing a "b"
#' combined with a numeric value specifying Manhattan plot y-location.
#' The character value will
#' place the Manhattan plot y relative to the bottom of the most
#' recently plotted plot according to the units of the plotgardener page.
#' @param width A numeric or unit object specifying Manhattan plot width.
#' @param height A numeric or unit object specifying Manhattan plot height.
#' @param just Justification of Manhattan plot relative to its (x, y)
#' location. If there are two values, the first value specifies horizontal
#' justification and the second value specifies vertical justification.
#' Possible string values are: \code{"left"}, \code{"right"},
#' \code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
#' Default value is \code{just = c("left", "top")}.
#' @param flip Logical value indicating whether to reflect Manhattan plot
#' over the x-axis. Default value is \code{flip = FALSE}.
#' @param default.units A string indicating the default units to use
#' if \code{x}, \code{y}, \code{width}, or \code{height} are only given
#' as numerics. Default value is \code{default.units = "inches"}.
#' @param draw A logical value indicating whether graphics output should
#' be produced. Default value is \code{draw = TRUE}.
#' @param params An optional \link[plotgardener]{pgParams} object containing
#' relevant function parameters.
#' @param ... Additional grid graphical parameters. See \link[grid]{gpar}.
#'
#' @return Returns a \code{manhattan} object containing
#' relevant genomic region, placement, and \link[grid]{grob} information.
#'
#' @examples
#' ## Load genomic assembly information
#' library("TxDb.Hsapiens.UCSC.hg19.knownGene")
#' ## Load GWAS data
#' library(plotgardenerData)
#' data("hg19_insulin_GWAS")
#'
#' ## Create a page
#' pageCreate(width = 7.5, height = 4.5, default.units = "inches")
#'
#' ## Plot all GWAS data
#' manhattanPlot <- plotManhattan(
#'     data = hg19_insulin_GWAS, assembly = "hg19",
#'     fill = c("grey", "#37a7db"),
#'     sigLine = TRUE,
#'     trans = "-log10",
#'     col = "grey", lty = 2, range = c(0, 14),
#'     x = 0.5, y = 0, width = 6.5, height = 2,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#' ## Annotate genome label
#' annoGenomeLabel(
#'     plot = manhattanPlot, x = 0.5, y = 2, fontsize = 8,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#' plotText(
#'     label = "Chromosome", fontsize = 8,
#'     x = 3.75, y = 2.20, just = "center", default.units = "inches"
#' )
#'
#' ## Annotate y-axis
#' annoYaxis(
#'     plot = manhattanPlot, at = c(0, 2, 4, 6, 8, 10, 12, 14),
#'     axisLine = TRUE, fontsize = 8
#' )
#'
#' ## Plot y-axis label
#' plotText(
#'     label = "-log10(p-value)", x = 0.15, y = 1, rot = 90,
#'     fontsize = 8, fontface = "bold", just = "center",
#'     default.units = "inches"
#' )
#'
#'
#' ## Plot GWAS data zooming in on chromosome 11
#' ## highlighting a lead SNP, and coloring by LD score
#' hg19_insulin_GWAS$LD <- as.numeric(hg19_insulin_GWAS$LD)
#' ## Group LD column into LD ranges
#' hg19_insulin_GWAS <- as.data.frame(dplyr::group_by(hg19_insulin_GWAS,
#'                                         LDgrp = cut(
#'                                         hg19_insulin_GWAS$LD,
#'                                         c(0, 0.2, 0.4, 0.6, 0.8, 1))))
#' hg19_insulin_GWAS$LDgrp <- addNA(hg19_insulin_GWAS$LDgrp)
#' leadSNP_p <- min(hg19_insulin_GWAS[
#'     which(hg19_insulin_GWAS$chrom == "chr11"), ]$p)
#' leadSNP <- hg19_insulin_GWAS[which(hg19_insulin_GWAS$p == leadSNP_p), ]$snp
#' chr11_manhattanPlot <- plotManhattan(
#'     data = hg19_insulin_GWAS, chrom = "chr11",
#'     chromstart = 60000000,
#'     chromend = 130000000,
#'     assembly = "hg19",
#'     fill = colorby("LDgrp",
#'     palette = colorRampPalette(c(
#'         "#1f4297",
#'         "#37a7db", "green",
#'         "orange", "red", "grey"
#'     ))),
#'     trans = "-log10",
#'     sigLine = TRUE, col = "grey",
#'     lty = 2, range = c(0, 16),
#'     leadSNP = list(
#'         snp = leadSNP,
#'         pch = 18,
#'         cex = 0.75,
#'         fill = "#7ecdbb",
#'         fontsize = 8
#'     ),
#'     x = 0.5, y = 2.5, width = 6.5,
#'     height = 1.5,
#'     just = c("left", "top"),
#'     default.units = "inches"
#' )
#'
#' ## Plot legend for LD scores
#' plotLegend(
#'     legend = c(
#'         "LD Ref Var",
#'         paste("0.4", ">", "r^2", 
#'         "", ">=", "0.2"),
#'         paste("0.2", ">", "r^2", 
#'         "", ">=", "0"),
#'         "no LD data"
#'     ),
#'     fill = c("#7ecdbb", "#37a7db", "#1f4297", "grey"), cex = 0.75,
#'     pch = c(18, 19, 19, 19), border = FALSE, x = 7, y = 2.5,
#'     width = 1.5, height = 0.6, just = c("right", "top"),
#'     default.units = "inches"
#' )
#'
#'
#' ## Annotate genome label
#' annoGenomeLabel(
#'     plot = chr11_manhattanPlot, x = 0.5, y = 4.01,
#'     fontsize = 8, scale = "Mb",
#'     just = c("left", "top"), default.units = "inches"
#' )
#'
#' ## Annotate y-axis
#' annoYaxis(
#'     plot = chr11_manhattanPlot,
#'     at = c(0, 2, 4, 6, 8, 10, 12, 14, 16),
#'     axisLine = TRUE, fontsize = 8
#' )
#'
#' ## Plot y-axis label
#' plotText(
#'     label = "-log10(p-value)", x = 0.15, y = 3.25, rot = 90,
#'     fontsize = 8, fontface = "bold", just = "center",
#'     default.units = "inches"
#' )
#'
#' ## Hide page guides
#' pageGuideHide()
#' @details
#' A Manhattan plot can be placed on a plotgardener coordinate page by
#' providing plot placement parameters:
#' \preformatted{
#' plotManhattan(data,
#'                 chrom = NULL,
#'                 chromstart = NULL, chromend = NULL,
#'                 x, y, width, height, just = c("left", "top"),
#'                 default.units = "inches")
#' }
#' This function can also be used to quickly plot an unannotated
#' Manhattan plot by ignoring plot placement parameters:
#' \preformatted{
#' plotManhattan(data,
#'                 chrom = NULL,
#'                 chromstart = NULL, chromend = NULL)
#' }
#'
#' @export
plotManhattan <- function(data, sigVal = 5e-08, chrom = NULL,
                            chromstart = NULL, chromend = NULL,
                            assembly = "hg38", fill = "black", pch = 19,
                            cex = 0.25, leadSNP = NULL,
                            sigLine = FALSE, sigCol = NULL,
                            trans = "-log10",
                            range = NULL, yscale_reverse = FALSE,
                            space = 0.01, bg = NA,
                            baseline = FALSE, baseline.color = "grey",
                            baseline.lwd = 1, x = NULL, y = NULL,
                            width = NULL, height = NULL,
                            just = c("left", "top"),
                            flip = FALSE, default.units = "inches",
                            draw = TRUE, params = NULL, ...) {

    # =========================================================================
    # FUNCTIONS
    # =========================================================================

    ## Define a function that checks for errors in plotManhattan
    errorcheck_plotManhattan <- function(bedfile, chrom, chromstart,
                                            chromend, object,
                                            leadSNP, fill) {
        ## check bedfile columns
        if (!"chrom" %in% colnames(bedfile)) {
            stop("\'chrom\' column not found in data.", call. = FALSE)
        } else {
            if (!is(bedfile$chrom, "character") & !is(bedfile$chrom, "factor")) {
                stop("\'chrom\' column must be a character or factor.", call. = FALSE)
            }
        }
        
        if (!"pos" %in% colnames(bedfile)) {
            stop("\'pos\' column not found in data.", call. = FALSE)
        } else {
            if (!is(bedfile$pos, "numeric") &
                !is(bedfile$pos, "integer")) {
                stop("\'pos\' column must be an integer or numeric.",
                    call. = FALSE
                )
            }
        }
        if (!"p" %in% colnames(bedfile)) {
            stop("\'p\' column not found in data.", call. = FALSE)
        } else {
            if (!is(bedfile$p, "numeric")) {
                stop("\'p\' column must be numeric.", call. = FALSE)
            }
        }

        ## Genomic region
        if (!is.null(chrom)) {
            
            regionErrors(chromstart = chromstart,
                        chromend = chromend)
            
        } else {
            if (!is.null(chromstart) | !is.null(chromend)) {
                warning("Plotting multiple chromosomes. \'chromstart\' ",
                        "and \'chromend\' inputs will be ignored.",
                    call. = FALSE
                )
            }
        }

        ## range
        rangeErrors(range = object$range)

        ## lead SNP
        if (!is.null(leadSNP)) {
            if (!is(leadSNP, "list")) {
                stop("\'leadSNP\' must be a list with a \'snp\' name ",
                "slot and any other aesthetic options for that SNP, ",
                "like \'fill\', \'pch\', \'cex\', \'fontcolor\', ",
                "and \'fontsize\'.", call. = FALSE)
            }

            if (!"snp" %in% names(leadSNP)) {
                stop("\'leadSNP\' must be a list with a \'snp\' name ",
                "slot and any other aesthetic options for that SNP, ",
                "like \'fill\', \'pch\', \'cex\', \'fontcolor\', ",
                "and \'fontsize\'.", call. = FALSE)
            }
        }
        
        ## Colorby
        checkColorby(fill = fill,
                        colorby = TRUE,
                        data = bedfile)
    }

    ## Define a function that parses the data into an internal format
    parse_data <- function(bedfile, fill) {

        ## Rearrange/reformat columns in case not in order
        data <- data.frame(
            "chrom" = bedfile[, "chrom"],
            "pos" = bedfile[, "pos"],
            "p" = bedfile[, "p"]
        )

        ## Parse optional 'snp' column
        if ("snp" %in% colnames(bedfile)) {
            data$snp <- bedfile[, "snp"]
        }

        ## Get colorby column if applicable
        if (is(fill, "colorby")){
            colorbyCol <- bedfile[, fill$column]
            data[[fill$column]] <- colorbyCol
        }
        
        return(data)
    }

    ## Define a function that adds offsets to the beddata based on the
    ## offsets of the genome assembly
    bed_offset <- function(bedData, offsetAssembly) {
        offsetChrom <- function(offsetChrom, bedData) {
            chromMatch <- offsetChrom["chrom"]
            offset <- as.numeric(offsetChrom["start"])
            bedMatches <- bedData[which(bedData[, "chrom"] == chromMatch), ]
            bedMatches[, "pos"] <- bedMatches[, "pos"] + offset

            return(bedMatches)
        }

        updatedBed <- apply(offsetAssembly, 1, offsetChrom, bedData = bedData)
        updatedBed <- dplyr::bind_rows(updatedBed)

        return(updatedBed)
    }

    ## Define a function that adjusts the yrange of the plot
    manhattan_range <- function(bedData, object, trans, yscale_reverse) {
        if (is.null(object$range)) {
            
            if (yscale_reverse == TRUE){
                object$range <- 
                    c(ceiling(max(unlist(lapply(parse(text = 
                                                          paste0(trans, "(",
                                                                 bedData[, "p"], 
                                                                 ")")), 
                                                eval)))), 0)
            } else {
                
                object$range <- 
                    c(0,
                      ceiling(max(unlist(lapply(parse(text = 
                                                          paste0(trans, "(",
                                                                 bedData[, "p"],
                                                                 ")")), 
                                                eval)))))
            }
            
        } else {
            if (yscale_reverse == TRUE){
                object$range <- rev(object$range)
            }
        }
        
        return(object)
    }
    
    ## Define a function that maps colors to a multi-chrom Manhattan plot
    genome_color <- function(fill, offsetAssembly, bedData){
        
        newCol <- rep(
            fill,
            ceiling(nrow(offsetAssembly) / length(fill))
        )
        
        ## Assign associated color number
        colNum <- length(newCol)
        colNum_vector <- rep_len(seq(1, colNum),
                            length.out = nrow(offsetAssembly)
        )
        
        ## Get color based on number
        colVec <- newCol[colNum_vector]
        offsetAssembly <- cbind(offsetAssembly, colVec)
        
        ## Get associated chroms in bedfile and assign the color
        chromColor <- function(offsetChrom, bedData) {
            chromMatch <- offsetChrom["chrom"]
            chromCol <- as.character(offsetChrom["colVec"])
            bedMatches <- bedData[which(bedData[, "chrom"] == chromMatch), ]
            bedCols <- colnames(bedMatches)
            bedMatches <- cbind(bedMatches, rep(chromCol, nrow(bedMatches)))
            colnames(bedMatches) <- c(bedCols, "color")
            return(bedMatches)
        }
        
        colorBed <- apply(offsetAssembly, 1, chromColor, bedData = bedData)
        colorBed <- dplyr::bind_rows(colorBed)
        return(colorBed)
        
    }
    
    ## Define a function that maps a vector of pch values to a colorby column
    mapPch <- function(bedData, fill, pch){
        ## Map pch to unique colorby column levels
        pchCol <- bedData[,which(colnames(bedData) == fill$column)]
        if (!is(pchCol, "factor")){
            pchCol <- as.factor(pchCol)
        }
        pch <- rep(pch,
                    ceiling(length(levels(pchCol)) / length(pch))
        )[seq(1, length(pchCol))]
        names(pch) <- levels(pchCol)[seq(1, length(pchCol))]
        bedData$pch <- pch[pchCol]
        
        return(bedData)
    }

    # =========================================================================
    # PARSE PARAMETERS
    # =========================================================================

    manInternal <- parseParams(
        params = params,
        defaultArgs = formals(eval(match.call()[[1]])),
        declaredArgs = lapply(match.call()[-1], eval.parent, n = 2),
        class = "manInternal"
    )

    ## Set gp
    manInternal$gp <- gpar(cex = manInternal$cex)
    manInternal$gp <- setGP(
        gpList = manInternal$gp,
        params = manInternal, ...
    )
    manInternal$gp$fill <- NA
    
    ## Justification
    manInternal$just <- justConversion(just = manInternal$just)
    
    # =========================================================================
    # INITIALIZE OBJECT
    # =========================================================================

    man_plot <- structure(list(
        chrom = manInternal$chrom,
        chromstart = manInternal$chromstart,
        chromend = manInternal$chromend,
        assembly = NULL,
        range = manInternal$range,
        ymax = manInternal$ymax,
        space = manInternal$space,
        color_palette = NULL,
        x = manInternal$x, y = manInternal$y,
        width = manInternal$width,
        height = manInternal$height,
        just = manInternal$just, grobs = NULL
    ),
    class = "manhattan"
    )
    attr(x = man_plot, which = "plotted") <- manInternal$draw

    # =========================================================================
    # CATCH MISSING ARGUMENT AND PLACEMENT ERRORS
    # =========================================================================

    if (is.null(manInternal$data)) stop("argument \"data\" is missing, ",
                                        "with no default.", call. = FALSE)

    check_placement(object = man_plot)
    
    # ========================================================================
    # PARSE ASSEMBLY
    # ========================================================================
    
    man_plot$assembly <- parseAssembly(assembly = manInternal$assembly)

    # =========================================================================
    # READ IN DATA
    # =========================================================================

    bedfile <- read_rangeData(data = manInternal$data,
                            assembly = man_plot$assembly,
                            type = "GWAS")
    
    # =========================================================================
    # CATCH MORE ERRORS
    # =========================================================================

    errorcheck_plotManhattan(
        bedfile = bedfile, chrom = man_plot$chrom,
        chromstart = man_plot$chromstart,
        chromend = man_plot$chromend,
        object = man_plot,
        leadSNP = manInternal$leadSNP,
        fill = manInternal$fill
    )

    # =========================================================================
    # FORMAT DATA
    # =========================================================================
    
    bed_data <- parse_data(
        bedfile = bedfile,
        fill = manInternal$fill
    )
    
    # =========================================================================
    # PARSE UNITS
    # =========================================================================

    man_plot <- defaultUnits(
        object = man_plot,
        default.units = manInternal$default.units
    )
    
    # =====================================================================
    # GENOMIC SCALE
    # =====================================================================
    
    if (nrow(bed_data) > 0) {

        # =====================================================================
        # MULTIPLE CHROMOSOMES
        # =====================================================================

        if (is.null(man_plot$chrom)) {
            man_plot$chromstart <- NULL
            man_plot$chromend <- NULL
            chroms <- as.character(unique(bed_data$chr))

            ## Get chrom sizes based on assembly data

            if (is(man_plot$assembly$TxDb, "TxDb")) {
                txdbChecks <- TRUE
            } else {
                
                if (!requireNamespace(man_plot$assembly$TxDb, quietly = TRUE)){
                    txdbChecks <- FALSE
                    warning("`", man_plot$assembly$TxDb, "` not available. ",
                    "Please load to generate Manhattan plot.", call. = FALSE)
                } else {
                    txdbChecks <- TRUE
                }
                
            }

            if (txdbChecks == TRUE) {
                if (is(man_plot$assembly$TxDb, "TxDb")) {
                    tx_db <- man_plot$assembly$TxDb
                } else {
                    tx_db <- eval(parse(text = 
                                paste0(as.name(man_plot$assembly$TxDb),
                                "::",
                                as.name(man_plot$assembly$TxDb))))
                }

                assembly_data <- as.data.frame(setDT(as.data.frame(
                    GenomeInfoDb::seqlengths(tx_db)
                ),
                keep.rownames = TRUE
                ))
                colnames(assembly_data) <- c("chrom", "length")
                assembly_data <- assembly_data[which(
                    assembly_data[, "chrom"] %in% chroms
                ), ]
                man_plot$chrom <- assembly_data[, "chrom"]

                if (any(!chroms %in% assembly_data[, "chrom"])) {
                    non_txdb <- chroms[which(!chroms 
                                        %in% assembly_data[, "chrom"])]
                    warning("Chromosome(s)",
                        "'", non_txdb, "'",
                        collapse = ", ",
                        "not found in",
                        "`", man_plot$assembly$TxDb$packageName, "`",
                        "and will be ignored.",
                        call. = FALSE
                    )
                }

                ## get the offsets based on spacer for the assembly
                offsetAssembly <- spaceChroms(
                    assemblyData = assembly_data,
                    space = manInternal$space
                )

                ## remove bed_data data that aren't in the genome assembly
                bed_data <- bed_data[bed_data$chrom %in% 
                                                offsetAssembly[, "chrom"], ]
                ## Add chromosome offsets to bed_data
                bed_data <- bed_offset(
                    bedData = bed_data,
                    offsetAssembly = offsetAssembly
                )
                
                ## Set viewport xscale
                cumsums <- cumsum(as.numeric(assembly_data[, "length"]))
                spacer <- cumsums[length(cumsum(as.numeric(
                    assembly_data[, "length"]
                )))] * manInternal$space

                xscale <- c(0, max(offsetAssembly[, "end"]) + spacer)
                
                # =============================================================
                # COLORS
                # =============================================================
                
                ## Vector of colors behaves differently for multi-chrom 
                ## Manhattan plot
                if (!is(manInternal$fill, "colorby")){
                    
                    if (length(manInternal$fill) > 1){
                        bed_data <- genome_color(fill = manInternal$fill,
                                            offsetAssembly = offsetAssembly,
                                            bedData = bed_data)
                    }
                    
                } else {
                    multichromColors <- parseColors(data = bed_data,
                                                fill = manInternal$fill,
                                                object = man_plot)
                    bed_data$color <- multichromColors[[1]]
                    man_plot <- multichromColors[[2]]
                }
                
            } else {
                xscale <- c(0, 1)
            }
            
            manInternal$xscale <- xscale
            manInternal$txdbChecks <- txdbChecks
        } else {

            # ==================================================================
            # SINGLE CHROMOSOME
            # ==================================================================
            
            scaleChecks <- genomicScale(object = man_plot,
                                        objectInternal = manInternal,
                                        plotType = "Manhattan plot")
            man_plot <- scaleChecks[[1]]
            manInternal <- scaleChecks[[2]]
            
            # ==================================================================
            # COLORS
            # ==================================================================
            ## Apply fill/colorby for a single chromosome
            chromColors <- parseColors(data = bed_data,
                                        fill = manInternal$fill,
                                        object = man_plot,
                                        subset = "manhattan")
            bed_data$color <- chromColors[[1]]
            man_plot <- chromColors[[2]]
            
            # ==================================================================
            # SUBSET DATA
            # ==================================================================
            
            bed_data <- bed_data[which(bed_data$chrom == man_plot$chrom), ]
            if (!is.null(man_plot$chromstart) & !is.null(man_plot$chromend)) {
                bed_data <- bed_data[which(
                    bed_data$pos >= man_plot$chromstart &
                        bed_data$pos <= man_plot$chromend), ]
            }
        }
        
        if (manInternal$txdbChecks != FALSE) {
            
            # =================================================================
            # PCH
            # =================================================================
            
            if (is(manInternal$fill, "colorby")){
                ## Map pch to colorby column values
                bed_data <- mapPch(bedData = bed_data,
                                fill = manInternal$fill,
                                pch = manInternal$pch)
            } else {
                bed_data$pch <- rep(manInternal$pch[1], nrow(bed_data))
            }
            
            # =================================================================
            # SIGNIFICANCE COLORING
            # =================================================================
            
            ## Significance coloring with sigCol
            if (!is.null(manInternal$sigCol)){
                if (nrow(bed_data[bed_data$p <= manInternal$sigVal, ]) > 0){
                    bed_data[bed_data$p <= manInternal$sigVal, ]$color <- 
                        manInternal$sigCol[1]
                }
            }

            # =================================================================
            # Y-LIMITS
            # =================================================================

            man_plot <- manhattan_range(bedData = bed_data, object = man_plot,
                                        trans = manInternal$trans,
                                        yscale_reverse = 
                                            manInternal$yscale_reverse)
            
        } else {
            manInternal$xscale <- c(0, 1)
            man_plot$range <- c(0, 1)
        }
    } else {
        manInternal$txdbChecks <- TRUE
        manInternal$xscale <- c(0, 1)
        man_plot$range <- c(0, 1)
        warning("No data found in region.", call. = FALSE)
    }


    # =========================================================================
    # VIEWPORTS
    # =========================================================================
    
    ## y-scale
    yscale <- c(man_plot$range[1], man_plot$range[2])
    if (manInternal$flip == TRUE) {
        yscale <- rev(yscale)
    }

    ## If placing information is provided but plot == TRUE,
    ## set up it's own viewport separate from bb_makepage
    ## Not translating into page_coordinates
    if (is.null(man_plot$x) | is.null(man_plot[["y"]])) {
        vp <- viewport(
            height = unit(0.25, "snpc"), width = unit(1, "snpc"),
            x = unit(0.5, "npc"), y = unit(0.5, "npc"),
            clip = "on",
            xscale = manInternal$xscale, yscale = yscale,
            just = "center",
            name = "manhattan1"
        )

        if (manInternal$draw == TRUE) {
            grid.newpage()
        }
        
    } else {
        
        ## Get viewport name
        currentViewports <- current_viewports()
        vp_name <- paste0(
            "manhattan",
            length(grep(
                pattern = "manhattan",
                x = currentViewports
            )) + 1
        )
        
        addViewport(vp_name)

        ## Convert coordinates into same units as page
        page_coords <- convert_page(object = man_plot)

        ## Make viewport
        vp <- viewport(
            height = page_coords$height, width = page_coords$width,
            x = page_coords$x, y = page_coords$y,
            clip = "on",
            xscale = manInternal$xscale, yscale = yscale,
            just = manInternal$just,
            name = vp_name
        )
    }

    # =========================================================================
    # INITIALIZE GTREE FOR GROBS WITH BACKGROUND
    # =========================================================================
    backgroundGrob <- rectGrob(gp = gpar(
        fill = manInternal$bg,
        col = NA
    ), name = "background")
    assign("manhattan_grobs", gTree(vp = vp, children = gList(backgroundGrob)),
        envir = pgEnv
    )

    if (nrow(bed_data) > 0 & manInternal$txdbChecks == TRUE) {

        # =====================================================================
        # SUBSET DATA FOR LEAD SNP
        # =====================================================================
        leadSNP_row <- data.frame(matrix(nrow = 0, ncol = 1))
        if (!is.null(manInternal$leadSNP)) {
            if ("snp" %in% colnames(bed_data)) {
                # Find index SNP in data
                leadSNP_row <- bed_data[which(
                    bed_data$snp == manInternal$leadSNP$snp
                ), ]
                if (nrow(leadSNP_row) > 0) {

                    ## Remove from data to plot separately
                    bed_data <- suppressMessages(dplyr::anti_join(
                        bed_data, leadSNP_row
                    ))
                } else {
                    warning("Specified lead SNP not found in data.",
                        call. = FALSE
                    )
                }
            }
        }
        # =====================================================================
        # POINTS
        # =====================================================================
        
        if ("col" %in% names(manInternal$gp)) {
            manInternal$gp$linecolor <- manInternal$gp$col
        }
        
        ## Assign color column to gp
        manInternal$gp$col <- bed_data$color
        
        ## Remove any additional lty information for point plotting
        manInternal$gp$linetype <- manInternal$gp$lty
        manInternal$gp$lty <- NULL

        points <- pointsGrob(
            x = bed_data$pos, 
            y = unlist(lapply(parse(text = paste0(manInternal$trans, 
                                     "(", bed_data$p, 
                                     ")")), eval)),
            pch = bed_data$pch,
            gp = manInternal$gp,
            default.units = "native"
        )
        
        assign("manhattan_grobs",
            addGrob(
                gTree = get("manhattan_grobs", envir = pgEnv),
                child = points
            ),
            envir = pgEnv
        )

        # =====================================================================
        # LEAD SNP
        # =====================================================================

        if (nrow(leadSNP_row) > 0) {
            manInternal$gp$col <- manInternal$leadSNP$fill
            manInternal$gp$cex <- manInternal$leadSNP$cex
            if (is.null(manInternal$leadSNP$pch)) {
                manInternal$leadSNP$pch <- manInternal$pch[1]
            }
            if (is.null(manInternal$leadSNP$cex)) {
                manInternal$gp$cex <- manInternal$cex
            }

            point <- pointsGrob(
                x = leadSNP_row$pos, 
                y = eval(parse(text = paste0(manInternal$trans, 
                                             "(", leadSNP_row$p, ")"))),
                pch = manInternal$leadSNP$pch,
                gp = manInternal$gp,
                default.units = "native"
            )
            snp <- textGrob(
                label = leadSNP_row$snp, x = leadSNP_row$pos,
                y = unit(eval(parse(text = paste0(manInternal$trans, 
                                                  "(", leadSNP_row$p, 
                                                  ")"))), 
                         "native") + unit(1.5, "mm"),
                just = "bottom",
                gp = gpar(
                    fontsize = manInternal$leadSNP$fontsize,
                    col = manInternal$leadSNP$fontcolor
                ),
                default.units = "native"
            )
            assign("manhattan_grobs",
                addGrob(
                    gTree = get("manhattan_grobs", envir = pgEnv),
                    child = point
                ),
                envir = pgEnv
            )
            assign("manhattan_grobs",
                addGrob(
                    gTree = get("manhattan_grobs", envir = pgEnv),
                    child = snp
                ),
                envir = pgEnv
            )
        }

        # =====================================================================
        # SIGLINE
        # =====================================================================

        if (manInternal$sigLine == TRUE) {
            manInternal$gp$col <- manInternal$gp$linecolor
            manInternal$gp$lty <- manInternal$gp$linetype
            
            sigGrob <- segmentsGrob(
                x0 = unit(0, "npc"),
                y0 = unit(eval(parse(text = paste0(manInternal$trans, 
                                                   "(", manInternal$sigVal, 
                                                   ")"))), 
                          "native"),
                x1 = unit(1, "npc"),
                y1 = unit(
                    eval(parse(text = paste0(manInternal$trans, 
                                             "(", manInternal$sigVal, 
                                             ")"))),
                    "native"
                ),
                gp = manInternal$gp
            )
            assign("manhattan_grobs",
                addGrob(
                    gTree = get("manhattan_grobs", envir = pgEnv),
                    child = sigGrob
                ),
                envir = pgEnv
            )
        }

        if (manInternal$baseline == TRUE) {
            baselineGrob <- segmentsGrob(
                x0 = unit(0, "npc"),
                y0 = 0,
                x1 = unit(1, "npc"),
                y1 = 0,
                gp = gpar(
                    col = manInternal$baseline.color,
                    lwd = manInternal$baseline.lwd
                ),
                default.units = "native"
            )
            assign("manhattan_grobs",
                addGrob(
                    gTree = get("manhattan_grobs", envir = pgEnv),
                    child = baselineGrob
                ),
                envir = pgEnv
            )
        }
    }

    # =========================================================================
    # IF PLOT == TRUE, DRAW GROBS
    # =========================================================================

    if (manInternal$draw == TRUE) {
        grid.draw(get("manhattan_grobs", envir = pgEnv))
    }

    # =========================================================================
    # ADD GROBS TO OBJECT
    # =========================================================================

    man_plot$grobs <- get("manhattan_grobs", envir = pgEnv)

    # =========================================================================
    # RETURN OBJECT
    # =========================================================================

    message("manhattan[", vp$name, "]")
    invisible(man_plot)
}

---
title: Plot Aesthetics
output: rmarkdown::html_vignette
vignette: >
    %\VignetteIndexEntry{Plot Aesthetics}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.align = "center",
    message = FALSE,
    warning = FALSE
)
library(plotgardener)
library(grid)
library(plotgardenerData)
```

`plotgardener` plots are extremely customizable in appearance. In this article 
we will outline some of the major aesthetic customizations, including general 
features and specific plot type customizations.

All the data included in this article can be found in the supplementary
package `plotgardenerData`.

# `gpar` and common plot customizations

The most common types of customizations are inherited from `grid` `gpar` 
options. If a function accepts `...`, this usually refers to `gpar` options 
that are not explicity listed as parameters in the function documentation. 
General valid parameters include:

+------------------:+:--------------------------------------------------------+
| **alpha**         | Alpha channel for transparency (number between 0 and 1).|
+-------------------+---------------------------------------------------------+
| **fill**          | Fill color.                                             |
+-------------------+---------------------------------------------------------+
|  **linecolor**    | Line color.                                             |
+-------------------+---------------------------------------------------------+
| **lty**           | Line type. (0=blank, 1=solid, 2=dashed, 3=dotted,       |
|                   | 4=dotdash, 5=longdash, 6=twodash).                      |
+-------------------+---------------------------------------------------------+
| **lwd**           | Line width.                                             |
+-------------------+---------------------------------------------------------+
| **lineend**       | Line end style (round, butt, square).                   |
+-------------------+---------------------------------------------------------+
| **linejoin**      | Line join style (round, mitre, bevel).                  |
+-------------------+---------------------------------------------------------+
| **linemitre**     | Line mitre limit (number greater than 1).               |
+-------------------+---------------------------------------------------------+
| **fontsize**      | The size of text, in points.                            |
+-------------------+---------------------------------------------------------+
| **fontcolor**     | Text color.                                             |
+-------------------+---------------------------------------------------------+
| **fontface**      | The font face (plain, bold, italic, bold.italic,        |
|                   | oblique).                                               |
+-------------------+---------------------------------------------------------+
| **fontfamily**    | The font family.                                        |
+-------------------+---------------------------------------------------------+
| **cex**           | Scaling multiplier applied to symbols.                  |
+-------------------+---------------------------------------------------------+
| **pch**           | Plotting character, or symbol (integer codes range      |
|                   | from 0 to 25).                                          |
+-------------------+---------------------------------------------------------+

Additional fonts for the `fontfamily` argument can be imported with the 
packages `extrafont` and `showtext`. This makes it possible to incorporate 
special fonts like Times New Roman, Arial, etc. into `plotgardener` figures.

# Backgrounds and baselines

By default, `plotgardener` plots have transparent backgrounds when placed on a 
`page`. In many functions, this background color can be changed with the 
parameter `bg`.

```{r eval=FALSE, echo=TRUE}
plotGenes(
    chrom = "chr8", chromstart = 1000000, chromend = 2000000,
    assembly = "hg19",
    bg = "#f6f6f6",
    x = 0.5, y = 0.5, width = 2, height = 1, just = c("left", "top"),
    default.units = "inches"
)
```


```{r aes_01, eval=TRUE, echo=FALSE, message=FALSE, fig.width=5, fig.height=3}
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)
pageCreate(
    width = 3, height = 2, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
genomicRegion <- pgParams(
    chrom = "chr8",
    chromstart = 1000000, chromend = 2000000,
    assembly = "hg19"
)
genesPlot <- plotGenes(
    params = genomicRegion, bg = "#f6f6f6",
    x = 0.5, y = 0.5, width = 2, height = 1,
    just = c("left", "top"), default.units = "inches"
)
```
This makes it easy to clearly see the precise dimensional boundaries of 
`plotgardener` plots.

Some plots also benefit from baselines to quickly show where y = 0. This can 
aid in data interpretation and guide plot annotation placement. Baselines can
be plotted in selective plots with `baseline = TRUE`.

```{r eval=FALSE, echo=TRUE}
plotRanges(
    data = IMR90_ChIP_CTCF_reads,
    chrom = "chr21", chromstart = 29073000, chromend = 29074000,
    assembly = "hg19",
    fill = c("#7ecdbb", "#37a7db"),
    baseline = TRUE, baseline.color = "black",
    x = 0.5, y = 0.25, width = 6.5, height = 4.25,
    just = c("left", "top"), default.units = "inches"
)
```

```{r aes_02, echo=FALSE, fig.height=6, fig.width=9.5}
data("IMR90_ChIP_CTCF_reads")
pageCreate(
    width = 7.5, height = 5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

pileupPlot <- plotRanges(
    data = IMR90_ChIP_CTCF_reads,
    chrom = "chr21", chromstart = 29073000, chromend = 29074000,
    assembly = "hg19",
    fill = c("#7ecdbb", "#37a7db"),
    x = 0.5, y = 0.25, width = 6.5, height = 4.25,
    baseline = TRUE, baseline.color = "black",
    just = c("left", "top"), default.units = "inches"
)
```

# Gene and transcript plot aesthetics

`plotgardener` provides many useful features specific for enhancing gene and 
transcript visualizations:

## Labels

Since `plotgardener` utilizes `TxDb` objects, `orgDb` objects, and internal 
citation information, `plotgardener` has access to numerous gene and transcript 
identifiers and can customize annotation labels in a variety of ways. 

By default, `plotgardener` will rank gene labels according to citation number to 
prevent label overcrowding. However, we can provide our own list of 
prioritized genes to label in a plot. For example, if we plot the hg19 genes 
in the region `chr2:1000000-20000000`, our plot will show these labels:

```{r aes_07, eval=TRUE, echo=TRUE, message=FALSE, fig.width=5, fig.height=1.5}
pageCreate(
    width = 5, height = 1.25,
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
genePlot <- plotGenes(
    chrom = "chr2", chromstart = 1000000, chromend = 20000000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 4.75, height = 1
)
```
Looking in the `genes` object, we can see that there were numerous genes 
that were not labeled.

```{r eval=TRUE, echo=TRUE}
genePlot$genes
```

If we were particularly interested in MIR3125, we could include this in 
the `geneOrder` parameter to prioritize its labeling:
```{r aes_08, echo=TRUE, fig.height=1.5, fig.width=5, message=FALSE}
pageCreate(
    width = 5, height = 1.25,
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
genePlot <- plotGenes(
    chrom = "chr2", chromstart = 1000000, chromend = 20000000,
    assembly = "hg19",
    geneOrder = c("MIR3125"),
    x = 0.25, y = 0.25, width = 4.75, height = 1
)
```

Label IDs used in transcript plots can be customized through `assembly()` 
objects, and transcript label formatting can be changed through the `labels` 
parameter. For example, if we wish to display both transcript names and their 
associated gene names, we can set `labels = "both"`:

```{r aes_10, echo=TRUE, fig.height=6, fig.width=7}
pageCreate(
    width = 6, height = 5,
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
transcriptPlot <- plotTranscripts(
    chrom = "chr2", chromstart = 1000000, chromend = 20000000,
    assembly = "hg19",
    labels = "both",
    x = 0.25, y = 0.25, width = 5.5, height = 4.5
)
```

## Highlighting genes by color

In addition to changing `fill` and `fontcolor` to change the colors of all 
genes in a plot, specific gene structures and their labels can be highlighted
in a different color with `geneHighlights`. If we revisit the `genes` plot
above, we can highlight RRM2 by creating a `data.frame` with "RRM2" in the 
first column and its highlight color in the second column:

```{r eval=TRUE, echo=TRUE, message=FALSE}
geneHighlights <- data.frame("geneName" = "RRM2", "color" = "steel blue")
```

We can then pass this into our `plotGenes()` call:

```{r aes_11, eval=TRUE, echo=TRUE, message=FALSE, fig.width=5, fig.height=1.5}
pageCreate(
    width = 5, height = 1.25,
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
genePlot <- plotGenes(
    chrom = "chr2", chromstart = 1000000, chromend = 20000000,
    assembly = "hg19",
    geneHighlights = geneHighlights, geneBackground = "grey",
    x = 0.25, y = 0.25, width = 4.75, height = 1
)
```

Since `geneHighlights` is a `data.frame`, we can highlight multiple genes 
in different colors at once. For example, let's now highlight RRM2 in 
"steel blue" and PXDN in "red":

```{r aes_12, eval=TRUE, echo=TRUE, message=FALSE, fig.width=5, fig.height=1.5}
geneHighlights <- data.frame(
    "geneName" = c("RRM2", "PXDN"),
    "color" = c("steel blue", "red")
)

pageCreate(
    width = 5, height = 1.25,
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
genePlot <- plotGenes(
    chrom = "chr2", chromstart = 1000000, chromend = 20000000,
    assembly = "hg19",
    geneHighlights = geneHighlights, geneBackground = "grey",
    x = 0.25, y = 0.25, width = 4.75, height = 1
)
```

## Highlighting transcripts by color

Similar to highlighting specific genes by colors, specific transcripts can
also be highlighted with `transcriptHighlights`. We can do this by either 
specifying transcripts by name or transcripts by their genes. Let's plot the 
transcripts of the gene track above and label the transcripts of LPIN1 and 
CMPK2:

```{r aes_13, eval=TRUE, echo=TRUE, message=FALSE, fig.width=7, fig.height=8}
transcriptHighlights <- data.frame(
    "gene" = c("LPIN1", "CMPK2"),
    "color" = c("steel blue", "red")
)

pageCreate(
    width = 6, height = 7,
    showGuides = FALSE
)
transcriptPlot <- plotTranscripts(
    chrom = "chr2", chromstart = 1000000, chromend = 20000000,
    assembly = "hg19",
    transcriptHighlights = transcriptHighlights,
    colorbyStrand = FALSE, fill = "grey",
    x = 0.25, y = 0.25, width = 5.5, height = 4.5
)
```

We can now see all transcripts of CMPK2 are colored in red and 
all transcripts of LPIN1 are colored in steel blue. If we knew the precise names
of these transcripts, we could also specify them for transcript highlighting
with the following `data.frame`:

```r
transcriptHighlights <- data.frame(
    "transcript" = c("uc010yjo.2", "uc002rbt.4", "uc010yjn.3", "uc002rbs.4",
                    "uc010yjm.3","uc010exi.1", "uc031rno.1", "uc010ewv.4",
                    "uc002qyo.4", "uc010yis.2", "uc002qyn.2"),
    "color" = c("steel blue", "steel blue", "steel blue", "steel blue",
                "steel blue", "steel blue", "red", "red", "red", "red", "red")
)
```

## Customizing transcripts by strand

To distinguish which strand a transcript belongs to, `plotTranscripts()` 
colors transcripts by strand with the parameter `colorbyStrand`. The first 
value in `fill` colors positive strand transcripts and the second `fill`
value colors negative strand transcripts. To further organize transcripts by 
strand, we can use `strandSplit` to separate transcript elements into groups 
of positive and negative strands:

```{r aes_14, echo=TRUE, fig.height=6, fig.width=7}
pageCreate(
    width = 6, height = 5,
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
transcriptPlot <- plotTranscripts(
    chrom = "chr2", chromstart = 1000000, chromend = 20000000,
    assembly = "hg19",
    strandSplit = TRUE,
    x = 0.25, y = 0.25, width = 5.5, height = 4.5
)
```

Now all our positive strand transcripts are grouped together above the 
group of negative strand transcripts.

# Hi-C plot customizations

`plotgardener` includes many types of customizations for Hi-C plots. `plotgardener` 
provides 3 different Hi-C plotting functions based on the desired plot shape:

- `plotHicSquare()`: Plots a square, symmetrical Hi-C plot with genomic 
coordinates along both the x- and y-axes.
    
- `plotHicTriangle()`: Plots a triangular Hi-C plot where the genome 
region falls along the base of the triangle.
    
- `plotHicRectangle()`: Plots a triangular Hi-C plot with additional data 
filling the surrounding regions to form a rectangle.

```{r aes_15, echo=FALSE, fig.height=3.9, fig.width=9.75, message=FALSE}
data("IMR90_HiC_10kb")

pageCreate(
    width = 7.1, height = 2.25, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
params <- pgParams(
    chrom = "chr21", chromstart = 28950000, chromend = 29800000,
    assembly = "hg19", resolution = 10000
)

hicPlot_square <- plotHicSquare(
    data = IMR90_HiC_10kb, params = params,
    zrange = c(0, 70),
    x = 0.25, y = 0.25,
    width = 1.6, height = 1.6
)
annoGenomeLabel(
    plot = hicPlot_square, fontsize = 8,
    x = 0.25, y = 1.9, scale = "Kb"
)
annoGenomeLabel(
    plot = hicPlot_square, axis = "y", fontsize = 8,
    x = 0.20, y = 0.25, scale = "Kb",
    just = c("right", "top")
)
hicPlot_triangle <- plotHicTriangle(
    data = IMR90_HiC_10kb, params = params,
    zrange = c(0, 70),
    x = 2.1, y = 1.85,
    width = 2.25, height = 2,
    just = c("left", "bottom")
)
annoGenomeLabel(
    plot = hicPlot_triangle, fontsize = 8,
    x = 2.1, y = 1.9, scale = "Kb"
)
hicPlot_rectangle <- plotHicRectangle(
    data = IMR90_HiC_10kb, params = params,
    zrange = c(0, 70),
    x = 4.6, y = 1.85,
    width = 2.25, height = 1.125,
    just = c("left", "bottom")
)
annoGenomeLabel(
    plot = hicPlot_rectangle, fontsize = 8,
    x = 4.6, y = 1.9, scale = "Kb"
)
```  

All Hi-C plot types can use different color palettes, and colors can be 
linearly or log-scaled with the `colorTrans` parameter.  

`hicSquare` plots can be further customized to include two datasets in 
one plot. Instead of plotting both symmetrical halves of the plot, we can set 
one dataset as `half = "top"` and the other dataset as `half = "bottom"`:

```{r aes_16, echo=TRUE, fig.height=4.25, fig.width=5.25, message=FALSE}
data("GM12878_HiC_10kb")
data("IMR90_HiC_10kb")

pageCreate(
    width = 3.25, height = 3.25, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
params <- pgParams(
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19", resolution = 10000,
    x = 0.25, width = 2.75, just = c("left", "top"), default.units = "inches"
)


hicPlot_top <- plotHicSquare(
    data = GM12878_HiC_10kb, params = params,
    zrange = c(0, 200),
    half = "top",
    y = 0.25, height = 2.75
)
hicPlot_bottom <- plotHicSquare(
    data = IMR90_HiC_10kb, params = params,
    zrange = c(0, 70),
    half = "bottom",
    y = 0.25, height = 2.75
)
```

# Session Info
```{r}
sessionInfo()
```

---
title: "plotgardener Meta Functions"
output:
    rmarkdown::html_vignette
vignette: >
    %\VignetteIndexEntry{plotgardener Meta Functions}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
    fig.align = "center",
    fig.width = 3,
    fig.height = 3,
    collapse = TRUE,
    comment = "#>",
    warning = FALSE,
    message = FALSE
)
library(grid)
library(plotgardener)
library(plotgardenerData)
```

`plotgardener` meta functions enhance the `plotgardener` user experience by providing 
simple methods to display various genomic assembly data, simplify `plotgardener`
code, and construct `plotgardener` objects. Functions in this category include:

- **`genomes`** and **`defaultPackages`**

Simple functions to display the strings of available default genomic builds and 
the genomic annotation packages associated with these builds in `plotgardener` functions.

```{r}
genomes()
```
```{r}
defaultPackages("hg19")
```

- **`assembly`**

A constructor to make custom combinations of genomic annotation packages for 
use in `plotgardener` functions through the `assembly` parameter.

- **`pgParams`**

A constructor to capture sets of parameters to be shared across multiple
function calls. `pgParams` objects can hold any argument from any `plotgardener`
function. Most often, `pgParams` objects are used to store a common genomic
region and common x-placement coordinate information. For a detailed example 
using the `pgParams` object, refer to the vignette 
[Plotting Multi-omic Data](plotting_multiomic_data.html#using-the-pgParams-object-1).

- **`colorby`** and **`mapColors`**

The `colorby` constructor allows us to color the data elements in `plotgardener` 
plots by various data features. These features can be a numerical range, like 
some kind of score value, or categorical values, like positive or negative 
strand. The `colorby` object is constructed by specifying the name of the data 
column to color by, an optional color palette function, and an optional range 
for numerical values. If not specified, `plotgardener` will use the `RColorBrewer`
"YlGnBl" palette for mapping numerical data and the "Pairs" palette for 
qualitative data.

For example, if we revist the BED plot above, `IMR90_ChIP_CTCF_reads` has an additional 
`strand` column for each BED element: 

```{r eval = TRUE, echo = TRUE}
data("IMR90_ChIP_CTCF_reads")
head(IMR90_ChIP_CTCF_reads)
```

Thus, we can use the `colorby` constructor to color BED elements by positive 
or negative strand. The `strand` column will be converted to a factor with a 
`-` level and `+` level. These values will be mapped to our input `palette`:

```{r eval=FALSE, echo=TRUE}
set.seed(nrow(IMR90_ChIP_CTCF_reads))
plotRanges(
    data = IMR90_ChIP_CTCF_reads,
    chrom = "chr21", chromstart = 29073000, chromend = 29074000,
    assembly = "hg19",
    order = "random",
    fill = colorby("strand", palette = 
                       colorRampPalette(c("#7ecdbb", "#37a7db"))),
    x = 0.5, y = 0.25, width = 6.5, height = 4.25,
    just = c("left", "top"), default.units = "inches"
)
```

```{r aes_03, echo=FALSE, fig.height=6, fig.width=9.5}

pageCreate(
    width = 7.5, height = 5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

set.seed(nrow(IMR90_ChIP_CTCF_reads))
plotRanges(
    data = IMR90_ChIP_CTCF_reads,
    chrom = "chr21", chromstart = 29073000, chromend = 29074000,
    assembly = "hg19",
    order = "random",
    fill = colorby("strand", palette = 
                       colorRampPalette(c("#7ecdbb", "#37a7db"))),
    strandSplit = TRUE,
    x = 0.5, y = 0.25, width = 6.5, height = 4.25,
    just = c("left", "top"), default.units = "inches"
)
```

To further control the order of color mapping, we can set our categorical 
`colorby` column as a factor with our own order of levels before plotting:

```{r eval=TRUE, echo=TRUE}
data("IMR90_ChIP_CTCF_reads")
IMR90_ChIP_CTCF_reads$strand <- factor(IMR90_ChIP_CTCF_reads$strand, levels = c("+", "-"))
head(IMR90_ChIP_CTCF_reads$strand)
```

Now we've set the `+` level as our first level, so our `palette` will map
colors in the opposite order from before:

```{r aes_04, echo=FALSE, fig.height=6, fig.width=9.5}

pageCreate(
    width = 7.5, height = 5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
set.seed(nrow(IMR90_ChIP_CTCF_reads))
plotRanges(
    data = IMR90_ChIP_CTCF_reads,
    chrom = "chr21", chromstart = 29073000, chromend = 29074000,
    assembly = "hg19",
    order = "random",
    fill = colorby("strand", palette = 
                       colorRampPalette(c("#7ecdbb", "#37a7db"))),
    strandSplit = TRUE,
    x = 0.5, y = 0.25, width = 6.5, height = 4.25,
    just = c("left", "top"), default.units = "inches"
)
```

In this example, we will color BEDPE arches by a range of numerical values 
we will add as a `length` column:

```{r eval=TRUE, echo=TRUE }
data("IMR90_DNAloops_pairs")
IMR90_DNAloops_pairs$length <- (IMR90_DNAloops_pairs$start2 - IMR90_DNAloops_pairs$start1) / 1000
head(IMR90_DNAloops_pairs$length)
```

Now we can set `fill` as a `colorby` object to color the BEDPE `length` column by:
```{r eval=FALSE, echo=TRUE}
bedpePlot <- plotPairsArches(
    data = IMR90_DNAloops_pairs,
    chrom = "chr21", chromstart = 27900000, chromend = 30700000,
    assembly = "hg19",
    fill = colorby("length", 
                   palette = colorRampPalette(c("dodgerblue2", "firebrick2"))),
    linecolor = "fill",
    archHeight = IMR90_DNAloops_pairs$length / max(IMR90_DNAloops_pairs$length),
    alpha = 1,
    x = 0.25, y = 0.25, width = 7, height = 1.5,
    just = c("left", "top"),
    default.units = "inches"
)
```

```{r aes_05, echo=FALSE, fig.width=9.5, message=FALSE, height=3}

pageCreate(
    width = 7.5, height = 2, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
heights <- IMR90_DNAloops_pairs$length / max(IMR90_DNAloops_pairs$length)
bedpePlot <- plotPairsArches(
    data = IMR90_DNAloops_pairs,
    chrom = "chr21", chromstart = 27900000, chromend = 30700000,
    assembly = "hg19",
    fill = colorby("length", 
                   palette = colorRampPalette(c("dodgerblue2", "firebrick2"))),
    linecolor = "fill",
    archHeight = heights, alpha = 1,
    x = 0.25, y = 0.25, width = 7, height = 1.5,
    just = c("left", "top"),
    default.units = "inches"
)
```

And now since we have numbers mapped to colors, we can use 
`annoHeatmapLegend()` with our `arches` object to add a legend for 
the `colorby` we performed:

```{r eval=FALSE, echo=TRUE}
annoHeatmapLegend(
    plot = bedpePlot, fontcolor = "black",
    x = 7.0, y = 0.25,
    width = 0.10, height = 1, fontsize = 10
)
```
```{r aes_06, echo=FALSE, fig.width=9.5, message=FALSE, height=3}

pageCreate(
    width = 7.5, height = 2, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
heights <- IMR90_DNAloops_pairs$length / max(IMR90_DNAloops_pairs$length)
bedpePlot <- plotPairsArches(
    data = IMR90_DNAloops_pairs,
    chrom = "chr21", chromstart = 27900000, chromend = 30700000,
    assembly = "hg19",
    fill = colorby("length", 
                   palette = colorRampPalette(c("dodgerblue2", "firebrick2"))),
    linecolor = "fill",
    archHeight = heights, alpha = 1,
    x = 0.25, y = 0.25, width = 7, height = 1.5,
    just = c("left", "top"),
    default.units = "inches"
)
annoHeatmapLegend(
    plot = bedpePlot, fontcolor = "black",
    x = 7.0, y = 0.25,
    width = 0.10, height = 1, fontsize = 10
)
```

If users wish to map values to a color palette before passing them into
a `plotgardener` function, they can use `mapColors`:
```{r echo=TRUE, eval=FALSE}
colors <- mapColors(vector = IMR90_DNAloops_pairs$length,
             palette = colorRampPalette(c("dodgerblue2", "firebrick2")))

bedpePlot <- plotPairsArches(
    data = IMR90_DNAloops_pairs,
    chrom = "chr21", chromstart = 27900000, chromend = 30700000,
    assembly = "hg19",
    fill = colors,
    linecolor = "fill",
    archHeight = heights, alpha = 1,
    x = 0.25, y = 0.25, width = 7, height = 1.5,
    just = c("left", "top"),
    default.units = "inches"
)

```

```{r aes_07, echo=FALSE, fig.width=9.5, message=FALSE, height=3}

pageCreate(
    width = 7.5, height = 2, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
heights <- IMR90_DNAloops_pairs$length / max(IMR90_DNAloops_pairs$length)
colors <- mapColors(vector = IMR90_DNAloops_pairs$length,
             palette = colorRampPalette(c("dodgerblue2", "firebrick2")))
bedpePlot <- plotPairsArches(
    data = IMR90_DNAloops_pairs,
    chrom = "chr21", chromstart = 27900000, chromend = 30700000,
    assembly = "hg19",
    fill = colors,
    linecolor = "fill",
    archHeight = heights, alpha = 1,
    x = 0.25, y = 0.25, width = 7, height = 1.5,
    just = c("left", "top"),
    default.units = "inches"
)
annoHeatmapLegend(
    plot = bedpePlot, fontcolor = "black",
    x = 7.0, y = 0.25,
    width = 0.10, height = 1, fontsize = 10
)
```

### Session Info
```{r}
sessionInfo()
```

---
title: Plot Annotations
output: rmarkdown::html_vignette
vignette: >
    %\VignetteIndexEntry{Plot Annotations}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.align = "center",
    message = FALSE,
    warning = FALSE
)
library(plotgardener)
library(grid)
library(GenomicRanges)
library(plotgardenerData)
```

`plotgardener` is modular and separates plotting and annotating into two different
categories of functions. To specify which plot to annotate within an 
annotation function, each annotation function has a `plot` parameter that 
accepts `plotgardener` plot objects. This will facilitate in inheriting genomic 
region and plot location information. In this article we will go through some 
of the major types of annotations used to create accurate and informative 
`plotgardener` plots.

All the data included in this article can be found in the supplementary
package `plotgardenerData`.

## Genome labels

Genome labels are some of the most important annotations for giving context 
to the genomic region of data. `annoGenomeLabel()` can add genome labels 
with various customizations.

Genome labels can be shown at three different basepair scales 
(Mb, Kb, and bp) depending on the size of the region and the desired accuracy 
of the start and end labels. In the genomic region `chr21:28000000-30300000` 
we can use a Mb scale:

```{r anno_01, echo=TRUE, eval=TRUE, fig.height=5, fig.width=6}
data("IMR90_HiC_10kb")
pageCreate(
    width = 3, height = 3.25, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)

annoGenomeLabel(
    plot = hicPlot, scale = "Mb",
    x = 0.25, y = 2.76
)
```

If we use a more specific genomic region like `chr21:28255554-29354665`, the 
Mb scale will be rounded and indicated with an approximation sign:

```{r anno_02, echo=FALSE, eval=TRUE, warning=TRUE, fig.height=5, fig.width=6}
data("IMR90_HiC_10kb")
pageCreate(
    width = 3, height = 3.25, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28255554, chromend = 29354665,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)
annoGenomeLabel(
    plot = hicPlot, scale = "Mb",
    x = 0.25, y = 2.76
)
```

Thus, it makes more sense to use the bp scale for ultimate accuracy:

```{r anno_03, echo=TRUE, eval=TRUE, message=FALSE, fig.height=5, fig.width=6}
data("IMR90_HiC_10kb")
pageCreate(
    width = 3, height = 3.25, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28255554, chromend = 29354665,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)
annoGenomeLabel(
    plot = hicPlot, scale = "bp",
    x = 0.25, y = 2.76
)
```

If our genomic region is small enough, `annoGenomeLabel()` can also be 
used to display the nucleotide sequence of that region. Similar to IGV, 
`annoGenomeLabel()` will first represent nucleotides as colored boxes:

```{r anno_04, echo=FALSE, fig.height=2.5, fig.width=7, message=FALSE}
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)
library(BSgenome.Hsapiens.UCSC.hg19)

pageCreate(
    width = 5, height = 1.5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
geneTrack <- plotGenes(
    chrom = "chr1", chromstart = 110146000, chromend = 110146050,
    assembly = "hg19",
    x = 0.5, y = 0.25, width = 4, height = 0.75, default.units = "inches"
)
annoGenomeLabel(plot = geneTrack, x = 0.5, y = 1.01)
```  

At even finer scales, `annoGenomeLabel()` will then represent nucleotides 
with colored letters:

```{r anno_05, echo=FALSE, fig.height=2.5, fig.width=7, message=FALSE}
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)

pageCreate(
    width = 5, height = 1.5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
geneTrack <- plotGenes(
    chrom = "chr1", chromstart = 110146000, chromend = 110146025,
    assembly = "hg19",
    x = 0.5, y = 0.25, width = 4, height = 0.75, default.units = "inches"
)
annoGenomeLabel(plot = geneTrack, x = 0.5, y = 1.01)
```  

In the specific case of square Hi-C plots (`hicSquare` objects), 
`annoGenomeLabel()` can annotate the genome label along the y-axis:

```{r anno_06, echo=TRUE, eval=TRUE, message=FALSE, fig.height=5, fig.width=6}
data("IMR90_HiC_10kb")
pageCreate(
    width = 3.25, height = 3, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)
annoGenomeLabel(
    plot = hicPlot, scale = "Mb",
    axis = "y",
    x = 0.5, y = 0.25,
    just = c("right", "top")
)
```

## Plot axes

In addition to genomic axes, it is also common to annotate standard x and 
y-axes for measures of scale. This functionality is provided by the 
`annoXaxis()` and `annoYaxis()` functions. For example, a Manhattan 
plot requires a y-axis to indicate the range of p-values:

```{r anno_07, echo=TRUE, fig.height=3.75, fig.width=9.5, message=FALSE}
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
data("hg19_insulin_GWAS")

pageCreate(
    width = 7.5, height = 2.75, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
manhattanPlot <- plotManhattan(
    data = hg19_insulin_GWAS, assembly = "hg19",
    fill = c("grey", "#37a7db"),
    sigLine = TRUE,
    col = "grey", lty = 2, range = c(0, 14),
    x = 0.5, y = 0.25, width = 6.5, height = 2,
    just = c("left", "top"),
    default.units = "inches"
)
annoGenomeLabel(
    plot = manhattanPlot, x = 0.5, y = 2.25, fontsize = 8,
    just = c("left", "top"), default.units = "inches"
)
plotText(
    label = "Chromosome", fontsize = 8,
    x = 3.75, y = 2.45, just = "center", default.units = "inches"
)

## Annotate y-axis
annoYaxis(
    plot = manhattanPlot, at = c(0, 2, 4, 6, 8, 10, 12, 14),
    axisLine = TRUE, fontsize = 8
)
## Plot y-axis label
plotText(
    label = "-log10(p-value)", x = 0.15, y = 1.25, rot = 90,
    fontsize = 8, fontface = "bold", just = "center",
    default.units = "inches"
)
```

`annoXaxis()` and `annoYaxis()` have similar usages and customizations.

## Heatmap legends

Heatmap-style plots with numbers translated to a palette of colors require a 
specific type of legend. This legend can be plotted with 
`annoHeatmapLegend()` in both vertical and horizontal orientations. Genomic 
plots that typically require this annotation are Hi-C plots made with 
`plotHicRectangle()`, `plotHicSquare()`, or `plotHicTriangle()`.

```{r anno_08, echo=TRUE, fig.height=4.25, fig.width=5.25, message=FALSE}
data("IMR90_HiC_10kb")

pageCreate(
    width = 3.25, height = 3.25, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
params <- pgParams(
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, width = 2.75, just = c("left", "top"), default.units = "inches"
)
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, params = params,
    zrange = c(0, 70), resolution = 10000,
    y = 0.25, height = 2.75
)

## Annotate Hi-C heatmap legend
annoHeatmapLegend(
    plot = hicPlot, fontsize = 7,
    orientation = "v",
    x = 0.125, y = 0.25,
    width = 0.07, height = 0.5, just = c("left", "top"),
    default.units = "inches"
)

annoHeatmapLegend(
    plot = hicPlot, fontsize = 7,
    orientation = "h",
    x = 3, y = 3.055,
    width = 0.5, height = 0.07, just = c("right", "top"),
    default.units = "inches"
)
```

## Hi-C pixels and domains

It is possible to annotate the pixels on a Hi-C plot with provided BEDPE 
data. Pixels can be annotated with boxes, circles, or squares.

```{r anno_09, echo=TRUE, fig.height=4.25, fig.width=5.25, message=FALSE}
data("IMR90_HiC_10kb")
data("IMR90_DNAloops_pairs")

pageCreate(
    width = 3.25, height = 3.24, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, resolution = 10000, zrange = c(0, 70),
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.75, height = 2.75,
    just = c("left", "top"),
    default.units = "inches"
)

## Annotate pixels
pixels <- annoPixels(
    plot = hicPlot, data = IMR90_DNAloops_pairs, type = "box",
    half = "top"
)
```

If we want to annotate one pixel of interest, we can subset our BEDPE data and 
`annoPixels()` will only annotate the specified pixels:

```{r anno_10, echo=TRUE, fig.height=4.25, fig.width=5.25, message=FALSE}
data("IMR90_HiC_10kb")
data("IMR90_DNAloops_pairs")

## Subset BEDPE data
IMR90_DNAloops_pairs <- IMR90_DNAloops_pairs[which(IMR90_DNAloops_pairs$start1 == 28220000 &
    IMR90_DNAloops_pairs$start2 == 29070000), ]

pageCreate(
    width = 3.25, height = 3.24, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, resolution = 10000, zrange = c(0, 70),
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    x = 0.25, y = 0.25, width = 2.75, height = 2.75,
    just = c("left", "top"),
    default.units = "inches"
)

## Annotate pixel
pixels <- annoPixels(
    plot = hicPlot, data = IMR90_DNAloops_pairs, type = "arrow",
    half = "bottom", shift = 12
)
```

For genomic ranges of domain data, we can annotate Hi-C domains with
`annoDomains()`. For example, if we want to annotate the following domains

```{r echo=TRUE, eval=TRUE}
domains <- GRanges("chr21",
     ranges = IRanges(
         start = c(28210000, 29085000, 29430000, 29700000),
         end = c(29085000, 29430000, 29700000, 30125000)
     )
 )
```
in this Hi-C plot: 

```{r anno_11, echo=FALSE, message=FALSE, fig.height=4.25, fig.width=5.25}
data("IMR90_HiC_10kb")
pageCreate(
    width = 3.25, height = 3.24, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, resolution = 10000, zrange = c(0, 70),
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    x = 0.25, y = 0.25, width = 2.75, height = 2.75,
    just = c("left", "top"),
    default.units = "inches"
)
```

We would use a similar workflow to how we annotated Hi-C pixels:

```{r anno_12, echo=TRUE, fig.height=4.25, fig.width=5.25, message=FALSE}
pageCreate(
    width = 3.25, height = 3.24, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, resolution = 10000, zrange = c(0, 70),
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    x = 0.25, y = 0.25, width = 2.75, height = 2.75,
    just = c("left", "top"),
    default.units = "inches"
)

## Annotate domains
domainAnno <- annoDomains(
    plot = hicPlot, data = domains,
    half = "bottom", linecolor = "red"
)

annoGenomeLabel(
    plot = hicPlot, 
    x = 0.25, y = 3.01
)

```

We can either annotate single domains or multiple domains at once depending 
on the `data` input.

## Genomic region highlights and zooms

The last category of annotations that is often used in plotting genomic data 
is highlighting and zooming. Many figures benefit from providing a broader 
context of data and then highlighting a smaller genomic region to show data 
at a finer scale. In this example, we will plot an ideogram and highlight and 
zoom in on a genomic region of interest to see the signal track data in that 
region.

First we can plot our ideogram:

```{r anno_13, echo=TRUE, fig.height=3.25, fig.width=8.25, message=FALSE}
library(AnnotationHub)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)

pageCreate(
    width = 6.25, height = 2.25, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
ideogramPlot <- plotIdeogram(
    chrom = "chr21", assembly = "hg19",
    orientation = "h",
    x = 0.25, y = 0.5, width = 5.75, height = 0.3, just = "left"
)
```

We can then use `annoHighlight()` to highlight our genomic region of 
interest (`chr21:28000000-30300000`) with a box of our desired `height`:

```{r eval=FALSE, echo=TRUE, message=FALSE}
region <- pgParams(chrom = "chr21", chromstart = 28000000, chromend = 30300000)
annoHighlight(
    plot = ideogramPlot, params = region,
    fill = "red",
    y = 0.25, height = 0.5, just = c("left", "top"), default.units = "inches"
)
```

```{r anno_14, echo=FALSE, fig.height=3.25, fig.width=8.25, message=FALSE}
library(AnnotationHub)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
pageCreate(
    width = 6.25, height = 2.25, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

ideogramPlot <- plotIdeogram(
    chrom = "chr21", assembly = "hg19",
    orientation = "h",
    x = 0.25, y = 0.5, width = 5.75, height = 0.3, just = "left"
)
region <- pgParams(chrom = "chr21", chromstart = 28000000, chromend = 30300000)

annoHighlight(
    plot = ideogramPlot, params = region,
    fill = "red",
    y = 0.25, height = 0.5, just = c("left", "top"), default.units = "inches"
)
```

To make it clearer that we are zooming in on a genomic region, we can then use
`annoZoomLines()` to add zoom lines from the genomic region we highlighted:

```{r eval=FALSE, echo=TRUE, message=FALSE}
annoZoomLines(
    plot = ideogramPlot, params = region,
    y0 = 0.75, x1 = c(0.25, 6), y1 = 1.25, default.units = "inches"
)
```

```{r anno_15, echo=FALSE, fig.height=3.25, fig.width=8.25, message=FALSE}
library(AnnotationHub)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
pageCreate(
    width = 6.25, height = 2.25, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

ideogramPlot <- plotIdeogram(
    chrom = "chr21", assembly = "hg19",
    orientation = "h",
    x = 0.25, y = 0.5, width = 5.75, height = 0.3, just = "left"
)
region <- pgParams(chrom = "chr21", chromstart = 28000000, chromend = 30300000)

annoHighlight(
    plot = ideogramPlot, params = region,
    fill = "red",
    y = 0.25, height = 0.5, just = c("left", "top"), default.units = "inches"
)
annoZoomLines(
    plot = ideogramPlot, params = region,
    y0 = 0.75, x1 = c(0.25, 6), y1 = 1.25, default.units = "inches"
)
```

Finally, we can add our zoomed-in signal track data within the zoom lines:

```{r anno_16, echo=FALSE, fig.height=3.25, fig.width=8.25, message=FALSE}
library(AnnotationHub)
data("IMR90_ChIP_H3K27ac_signal")
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
pageCreate(
    width = 6.25, height = 2.25, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

ideogramPlot <- plotIdeogram(
    chrom = "chr21", assembly = "hg19",
    orientation = "h",
    x = 0.25, y = 0.5, width = 5.75, height = 0.3, just = "left"
)
region <- pgParams(chrom = "chr21", chromstart = 28000000, chromend = 30300000)

annoHighlight(
    plot = ideogramPlot, params = region,
    fill = "red",
    y = 0.25, height = 0.5, just = c("left", "top"), default.units = "inches"
)
annoZoomLines(
    plot = ideogramPlot, params = region,
    y0 = 0.75, x1 = c(0.25, 6), y1 = 1.25, default.units = "inches"
)


signalPlot <- plotSignal(
    data = IMR90_ChIP_H3K27ac_signal, params = region,
    x = 0.25, y = 1.25, width = 5.75, height = 0.65
)

annoGenomeLabel(
    plot = signalPlot, scale = "Mb",
    x = 0.25, y = 1.95
)
```

# Session Info
```{r}
sessionInfo()
```

---
title: Ideograms and Shapes
output: rmarkdown::html_vignette
vignette: >
    %\VignetteIndexEntry{Ideograms and Shapes}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.align = "center",
    message = FALSE,
    warning = FALSE
)
library(plotgardener)
library(grid)
library(plotgardenerData)
```

Beyond providing functions for plotting and arranging various genomic 
datasets, `plotgardener` also gives users the functionality to plot other elements
within a `plotgardener` page layout:

## Ideograms

In addition to a genomic axis label, it can also be useful to include an 
ideogram representation of a chromosome to give a broader context of the 
location of genomic data. UCSC Giemsa stain cytoband information for various 
genomic assemblies is retrieved from `AnnotationHub` for default assemblies, 
but users can also provide their own Giemsa stain information if they desire.

Ideograms can be plotted both vertically and horizontally:
```{r ideogram_01, echo=TRUE, fig.height=5.25, fig.width=10.35, message=FALSE}
library(AnnotationHub)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(GenomeInfoDb)

## Get sizes of chromosomes to scale their sizes
tx_db <- TxDb.Hsapiens.UCSC.hg19.knownGene
chromSizes <- GenomeInfoDb::seqlengths(tx_db)
maxChromSize <- max(chromSizes)

pageCreate(
    width = 8.35, height = 4.25, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
xCoord <- 0.15
for (chr in c(paste0("chr", seq(1, 22)), "chrX", "chrY")) {
    height <- (4 * chromSizes[[chr]]) / maxChromSize
    plotIdeogram(
        chrom = chr, assembly = "hg19",
        orientation = "v",
        x = xCoord, y = 4,
        width = 0.2, height = height,
        just = "bottom"
    )
    plotText(
        label = gsub("chr", "", chr),
        x = xCoord, y = 4.1, fontsize = 10
    )
    xCoord <- xCoord + 0.35
}
```

```{r ideogram_02, echo=TRUE, fig.height=.5, fig.width=8.25, message=FALSE}
pageCreate(
    width = 6.25, height = 0.5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

plotIdeogram(
    chrom = "chr1", assembly = "hg19",
    orientation = "h",
    x = 0.25, y = unit(0.25, "npc"), width = 5.75, height = 0.3
)
```

The cytobands can also be hidden if a more minimal ideogram is preferred:

```{r eval=FALSE, echo=TRUE, message=FALSE}
plotIdeogram(
    showBands = FALSE,
    chrom = "chr1", assembly = "hg19",
    orientation = "h",
    x = 0.25, y = unit(0.25, "npc"), width = 5.75, height = 0.3
)
```

```{r ideogram_03, echo=FALSE, fig.height=.5, fig.width=8.25, message=FALSE}
pageCreate(
    width = 6.25, height = 0.5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

plotIdeogram(
    showBands = FALSE,
    chrom = "chr1", assembly = "hg19",
    orientation = "h",
    x = 0.25, y = unit(0.25, "npc"), width = 5.75, height = 0.3
)
```

To highlight a specific genomic region on an ideogram, see the 
article [Plot Annotations](annotations.html#genomic-region-highlights-and-zooms-1). 

## Images and basic shapes

`plotgardener` also allows users to plot images and basic shapes and elements to 
further enhance and customize plot layouts. The functions `plotCircle()`, 
`plotPolygon()`, `plotRaster()`, `plotRect()`, `plotSegments()`, 
and `plotText()` provide an intuitive way to plot basic `grid` `grobs` 
without requiring any knowledge of `grid` graphics.

For example, we can include `plotgardener`'s Gene the Gnome in our figures!:

```{r shapes, echo=TRUE, fig.height=7, fig.showtext=TRUE, fig.width=6}
library(png)
pg_type <- readPNG(system.file("images",
                        "pg-wordmark.png",
                        package = "plotgardener"))

gene_gnome <- readPNG(system.file("images",    
            "pg-gnome-hole-shadow.png",
            package = "plotgardener" ))

pageCreate(
    width = 5, height = 6, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
plotRaster(
    image = pg_type,
    x = 2.5, y = 0.25, width = 4, height = 1.5, just = "top"
)
plotRaster(
    image = gene_gnome,
    x = 2.5, y = 1, width = 3.5, height = 3.5, just = "top"
)
```

For more detailed usage of basic shape functions, see the function-specific 
reference examples with `?function()` (e.g. `?plotCircle()`).

## Other grob objects

We saw how to add `ggplots` and `ComplexHeatmaps` to `plotgardener` layouts 
in the vignette 
[Incorporating ggplots and other `grid`-based Bioconductor visualizations"](incorporating_ggplots.html) 
with the `plotGG()` function. Beyond customizing the coordinates and dimensions 
of `ggplots` and `grid`-based Bioconductor visualizations, `plotGG()` can also 
be used to incorporate other `grob` and `gtable` objects. Thus, `plotgardener` 
allows us to easily mix and arrange most kinds of plot objects for ultimate 
customization.

## Session Info
```{r}
sessionInfo()
```

---
title: "Reading Data for plotgardener"
output:
    rmarkdown::html_vignette
vignette: >
    %\VignetteIndexEntry{Reading Data for plotgardener}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
    fig.align = "center",
    fig.width = 3,
    fig.height = 3,
    collapse = TRUE,
    comment = "#>",
    warning = FALSE,
    message = FALSE
)
library(grid)
library(plotgardener)
library(plotgardenerData)
```

`plotgardener` handles a wide array of genomic data types in various formats 
and file types. Not only does it work with `data.frames`, `data.tables`, 
`tibbles`, and Bioconductor `GRanges` and `GInteractions` objects, but 
it can also read in common genomic file types like BED, BEDPE, bigWig, 
and .hic files. While files can be read directly into `plotgardener` plotting 
functions, `plotgardener` also provides functions for reading in these large 
genomic data sets to work with them within the R environment:

- `readBigwig()`: Read in entire bigWig files, or read in specific 
genomic regions or strands of bigWig data. Please note that this function does
not work on Windows.
```{r eval=TRUE, echo=TRUE, message=FALSE}
bwFile <- system.file("extdata/test.bw", package="plotgardenerData")

## Read in entire file
bwFileData <- readBigwig(file = bwFile)

## Read in specified region
bwRegion <- readBigwig(file = bwFile,
                        chrom = "chr2",
                        chromstart = 1,
                        chromend = 1500)
     
## Read in specified region on "+" strand
bwRegionPlus <- readBigwig(file = bwFile,
                            chrom = "chr2",
                            chromstart = 1, 
                            chromend = 1500,
                            strand = "+")
```

The resulting file will contain `seqnames`, `start`, `end`, `width`, 
`strand`, and `score` columns:
```{r eval=TRUE, echo=TRUE}
head(bwRegion)
```

- `readHic()`: Read in genomic regions of .hic files with various 
data resolutions and normalizations.
```{r eval=TRUE, echo=TRUE, message=FALSE}
hicFile <- system.file("extdata/test_chr22.hic", package="plotgardenerData")

hicDataChrom <- readHic(file = hicFile,
    chrom = "22", assembly = "hg19",
    resolution = 250000, res_scale = "BP", norm = "NONE"
)

hicDataChromRegion <- readHic(file = hicFile,
    chrom = "22", assembly = "hg19",
    chromstart = 20000000, chromend = 47500000,
    resolution = 100000, res_scale = "BP", norm = "KR"
)

```

These data will be output in 3-column dataframe in sparse upper triangular 
matrix format:

```{r eval=TRUE, echo=TRUE}
head(hicDataChromRegion)
```

It is also possible to use `readHic` for interchromosomal Hi-C data:

```{r eval=FALSE, echo=TRUE, message=FALSE}
twoChroms <- readHic(file = "/path/to/hic",
    chrom = "chr1", altchrom = "chr2",
    resolution = 250000, res_scale = "BP"
)
```

For other filetypes, we recommend reading in files with `data.table` 
or `rtracklayer`.
```{r eval=FALSE, echo=TRUE, message=FALSE}
library(data.table)
data <- data.table::fread("/path/to/file")

library(rtracklayer)
data <- rtracklayer::import(con = "/path/to/file", format = "fileFormat")
```

### Session Info
```{r}
sessionInfo()
```

---
title: Our Philosophy
output: rmarkdown::html_vignette
vignette: >
    %\VignetteIndexEntry{Our Philosophy}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.height = 5,
    fig.width = 6,
    fig.align = "center"
)
library(plotgardener)
library(grid)
library(plotgardenerData)
```

<img src="../../man/figures/logo.png" align="left" width="20px" 
style="vertical-align: middle; background-color:white; border-color: transparent; margin: 9px" />

**`plotgardener` was developed to give users unparalleled control in plotting and**
**arranging multiple figures entirely within the R plotting environment.** 
**This functionality is motivated by the following design principles:**

## Coordinate-based plot placement

A coordinate-based plotting system provides users with exquisite control 
over plot sizes and arrangements through a user-defined page and common units of
measurement. This system makes the `plotgardener` plotting process intuitive 
and absolute, meaning that plots cannot be squished and stretched based on 
their *relative* sizes and placements. Users can create a page in their 
preferred size and unit of measurement:

```{r philosophy_1, eval=TRUE}
pageCreate(width = 3, height = 3, default.units = "inches")
```

and then make and precisely arrange plots within this defined landscape. If 
users want the top, left corner of their plot to be 0.5 inches down from the 
top of this page and 0.5 inches from the left:

```{r philosphy_2, echo=FALSE, eval=TRUE, message=FALSE}
pageCreate(width = 3, height = 3, default.units = "inches")
plotSegments(x0 = 0.5, y0 = 0, x1 = 0.5, y1 = 0.5, 
                arrow = arrow(angle = 30, 
                            length = unit(0.1, "inches"), 
                            ends = "last", type = "closed"), 
                fill = "black")
plotSegments(x0 = 0, y0 = 0.5, x1 = 0.5, y1 = 0.5, 
                arrow = arrow(angle = 30, 
                            length = unit(0.1, "inches"), 
                            ends = "last", type = "closed"),
                fill = "black")
plotText(label = "0.5 in", x = 0.6, y = 0.25, just = "left")
plotText(label = "0.5 in", x = 0.25, y = 0.6, just = "top")
```

and users want their plot be 2 inches wide and 1 inch tall:

```{r philosphy_3, echo=FALSE, eval=TRUE, message=FALSE}
pageCreate(width = 3, height = 3, default.units = "inches")
plotSegments(x0 = 0.5, y0 = 0, x1 = 0.5, y1 = 0.5, 
                arrow = arrow(angle = 30, 
                            length = unit(0.1, "inches"), 
                            ends = "last", type = "closed"), 
                fill = "black")
plotSegments(x0 = 0, y0 = 0.5, x1 = 0.5, y1 = 0.5, 
                arrow = arrow(angle = 30, 
                            length = unit(0.1, "inches"), 
                            ends = "last", type = "closed"), 
                fill = "black")
plotSegments(x0 = 0.5, y0 = 0.5, x1 = 2.5, y1 = 0.5, fill = "black", 
                arrow = arrow(angle = 30, 
                            length = unit(0.1, "inches"), 
                            ends = "both", type = "closed"))
plotSegments(x0 = 0.5, y0 = 0.5, x1 = 0.5, y1 = 1.5, fill = "black", 
                arrow = arrow(angle = 30, 
                            length = unit(0.1, "inches"), 
                            ends = "both", type = "closed"))
plotText(label = "2 in", x = 1.5, y = 0.4, just = "bottom")
plotText(label = "1 in", x = 0.4, y = 1, just = "right")
```

`plotgardener` can make the plot with these exact parameters:

```{r philosophy_4, echo=TRUE, eval=TRUE, message=FALSE}
## Create plotgardener page
pageCreate(width = 3, height = 3, default.units = "inches")

## Load signal data
data("IMR90_ChIP_H3K27ac_signal")

## Plot and place signal data with precise measurements
signalPlot <- plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    x = 0.5, y = 0.5, width = 2, height = 1,
    just = c("left", "top"), default.units = "inches"
)
```

This exact plot sizing and placement is particularly important and useful 
for standardized and accurate data comparisons along the x and y-axes. 

## Containerized, edge-to-edge visualizations

With the stacked nature of genomic plots, it is critical that aligned plots 
correspond to the same genomic regions to ensure figure accuracy. By 
separating data plotting from plot annotations, data fills defined plot 
coordinates and dimensions from edge to edge and precisely preserves the 
mapping between the data and its user-defined container. For example, if a 
user creates a 2 inch-wide gene track and wants that plot to represent the 
genomic region chr8:1000000-2000000, this genomic region will exactly span 
the 2 inch width:

```{r philosphy_5, echo=TRUE, eval=TRUE, message=FALSE, warning=FALSE}
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)

## Create plotgardener page
pageCreate(width = 3, height = 2, default.units = "inches")

## Define genomic region with `pgParams`
genomicRegion <- pgParams(chrom = "chr8", 
                        chromstart = 1000000, chromend = 2000000,
                        assembly = "hg19")

## Plot genes with background color highlighting size
genesPlot <- plotGenes(
    params = genomicRegion, bg = "#f6f6f6",
    x = 0.5, y = 0.5, width = 2, height = 1,
    just = c("left", "top"), default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(
    plot = genesPlot, scale = "Mb",
    x = 0.5, y = 1.5,
    just = c("left", "top"), default.units = "inches"
)
```

When it's time to stack various data types along the same genomic region, 
users can be confident in accurately aligning containers of the same width:

```{r philosphy_6, echo=TRUE, eval=TRUE, message=FALSE, warning=FALSE}
## Load data
library(plotgardenerData)
data("IMR90_HiC_10kb")
data("IMR90_DNAloops_pairs")
data("IMR90_ChIP_H3K27ac_signal")

## Define genomic region and widths of all plots
params <- pgParams(
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = unit(0.5, "inches"), width = unit(2, "inches")
)

## Create plotgardener page
pageCreate(width = 3, height = 4, default.units = "inches")

## Plot Hi-C data in region
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    params = params,
    y = 0.5, height = 2,
    just = c("left", "top"), default.units = "inches"
)


## Plot and align DNA loops in region
bedpeLoops <- plotPairsArches(
    data = IMR90_DNAloops_pairs,
    params = params, fill = "black", linecolor = "black",
    y = 2.6, height = 0.45,
    just = c("left", "top"), default.units = "inches"
)

## Plot and align signal track in region
signalPlot <- plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    params = params,
    y = 3.1, height = 0.45,
    just = c("left", "top"), default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(
    plot = signalPlot,
    params = params, scale = "Mb",
    y = 3.57, just = c("left", "top"), default.units = "inches"
)
```

## Programmatic and reproducible multi-panel figures

Data visualization is most rigorous and accurate when it is reproducible. 
Although many visualizations are initially designed with code, final 
customizations and arrangements of figures are typically made with third 
party graphic design software and cannot be easily replicated. `plotgardener` 
makes this entire process programmatic, from raw data input to finalized, 
complex visualization. This means that if users define the same data:

```{r eval=TRUE, echo = TRUE, message=FALSE,warning=FALSE}
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)
library(ggplot2)
data(mtcars)
library(plotgardenerData)
data("IMR90_HiC_10kb")
head(IMR90_HiC_10kb)
```

and the same `plotgardener` code:

```{r eval=FALSE}
## Create a plotgardener page
pageCreate(width = 7, height = 3.5, default.units = "inches")

## Define genomic region with `params`
params <- pgParams(chrom = "chr21", 
                    chromstart = 28000000, chromend = 30300000,
                    assembly = "hg19")

## Plot Hi-C data
hicPlot <- plotHicTriangle(
    data = IMR90_HiC_10kb,
    params = params,
    x = 0.5, y = 0.5, width = 3, height = 1.5,
    just = c("left", "top"), default.units = "inches"
)

## Add color scale annotation
annoHeatmapLegend(
    plot = hicPlot,
    x = 3.5, y = 0.5, width = 0.12, height = 1,
    just = c("right", "top"), default.units = "inches"
)

## Plot gene track in same genomic region
genesPlot <- plotGenes(
    params = params,
    x = 0.5, y = 2.25, width = 3, height = 0.5,
    just = c("left", "top"), default.units = "inches"
)

## Label genomic region
annoGenomeLabel(
    plot = genesPlot,
    x = 0.5, y = 2.8, just = c("left", "top"), default.units = "inches"
)

## Create and place mtcars boxplot
boxPlot <- ggplot(mtcars) +
    geom_boxplot(aes(gear, disp, group = gear))
plotGG(
    plot = boxPlot,
    x = 4, y = 0.5, width = 2.5, height = 2,
    just = c("left", "top"), default.units = "inches"
)

## Label panels
plotText(
    label = "A", fontsize = 16, fontface = "bold",
    x = 0.75, y = 0.5, just = "center", default.units = "inches"
)
plotText(
    label = "B", fontsize = 16, fontface = "bold",
    x = 3.75, y = 0.5, just = "center", default.units = "inches"
)

## Hide page guides
pageGuideHide()
```

they will generate the **exact same** multi-panel visualization:

```{r philosophy_7, eval=TRUE, message=FALSE, echo=FALSE, fig.width=8}
## Create a plotgardener page
pageCreate(
    width = 7, height = 3.5, default.units = "inches",
    xgrid = 0, ygrid = 0, showGuides = FALSE
)

## Define genomic region with `params`
params <- pgParams(chrom = "chr21", 
                    chromstart = 28000000, chromend = 30300000,
                    assembly = "hg19")

## Plot Hi-C data
hicPlot <- plotHicTriangle(
    data = IMR90_HiC_10kb,
    params = params,
    x = 0.5, y = 0.5, width = 3, height = 1.5,
    just = c("left", "top"), default.units = "inches"
)

## Add color scale annotation
annoHeatmapLegend(
    plot = hicPlot,
    x = 3.5, y = 0.5, width = 0.12, height = 1,
    just = c("right", "top"), default.units = "inches"
)

## Plot gene track in same genomic region
genesPlot <- plotGenes(
    params = params,
    x = 0.5, y = 2.25, width = 3, height = 0.5,
    just = c("left", "top"), default.units = "inches"
)

## Label genomic region
annoGenomeLabel(
    plot = genesPlot,
    x = 0.5, y = 2.8, just = c("left", "top"), default.units = "inches"
)

## Create and place mtcars boxplot
boxPlot <- ggplot(mtcars) +
    geom_boxplot(aes(gear, disp, group = gear))
plotGG(
    plot = boxPlot,
    x = 4, y = 0.5, width = 2.5, height = 2,
    just = c("left", "top"), default.units = "inches"
)

## Label panels
plotText(
    label = "A", fontsize = 16, fontface = "bold",
    x = 0.75, y = 0.5, just = "center", default.units = "inches"
)
plotText(
    label = "B", fontsize = 16, fontface = "bold",
    x = 3.75, y = 0.5, just = "center", default.units = "inches"
)
```

Not only does this make visualizations entirely reproducible with code, 
but it also makes it easy to change data ranges and aesthetics with 
simple pieces of code:

```{r eval=FALSE}
## Change colors while maintaining plot layout
hicPlot <- plotHicTriangle(
    data = IMR90_HiC_10kb,
    params = params,
    palette = colorRampPalette(c("white", "steel blue")),
    x = 0.5, y = 0.5, width = 3, height = 1.5,
    just = c("left", "top"), default.units = "inches"
)

genesPlot <- plotGenes(
    params = params,
    fill = c("grey", "grey"), fontcolor = c("black", "black"),
    x = 0.5, y = 2.25, width = 3, height = 0.5,
    just = c("left", "top"), default.units = "inches"
)
```

```{r philosophy_8, eval=TRUE, message=FALSE, echo=FALSE, fig.width=8}
## Create a plotgardener page
pageCreate(
    width = 7, height = 3.5, default.units = "inches",
    xgrid = 0, ygrid = 0, showGuides = FALSE
)

## Define genomic region with `pgParams`
params <- pgParams(chrom = "chr21", 
                    chromstart = 28000000, chromend = 30300000,
                    assembly = "hg19")

## Plot Hi-C data
hicPlot <- plotHicTriangle(
    data = IMR90_HiC_10kb,
    params = params,
    palette = colorRampPalette(c("white", "steel blue")),
    x = 0.5, y = 0.5, width = 3, height = 1.5,
    just = c("left", "top"), default.units = "inches"
)

## Add color scale annotation
annoHeatmapLegend(
    plot = hicPlot,
    x = 3.5, y = 0.5, width = 0.12, height = 1,
    just = c("right", "top"), default.units = "inches"
)

## Plot gene track in same genomic region
genesPlot <- plotGenes(
    params = params,
    fill = c("grey", "grey"), fontcolor = c("black", "black"),
    x = 0.5, y = 2.25, width = 3, height = 0.5,
    just = c("left", "top"), default.units = "inches"
)

## Label genomic region
annoGenomeLabel(
    plot = genesPlot,
    x = 0.5, y = 2.8, just = c("left", "top"), default.units = "inches"
)

## Create and place mtcars boxplot
boxPlot <- ggplot(mtcars) +
    geom_boxplot(aes(gear, disp, group = gear))
plotGG(
    plot = boxPlot,
    x = 4, y = 0.5, width = 2.5, height = 2,
    just = c("left", "top"), default.units = "inches"
)

## Label panels
plotText(
    label = "A", fontsize = 16, fontface = "bold",
    x = 0.75, y = 0.5, just = "center", default.units = "inches"
)
plotText(
    label = "B", fontsize = 16, fontface = "bold",
    x = 3.75, y = 0.5, just = "center", default.units = "inches"
)
```

## Utilizing `grid` graphics `viewports`

`plotgardener` achieves its functionality through `grid` graphics `viewports`, 
or defined graphical regions. A `plotgardener` page is defined by one large 
`viewport` with specified dimensions and units. Subsequent plots each have 
their own `viewport` that are placed on the larger page `viewport`. These 
`viewports` give users the power to specify the size and placement of each 
plot's container and clip data to precise axis measurements.

---
title: "Plotting Multi-omic Data"
output:
    rmarkdown::html_vignette
vignette: >
    %\VignetteIndexEntry{Plotting Multi-omic Data}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
    fig.align = "center",
    fig.width = 3,
    fig.height = 3,
    collapse = TRUE,
    comment = "#>",
    warning = FALSE,
    message = FALSE
)
library(grid)
library(plotgardener)
library(plotgardenerData)
```

`plotgardener` makes it easy to create reproducible, publication-quality figures 
from multi-omic data. Since each plot can be placed in *exactly* the desired 
location, users can stack multiple types of genomic data so that their axes 
and data are correctly aligned. In this section we will show some examples of 
plotting multi-omic data and how the `pgParams` object and "below" 
y-coordinate can facilitate this process. 

In the following example, we plot the same genomic region 
(i.e. `chr21:28000000-30300000`) represented in Hi-C data, loop annotations, 
signal track data, GWAS data, all along a common gene track and genome 
label axis:

```{r plotting_example01, echo=TRUE, fig.height=6, fig.width=5, message=FALSE}
## Load example data
library(plotgardenerData)
data("IMR90_HiC_10kb")
data("IMR90_DNAloops_pairs")
data("IMR90_ChIP_H3K27ac_signal")
data("hg19_insulin_GWAS")

## Create a plotgardener page
pageCreate(
    width = 3, height = 5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

## Plot Hi-C data in region
plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 0.5, width = 2, height = 2,
    just = c("left", "top"), default.units = "inches"
)

## Plot loop annotations
plotPairsArches(
    data = IMR90_DNAloops_pairs,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 2.5, width = 2, height = 0.25,
    just = c("left", "top"), default.units = "inches",
    fill = "black", linecolor = "black", flip = TRUE
)

## Plot signal track data
plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 2.75, width = 2, height = 0.5,
    just = c("left", "top"), default.units = "inches"
)

## Plot GWAS data
plotManhattan(
    data = hg19_insulin_GWAS,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    ymax = 1.1, cex = 0.20,
    x = 0.5, y = 3.5, width = 2, height = 0.5,
    just = c("left", "top"), default.units = "inches"
)

## Plot gene track
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)
plotGenes(
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 4, width = 2, height = 0.5,
    just = c("left", "top"), default.units = "inches"
)

## Plot genome label
plotGenomeLabel(
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 4.5, length = 2, scale = "Mb",
    just = c("left", "top"), default.units = "inches"
)
```

## Using the `pgParams` object

The `pgParams()` function creates a `pgParams` object that can contain any 
argument from `plotgardener` functions.  

We can recreate and simplify the multi-omic plot above by saving the genomic 
region, left-based x-coordinate, and width into a `pgParams` object:

```{r eval=TRUE, message=FALSE, echo=TRUE}
params <- pgParams(
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, just = c("left", "top"),
    width = 2, length = 2, default.units = "inches"
)
```

Since these values are the same for each of the functions we are using to 
build our multi-omic figure, we can now pass the `pgParams` object into 
our functions so we don't need to write the same parameters over and over 
again:

```{r plotting_example02, echo=TRUE, fig.height=6, fig.width=5, message=FALSE}
## Load example data
data("IMR90_HiC_10kb")
data("IMR90_DNAloops_pairs")
data("IMR90_ChIP_H3K27ac_signal")
data("hg19_insulin_GWAS")

## Create a plotgardener page
pageCreate(
    width = 3, height = 5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

## Plot Hi-C data in region
plotHicSquare(
    data = IMR90_HiC_10kb,
    params = params,
    y = 0.5, height = 2
)

## Plot loop annotations
plotPairsArches(
    data = IMR90_DNAloops_pairs,
    params = params,
    y = 2.5, height = 0.25,
    fill = "black", linecolor = "black", flip = TRUE
)

## Plot signal track data
plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    params = params,
    y = 2.75, height = 0.5
)

## Plot GWAS data
plotManhattan(
    data = hg19_insulin_GWAS,
    params = params,
    ymax = 1.1, cex = 0.20,
    y = 3.5, height = 0.5
)

## Plot gene track
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)
plotGenes(
    params = params,
    y = 4, height = 0.5
)

## Plot genome label
plotGenomeLabel(
    params = params,
    y = 4.5, scale = "Mb"
)
```

The `pgParams` object also simplifies the code for making complex multi-omic 
figures when we want to change the genomic region of our plots. If we want to 
change the region for the figure above, we can simply put it into the 
`pgParams` object and re-run the code to generate the figure:

```{r eval=TRUE, echo=TRUE, message=FALSE}
params <- pgParams(
    chrom = "chr21", chromstart = 29000000, chromend = 30000000,
    assembly = "hg19",
    x = 0.5, just = c("left", "top"),
    width = 2, length = 2, default.units = "inches"
)
```

```{r plotting_example03, echo=FALSE, fig.height=6, fig.width=5, message=FALSE}
## Load example data
data("IMR90_HiC_10kb")
data("IMR90_DNAloops_pairs")
data("IMR90_ChIP_H3K27ac_signal")
data("hg19_insulin_GWAS")

## Create a plotgardener page
pageCreate(
    width = 3, height = 5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

## Plot Hi-C data in region
plotHicSquare(
    data = IMR90_HiC_10kb,
    params = params,
    y = 0.5, height = 2
)

## Plot loop annotations
plotPairsArches(
    data = IMR90_DNAloops_pairs,
    params = params,
    y = 2.5, height = 0.25,
    fill = "black", linecolor = "black", flip = TRUE
)

## Plot signal track data
plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    params = params,
    y = 2.75, height = 0.5
)

## Plot GWAS data
plotManhattan(
    data = hg19_insulin_GWAS,
    params = params,
    ymax = 1.1, cex = 0.20,
    y = 3.5, height = 0.5
)

## Plot gene track
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)
plotGenes(
    params = params,
    y = 4, height = 0.5
)

## Plot genome label
plotGenomeLabel(
    params = params,
    y = 4.5, scale = "Mb"
)
```

Alternatively, if we want to plot around a particular gene rather than a 
genomic region we can use `pgParams()` to specify `gene` and `geneBuffer`. 
If `geneBuffer` is not included, the default buffer adds `(gene length) / 2` 
base pairs to the ends of the gene coordinates.

```{r eval=TRUE, echo=TRUE, message=FALSE}
params <- pgParams(
    gene = "LINC00113", geneBuffer = 100000, assembly = "hg19",
    x = 0.5, just = c("left", "top"),
    width = 2, length = 2, default.units = "inches"
)
```
```{r plotting_example04, echo=FALSE, fig.height=6, fig.width=5, message=FALSE}
## Load example data
data("IMR90_HiC_10kb")
data("IMR90_DNAloops_pairs")
data("IMR90_ChIP_H3K27ac_signal")
data("hg19_insulin_GWAS")

## Create a plotgardener page
pageCreate(
    width = 3, height = 5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

## Plot Hi-C data in region
plotHicSquare(
    data = IMR90_HiC_10kb,
    params = params,
    y = 0.5, height = 2
)

## Plot loop annotations
plotPairsArches(
    data = IMR90_DNAloops_pairs,
    params = params,
    y = 2.5, height = 0.25,
    fill = "black", linecolor = "black", flip = TRUE
)

## Plot signal track data
plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    params = params,
    y = 2.75, height = 0.5
)

## Plot GWAS data
plotManhattan(
    data = hg19_insulin_GWAS,
    params = params,
    ymax = 1.1, cex = 0.20,
    y = 3.5, height = 0.5
)

## Plot gene track
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)
plotGenes(
    params = params,
    y = 4, height = 0.5
)

## Plot genome label
plotGenomeLabel(
    params = params,
    y = 4.5, scale = "bp", fontsize = 7
)
```

## The "below" y-coordinate

Since multi-omic plots often involve vertical stacking, the placement of 
multi-omic plots can be facilitated with the "below" y-coordinate. Rather than
providing a `numeric` value or `unit` object to the `y` parameter in plotting 
functions, we can place a plot below the previously drawn `plotgardener` plot with 
a `character` value consisting of the distance below the last plot, in page 
units, and "b". For example, on a page made in inches, `y = "0.1b"` will place 
a plot 0.1 inches below the last drawn plot.

We can further simplify the placement code of our multi-omic figure above by 
using the "below" y-coordinate to easily stack our plots:

```{r below_y, echo=TRUE, fig.height=6, fig.width=5, message=FALSE}
## Load example data
data("IMR90_HiC_10kb")
data("IMR90_DNAloops_pairs")
data("IMR90_ChIP_H3K27ac_signal")
data("hg19_insulin_GWAS")

## pgParams
params <- pgParams(
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, just = c("left", "top"),
    width = 2, length = 2, default.units = "inches"
)

## Create a plotgardener page
pageCreate(
    width = 3, height = 5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

## Plot Hi-C data in region
plotHicSquare(
    data = IMR90_HiC_10kb,
    params = params,
    y = 0.5, height = 2
)

## Plot loop annotations
plotPairsArches(
    data = IMR90_DNAloops_pairs,
    params = params,
    y = "0b",
    height = 0.25,
    fill = "black", linecolor = "black", flip = TRUE
)

## Plot signal track data
plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    params = params,
    y = "0b",
    height = 0.5
)

## Plot GWAS data
plotManhattan(
    data = hg19_insulin_GWAS,
    params = params,
    ymax = 1.1, cex = 0.20,
    y = "0.25b",
    height = 0.5
)

## Plot gene track
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)
plotGenes(
    params = params,
    y = "0b",
    height = 0.5
)

## Plot genome label
plotGenomeLabel(
    params = params,
    y = "0b",
    scale = "Mb"
)
```

## Plotting and comparing multiple signal tracks

In many multi-omic visualizations, multiple signal tracks are often aligned 
and stacked to compare different kinds of signal data and/or signals
from different samples. **`plotgardener` does not normalize signal data** 
**based on variables like read depth**, but it is possible to 
**scale** `plotgardener` signal plots to the same y-axis.

To determine the appropriate y-axis range, we first must get the
maximum signal score from all of our datasets to be compared:

```{r eval=TRUE, echo=TRUE}
library(plotgardenerData)
data("IMR90_ChIP_H3K27ac_signal")
data("GM12878_ChIP_H3K27ac_signal")

maxScore <- max(c(IMR90_ChIP_H3K27ac_signal$score, 
                    GM12878_ChIP_H3K27ac_signal$score))
print(maxScore)
```

In each of our signal plotting calls, we will then use the
`range` parameter to set the range of both our y-axes to
`c(0, maxScore)`. Here we can do this with our `pgParams` object:

```{r echo=TRUE, eval=TRUE}
params <- pgParams(
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    range = c(0, maxScore)
)
```

We are now ready to plot, align, and compare our signal plots along 
the genomic x-axis and the score y-axis:
```{r scale_signal, fig.height=2.1, fig.width=7.5, eval=TRUE, echo=TRUE}
## Create a page
pageCreate(width = 7.5, height = 2.1, default.units = "inches",
            showGuides = FALSE, xgrid = 0, ygrid = 0)

## Plot and place signal plots
signal1 <- plotSignal(
    data = IMR90_ChIP_H3K27ac_signal, params = params,
    x = 0.5, y = 0.25, width = 6.5, height = 0.65,
    just = c("left", "top"), default.units = "inches"
)

signal2 <- plotSignal(
    data = GM12878_ChIP_H3K27ac_signal, params = params,
    linecolor = "#7ecdbb",
    x = 0.5, y = 1, width = 6.5, height = 0.65,
    just = c("left", "top"), default.units = "inches"
)

## Plot genome label
plotGenomeLabel(
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 1.68, length = 6.5,
    default.units = "inches"
)

## Add text labels
plotText(
    label = "IMR90", fonsize = 10, fontcolor = "#37a7db",
    x = 0.5, y = 0.25, just = c("left", "top"),
    default.units = "inches"
)
plotText(
    label = "GM12878", fonsize = 10, fontcolor = "#7ecdbb",
    x = 0.5, y = 1, just = c("left", "top"),
    default.units = "inches"
)
```

# Session Info
```{r}
sessionInfo()
```

---
title: Introduction to plotgardener
author: "Nicole Kramer, Eric S. Davis, Craig Wenger, Sarah Parker, \
    Erika Deoudes, Michael Love, Douglas H. Phanstiel"
output: 
    rmarkdown::html_vignette: 
        md_extensions: +grid_tables
vignette: >
    %\VignetteIndexEntry{Introduction to plotgardener}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    fig.align = "center",
    fig.width = 3,
    fig.height = 3,
    collapse = TRUE,
    warning = FALSE,
    message = FALSE
)
library(grid)
library(plotgardener)
library(plotgardenerData)
```

# Overview

```{=html}
<img src="../man/figures/pg-hex-text.png" align="right" width="140px" 
style="padding-left:20px; background-color:white; border-color: transparent" />
```
`plotgardener` is a coordinate-based, genomic visualization package for R. Using
`grid` graphics, `plotgardener` empowers users to programmatically and flexibly
generate multi-panel figures. Tailored for genomics for a variety of genomic
assemblies, `plotgardener` allows users to visualize large, complex genomic
datasets while providing exquisite control over the arrangement of plots.

`plotgardener` functions can be grouped into the following categories:

-   **Page layout functions:**

Functions for creating `plotgardener` page layouts, drawing, showing, and hiding
guides, as well as placing plots on the page. See [The plotgardener
Page](https://phanstiellab.github.io/plotgardener/articles/guides/plotgardener_page.html)

-   **Reading functions:**

Functions for quickly reading in large biological datasets. See [Reading Data
for plotgardener](https://phanstiellab.github.io/plotgardener/articles/guides/reading_data_for_plotgardener.html)

-   **Plotting functions:**

Contains genomic plotting functions, functions for placing `ggplots` and `base`
plots, as well as functions for drawing simple shapes. See [Plotting Multi-omic
Data](https://phanstiellab.github.io/plotgardener/articles/guides/plotting_multiomic_data.html)

-   **Annotation functions:**

Enables users to add annotations to their plots, such as legends, axes, and
scales. See [Plot Annotations](https://phanstiellab.github.io/plotgardener/articles/guides/annotations.html)

-   **Meta functions:**

Functions that display `plotgardener` properties or operate on other
`plotgardener` functions, or constructors for `plotgardener` objects. See
[plotgardener Meta Functions](https://phanstiellab.github.io/plotgardener/articles/guides/plotgardener_meta_functions.html)

This vignette provides a quick start guide for utilizing `plotgardener`. For
in-depth demonstrations of `plotgardener`'s key features, see the additional
articles. For detailed usage of each function, see the function-specific
reference examples with `?function()` (e.g. `?plotPairs()`).

All the data included in this vignette can be found in the supplementary package
`plotgardenerData`.

# Quick plotting

`plotgardener` plotting functions contain 4 types of arguments:

1.  Data reading argument (`data`)

2.  Genomic locus arguments (`chrom`, `chromstart`, `chromend`, `assembly`)

3.  Placement arguments (`x`, `y`, `width`, `height`, `just`, `default.units`,
    ...) that define where each plot resides on a `page`

4.  Attribute arguments that affect the data being plotted or the style of the
    plot (`norm`, `fill`, `fontcolor`, ...) that vary between functions

The quickest way to plot data is to omit the placement arguments. This will
generate a `plotgardener` plot that fills up the entire graphics window and
cannot be annotated. **These plots are only meant to be used for quick**
**genomic data inspection and not as final `plotgardener` plots.** The only
arguments that are required are the data arguments and locus arguments. The
examples below show how to quickly plot different types of genomic data with
plot defaults and included data types. To use your own data, replace the `data`
argument with either a path to the file or an R object as described above.

## Hi-C matrices

```{r hic_quickplot, eval=TRUE, echo=TRUE, message=FALSE}
## Load plotgardener
library(plotgardener)

## Load example Hi-C data
library(plotgardenerData)
data("IMR90_HiC_10kb")

## Quick plot Hi-C data
plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19"
)
```

## Signal tracks

```{r signal_quickplot, eval=TRUE, echo=TRUE, message=FALSE}
## Load plotgardener
library(plotgardener)

## Load example signal data
library(plotgardenerData)
data("IMR90_ChIP_H3K27ac_signal")

## Quick plot signal data
plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19"
)
```

## Gene tracks

```{r gene_quickplot, eval=TRUE, echo=TRUE, message=FALSE}
## Load plotgardener
library(plotgardener)

## Load hg19 genomic annotation packages
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)

## Quick plot genes
plotGenes(
    assembly = "hg19",
    chrom = "chr21", chromstart = 28000000, chromend = 30300000
)
```

## GWAS Manhattan plots

```{r gwas_quickplot, eval=TRUE, echo=TRUE, message=FALSE}
## Load plotgardener
library(plotgardener)

## Load hg19 genomic annotation packages
library(TxDb.Hsapiens.UCSC.hg19.knownGene)

## Load example GWAS data
library(plotgardenerData)
data("hg19_insulin_GWAS")

## Quick plot GWAS data
plotManhattan(
    data = hg19_insulin_GWAS, 
    assembly = "hg19",
    fill = c("steel blue", "grey"),
    ymax = 1.1, cex = 0.20
)
```

# Plotting and annotating on the `plotgardener` page

To build complex, multi-panel `plotgardener` figures with annotations, we must:

1.  Create a `plotgardener` coordinate page with `pageCreate()`.

```{r quickpage, echo=TRUE, fig.height=4, fig.width=4, message=FALSE}
pageCreate(width = 3.25, height = 3.25, default.units = "inches")
```

2.  Provide values for the placement arguments (`x`, `y`, `width`, `height`,
    `just`, `default.units`) in plotting functions and save the output of the
    plotting function.

```{r eval=FALSE, echo=TRUE, message=FALSE}
data("IMR90_HiC_10kb")
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)
```

```{r quickpageHic, echo=FALSE, fig.height=4, fig.width=4, message=FALSE}
pageCreate(width = 3.25, height = 3.25, default.units = "inches")
data("IMR90_HiC_10kb")
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)
```

3.  Annotate `plotgardener` plot objects by passing them into the `plot`
    argument of annotation functions.

```{r eval=FALSE, echo=TRUE, message=FALSE}
annoHeatmapLegend(
    plot = hicPlot,
    x = 2.85, y = 0.25, width = 0.1, height = 1.25, default.units = "inches"
)

annoGenomeLabel(
    plot = hicPlot,
    x = 0.25, y = 2.75, width = 2.5, height = 0.25, default.units = "inches"
)
```

```{r quickpageAnno, echo=FALSE, fig.height=4, fig.width=4, message=FALSE}
pageCreate(width = 3.25, height = 3.25, default.units = "inches")
data("IMR90_HiC_10kb")
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)
annoHeatmapLegend(
    plot = hicPlot,
    x = 2.85, y = 0.25, width = 0.1, height = 1.25, default.units = "inches"
)

annoGenomeLabel(
    plot = hicPlot,
    x = 0.25, y = 2.75, width = 2.5, height = 0.25, default.units = "inches"
)
```

For more information about how to place plots and annotations on a
`plotgardener` page, check out the section [Working with plot
objects](https://phanstiellab.github.io/plotgardener/articles/guides/plotgardener_page.html#working-with-plot-objects).

# Exporting plots

When a `plotgardener` plot is ready to be saved and exported, we can first
remove all page guides that were made with `pageCreate()`:

```{r eval=FALSE, echo=TRUE, message=FALSE}
pageGuideHide()
```

```{r quickpageHide, echo=FALSE, fig.height=4, fig.width=4, message=FALSE}
pageCreate(
    width = 3.25, height = 3.25, default.units = "inches",
    xgrid = 0, ygrid = 0, showGuides = FALSE
)
data("IMR90_HiC_10kb")
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)
annoHeatmapLegend(
    plot = hicPlot,
    x = 2.85, y = 0.25, width = 0.1, height = 1.25, default.units = "inches"
)

annoGenomeLabel(
    plot = hicPlot,
    x = 0.25, y = 2.75, width = 2.5, height = 0.25, default.units = "inches"
)
```

We can then either use the **Export** toggle in the RStudio plot panel, or save
the plot within our R code as follows:

```{r eval=FALSE, echo=TRUE, message=FALSE}
pdf(width = 3.25, height = 3.25)

pageCreate(width = 3.25, height = 3.25, default.units = "inches")
data("IMR90_HiC_10kb")
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)
annoHeatmapLegend(
    plot = hicPlot,
    x = 2.85, y = 0.25, width = 0.1, height = 1.25, default.units = "inches"
)

annoGenomeLabel(
    plot = hicPlot,
    x = 0.25, y = 2.75, width = 2.5, height = 0.25, default.units = "inches"
)
pageGuideHide()

dev.off()
```

**Please note that due to the implementation of `grid` removal functions,**
**using `pageGuideHide` within a `pdf` call will result in the rendering of a**
**separate, new page with the plot guides removed. To avoid this artifact,**
**hide guides in the `pageCreate` function call with `showGuides = FALSE`.**

For more detailed usage and examples, please refer to the other available
vignettes.

# Future Directions

We still have many ideas to add for a second version of `plotgardener`
including, but not limited to: grammar of graphics style plot arguments and plot
building, templates, themes, and multi-plotting functions. If you have
suggestions for ways we can improve `plotgardener`, please let us know!

# Session Info

```{r}
sessionInfo()
```

---
title: "Incorporating `ggplots` and other `grid`-based Bioconductor visualizations"
output:
    rmarkdown::html_vignette
vignette: >
    %\VignetteIndexEntry{Incorporating `ggplots` and other `grid`-based Bioconductor visualizations}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
    fig.align = "center",
    fig.width = 3,
    fig.height = 3,
    collapse = TRUE,
    comment = "#>",
    warning = FALSE,
    message = FALSE
)
library(grid)
library(plotgardener)
library(plotgardenerData)
```

```{r eval=TRUE, echo=FALSE, message=FALSE}
library(showtext)
font_add(
    family = "ProximaNova",
    regular = system.file("extdata",
                        "proximanova-regular.otf",
                        package = "plotgardener"
    ),
    bold = system.file("extdata",
                    "proximanova-semibold.otf",
                    package = "plotgardener"
    ),
    italic = system.file("extdata",
                        "proximanova-regitalic.otf",
                        package = "plotgardener")
)
showtext_auto()
```

In addition to its numerous built-in genomic functions, `plotgardener` can size 
and place `ggplots` and other `grid`-based visualizations within a 
`plotgardener` layout. Rather than arranging these plots in a 
relative manner, `plotgardener` can make and place these plots in absolute sizes 
and locations. This makes it simple and intuitive to make complex and combined 
`plotgardener`,`ggplot`, and other `grid` plot arrangements beyond a 
basic grid-style layout.

## `ggplots`

Let's say we wanted to make a complex multi-panel `ggplot` about 
COVID-19 data consisting of the following plots:

1) A United States map depicting COVID-19 cases:

```{r ggplot_01, echo=TRUE, fig.showtext=TRUE, message=FALSE, warning=FALSE}
library(ggplot2)
library(scales)
data("COVID_USA_cases")

US_map <- ggplot(COVID_USA_cases, aes(long, lat, group = group)) +
    theme_void() +
    geom_polygon(aes(fill = cases_100K), color = "white", size = 0.3) +
    scale_fill_distiller(
        palette = "YlGnBu", direction = 1,
        labels = label_number(suffix = "", scale = 1e-3, accuracy = 1)
    ) +
    theme(
        legend.position = "left",
        legend.justification = c(0.5, 0.95),
        legend.title = element_blank(),
        legend.text = element_text(size = 7),
        legend.key.width = unit(0.3, "cm"),
        legend.key.height = unit(0.4, "cm"),
        plot.title = element_text(
            hjust = 0, vjust = -1,
            family = "ProximaNova", face = "bold",
            size = 12
        ),
        plot.title.position = "plot"
    ) +
    labs(title = "Thousands of COVID-19 Cases per 100,000 People") +
    coord_fixed(1.3)

print(US_map)
```

2) Line plots showing the accumulation of COVID-19 cases over time:

```{r ggplot_02, echo=TRUE, fig.showtext=TRUE, message=FALSE}
data("COVID_NY_FL_tracking")

# Format y-labels
ylabels <- seq(0, 2000000, by = 500000) / 1e6
ylabels[c(3, 5)] <- round(ylabels[c(3, 5)], digits = 0)
ylabels[c(2, 4)] <- round(ylabels[c(2, 4)], digits = 1)
ylabels[5] <- paste0(ylabels[5], "M cases")
ylabels[1] <- ""

casesNY <- COVID_NY_FL_tracking[COVID_NY_FL_tracking$state == "new york", ]
casesNYpoly <- rbind(
    casesNY,
    data.frame(
        "date" = as.Date("2021-03-07"),
        "state" = "new york",
        "caseIncrease" = -1 * sum(casesNY$caseIncrease)
    )
)

cases_NYline <- ggplot(
    casesNY,
    aes(x = date, y = cumsum(caseIncrease))
) +
    geom_polygon(data = casesNYpoly, fill = "#B8E6E6") +
    scale_x_date(
        labels = date_format("%b '%y"),
        breaks = as.Date(c("2020-05-01", "2020-09-01", "2021-01-01")),
        limits = as.Date(c("2020-01-29", "2021-03-07")),
        expand = c(0, 0)
    ) +
    scale_y_continuous(labels = ylabels, position = "right", expand = c(0, 0)) +
    geom_hline(
        yintercept = c(500000, 1000000, 1500000, 2000000),
        color = "white", linetype = "dashed", size = 0.3
    ) +
    coord_cartesian(ylim = c(0, 2000000)) +
    theme(
        panel.background = element_rect(fill = "transparent", color = NA),
        text = element_text(family = "ProximaNova"),
        panel.grid = element_blank(),
        panel.border = element_blank(),
        plot.background = element_rect(fill = "transparent", color = NA),
        axis.line.x.bottom = element_blank(),
        axis.line.y = element_line(size = 0.1, color = "#8F9BB3"),
        axis.text.x = element_text(
            size = 7, hjust = 0.5,
            margin = margin(t = -10), color = "black"
        ),
        axis.title.x = element_blank(),
        axis.ticks.x = element_line(size = 0.2, color = "black"),
        axis.title.y = element_blank(),
        axis.text.y = element_text(size = 7, color = "black"),
        axis.ticks.y = element_blank(),
        axis.ticks.length.x.bottom = unit(-0.1, "cm"),
        plot.title = element_text(size = 8, hjust = 1),
        plot.title.position = "plot"
    )

print(cases_NYline)
```

```{r ggplot_03, echo=TRUE, fig.showtext=TRUE, message=FALSE}
casesFL <- COVID_NY_FL_tracking[COVID_NY_FL_tracking$state == "florida", ]
casesFLpoly <- rbind(
    casesFL,
    data.frame(
        "date" = as.Date("2021-03-07"),
        "state" = "florida",
        "caseIncrease" = -1 * sum(casesFL$caseIncrease)
    )
)

cases_FLline <- ggplot(
    casesFL,
    aes(x = date, y = cumsum(caseIncrease))
) +
    geom_polygon(data = casesFLpoly, fill = "#B8E6E6") +
    scale_x_date(
        labels = date_format("%b '%y"),
        breaks = as.Date(c("2020-05-01", "2020-09-01", "2021-01-01")),
        limits = as.Date(c("2020-01-29", "2021-03-07")),
        expand = c(0, 0)
    ) +
    scale_y_continuous(labels = ylabels, position = "right", expand = c(0, 0)) +
    geom_hline(
        yintercept = c(500000, 1000000, 1500000, 2000000),
        color = "white", linetype = "dashed", size = 0.3
    ) +
    coord_cartesian(ylim = c(0, 2000000)) +
    theme(
        panel.background = element_rect(fill = "transparent", color = NA),
        plot.background = element_rect(fill = "transparent", color = NA),
        text = element_text(family = "ProximaNova"),
        panel.grid = element_blank(),
        panel.border = element_blank(),
        axis.line.x.bottom = element_blank(),
        axis.line.y = element_line(size = 0.1, color = "#8F9BB3"),
        axis.title = element_blank(),
        axis.text.y = element_text(size = 7, color = "black"),
        axis.text.x = element_text(
            size = 7, hjust = 0.5,
            margin = margin(t = -10), color = "black"
        ),
        axis.ticks = element_line(color = "black", size = 0.2),
        axis.ticks.y = element_blank(),
        axis.ticks.length.x.bottom = unit(-0.1, "cm"),
        plot.title = element_text(size = 8, hjust = 1),
        plot.title.position = "plot"
    )

print(cases_FLline)
```

3) Pie charts of COVID-19 vaccination status:

```{r ggplot_04, echo=TRUE, fig.showtext=TRUE, message=FALSE}
data("COVID_NY_FL_vaccines")

vaccines_NYpie <- ggplot(
    COVID_NY_FL_vaccines[COVID_NY_FL_vaccines$state == "new york", ],
    aes(x = "", y = value, fill = vax_group)
) +
    geom_bar(width = 1, stat = "identity") +
    theme_void() +
    scale_fill_manual(values = c("#FBAA7E", "#F7EEBF", "#FBCB88")) +
    coord_polar(theta = "y", start = 2.125, clip = "off") +
    geom_text(aes(
        x = c(1.9, 2, 1.9),
        y = c(1.65e7, 1.3e6, 7.8e6),
        label = paste0(percent, "%")
    ),
    size = 2.25, color = "black"
    ) +
    theme(
        legend.position = "none",
        plot.title = element_text(
            hjust = 0.5, vjust = -3.5, size = 10,
            family = "ProximaNova", face = "bold"
        ),
        text = element_text(family = "ProximaNova")
    ) +
    labs(title = "New York")

print(vaccines_NYpie)
```
```{r ggplot_05, echo = TRUE, eval = TRUE}
vaccines_FLpie <- ggplot(
    COVID_NY_FL_vaccines[COVID_NY_FL_vaccines$state == "florida", ],
    aes(x = "", y = value, fill = vax_group)
) +
    geom_bar(width = 1, stat = "identity") +
    scale_fill_manual(values = c("#FBAA7E", "#F7EEBF", "#FBCB88")) +
    theme_void() +
    coord_polar(theta = "y", start = pi / 1.78, clip = "off") +
    geom_text(aes(
        x = c(1.95, 2, 1.9),
        y = c(1.9e7, 1.83e6, 9.6e6),
        label = paste0(percent, "%")
    ),
    color = "black",
    size = 2.25
    ) +
    theme(
        legend.position = "none",
        plot.title = element_text(
            hjust = 0.5, vjust = -4, size = 10,
            family = "ProximaNova", face = "bold"
        ),
        text = element_text(family = "ProximaNova")
    ) +
    labs(title = "Florida")

print(vaccines_FLpie)
```

We can now easily overlap and size all these `ggplots` by passing our saved 
plot objects into `plotGG()`:

```{r gg_plot05, echo=TRUE, fig.height=4.5, fig.showtext=TRUE, fig.width=11.5}
pageCreate(width = 9.5, height = 3.5, default.units = "inches")

plotGG(
    plot = US_map,
    x = 0.1, y = 0,
    width = 6.5, height = 3.5, just = c("left", "top")
)
plotGG(
    plot = cases_NYline,
    x = 6.25, y = 1.8,
    width = 3.025, height = 1.4, just = c("left", "bottom")
)
plotGG(
    plot = cases_FLline,
    x = 6.25, y = 3.5,
    width = 3.025, height = 1.4, just = c("left", "bottom")
)
```

In particular, `plotgardener` makes it easy to resize and place our pie charts in
a layout that overlaps our line plots without it affecting the sizing of the 
other plots on the page:

```{r eval = FALSE, echo = TRUE}
plotGG(
    plot = vaccines_NYpie,
    x = 6.37, y = -0.05,
    width = 1.45, height = 1.45, just = c("left", "top")
)
plotGG(
    plot = vaccines_FLpie,
    x = 6.37, y = 1.67,
    width = 1.45, height = 1.45, just = c("left", "top")
)
```

```{r gg_plot06, echo=FALSE, fig.height=4.5, fig.showtext=TRUE, ,fig.width=11.5}
pageCreate(width = 9.5, height = 3.5, default.units = "inches")

plotGG(
    plot = US_map,
    x = 0.1, y = 0,
    width = 6.5, height = 3.5, just = c("left", "top")
)
plotGG(
    plot = cases_NYline,
    x = 6.25, y = 1.8,
    width = 3.025, height = 1.4, just = c("left", "bottom")
)
plotGG(
    plot = cases_FLline,
    x = 6.25, y = 3.5,
    width = 3.025, height = 1.4, just = c("left", "bottom")
)
plotGG(
    plot = vaccines_NYpie,
    x = 6.37, y = -0.05,
    width = 1.45, height = 1.45, just = c("left", "top")
)
plotGG(
    plot = vaccines_FLpie,
    x = 6.37, y = 1.67,
    width = 1.45, height = 1.45, just = c("left", "top")
)
```

We can also easily add additional elements to further enhance our 
complex `ggplot` arrangments, like a precise placement of text labels:

```{r eval = FALSE, echo = TRUE}
plotText(
    label = c("not", "partially", "fully vaccinated"),
    fontfamily = "ProximaNova", fontcolor = "black", fontsize = 7,
    x = c(6.58, 7.3, 7.435),
    y = c(0.74, 1.12, 0.51), just = c("left", "bottom")
)
plotText(
    label = c("not", "partially", "fully vaccinated"),
    fontfamily = "ProximaNova", fontcolor = "black", fontsize = 7,
    x = c(6.58, 7.39, 7.435),
    y = c(2.47, 2.75, 2.2), just = c("left", "bottom")
)
plotText(label = paste("Sources: The COVID Tracking Project;",
                        "Johns Hopkins Center for Civic Impact"),
            fontfamily = "ProximaNova", fontcolor = "black",
            fontsize = 7, fontface = "italic",
            x = 0.15, y = 3.45, just = c("left", "bottom"))
```

We are then left with a complex, precise, and elegant arrangement of 
`ggplots` as if we had arranged them together with graphic design software:

```{r gg_plot07, echo=FALSE, fig.height=4.5, fig.showtext=TRUE, fig.width=11.5}
pageCreate(
    width = 9.5, height = 3.5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
plotGG(
    plot = US_map,
    x = 0.1, y = 0,
    width = 6.5, height = 3.5, just = c("left", "top")
)
plotGG(
    plot = cases_NYline,
    x = 6.25, y = 1.8,
    width = 3.025, height = 1.4, just = c("left", "bottom")
)
plotGG(
    plot = cases_FLline,
    x = 6.25, y = 3.5,
    width = 3.025, height = 1.4, just = c("left", "bottom")
)
plotGG(
    plot = vaccines_NYpie,
    x = 6.37, y = -0.05,
    width = 1.45, height = 1.45, just = c("left", "top")
)
plotGG(
    plot = vaccines_FLpie,
    x = 6.37, y = 1.67,
    width = 1.45, height = 1.45, just = c("left", "top")
)
plotText(
    label = c("not", "partially", "fully vaccinated"),
    fontfamily = "ProximaNova", fontcolor = "black", fontsize = 7,
    x = c(6.58, 7.3, 7.435),
    y = c(0.74, 1.12, 0.51), just = c("left", "bottom")
)
plotText(
    label = c("not", "partially", "fully vaccinated"),
    fontfamily = "ProximaNova", fontcolor = "black", fontsize = 7,
    x = c(6.58, 7.39, 7.435),
    y = c(2.47, 2.75, 2.2), just = c("left", "bottom")
)
plotText(label = paste("Sources: The COVID Tracking Project;",
                        "Johns Hopkins Center for Civic Impact"),
            fontfamily = "ProximaNova", fontcolor = "black",
            fontsize = 7, fontface = "italic",
            x = 0.15, y = 3.45, just = c("left", "bottom"))
```

## `ComplexHeatmap`

Heatmaps are an integral visualization to many multi-panel genomic 
visualizations. Existing Bioconductor packages like `ComplexHeatmap` provide
excellent methods to produce such heatmaps. Since these plots are also based
on `grid` graphics, it is possible to incorporate them into `plotgardener` 
figure arrangements.

For example, let's say we made a heatmap representing the density of ChIP-seq
data at a particular peak:

```{r gg_plot08, fig.height=4, fig.width=5}
library(ComplexHeatmap)
library(purrr)
library(RColorBrewer)

# Simulated data
genmat <- map(
    1:2000,
    function(i) {
        c(sort(abs(rnorm(50)))[1:25], rev(sort(abs(rnorm(50)))[1:25])) * i/5000
    }
) %>% do.call(rbind, .)
genmat <- genmat[nrow(genmat):1,]
Heatmap(genmat, col = colorRampPalette(brewer.pal(n = 9, "YlGnBu"))(9),
        border = "black",
        border_gp = gpar(lwd = 0.5),
        show_heatmap_legend = FALSE, 
        cluster_rows = FALSE, cluster_columns = FALSE)
```

We can capture this heatmap with the `grid` function `grid.grabExpr()`:

```{r}
library(grid)
heatmap <- grid.grabExpr(draw(Heatmap(genmat, 
                    col = colorRampPalette(brewer.pal(n = 9, "YlGnBu"))(9),
                    border = "black",
                    border_gp = gpar(lwd = 0.5),
                    show_heatmap_legend = FALSE, 
                    cluster_rows = FALSE, cluster_columns = FALSE)))
```

We can now pass this object into the `plotGG` function and incorporate the 
heatmap into a `plotgardener` layout with additional figure elements made
by `plotgardener`:

```{r eval=FALSE}
data("GM12878_HiC_10kb")
data("GM12878_ChIP_CTCF_signal")
data("GM12878_ChIP_H3K27ac_signal")
library("org.Hs.eg.db")
library("TxDb.Hsapiens.UCSC.hg19.knownGene")

## Create page
pageCreate(
    width = 6, height = 4, default.units = "inches")

params <- pgParams(chrom = "chr21", chromstart = 28150000, chromend = 29150000, 
                   assembly = "hg19",
                   x = 0.5, width = 2, default.units = "inches")
ctcf_range <- pgParams(range = c(0, 77),
                       assembly = "hg19")
hk_range <- pgParams(range = c(0, 32.6),
                     assembly = "hg19")
hic_gm <- plotHicTriangle(data = GM12878_HiC_10kb, params = params,
                          zrange = c(0, 200), resolution = 10000,
                          y = 1.5, height = 1.25, just = c("left", "bottom"))
annoHeatmapLegend(plot = hic_gm, fontsize = 7, 
                  x = 2.5, y = 0.5, width = 0.07, height = 0.5, 
                  just = c("right", "top"), default.units = "inches")
ctcf_gm <- plotSignal(data = GM12878_ChIP_CTCF_signal, params = c(params, ctcf_range),
                      fill = "#253494", linecolor = "#253494",
                      y = 1.6, height = 0.6)
plotText(label = "CTCF", fontcolor = "#253494", fontsize = 8,
         x = 0.5, y = 1.6, just = c("left","top"), default.units = "inches")
hk_gm <- plotSignal(data = GM12878_ChIP_H3K27ac_signal, params = c(params, hk_range),
                    fill = "#37a7db", linecolor = "#37a7db",
                    y = 2.3, height = 0.6, just = c("left", "top"))
plotText(label = "H3K27ac", fontcolor = "#37a7db", fontsize = 8,
         x = 0.5, y = 2.4, just = c("left","bottom"), default.units = "inches")
genes_gm <- plotGenes(params = params, stroke = 1, fontsize = 6,
                      strandLabels = FALSE,
                      y = 3, height = 0.4)
annoGenomeLabel(plot = genes_gm, params = params, 
                scale = "Kb", fontsize = 7,
                y = 3.5, digits = 0)

## Add ComplexHeatmap
gg_heatmap <- plotGG(
    plot = heatmap,
    x = 3, y = 0.5,
    width = 2.5, height = 3
)
seekViewport(name = "heatmap_matrix_2")
grid.xaxis(at = c(0, 0.5, 1), label = FALSE, gp = gpar(lwd = 0.5))
seekViewport(name = "page")

plotText(label = "Simulated Data", x = 4.25, y = 0.5,
         fontsize = 12, just = "bottom")
plotText(label = c(-2, 0, 2), x = c(3.065, 4.255, 5.425), 
         y = 3.6, fontsize = 7)
plotText(label = "Distance from center", x = 4.25, 
         y = 3.75, fontsize = 8)

## Hide page guides
pageGuideHide()
```

```{r gg_plot09, echo=FALSE, fig.height=6, fig.width=8}
data("GM12878_HiC_10kb")
data("GM12878_ChIP_CTCF_signal")
data("GM12878_ChIP_H3K27ac_signal")
library("org.Hs.eg.db")
library("TxDb.Hsapiens.UCSC.hg19.knownGene")

pageCreate(
    width = 6, height = 4, default.units = "inches",
    showGuides = FALSE)

params <- pgParams(chrom = "chr21", chromstart = 28150000, chromend = 29150000, 
                   assembly = "hg19",
                   x = 0.5, width = 2, default.units = "inches")
ctcf_range <- pgParams(range = c(0, 77),
                       assembly = "hg19")
hk_range <- pgParams(range = c(0, 32.6),
                     assembly = "hg19")
hic_gm <- plotHicTriangle(data = GM12878_HiC_10kb, params = params,
                          zrange = c(0, 200), resolution = 10000,
                          y = 1.5, height = 1.25, just = c("left", "bottom"))
annoHeatmapLegend(plot = hic_gm, fontsize = 7, 
                  x = 2.5, y = 0.5, width = 0.07, height = 0.5, 
                  just = c("right", "top"), default.units = "inches")
ctcf_gm <- plotSignal(data = GM12878_ChIP_CTCF_signal, params = c(params, ctcf_range),
                      fill = "#253494", linecolor = "#253494",
                      y = 1.6, height = 0.6)
plotText(label = "CTCF", fontcolor = "#253494", fontsize = 8,
         x = 0.5, y = 1.6, just = c("left","top"), default.units = "inches")
hk_gm <- plotSignal(data = GM12878_ChIP_H3K27ac_signal, params = c(params, hk_range),
                    fill = "#37a7db", linecolor = "#37a7db",
                    y = 2.3, height = 0.6, just = c("left", "top"))
plotText(label = "H3K27ac", fontcolor = "#37a7db", fontsize = 8,
         x = 0.5, y = 2.4, just = c("left","bottom"), default.units = "inches")
genes_gm <- plotGenes(params = params, stroke = 1, fontsize = 6,
                      strandLabels = FALSE,
                      y = 3, height = 0.4)
annoGenomeLabel(plot = genes_gm, params = params, 
                scale = "Kb", fontsize = 7,
                y = 3.5, digits = 0)

## Add ComplexHeatmap
gg_heatmap <- plotGG(
    plot = heatmap,
    x = 3, y = 0.5,
    width = 2.5, height = 3
)
seekViewport(name = "heatmap_matrix_2")
grid.xaxis(at = c(0, 0.5, 1), label = FALSE, gp = gpar(lwd = 0.5))
seekViewport(name = "page")

plotText(label = "Simulated Data", x = 4.25, y = 0.5,
         fontsize = 12, just = "bottom")
plotText(label = c(-2, 0, 2), x = c(3.065, 4.255, 5.425), 
         y = 3.6, fontsize = 7)
plotText(label = "Distance from center", x = 4.25, 
         y = 3.75, fontsize = 8)
```

## Session Info
```{r}
sessionInfo()
```

---
title: "Bioconductor Integration"
output:
    rmarkdown::html_vignette
vignette: >
    %\VignetteIndexEntry{Bioconductor Integration}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
    fig.align = "center",
    fig.width = 3,
    fig.height = 3,
    collapse = TRUE,
    comment = "#>",
    warning = FALSE,
    message = FALSE
)
library(grid)
library(plotgardener)
```

`plotgardener` is designed to be flexibly compatible with typical Bioconductor 
classes and libraries of genomic data to easily integrate genomic data 
analysis and visualization. In addition to handling various genomic file 
types and `R` objects, many `plotgardener` functions can also handle `GRanges` or
`GInteractions` objects as input data. Furthermore, `plotgardener` does not hard-code 
any genomic assemblies and can utilize `TxDb`, `OrgDb`, and `BSgenome` objects 
for various genomic annotations, including gene and transcript structures 
and names, chromosome sizes, and nucleotide sequences. Furthermore, all cytoband
data for ideogram plots is retrieved from the UCSC Genome Browser through 
`AnnotationHub`. For standard genomic assemblies (i.e. hg19, hg38, mm10), 
`plotgardener` uses a set of default packages that can be displayed by calling 
`defaultPackages()`:

```{r echo=TRUE, eval=TRUE}
defaultPackages("hg38")
defaultPackages("hg19")
defaultPackages("mm10")
```

To see which assemblies have defaults within `plotgardener`, call `genomes()`:

```{r echo=TRUE, eval=TRUE}
genomes()
```

`plotgardener` functions default to an "hg38" assembly, but can be customized
with any of the other genomic assemblies included or a `assembly` object.
To create custom genomic assemblies and combinations of `TxDb`, `orgDb`, and 
`BSgenome` packages for use in `plotgardener` functions, we can use the 
`assembly()` constructor. For example, we can create our own `TxDb` 
from the current human Ensembl release:

```{r eval=FALSE, echo=TRUE}
library(GenomicFeatures)
TxDb.Hsapiens.Ensembl.GrCh38.103 <- makeTxDbFromEnsembl(
    organism =
        "Homo sapiens"
)
```

We can now create a new `assembly` with this `TxDb` and combinations of 
other Bioconductor packages. The `Genome` parameter can is a string to name 
or describe this assembly. Since the `TxDb` is now from ENSEMBL, we will 
change the `gene.id` field to `"ENSEMBL"` to map gene IDs and symbols between 
our `TxDb` and `orgDb` objects. Most gene ID types can be found by calling
`AnnotationDbi::keytypes()` on an `orgDb`.

```{r eval=FALSE, echo=TRUE}
Ensembl38 <- assembly(
    Genome = "Ensembl.GRCh38.103",
    TxDb = TxDb.Hsapiens.Ensembl.GrCh38.103,
    OrgDb = "org.Hs.eg.db",
    BSgenome = "BSgenome.Hsapiens.NCBI.GRCh38",
    gene.id = "ENSEMBL", display.column = "SYMBOL"
)
```

This `assembly` object can now be easily passed into `plotgardener` functions 
through the `assembly` parameter to use custom genomic assembly configurations.

`assembly` objects are especially handy for changing the type of gene or transcript label 
of our gene and transcript plots. The default `display.column = "SYMBOL"`, but we could 
change this value to other available `keytypes` in the `orgDb` we are using.
For example, if we wanted to display the associated Ensembl IDs of an "hg19" 
`assembly` object, we would set `display.column = "ENSEMBL"`:

```{r bioc_01, echo=TRUE, fig.height=2.25, fig.width=5, message=FALSE}
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)
new_hg19 <- assembly(
    Genome = "id_hg19",
    TxDb = "TxDb.Hsapiens.UCSC.hg19.knownGene",
    OrgDb = "org.Hs.eg.db",
    gene.id.column = "ENTREZID",
    display.column = "ENSEMBL"
)
pageCreate(
    width = 5, height = 1.25,
    showGuides = FALSE, xgrid = 0, ygrid = 0
)
genePlot <- plotGenes(
    chrom = "chr2", chromstart = 1000000, chromend = 20000000,
    assembly = new_hg19,
    x = 0.25, y = 0.25, width = 4.75, height = 1
)
```

### Session Info
```{r}
sessionInfo()
```

---
title: The plotgardener Page
output: rmarkdown::html_vignette
vignette: >
    %\VignetteIndexEntry{The plotgardener Page}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    fig.align = "center",
    message = FALSE,
    warning = FALSE
)
library(plotgardener)
library(grid)
library(plotgardenerData)
```

`plotgardener` uses a coordinate-based plotting system to define the size and 
location of plots. This system makes the plotting process intuitive and 
absolute, meaning that plots cannot be squished and stretched based 
on their *relative* sizes. This also allows for precise control of the size 
of each visualization and the location of all plots, annotations, and text. 

All `plotgardener` page functions begin with the `page` prefix. 

Users can create a page in their preferred size and unit of measurement using
`pageCreate()`. Within this function the user can also set gridlines in 
the vertical and horizontal directions with `xgrid` and `ygrid`, respectively. 
By default these values are set to 0.5 of the unit. In the following example 
we demonstrate creating a standard 8.5 x 11 inch page:

```{r page_demo01, fig.width=11, fig.height=12}
pageCreate(width = 8.5, height = 11, default.units = "inches")
```

Or we could create a smaller sized page in a different set of units 
with different gridlines:

```{r page_demo02, fig.width=5, fig.height=4}
pageCreate(width = 8, height = 8, xgrid = 1, ygrid = 1, default.units = "cm")
```

We could turn off gridlines entirely by setting `xgrid` and `ygrid` to 0:

```{r page_demo03, fig.width=5, fig.height=4}
pageCreate(
    width = 3, height = 3, xgrid = 0, ygrid = 0,
    default.units = "inches"
)
```

If we want more specific gridlines on our page, we can use 
the `pageGuideHorizontal()` and `pageGuideVertical()` functions:

```{r page_demo04, fig.width=5, fig.height=4}
pageCreate(width = 3, height = 3, default.units = "inches")
## Add a horizontal guide at y = 2.25 inches
pageGuideHorizontal(y = 2.25, default.units = "inches")
## Add a vertical guide at x = 0.75 inches
pageGuideVertical(x = 0.75, default.units = "inches")
```

We can also remove all guidelines from the plot once we are finished using 
guides by using the `pageGuideHide()` function:

```{r page_demo05, fig.width=5, fig.height=4}
## Create page
pageCreate(width = 3, height = 3, default.units = "inches")
## Remove guides
pageGuideHide()
```

## Coordinate systems and units

`plotgardener` is compatible with numerous coordinate systems, which are 
flexible enough to be used in combination. Brief descriptions of the most 
commonly used `plotgardener` coordinate systems are as follows:

+-------------------+---------------------------------------------------------+
| Coordinate System | Description                                             |
+==================:+:========================================================+
| **"npc"**         | Normalized Parent Coordinates. Treats the bottom-left   |
|                   | corner of the plotting region as the location (0,0) and |
|                   | the top-right corner as (1,1).                          |
+-------------------+---------------------------------------------------------+
| **"snpc"**        | Squared Normalized Parent Coordiantes. Placements and   |
|                   | sizes are expressed as a proportion of the smaller of   |
|                   | the width and height of the plotting region.            |
+-------------------+---------------------------------------------------------+
| **"native"**      | Placements and sizes are relative to the x- and         |
|                   | y-scales of the plotting region.                        |
+-------------------+---------------------------------------------------------+
| **"inches"**      | Placements and sizes are in terms of physical inches.   |
+-------------------+---------------------------------------------------------+
| **"cm"**          | Placements and sizes are in terms of physical           |
|                   | centimeters.                                            |
+-------------------+---------------------------------------------------------+
| **"mm"**          | Placements and sizes are in terms of physical           |
|                   | millimeters.                                            |
+-------------------+---------------------------------------------------------+
| **"points"**      | Placements and sizes are in terms of physical points.   |
|                   | There are 72.27 points per inch.                        |
+-------------------+---------------------------------------------------------+

We can set the `page` in one coordinate system, but then place and arrange 
our plots using other coordinate systems. For example, we can set our page 
as 3 x 3 **inches**:

```{r coord_01, eval=TRUE, message=FALSE,echo=TRUE, fig.width=5, fig.height=4}
pageCreate(width = 3, height = 3, default.units = "inches")
```

But we can then switch to **npc** coordinates to plot something in the 
center of the page at (0.5, 0.5) npc. The `unit()` function allows us to 
easily specify `x`, `y`, `width`, and `height` in combinations of different 
units in one plotting function call. 
```{r eval=FALSE, message=FALSE,echo=TRUE}
plotRect(
    x = unit(0.5, "npc"), y = unit(0.5, "npc"), width = 1, height = 1,
    default.units = "inches"
)
```
```{r coord_02, eval=TRUE, message=FALSE,echo=FALSE, fig.width=5, fig.height=4}
pageCreate(width = 3, height = 3, default.units = "inches")
plotRect(x = unit(0.5, "npc"), y = unit(0.5, "npc"), width = 1, height = 1)
```

The **native** coordinate system is particularly useful for annotation 
functions that can plot relative to the genomic scales of a plot. For example,
we can use `annoText()` to annotate some text at a specific genomic 
location in a plot:

```{r coord_03, echo=TRUE, fig.height=2.5, fig.width=7, message=FALSE}
pageCreate(
    width = 5, height = 1.5, default.units = "inches",
    showGuides = FALSE, xgrid = 0, ygrid = 0
)

library(plotgardenerData)
data("IMR90_ChIP_H3K27ac_signal")
signalPlot <- plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 0.25, width = 4, height = 0.75, default.units = "inches"
)
annoGenomeLabel(plot = signalPlot, x = 0.5, y = 1.01)

## Annotate text at average x-coordinate of data peak
peakScore <- IMR90_ChIP_H3K27ac_signal[which(
    IMR90_ChIP_H3K27ac_signal$score == max(IMR90_ChIP_H3K27ac_signal$score)
), ]
peakPos <- round((min(peakScore$start) + max(peakScore$end)) * 0.5)
annoText(
    plot = signalPlot, label = format(peakPos, big.mark = ","), fontsize = 8,
    x = unit(peakPos, "native"), y = unit(1, "npc"),
    just = "bottom"
)
```

## Working with plot objects

In `plotgardener` all plot objects are boxes, with user-defined positions and 
sizes. All plot objects can be placed on a `page` using the placement 
arguments (e.g. `x`, `y`, `width`, `height`, `just`, `default.units`, ...). 
The `page` sets the origin of the plot at the top left corner of the page. 
By default, the `x` and `y` arguments place the top-left corner of a plot in 
the specified position on the `page` while the `width` and `height` 
arguments define the size of the plot.

For example, if users want the top-left corner of their plot to be 0.5 inches 
down from the top of the page and 0.5 inches from the left...

```{r arrange_example01, echo=FALSE, fig.height=4, fig.width=5, message=FALSE}
## Create page
pageCreate(width = 3, height = 3, default.units = "inches")

## Draw arrows
plotSegments(
    x0 = 0.5, y0 = 0, x1 = 0.5, y1 = 0.5,
    arrow = arrow(
        angle = 30,
        length = unit(0.1, "inches"),
        ends = "last",
        type = "closed"
    ),
    fill = "black"
)

plotSegments(
    x0 = 0, y0 = 0.5, x1 = 0.5, y1 = 0.5,
    arrow = arrow(
        angle = 30,
        length = unit(0.1, "inches"),
        ends = "last",
        type = "closed"
    ),
    fill = "black"
)

## Draw text
plotText(label = "0.5 in", x = 0.6, y = 0.25, just = "left")
plotText(label = "0.5 in", x = 0.25, y = 0.6, just = "top")
```

and the plot to be 2 inches wide and 1 inch tall...

```{r arrange_example02, echo=FALSE, fig.height=4, fig.width=5, message=FALSE}
## Create page
pageCreate(width = 3, height = 3, default.units = "inches")

## Draw arrows
plotSegments(
    x0 = 0.5, y0 = 0, x1 = 0.5, y1 = 0.5,
    arrow = arrow(
        angle = 30,
        length = unit(0.1, "inches"),
        ends = "last",
        type = "closed"
    ),
    fill = "black"
)

plotSegments(
    x0 = 0, y0 = 0.5, x1 = 0.5, y1 = 0.5,
    arrow = arrow(
        angle = 30,
        length = unit(0.1, "inches"),
        ends = "last",
        type = "closed"
    ),
    fill = "black"
)

## Draw plot dimension arrows
plotSegments(
    x0 = 0.5, y0 = 0.5, x1 = 2.5, y1 = 0.5,
    arrow = arrow(
        angle = 30,
        length = unit(0.1, "inches"),
        ends = "both",
        type = "closed"
    ),
    fill = "black"
)

plotSegments(
    x0 = 0.5, y0 = 0.5, x1 = 0.5, y1 = 1.5,
    arrow = arrow(
        angle = 30,
        length = unit(0.1, "inches"),
        ends = "both",
        type = "closed"
    ),
    fill = "black"
)

## Draw text
plotText(label = "2 in", x = 1.5, y = 0.4, just = "bottom")
plotText(label = "1 in", x = 0.4, y = 1, just = "right")
```

`plotgardener` can make the plot with these exact dimensions:

```{r arrange_example03, echo=TRUE, fig.height=4, fig.width=5, message=FALSE}
## Create page
pageCreate(width = 3, height = 3, default.units = "inches")

## Plot rectangle
plotRect(
    x = 0.5, y = 0.5, width = 2, height = 1,
    just = c("left", "top"), default.units = "inches"
)
```

`plotgardener` also provides the helper function `pagePlotPlace()` for placing 
plot objects that have been previously defined:

```{r arrange_example04, echo=TRUE, fig.height=4, fig.width=5, message=FALSE}
## Load data
library(plotgardenerData)
data("IMR90_ChIP_H3K27ac_signal")

## Create page
pageCreate(width = 3, height = 3, default.units = "inches")

## Define signal plot
signalPlot <- plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    draw = FALSE
)

## Place plot on page
pagePlotPlace(
    plot = signalPlot,
    x = 0.5, y = 0.5, width = 2, height = 1,
    just = c("left", "top"), default.units = "inches"
)
```

and `pagePlotRemove()` for removing plots from a page:

```{r arrange_example05, echo=TRUE, fig.height=4, fig.width=5, message=FALSE}
# Load data
library(plotgardenerData)
data("IMR90_ChIP_H3K27ac_signal")

## Create page
pageCreate(width = 3, height = 3, default.units = "inches")

## Plot and place signal plot
signalPlot <- plotSignal(
    data = IMR90_ChIP_H3K27ac_signal,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 0.5, width = 2, height = 1,
    just = c("left", "top"), default.units = "inches"
)
## Remove signal plot
pagePlotRemove(plot = signalPlot)
```


These functions give the users additional flexibility in how they create 
their R scripts and `plotgardener` layouts.

## Using the `just` parameter

While the `x`, `y`, `width`, and `height` parameters are relative to the 
top-left corner of the plot by default, the `just` parameter provides 
additional flexibility by allowing users to change the placement reference 
point. The `just` parameter accepts a character or numeric vector of length 2 
describing the horizontal and vertical justification (or reference point), 
respectively.

The just parameter can be set using character strings `"left"`, `"right"`, 
`"center"`, `"bottom"` and `"top"`:

```{r arrange_example06, echo=FALSE, fig.height=5, fig.width=6, message=FALSE}
## Load libraries
library(plotgardener)

## Create page
pageCreate(
    width = 4, height = 4, xgrid = 1, ygrid = 1,
    default.units = "inches"
)

## Define x and y coords, colors, and justifications
xcoords <- c(0.25, 2, 3.75, 3.75, 3.75, 2, 0.25, 0.25, 2)
ycoords <- c(0.25, 0.25, 0.25, 2, 3.75, 3.75, 3.75, 2, 2)
cols <- c(RColorBrewer::brewer.pal(n = 8, name = "Dark2"), "black")
justs <- list(
    c("left", "top"), c("center", "top"), c("right", "top"),
    c("right", "center"), c("right", "bottom"), c("center", "bottom"),
    c("left", "bottom"), c("left", "center"), c("center", "center")
)

## Define x and y shift vectors for adjusting text
s <- 0.1
xshift <- c(s, 0, -s, -s, -s, 0, s, s, 0)
yshift <- c(s, s, s, 0, -s, -s, -s, 0, -s * 3)

## Draw guides
pageGuideHorizontal(y = ycoords, linecolor = "grey90", lty = 2)
pageGuideVertical(x = xcoords, linecolor = "grey90", lty = 2)

## Draw box
plotRect(
    x = 0.25, y = 0.25, width = 3.5, height = 3.5,
    just = c("left", "top")
)

## Plot points
plotCircle(
    x = xcoords,
    y = ycoords,
    r = 0.035, linecolor = cols, fill = cols
)

## Text descriptions
for (i in 1:9) {
    plotText(
        label = sprintf(
            "x = %s\ny = %s\njust = c('%s', '%s')",
            xcoords[i], ycoords[i], justs[[i]][1], justs[[i]][2]
        ),
        x = xcoords[i] + xshift[i],
        y = ycoords[i] + yshift[i],
        just = justs[[i]],
        fontsize = 6.5, fontcolor = cols[i], fontface = "bold"
    )
}
```

Or it can be set using numeric values where 0 means left/bottom, 1 means 
right/top, and 0.5 means center: 

```{r arrange_example07, echo=FALSE, fig.height=5, fig.width=6, message=FALSE}
## Load libraries
library(plotgardener)

## Create page
pageCreate(
    width = 4, height = 4, xgrid = 1, ygrid = 1,
    default.units = "inches"
)

## Define x and y coords, colors, and justifications
xcoords <- c(0.25, 2, 3.75, 3.75, 3.75, 2, 0.25, 0.25, 2)
ycoords <- c(0.25, 0.25, 0.25, 2, 3.75, 3.75, 3.75, 2, 2)
cols <- c(RColorBrewer::brewer.pal(n = 8, name = "Dark2"), "black")
justs <- list(
    c(0, 1), c(0.5, 1), c(1, 1),
    c(1, 0.5), c(1, 0), c(0.5, 0),
    c(0, 0), c(0, 0.5), c(0.5, 0.5)
)

## Define x and y shift vectors for adjusting text
s <- 0.1
xshift <- c(s, 0, -s, -s, -s, 0, s, s, 0)
yshift <- c(s, s, s, 0, -s, -s, -s, 0, -s * 3)

## Draw guides
pageGuideHorizontal(y = ycoords, linecolor = "grey90", lty = 2)
pageGuideVertical(x = xcoords, linecolor = "grey90", lty = 2)

## Draw box
plotRect(
    x = 0.25, y = 0.25, width = 3.5, height = 3.5,
    just = c("left", "top")
)

## Plot points
plotCircle(
    x = xcoords,
    y = ycoords,
    r = 0.035, linecolor = cols, fill = cols
)

## Text descriptions
for (i in 1:9) {
    plotText(
        label = sprintf(
            "x = %s\ny = %s\njust = c(%s, %s)",
            xcoords[i], ycoords[i], justs[[i]][1], justs[[i]][2]
        ),
        x = xcoords[i] + xshift[i],
        y = ycoords[i] + yshift[i],
        just = justs[[i]],
        fontsize = 6.5, fontcolor = cols[i], fontface = "bold"
    )
}
```

This is particularly useful when an object needs to be aligned in reference 
to another plot object or page marker. For example, in the Hi-C plot below we 
might want to align the top-right corner of the heatmap legend to the 3-inch 
mark. There is no need to calculate the top-left position 
(i.e. `3 inches - (legend width)`) to determine where to place the heatmap 
legend. Instead we can change the `just` parameter to `just=c('right', 'top')`:

```{r arrange_example08, echo=TRUE, fig.height=5, fig.width=6, message=FALSE}
## Load example Hi-C data
library(plotgardenerData)
data("IMR90_HiC_10kb")

## Create a plotgardener page
pageCreate(width = 3.25, height = 3.25, default.units = "inches")

## Plot Hi-C data with placing information
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb,
    chrom = "chr21", chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.25, y = 0.25, width = 2.5, height = 2.5, default.units = "inches"
)

## Add color scale annotation with just = c("right", "top")
annoHeatmapLegend(
    plot = hicPlot,
    x = 3, y = 0.25, width = 0.1, height = 1.25,
    just = c("right", "top"), default.units = "inches"
)
```

# Session Info
```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCool.R
\name{.checkCool}
\alias{.checkCool}
\title{Check for .(m)cool file and contents}
\usage{
.checkCool(file)
}
\arguments{
\item{file}{Path to .(m)cool file}
}
\description{
Check for .(m)cool file and contents
}
\author{
Sarah Parker
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pgParams.R
\name{pgParams}
\alias{pgParams}
\title{pgParams: plotgardener parameters object}
\usage{
pgParams(assembly = "hg38", gene = NULL, geneBuffer = NULL, ...)
}
\arguments{
\item{assembly}{String defining the genome build.
Default value is \code{assembly = "hg38"}.}

\item{gene}{(optional) String naming a gene used to set the
chrom, chromstart, and chromend arguments.}

\item{geneBuffer}{(optional) Integer base-pairs to extend the
start and end of a gene defined by argument \code{gene}.
Can be one integer or a vector of length 2, where the first integer
will extend the start of the gene and the second integer
will extend the end of the gene.}

\item{...}{This function will take any plotgardener function
parameters and their values:
\itemize{
\item{\code{alpha}}
\item{\code{altchrom}}
\item{\code{altchromend}}
\item{\code{altchromstart}}
\item{\code{archHeight}}
\item{\code{arrow}}
\item{\code{at}}
\item{\code{axis}}
\item{\code{axisLine}}
\item{\code{baseline}}
\item{\code{baseline.color}}
\item{\code{baseline.lwd}}
\item{\code{bg}}
\item{\code{binCap}}
\item{\code{binSize}}
\item{\code{border}}
\item{\code{boxHeight}}
\item{\code{boxWidth}}
\item{\code{breaks}}
\item{\code{BSgenome}}
\item{\code{cex}}
\item{\code{check.overlap}}
\item{\code{chrom}}
\item{\code{chromend}}
\item{\code{chromstart}}
\item{\code{clip}}
\item{\code{collapse}}
\item{\code{colorbyStrand}}
\item{\code{colorTrans}}
\item{\code{column}}
\item{\code{commas}}
\item{\code{curvature}}
\item{\code{data}}
\item{\code{default.units}}
\item{\code{digits}}
\item{\code{display.column}}
\item{\code{draw}}
\item{\code{extend}}
\item{\code{file}}
\item{\code{fill}}
\item{\code{flip}}
\item{\code{fontcolor}}
\item{\code{fontsize}}
\item{\code{geneBackground}}
\item{\code{geneHighlights}}
\item{\code{gene.id.column}}
\item{\code{geneOrder}}
\item{\code{Genome}}
\item{\code{half}}
\item{\code{height}}
\item{\code{id}}
\item{\code{id.lengths}}
\item{\code{image}}
\item{\code{interpolate}}
\item{\code{just}}
\item{\code{label}}
\item{\code{labels}}
\item{\code{leadSNP}}
\item{\code{legend}}
\item{\code{length}}
\item{\code{limitLabel}}
\item{\code{linecolor}}
\item{\code{lineend}}
\item{\code{linejoin}}
\item{\code{lty}}
\item{\code{lwd}}
\item{\code{main}}
\item{\code{margin}}
\item{\code{matrix}}
\item{\code{negData}}
\item{\code{norm}}
\item{\code{OrgDb}}
\item{\code{orientation}}
\item{\code{palette}}
\item{\code{pch}}
\item{\code{plot}}
\item{\code{quiet}}
\item{\code{r}}
\item{\code{range}}
\item{\code{resolution}}
\item{\code{res_scale}}
\item{\code{rot}}
\item{\code{scale}}
\item{\code{scientific}}
\item{\code{scipen}}
\item{\code{sequence}}
\item{\code{shift}} 
\item{\code{showBands}}
\item{\code{showGuides}}
\item{\code{sigCol}}
\item{\code{sigLine}}
\item{\code{sigVal}}
\item{\code{spaceHeight}}
\item{\code{spaceWidth}}
\item{\code{strand}}
\item{\code{strandLabels}}
\item{\code{strandSplit}}
\item{\code{stroke}}
\item{\code{style}}
\item{\code{tcl}}
\item{\code{ticks}}
\item{\code{title}}
\item{\code{TxDb}}
\item{\code{type}}
\item{\code{width}}
\item{\code{x}}
\item{\code{xgrid}}
\item{\code{x0}}
\item{\code{x1}}
\item{\code{y}}
\item{\code{ygrid}}
\item{\code{ymax}}
\item{\code{y0}}
\item{\code{y1}}
\item{\code{zrange}}
}}
}
\value{
Returns an object of class \code{pgParams}
containing plotgardener function arguments.
}
\description{
Creates an object of class "pgParams" that can be used by
plotgardener functions. pgParams can be used to set a set of parameters
to be shared across multiple functions.
}
\details{
pgParams generates arguments from exported plotgardener functions at
loading time of the package. Arguments defined in a pgParams object
can be passed into the \code{params} argument of plotgardener functions.
params arguments can be overridden from within plotgardener functions.

pgParams also provides an alternative region definition mechanism.
Given a gene name and genome assembly, pgParams returns the appropriate
"chrom", "chromstart", and "chromend" with a default buffer of
\code{(gene length) / 2} added to the ends of the gene coordinates.
The buffer amount can be set manually with the \code{geneBuffer}
parameter. Buffer extending beyond the length of the chromosome
will be trimmed.
}
\examples{
## Load hg19 genomic annotation packages
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
library("org.Hs.eg.db")

## Define parameters
p1 <- pgParams(gene = "IL1B", assembly = "hg19")

## Optionally add more parameters
p2 <- pgParams(fontsize = 10, assembly = "hg19")

## Combine parameters and pass them to a plotgardener function
plotGenes(params = c(p1, p2))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSegments.R
\name{plotSegments}
\alias{plotSegments}
\title{Draw a line segment within a plotgardener layout}
\usage{
plotSegments(
    x0,
    y0,
    x1,
    y1,
    default.units = "inches",
    linecolor = "black",
    lwd = 1,
    lty = 1,
    lineend = "butt",
    linejoin = "mitre",
    arrow = NULL,
    params = NULL,
    ...
)
}
\arguments{
\item{x0}{A numeric vector or unit object indicating the
starting x-values of the line segments.}

\item{y0}{A numeric vector, unit object, or a character vector
of values containing a "b" combined with a numeric value specifying
starting y-values of the line segments.
The character vector will place starting y-values relative to the
bottom of the most recently plotted plot according to the
units of the plotgardener page.}

\item{x1}{A numeric vector or unit object indicating the stopping
x-values of the line segments.}

\item{y1}{A numeric vector, unit object, or a character vector of v
alues containing a "b" combined with a numeric value specifying
stopping y-values of the line segments.
The character vector will place stopping y-values relative to the
bottom of the most recently plotted plot according to the
units of the plotgardener page.}

\item{default.units}{A string indicating the default units to use
if \code{x0}, \code{y0}, \code{x1}, or \code{y1} are only given as
numeric vectors. Default value is \code{default.units = "inches"}.}

\item{linecolor}{A character value specifying segment line color.
Default value is \code{linecolor = "black"}.}

\item{lwd}{A numeric specifying segment line width.
Default value is \code{lwd = 1}.}

\item{lty}{A numeric specifying segment line type.
Default value is \code{lty = 1}.}

\item{lineend}{A character value specifying line end style.
Default value is \code{lineend = "butt"}. Options are:
\itemize{
\item{\code{"round"}: Segment ends are rounded.}
\item{\code{"butt"}: Segment ends end exactly where ended.}
\item{\code{"square"}: Segment ends are squared.}
}}

\item{linejoin}{A character value specifying line join style.
Default value is \code{linejoin = "mitre"}. Options are:
\itemize{
\item{\code{"round"}: }{Line joins are rounded.}
\item{\code{"mitre"}: }{Line joins are sharp corners.}
\item{\code{"bevel"}: }{Line joins are flattened corners.}
}}

\item{arrow}{A list describing arrow heads to place at either end of
the line segments, as produced by the \link[grid]{arrow} function.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{segments} object containing relevant
placement and \link[grid]{grob} information.
}
\description{
Draw a line segment within a plotgardener layout
}
\examples{
library(grid)
## Create a page
pageCreate(width = 7.5, height = 6, default.units = "inches")

## Plot one line segment
plotSegments(
    x0 = 3.75, y0 = 0.25, x1 = 3.75, y1 = 5.75,
    default.units = "inches",
    lwd = 3, lty = 2
)

## Plot multiple line segments at different locations in different colors
plotSegments(
    x0 = 0.5, y0 = c(1, 3, 5), x1 = 3.25, y1 = c(1, 3, 5),
    default.units = "inches",
    lwd = 2, linecolor = c("#7ecdbb", "#37a7db", "grey")
)

## Plot a line segment with an arrowhead
plotSegments(
    x0 = 4.5, y0 = 0.5, x1 = 7, y1 = 3,
    default.units = "inches",
    arrow = arrow(type = "closed"), fill = "black"
)

## Plot lines with round lineends
plotSegments(
    x0 = c(4, 7), y0 = 3.5, x1 = 5.5, y1 = 4.5,
    default.units = "inches",
    lwd = 5, lineend = "round"
)

## Hide page guides
pageGuideHide()
}
\seealso{
\link[grid]{grid.segments}, \link[grid]{arrow}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMultiSignal.R
\name{calcSignalRange}
\alias{calcSignalRange}
\title{Calculate a score range for multiple signals}
\usage{
calcSignalRange(
    data,
    chrom = NULL,
    chromstart = 1,
    chromend = .Machine$integer.max,
    assembly = "hg38",
    negData = FALSE)
}
\arguments{
\item{data}{List of data to be plotted as character values specifying 
multiple bigwig file paths, dataframes in BED format, or
\link[GenomicRanges]{GRanges} objects with metadata column \code{score}.}

\item{chrom}{Chromosome of data region ragne as a string, if range for a 
specific chromosome is desired.}

\item{chromstart}{Integer start position on chromosome to get data range.}

\item{chromend}{Integer end position on chromosome to get data range.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{negData}{A logical value indicating whether any of the data has both
positive and negative scores and the signal range should be adjusted
accordingly. Default value is \code{negData = FALSE}.}
}
\value{
Returns a vector of length 2 with the calculated c(min, max) range.
}
\description{
Calculate a score range for multiple signals
}
\examples{
library("plotgardenerData")
data("GM12878_ChIP_CTCF_signal")
data("IMR90_ChIP_CTCF_signal")
data("GM12878_ChIP_H3K27ac_signal")
data("IMR90_ChIP_H3K27ac_signal")

calcSignalRange(data = list(GM12878_ChIP_CTCF_signal, 
                            GM12878_ChIP_H3K27ac_signal, 
                            IMR90_ChIP_CTCF_signal, 
                            IMR90_ChIP_H3K27ac_signal),
                chrom = "chr21",
                chromstart = 28150000, chromend = 29150000,
                assembly = "hg38", negData = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoPixels.R
\name{annoPixels}
\alias{annoPixels}
\title{Annotate pixels in a Hi-C plot}
\usage{
annoPixels(
    plot,
    data,
    type = "box",
    half = "inherit",
    shift = 4,
    params = NULL,
    quiet = FALSE,
    ...
)
}
\arguments{
\item{plot}{Hi-C plot object from \code{plotHicSquare} or
\code{plotHicTriangle} on which to annotate pixels.}

\item{data}{A string specifying the BEDPE file path, a dataframe in BEDPE
format specifying pixel positions, or a
\link[InteractionSet]{GInteractions} object specifying pixel
positions.}

\item{type}{Character value specifying type of annotation.
Default value is \code{type = "box"}. Options are:
\itemize{
\item{\code{"box"}: }{Boxes are drawn around each pixel.}
\item{\code{"circle"}: }{Circles are drawn around each pixel.}
\item{\code{"arrow"}: }{Arrows are drawn pointing to each pixel.}
}}

\item{half}{Character value specifying which half of hic plots
to annotate. Triangle Hi-C plots will always default to the entirety of
the triangular plot. Default value is \code{half = "inherit"}. Options are:
\itemize{
\item{\code{"inherit"}: }{Pixels will be annotated on the \code{half}
inherited by the input Hi-C plot.}
\item{\code{"both"}: }{Pixels will be annotated on both halves of the
diagonal of a square Hi-C plot.}
\item{\code{"top"}: }{Pixels will be annotated on the upper diagonal
half of a square Hi-C plot.}
\item{\code{"bottom"}: }{Pixels will be annotated on the bottom diagonal
half of a square Hi-C plot.}
}}

\item{shift}{Numeric specifying the number of pixels on either end of
main pixel in a box or circle. Numeric specifying number of pixels
for the length of an arrow.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{quiet}{A logical indicating whether or not to print messages.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{pixel} object containing relevant
genomic region, placement, and \link[grid]{grob} information.
}
\description{
Annotate pixels in a Hi-C plot
}
\examples{
## Load Hi-C data and BEDPE data
library(plotgardenerData)
data("IMR90_HiC_10kb")
data("IMR90_DNAloops_pairs")

## Create page
pageCreate(width = 4.5, height = 4, default.units = "inches")

## Plot and place a square Hi-C plot
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, resolution = 10000,
    zrange = c(0, 70),
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 0.5, width = 3, height = 3,
    just = c("left", "top"),
    default.units = "inches"
)

## Annotate loops of both sides of Hi-C plot with squares
pixels <- annoPixels(
    plot = hicPlot, data = IMR90_DNAloops_pairs, type = "box",
    half = "both"
)

## Annotate loops on one side of Hi-C plot with arrows
## and the other side with circles
pagePlotRemove(plot = pixels)
pixels1 <- annoPixels(
    plot = hicPlot, data = IMR90_DNAloops_pairs,
    type = "arrow", half = "top", shift = 8
)
pixels2 <- annoPixels(
    plot = hicPlot, data = IMR90_DNAloops_pairs,
    type = "circle", half = "bottom"
)

## Annotate heatmap legend
annoHeatmapLegend(
    plot = hicPlot,
    x = 3.6, y = 0.5, width = 0.12, height = 1.2,
    just = c("left", "top"), default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(
    plot = hicPlot, x = 0.5, y = 3.53, scale = "Mb",
    just = c("left", "top")
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotGenomeLabel.R
\name{plotGenomeLabel}
\alias{plotGenomeLabel}
\title{Plot genomic coordinates along the x or y-axis of a plotgardener plot}
\usage{
plotGenomeLabel(
    chrom,
    chromstart = NULL,
    chromend = NULL,
    assembly = "hg38",
    fontsize = 10,
    fontcolor = "black",
    linecolor = "black",
    margin = unit(1, "mm"),
    scale = "bp",
    commas = TRUE,
    sequence = TRUE,
    boxWidth = 0.5,
    axis = "x",
    at = NULL,
    tcl = 0.5,
    x,
    y,
    length,
    just = c("left", "top"),
    default.units = "inches",
    params = NULL,
    ...
)
}
\arguments{
\item{chrom}{Chromosome of genome label, as a string,
or a character vector of chromosomes for a whole genome Manhattan plot.}

\item{chromstart}{Integer start of genome label.}

\item{chromend}{Integer end of genome label.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.}

\item{fontsize}{A numeric specifying text fontsize in points.
Default value is \code{fontsize = 10}.}

\item{fontcolor}{A character value indicating the color for text.
Default value is \code{fontcolor = "black"}.}

\item{linecolor}{A character value indicating the color of
the genome label axis. Default value is \code{linecolor = "black"}.}

\item{margin}{A numeric or unit vector specifying space between axis
and coordinate labels. Default value is \code{margin = unit(1, "mm")},}

\item{scale}{A character value indicating the scale of the coordinates
along the genome label. Default value is \code{scale = "bp"}. Options are:
\itemize{
\item{\code{"bp"}: }{base pairs.}
\item{\code{"Kb"}: }{kilobase pairs. 1 kilobase pair is equal to
1000 base pairs.}
\item{\code{"Mb"}: }{megabase pairs. 1 megabase pair is equal to
1000000 base pairs.}
}}

\item{commas}{A logical value indicating whether to include commas in
start and stop labels. Default value is \code{commas = TRUE}.}

\item{sequence}{A logical value indicating whether to include sequence
information above the label of an x-axis (only at appropriate resolutions).}

\item{boxWidth}{A numeric value indicating the width of the boxes
representing sequence information at appropriate resolutions.
Default value is \code{boxWidth = 0.5}.}

\item{axis}{A character value indicating along which axis to
add genome label. Sequence information will not be displayed along a y-axis.
Default value is \code{axis = "x"}.
Options are:
\itemize{
\item{\code{"x"}: }{Genome label will be plotted along the x-axis.}
\item{\code{"y"}: }{Genome label will be plotted along the y-axis.
This is typically used for a square Hi-C plot made with
\code{plotHicSquare}.}
}}

\item{at}{A numeric vector of x-value locations for tick marks.}

\item{tcl}{A numeric specifying the length of tickmarks as a
fraction of text height. Default value is \code{tcl = 0.5}.}

\item{x}{A numeric or unit object specifying genome label x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying genome label y-location.
The character value will
place the genome label y relative to the bottom of the most recently
plotted plot according to the units of the plotgardener page.}

\item{length}{A numeric or unit object specifying length of
genome label axis.}

\item{just}{Justification of genome label relative to its (x, y)
location. If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"},
and \code{"top"}. Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to
use if \code{x}, \code{y}, or \code{length} are only given as numerics.
Default value is \code{default.units = "inches"}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters or digit specifications.
See \link[grid]{gpar} and \link[base]{formatC}.}
}
\value{
Returns a \code{genomeLabel} object containing
relevant genomic region, placement, and \link[grid]{grob} information.
}
\description{
Plot genomic coordinates along the x or y-axis of a plotgardener plot
}
\examples{
## Load hg19 genomic annotation packages
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
library("org.Hs.eg.db")
library("BSgenome.Hsapiens.UCSC.hg19")

## Create page
pageCreate(width = 5, height = 3, default.units = "inches")

## Plot and place gene track on page
genesPlot <- plotGenes(
    chrom = "chr8",
    chromstart = 1000000, chromend = 2000000,
    assembly = "hg19", fill = c("grey", "grey"),
    fontcolor = c("grey", "grey"),
    x = 0.5, y = 0.25, width = 4, height = 1,
    just = c("left", "top"),
    default.units = "inches"
)

## Plot x-axis genome labels at different scales
plotGenomeLabel(
    chrom = "chr8",
    chromstart = 1000000, chromend = 2000000,
    assembly = "hg19",
    scale = "Mb",
    x = 0.5, y = 1.25, length = 4, just = c("left", "top"),
    default.units = "inches"
)
plotGenomeLabel(
    chrom = "chr8",
    chromstart = 1000000, chromend = 2000000,
    assembly = "hg19",
    scale = "Kb",
    x = 0.5, y = 1.5, length = 4, just = c("left", "top"),
    default.units = "inches"
)
plotGenomeLabel(
    chrom = "chr8",
    chromstart = 1000000, chromend = 2000000,
    assembly = "hg19",
    scale = "bp",
    x = 0.5, y = 1.75, length = 4, just = c("left", "top"),
    default.units = "inches"
)

## Plot a different genomic label region, zooming in enough
## to see base pairs
plotGenomeLabel(
    chrom = "chr8",
    chromstart = 1000000, chromend = 1000050,
    assembly = "hg19",
    x = 0.25, y = 2.2, length = 4.5
)
plotGenomeLabel(
    chrom = "chr8",
    chromstart = 1000000, chromend = 1000020,
    assembly = "hg19",
    x = 0, y = 2.6, length = 5
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotIdeogram.R
\name{plotIdeogram}
\alias{plotIdeogram}
\title{Plot a chromosome ideogram with or without cytobands}
\usage{
plotIdeogram(
    chrom,
    assembly = "hg38",
    data = NULL,
    orientation = "h",
    flip = FALSE,
    showBands = TRUE,
    fill = NULL,
    x = NULL,
    y = NULL,
    width = NULL,
    height = NULL,
    just = c("left", "top"),
    default.units = "inches",
    draw = TRUE,
    params = NULL
)
}
\arguments{
\item{chrom}{Chromosome to be plotted, as a string.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{data}{Custom cytoband data, as a dataframe with the following
columns: "seqnames", "start", "end", "width", "strand",
"name", "gieStain".}

\item{orientation}{Character value indicating the orientation
of the ideogram. Default value is \code{orientation = "h"}.
Options are:
\itemize{
\item{\code{"v"}: }{Vertical ideogram orientation.}
\item{\code{"h"}: }{Horizontal ideogram orientation.}
}}

\item{flip}{Logical value indicating whether to reverse the start and end
positions of the ideogram. If \code{flip = FALSE} (default), the ideogram
starts at the top/left and ends at the bottom/right. If \code{flip = TRUE},
the start and end positions are reversed, meaning the ideogram starts at the
bottom/right and ends at the top/left.}

\item{showBands}{Logical value indicating whether to draw
colored cytobands within ideogram.
Default value is \code{showBands = TRUE}.}

\item{fill}{(optional) A vector specifying alternate colors for cytoband
stains. To change specific gieStain values (i.e. gneg, gpos, etc.) to
specific colors, this vector can be named. This vector must have the same
number of colors as there are gieStain values for each genome assembly.}

\item{x}{A numeric or unit object specifying ideogram x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying ideogram y-location.
The character value will
place the ideogram y relative to the bottom of the most recently
plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying ideogram width.}

\item{height}{A numeric or unit object specifying ideogram height.}

\item{just}{Justification of ideogram relative to its (x, y) location.
If there are two values, the first value specifies horizontal justification
and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use if
\code{x}, \code{y}, \code{width}, or \code{height} are only given as
numerics. Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics output should be
produced. Default value is \code{draw = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}
}
\value{
Returns a \code{ideogram} object containing relevant
genomic region, placement, and \link[grid]{grob} information.
}
\description{
Plot a chromosome ideogram with or without cytobands
}
\details{
An ideogram can be placed on a plotgardener coordinate page by
providing plot placement parameters:
\preformatted{
plotIdeogram(chrom,
                x, y, width, height, just = c("left", "top"),
                default.units = "inches")
}
This function can also be used to quickly plot an unannotated ideogram
by ignoring plot placement parameters:
\preformatted{
plotIdeogram(chrom)
}
If no data is provided, Giemsa stain band data will first try to
fetch UCSC with AnnotationHub. The results are cached for faster access,
but these cached items can be deleted. If no internet connection is
available and AnnotationHub has not previously cached the data, custom
Giemsa stain band data can be loaded with the `data` parameter.
}
\examples{
## Load Giemsa stain band information and genomic
## annotation data for hg19 genome assembly
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(AnnotationHub)

## Create page
pageCreate(width = 4.5, height = 1, default.units = "inches")

## Plot and place ideogram
ideogramPlot <- plotIdeogram(
    chrom = "chr2", assembly = "hg19",
    x = 0.25, y = 0.25, width = 4, height = 0.3,
    just = c("left", "top"),
    default.units = "inches"
)

## Plot text
plotText(
    label = "Chromosome 2", fontcolor = "dark grey",
    x = 4.25, y = 0.65, just = "right"
)

## Hide page guides
pageGuideHide()
}
\seealso{
\link[AnnotationHub]{AnnotationHub}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotManhattan.R
\name{plotManhattan}
\alias{plotManhattan}
\title{Plot a Manhattan plot}
\usage{
plotManhattan(
    data,
    sigVal = 5e-08,
    chrom = NULL,
    chromstart = NULL,
    chromend = NULL,
    assembly = "hg38",
    fill = "black",
    pch = 19,
    cex = 0.25,
    leadSNP = NULL,
    sigLine = FALSE,
    sigCol = NULL,
    trans = "-log10",
    range = NULL,
    yscale_reverse = FALSE,
    space = 0.01,
    bg = NA,
    baseline = FALSE,
    baseline.color = "grey",
    baseline.lwd = 1,
    x = NULL,
    y = NULL,
    width = NULL,
    height = NULL,
    just = c("left", "top"),
    flip = FALSE,
    default.units = "inches",
    draw = TRUE,
    params = NULL,
    ...
)
}
\arguments{
\item{data}{Data to be plotted, as a character value specifying a
file path of GWAS data, a dataframe, or a \link[GenomicRanges]{GRanges}
object. Each of these data types must have the following columns:
\itemize{
\item{\code{"chrom"}: }{Chromosome names. This column must be a character.}
\item{\code{"pos"}: }{Chromosomal position. This column must be
an integer or numeric.}
\item{\code{"p"}: }{p-value or similar measure. This column must be numeric.
Values will be converted according to the \code{trans} parameter.}
\item{\code{"snp"}(optional): }{SNP name or rsid.
This column should be a character.}
}}

\item{sigVal}{A numeric specifying the significance level of p-values.
Along with data p-values, this value will be converted according to the
\code{trans} parameter.
Default value is \code{sigVal = 5e-08}.}

\item{chrom}{Chromosome of region to be plotted, as a string.
If left \code{NULL}, all chromosomes found in data will be plotted.}

\item{chromstart}{Integer start position on chromosome to be plotted.}

\item{chromend}{Integer end position on chromosome to be plotted.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{fill}{A single character value, a vector, or a 
\link[plotgardener]{colorby} object specifying fill colors of data points.
For a Manhattan plot with multiple chromosomes, a vector of colors 
will be used to color points of different chromosomes.
Default value is \code{fill = "black"}.}

\item{pch}{A numeric value or numeric vector specifying point symbols.
If \link[plotgardener]{colorby} object is supplied for \code{fill},
point symbols will be mapped to
\code{colorby} values. Default value is \code{pch = 19}.}

\item{cex}{A numeric indicating the amount by which points should be
scaled relative to the default. Default value is \code{cex = 0.25}.}

\item{leadSNP}{A list specifying the lead SNP in the desired region and
any associated aesthetic features of the lead SNP data point and text label.
The lead SNP should be specified as a character with the name slot
\code{"snp"} in the list. Accepted lead SNP aesthetic
features in the list include
\code{fill}, \code{pch}, \code{cex}, \code{fontcolor}, and \code{fontsize}.}

\item{sigLine}{Logical value indicating whether to draw a line at the
significance level indicated with \code{sigVal}.
Default value is \code{sigLine = FALSE}.}

\item{sigCol}{Single character value specifying the color of
significant data points.}

\item{trans}{Character value specifying the transformation to apply to the
"p" column plotted along the y-axis. For no transformation, set value to the 
empty character "". Default value is \code{trans = "-log10"}.}

\item{range}{A numeric vector of length 2 specifying the y-range
of p-values to plot (c(min, max)).}

\item{yscale_reverse}{Logical value indicating whether to reverse the y-scale
and order points from max to min.}

\item{space}{A numeric value indicating the space between each
chromosome as a fraction of the width of the plot, if plotting multiple
chromosomes. Default value is \code{space = 0.01}.}

\item{bg}{Character value indicating background color.
Default value is \code{bg = NA}.}

\item{baseline}{Logical value indicating whether to include a
baseline along the x-axis. Default value is \code{baseline = FALSE}.}

\item{baseline.color}{Baseline color. Default value
is \code{baseline.color = "grey"}.}

\item{baseline.lwd}{Baseline line width. Default value
is \code{baseline.lwd = 1}.}

\item{x}{A numeric or unit object specifying Manhattan plot x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying Manhattan plot y-location.
The character value will
place the Manhattan plot y relative to the bottom of the most
recently plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying Manhattan plot width.}

\item{height}{A numeric or unit object specifying Manhattan plot height.}

\item{just}{Justification of Manhattan plot relative to its (x, y)
location. If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{flip}{Logical value indicating whether to reflect Manhattan plot
over the x-axis. Default value is \code{flip = FALSE}.}

\item{default.units}{A string indicating the default units to use
if \code{x}, \code{y}, \code{width}, or \code{height} are only given
as numerics. Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics output should
be produced. Default value is \code{draw = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{manhattan} object containing
relevant genomic region, placement, and \link[grid]{grob} information.
}
\description{
Plot a Manhattan plot
}
\details{
A Manhattan plot can be placed on a plotgardener coordinate page by
providing plot placement parameters:
\preformatted{
plotManhattan(data,
                chrom = NULL,
                chromstart = NULL, chromend = NULL,
                x, y, width, height, just = c("left", "top"),
                default.units = "inches")
}
This function can also be used to quickly plot an unannotated
Manhattan plot by ignoring plot placement parameters:
\preformatted{
plotManhattan(data,
                chrom = NULL,
                chromstart = NULL, chromend = NULL)
}
}
\examples{
## Load genomic assembly information
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
## Load GWAS data
library(plotgardenerData)
data("hg19_insulin_GWAS")

## Create a page
pageCreate(width = 7.5, height = 4.5, default.units = "inches")

## Plot all GWAS data
manhattanPlot <- plotManhattan(
    data = hg19_insulin_GWAS, assembly = "hg19",
    fill = c("grey", "#37a7db"),
    sigLine = TRUE,
    trans = "-log10",
    col = "grey", lty = 2, range = c(0, 14),
    x = 0.5, y = 0, width = 6.5, height = 2,
    just = c("left", "top"),
    default.units = "inches"
)
## Annotate genome label
annoGenomeLabel(
    plot = manhattanPlot, x = 0.5, y = 2, fontsize = 8,
    just = c("left", "top"),
    default.units = "inches"
)
plotText(
    label = "Chromosome", fontsize = 8,
    x = 3.75, y = 2.20, just = "center", default.units = "inches"
)

## Annotate y-axis
annoYaxis(
    plot = manhattanPlot, at = c(0, 2, 4, 6, 8, 10, 12, 14),
    axisLine = TRUE, fontsize = 8
)

## Plot y-axis label
plotText(
    label = "-log10(p-value)", x = 0.15, y = 1, rot = 90,
    fontsize = 8, fontface = "bold", just = "center",
    default.units = "inches"
)


## Plot GWAS data zooming in on chromosome 11
## highlighting a lead SNP, and coloring by LD score
hg19_insulin_GWAS$LD <- as.numeric(hg19_insulin_GWAS$LD)
## Group LD column into LD ranges
hg19_insulin_GWAS <- as.data.frame(dplyr::group_by(hg19_insulin_GWAS,
                                        LDgrp = cut(
                                        hg19_insulin_GWAS$LD,
                                        c(0, 0.2, 0.4, 0.6, 0.8, 1))))
hg19_insulin_GWAS$LDgrp <- addNA(hg19_insulin_GWAS$LDgrp)
leadSNP_p <- min(hg19_insulin_GWAS[
    which(hg19_insulin_GWAS$chrom == "chr11"), ]$p)
leadSNP <- hg19_insulin_GWAS[which(hg19_insulin_GWAS$p == leadSNP_p), ]$snp
chr11_manhattanPlot <- plotManhattan(
    data = hg19_insulin_GWAS, chrom = "chr11",
    chromstart = 60000000,
    chromend = 130000000,
    assembly = "hg19",
    fill = colorby("LDgrp",
    palette = colorRampPalette(c(
        "#1f4297",
        "#37a7db", "green",
        "orange", "red", "grey"
    ))),
    trans = "-log10",
    sigLine = TRUE, col = "grey",
    lty = 2, range = c(0, 16),
    leadSNP = list(
        snp = leadSNP,
        pch = 18,
        cex = 0.75,
        fill = "#7ecdbb",
        fontsize = 8
    ),
    x = 0.5, y = 2.5, width = 6.5,
    height = 1.5,
    just = c("left", "top"),
    default.units = "inches"
)

## Plot legend for LD scores
plotLegend(
    legend = c(
        "LD Ref Var",
        paste("0.4", ">", "r^2", 
        "", ">=", "0.2"),
        paste("0.2", ">", "r^2", 
        "", ">=", "0"),
        "no LD data"
    ),
    fill = c("#7ecdbb", "#37a7db", "#1f4297", "grey"), cex = 0.75,
    pch = c(18, 19, 19, 19), border = FALSE, x = 7, y = 2.5,
    width = 1.5, height = 0.6, just = c("right", "top"),
    default.units = "inches"
)


## Annotate genome label
annoGenomeLabel(
    plot = chr11_manhattanPlot, x = 0.5, y = 4.01,
    fontsize = 8, scale = "Mb",
    just = c("left", "top"), default.units = "inches"
)

## Annotate y-axis
annoYaxis(
    plot = chr11_manhattanPlot,
    at = c(0, 2, 4, 6, 8, 10, 12, 14, 16),
    axisLine = TRUE, fontsize = 8
)

## Plot y-axis label
plotText(
    label = "-log10(p-value)", x = 0.15, y = 3.25, rot = 90,
    fontsize = 8, fontface = "bold", just = "center",
    default.units = "inches"
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/assembly.R
\name{assembly}
\alias{assembly}
\title{Make a \code{assembly} object for alternate TxDb, OrgDb,and BSgenome
genomic annotation packages}
\usage{
assembly(
    Genome,
    TxDb,
    OrgDb,
    gene.id.column = "ENTREZID",
    display.column = "SYMBOL",
    BSgenome = NULL
)
}
\arguments{
\item{Genome}{String indicating the name of the genome assembly.}

\item{TxDb}{String of existing TxDb package name or a TxDb object.}

\item{OrgDb}{String of the desired OrgDb package name.}

\item{gene.id.column}{String of the TxDb column name that refers to
the given TxDb gene IDs.
Default value is \code{gene.id.column = "ENTREZID"}.}

\item{display.column}{String of the OrgDb column name that refers to
the type of gene symbol to be displayed in plots.
Default value is \code{display.column = "SYMBOL"}.}

\item{BSgenome}{String of the desired BSgenome package name.}
}
\value{
Returns a \code{assembly} object containing all input parameters.
}
\description{
Make a \code{assembly} object for alternate TxDb, OrgDb,and BSgenome
genomic annotation packages
}
\examples{
## Create a custom `assembly` object for hg38/GRCh38 packages
newAssembly <- assembly(
    Genome = "hg38_GRCh38",
    TxDb = "TxDb.Hsapiens.UCSC.hg38.knownGene",
    OrgDb = "org.Hs.eg.db",
    BSgenome = "BSgenome.Hsapiens.NCBI.GRCh38"
)
}
\seealso{
\link[GenomicFeatures]{TxDb}, \link[AnnotationDbi]{OrgDb-class},
\link[BSgenome]{BSgenome}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoGenomeLabel.R
\name{annoGenomeLabel}
\alias{annoGenomeLabel}
\title{Annotate genomic coordinates along the x or y-axis of a plot}
\usage{
annoGenomeLabel(
    plot,
    fontsize = 10,
    fontcolor = "black",
    linecolor = "black",
    margin = unit(1, "mm"),
    scale = "bp",
    commas = TRUE,
    sequence = TRUE,
    boxWidth = 0.5,
    axis = "x",
    at = NULL,
    tcl = 0.5,
    x,
    y,
    just = c("left", "top"),
    default.units = "inches",
    params = NULL,
    ...
)
}
\arguments{
\item{plot}{Input plot to annotate genomic coordinates.
Genomic coordinates and assembly will be inherited from \code{plot}.}

\item{fontsize}{A numeric specifying text fontsize in points.
Default value is \code{fontsize = 10}.}

\item{fontcolor}{A character value indicating the color for text.
Default value is \code{fontcolor = "black"}.}

\item{linecolor}{A character value indicating the color of
the genome label axis. Default value is \code{linecolor = "black"}.}

\item{margin}{A numeric or unit vector specifying space between axis
and coordinate labels. Default value is \code{margin = unit(1, "mm")}.}

\item{scale}{A character value indicating the scale of the coordinates
along the genome label. Default value is \code{scale = "bp"}. Options are:
\itemize{
\item{\code{"bp"}: }{base pairs.}
\item{\code{"Kb"}: }{kilobase pairs. 1 kilobase pair is equal to
1000 base pairs.}
\item{\code{"Mb"}: }{megabase pairs. 1 megabase pair is equal to
1000000 base pairs.}
}}

\item{commas}{A logical value indicating whether to include commas in
start and stop labels. Default value is \code{commas = TRUE}.}

\item{sequence}{A logical value indicating whether to include sequence
information above the label of an x-axis (only at appropriate resolutions).}

\item{boxWidth}{A numeric value indicating the width of the boxes
representing sequence information at appropriate resolutions.
Default value is \code{boxWidth = 0.5}.}

\item{axis}{A character value indicating along which axis to
add genome label. Sequence information will not be displayed along a y-axis.
Default value is \code{axis = "x"}.
Options are:
\itemize{
\item{\code{"x"}: }{Genome label will be plotted along the x-axis.}
\item{\code{"y"}: }{Genome label will be plotted along the y-axis.
This is typically used for a square Hi-C plot made with
\code{plotHicSquare}.}
}}

\item{at}{A numeric vector of x-value locations for tick marks.}

\item{tcl}{A numeric specifying the length of tickmarks as a fraction of
text height. Default value is \code{tcl = 0.5}.}

\item{x}{A numeric or unit object specifying genome label x-location.}

\item{y}{A numeric, unit object, or character containing a "b" combined
with a numeric value specifying genome label y-location.
The character value will place the genome label y relative to the bottom
of the most recently plotted plot according to the units of the
plotgardener page.}

\item{just}{Justification of genome label relative to its (x, y) location.
If there are two values, the first value specifies horizontal justification
and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"}, \code{"centre"},
\code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use
if \code{x} or \code{y} are only given as numerics.
Default value is \code{default.units = "inches"}.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}

\item{...}{Additional grid graphical parameters or digit specifications.
See \link[grid]{gpar} and \link[base]{formatC}.}
}
\value{
Returns a \code{genomeLabel} object containing
relevant genomic region, placement, and \link[grid]{grob} information.
}
\description{
Annotate genomic coordinates along the x or y-axis of a plot
}
\examples{
## Load hg19 genomic annotation packages
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
library("org.Hs.eg.db")

## Create page
pageCreate(width = 5, height = 2, default.units = "inches")

## Plot and place gene track on page
genesPlot <- plotGenes(
    chrom = "chr8",
    chromstart = 1000000, chromend = 2000000,
    assembly = "hg19", fill = c("grey", "grey"),
    fontcolor = c("grey", "grey"),
    x = 0.5, y = 0.25, width = 4, height = 1,
    just = c("left", "top"),
    default.units = "inches"
)

## Annotate x-axis genome labels at different scales
annoGenomeLabel(
    plot = genesPlot, scale = "Mb",
    x = 0.5, y = 1.25, just = c("left", "top"),
    default.units = "inches"
)
annoGenomeLabel(
    plot = genesPlot, scale = "Kb",
    x = 0.5, y = 1.5, just = c("left", "top"),
    default.units = "inches"
)
annoGenomeLabel(
    plot = genesPlot, scale = "bp",
    x = 0.5, y = 1.75, just = c("left", "top"),
    default.units = "inches"
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCool.R
\name{readCoolBpResolutions}
\alias{readCoolBpResolutions}
\title{Read basepair resolutions from an .(m)cool file}
\usage{
readCoolBpResolutions(file)
}
\arguments{
\item{file}{A character value specifying the path to the .(m)cool file}
}
\value{
Vector of basepair resolutions
}
\description{
Read basepair resolutions from an .(m)cool file
}
\author{
Sarah Parker
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoHighlight.R
\name{annoHighlight}
\alias{annoHighlight}
\title{Annotates a highlight box around a specified genomic region of a
plot}
\usage{
annoHighlight(
    plot,
    chrom,
    chromstart = NULL,
    chromend = NULL,
    fill = "grey",
    linecolor = NA,
    alpha = 0.4,
    y,
    height,
    just = c("left", "top"),
    default.units = "inches",
    params = NULL,
    ...
)
}
\arguments{
\item{plot}{Input plot on which to annotate genomic region.}

\item{chrom}{Chromosome of region to be highlighted, as a string.}

\item{chromstart}{Integer start position on chromosome to be highlighted.}

\item{chromend}{Integer end position on chromosome to be highlighted.}

\item{fill}{A character value specifying highlight box fill color.
Default value is \code{fill = "grey"}.}

\item{linecolor}{A character value specifying highlight box line color.
Default value is \code{linecolor = NA}.}

\item{alpha}{Numeric value specifying color transparency.
Default value is \code{alpha = 0.4}.}

\item{y}{A numeric, unit object, or character containing a "b" combined
with a numeric value specifying square highlight box y-location.
The character value will place the highlight box y relative to the
bottom of the most recently plotted plot according to the
units of the \code{plotgardener} page.}

\item{height}{A numeric or unit object specifying highlight box height.}

\item{just}{Justification of highlight box relative to its (x, y)
location. If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use if
\code{y} or \code{height} are only given as numerics or numeric vectors.
Default value is \code{default.units = "inches"}.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{highlight} object containing relevant
genomic region, placement, and \link[grid]{grob} information.
}
\description{
Annotates a highlight box around a specified genomic region of a
plot
}
\examples{
## Create a page
pageCreate(width = 7.5, height = 1.5, default.units = "inches")

## Plot and place a signal plot
library(plotgardenerData)
data("IMR90_ChIP_H3K27ac_signal")
region <- pgParams(
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    range = c(0, 45)
)
signalPlot <- plotSignal(
    data = IMR90_ChIP_H3K27ac_signal, params = region,
    x = 0.5, y = 0.25, width = 6.5, height = 0.65,
    just = c("left", "top"),
    default.units = "inches"
)

## Highlight genomic region on signal plot
annoHighlight(
    plot = signalPlot,
    chrom = "chr21",
    chromstart = 29000000, chromend = 29125000,
    y = 0.25, height = 1, just = c("left", "top"),
    default.units = "inches"
)

## Plot text label
plotText(
    label = "region of interest", fontsize = 8, fontcolor = "black",
    x = 3.5, y = 0.2, just = "bottom", default.units = "inches"
)

## Plot genome label
plotGenomeLabel(
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 1.3, length = 6.5, default.units = "inches"
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/defaultPackages.R
\name{defaultPackages}
\alias{defaultPackages}
\title{Display the default genomic annotation packages associated with a
genome build}
\usage{
defaultPackages(Genome)
}
\arguments{
\item{Genome}{String indicating the name of the genome assembly.}
}
\value{
Returns a list of the default data packages for a genome build.
}
\description{
Display the default genomic annotation packages associated with a
genome build
}
\examples{
## View default genomic annotation packages associated with "hg19"
defaultPackages(Genome = "hg19")

## View default genomic annotation packages associated with "mm9"
defaultPackages(Genome = "mm9")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoZoomLines.R
\name{annoZoomLines}
\alias{annoZoomLines}
\title{Annotates zoom lines for a specified genomic region of a plot}
\usage{
annoZoomLines(
    plot,
    chrom,
    chromstart = NULL,
    chromend = NULL,
    y0,
    x1 = NULL,
    y1,
    extend = 0,
    default.units = "inches",
    linecolor = "grey",
    lty = 2,
    params = NULL,
    ...
)
}
\arguments{
\item{plot}{Input plot to annotate genomic region zoom lines from.}

\item{chrom}{Chromosome of region to draw zoom lines from, as a string.}

\item{chromstart}{Integer start position on chromosome to draw
zoom lines from.}

\item{chromend}{Integer end position on chromosome to draw
zoom lines from.}

\item{y0}{A numeric vector or unit object indicating the starting
y-values of the zoom line segments. If two values are given,
the first value will correspond to the left zoom line and the
second value will correspond to the right zoom line.}

\item{x1}{A numeric vector or unit object indicating the stopping
x-values of the zoom line segments. If two values are given,
the first value will correspond to the left zoom line and the
second value will correspond to the right zoom line. If NULL,
straight lines from zoomed genomic region will be drawn.}

\item{y1}{A numeric vector or unit object indicating the stopping
y-values of the zoom line segments. If two values are given,
the first value will correspond to the left zoom line and the
second value will correspond to the right zoom line.}

\item{extend}{A numeric vector or unit object indicating the length
to extend straight lines from each end
of the zoom line segments. If two values are given, the first value
will correspond to the top extension length
and the second value will correspond to the bottom extension length.
Default value is \code{extend = 0}.}

\item{default.units}{A string indicating the default units to use
if \code{y0}, \code{x1}, \code{y1}, or \code{extend} are only given
as numerics or numeric vectors.
Default value is \code{default.units = "inches"}.}

\item{linecolor}{A character value specifying zoom line color.
Default value is \code{linecolor = "grey"}.}

\item{lty}{A numeric specifying zoom line type.
Default value is \code{lty = 2}.}

\item{params}{An optional \link[plotgardener]{pgParams}
object containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{zoom} object containing
relevant genomic region, placement, and \link[grid]{grob} information.
}
\description{
Annotates zoom lines for a specified genomic region of a plot
}
\examples{
## Create a page
pageCreate(width = 7.5, height = 4.75, default.units = "inches")

## Plot and place a Manhattan plot
library(plotgardenerData)
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
data("hg19_insulin_GWAS")
manhattanPlot <- plotManhattan(
    data = hg19_insulin_GWAS, assembly = "hg19",
    fill = c("grey", "#37a7db"),
    sigLine = FALSE,
    col = "grey", lty = 2, range = c(0, 14),
    x = 0.5, y = 0, width = 6.5, height = 2,
    just = c("left", "top"),
    default.units = "inches"
)
annoYaxis(
    plot = manhattanPlot, at = c(0, 2, 4, 6, 8, 10, 12, 14),
    axisLine = TRUE, fontsize = 8
)

## Annotate zoom lines for a region on chromsome 21
zoomRegion <- pgParams(
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19"
)
annoZoomLines(
    plot = manhattanPlot, params = zoomRegion,
    y0 = 2, x1 = c(0.5, 7), y1 = 2.5, extend = c(0, 1.1),
    default.units = "inches",
    lty = 3
)

## Annotate highlight region for zoom region
annoHighlight(
    plot = manhattanPlot, params = zoomRegion,
    y = 2, height = 2, just = c("left", "bottom"),
    default.units = "inches",
    fill = "red", alpha = 0.8
)

## Plot Manhattan plot data and signal track under zoom lines
manhattanPlotZoom <- plotManhattan(
    data = hg19_insulin_GWAS,
    fill = "grey",
    sigLine = FALSE,
    baseline = TRUE,
    params = zoomRegion, range = c(0, 14),
    x = 0.5, y = 2.6,
    width = 6.5, height = 1
)
data("IMR90_ChIP_H3K27ac_signal")
signalPlot <- plotSignal(
    data = IMR90_ChIP_H3K27ac_signal, params = zoomRegion,
    range = c(0, 45),
    x = 0.5, y = "b0.1",
    width = 6.5, height = 0.65,
    just = c("left", "top"),
    default.units = "inches"
)

## Plot genome label
plotGenomeLabel(
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 4.4, length = 6.5,
    default.units = "inches"
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pageGuideVertical.R
\name{pageGuideVertical}
\alias{pageGuideVertical}
\title{Draw a vertical guideline at a specified x-coordinate on a 
plotgardener page}
\usage{
pageGuideVertical(
    x,
    default.units = "inches",
    linecolor = "grey55",
    params = NULL,
    ...
)
}
\arguments{
\item{x}{A numeric or unit object specifying x-coordinate of guide.}

\item{default.units}{A string indicating the default units to use
if \code{x} is only given as a numeric.
Default value is \code{default.units = "inches"}.}

\item{linecolor}{Character value indicating color of guideline.
Default value is \code{linecolor = "grey55"}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
None.
}
\description{
Draw a vertical guideline at a specified x-coordinate on a 
plotgardener page
}
\examples{
## Create a page
pageCreate(width = 6, height = 5, default.units = "inches")

## Add blue vertical guideline at x = 1.7 inches
pageGuideVertical(x = 1.7, linecolor = "blue")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoXaxis.R
\name{annoXaxis}
\alias{annoXaxis}
\title{Add an x-axis to a plot}
\usage{
annoXaxis(
    plot,
    at = NULL,
    label = TRUE,
    main = TRUE,
    scipen = 999,
    axisLine = FALSE,
    params = NULL,
    ...
)
}
\arguments{
\item{plot}{Plot object to annotate with x-axis.}

\item{at}{A numeric vector of x-value locations for tick marks.}

\item{label}{A logical value indicating whether to draw the labels on
the tick marks, or an expression or character vector which specify
the labels to use.
If not logical, must be the same length as the \code{at} argument.}

\item{main}{A logical value indicating whether to draw the x-axis at the
bottom of the plot. Default value is \code{main = TRUE}. Options are:
\itemize{
\item{\code{TRUE}: }{x-axis is drawn at the bottom of the plot.}
\item{\code{FALSE}: }{x-axis is drawn at the top of the plot.}
}}

\item{scipen}{An integer indicating the penalty to be applied when
deciding to print numeric values in fixed or exponential notation.
Default value is \code{scipen = 999}.}

\item{axisLine}{A logical value indicating whether to show the axis line.
Default value is \code{axisLine = FALSE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{xaxis} object containing
relevant \link[grid]{grob} information.
}
\description{
Add an x-axis to a plot
}
\examples{
## Load transcript information
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
library("org.Hs.eg.db")

## Create page
pageCreate(width = 7.5, height = 4.5, default.units = "inches")

## Plot gene transcripts
transcriptPlot <- plotTranscripts(
    chrom = "chr1",
    chromstart = 1000000,
    chromend = 2000000,
    assembly = "hg19",
    x = 0.5, y = 0,
    width = 6.5, height = 4,
    just = c("left", "top"),
    default.units = "inches"
)

## Add standard x-axis to transcript plot
annoXaxis(
    plot = transcriptPlot,
    at = c(1000000, 1250000, 1500000, 1750000, 2000000),
    fontsize = 8
)
plotText(
    label = "Basepairs", fontsize = 10, fontface = "bold",
    x = 3.75, y = 4.3, just = "top"
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotPairs.R
\name{plotPairs}
\alias{plotPairs}
\title{Plot paired-end genomic range elements}
\usage{
plotPairs(
    data,
    chrom,
    chromstart = NULL,
    chromend = NULL,
    assembly = "hg38",
    fill = "#1f4297",
    linecolor = NA,
    bg = NA,
    boxHeight = unit(2, "mm"),
    spaceWidth = 0.02,
    spaceHeight = 0.3,
    limitLabel = TRUE,
    baseline = FALSE,
    baseline.color = "grey",
    baseline.lwd = 1,
    x = NULL,
    y = NULL,
    width = NULL,
    height = NULL,
    just = c("left", "top"),
    default.units = "inches",
    draw = TRUE,
    params = NULL,
    ...
)
}
\arguments{
\item{data}{A string specifying the BEDPE file path, a dataframe
in BEDPE format specifying data to be plotted, or a
\link[InteractionSet]{GInteractions} object.}

\item{chrom}{Chromosome of region to be plotted, as a string.}

\item{chromstart}{Integer start position on chromosome to be plotted.}

\item{chromend}{Integer end position on chromosome to be plotted.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{fill}{A single character value, a vector, or 
a \link[plotgardener]{colorby} object specifying fill colors of
paired range elements. Default value is \code{fill = "#1f4297"}.}

\item{linecolor}{A single character value, a vector, or a
\link[plotgardener]{colorby} object specifying the color of the lines
outlining paired range elements. Default value is \code{linecolor = NA}.
Special options include:
\itemize{
\item{\code{NA}: }{No line color.}
\item{\code{"fill"}: }{Same color as \code{fill}.}
}}

\item{bg}{Character value indicating background color.
Default value is \code{bg = NA}.}

\item{boxHeight}{A numeric or unit object specifying height of boxes
at either end of paired range elements.
Default value is \code{boxHeight = unit(2, "mm")}.}

\item{spaceWidth}{A numeric specifying the width of spacing between
paired range elements, as a fraction of the plot's genomic range.
Default value is \code{spaceWidth = 0.02}.}

\item{spaceHeight}{A numeric specifying the height of space between
boxes of paired range elements on different rows.
Default value is \code{spaceHeight = 0.3}.}

\item{limitLabel}{A logical value indicating whether to draw a "+"
when not all elements can be plotted in the plotting space. Default 
value is \code{limitLabel = TRUE}.}

\item{baseline}{Logical value indicating whether to include a baseline
along the x-axis. Default value is \code{baseline = FALSE}.}

\item{baseline.color}{Baseline color.
Default value is \code{baseline.color = "grey"}.}

\item{baseline.lwd}{Baseline line width.
Default value is \code{baseline.lwd = 1}.}

\item{x}{A numeric or unit object specifying paired range plot x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying paired range plot y-location.
The character value will
place the paired range plot y relative to the bottom of the most recently
plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying paired range plot width.}

\item{height}{A numeric or unit object specifying paired range plot height.}

\item{just}{Justification of paired range plot relative
to its (x, y) location.
If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use
if \code{x}, \code{y}, \code{width}, or \code{height} are only given
as numerics. Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics
output should be produced.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{pairs} object containing relevant
genomic region, placement, and \link[grid]{grob} information.
}
\description{
Plot paired-end genomic range elements
}
\details{
#' A paired ranges plot can be placed on a plotgardener coordinate page
by providing plot placement parameters:
\preformatted{
plotPairs(data, chrom,
            chromstart = NULL, chromend = NULL,
            x, y, width, height, just = c("left", "top"),
            default.units = "inches")
}
This function can also be used to quickly plot an unannotated paired
ranges plot by ignoring plot placement parameters:
\preformatted{
plotPairs(data, chrom,
            chromstart = NULL, chromend = NULL)
}
}
\examples{
## Load paired ranges data in BEDPE format
library(plotgardenerData)
data("IMR90_DNAloops_pairs")

## Set the coordinates
params <- pgParams(
    chrom = "chr21",
    chromstart = 27900000, chromend = 30700000,
    assembly = "hg19",
    width = 7
)

## Create a page
pageCreate(width = 7.5, height = 2.1, default.units = "inches")

## Add a length column
IMR90_DNAloops_pairs$length <- 
        (IMR90_DNAloops_pairs$start2 - IMR90_DNAloops_pairs$start1) / 1000

## Plot the data
bedpePlot <- plotPairs(
    data = IMR90_DNAloops_pairs, params = params,
    fill = colorby("length", palette = 
                colorRampPalette(c("dodgerblue2", "firebrick2"))),
    lwd = 2, spaceHeight = .7,
    x = 0.25, y = 0.25, height = 1.5,
    just = c("left", "top"), default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(plot = bedpePlot, x = 0.25, y = 1.78, scale = "Mb")

## Add heatmap legend
annoHeatmapLegend(
    plot = bedpePlot, fontcolor = "black",
    x = 7.0, y = 0.25,
    width = 0.10, height = 1, fontsize = 10
)

## Add heatmap legend label
plotText(
    label = "Kb", rot = 90, x = 6.9, y = 0.75,
    just = c("center", "center"), fontsize = 10
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoSegments.R
\name{annoSegments}
\alias{annoSegments}
\title{Annotates a line segment within a plot}
\usage{
annoSegments(
    x0,
    y0,
    x1,
    y1,
    plot,
    default.units = "native",
    linecolor = "black",
    lwd = 1,
    lty = 1,
    lineend = "butt",
    linejoin = "mitre",
    arrow = NULL,
    params = NULL,
    ...
)
}
\arguments{
\item{x0}{A numeric vector or unit object indicating the starting
x-values of the line segments.}

\item{y0}{A numeric vector or unit object indicating the starting
y-values of the line segments.}

\item{x1}{A numeric vector or unit object indicating the stopping
x-values of the line segments.}

\item{y1}{A numeric vector or unit object indicating the stopping
y-values of the line segments.}

\item{plot}{Input plotgardener plot to internally plot line segments
relative to.}

\item{default.units}{A string indicating the default units to use
if \code{x0}, \code{y0}, \code{x1}, or \code{y1} are only given
as numeric vectors. Default value is \code{default.units = "native"}.}

\item{linecolor}{A character value specifying segment line color.
Default value is \code{linecolor = "black"}.}

\item{lwd}{A numeric specifying segment line width.
Default value is \code{lwd = 1}.}

\item{lty}{A numeric specifying segment line type.
Default value is \code{lty = 1}.}

\item{lineend}{A character value specifying line end style.
Default value is \code{lineend = "butt"}. Options are:
\itemize{
\item{\code{"round"}: Segment ends are rounded.}
\item{\code{"butt"}: Segment ends end exactly where ended.}
\item{\code{"square"}: Segment ends are squared.}
}}

\item{linejoin}{A character value specifying line join style.
Default value is \code{linejoin = "mitre"}. Options are:
\itemize{
\item{\code{"round"}: }{Line joins are rounded.}
\item{\code{"mitre"}: }{Line joins are sharp corners.}
\item{\code{"bevel"}: }{Line joins are flattened corners.}
}}

\item{arrow}{A list describing arrow heads to place at either
end of the line segments, as produced by the \link[grid]{arrow} function.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{segments} object containing relevant
placement and \link[grid]{grob} information.
}
\description{
Annotates a line segment within a plot
}
\examples{
library(grid)
## Create a page
pageCreate(width = 7.5, height = 2.5, default.units = "inches")

## Plot a Manhattan plot
library(plotgardenerData)
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
data("hg19_insulin_GWAS")
manhattanPlot <- plotManhattan(
    data = hg19_insulin_GWAS, assembly = "hg19",
    fill = c("grey", "#37a7db"),
    sigLine = TRUE,
    col = "grey", lty = 2, range = c(0, 14),
    x = 0.5, y = 0, width = 6.5, height = 2,
    just = c("left", "top"),
    default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(
    plot = manhattanPlot, x = 0.5, y = 2, fontsize = 8,
    just = c("left", "top"),
    default.units = "inches"
)
plotText(
    label = "Chromosome", fontsize = 8,
    x = 3.75, y = 2.20, just = "center", default.units = "inches"
)

## Annotate y-axis
annoYaxis(
    plot = manhattanPlot, at = c(0, 2, 4, 6, 8, 10, 12, 14),
    axisLine = TRUE, fontsize = 8
)

## Annotate a line segment for an additional significance line of
## the Manhattan plot
annoSegments(
    x0 = unit(0, "npc"), y0 = 10,
    x1 = unit(1, "npc"), y1 = 10,
    plot = manhattanPlot, default.units = "native",
    linecolor = "red", lty = 2
)

## Plot y-axis label
plotText(
    label = "-log10(p-value)", x = 0.15, y = 1, rot = 90,
    fontsize = 8, fontface = "bold", just = "center",
    default.units = "inches"
)

## Hide page guides
pageGuideHide()
}
\seealso{
\link[grid]{grid.segments}, \link[grid]{arrow}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotPolygon.R
\name{plotPolygon}
\alias{plotPolygon}
\title{Plot a polygon within a plotgardener layout}
\usage{
plotPolygon(
    x,
    y,
    default.units = "inches",
    linecolor = "black",
    lwd = 1,
    lty = 1,
    fill = NA,
    alpha = 1,
    id = NULL,
    id.lengths = NULL,
    params = NULL,
    ...
)
}
\arguments{
\item{x}{A numeric vector or unit object specifying polygon
vertex x-locations.}

\item{y}{A numeric vector, unit object, or a character vector
of values containing a "b" combined with a numeric value specifying
polygon vertex y-locations.
The character vector will place polygon vertex y-locations relative
to the bottom of the most recently plotted plot according
to the units of the plotgardener page.}

\item{default.units}{A string indicating the default units to use
if \code{x} or \code{y} are only given as numeric vectors.
Default value is \code{default.units = "inches"}.}

\item{linecolor}{A character value specifying polygon line color.
Default value is \code{linecolor = "black"}.}

\item{lwd}{A numeric specifying polygon line width.
Default value is \code{lwd = 1}.}

\item{lty}{A numeric specifying polygon line type.
Default value is \code{lty = 1}.}

\item{fill}{A character value specifying polygon fill color.
Default value is \code{fill = NA}.}

\item{alpha}{Numeric value specifying color transparency.
Default value is \code{alpha = 1}.}

\item{id}{A numeric vector used to separate locations in \code{x} and
\code{y} into multiple polygons. All locations with the same \code{id}
belong to the same polygon.}

\item{id.lengths}{A numeric vector used to separate locations in
\code{x} and \code{y} into multiple polygons. Specifies consecutive
blocks of locations which make up separate polygons.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{polygon} object containing relevant
placement and \link[grid]{grob} information.
}
\description{
Plot a polygon within a plotgardener layout
}
\examples{
## Create a page
pageCreate(width = 7.5, height = 6, default.units = "inches")

## Plot complex polygons one at a time
plotPolygon(
    x = c(2.6, 4.65, 4.75, 6.05, 1.4, 1.3),
    y = c(2.5, 3.1, 3.5, 4, 3.15, 2.8),
    fill = "#4a168e", linecolor = NA
)

plotPolygon(
    x = c(4.65, 4.75, 6.05, 5.05, 4.4),
    y = c(3.1, 3.5, 4, 1.45, 1.2),
    fill = "#9d28b0", linecolor = NA
)

## Plot multiple triangles with different id's and colors
plotPolygon(
    x = c(
        0.45, 6.05, 3, 3, 6.05, 5.25, 4.4, 5.05, 4.95,
        1.3, 2.6, 1, 4.4, 4.95, 5, 4.95, 5, 6.25
    ),
    y = c(
        2.85, 4, 5.55, 5.55, 4, 5.55, 1.2, 1.45, 1.1,
        2.8, 2.5, 2.1, 1.2, 1.1, 0.45, 1.1, 0.45, 1.1
    ),
    id = c(1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5, 6, 6, 6),
    fill = c(
        "#ce93d9", "#bb6ac9", "#4a168e",
        "#7b1fa0", "#bb6ac9", "#ce93d9"
    ),
    linecolor = NA
)

## Hide page guides
pageGuideHide()
}
\seealso{
\link[grid]{grid.polygon}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCool.R
\name{readCoolChroms}
\alias{readCoolChroms}
\title{Read chromosomes included in .(m)cool files}
\usage{
readCoolChroms(file, resolution = NULL)
}
\arguments{
\item{file}{A character value specifying the path to the .(m)cool file}

\item{resolution}{optional, specify which resolution(s) to read 
chromosomes from. Default is all resolutions in `file`.}
}
\value{
Data frame or list of data frames of chromosome names and lengths
}
\description{
Read chromosomes included in .(m)cool files
}
\author{
Sarah Parker, Nicole Kramer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pageGuideShow.R
\name{pageGuideShow}
\alias{pageGuideShow}
\title{Reshow guides drawn with \code{pageCreate},
\code{pageGuideHorizontal}, and \code{pageGuideVertical}}
\usage{
pageGuideShow()
}
\value{
None.
}
\description{
Reshow guides drawn with \code{pageCreate},
\code{pageGuideHorizontal}, and \code{pageGuideVertical}
}
\examples{
## Load Hi-C data
library(plotgardenerData)
data("IMR90_HiC_10kb")

## Create a page
pageCreate(width = 3, height = 3, default.units = "inches")

## Add a page guide
pageGuideHorizontal(y = 0.5, default.units = "inches")

## Plot and place Hi-C plot
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, resolution = 10000,
    zrange = c(0, 70),
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    x = 0.5, y = 0.5, width = 2, height = 2,
    just = c("left", "top"),
    default.units = "inches"
)

## Hide page guides
pageGuideHide()

## Re-show page guides
pageGuideShow()

## Annotate genome label
annoGenomeLabel(
    plot = hicPlot, scale = "Mb", axis = "x",
    x = 0.5, y = 2.53, just = c("left", "top")
)
}
\seealso{
\link[plotgardener]{pageCreate},
\link[plotgardener]{pageGuideHorizontal},
\link[plotgardener]{pageGuideVertical}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotGenes.R
\name{plotGenes}
\alias{plotGenes}
\title{Plot a gene track for a specified genomic region}
\usage{
plotGenes(
    chrom,
    chromstart = NULL,
    chromend = NULL,
    assembly = "hg38",
    fontsize = 8,
    fontcolor = c("#669fd9", "#abcc8e"),
    fill = c("#669fd9", "#abcc8e"),
    geneOrder = NULL,
    geneHighlights = NULL,
    geneBackground = "grey",
    strandLabels = TRUE,
    stroke = 0.1,
    bg = NA,
    x = NULL,
    y = NULL,
    width = NULL,
    height = unit(0.6, "inches"),
    just = c("left", "top"),
    default.units = "inches",
    draw = TRUE,
    params = NULL
)
}
\arguments{
\item{chrom}{Chromosome of region to be plotted, as a string.}

\item{chromstart}{Integer start position on chromosome to be plotted.}

\item{chromend}{Integer end position on chromosome to be plotted.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{fontsize}{A numeric specifying text fontsize in points.
Default value is \code{fontsize = 8}.}

\item{fontcolor}{A character value or vector of length 2 indicating
the fontcolors for the plus strand and minus strand gene labels.
The first value will color the plus strand gene labels and
the second value will color the minus strand gene labels.
Default value is \code{fontcolor = c("#669fd9", "#abcc8e")}.}

\item{fill}{A character value or vector of length 2 indicating the
strand fill colors for the plus strand and minus strand plot elements.
The first value will color the plus strand plot elements and
the second label will color the minus strand plot elements.
Default value is \code{fill = c("#669fd9", "#abcc8e")}.}

\item{geneOrder}{An ordered character vector of gene names to
prioritize when labeling genes.}

\item{geneHighlights}{A two-column dataframe with a column named "gene"
containing gene names as strings to highlight and a named column "color"
containing corresponding highlight colors.}

\item{geneBackground}{If \code{geneHighlights} is given, a character
value indicating the color for genes that are not highlighted.}

\item{strandLabels}{A logical value indicating whether to include
+ and - strand labels to the left of the gene track.}

\item{stroke}{A numeric value indicating the stroke width for gene
body outlines. Default value is \code{stroke = 0.1}.}

\item{bg}{Character value indicating background color.
Default value is \code{bg = NA}.}

\item{x}{A numeric or unit object specifying genes plot x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying genes plot y-location.
The character value will
place the genes plot y relative to the bottom of the most recently
plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying genes plot width.}

\item{height}{A numeric or unit object specifying genes plot height.}

\item{just}{Justification of genes plot relative to its (x, y) location.
If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use if
\code{x}, \code{y}, \code{width}, or \code{height} are only given
as numerics. Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics output
should be produced. Default value is \code{draw = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}
}
\value{
Returns a \code{genes} object containing
relevant genomic region, placement, and \link[grid]{grob} information.
}
\description{
Plot a gene track for a specified genomic region
}
\details{
A gene track can be placed on a page by providing
plot placement parameters:
\preformatted{
plotGenes(chrom, chromstart = NULL, chromend = NULL,
            x, y, width, height, just = c("left", "top"),
            default.units = "inches")
}
This function can be used to quickly plot an unnannotated gene track
by ignoring plot placement parameters:
\preformatted{
plotGenes(chrom, chromstart = NULL, chromend = NULL)
}

Genomic annotation information is acquired through
\link[GenomicFeatures]{TxDb} and \link[AnnotationDbi]{OrgDb-class}
packages, as determined
through the \code{assembly} parameter. To avoid overcrowding of gene name
labels, plotted gene labels are by default prioritized according to
citation counts.
}
\examples{
## Load hg19 genomic annotation packages
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
library("org.Hs.eg.db")

## Set genomic coordinates
paramssmall <- pgParams(
    chrom = "chr8",
    chromstart = 1, chromend = 3000000,
    assembly = "hg19", width = 7
)
paramsbig <- pgParams(
    chrom = "chr8",
    chromstart = 1, chromend = 146364022,
    assembly = "hg19", width = 7
)
## Set colors
cols <- c("#41B6C4", "#225EA8")

## Create page
pageCreate(width = 7.5, height = 3.5, default.units = "inches")

## Plot genes big
genesPlot <- plotGenes(
    params = paramsbig, fill = cols,
    fontcolor = cols,
    x = 0.25, y = 0.25, height = 0.75,
    just = c("left", "top"),
    default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(
    plot = genesPlot, x = 0.25, y = 1.0,
    scale = "Mb", just = c("left", "top")
)

## Plot genes small
genesPlot <- plotGenes(
    params = paramssmall,
    geneHighlights = data.frame(
        "gene" = c("DLGAP2"),
        "color" = c("#225EA8")
    ),
    geneBackground = "grey",
    x = 0.25, y = 2.25, height = 0.75,
    just = c("left", "top"), default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(
    plot = genesPlot, x = 0.25, y = 3.0, scale = "Mb",
    just = c("left", "top")
)

## Hide page guides
pageGuideHide()
}
\seealso{
\link[plotgardener]{assembly},
\link[plotgardener]{genomes}, \link[plotgardener]{defaultPackages}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoHeatmapLegend.R
\name{annoHeatmapLegend}
\alias{annoHeatmapLegend}
\title{Add a color scale legend for heatmap-style plots}
\usage{
annoHeatmapLegend(
    plot,
    orientation = "v",
    fontsize = 8,
    fontcolor = "dark grey",
    scientific = FALSE,
    digits = 1,
    ticks = FALSE,
    breaks = NULL,
    border = FALSE,
    x,
    y,
    width,
    height,
    just = c("left", "top"),
    default.units = "inches",
    params = NULL,
    ...
)
}
\arguments{
\item{plot}{Heatmap-style plot object to add heatmap legend for.}

\item{orientation}{A string specifying legend orientation.
Default value is \code{orientation = "v"}. Options are:
\itemize{
\item{\code{"v"}: }{Vertical legend orientation.}
\item{\code{"h"}: }{Horizontal legend orientation.}
}}

\item{fontsize}{A numeric specifying text fontsize in points.
Default value is \code{fontsize = 8}.}

\item{fontcolor}{Character value specfying text fontcolor.
Default value is \code{fontcolor = "dark grey"}.}

\item{scientific}{Logical value specifying if numeric color value labels
should be encoded in scientific format.
Default value is \code{scientific = FALSE}.}

\item{digits}{Numeric specifying how many significant digits to include
of numeric color value labels. Default value is \code{digits = 1}.}

\item{ticks}{Logical value specifying if tick marks on the heatmap
colorbar should be visible. Default value is \code{ticks = FALSE}.}

\item{breaks}{A numeric vector specifying tick breaks.
Default value is \code{breaks = NULL}.}

\item{border}{Logical value indicating whether to add a border around
heatmap legend. Default value is \code{border = FALSE}.}

\item{x}{A numeric or unit object specifying x-location of legend.}

\item{y}{A numeric, unit object, or character containing a "b" combined
with a numeric value specifying y-location of legend.
The character value will place the legend y relative to the bottom of the
most recently plotted plot according to the units of
the plotgardener page.}

\item{width}{A numeric or unit object specifying width of legend.}

\item{height}{A numeric or unit object specifying height of legend.}

\item{just}{Justification of heatmap legend relative to
its (x, y) location. If there are two values, the first value specifies
horizontal justification and the second value specifies vertical
justification. Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use if
\code{x}, \code{y}, \code{width}, or \code{height} are only given as
numerics. Default value is \code{default.units = "inches"}.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{heatmapLegend} object with relevant
color value, placement, and \link[grid]{grob} information.
}
\description{
Add a color scale legend for heatmap-style plots
}
\examples{
## Load Hi-C data
library(plotgardenerData)
data("IMR90_HiC_10kb")

## Create page
pageCreate(width = 4, height = 3.5, default.units = "inches")

## Plot and place a square Hi-C plot
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, resolution = 10000,
    zrange = c(0, 70),
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 0.5, width = 2.5, height = 2.5,
    just = c("left", "top"),
    default.units = "inches"
)

## Add heatmap legend
annoHeatmapLegend(
    plot = hicPlot,
    x = 3.2, y = 0.5, width = 0.12, height = 1.2,
    just = c("left", "top"), default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(
    plot = hicPlot, x = 0.5, y = 3.03, scale = "Mb",
    just = c("left", "top")
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readBigwig.R
\name{readBigwig}
\alias{readBigwig}
\title{Read a bigWig file and return it as a data frame}
\usage{
readBigwig(
    file,
    chrom = NULL,
    chromstart = 1,
    chromend = .Machine$integer.max,
    strand = "*",
    params = NULL
)
}
\arguments{
\item{file}{A character value specifying the path to the bigwig file.}

\item{chrom}{Chromosome of data as a string, if data for a specific
chromosome is desired.}

\item{chromstart}{Integer start position on chromosome.}

\item{chromend}{Integer end position on chromosome.}

\item{strand}{A character value specifying strand.
Default value is \code{strand = "*"}. Options are:
\itemize{
\item{\code{"+"}: }{Plus strand.}
\item{\code{"-"}: }{Minus strand.}
\item{\code{"*"}: }{Plus and minus strands.}
}}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}
}
\value{
Returns a 6-column dataframe of bigwig information.
}
\description{
Read a bigWig file and return it as a data frame
}
\details{
This function does not work on Windows.
}
\examples{
if (.Platform$OS.type != "windows"){
    bwFile <- system.file("extdata/test.bw", package="plotgardenerData")

    ## Read in entire file
    bwData <- readBigwig(file = bwFile)

    ## Read in specified region
    bwRegion <- readBigwig(file = bwFile,
                            chrom = "chr2",
                            chromstart = 1,
                            chromend = 1500)
}

}
\seealso{
\link[rtracklayer]{import.bw}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotTranscripts.R
\name{plotTranscripts}
\alias{plotTranscripts}
\title{Plot gene transcripts in a pileup style for a single chromosome}
\usage{
plotTranscripts(
    chrom,
    chromstart = NULL,
    chromend = NULL,
    assembly = "hg38",
    fill = c("#669fd9", "#abcc8e"),
    colorbyStrand = TRUE,
    strandSplit = FALSE,
    boxHeight = unit(2, "mm"),
    spaceWidth = 0.02,
    spaceHeight = 0.3,
    limitLabel = TRUE,
    transcriptHighlights = NULL,
    transcriptFilter = NULL,
    fontsize = 8,
    labels = "transcript",
    stroke = 0.1,
    bg = NA,
    x = NULL,
    y = NULL,
    width = NULL,
    height = NULL,
    just = c("left", "top"),
    default.units = "inches",
    draw = TRUE,
    params = NULL
)
}
\arguments{
\item{chrom}{Chromosome of region to be plotted, as a string.}

\item{chromstart}{Integer start position on chromosome to be plotted.}

\item{chromend}{Integer end position on chromosome to be plotted.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{fill}{Character value(s) as a single value or vector
specifying fill colors of transcripts.
Default value is \code{fill = c("#669fd9", "#abcc8e")}.}

\item{colorbyStrand}{A logical value indicating whether to
color plus and minus strands by the first two colors in
a \code{fill} vector, where plus strand transcripts will be
colored by the first \code{fill} color and
minus strand transcripts will be colored by the second \code{fill}
color. Default value is \code{colorbyStrand = TRUE}.}

\item{strandSplit}{A logical value indicating whether plus and
minus-stranded transcripts should be separated, with plus strand
transcripts plotted above the x-axis and minus strand transcripts
plotted below the x-axis. Default value is \code{strandSplit = FALSE}.}

\item{boxHeight}{A numeric or unit object specifying height of transcripts.
Default value is \code{boxHeight = unit(2, "mm")}.}

\item{spaceWidth}{A numeric value specifying the width of minimum spacing
between transcripts, as a fraction of the plot's genomic range.
Default value is \code{spaceWidth = 0.02}.}

\item{spaceHeight}{A numeric value specifying the height of spacing
between transcripts on different rows, as a fraction of \code{boxHeight}.
Default value is \code{spaceHeight = 0.3}.}

\item{limitLabel}{A logical value indicating whether to draw a "+"
when not all elements can be plotted in the plotting space. Default 
value is \code{limitLabel = TRUE}.}

\item{transcriptHighlights}{A two-column dataframe with a column named
"transcript" or "gene" containing transcript names or their associated gene 
names as strings to highlight and a column named "color" containing 
corresponding highlight colors.}

\item{transcriptFilter}{A character vector of the names of transcripts to 
display (default is \code{NULL}, no filtering)}

\item{fontsize}{A numeric specifying text fontsize in points.
Default value is \code{fontsize = 8}.}

\item{labels}{A character value describing the format of
transcript text labels. Default value is \code{labels = "trancript"}.
Options are:
\itemize{
\item{\code{NULL}: }{No labels.}
\item{\code{"transcript"}: }{Transcript name labels.}
\item{\code{"gene"}: }{Gene name labels.}
\item{\code{"both"}: }{Combined transcript and gene name labels with
the format "gene name:transcript name".}
}}

\item{stroke}{A numeric value indicating the stroke width for
transcript body outlines. Default value is \code{stroke = 0.1}.}

\item{bg}{Character value indicating background color.
Default value is \code{bg = NA}.}

\item{x}{A numeric or unit object specifying transcript plot x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying transcript plot y-location.
The character value will
place the transcript plot y relative to the bottom of the most recently
plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying transcript plot width.}

\item{height}{A numeric or unit object specifying transcript plot height.}

\item{just}{Justification of transcript plot relative to
its (x, y) location. If there are two values, the first value specifies
horizontal justification and the second value specifies vertical
justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use if
\code{x}, \code{y}, \code{width}, or \code{height} are only given as
numerics. Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics output should be
produced. Default value is \code{draw = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}
}
\value{
Returns a \code{transcripts} object containing relevant
genomic region, placement, and \link[grid]{grob} information.
}
\description{
Plot gene transcripts in a pileup style for a single chromosome
}
\details{
A transcripts plot can be placed on a plotgardener coordinate page
by providing plot placement parameters:
\preformatted{
plotTranscripts(chrom, chromstart = NULL, chromend = NULL,
                x, y, width, height, just = c("left", "top"),
                default.units = "inches")
}
This function can also be used to quickly plot an unannotated
transcripts plot by ignoring plot placement parameters:
\preformatted{
plotTranscripts(chrom, chromstart = NULL, chromend = NULL)
}

Genomic annotation information is acquired through
\link[GenomicFeatures]{TxDb} and \link[AnnotationDbi]{OrgDb-class} packages,
as determined through the \code{assembly} parameter.
}
\examples{
## Load hg19 genomic annotation packages
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
library("org.Hs.eg.db")

## Create page
pageCreate(width = 7.5, height = 3.5, default.units = "inches")

## Plot and place transcripts
plotTranscripts(
    chrom = "chr8", chromstart = 1000000, chromend = 2000000,
    assembly = "hg19", labels = "gene",
    x = 0.5, y = 0.5, width = 6.5, height = 2.5,
    just = c("left", "top"), default.units = "inches"
)

## Plot genome label
plotGenomeLabel(
    chrom = "chr8", chromstart = 1000000, chromend = 2000000,
    assembly = "hg19",
    x = 0.5, y = 3.03, length = 6.5, default.units = "inches"
)

## Plot a legend
plotLegend(
    legend = c("+ strand", "- strand"),
    fill = c("#669fd9", "#abcc8e"), border = FALSE,
    x = 0.5, y = 1, width = 1, height = 0.5,
    just = c("left", "top")
)

## Hide page guides
pageGuideHide()
}
\seealso{
\link[plotgardener]{assembly},
\link[plotgardener]{genomes}, \link[plotgardener]{defaultPackages}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotRaster.R
\name{plotRaster}
\alias{plotRaster}
\title{Plot a raster object within a plotgardener layout}
\usage{
plotRaster(
    image,
    x,
    y,
    width,
    height,
    just = "center",
    default.units = "inches",
    interpolate = TRUE,
    params = NULL,
    ...
)
}
\arguments{
\item{image}{Any R object that can be coerced to a raster object.}

\item{x}{A numeric vector or unit object specifying raster x-locations.}

\item{y}{A numeric vector, unit object, or a character vector of values
containing a "b" combined with a numeric value specifying
raster y-locations.
The character vector will place raster y relative to the bottom
of the most recently plotted plot according to the units
of the plotgardener page.}

\item{width}{A numeric vector or unit object specifying raster widths.}

\item{height}{A numeric vector or unit object specifying raster heights.}

\item{just}{Justification of text relative to its (x, y) location.
If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and
\code{"top"}. Default value is \code{just = "center"}.}

\item{default.units}{A string indicating the default units
to use if \code{x}, \code{y}, \code{width}, or \code{height}
are only given as numerics or numeric vectors.
Default value is \code{default.units = "inches"}.}

\item{interpolate}{A logical value indicating whether to linearly
interpolate the image. Default value is \code{interpolate = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{raster} object containing
relevant placement and \link[grid]{grob} information.
}
\description{
Plot a raster object within a plotgardener layout
}
\examples{
library(png)

## Load images

pg_type <- readPNG(system.file("images",
    "pg-wordmark.png",
    package = "plotgardener"
))

gene_gnome <- readPNG(system.file("images",
    "pg-gnome-hole-shadow.png",
    package = "plotgardener"
))

rlogo <- readPNG(system.file("images", "Rlogo.png", 
                package = "plotgardener"))

## Create page
pageCreate(width = 5, height = 6)

## Plot images
plotRaster(
    image = pg_type,
    x = 2.5, y = 0.25, width = 4, height = 1.5,
    just = "top"
)

plotRaster(
    image = gene_gnome,
    x = 2.5, y = 2.25, width = 3.5, height = 3.5,
    just = "top"
)

plotRaster(
    image = rlogo,
    x = 1, y = 1.5, width = 0.5, height = 0.45,
    just = c("left", "top")
)

## Hide page guies
pageGuideHide()
}
\seealso{
\link[grid]{grid.raster}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotgardener.R
\docType{package}
\name{plotgardener}
\alias{plotgardener-package}
\alias{plotgardener}
\title{plotgardener: Coordinate-based Genomic Visualization Package for R}
\description{
plotgardener is a coordinate-based genomic visualization package for R.
It grants users the ability to programmatically produce complex,
multi-paneled figures. Tailored for genomics, plotgardener allows users
to visualize large complex genomic datasets and
provides exquisite control over how plots are placed and arranged on
a page.
}
\seealso{
Useful links:
\itemize{
    \item \url{https://phanstiellab.github.io/plotgardener}
    \item \url{https://github.com/PhanstielLab/plotgardener}
}
}
\author{
\strong{Maintainer}: Nicole Kramer \email{nekramer@live.unc.edu}
(\href{https://orcid.org/0000-0001-9617-9671}{ORCID})

Authors:
\itemize{
    \item Eric S. Davis \email{esdavis@live.unc.edu}
    (\href{https://orcid.org/0000-0003-4051-3217}{ORCID})
    \item Craig Wenger \email{craig.wenger@gmail.com}
    (\href{https://orcid.org/0000-0002-7361-8456}{ORCID})
    \item Douglas H. Phanstiel \email{douglas_phanstiel@med.unc.edu}
    [copyright holder]
}

Other contributors:
\itemize{
    \item Sarah Parker \email{sarmae@live.unc.edu} [contributor]
    \item Erika Deoudes \email{ed@erikadudes.com} [artist]
    \item Michael Love \email{milove@email.unc.edu} [contributor]
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotText.R
\name{plotText}
\alias{plotText}
\title{Plot text within a plotgardener layout}
\usage{
plotText(
    label,
    fontcolor = "black",
    fontsize = 12,
    rot = 0,
    check.overlap = FALSE,
    x,
    y,
    just = "center",
    default.units = "inches",
    params = NULL,
    ...
)
}
\arguments{
\item{label}{Character or expression of text to be plotted.}

\item{fontcolor}{A character value specifying text fontcolor.
Default value is \code{fontcolor = "black"}.}

\item{fontsize}{A numeric specifying text fontsize in points.
Default value is \code{fontsize = 12}.}

\item{rot}{A numeric specifying the angle to rotate the text.
Default value is \code{rot = 0}.}

\item{check.overlap}{A logical value to indicate whether to check
for and omit overlapping text.
Default value is \code{check.overlap = FALSE}.}

\item{x}{A numeric vector or unit object specifying text x-location.}

\item{y}{A numeric vector, unit object, or a character vector of
values containing a "b" combined with a numeric value
specifying text y-locations.
The character vector will place text y-locations relative to the
bottom of the most recently plotted plot according to the
units of the plotgardener page.}

\item{just}{Justification of text relative to its (x, y) location.
If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = "center"}.}

\item{default.units}{A string indicating the default units to use if
\code{x} or \code{y} are only given as numerics or numeric vectors.
Default value is \code{default.units = "inches"}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{text} object containing relevant
placement and \link[grid]{grob} information.
}
\description{
Plot text within a plotgardener layout
}
\examples{
## Create a page
pageCreate(width = 4, height = 2, default.units = "inches")

## Plot text, adjusting fontsize and fontface
plotText(
    label = "plotgardener", fontsize = 14, fontface = "bold",
    x = 1, y = 1, just = "center", default.units = "inches"
)

## Plot text, adjusting color, rotation, and fontfamily
plotText(
    label = "coordinate-based", fontcolor = "#225EA8", rot = 90,
    fontfamily = "HersheyScript", x = 2, y = 1, just = "center",
    default.units = "inches"
)

## Plot a text label in multiple places at once
plotText(
    label = "R", x = c(0.5, 1, 1.5), y = 1.5, just = "center",
    default.units = "inches"
)

## Plot a vector of text labels
plotText(
    label = c("pg", "plot", "gardener"), x = 3, y = c(0.5, 1, 1.75),
    just = "center", default.units = "inches"
)

## Hide page guides
pageGuideHide()
}
\seealso{
\link[grid]{grid.text}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pagePlotPlace.R
\name{pagePlotPlace}
\alias{pagePlotPlace}
\title{Place a plot that has been previously created but not drawn}
\usage{
pagePlotPlace(
    plot,
    x = NULL,
    y = NULL,
    width = NULL,
    height = NULL,
    just = c("left", "top"),
    default.units = "inches",
    draw = TRUE,
    params = NULL
)
}
\arguments{
\item{plot}{Plot object to be placed, defined by the
output of a plotgardener plotting function.}

\item{x}{A numeric or unit object specifying plot x-location.}

\item{y}{A numeric, unit object, or character containing a "b" combined
with a numeric value specifying plot y-location.
The character value will place the plot y relative to the bottom
of the most recently plotted plot according to the units
of the plotgardener page.}

\item{width}{A numeric or unit object specifying plot width.}

\item{height}{A numeric or unit object specifying plot height.}

\item{just}{Justification of plot relative to its (x, y) location.
If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use
if \code{x}, \code{y}, \code{width}, or \code{height} are only
given as numerics. Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics output
should be produced. Default value is \code{draw = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}
}
\value{
Function will update dimensions of an input plot and
return an updated plot object.
}
\description{
Place a plot that has been previously created but not drawn
}
\examples{
## Load Hi-C data
library(plotgardenerData)
data("IMR90_HiC_10kb")

## Create, but do not plot, square Hi-C plot
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, resolution = 10000,
    zrange = c(0, 70),
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    draw = FALSE
)

## Create page
pageCreate(width = 3.75, height = 3.5, default.units = "inches")

## Place Hi-C plot on page
pagePlotPlace(
    plot = hicPlot,
    x = 0.25, y = 0.25, width = 3, height = 3,
    just = c("left", "top"),
    default.units = "inches", draw = TRUE
)

## Annotate heatmap legend
annoHeatmapLegend(
    plot = hicPlot,
    x = 3.4, y = 0.25, width = 0.12, height = 1.2,
    just = c("left", "top"), default.units = "inches"
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/colorby.R
\name{colorby}
\alias{colorby}
\title{Handle plotgardener color scaling parameters}
\usage{
colorby(column, palette = NULL, range = NULL, scalePerRegion = FALSE)
}
\arguments{
\item{column}{String specifying name of data column to scale colors by.}

\item{palette}{(optional) A function describing the color palette to use for
color scaling.}

\item{range}{(optional) A numeric vector specifying the range of values to
apply a color scale to.}

\item{scalePerRegion}{A logical value indicating whether to adjust 
NULL range of numerical `colorby` values to subset of data in a plotted
genomic region. Default value is \code{scalePerRegion = FALSE}.}
}
\value{
Returns a "\code{colorby}" object.
}
\description{
\code{colorby} should be used to create a set of parameters
that specify color scaling for the functions \code{plotPairs},
\code{plotPairsArches}, and \code{plotRanges}.
}
\examples{
## Load paired ranges data in BEDPE format
library(plotgardenerData)
data("IMR90_DNAloops_pairs")

## Add a length column
IMR90_DNAloops_pairs$length <- 
        (IMR90_DNAloops_pairs$start2 - IMR90_DNAloops_pairs$start1) / 1000

## Plot pairs with colorby object set for `length` column
bedpePlot <- plotPairs(
    data = IMR90_DNAloops_pairs,
    chrom = "chr21",
    chromstart = 27900000, chromend = 30700000,
    assembly = "hg19",
    fill = colorby("length", palette = 
                colorRampPalette(c("dodgerblue2", "firebrick2"))),
    lwd = 2, spaceHeight = .7,
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotRect.R
\name{plotRect}
\alias{plotRect}
\title{Plot a rectangle within a plotgardener layout}
\usage{
plotRect(
    x,
    y,
    width,
    height,
    just = "center",
    default.units = "inches",
    linecolor = "black",
    lwd = 1,
    lty = 1,
    fill = NA,
    alpha = 1,
    params = NULL,
    ...
)
}
\arguments{
\item{x}{A numeric vector or unit object specifying rectangle x-locations.}

\item{y}{A numeric vector, unit object, or a character vector of values
containing a "b" combined with a numeric value specifying
rectangle y-locations.
The character vector will place rectangle y-locations relative to
the bottom of the most recently plotted plot according to
the units of the plotgardener page.}

\item{width}{A numeric vector or unit object specifying rectangle widths.}

\item{height}{A numeric vector or unit object specifying rectangle heights.}

\item{just}{Justification of rectangle relative to its (x, y) location.
If there are two values, the first value specifies horizontal justification
and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = "center"}.}

\item{default.units}{A string indicating the default units to use if
\code{x}, \code{y}, \code{width}, and \code{height} are only given as
numerics or numeric vectors.
Default value is \code{default.units = "inches"}.}

\item{linecolor}{A character value specifying rectangle line color.
Default value is \code{linecolor = "black"}.}

\item{lwd}{A numeric specifying rectangle line width.
Default value is \code{lwd = 1}.}

\item{lty}{A numeric specifying rectangle line type.
Default value is \code{lty = 1}.}

\item{fill}{A character value specifying rectangle fill color.
Default value is \code{fill = NA}.}

\item{alpha}{Numeric value specifying color transparency.
Default value is \code{alpha = 1}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{rect} object containing
relevant placement and \link[grid]{grob} information.
}
\description{
Plot a rectangle within a plotgardener layout
}
\examples{
## Create a page
pageCreate(width = 7.5, height = 6, default.units = "inches")

## Plot one rectangle with no fill
plotRect(
    x = 0.5, y = 0.5, width = 3, height = 3,
    just = c("left", "top"), default.units = "inches",
    lwd = 2, fill = NA
)


## Plot two rectangles with same width and height at different locations
plotRect(
    x = 4, y = c(0.5, 2.25), width = 3, height = 1.25,
    just = c("left", "top"), default.units = "inches",
    fill = "#7ecdbb"
)

## Plot two rectangles with different widths, heights,
## locations, and colors
plotRect(
    x = 3.75, y = c(4, 5.25), width = c(6.5, 4.5),
    height = c(1, 0.25),
    just = "top", default.units = "inches",
    fill = c("#7ecdbb", "#37a7db"), linecolor = NA, alpha = 0.4
)

## Hide page guides
pageGuideHide()
}
\seealso{
\link[grid]{grid.rect}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mapColors.R
\name{mapColors}
\alias{mapColors}
\title{Maps a numeric or character vector to a color palette and returns
the vector of colors}
\usage{
mapColors(vector, palette, range = NULL)
}
\arguments{
\item{vector}{Vector to map to color.}

\item{palette}{Color palette function.}

\item{range}{Range of values to map for a numerical value.}
}
\value{
Returns a character vector of color values. If the input vector is 
numerical, this vector will have additional `palette` and `range`
attributes.
}
\description{
Maps a numeric or character vector to a color palette and returns
the vector of colors
}
\details{
This function allows for the manual mapping of a numerical or factor
vector to a palette of colors. For a more automatic implementation 
of this functionality in plotgardener functions,  
\link[plotgardener]{colorby} objects can be used.
}
\examples{
## Load paired ranges data in BEDPE format
library(plotgardenerData)
data("IMR90_DNAloops_pairs")

## Add a length column
IMR90_DNAloops_pairs$length <- (IMR90_DNAloops_pairs$start2 - 
        IMR90_DNAloops_pairs$start1) / 1000

## Map length column to a vector of colors
colors <- mapColors(vector = IMR90_DNAloops_pairs$length,
            palette = colorRampPalette(c("dodgerblue2", "firebrick2")))
            
## Pass color vector into bbPlotPairsArches
heights <- IMR90_DNAloops_pairs$length / max(IMR90_DNAloops_pairs$length)    
pageCreate(width = 7.5, height = 2.1, default.units = "inches",
            showGuides = FALSE, xgrid = 0, ygrid = 0)       
params <- pgParams(
    chrom = "chr21",
    chromstart = 27900000, chromend = 30700000,
    assembly = "hg19",
    width = 7
)

archPlot <- plotPairsArches(
    data = IMR90_DNAloops_pairs, params = params,
    fill = colors,
    linecolor = "fill",
    archHeight = heights, alpha = 1,
    x = 0.25, y = 0.25, height = 1.5,
    just = c("left", "top"),
    default.units = "inches"
)            

annoGenomeLabel(plot = archPlot, x = 0.25, y = 1.78, scale = "Mb") 
annoHeatmapLegend(
    plot = archPlot, fontcolor = "black",
    x = 7.0, y = 0.25,
    width = 0.10, height = 1, fontsize = 10
)
plotText(
    label = "Kb", rot = 90, x = 6.9, y = 0.75,
    just = c("center", "center"),
    fontsize = 10
)

}
\seealso{
\link[plotgardener]{colorby}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pageGuideHide.R
\name{pageGuideHide}
\alias{pageGuideHide}
\title{Remove guides from a plotgardener page}
\usage{
pageGuideHide()
}
\value{
None.
}
\description{
Remove guides from a plotgardener page
}
\note{
Please note that due to the implementation of `grid` removal functions,
using `pageGuideHide` within a `pdf` call will result in the rendering of a 
separate, new page with the plot guides removed. To avoid this artifact,
hide guides in the `pageCreate` function call with `showGuides = FALSE`.
}
\examples{
## Make a page
pageCreate(width = 7, height = 4, default.units = "inches")

## Hide page guides
pageGuideHide()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotPairsArches.R
\name{plotPairsArches}
\alias{plotPairsArches}
\title{Plot paired-end genomic range data in an arch style}
\usage{
plotPairsArches(
    data,
    chrom,
    chromstart = NULL,
    chromend = NULL,
    assembly = "hg38",
    style = "2D",
    flip = FALSE,
    curvature = 5,
    archHeight = NULL,
    fill = "#1f4297",
    linecolor = NA,
    alpha = 0.4,
    bg = NA,
    clip = FALSE,
    clip.noAnchor = TRUE,
    range = NULL,
    baseline = FALSE,
    baseline.color = "grey",
    baseline.lwd = 1,
    x = NULL,
    y = NULL,
    width = NULL,
    height = NULL,
    just = c("left", "top"),
    default.units = "inches",
    draw = TRUE,
    params = NULL,
    ...
)
}
\arguments{
\item{data}{A string specifying the BEDPE file path, a dataframe
in BEDPE format specifying data to be plotted, or a
\link[InteractionSet]{GInteractions} object.}

\item{chrom}{Chromosome of region to be plotted, as a string.}

\item{chromstart}{Integer start position on chromosome to be plotted.}

\item{chromend}{Integer end position on chromosome to be plotted.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{style}{Character value describing the style of arches.
Default value is \code{style = "2D"}. Options are:
\itemize{
\item{\code{"2D"}: }{Arches will be drawn in a 2-dimensional style.}
\item{\code{"3D"}: }{Arches will be drawn in a 3-dimensional style.}
}}

\item{flip}{Logical value indicating whether to reflect arches over
the x-axis. Default value is \code{flip = FALSE}.}

\item{curvature}{Numeric indicating the number of points along the
arch curvature. Default value is \code{curvature = 5}.}

\item{archHeight}{Single numeric value, numeric vector, or column name 
in data specifying the arch heights. When NULL, all arches will be the 
same height, filling up the given plot area.}

\item{fill}{A single character value, a vector, or a 
\link[plotgardener]{colorby} object specifying fill colors of arches.
Default value is \code{fill = #1f4297"}.}

\item{linecolor}{A single character value, a vector, or a
\link[plotgardener]{colorby} object specifying the color of the lines
outlining arches. Default value is \code{linecolor = NA}.
Special options include:
\itemize{
\item{\code{NA}: }{No line color.}
\item{\code{"fill"}: }{Same color as \code{fill}.}
}}

\item{alpha}{Numeric value specifying transparency.
Default value is \code{alpha = 0.4}.}

\item{bg}{Character value indicating background color.
Default value is \code{bg = NA}.}

\item{clip}{A logical value indicating whether to clip any
arches that get cutoff in the given genomic region.
Default value is \code{clip = FALSE}.}

\item{clip.noAnchor}{A logical value indicating whether to clip
any arches that overlap the given genomic region but do not 
have an anchor in that region. Default value is \code{clip.noAnchor = TRUE}.}

\item{range}{A numeric vector of length 2 specifying the y-range
of \code{archHeight} to plot (c(min, max)).}

\item{baseline}{Logical value indicating whether to include
a baseline along the x-axis. Default value is \code{baseline = FALSE}.}

\item{baseline.color}{Baseline color.
Default value is \code{baseline.color = "grey"}.}

\item{baseline.lwd}{Baseline line width.
Default value is \code{baseline.lwd = 1}.}

\item{x}{A numeric or unit object specifying pair arches plot x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying BEDPE arches plot y-location.
The character value will
place the pair arches plot y relative to the bottom of the most
recently plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying pair arches plot width.}

\item{height}{A numeric or unit object specifying pair arches plot height.}

\item{just}{Justification of pair arches plot relative to its (x, y)
location. If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use if
\code{x}, \code{y}, \code{width}, or \code{height} are only given as
numerics. Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics output should be
produced. Default value is \code{draw = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{arches} object containing relevant
genomic region, placement, and \link[grid]{grob} information.
}
\description{
Plot paired-end genomic range data in an arch style
}
\details{
A pair arches plot can be placed on a plotgardener coordinate page
by providing plot placement parameters:
\preformatted{
plotPairsArches(data chrom,
                chromstart = NULL, chromend = NULL,
                x, y, width, height, just = c("left", "top"),
                default.units = "inches")
}
This function can also be used to quickly plot an unannotated pair
arches plot by ignoring plot placement parameters:
\preformatted{
plotPairsArches(data, chrom,
                chromstart = NULL, chromend = NULL)
}
}
\examples{
## Load paired ranges data in BEDPE format
library(plotgardenerData)
data("IMR90_DNAloops_pairs")

## Set the coordinates
params <- pgParams(
    chrom = "chr21",
    chromstart = 27900000, chromend = 30700000,
    assembly = "hg19",
    width = 7
)

## Create a page
pageCreate(width = 7.5, height = 2.1, default.units = "inches")

## Add a length column to color by
IMR90_DNAloops_pairs$length <- 
        (IMR90_DNAloops_pairs$start2 - IMR90_DNAloops_pairs$start1) / 1000

## Translate lengths into heights
IMR90_DNAloops_pairs$h <- 
        IMR90_DNAloops_pairs$length / max(IMR90_DNAloops_pairs$length)

## Plot the data
archPlot <- plotPairsArches(
    data = IMR90_DNAloops_pairs, params = params,
    fill = colorby("length", palette = 
                colorRampPalette(c("dodgerblue2", "firebrick2"))),
    linecolor = "fill",
    archHeight = "h", alpha = 1,
    x = 0.25, y = 0.25, height = 1.5,
    just = c("left", "top"),
    default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(plot = archPlot, x = 0.25, y = 1.78, scale = "Mb")


## Annotate heatmap legend
annoHeatmapLegend(
    plot = archPlot, fontcolor = "black",
    x = 7.0, y = 0.25,
    width = 0.10, height = 1, fontsize = 10
)

## Add the heatmap legend title
plotText(
    label = "Kb", rot = 90, x = 6.9, y = 0.75,
    just = c("center", "center"),
    fontsize = 10
)


## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genomes.R
\name{genomes}
\alias{genomes}
\title{Display the included available default genome assemblies}
\usage{
genomes()
}
\value{
Returns the included available default genome assemblies
}
\description{
Display the included available default genome assemblies
}
\examples{
genomes()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCool.R
\name{.coolAutoResolution}
\alias{.coolAutoResolution}
\title{Determine best resolution for size of region for .(m)cool files}
\usage{
.coolAutoResolution(file, chromstart, chromend)
}
\arguments{
\item{file}{Path to .(m)cool file}

\item{chromstart}{Chromstart of region}

\item{chromend}{Chromend of region}
}
\description{
Determine best resolution for size of region for .(m)cool files
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotRanges.R
\name{plotRanges}
\alias{plotRanges}
\title{Plot genomic range elements in a pileup or collapsed format}
\usage{
plotRanges(
    data,
    chrom,
    chromstart = NULL,
    chromend = NULL,
    assembly = "hg38",
    fill = "#7ecdbb",
    linecolor = NA,
    order = "width",
    collapse = FALSE,
    boxHeight = unit(2, "mm"),
    spaceWidth = 0.02,
    spaceHeight = 0.3,
    limitLabel = TRUE,
    strandSplit = FALSE,
    bg = NA,
    baseline = FALSE,
    baseline.color = "grey",
    baseline.lwd = 1,
    x = NULL,
    y = NULL,
    width = NULL,
    height = NULL,
    just = c("left", "top"),
    default.units = "inches",
    draw = TRUE,
    params = NULL,
    ...
)
}
\arguments{
\item{data}{Data to be plotted; as a character value specifying
a BED file path, a data frame in BED format, a character value
specifying a .bam file path where a bam index file (.bam.bai)
is in the same directory, or a \link[GenomicRanges]{GRanges} object.}

\item{chrom}{Chromosome of region to be plotted, as a string.}

\item{chromstart}{Integer start position on chromosome to be plotted.}

\item{chromend}{Integer end position on chromosome to be plotted.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{fill}{A single character value, a vector, or a 
\link[plotgardener]{colorby} object specifying fill colors of range elements.
Default value is \code{fill = "#7ecdbb"}.}

\item{linecolor}{A single character value, a vector, or a
\link[plotgardener]{colorby} object specifying the color of the lines
outlining range elements. Default value is \code{linecolor = NA}.
Special options include:
\itemize{
\item{\code{NA}: }{No line color.}
\item{\code{"fill"}: }{Same color as \code{fill}.}
} .}

\item{order}{A character value specifying how to order pileup data
before assigning rows. Default value is \code{order = "width"}. Options 
include:
\itemize{
\item{\code{"width"}: }{Ordered by decreasing width of elements.}
\item{\code{"random"}: }{Ordered randomly in each function call.}
} .}

\item{collapse}{A logical value indicating whether to collapse
range elements into a single row, or into
two rows if \code{strandSplit = TRUE}.
If \code{collapse = TRUE}, \code{boxHeight} will be ignored and elements
will be the height of the entire plot if \code{strandSplit = FALSE} or
be the height of half of the entire plot if \code{strandSplit = TRUE}.
Default value is \code{collapse = FALSE}.}

\item{boxHeight}{A numeric or unit object specifying height of range element
boxes. Default value is \code{boxHeight = unit(2, "mm")}.}

\item{spaceWidth}{A numeric value specifying the width of minimum spacing
between range element boxes, as a fraction of the plot's genomic range.
Default value is \code{spaceWidth = 0.02}.}

\item{spaceHeight}{A numeric value specifying the height of spacing between
range element boxes on different rows, as a fraction of boxHeight.
Default value is \code{spaceHeight = 0.3}.}

\item{limitLabel}{A logical value indicating whether to draw a "+"
when not all elements can be plotted in the plotting space. Default 
value is \code{limitLabel = TRUE}.}

\item{strandSplit}{A logical value indicating whether plus and
minus-stranded elements should be separated. Elements can only be
split by strand if a \code{strand} column is found in \code{data}.
Default value is \code{strandSplit = FALSE}.}

\item{bg}{Character value indicating background color.
Default value is \code{bg = NA}.}

\item{baseline}{Logical value indicating whether to include a
baseline along the x-axis. Default value is \code{baseline = FALSE}.}

\item{baseline.color}{Baseline color.
Default value is \code{baseline.color = "grey"}.}

\item{baseline.lwd}{Baseline line width.
Default value is \code{baseline.lwd = 1}.}

\item{x}{A numeric or unit object specifying ranges plot x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying ranges plot y-location.
The character value will
place the ranges plot y relative to the bottom of the most recently
plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying ranges plot width.}

\item{height}{A numeric or unit object specifying ranges plot height.}

\item{just}{Justification of ranges plot relative to its (x, y) location.
If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use
if \code{x}, \code{y}, \code{width}, or \code{height} are only given
as numerics. Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics output should
be produced. Default value \code{draw = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{ranges} object containing relevant
genomic region, coloring data, placement, and \link[grid]{grob} information.
}
\description{
Plot genomic range elements in a pileup or collapsed format
}
\details{
A ranges plot can be placed on a plotgardener coordinate page by providing
plot placement parameters:
\preformatted{
plotRanges(data, chrom,
            chromstart = NULL, chromend = NULL,
            x, y, width, height, just = c("left", "top"),
            default.units = "inches")
}
This function can also be used to quickly plot an unannotated BED plot
by ignoring plot placement parameters:
\preformatted{
plotRanges(data, chrom,
            chromstart = NULL, chromend = NULL)
}
}
\examples{
## Load ranges data in BED format
library(plotgardenerData)
data("IMR90_ChIP_CTCF_reads")

## Create page
pageCreate(width = 7.5, height = 5, default.units = "inches")

## Plot and place a pileup ranges plot
pileupPlot <- plotRanges(
    data = IMR90_ChIP_CTCF_reads, chrom = "chr21",
    chromstart = 29073000, chromend = 29074000,
    assembly = "hg19",
    order = "random",
    fill = colorby("strand", palette = 
                colorRampPalette(c("#7ecdbb", "#37a7db"))),
    strandSplit = TRUE, 
    x = 0.5, y = 0.25, width = 6.5, height = 4.25,
    just = c("left", "top"), default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(
    plot = pileupPlot, x = 0.5, y = 4.5,
    just = c("left", "top")
)

## Add text labels
plotText(
    label = "+ strand", fontcolor = "#37a7db", fontsize = 12,
    x = 0.5, y = 1.25, just = "left"
)
plotText(
    label = "- strand", fontcolor = "#7ecdbb", fontsize = 12,
    x = 0.5, y = 3.5, just = "left"
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotCircle.R
\name{plotCircle}
\alias{plotCircle}
\title{Plot a circle within a plotgardener layout}
\usage{
plotCircle(
    x,
    y,
    r,
    default.units = "inches",
    linecolor = "black",
    lwd = 1,
    lty = 1,
    fill = NA,
    alpha = 1,
    params = NULL,
    ...
)
}
\arguments{
\item{x}{A numeric vector or unit object specifying circle
x-locations relative to center.}

\item{y}{A numeric vector, unit object, or a character vector
of values containing a "b" combined with a numeric value
specifying circle y-locations relative to center.
The character vector will place circle y-locations relative to
the bottom of the most recently plotted plot according
to the units of the plotgardener page.}

\item{r}{A numeric vector or unit object specifying radii.}

\item{default.units}{A string indicating the default units to use
if \code{r}, \code{x}, or \code{y} are only given as numerics or
numeric vectors. Default value is \code{default.units = "inches"}.}

\item{linecolor}{A character value specifying circle line color.
Default value is \code{linecolor = "black"}.}

\item{lwd}{A numeric specifying circle line width.
Default value is \code{lwd = 1}.}

\item{lty}{A numeric specifying circle line type.
Default value is \code{lty = 1}.}

\item{fill}{A character value specifying circle fill color.
Default value is \code{fill = NA}.}

\item{alpha}{Numeric value specifying color transparency.
Default value is \code{alpha = 1}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{circle} object containing
relevant placement and \link[grid]{grob} information.
}
\description{
Plot a circle within a plotgardener layout
}
\examples{
## Create a page
pageCreate(width = 2, height = 2, default.units = "inches")

## Plot two circles, one at a time
plotCircle(
    x = 0.6, y = 0.5, r = 0.1, fill = "black",
    default.units = "inches"
)
plotCircle(
    x = 1.4, y = 0.5, r = 0.1, fill = "black",
    default.units = "inches"
)

## Plot a vector of circles
xVals <- 1 + (0.5 * cos(seq(0, pi, pi / 8)))
yVals <- 1 + (0.5 * sin(seq(0, pi, pi / 8)))
plotCircle(x = xVals, y = yVals, r = 0.05, default.units = "inches")

## Hide page guides
pageGuideHide()
}
\seealso{
\link[grid]{grid.circle}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotLegend.R
\name{plotLegend}
\alias{plotLegend}
\title{Plot a legend}
\usage{
plotLegend(
    legend,
    fill = NULL,
    pch = NULL,
    lty = NULL,
    orientation = "v",
    title = NULL,
    fontsize = 10,
    border = TRUE,
    bg = NA,
    x = NULL,
    y = NULL,
    width = NULL,
    height = NULL,
    just = c("left", "top"),
    default.units = "inches",
    draw = TRUE,
    params = NULL,
    ...
)
}
\arguments{
\item{legend}{A character or expression vector to appear in the legend.}

\item{fill}{If specified, this argument will produce boxes filled with
the specified colors to appear beside the legend text.}

\item{pch}{The plotting symbols appearing in the legend, as a
numeric vector.}

\item{lty}{The line types for lines appearing in the legend.}

\item{orientation}{A string specifying legend orientation.
Default value is \code{orientation = "v"}. Options are:
\itemize{
\item{\code{"v"}: }{Vertical legend orientation.}
\item{\code{"h"}: }{Horizontal legend orientation.}
}}

\item{title}{A character value giving a title to be placed at
the top of the legend.}

\item{fontsize}{A numeric specifying text fontsize in points.
Default value is \code{fontsize = 10}.}

\item{border}{Logical value indicating whether to add a border
around heatmap legend. Default value is \code{border = TRUE}.}

\item{bg}{Character value indicating background color.
Default value is \code{bg = NA}.}

\item{x}{A numeric or unit object specifying legend x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying legend y-location.
The character value will
place the legend y relative to the bottom of the most recently
plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying legend width.}

\item{height}{A numeric or unit object specifying legend height.}

\item{just}{Justification of legend relative to its (x, y) location.
If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use
if \code{x}, \code{y}, \code{width}, or \code{height} are only given
as numerics. Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics output should
be produced. Default value is \code{draw = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{legend} object containing relevant
placement and \link[grid]{grob} information.
}
\description{
Plot a legend
}
\examples{
## Load BED data
library(plotgardenerData)
data("IMR90_ChIP_CTCF_reads")

## Create page
pageCreate(width = 7.5, height = 4, default.units = "inches")

## Plot a pileup plot, coloring elements by strand
pileupPlot <- plotRanges(
    data = IMR90_ChIP_CTCF_reads, chrom = "chr21",
    chromstart = 29072500, chromend = 29075000,
    assembly = "hg19",
    fill = colorby("strand", palette = 
                colorRampPalette(c("steel blue", "light salmon"))),
    x = 0.5, y = 3.5, width = 6.5, height = 3.5,
    just = c("left", "bottom"),
    default.units = "inches"
)

## Add a legend depicting strand colors
legendPlot <- plotLegend(
    legend = c("- strand", "+ strand"),
    fill = c("steel blue", "light salmon"),
    border = FALSE,
    x = 5, y = 0.5, width = 1.5, height = 0.7,
    just = c("left", "top"),
    default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(
    plot = pileupPlot, x = 0.5, y = 3.5,
    just = c("left", "top")
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoYaxis.R
\name{annoYaxis}
\alias{annoYaxis}
\title{Add a y-axis to a plot}
\usage{
annoYaxis(
    plot,
    at = NULL,
    label = TRUE,
    main = TRUE,
    scipen = 999,
    axisLine = FALSE,
    params = NULL,
    ...
)
}
\arguments{
\item{plot}{Plot object to annotate with y-axis.}

\item{at}{A numeric vector of y-value locations for tick marks.}

\item{label}{A logical value indicating whether to draw the labels
on the tick marks, or an expression or character vector which specify
the labels to use.
If not logical, must be the same length as the \code{at} argument.}

\item{main}{A logical value indicating whether to draw the y-axis at
the left of the plot. Default value is \code{main = TRUE}. Options are:
\itemize{
\item{\code{TRUE}: }{y-axis is drawn at the left of the plot.}
\item{\code{FALSE}: }{y-axis is drawn at the right of the plot.}
}}

\item{scipen}{An integer indicating the penalty to be applied when
deciding to print numeric values in fixed or exponential notation.
Default value is \code{scipen = 999}.}

\item{axisLine}{A logical value indicating whether to show the axis line.
Default value is \code{axisLine = FALSE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{yaxis} object containing
relevant \link[grid]{grob} information.
}
\description{
Add a y-axis to a plot
}
\examples{
## Load Hi-C data
library(plotgardenerData)
data("IMR90_HiC_10kb")

## Create page
pageCreate(width = 4, height = 3.5, default.units = "inches")

## Plot and place a square Hi-C plot
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, resolution = 10000,
    zrange = c(0, 70),
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 1, y = 0.5, width = 2.5, height = 2.5,
    just = c("left", "top"),
    default.units = "inches"
)

## Add standard y-axis to Hi-C plot
annoYaxis(
    plot = hicPlot, at = c(28000000, 29000000, 30300000),
    fontsize = 10
)

## Annotate genome label on x-axis
annoGenomeLabel(plot = hicPlot, x = 1, y = 3.03)

## Annotate heatmap legend
annoHeatmapLegend(
    plot = hicPlot,
    x = 3.6, y = 0.5, width = 0.12, height = 1.2
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCool.R
\name{.coolRegion}
\alias{.coolRegion}
\title{Add (alt)chromstart and (alt)chromend for NULL (alt)chrom region of 
.(m)cool files}
\usage{
.coolRegion(file, chrom, resolution)
}
\arguments{
\item{file}{Path to .(m)cool file}

\item{chrom}{Chromosome of region; can also be altchromosome}

\item{resolution}{Resolution to read chromsome info from}
}
\description{
Add (alt)chromstart and (alt)chromend for NULL (alt)chrom region of 
.(m)cool files
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readHic.R
\name{readHic}
\alias{readHic}
\title{Read a .hic file and return Hi-C data as a dataframe}
\usage{
readHic(
    file,
    chrom,
    chromstart = NULL,
    chromend = NULL,
    altchrom = NULL,
    altchromstart = NULL,
    altchromend = NULL,
    assembly = "hg38",
    resolution = "auto",
    res_scale = "BP",
    zrange = NULL,
    norm = "KR",
    matrix = "observed",
    params = NULL,
    quiet = FALSE
)
}
\arguments{
\item{file}{A character value specifying the path to the .hic file.}

\item{chrom}{Chromosome of data, as a string.}

\item{chromstart}{Integer start position on chromosome.}

\item{chromend}{Integer end position on chromosome.}

\item{altchrom}{Alternate chromosome for interchromosomal data,
as a string.}

\item{altchromstart}{Alternate chromosome integer start position
for interchromosomal data.}

\item{altchromend}{Alternate chromosome integer end position
for interchromosomal data.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{resolution}{A numeric specifying the width of each pixel.
"auto" will attempt to choose a resolution in basepairs based on
the size of the region.}

\item{res_scale}{A character value specifying the resolution scale.
Default value is \code{res_scale = "BP"}. Options are:
\itemize{
\item{\code{"BP"}: }{Base pairs.}
\item{\code{"FRAG"}: }{Fragments.}
}}

\item{zrange}{A numeric vector of length 2 specifying the range of
interaction scores, where extreme values will be set to the max or min.}

\item{norm}{Character value specifying hic data normalization method.
This value must be found in the .hic file.
Default value is \code{norm = "KR"}.}

\item{matrix}{Character value indicating the type of matrix to output.
Default value is \code{matrix = "observed"}. Options are:
\itemize{
\item{\code{"observed"}: }{Observed counts.}
\item{\code{"oe"}: }{Observed/expected counts.}
\item{\code{"log2oe"}: }{Log2 transformed observed/expected counts.}
}}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{quiet}{A logical indicating whether or not to print messages.}
}
\value{
Returns a 3-column dataframe in sparse upper triangular
format with the following columns: \code{chrom}, \code{altchrom},
\code{counts}.
}
\description{
Read a .hic file and return Hi-C data as a dataframe
}
\examples{
hicFile <- system.file("extdata/test_chr22.hic", package="plotgardenerData")

## Read in data for all chr22 file at 2.5Mb bp resolution
hicData <- readHic(file = hicFile, chrom = "22",
                    assembly = "hg19",
                    resolution = 2500000) 
                        
## Read in region `chr22:20000000-47500000` at 100 Kb resolution
hicData10Kb <- readHic(file = hicFile, chrom = "22",
                        chromstart = 20000000, chromend = 47500000,
                        assembly = "hg19",
                        resolution = 100000)                     

}
\seealso{
\link[strawr]{straw}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotGG.R
\name{plotGG}
\alias{plotGG}
\title{Plot a ggplot2 plot, gtable, or grob object in a plotgardener layout}
\usage{
plotGG(
    plot,
    x,
    y,
    width,
    height,
    just = c("left", "top"),
    default.units = "inches",
    params = NULL
)
}
\arguments{
\item{plot}{ggplot, gtable, or grob object.}

\item{x}{A numeric or unit object specifying ggplot x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying ggplot y-location.
The character value will
place the ggplot y relative to the bottom of the most recently
plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying ggplot width.}

\item{height}{A numeric or unit object specifying ggplot height.}

\item{just}{Justification of ggplot relative to its (x, y) location.
If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use
if \code{x}, \code{y}, \code{width}, or \code{height} are only given
as numerics. Default value is \code{default.units = "inches"}.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}
}
\value{
Returns a \code{pg_gg} object containing
relevant placement and \link[grid]{grob} information.
}
\description{
Plot a ggplot2 plot, gtable, or grob object in a plotgardener layout
}
\examples{
## Create a plot using ggplot2
library(ggplot2)
p <- ggplot(mtcars) +
    geom_point(aes(mpg, disp))

## Create a page
pageCreate(width = 4, height = 4, default.units = "inches")

## Place ggplot in page
plotGG(
    plot = p, x = 0.5, y = 0.5, width = 3, height = 3,
    just = c("left", "top"), default.units = "inches"
)

## Add title
plotText(
    label = "mtcars", fontsize = 14, fontface = "bold",
    x = 1, y = 0.35
)

## Hide page guides
pageGuideHide()
}
\seealso{
\link[ggplot2]{ggplot}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotHicTriangle.R
\name{plotHicTriangle}
\alias{plotHicTriangle}
\title{Plot a Hi-C interaction matrix in a triangular format}
\usage{
plotHicTriangle(
    data,
    resolution = "auto",
    zrange = NULL,
    norm = "KR",
    matrix = "observed",
    chrom,
    chromstart = NULL,
    chromend = NULL,
    assembly = "hg38",
    palette = colorRampPalette(brewer.pal(n = 9, "YlGnBu")),
    colorTrans = "linear",
    flip = FALSE,
    bg = NA,
    x = NULL,
    y = NULL,
    width = NULL,
    height = NULL,
    just = c("left", "top"),
    default.units = "inches",
    draw = TRUE,
    params = NULL,
    quiet = FALSE
)
}
\arguments{
\item{data}{Path to .hic or .(m)cool file as a string or a 3-column
dataframe of interaction counts in sparse upper triangular format.}

\item{resolution}{A numeric specifying the width in basepairs of
each pixel. For files, "auto" will attempt to choose a
resolution based on the size of the region. For
dataframes, "auto" will attempt to detect the resolution
the dataframe contains.}

\item{zrange}{A numeric vector of length 2 specifying the
range of interaction scores to plot, where extreme values
will be set to the max or min.}

\item{norm}{Character value specifying hic data normalization method,
if giving .hic or .(m)cool file. This value must be found in the .hic or
.(m)cool file. Default value is \code{norm = "KR"}.}

\item{matrix}{Character value indicating the type of matrix to output for
.hic files.
Default value is \code{matrix = "observed"}. Options are:
\itemize{
\item{\code{"observed"}: }{Observed counts.}
\item{\code{"oe"}: }{Observed/expected counts.}
\item{\code{"log2oe"}: }{Log2 transformed observed/expected counts.}
}}

\item{chrom}{Chromosome of region to be plotted, as a string.}

\item{chromstart}{Integer start position on chromosome to be plotted.}

\item{chromend}{Integer end position on chromosome to be plotted.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{palette}{A function describing the color palette to use for
representing scale of interaction scores. Default value is
\code{palette =  colorRampPalette(brewer.pal(n = 9, "YlGnBu"))}.}

\item{colorTrans}{A string specifying how to scale Hi-C colors.
Options are "linear", "log", "log2", or "log10".
Default value is \code{colorTrans = "linear"}.}

\item{flip}{A logical indicating whether to flip the orientation of
the Hi-C matrix over the x-axis. Default value is \code{flip = FALSE}.}

\item{bg}{Character value indicating background color.
Default value is \code{bg = NA}.}

\item{x}{A numeric or unit object specifying triangle Hi-C plot x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying triangle Hi-C plot y-location.
The character value will
place the triangle Hi-C plot y relative to the bottom of the most
recently plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying the bottom
width of the Hi-C plot triangle.}

\item{height}{A numeric or unit object specifying the height of
the Hi-C plot triangle.}

\item{just}{Justification of triangle Hi-C plot relative to
its (x, y) location. If there are two values, the first value specifies
horizontal justification and the second value specifies vertical
justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use if
\code{x}, \code{y}, \code{width}, or \code{height} are only given as
numerics. Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics output should
be produced. Default value is \code{draw = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}

\item{quiet}{A logical indicating whether or not to print messages.}
}
\value{
Returns a \code{hicTriangle} object containing relevant
genomic region, Hi-C data, placement, and \link[grid]{grob} information.
}
\description{
Plot a Hi-C interaction matrix in a triangular format
}
\details{
In this orientation, the x-axis represents the genomic coordinates and
the y-axis corresponds to distance in Hi-C bins.

A triangle Hi-C plot can be placed on a plotgardener coordinate page
by providing plot placement parameters:
\preformatted{
plotHicTriangle(data, chrom,
                chromstart = NULL, chromend = NULL,
                x, y, width, height, just = c("left", "top"),
                default.units = "inches")
}
This function can also be used to quickly plot an unannotated triangle
Hi-C plot by ignoring plot placement parameters:
\preformatted{
plotHicTriangle(data, chrom,
                chromstart = NULL, chromend = NULL)
}

If \code{height} is \eqn{<} \eqn{0.5 * width}, the top of the triangle
will be cropped to the given \code{height}.
}
\examples{
## Load Hi-C data
library(plotgardenerData)
data("IMR90_HiC_10kb")

## Create a page
pageCreate(width = 4, height = 2.5, default.units = "inches")

## Plot and place triangle Hi-C plot
hicPlot <- plotHicTriangle(
    data = IMR90_HiC_10kb, resolution = 10000,
    zrange = c(0, 70),
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 2, y = 0.5, width = 3, height = 1.5,
    just = "top", default.units = "inches"
)

## Annotate x-axis genome label
annoGenomeLabel(
    plot = hicPlot, scale = "Mb", x = 0.5, y = 2.03,
    just = c("left", "top")
)

## Annotate heatmap legend
annoHeatmapLegend(
    plot = hicPlot, x = 3.5, y = 0.5,
    width = 0.13, height = 1.2,
    just = c("right", "top")
)

## Hide page guides
pageGuideHide()
}
\seealso{
\link[plotgardener]{readHic}, \link[plotgardener]{readCool}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pagePlotRemove.R
\name{pagePlotRemove}
\alias{pagePlotRemove}
\title{Remove plotgardener plots and annotations}
\usage{
pagePlotRemove(plot)
}
\arguments{
\item{plot}{Plot object to be removed, defined by the output
of a plotgardener plotting function.}
}
\value{
None.
}
\description{
Remove plotgardener plots and annotations
}
\examples{
## Load Hi-C data
library(plotgardenerData)
data("IMR90_HiC_10kb")

## Create page
pageCreate(width = 5.5, height = 4, default.units = "inches")

## Plot and place a square Hi-C plot
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, resolution = 10000,
    zrange = c(0, 70),
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    x = 0.5, y = 0.5, width = 2.5, height = 2.5,
    just = c("left", "top"),
    default.units = "inches"
)

## Remove square Hi-C plot from page
pagePlotRemove(plot = hicPlot)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoDomains.R
\name{annoDomains}
\alias{annoDomains}
\title{Annotate domains in a Hi-C plot}
\usage{
annoDomains(
    plot,
    data,
    half = "inherit",
    linecolor = "black",
    params = NULL,
    ...
)
}
\arguments{
\item{plot}{Hi-C plot object from \code{plotHicSquare} or
\code{plotHicTriangle} on which to annotate pixels.}

\item{data}{A string specifying the BED file path, a dataframe in BED
format, or a \link[GenomicRanges]{GRanges} object specifying
domain ranges.}

\item{half}{Character value specifying which half of hic plots
to annotate. Triangle Hi-C plots will always default to the entirety of
the triangular plot. Default value is \code{half = "inherit"}. Options are:
\itemize{
\item{\code{"inherit"}: }{Domains will be annotated on the \code{half}
inherited by the input Hi-C plot.}
\item{\code{"both"}: }{Domains will be annotated on both halves of the
diagonal of a square Hi-C plot.}
\item{\code{"top"}: }{Domains will be annotated on the upper diagonal
half of a square Hi-C plot.}
\item{\code{"bottom"}: }{Domains will be annotated ont the bottom diagonal
half of a square Hi-C plot.}
}}

\item{linecolor}{A character value specifying the color of the domain
annotations. Default value is \code{linecolor = "black"}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{domain} object containing relevant
genomic region, placement, and \link[grid]{grob} information.
}
\description{
Annotate domains in a Hi-C plot
}
\examples{
## Define a GRanges object with TAD ranges
library(GenomicRanges)
library(IRanges)
domains <- GRanges("chr21",
    ranges = IRanges(
        start = c(28210000, 29085000, 29430000, 29700000),
        end = c(29085000, 29430000, 29700000, 30125000)
    )
)

## Load Hi-C data
library(plotgardenerData)
data("IMR90_HiC_10kb")

## Create page
pageCreate(width = 4.5, height = 4, default.units = "inches")

## Plot and place a square Hi-C plot
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, resolution = 10000,
    zrange = c(0, 70),
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 0.5, width = 3, height = 3,
    just = c("left", "top"),
    default.units = "inches"
)

## Annotate domains on bottom half 0f Hi-C plot
annoDomains(
    plot = hicPlot, data = domains,
    half = "bottom", linecolor = "red"
)

## Annotate heatmap legend
annoHeatmapLegend(
    plot = hicPlot,
    x = 3.6, y = 0.5, width = 0.12, height = 1.2,
    just = c("left", "top"), default.units = "inches"
)

## Annotate genome label
annoGenomeLabel(
    plot = hicPlot, x = 0.5, y = 3.53, scale = "Mb",
    just = c("left", "top")
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCool.R
\name{.pullBinChunks}
\alias{.pullBinChunks}
\title{Read in data for a bin chunk}
\usage{
.pullBinChunks(
  binChunk,
  file,
  bin_offsets,
  binChunkSize,
  datasetPath,
  end1bin,
  start2bin,
  end2bin
)
}
\arguments{
\item{binChunk}{The binChunk indeces to read}

\item{file}{Path to .(m)cool file}

\item{bin_offsets}{Read in bin1 offsets}

\item{binChunkSize}{Size of bin chunk, for comparison against the end of 
the bin chunk}

\item{datasetPath}{Dataset path, for specifying resolution in .mcool file}

\item{end1bin}{Bin where end1 starts}

\item{start2bin}{Bin for chr2 starts}

\item{end2bin}{Bin for end2 starts}
}
\description{
Read in data for a bin chunk
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCool.R
\name{readCool}
\alias{readCool}
\title{Read a .(m)cool file and return Hi-C data as a dataframe}
\usage{
readCool(
    file,
    chrom,
    chromstart = NULL,
    chromend = NULL,
    altchrom = NULL,
    altchromstart = NULL,
    altchromend = NULL,
    resolution = "auto",
    zrange = NULL,
    norm = "NONE",
    binChunkSize = 5e6,
    params = NULL,
    quiet = FALSE
)
}
\arguments{
\item{file}{A character value specifying the path to the .(m)cool file.}

\item{chrom}{Chromosome of data, as a string.}

\item{chromstart}{Integer start position on chromosome.}

\item{chromend}{Integer end position on chromosome.}

\item{altchrom}{Alternate chromosome for interchromosomal data,
as a string.}

\item{altchromstart}{Alternate chromosome integer start position
for interchromosomal data.}

\item{altchromend}{Alternate chromosome integer end position
for interchromosomal data.}

\item{resolution}{A numeric specifying the width of each pixel.
"auto" will attempt to choose a resolution in basepairs based on
the size of the region.}

\item{zrange}{A numeric vector of length 2 specifying the range of
interaction scores, where extreme values will be set to the max or min.}

\item{norm}{Character value specifying hic data normalization method.
This value must be found in the .(m)cool file.
Default value is \code{norm = "NONE"}.}

\item{binChunkSize}{A numeric specifying the number of bin indices to read 
from a file for a given region at a given resolution. If the total amount of 
data is larger than the \code{binChunkSize}, data will be read in multiple
chunks. Default value is \code{binChunkSize = 5e6}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{quiet}{A logical indicating whether or not to print messages.}
}
\value{
Returns a 3-column dataframe in sparse upper triangular
format with the following columns: \code{chrom}, \code{altchrom},
\code{counts}.
}
\description{
Read a .(m)cool file and return Hi-C data as a dataframe
}
\examples{

## .cool file
coolFile <- file.path(tempdir(), "Rao2014-IMR90-MboI-allreps-filtered.1000kb.cool")
download.file(url = "https://usgs2.osn.mghpcc.org/cooler01/examples/hg19/Rao2014-IMR90-MboI-allreps-filtered.1000kb.cool",
    destfile = coolFile, mode = "wb")

## Read in region `chr2:10000000-22000000` at 1000Kb cool file resolution
coolData <- readCool(file = coolFile, chrom = "chr2", chromstart = 10000000,
                     chromend = 22000000,
                     resolution = 1000000)

## .mcool file
mcoolFile <- file.path(tempdir(), "LEUK_HEK_PJA27_inter_30.mcool")
download.file(url = "https://zenodo.org/records/10906240/files/LEUK_HEK_PJA27_inter_30.mcool?download=1",
    destfile = mcoolFile, mode = "wb")

## Read in region `chr2:1000000-5000000` at 100Kb resolution
mcoolData_100Kb <- readCool(file = mcoolFile, chrom = "2",
                            chromstart = 1000000, chromend = 5000000,
                            resolution = 100000)

## Read in data for chr2 at 2500Kb resolution 
mcoolData_2500Kb <- readCool(file = mcoolFile, chrom = "2",
                             resolution = 2500000)
}
\seealso{
\link[plotgardener]{readHic}
}
\author{
Sarah Parker, Nicole Kramer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pageGuideHorizontal.R
\name{pageGuideHorizontal}
\alias{pageGuideHorizontal}
\title{Draw a horizontal guideline at a specified y-coordinate
on a plotgardener page}
\usage{
pageGuideHorizontal(
    y,
    default.units = "inches",
    linecolor = "grey55",
    params = NULL,
    ...
)
}
\arguments{
\item{y}{A numeric or unit object specifying y-coordinate of guide.}

\item{default.units}{A string indicating the default units to use
if \code{y} is only given as a numeric.
Default value is \code{default.units = "inches"}.}

\item{linecolor}{Character value indicating color of guideline.
Default value is \code{linecolor = "grey55"}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
None.
}
\description{
Draw a horizontal guideline at a specified y-coordinate
on a plotgardener page
}
\examples{
## Create a page
pageCreate(width = 6, height = 5, default.units = "inches")

## Add red horizontal guideline at y = 2.5 inches
pageGuideHorizontal(y = 2.5, linecolor = "red")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pgParams.R
\name{c}
\alias{c}
\title{Combine multiple pgParams objects into a vector}
\usage{
c(..., recursive = FALSE)
}
\arguments{
\item{...}{\link[plotgardener]{pgParams} objects to be concatenated.}

\item{recursive}{logical. If \code{recursive = TRUE}, the function
recursively descends through lists
(and pairlists) combining all their elements into a vector.}
}
\value{
\code{NULL} or an expression or a vector of an appropriate mode.
(With no arguments the value is \code{NULL}.)
}
\description{
Combine multiple pgParams objects into a vector
}
\examples{
## Define parameters
p1 <- pgParams(chrom = "chr1", assembly = "hg19")

## Define another set of parameters
p2 <- pgParams(fontsize = 10, assembly = "hg19")

## Combine parameters into one `pgParams` object
pTotal <- c(p1, p2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSignal.R
\name{plotSignal}
\alias{plotSignal}
\title{Plot any kind of signal track data for a single chromosome}
\usage{
plotSignal(
    data,
    binSize = NA,
    binCap = TRUE,
    negData = FALSE,
    chrom,
    chromstart = NULL,
    chromend = NULL,
    assembly = "hg38",
    linecolor = "#37a7db",
    fill = NA,
    ymax = 1,
    range = NULL,
    scale = FALSE,
    label = NULL,
    bg = NA,
    baseline = TRUE,
    baseline.color = "grey",
    baseline.lwd = 1,
    orientation = "h",
    x = NULL,
    y = NULL,
    width = NULL,
    height = NULL,
    just = c("left", "top"),
    default.units = "inches",
    draw = TRUE,
    params = NULL,
    ...
)
}
\arguments{
\item{data}{Data to be plotted as a character value specifying a
bigwig file path, a dataframe in BED format, or a
\link[GenomicRanges]{GRanges} object with metadata column \code{score}.
Either one \code{data} argument or a list of two can be provided, where
the second \code{data} will be plotted below the x-axis if positive.
The second \code{data} can also be negative data.}

\item{binSize}{A numeric specifying the length of each data
bin in basepairs. Default value is \code{binSize = NA}.}

\item{binCap}{A logical value indicating whether the function will
limit the number of data bins to 8,000.
Default value is \code{binCap = TRUE}.}

\item{negData}{A logical value indicating whether the provided data has 
negative scores. Default value is \code{negData = FALSE}.}

\item{chrom}{Chromosome of region to be plotted, as a string.}

\item{chromstart}{Integer start position on chromosome to be plotted.}

\item{chromend}{Integer end position on chromosome to be plotted.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{linecolor}{A character value or vector of length 2 specifying the
line color(s) outlining the signal track(s).
Default value is \code{linecolor = "#37a7db"}.}

\item{fill}{A character value or vector of length 2 specifying
the fill color(s) of the signal track(s). Default value is \code{fill = NA}.}

\item{ymax}{A numeric specifying the fraction of the max y-value
to set as the height of the plot. Default value is \code{ymax = 1}.}

\item{range}{A numeric vector of length 2 specifying the y-range
of data to plot (c(min, max)).}

\item{scale}{A logical value indicating whether to include a data
scale label in the top left corner of the plot.
Default value is \code{scale = FALSE}.}

\item{label}{An optional character value to conveniently add a text label
to the plot. If \code{scale = TRUE}, the label will be draw in the top right
of the plot. Otherwise, the label will be drawn in the top left of the plot.
For more customizable labels, use \link[plotgardener]{plotText}.
Default value is \code{label = NULL}.}

\item{bg}{Character value indicating background color.
Default value is \code{bg = NA}.}

\item{baseline}{Logical value indicating whether to include a
baseline along the x-axis. Default value is \code{baseline = TRUE}.}

\item{baseline.color}{Baseline color.
Default value is \code{baseline.color = "grey"}.}

\item{baseline.lwd}{Baseline line width.
Default value is \code{baseline.lwd = 1}.}

\item{orientation}{A string specifying signal track orientation.
Default value is \code{orientation = "h"}. Options are:
\itemize{
\item{\code{"v"}: }{Vertical signal track orientation.}
\item{\code{"h"}: }{Horizontal signal track orientation.}
}}

\item{x}{A numeric or unit object specifying signal plot x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying signal plot y-location.
The character value will
place the signal plot y relative to the bottom of the most recently
plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying signal plot width.}

\item{height}{A numeric or unit object specifying signal plot height.}

\item{just}{Justification of signal plot relative to its (x, y) location.
If there are two values, the first value specifies horizontal justification
and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{default.units}{A string indicating the default units to use if
\code{x}, \code{y}, \code{width}, or \code{height} are only given as
numerics. Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics output should be
produced. Default value \code{draw = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{signal} object containing relevant
genomic region, placement, and \link[grid]{grob} information.
}
\description{
Plot any kind of signal track data for a single chromosome
}
\details{
#A signal track can be placed on a plotgardener coordinate page
by providing plot placement parameters:
\preformatted{
plotSignal(data, chrom,
            chromstart = NULL, chromend = NULL,
            x, y, width, height, just = c("left", "top"),
            default.units = "inches")
}
This function can also be used to quickly plot an unannotated
signal track by ignoring plot placement parameters:
\preformatted{
plotSignal(data, chrom,
            chromstart = NULL, chromend = NULL)
}
}
\examples{
## Load signal data
library(plotgardenerData)
data("IMR90_ChIP_H3K27ac_signal")
data("GM12878_ChIP_H3K27ac_signal")

## Create a page
pageCreate(width = 7.5, height = 2.1, default.units = "inches")

## Define region
region <- pgParams(
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    range = c(0, 45)
)

## Plot and place signal plots
signal1 <- plotSignal(
    data = IMR90_ChIP_H3K27ac_signal, params = region,
    x = 0.5, y = 0.25, width = 6.5, height = 0.65,
    just = c("left", "top"), default.units = "inches"
)

signal2 <- plotSignal(
    data = GM12878_ChIP_H3K27ac_signal, params = region,
    linecolor = "#7ecdbb",
    x = 0.5, y = 1, width = 6.5, height = 0.65,
    just = c("left", "top"), default.units = "inches"
)

## Plot genome label
plotGenomeLabel(
    chrom = "chr21",
    chromstart = 28000000, chromend = 30300000,
    assembly = "hg19",
    x = 0.5, y = 1.68, length = 6.5,
    default.units = "inches"
)

## Add text labels
plotText(
    label = "IMR90", fonsize = 10, fontcolor = "#37a7db",
    x = 0.5, y = 0.25, just = c("left", "top"),
    default.units = "inches"
)
plotText(
    label = "GM12878", fonsize = 10, fontcolor = "#7ecdbb",
    x = 0.5, y = 1, just = c("left", "top"),
    default.units = "inches"
)

## Hide page guides
pageGuideHide()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCool.R
\name{.checkCoolErrors}
\alias{.checkCoolErrors}
\title{Error checking function for .(m)cool files}
\usage{
.checkCoolErrors(
  file,
  chrom,
  chromstart,
  chromend,
  zrange,
  altchrom,
  altchromstart,
  altchromend,
  norm,
  resolution
)
}
\arguments{
\item{file}{Path to .(m)cool file}

\item{chrom}{User-inputted chromosome}

\item{chromstart}{User-inputted chromstart, can still be NULL at this point.}

\item{chromend}{User-inputted chromend, can still be NULL at this point.}

\item{zrange}{User-inputted zrange.}

\item{altchrom}{User-inputted alt chromosome.}

\item{altchromstart}{User-inputted alt chromstart.}

\item{altchromend}{User-inputted alt chromend.}

\item{norm}{User-inputted normalization.}

\item{resolution}{Resolution, either user-inputted or determined by 'auto'.}
}
\description{
Error checking function for .(m)cool files
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pageLayout.R
\name{pageLayoutRow}
\alias{pageLayoutRow}
\title{Generate row positions for a number of plot elements with a specified height
and space between them}
\usage{
pageLayoutRow(y, height, space, n, default.units = "inches")
}
\arguments{
\item{y}{A numeric or unit object specifying the starting row y-position.}

\item{height}{A numeric or unit object specifying the height of rows.}

\item{space}{A numeric or unit object specifying the space between rows.}

\item{n}{An integer specifying the number of elements to generate row 
positions for.}

\item{default.units}{A string indicating the default units to use
if \code{y}, \code{h}, or \code{s} are only given as numerics.
Default value is \code{default.units = "inches"}.}
}
\value{
Returns a unit vector of page positions.
}
\description{
Generate row positions for a number of plot elements with a specified height
and space between them
}
\examples{
# Starting at 0.5 units, return a vector of positions for 3 objects that
# are 2 units in height with 0.1 units of space between them

pageLayoutRow(y = 0.5, height = 2, space = 0.1, n = 3, 
            default.units = "inches")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annoText.R
\name{annoText}
\alias{annoText}
\title{Annotates text within a plot}
\usage{
annoText(
    label,
    fontcolor = "black",
    fontsize = 12,
    rot = 0,
    check.overlap = FALSE,
    plot,
    x,
    y,
    just = "center",
    default.units = "native",
    params = NULL,
    ...
)
}
\arguments{
\item{label}{Character or expression of text to be plotted.}

\item{fontcolor}{A character value specifying text fontcolor.
Default value is \code{fontcolor = "black"}.}

\item{fontsize}{A numeric specifying text fontsize in points.
Default value is \code{fontsize = 12}.}

\item{rot}{A numeric specifying the angle to rotate the text.
Default value is \code{rot = 0}.}

\item{check.overlap}{A logical value to indicate whether to check for
and omit overlapping text. Default value is \code{check.overlap = FALSE}.}

\item{plot}{Input plotgardener plot to internally place text relative to.}

\item{x}{A numeric vector or unit object specifying text x-location.}

\item{y}{A numeric vector or unit object specifying text y-location.}

\item{just}{Justification of text relative to its (x, y) location.
If there are two values, the first value specifies horizontal
justification and the second value specifies vertical justification.
Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = "center"}.}

\item{default.units}{A string indicating the default units to use if
\code{x} or \code{y} are only given as numerics or numeric vectors.
Default value is \code{default.units = "native"}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a \code{text} object containing
relevant placement and \link[grid]{grob} information.
}
\description{
Annotates text within a plot
}
\examples{
## Create a page
pageCreate(width = 4, height = 4, default.units = "inches")

## Plot text relative to a plotgardener plot
library(plotgardenerData)
data("IMR90_HiC_10kb")
hicPlot <- plotHicSquare(
    data = IMR90_HiC_10kb, chrom = "chr21",
    chromstart = 28000000, chromend = 29500000,
    assembly = "hg19",
    zrange = c(0, 70),
    x = 0.5, y = 0.5, width = 3, height = 3,
    just = c("left", "top"),
    default.units = "inches"
)
annoGenomeLabel(
    plot = hicPlot, x = 0.5, y = 3.55, scale = "Mb",
    just = c("left", "top"), default.units = "inches"
)

annoText(
    label = "Loop", fontsize = 8, plot = hicPlot,
    x = 29075000, y = 28150000,
    just = "center", default.units = "native"
)

## Hide page guides
pageGuideHide()
}
\seealso{
\link[grid]{grid.text}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pageCreate.R
\name{pageCreate}
\alias{pageCreate}
\title{Create a page for a plotgardener layout}
\usage{
pageCreate(
    width = 8.5,
    height = 11,
    default.units = "inches",
    bg = NA,
    xgrid = 0.5,
    ygrid = 0.5,
    showGuides = TRUE,
    params = NULL
)
}
\arguments{
\item{width}{A numeric or unit object specifying page width.
Default value is \code{width = 8}.}

\item{height}{A numeric or unit object specifying page height.
Default value is \code{height = 11}.}

\item{default.units}{A string indicating the default units to use if
\code{width} or \code{height} are only given as numerics.
Default value is \code{default.units = "inches"}.}

\item{bg}{Character value indicating page background color.
Default value is \code{bg = NA}.}

\item{xgrid}{A numeric indicating the increment by which to place
vertical gridlines. Default value is \code{xgrid = 0.5}.}

\item{ygrid}{A numeric indicating the increment by which to place
horizontal gridlines. Default value is \code{ygrid = 0.5}.}

\item{showGuides}{A logical value indicating whether to draw a
black border around the entire page and guiding rulers along the top and
left side of the page. Default value is \code{showOutline = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object
containing relevant function parameters.}
}
\value{
None.
}
\description{
Create a page for a plotgardener layout
}
\details{
\code{width} and \code{height} must be specified in the same units.
}
\examples{
## Create a 6-inch wide, 4.5-inch high page
pageCreate(width = 6, height = 4.5, default.units = "inches")

## Create a 14-cm wide, 10-cm high page
pageCreate(width = 14, height = 10, default.units = "cm")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMultiSignal.R
\name{plotMultiSignal}
\alias{plotMultiSignal}
\title{Plot multiple signal tracks in line with each other}
\usage{
plotMultiSignal(
   data,
   binSize = NA, 
   binCap = TRUE, 
   negData = FALSE,
   chrom, 
   chromstart = NULL, 
   chromend = NULL,
   assembly = "hg38", 
   linecolor= "#37a7db",
   fill = NA, 
   ymax = 1, 
   range = NULL, 
   scale = FALSE,
   label = NULL,
   bg = NA, 
   baseline = TRUE, 
   baseline.color = "grey",
   baseline.lwd = 1, 
   orientation = "h", 
   x = NULL, 
   y = NULL,
   width = NULL,
   height = NULL,
   just = c("left", "top"),
   gapdistance = .2,
   default.units = "inches", 
   draw = TRUE,
   params = NULL, ...
)
}
\arguments{
\item{data}{List of data to be plotted as character values specifying 
multiple bigwig file paths, dataframes in BED format, or
\link[GenomicRanges]{GRanges} objects with metadata column \code{score}.}

\item{binSize}{A numeric specifying the length of each data
bin in basepairs. Default value is \code{binSize = NA}.}

\item{binCap}{A logical value indicating whether the function will
limit the number of data bins to 8,000.
Default value is \code{binCap = TRUE}.}

\item{negData}{A logical value indicating whether any of the data has both
positive and negative scores and the y-axis of each signal track
should be split. Default value is \code{negData = FALSE}.}

\item{chrom}{Chromosome of region to be plotted, as a string.}

\item{chromstart}{Integer start position on chromosome to be plotted.}

\item{chromend}{Integer end position on chromosome to be plotted.}

\item{assembly}{Default genome assembly as a string or a
\link[plotgardener]{assembly} object.
Default value is \code{assembly = "hg38"}.}

\item{linecolor}{A character value or vector of character values specifying 
the line color(s) outlining the signal tracks.
Default value is \code{linecolor = "#37a7db"}.}

\item{fill}{A character value or vector specifying
the fill color(s) of the signal tracks. Default value is \code{fill = NA}.}

\item{ymax}{A numeric specifying the fraction of the max y-value
to set as the height of each plot. Default value is \code{ymax = 1}.}

\item{range}{A numeric vector of length 2 specifying the y-range
of data to plot (c(min, max)) in each signal track. If \code{range = NULL},
an optimal range for all signal tracks will be calculated.}

\item{scale}{A logical value indicating whether to include a data
scale label in the top left corner of each plot.
Default value is \code{scale = FALSE}.}

\item{label}{An optional character vector to conveniently add text labels
to signal tracks. If \code{scale = TRUE}, the labels will be drawn in the 
top right of the signal tracks. Otherwise, the label will be drawn in the 
top left of the plot. For more customizable labels, 
use \link[plotgardener]{plotText}.}

\item{bg}{Character value indicating background color.
Default value is \code{bg = NA}.}

\item{baseline}{Logical value indicating whether to include a
baseline along the x-axis. Default value is \code{baseline = TRUE}.}

\item{baseline.color}{Baseline color.
Default value is \code{baseline.color = "grey"}.}

\item{baseline.lwd}{Baseline line width.
Default value is \code{baseline.lwd = 1}.}

\item{orientation}{A string specifying signal track orientations.
Default value is \code{orientation = "h"}. Options are:
\itemize{
\item{\code{"v"}: }{Vertical signal track orientations, where signal tracks
will be stacked from left to right.}
\item{\code{"h"}: }{Horizontal signal track orientations, where signal tracks
will be stacked from top to bottom.}
}}

\item{x}{A numeric vector or unit object specifying the overall multisignal 
x-location.}

\item{y}{A numeric, unit object, or character containing a "b"
combined with a numeric value specifying overall multisignal plot y-location.
The character value will
place the multisignal plot y relative to the bottom of the most recently
plotted plot according to the units of the plotgardener page.}

\item{width}{A numeric or unit object specifying overall multisignal plot 
width.}

\item{height}{A numeric or unit object specifying overall multisignal plot 
height.}

\item{just}{Justification of overall multisignal plot relative to 
its (x, y) location. If there are two values, the first value specifies 
horizontal justification and the second value specifies vertical 
justification. Possible string values are: \code{"left"}, \code{"right"},
\code{"centre"}, \code{"center"}, \code{"bottom"}, and \code{"top"}.
Default value is \code{just = c("left", "top")}.}

\item{gapdistance}{A numeric or unit object 
specifying space between plots. Default value is \code{gapdistance = 0.2}.}

\item{default.units}{A string indicating the default units to use
if \code{x} or \code{y} are only given as numerics.
Default value is \code{default.units = "inches"}.}

\item{draw}{A logical value indicating whether graphics output should be
produced. Default value \code{draw = TRUE}.}

\item{params}{An optional \link[plotgardener]{pgParams} object containing
relevant function parameters.}

\item{...}{Additional grid graphical parameters. See \link[grid]{gpar}.}
}
\value{
Returns a list of \code{signal} objects containing relevant
genomic region, placement, and \link[grid]{grob} information for each signal
track.
}
\description{
Plot multiple signal tracks in line with each other
}
\examples{
library("plotgardenerData")
data("GM12878_ChIP_CTCF_signal")
data("IMR90_ChIP_CTCF_signal")
data("GM12878_ChIP_H3K27ac_signal")
data("IMR90_ChIP_H3K27ac_signal")
library("RColorBrewer")

## List of multiple signal datasets
signalList <- list(GM12878_ChIP_CTCF_signal, GM12878_ChIP_H3K27ac_signal, 
    IMR90_ChIP_CTCF_signal, IMR90_ChIP_H3K27ac_signal)

## Create page
pageCreate(width = 6.9, height = 3.5, default.units = "inches")

## Plot multiple signals
multisignal <- plotMultiSignal(signalList, chrom = "chr21",
                               chromstart = 28150000, chromend = 29150000,
                               linecolor = c(brewer.pal(n = 9,"YlGnBu")[4],
                                             brewer.pal(n = 9,"YlGnBu")[5],
                                             brewer.pal(n = 9,"YlGnBu")[6],
                                             brewer.pal(n = 9,"YlGnBu")[7]),
                               label = c("GM12878 CTCF", "GM12878 H3K27ac",
                                         "IMR90 CTCF", "IMR90 H3K27ac"),
                               assembly = "hg19",
                               x = 0.2, y = 0.2,
                               width = 6.5, height = 3,
                               default.units = "inches",
                               gapdistance = 0.1)
                               
## Plot genome label
plotGenomeLabel(
    chrom = "chr21",
    chromstart = 28150000, chromend = 29150000,
    assembly = "hg19",
    scale = "Kb",
    x = 0.2, y = 3.25, length = 6.5,
    default.units = "inches"
)                                

## Hide page guides
pageGuideHide()              
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readCool.R
\name{readCoolNorms}
\alias{readCoolNorms}
\title{Read normalizations included in .(m)cool files}
\usage{
readCoolNorms(file, resolution = NULL)
}
\arguments{
\item{file}{A character value specifying the path to the .(m)cool file}

\item{resolution}{optional, specify which resolution(s) to read 
normalization types from. Default is all resolutions in `file`.}
}
\value{
A vector or list of vectors of available normalizations
}
\description{
Read normalizations included in .(m)cool files
}
\details{
The "BALANCE" normalization refers to applying the pre-calculated matrix 
balancing weights in the `weight` dataset of `file`, typically present
in files created using cooler. VC is vanilla coverage, 
VC_SQRT is square root of vanilla coverage, 
and KR is Knight-Ruiz normalization.

Please note that if using a file from HiC-Pro, ICE normalizations will come
from files stored in a separate folder, and thus will not contain any 
normalizations explicitly called "ICE" or "BALANCE" since values are 
included already normalized. This normalization can be specified as "NONE".
}
\author{
Sarah Parker, Nicole Kramer
}
